
#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_cuseeme.h"

int32 rtl8651_l4AliasHandleCUseeMeClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct udphdr *udp;
	int32 tlen,hlen,dlen;
	uint8 *data;
	struct cu_header *chdr;
	
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_CUSEEME)==0) return FWDENG_USER_DROP;

	udp = (struct udphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	
	data = (uint8 *)(udp+1);

	tlen = ntohs(pip->ip_len);
	hlen =(pip->ip_vhl & 0xf) + sizeof(struct udphdr);
	dlen = tlen - hlen;

	if(dlen>=sizeof(struct cu_header))
	{	
		chdr=(struct cu_header *)data;

		if(chdr->addr) 
		{
			{
				uint8 *srcip,*srcport;
				srcip=(uint8*)&chdr->addr;
				srcport=(uint8*)&chdr->port;
				*srcip=(tb->insideGlobalIpAddr>>24)&0xff;
				*(srcip+1)=(tb->insideGlobalIpAddr>>16)&0xff;
				*(srcip+2)=(tb->insideGlobalIpAddr>>8)&0xff;
				*(srcip+3)=tb->insideGlobalIpAddr&0xff;
				*srcport=(tb->insideGlobalPort>>8)&0xff;
				*(srcport+1)=tb->insideGlobalPort&0xff;				
			}			
		}
	}

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleCUseeMeClientInbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct udphdr *udp;
	int32 hlen, tlen, dlen;
	uint8 *data;
	struct cu_header *chdr;
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_CUSEEME)==0) return SUCCESS;

	udp = (struct udphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = (uint8 *)(udp+1);	
		
	tlen = ntohs(pip->ip_len);
	hlen =(pip->ip_vhl & 0xf) + sizeof(struct udphdr);
	dlen = tlen - hlen;


	if(dlen>=sizeof(struct cu_header))
	{
		chdr=(struct cu_header *)data;
		if(chdr->dest_addr)
		{
			uint8 *addr,*port;	               
                     addr=(uint8*)&chdr->dest_addr;
                     port=(uint8*)&chdr->dest_port;
                     addr[0]=(tb->insideLocalIpAddr>>24)&0xff;
			addr[1]=(tb->insideLocalIpAddr>>16)&0xff;
			addr[2]=(tb->insideLocalIpAddr>>8)&0xff;
			addr[3]=tb->insideLocalIpAddr&0xff;
			port[0]=(tb->insideLocalPort>>8)&0xff;
			port[1]=tb->insideLocalPort&0xff;
		}

		if(ntohs(chdr->data_type)==101 && dlen > sizeof(struct oc_header))
		{
			struct oc_header *oc;
			struct client_info *ci;
			uint16 off,i;
			oc = (struct oc_header * ) data;

		       off=sizeof(struct oc_header);
		       
			for(i=0;(i < ntohs(oc->client_count) && off+sizeof(struct client_info) <= dlen); i++)
			{
				uint8 *addr;				
                            ci=(struct client_info *)(data+off);
                            addr=(uint8*)&ci->address;                              
                            
				if(addr[0]==((tb->insideGlobalIpAddr>>24)&0xff)&&
					addr[1]==((tb->insideGlobalIpAddr>>16)&0xff)&&				
					addr[2]==((tb->insideGlobalIpAddr>>8)&0xff)&&					
					addr[3]==(tb->insideGlobalIpAddr&0xff))
				{					
					addr[0]=((tb->insideLocalIpAddr>>24)&0xff);
					addr[1]=((tb->insideLocalIpAddr>>16)&0xff);
					addr[2]=((tb->insideLocalIpAddr>>8)&0xff);
					addr[3]=(tb->insideLocalIpAddr&0xff);
					break;
				}
			        else
				   off+=sizeof(struct client_info);
			}
			
		}
	}

	return SUCCESS;	
}


