

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"
#include "rtl8651_config.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_dx7play.h" 
static uint32 session=0;
static uint16 alg_port=0;

void rtl8651_l4AliasHandleDx7playReInit(void)
{
	session=0;
	alg_port=0;
}

int32
rtl8651_l4AliasHandleDx7playClientOutbound (struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	
						struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
	struct tcphdr *th = NULL;
	uint8 *data=NULL;
	uint16 port;
	uint32   hlen, tlen, dlen=0;


	

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7)==0) return SUCCESS;

 	if(pip->ip_p==6)
	{
		th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
		hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
		tlen = ntohs(pip->ip_len);
		dlen = tlen - hlen;	
		data = (uint8 *)(th + 1);
 	}
 	else
 	{
 		return SUCCESS;
 	}



	
	if((dlen!=(data[0]|(data[1]<<8))) || (data[2]!=0xB0) || (data[3]!=0xFA)) 
  		return SUCCESS;
	 
	port=(*(data+6)<<8)|(*(data+7));
	if(port>2400||port<2300) return SUCCESS;

	

#ifdef _RTL_UPNP

	rtl8651_addUpnpMap(UPNP_TCP|UPNP_PERSIST , link->dstIpAddr, 0, 
		link->insideGlobalIpAddr, port,
		link->insideLocalIpAddr, port);
#endif 
	session++;
	

	return SUCCESS;
}


int32
rtl8651_l4AliasHandleDx7playServerInbound (struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	
						struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
	struct tcphdr *th = NULL;
	uint8 *data=NULL;
	uint16 port;
	uint32   hlen, tlen, dlen=0;


	

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7)==0) return SUCCESS;

 	if(pip->ip_p==6)
	{
		th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
		hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
		tlen = ntohs(pip->ip_len);
		dlen = tlen - hlen;	
		data = (uint8 *)(th + 1);
 	}
 	else
 	{
 		return SUCCESS;
 	}



	
	if((dlen!=(data[0]|(data[1]<<8))) || (data[2]!=0xB0) || (data[3]!=0xFA)) 
  		return SUCCESS;
	 
	port=(*(data+6)<<8)|(*(data+7));
	if(port>2400||port<2300) return SUCCESS;

	if(alg_port==0)
	{


		#ifdef RTL8651_ALG_MODULE_UPDATE
		rtl8651_fwdEngineRegisterAlgModule( port, port, TRUE, TRUE, TRUE, 
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleDx7playClientOutbound2, 
		NULL, 
		NULL,
		NULL ); 
		#else
		rtl8651_fwdEngineRegisterAlgModule(port, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleDx7playClientOutbound2, 
		NULL, 
		NULL,
		NULL); 
		#endif
		alg_port=port;
	}

	

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleDx7playClientOutbound2(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
 {
	struct tcphdr *th = NULL;
	uint8 *data;
	uint16 port=0;
	uint32   hlen, tlen, dlen;


 	if(pip->ip_p!=6)
		return FAILED; 
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7)==0) return SUCCESS;	


	link->alg_client_out=rtl8651_l4AliasHandleDx7playClientOutbound2;

 
	th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;	
	data = (uint8 *)(th + 1);

	
	if((dlen!=(data[0]|(data[1]<<8))) || (data[2]!=0xB0) || (data[3]!=0xFA)) 
  		return SUCCESS;

	
	if((dlen>=300)&&(data[dlen-16]==2)&&(data[dlen-15]==0))
	{
		port=(*(data+dlen-14)<<8)|(*(data+dlen-13));

		
	}
	else if((dlen>=134)&&(data[112]==2)&&(data[113]==0))
	{
		port=(*(data+114)<<8)|(*(data+115));

		
	}
	else if((dlen>=128)&&(data[4]==2)&&(data[5]==0))
	{
		port=(*(data+6)<<8)|(*(data+7));
	
		
	}
	
	if((port>2400)||(port<2300)) return SUCCESS;
	


#ifdef _RTL_UPNP

	
	rtl8651_addUpnpMap(UPNP_ONESHOT , link->dstIpAddr, 0, 
		link->insideGlobalIpAddr, port,
		link->insideLocalIpAddr, port);

#endif 

	if(alg_port!=0)
	{
		#ifdef RTL8651_ALG_MODULE_UPDATE
		rtl8651_fwdEngineRemoveAlgModule( alg_port, alg_port, TRUE );
		#else
		rtl8651_fwdEngineRemoveAlgModule(alg_port, TRUE);
		#endif
		alg_port=0;
		rtl8651_addUpnpMap(UPNP_PERSIST|UPNP_TCP , link->dstIpAddr, 0, 
		link->insideGlobalIpAddr, port,
		link->insideLocalIpAddr, port);		
	}

	return SUCCESS;
 }


int32 rtl8651_l4AliasHandleDx7playServerInbound2(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
 {
	struct tcphdr *th = NULL;
	uint8 *data;
	uint16 port=0;
	uint32   hlen, tlen, dlen;

 	if(pip->ip_p!=6)
		return FAILED; 
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7)==0) return SUCCESS;	


	link->alg_client_out=rtl8651_l4AliasHandleDx7playClientOutbound2;

 
	th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;	
	data = (uint8 *)(th + 1);

	
	if((dlen!=(data[0]|(data[1]<<8))) || (data[2]!=0xB0) || (data[3]!=0xFA)) 
  		return SUCCESS;

	if((dlen>=300)&&(data[dlen-16]==2)&&(data[dlen-15]==0))
	{
		port=(*(data+dlen-14)<<8)|(*(data+dlen-13));

		
	}
	else if((dlen>=134)&&(data[112]==2)&&(data[113]==0))
	{
		port=(*(data+114)<<8)|(*(data+115));		

		
	}
	else if((dlen>=128)&&(data[4]==2)&&(data[5]==0))					
	{
		port=(*(data+6)<<8)|(*(data+7));

		
	}
	
	if((port>2400)||(port<2300)) return SUCCESS;
	


	if(alg_port==0)
	{
		#ifdef RTL8651_ALG_MODULE_UPDATE
		rtl8651_fwdEngineRegisterAlgModule( port, port, TRUE, TRUE, TRUE, 
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleDx7playClientOutbound2, 
		NULL, 
		NULL,
		NULL );
		#else
		rtl8651_fwdEngineRegisterAlgModule(port, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleDx7playClientOutbound2, 
		NULL, 
		NULL,
		NULL); 
		#endif
		alg_port=port;
	}


#ifdef _RTL_UPNP

	rtl8651_addUpnpMap(UPNP_ONESHOT , link->dstIpAddr, 0, 
		link->insideGlobalIpAddr, port,
		link->insideLocalIpAddr, port);

#endif 


	return SUCCESS;
 }

