

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_icq.h"
static int client_session=0;
static ipaddr_t localip=0;


int32 rtl8651_l4AliasHandleIcqUdpClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	
	struct udphdr *udp;
	uint8 *payload;
	int datalen;
	int step=0;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_ICQ)==0) return SUCCESS;	

	udp = (struct udphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	payload = ((uint8 *)udp) + 8;	
	datalen=ntohs(udp->uh_ulen)-8;
	if(datalen>6)  
	{
		if(memcmp(payload,"INVITE",6)==0)
		{
			int i;
			printk("found INVITE packet...\n");
			
			for(i=0;i<datalen-14;i++)
			{
				if(memcmp(payload+i,"Contact: <sip:",14)==0)
				{
					int j;
					uint16 port=0;
					uint8 *pl;
					pl=payload+i+14;
					for(j=0;j<16;j++)					
						if(pl[j]==':') { pl+=j; break;}
					pl++;

					for(j=0;j<5;j++)
					{
						if((pl[j]>'9')||(pl[j]<'0')) break;
						port=port*10+(pl[j]-'0');
					}
					printk("SIP port = %d\n",port);

#ifdef _RTL_UPNP
					rtl8651_addUpnpMap(UPNP_ONESHOT, 0, 0, 
						tb->insideGlobalIpAddr, port,
						tb->insideLocalIpAddr, 5190);
#endif 
					
					step++;
				}

				if(memcmp(payload+i,"a=rtcp:",7)==0)
				{
					int j;
					uint8 *pl;
					uint16 port=0;
					pl=payload+i+7;
					for(j=0;j<5;j++)
					{
						if((pl[j]>'9')||(pl[j]<'0')) break;
						port=port*10+(pl[j]-'0');
					}
					printk("RTCP port = %d\n",port);

#ifdef _RTL_UPNP
					rtl8651_addUpnpMap(UPNP_ONESHOT, 0, 0, 
						tb->insideGlobalIpAddr, port,
						tb->insideLocalIpAddr, port);
#endif 

					step++;

				}

				if(memcmp(payload+i,"m=audio ",8)==0)
				{
					int j;
					uint8 *pl;
					uint16 port=0;
					pl=payload+i+8;
					for(j=0;j<5;j++)
					{
						if((pl[j]>'9')||(pl[j]<'0')) break;
						port=port*10+(pl[j]-'0');
					}
					printk("RTP port = %d\n",port);

#ifdef _RTL_UPNP
					rtl8651_addUpnpMap(UPNP_ONESHOT, 0, 0, 
						tb->insideGlobalIpAddr, port,
						tb->insideLocalIpAddr, 5191);
#endif 

					step++;

				}				

				if(step>=3) break;
			}
			
			

		}
	}	
	
	return SUCCESS;
}


int32 rtl8651_l4AliasHandleIcqClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	struct icq_command *icq;
	struct icq_command2 *icq2;	
	int32 hlen, tlen, dlen, idx=0;
	uint8 *payload;
	char buf[1500];	

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_ICQ)==0) return SUCCESS;	

	
#ifdef _RTL_UPNP
	if(localip!=tb->insideLocalIpAddr)
	{
		localip=tb->insideLocalIpAddr;
		
		rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
			tb->insideGlobalIpAddr, 5190,
			tb->insideLocalIpAddr, 5190);
	}
#endif 
	
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	payload = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));	
	
	tlen = ntohs(pip->ip_len); 
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2; 
	dlen = tlen - hlen; 

	while(idx+sizeof(struct icq_command)<dlen)
	{
		rtl8651_memcpy(buf,payload+idx,dlen-idx);
		icq = (struct icq_command *)buf;

		if((icq->id==0x2a)&&(icq->channel==0x02)&&(ntohs(icq->snac1)==0x01)&&(ntohs(icq->snac2)==0x1e))
		{
			if((ntohl(icq->tlv6)==0x00060004)&&(ntohl(icq->tlv8)==0x00080002)&&(ntohs(icq->tlv12)==0x000c))
				{				
					
					

					#ifdef _RTL_UPNP
					
					rtl8651_addUpnpMap(UPNP_TCP|UPNP_PERSIST, 0, 0, 
							tb->insideGlobalIpAddr, 24500+client_session,
							tb->insideLocalIpAddr, ntohs(icq->port));
					#endif 
						
					
					
					{
						uint16 *icqport=(uint16*)(payload+idx+40);
						*icqport=htons(24500+client_session);						
					}
					++client_session;					
					client_session%=_RTL8651_ALG_ICQ_MAX_CLIENT;
					return SUCCESS;
				}
		}
		idx+=(ntohs(icq->length)+6);
	}

	
	if(sizeof(struct icq_command2)+4>dlen) return SUCCESS;

	rtl8651_memcpy(buf,payload,dlen);
	icq2 = (struct icq_command2 *)buf;

	if((icq2->id==0x2a)&&(icq2->channel==0x02)&&(ntohs(icq2->snac1)==0x04)&&(ntohs(icq2->snac2)==0x06))
	{
		uint16 port;
		port=(*(payload+dlen-4)&0xff)|((*(payload+dlen-3)&0xff)<<8);

#ifdef _RTL_UPNP
		
		if(port>1024)
		{
			rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
				tb->insideGlobalIpAddr, port,
				tb->insideLocalIpAddr, port);
		}
#endif 

		port=(*(payload+dlen-8)&0xff)|((*(payload+dlen-7)&0xff)<<8);

#ifdef _RTL_UPNP
		
		if(port>1024)
		{
			rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
				tb->insideGlobalIpAddr, port,
				tb->insideLocalIpAddr, port);
		}		
#endif

		
	}

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleIcqServerOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint16 port;
	uint8 *payload;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_ICQ)==0) return SUCCESS;
	
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	tlen = ntohs(pip->ip_len); 
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2; 
	dlen = tlen - hlen; 
	if(dlen<5) return SUCCESS; 
	payload = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));
	if((*payload)!=2) return SUCCESS;	
	port=(*(payload+dlen-4)&0xff)|((*(payload+dlen-3)&0xff)<<8);	
	
#ifdef _RTL_UPNP
	
	rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
		tb->insideGlobalIpAddr, port,
		tb->insideLocalIpAddr, port);
#endif 

	
	return SUCCESS;
}


void  rtl8651_l4AliasIcqReInit(void)
 {
	client_session=0;
	localip=0;
 }


