

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_irc_dcc.h"

int32 rtl8651_l4AliasHandleIrcDccClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint32 i,j,k,endport_idx=0;

	uint32 dcc_type=0;
	uint8 *dcc;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_IRC)==0) return SUCCESS;
		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	dcc = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;
	dlen = tlen - hlen;

	
	if(dlen<8) return SUCCESS;
	if(memcmp(dcc,"PRIVMSG",7))  return SUCCESS;

	for(i=7;i<dlen;i++)
	{
		if(dcc[i]==1)
		{			
			if(i+10>dlen) return SUCCESS;
			if(memcmp(&dcc[i+1],"DCC SEND ",9)==0) dcc_type=IRC_DCC_SEND;
			else if(memcmp(&dcc[i+1],"DCC CHAT ",9)==0) dcc_type=IRC_DCC_CHAT;				
			else return SUCCESS;
			i+=10;
			break;
		}
	}
	if(dcc_type==0) return SUCCESS;
	

	for(j=dlen-1;j>=i;j--)
		{
			if(((dcc[j]&0xff)==1)&&(dcc_type==IRC_DCC_CHAT)) endport_idx=j;
			if(dcc[j]==' ')
			{				
				
				if(endport_idx!=0)				
				{
					uint16 port=0;
					char port_str[6]={0};
					if(endport_idx-j-1>5) return SUCCESS;
					rtl8651_memcpy(port_str,&dcc[j+1],endport_idx-j-1);
					for(k=0;k<5;k++)
						{
							if(port_str[k]==0) break;
							port=port*10+(port_str[k]-'0');							
						}					
					
#ifdef _RTL_UPNP
					
					rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
						tb->insideGlobalIpAddr, port,
						tb->insideLocalIpAddr, port);	
					
#endif 					
					break;
				}

				if((endport_idx==0) &&(dcc_type==IRC_DCC_SEND)) endport_idx=j;
			}
		}

	return SUCCESS;
}

