

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_quake.h"

static uint16 udpport=0;

int32 rtl8651_l4AliasHandleQuakeClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint8 *data;
	uint8 *message;


	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_QUAKE)==0) return SUCCESS;
		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;
	dlen = tlen - hlen;

	if(dlen<5) return SUCCESS;

	
	if(data[0]!=0x00||data[1]!=0x80) return SUCCESS;

	
	message=data+4;

	switch(*message)
	{
		case 0x81:
			{
				uint16 length=((data[2]<<8)&0xff00)|(data[3]&0xff);
				uint16 udpport_local=0;
				if(length<9) return SUCCESS;
				message++;
				udpport_local=((message[0]<<8)&0xff00)|(message[1]&0xff);
#ifdef _RTL_UPNP
				
				rtl8651_addUpnpMap(UPNP_ONESHOT, 0, udpport, 
					tb->insideGlobalIpAddr, udpport_local,
					tb->insideLocalIpAddr, udpport_local);	
#endif 						
				
			}
			break;	
	}

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleQuakeClientInbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint8 *data;
	uint8 *message;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_QUAKE)==0) return SUCCESS;
		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;
	dlen = tlen - hlen;

	if(dlen<5) return SUCCESS;

	
	if(data[0]!=0x00||data[1]!=0x80) return SUCCESS;

	
	message=data+4;

	switch(*message)
	{
		case 0x81:
			{
				uint16 length=((data[2]<<8)&0xff00)|(data[3]&0xff);
				if(length<9) return SUCCESS;
				message++;
				udpport=((message[0]<<8)&0xff00)|(message[1]&0xff);
			}
			break;	
	}

	return SUCCESS;	
}
