

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_realaudio.h"

int32 rtl8651_l4AliasHandleRealAudioClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen,idx,port_idx;
	uint8 *data;
	uint16 version=0;
	uint16 msg_id=0;
	uint16 msg_len=0;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_REALAUDIO)==0) return SUCCESS;

		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;
	dlen = tlen - hlen;

	if(dlen<9) return SUCCESS; 

	if(memcmp(data,"PNA",3)!=0) return SUCCESS;

	version=((data[3]<<8)&0xff00)|(data[4]&0xff);

	if(version>=256) return SUCCESS;

	idx=5;

	while(idx+4<dlen)
	{
		msg_id=((data[idx]<<8)&0xff00)|(data[idx+1]&0xff);
		msg_len=((data[idx+2]<<8)&0xff00)|(data[idx+3]&0xff);
		idx+=4;
		if(msg_id==0) return SUCCESS; 
		port_idx=idx;
		idx+=msg_len;
		if(idx>dlen) return SUCCESS; 
		if((msg_id==1)||(msg_id==7)) 
		{
			uint16 udp_port;
			udp_port=((data[port_idx]<<8)&0xff00)|(data[port_idx+1]&0xff);
#ifdef _RTL_UPNP
			
			if(udp_port!=0)
			{
				rtl8651_addUpnpMap(UPNP_ONESHOT, 0, 0, 
					tb->insideGlobalIpAddr, udp_port,
					tb->insideLocalIpAddr, udp_port);
					
			}
#endif 
		}
	}
	return SUCCESS;
}




