

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_vdolive.h"

int32 rtl8651_l4AliasHandleVDOliveClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint8 *data;
	uint32 targval=0;
	uint16 port=0;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_VDOLIVE)==0) return SUCCESS;
		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;
	dlen = tlen - hlen;

	if(dlen<=8) return SUCCESS;

	targval=((data[4]<<24)&0xff000000)|((data[5]<<16)&0xff0000)|((data[6]<<24)&0xff00)|(data[7]&0xff);

	if((targval!=6)&&(targval!=1)) return SUCCESS;

	if((targval==6)&&(dlen<=36)) return 0;
	else if((targval==1)&&(dlen<=20)) return 0;

	if(targval==6) data+=24;
	else data+=8;

	if(memcmp(data,"VDO Live",8)!=0) return 0;

	data+=10;
	
	port=(data[0]<<8&0xff00)|(data[1]&0xff);

#ifdef _RTL_UPNP
	
	rtl8651_addUpnpMap(UPNP_ONESHOT, 0, 0, 
		tb->insideGlobalIpAddr, port,
		tb->insideLocalIpAddr, port);	
#endif 		

	return SUCCESS;
}




