

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_ymsg.h"

#define _RTL8651_L4_MAX_YMSG_ALIAS_BUF_SIZE 576

static uint8 *_rtl8651_l4_ymsg_alias_buf[1]; 
static ipaddr_t triggerIP=0;

int32 rtl8651_l4AliasHandleYmsgClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct ip *spip;
	struct tcphdr *tcp,*stcp;
	struct ymsg_command *ymsg;
	int32 hlen, tlen, dlen, off_set, i ,size_delta;
	int8 *sptr, *newpacket;
	int8 sflag=0, http[8]="http://",*ymsg_content;	
	int8 route_ip[22]={0};
	ipaddr_t src,dest;	
	struct rtl_mBuf *m = pkthdrPtr->ph_mbuf;


	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_YAHOOMSG)==0) return SUCCESS;
	
	src=ntohl(PKTGET_UINT32_UNALIGNED(&pip->ip_src.s_addr));
	dest=ntohl(PKTGET_UINT32_UNALIGNED(&pip->ip_dst.s_addr));


#ifdef _RTL_TRIGGER_PORT
	{
		triggerIP = src;		
		rtl8651a_addTriggerPortRule(pkthdrPtr->ph_dsid,2,5000,5001,0,0,0,htonl(triggerIP));
		rtl8651a_addTriggerPortRule(pkthdrPtr->ph_dsid,2,5055,5055,0,0,0,htonl(triggerIP));
	}
#endif	

	
	
	
	
	
		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	ymsg = (struct ymsg_command *)((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));	
	ymsg_content = (void *)ymsg + sizeof(struct ymsg_command);
	
	off_set = ((uint8 *)pip) - m->m_data;
	
	if(off_set < 0 || off_set > 40 || tb == NULL) return FAILED;

	if(memcmp(ymsg->ymsg,"YMSG",4)!=0)  return SUCCESS;	
	if(ntohs(ymsg->service)!=YAHOO_SERVICE_P2PFILEXFER) return SUCCESS;
	
	
	
	
	
	if (m->m_pkthdr->ph_len > _RTL8651_L4_MAX_YMSG_ALIAS_BUF_SIZE) return FAILED;
	
	
	newpacket =  (int8 *)_rtl8651_l4_ymsg_alias_buf[0];
	
	
	mBuf_copyToUserBuffer(m, off_set, m->m_pkthdr->ph_len - off_set, newpacket);
	
	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;
	dlen = tlen - hlen;

	
	spip = (struct ip*)newpacket;
	stcp = (struct tcphdr *) ((int8 *) spip + ((spip->ip_vhl &0xf) << 2));	
	sptr = (int8 *) newpacket+hlen+sizeof(struct ymsg_command); 
			
	
		
	for(i=0;i<ntohs(ymsg->length)-10;i++)
	{
		if((sflag!=0)&&(ymsg_content[i]=='/')) break;		
		if((sflag==0)&&(memcmp((void *)(ymsg_content+i),http,7)==0)) {  i+=7; sflag=i; }
	}

	if(sflag==0) return SUCCESS;	

	sprintf(route_ip,"%u.%u.%u.%u:5002",(tb->insideGlobalIpAddr>>24)&0xff,
		(tb->insideGlobalIpAddr>>16)&0xff,
		(tb->insideGlobalIpAddr>>8)&0xff,
		(tb->insideGlobalIpAddr)&0xff);

	size_delta=strlen(route_ip)-(i-sflag);
	

	sptr+=sflag;
	rtl8651_memcpy(sptr,route_ip,strlen(route_ip));
	rtl8651_memcpy(sptr+strlen(route_ip),ymsg_content+i,ntohs(ymsg->length)-i+1);
			
	
	{
		int32     delta;
		tb->tcpAckModified = 1;
		delta = _rtl8651_l4GetDeltaSeqOut(spip, stcp, tb);
		_rtl8651_l4AddSeq(spip, tb, delta + size_delta);
	}

	spip->ip_len = htons(ntohs(spip->ip_len)+size_delta);
	
	
	stcp->th_sum = 0;
	spip->ip_sum = 0;				
	stcp->th_sum = _rtl8651_tcpChecksum(spip);
	spip->ip_sum = _rtl8651_ipChecksum(spip);	

	mBuf_copyToMbuf(m, off_set, ntohs(spip->ip_len), newpacket);
	
	assert(m->m_len == m->m_pkthdr->ph_len);

#ifdef _RTL_UPNP
		
		rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
				tb->insideGlobalIpAddr, 5002,
				tb->insideLocalIpAddr, 80);	
#endif 

	return SUCCESS;
}

static int32 init_ymsg = 0;
int32 rtl8651_l4AliasYmsgInit(void *arg){
	
	
	if(init_ymsg)
		return SUCCESS;

	_rtl8651_l4_ymsg_alias_buf[0] = (uint8 *)rtlglue_malloc(_RTL8651_L4_MAX_YMSG_ALIAS_BUF_SIZE+64);
	assert(_rtl8651_l4_ymsg_alias_buf[0]);

	init_ymsg = 1;	
	return SUCCESS;
}

void rtl8651_l4AliasYmsgReInit()
{
	triggerIP=0;
}


