
#include "rtl_types.h"
#include "assert.h"
#include "rtl_errno.h"
#include "types.h"
#include "rtl8651_layer2.h"
#include "rtl8651_layer2fwdLocal.h"
#include "rtl8651_tblAsicDrv.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "asicRegs.h"
#include "asicTabs.h"
#include "rtl_queue.h"
#include "rtl_utils.h"
#ifdef RTL865X_TEST
#include <string.h>
#endif
#ifdef RTL865X_MODEL_USER
#include "rtl_glue.h"
#include "rtl8651_tblDrvPatch.h"
#include <stdio.h>
#include <string.h>
#endif

uint32 _sysUpSeconds; 
uint32 rtl8651_tblDrvCpuMirrorPortMask;
uint32 phyPortLinkStatus;


uint32 rtl8651_tblDrvSpanningTreeEnable;
uint32 rtl8651_tblDrvSpanningTreePortFwdStatus;

uint32 arpAgingTime; 
rtl8651_tblDrvInitPara_t rtl8651_tblDrvPara;
__DRAM_L2_FWD struct rtl8651_driverTables DrvTbl;
int8 pureSoftFwd;	

struct AsicTableUsage_S AsicTableUsage;

uint32 rtl8651_l2protoPassThrough = 0;	
int8 rtl8651_drvDropUnknownPppoePADT		= FALSE;		
struct ether_header rtl8651_knownPppoePassthruEthHdr;		



void (*rtl8651_linkStatusNotifier)(uint32 port, int8 linkUp)=NULL;
void (*rtl8651_L2statusNotifier)(void *l2entry_t, void *arg)=NULL;
int32 _rtl8651_delVlanRefFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr);



int32 rtl8651_installPortStatusChangeNotifier(void (*notifier)(uint32 port, int8 linkUp)){
	rtl8651_linkStatusNotifier = notifier;
	return SUCCESS;
}



int32 rtl8651_installFDBEntryChangeNotifier( void (*notifier)(void *l2entry_t, void *arg)){
	rtl8651_L2statusNotifier=notifier;
	return SUCCESS;
}


 void rtl8651_setEthernetPortLinkStatus(uint32 port, int8 linkUp) {
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	rtl8651_tblDrv_ethernet_t *phyPortPtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	int8 ethernetNotify;
	uint32 i;
#ifdef RTL865XB_DCUT_SWVLAN
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;
#endif

	if(port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)
		return;
	rtlglue_drvMutexLock();
	phyPortPtr = &DrvTbl.phyPort[port];
	if(rtl8651_linkStatusNotifier && phyPortPtr->linkUp != (linkUp==TRUE? 1: 0))
		ethernetNotify = TRUE;
	else
		ethernetNotify = FALSE;
	
	if (linkUp == TRUE) {		
		phyPortPtr->linkUp = 1;
		phyPortLinkStatus |= (1 << port);
	} else {
		phyPortPtr->linkUp = 0;
		phyPortLinkStatus &= ~(1 << port);
	}

	
	for(i=0,aggrePtr=&DrvTbl.aggregator[0]; i < RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum ; i++,aggrePtr++)
		if(aggrePtr->ethernetPortMask & (1<<port)) {
			if(linkUp==TRUE)
				aggrePtr->ethernetPortUpStatus |= (1<<port);
			else
				aggrePtr->ethernetPortUpStatus &= ~(1<<port);
		}
	
	for(i=0,vlanPtr=&DrvTbl.vlan[0]; i<RTL8651_VLAN_NUMBER; i++,vlanPtr++) {
		if (vlanPtr->valid == 0)
			continue;
		if(vlanPtr->memberPortMask & (1<<port)) {
			if(linkUp==TRUE)
				vlanPtr->memberPortUpStatus |= (1<<port);
			else
				vlanPtr->memberPortUpStatus &= ~(1<<port);
			RTL8651_SETASICVLAN(vlanPtr);
		}
	}

#ifdef RTL865XB_DCUT_SWVLAN
	
	for (i = 0, swVlanPtr = &DrvTbl.swVlan[0]; i < RTL8651_SWVLAN_NUMBER; i++, swVlanPtr++) {
		if (swVlanPtr->valid == 0)
			continue;
		if (swVlanPtr->memberPortMask & (1 << port)) {
			if (linkUp == TRUE)
				swVlanPtr->memberPortUpStatus |= (1 << port);
			else
				swVlanPtr->memberPortUpStatus &= ~(1 << port);
		}
	}
#endif
	
	memset(&cachedDA,0,sizeof(ether_addr_t)); 

#if 1 && defined(CONFIG_RTL865X_MULTILAYER_BSP) 
	if ( rtl8651_l2protoPassThrough & PASSTHRU_PPPOE )
	{
		

		
		if ( 0 && rtl8651_drvDropUnknownPppoePADT )
			rtl8651_setProtocolBasedVLAN( RTL8651_PBV_RULE_PPPOE_CONTROL, port, FALSE, rtl8651_vlanTableIndex(rtl8651_gPPPoEPassthruVlanID) );
		else
			rtl8651_setProtocolBasedVLAN( RTL8651_PBV_RULE_PPPOE_CONTROL, port, linkUp, rtl8651_vlanTableIndex(rtl8651_gPPPoEPassthruVlanID) );

		
		rtl8651_setProtocolBasedVLAN( RTL8651_PBV_RULE_PPPOE_SESSION, port, linkUp, rtl8651_vlanTableIndex(rtl8651_gPPPoEPassthruVlanID) );
	}
#else 
#endif

#if 1 && defined(CONFIG_RTL865X_MULTILAYER_BSP) 
	if ( rtl8651_l2protoPassThrough & PASSTHRU_IPV6 )
	{
		
		if ( rtl8651_pbv_ipv6passthru != RTL8651_IPV6PASSTHRU_PBVID_IS_NOT_SET )
			rtl8651_setProtocolBasedVLAN( rtl8651_pbv_ipv6passthru, port, linkUp, rtl8651_vlanTableIndex(rtl8651_gIPv6PassthruVlanID) );
	}
#else 
#endif

#if 1 && defined(CONFIG_RTL865X_MULTILAYER_BSP) 
	if ( rtl8651_l2protoPassThrough & PASSTHRU_IPX )
	{
		
		if ( rtl8651_pbv_ipxpassthru != RTL8651_IPXPASSTHRU_PBVID_IS_NOT_SET )
			rtl8651_setProtocolBasedVLAN( rtl8651_pbv_ipxpassthru, port, linkUp, rtl8651_vlanTableIndex(rtl8651_gIPXPassthruVlanID) );
	}
#else 
#endif

#if 1 && defined(CONFIG_RTL865X_MULTILAYER_BSP) 
	if ( rtl8651_l2protoPassThrough & PASSTHRU_NETBIOS )
	{
		
		if ( rtl8651_pbv_netbiospassthru != RTL8651_NETBIOSPASSTHRU_PBVID_IS_NOT_SET )
			rtl8651_setProtocolBasedVLAN( rtl8651_pbv_netbiospassthru, port, linkUp, rtl8651_vlanTableIndex(rtl8651_gNetbiosPassthruVlanID) );
	}
#else 
#endif

	
	if (RtkHomeGatewayChipRevisionID >= 0x02)
	{
		int8 autoNego, fullDuplex;
		uint32 speed, advCap;
		rtl8651_getAsicEthernetPHY(port, &autoNego, &advCap, &speed, &fullDuplex);
		phyPortPtr->speed = (speed==1)? 1: 0;
		phyPortPtr->duplex = (fullDuplex==TRUE)? 1: 0;
		phyPortPtr->autoNegotiation = (autoNego==1)? 1: 0;
		phyPortPtr->autoAdvCapability = advCap;
		
		
	}
	
	else
	{
		if (phyPortPtr->autoAdvCapability < 0x4) { 
			int8 autoNego, fullDuplex;
			uint32 speed, advCap;
			rtl8651_getAsicEthernetPHY(port, &autoNego, &advCap, &speed, &fullDuplex);
			phyPortPtr->speed = (speed==1)? 1: 0;
			phyPortPtr->duplex = (fullDuplex==TRUE)? 1: 0;
			phyPortPtr->autoNegotiation = (autoNego==1)? 1: 0;
			
		}
	}

#ifdef CONFIG_RTL865X_MULTILAYER_BSP
	
	if (linkUp == FALSE) {
		_rtl8651_delMulticastByPort(port);
	}
#endif
	rtlglue_drvMutexUnlock();
	
	if(ethernetNotify == TRUE)
		rtl8651_linkStatusNotifier(port, linkUp);

}

static void _rtl8651_updateAsicPHY(uint32 port) {
	rtl8651_setAsicEthernetPHY(port, DrvTbl.phyPort[port].autoNegotiation==1? TRUE: FALSE, DrvTbl.phyPort[port].autoAdvCapability, DrvTbl.phyPort[port].speed, DrvTbl.phyPort[port].duplex==1? TRUE: FALSE);
}



int32 rtl8651_getEthernetPortLinkStatus(uint32 port, int8 * linkUp, uint16 *speed, int8 *fullduplex, int8 *autoNeg)
{
	rtl8651_tblDrv_ethernet_t *phyPortPtr;

	UNLOCK_ERROR_CHECK((port>=RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	phyPortPtr = &DrvTbl.phyPort[port];

	if(linkUp)
		*linkUp = phyPortPtr->linkUp==1? TRUE: FALSE;
	if(speed){
		int32 _speed[]={ 10, 100, 1000 };
		*speed = _speed[phyPortPtr->speed];
	}
	if(fullduplex)
		*fullduplex = phyPortPtr->duplex==1? TRUE: FALSE;

	
	if (RtkHomeGatewayChipRevisionID >= 0x02)
	{
		if(autoNeg)
			*autoNeg = phyPortPtr->autoNegotiation==1? TRUE: FALSE;
	}
	
	else	
	{
		if (autoNeg) {
			if (phyPortPtr->fake_forceMode == 1)		
				*autoNeg = FALSE;
			
			else	
				*autoNeg = TRUE;
		}
	}

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}

int32 _rtl8651_setEthernetPortAutoNegotiation(uint32 port, int8 autoNegotiation, uint32 advCapability) {
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	rtl8651_tblDrv_ethernet_t *phyPortPtr;
	int32 i;

	
	if (RtkHomeGatewayChipRevisionID >= 0x02)
	{
		
		for(i=0,aggrePtr=&DrvTbl.aggregator[0]; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++, aggrePtr++) {
			LOCK_ERROR_CHECK(
				( (aggrePtr->aggregated==1)&&(aggrePtr->ethernetPortMask&(1<<port)) ),
				TBLDRV_EPORTAUTONEGOCANNOTAGGREGATE
			);		
		}
		phyPortPtr = &DrvTbl.phyPort[port];
		phyPortPtr->autoNegotiation = autoNegotiation==TRUE? 1: 0;
		phyPortPtr->autoAdvCapability = advCapability;
		_rtl8651_updateAsicPHY(port);
	}
	
	else
	{
		
		for(i=0,aggrePtr=&DrvTbl.aggregator[0]; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++, aggrePtr++) {
			LOCK_ERROR_CHECK(
				( (aggrePtr->aggregated==1)&&(aggrePtr->ethernetPortMask&(1<<port)) ),
				TBLDRV_EPORTAUTONEGOCANNOTAGGREGATE
			);		
		}	

		phyPortPtr = &DrvTbl.phyPort[port];
		
		if (autoNegotiation == FALSE)
			phyPortPtr->fake_forceMode = 1;	
		else
			phyPortPtr->fake_forceMode = 0;

		phyPortPtr->autoNegotiation = 1;			
		phyPortPtr->autoAdvCapability = advCapability;
		if (advCapability == RTL8651_ETHER_FORCE_100FULL) {
			phyPortPtr->speed = 1;
			phyPortPtr->duplex = 1;
		}
		else if (advCapability == RTL8651_ETHER_FORCE_100HALF) {
			phyPortPtr->speed = 1;
			phyPortPtr->duplex = 0;
		}
		else if (advCapability == RTL8651_ETHER_FORCE_10FULL) {
			phyPortPtr->speed = 0;
			phyPortPtr->duplex = 1;
		}
		else if (advCapability == RTL8651_ETHER_FORCE_10HALF) {
			phyPortPtr->speed = 0;
			phyPortPtr->duplex = 0;
		}
		_rtl8651_updateAsicPHY(port);
	}

	return SUCCESS;
}



int32 rtl8651_setEthernetPortDuplexMode(uint32 port, int8 fullDuplex) {
	
	if (RtkHomeGatewayChipRevisionID >= 0x02)
	{
		rtl8651_tblDrv_linkAggregation_t *aggrePtr;
		uint32 i;

		UNLOCK_ERROR_CHECK((port>=RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
		rtlglue_drvMutexLock();
		
		if(!fullDuplex){
			
			for(i=0,aggrePtr=&DrvTbl.aggregator[0]; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++,aggrePtr++) {
				LOCK_ERROR_CHECK(
					( (aggrePtr->aggregated == 1)&&(aggrePtr->ethernetPortMask&(1<<port)) ),
					TBLDRV_EPORTOPMODECANNOTAGGREGATE
				);
			}
		}
		DrvTbl.phyPort[port].duplex = fullDuplex==TRUE? 1: 0;
		_rtl8651_updateAsicPHY(port);
		rtlglue_drvMutexUnlock();
		return SUCCESS;
	}
	
	else	
	{
		int32 retval;
		uint32 advCapability;

		UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);

		rtlglue_drvMutexLock();		


		
		if (DrvTbl.phyPort[port].speed == 1 && fullDuplex)
			advCapability = RTL8651_ETHER_FORCE_100FULL;
		else if (DrvTbl.phyPort[port].speed == 1 && !fullDuplex)
			advCapability = RTL8651_ETHER_FORCE_100HALF;
		else if (DrvTbl.phyPort[port].speed == 0 && fullDuplex)
			advCapability = RTL8651_ETHER_FORCE_10FULL;
		else
			advCapability = RTL8651_ETHER_FORCE_10HALF;

		retval = _rtl8651_setEthernetPortAutoNegotiation(port, FALSE, advCapability);

		rtlglue_drvMutexUnlock();	
		return retval;
	}
}



int32 rtl8651_setEthernetPortSpeed(uint32 port, uint32 speed) {
	
	if (RtkHomeGatewayChipRevisionID >= 0x02)
	{
		rtl8651_tblDrv_linkAggregation_t *aggrePtr;
		rtl8651_tblDrv_ethernet_t *phyPortPtr;
		uint32 newSpeed=0, i;

		UNLOCK_ERROR_CHECK((port>=RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
		UNLOCK_ERROR_CHECK(((speed!=10)&&(speed!=100)), TBLDRV_EUNKNOWPORTSPEED);
		rtlglue_drvMutexLock();
		switch(speed) {
			case 10:	newSpeed = 0; break;
			case 100:	newSpeed = 1; break;
			default:	assert(0);
		}
		phyPortPtr = &DrvTbl.phyPort[port];
		
		if(phyPortPtr->speed != newSpeed) {
			for(i=0,aggrePtr=&DrvTbl.aggregator[0]; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++,aggrePtr++) {
				LOCK_ERROR_CHECK(
					( (aggrePtr->aggregated == 1)&&(aggrePtr->ethernetPortMask&(1<<port)) ),
					TBLDRV_EPORTSPEEDCANNOTAGGREGATE;
				);
			}
		}
		phyPortPtr->speed = newSpeed;
		_rtl8651_updateAsicPHY(port);
		rtlglue_drvMutexUnlock();
		return SUCCESS;
	}
	
	else	
	{
		int32 retval;
		uint32 advCapability;

		UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
		UNLOCK_ERROR_CHECK(((speed != 10) && (speed!=100)), TBLDRV_EUNKNOWPORTSPEED);
		rtlglue_drvMutexLock();		

		if (speed == 100 && DrvTbl.phyPort[port].duplex)
			advCapability = RTL8651_ETHER_FORCE_100FULL;
		else if (speed == 100 && !DrvTbl.phyPort[port].duplex)
			advCapability = RTL8651_ETHER_FORCE_100HALF;
		else if (speed == 10 && DrvTbl.phyPort[port].duplex)
			advCapability = RTL8651_ETHER_FORCE_10FULL;
		else
			advCapability = RTL8651_ETHER_FORCE_10HALF;

		retval = _rtl8651_setEthernetPortAutoNegotiation(port, FALSE, advCapability);
		rtlglue_drvMutexUnlock();	
		return retval;
	}
}


int32 rtl8651_setEthernetPortAutoNegotiation(uint32 port, int8 autoNegotiation, uint32 advCapability) {
	int32 retval;

	
	if (RtkHomeGatewayChipRevisionID >= 0x02)
	{
		UNLOCK_ERROR_CHECK((port>=RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
	}
	
	else	
	{
	    	
		UNLOCK_ERROR_CHECK((port>=RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
		if ((autoNegotiation == TRUE && advCapability > 0x03) || (autoNegotiation == FALSE && advCapability < 0x04))
			return TBLDRV_EINVALIDINPUT;
	}
	rtlglue_drvMutexLock();

	retval = _rtl8651_setEthernetPortAutoNegotiation(port, autoNegotiation, advCapability);

	rtlglue_drvMutexUnlock();
	return retval;
}



int32 rtl8651_setEthernetPortBandwidthControl(uint32 port, int8 input, uint32 rate) {
	rtl8651_tblDrv_ethernet_t *phyPortPtr;
	uint32 rangeIdx, i, j, cfgRate;
	uint32 asicRate=0;	

	UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER), TBLDRV_EINVALIDPORT);

		
	if (RtkHomeGatewayChipRevisionID >= 0x02) {
		UNLOCK_ERROR_CHECK((rate > RTL8651_BC_64M), TBLDRV_EINVALIDDATARATE);
		
		rtlglue_drvMutexLock();
		{
			rangeIdx = 0;
			for(i=0; i<RTL8651_PORT_NUMBER; i++) {
				phyPortPtr = &DrvTbl.phyPort[i];
				if(i != port) {
					if(phyPortPtr->inputBandwidthControl == RTL8651_BC_128K || phyPortPtr->inputBandwidthControl == RTL8651_BC_256K ||
						phyPortPtr->inputBandwidthControl == RTL8651_BC_512K || phyPortPtr->outputBandwidthControl == RTL8651_BC_512K ||
						phyPortPtr->outputBandwidthControl == RTL8651_BC_128K || phyPortPtr->outputBandwidthControl == RTL8651_BC_256K) {
						assert(rangeIdx==0 || rangeIdx == 1);
						rangeIdx = 1;
					} else if (phyPortPtr->inputBandwidthControl == RTL8651_BC_16M || phyPortPtr->inputBandwidthControl == RTL8651_BC_32M ||
						phyPortPtr->inputBandwidthControl == RTL8651_BC_64M || phyPortPtr->outputBandwidthControl == RTL8651_BC_64M ||
						phyPortPtr->outputBandwidthControl == RTL8651_BC_16M || phyPortPtr->outputBandwidthControl == RTL8651_BC_32M ) {
						assert(rangeIdx==0 || rangeIdx == 2);
						rangeIdx = 2;
					}
				} else if (input == TRUE) {
					if(phyPortPtr->outputBandwidthControl == RTL8651_BC_128K || phyPortPtr->outputBandwidthControl == RTL8651_BC_256K ||
						phyPortPtr->outputBandwidthControl == RTL8651_BC_512K) {
						assert(rangeIdx==0 || rangeIdx == 1);
						rangeIdx = 1;
					} else if (phyPortPtr->outputBandwidthControl == RTL8651_BC_16M || phyPortPtr->outputBandwidthControl == RTL8651_BC_32M ||
						phyPortPtr->outputBandwidthControl == RTL8651_BC_64M) {
						assert(rangeIdx==0 || rangeIdx == 2);
						rangeIdx = 2;
					}
				
				} else {
					if(phyPortPtr->inputBandwidthControl == RTL8651_BC_128K || phyPortPtr->inputBandwidthControl == RTL8651_BC_256K ||
						phyPortPtr->inputBandwidthControl == RTL8651_BC_512K) {
						assert(rangeIdx==0 || rangeIdx == 1);
						rangeIdx = 1;
					} else if (phyPortPtr->inputBandwidthControl == RTL8651_BC_16M || phyPortPtr->inputBandwidthControl == RTL8651_BC_32M ||
						phyPortPtr->inputBandwidthControl == RTL8651_BC_64M) {
						assert(rangeIdx==0 || rangeIdx == 2);
						rangeIdx = 2;
					}
				}
			}
			if (((rate == RTL8651_BC_128K || rate == RTL8651_BC_256K || rate == RTL8651_BC_512K) && rangeIdx == 2) ||
				((rate == RTL8651_BC_16M || rate == RTL8651_BC_32M || rate == RTL8651_BC_64M) && rangeIdx == 1)) {
				rtlglue_drvMutexUnlock();
				return(TBLDRV_EINVALIDDATARATE);
			}
		}
		phyPortPtr = &DrvTbl.phyPort[port];
		if(input == TRUE)
			phyPortPtr->inputBandwidthControl = rate;
		else phyPortPtr->outputBandwidthControl = rate;
		
		if(rangeIdx == 2 || rate == RTL8651_BC_16M || rate == RTL8651_BC_32M || rate == RTL8651_BC_64M) {
			rtl8651_setAsicEthernetBandwidthControlX8(TRUE);
			for(i=0; i<RTL8651_PORT_NUMBER; i++) 
				for(j=0; j<2; j++) {
					phyPortPtr = &DrvTbl.phyPort[i];
					if(j)	cfgRate = phyPortPtr->inputBandwidthControl;
					else	cfgRate = phyPortPtr->outputBandwidthControl;
					switch(cfgRate){
						case RTL8651_BC_FULL:	asicRate = BW_FULL_RATE;
							break;
						case RTL8651_BC_1M:		asicRate = BW_128K;
							break;
						case RTL8651_BC_2M:		asicRate = BW_256K;
							break;
						case RTL8651_BC_4M:		asicRate = BW_512K;
							break;
						case RTL8651_BC_8M:		asicRate = BW_1M;
							break;
						case RTL8651_BC_16M:	asicRate = BW_2M;
							break;
						case RTL8651_BC_32M:	asicRate = BW_4M;
							break;
						case RTL8651_BC_64M:	asicRate = BW_8M;
							break;
						case RTL8651_BC_128K:
						case RTL8651_BC_256K:
						case RTL8651_BC_512K:
						default:
							assert(0);
					}
					rtl8651_setAsicEthernetBandwidthControl(i, j, asicRate);
				}
		}
		else {
			rtl8651_setAsicEthernetBandwidthControlX8(FALSE);
			for(i=0; i<RTL8651_PORT_NUMBER; i++) 
				for(j=0; j<2; j++) {
					phyPortPtr = &DrvTbl.phyPort[i];
					if(j)	cfgRate = phyPortPtr->inputBandwidthControl;
					else	cfgRate = phyPortPtr->outputBandwidthControl;
					switch(cfgRate){
						case RTL8651_BC_FULL:	asicRate = BW_FULL_RATE;
							break;
						case RTL8651_BC_128K:	asicRate = BW_128K;
							break;
						case RTL8651_BC_256K:	asicRate = BW_256K;
							break;
						case RTL8651_BC_512K:	asicRate = BW_512K;
							break;
						case RTL8651_BC_1M:		asicRate = BW_1M;
							break;
						case RTL8651_BC_2M:		asicRate = BW_2M;
							break;
						case RTL8651_BC_4M:		asicRate = BW_4M;
							break;
						case RTL8651_BC_8M:		asicRate = BW_8M;
							break;
						case RTL8651_BC_16M:
						case RTL8651_BC_32M:
						case RTL8651_BC_64M:
						default:
							assert(0);
					}
					rtl8651_setAsicEthernetBandwidthControl(i, j, asicRate);
				}
		}	
	}
	
	else {
		UNLOCK_ERROR_CHECK((rate > RTL8651_BC_32M), TBLDRV_EINVALIDDATARATE);
		rtlglue_drvMutexLock();
		{
			rangeIdx = 0;
			for(i=0; i<RTL8651_PORT_NUMBER; i++) {
				phyPortPtr = &DrvTbl.phyPort[i];
				if(i != port) {
					if(phyPortPtr->inputBandwidthControl == RTL8651_BC_128K || phyPortPtr->inputBandwidthControl == RTL8651_BC_256K ||
						phyPortPtr->outputBandwidthControl == RTL8651_BC_128K || phyPortPtr->outputBandwidthControl == RTL8651_BC_256K) {
						assert(rangeIdx==0 || rangeIdx == 1);
						rangeIdx = 1;
					} else if (phyPortPtr->inputBandwidthControl == RTL8651_BC_16M || phyPortPtr->inputBandwidthControl == RTL8651_BC_32M ||
						phyPortPtr->outputBandwidthControl == RTL8651_BC_16M || phyPortPtr->outputBandwidthControl == RTL8651_BC_32M ) {
						assert(rangeIdx==0 || rangeIdx == 2);
						rangeIdx = 2;
					}
				} else if (input == TRUE) {
					if(phyPortPtr->outputBandwidthControl == RTL8651_BC_128K || phyPortPtr->outputBandwidthControl == RTL8651_BC_256K) {
						assert(rangeIdx==0 || rangeIdx == 1);
						rangeIdx = 1;
					} else if (phyPortPtr->outputBandwidthControl == RTL8651_BC_16M || phyPortPtr->outputBandwidthControl == RTL8651_BC_32M ) {
						assert(rangeIdx==0 || rangeIdx == 2);
						rangeIdx = 2;
					}
				
				} else {
					if(phyPortPtr->inputBandwidthControl == RTL8651_BC_128K || phyPortPtr->inputBandwidthControl == RTL8651_BC_256K) {
						assert(rangeIdx==0 || rangeIdx == 1);
						rangeIdx = 1;
					} else if (phyPortPtr->inputBandwidthControl == RTL8651_BC_16M || phyPortPtr->inputBandwidthControl == RTL8651_BC_32M) {
						assert(rangeIdx==0 || rangeIdx == 2);
						rangeIdx = 2;
					}
				}
			}
			if (((rate == RTL8651_BC_128K || rate == RTL8651_BC_256K) && rangeIdx == 2) ||
				((rate == RTL8651_BC_16M || rate == RTL8651_BC_32M) && rangeIdx == 1)) {
				rtlglue_drvMutexUnlock();
				return(TBLDRV_EINVALIDDATARATE);
			}
		}
		phyPortPtr = &DrvTbl.phyPort[port];
		if(input == TRUE)
			phyPortPtr->inputBandwidthControl = rate;
		else phyPortPtr->outputBandwidthControl = rate;
		
		if(rangeIdx == 2 || rate == RTL8651_BC_16M || rate == RTL8651_BC_32M) {
			rtl8651_setAsicEthernetBandwidthControlX4(TRUE);
			for(i=0; i<RTL8651_PORT_NUMBER; i++) 
				for(j=0; j<2; j++) {
					phyPortPtr = &DrvTbl.phyPort[i];
					if(j)	cfgRate = phyPortPtr->inputBandwidthControl;
					else	cfgRate = phyPortPtr->outputBandwidthControl;
					switch(cfgRate){
						case RTL8651_BC_FULL:	asicRate = BW_FULL_RATE;
							break;
						case RTL8651_BC_512K:	asicRate = BW_128K;
							break;
						case RTL8651_BC_1M:		asicRate = BW_256K;
							break;
						case RTL8651_BC_2M:		asicRate = BW_512K;
							break;
						case RTL8651_BC_4M:		asicRate = BW_1M;
							break;
						case RTL8651_BC_8M:		asicRate = BW_2M;
							break;
						case RTL8651_BC_16M:	asicRate = BW_4M;
							break;
						case RTL8651_BC_32M:	asicRate = BW_8M;
							break;
						case RTL8651_BC_128K:
						case RTL8651_BC_256K:
						default:
							assert(0);
					}
					rtl8651_setAsicEthernetBandwidthControl(i, j, asicRate);
				}
		}
		else {
			rtl8651_setAsicEthernetBandwidthControlX4(FALSE);
			for(i=0; i<RTL8651_PORT_NUMBER; i++) 
				for(j=0; j<2; j++) {
					phyPortPtr = &DrvTbl.phyPort[i];
					if(j)	cfgRate = phyPortPtr->inputBandwidthControl;
					else	cfgRate = phyPortPtr->outputBandwidthControl;
					switch(cfgRate){
						case RTL8651_BC_FULL:	asicRate = BW_FULL_RATE;
							break;
						case RTL8651_BC_128K:	asicRate = BW_128K;
							break;
						case RTL8651_BC_256K:	asicRate = BW_256K;
							break;
						case RTL8651_BC_512K:	asicRate = BW_512K;
							break;
						case RTL8651_BC_1M:		asicRate = BW_1M;
							break;
						case RTL8651_BC_2M:		asicRate = BW_2M;
							break;
						case RTL8651_BC_4M:		asicRate = BW_4M;
							break;
						case RTL8651_BC_8M:		asicRate = BW_8M;
							break;
						case RTL8651_BC_16M:	
						case RTL8651_BC_32M:	
						default:
							assert(0);
					}
					rtl8651_setAsicEthernetBandwidthControl(i, j, asicRate);
				}
		}	
	}
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}

static uint32 mPortMask = 0;
static uint32 mRxMirrorMask = 0;
static uint32 mTxMirrorMask = 0;

static int32 _rtl8651_delMirrorPort(uint32 port) {
	rtl8651_tblDrv_linkAggregation_t *aggregate_t;
	rtl8651_tblDrv_vlanTable_t *vlan_t;
	uint32 portMask, i;

	portMask = (1<<port);
	UNLOCK_ERROR_CHECK(!(mPortMask&portMask), TBLDRV_EMIRRORPORTNOTFOUND);
	aggregate_t = &DrvTbl.aggregator[port];
	assert(aggregate_t->aggregated == 0);
	assert(aggregate_t->ethernetPortMask > 0);
	aggregate_t->pvid = 1; 
	
	for(i=0,vlan_t=&DrvTbl.vlan[0]; i<RTL8651_VLAN_NUMBER; i++,vlan_t++) 
		if (vlan_t->valid == 1 && vlan_t->vid == 1)
			break;
	assert(i < RTL8651_VLAN_NUMBER);
	vlan_t->memberPortMask |= portMask;
	vlan_t->memberPortUpStatus |= portMask;
	vlan_t->untagPortMask |= portMask;
	RTL8651_SETASICVLAN(vlan_t);
	mPortMask &= ~portMask;
	rtl8651_setAsicPortMirror(mTxMirrorMask, mRxMirrorMask, mPortMask);
	return SUCCESS;
}


int32 rtl8651_addRxTxMirror(int8 isRxMirror, uint32 port) {
	uint32 portMask;

	UNLOCK_ERROR_CHECK(port>=RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum, TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	portMask = (1<<port);
	
	LOCK_ERROR_CHECK((mPortMask&portMask), TBLDRV_EPORTISAMIRRORPORT);
	if (isRxMirror == TRUE)
		mRxMirrorMask |= portMask;
	else mTxMirrorMask = portMask; 
	if (mPortMask != 0)
		rtl8651_setAsicPortMirror(mTxMirrorMask, mRxMirrorMask, mPortMask);
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_delRxTxMirror(int8 isRxMirror, uint32 port) {
	uint32 portMask;

	UNLOCK_ERROR_CHECK(port>=RTL8651_PORT_NUMBER, TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	portMask = (1<<port);
	
	LOCK_ERROR_CHECK((mPortMask&portMask), TBLDRV_EPORTISAMIRRORPORT);
	if (isRxMirror == TRUE)
		mRxMirrorMask &= ~portMask;
	else mTxMirrorMask = 0;
	if (mPortMask != 0)
		rtl8651_setAsicPortMirror(mTxMirrorMask, mRxMirrorMask, mPortMask);
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_addMirrorPort(uint32 port) {
	rtl8651_tblDrv_linkAggregation_t *aggregate_t;
	rtl8651_tblDrv_vlanTable_t *vlan_t;
	uint32 portMask, i;

	
	UNLOCK_ERROR_CHECK(port>=RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum, TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	portMask = (1<<port);
	
	LOCK_ERROR_CHECK(((mRxMirrorMask&portMask)||(mTxMirrorMask&portMask)), TBLDRV_EPORTISARXTXMIRRORED);
	LOCK_ERROR_CHECK((mPortMask&portMask), SUCCESS);
	
	aggregate_t = &DrvTbl.aggregator[0];
	for(i=0; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++, aggregate_t++) {
		if (aggregate_t->aggregated == 0)
			continue;
		LOCK_ERROR_CHECK((aggregate_t->ethernetPortMask&portMask), TBLDRV_EPORTCANTBEAGGREGATED);
	}
	
	for(i=0,vlan_t=&DrvTbl.vlan[0]; i<RTL8651_VLAN_NUMBER; i++,vlan_t++) {
		if (vlan_t->valid == 0)
			continue;
		vlan_t->memberPortMask &= ~portMask;
		vlan_t->untagPortMask &= ~portMask;
		vlan_t->memberPortUpStatus &= ~portMask;
		RTL8651_SETASICVLAN(vlan_t);
	}
	mPortMask |= portMask;
	rtl8651_setAsicPortMirror(mTxMirrorMask, mRxMirrorMask, mPortMask);
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_delMirrorPort(uint32 port) {
	int32 retval;
	UNLOCK_ERROR_CHECK(port>=RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum, TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	retval = _rtl8651_delMirrorPort(port);
	rtlglue_drvMutexUnlock();
	return retval;
}


int32 rtl8651_resetRxTxMirror(void) {
	uint32 port;
	mRxMirrorMask = mTxMirrorMask = 0;
	rtl8651_setAsicPortMirror(0, 0, 0);
	
	for(port=0; port<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; port++)
		if (mPortMask&(1<<port))
			_rtl8651_delMirrorPort(port);
	return SUCCESS;
}


int32 rtl8651_setVlanFwdTxMirror(uint16 vid, int8 isFwdTxMirror) {
	rtl8651_tblDrv_networkIntfTable_t *netIfPtr;
	rtl8651_tblDrv_pppTable_t *pppoePtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	uint32 i;

	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094), TBLDRV_EINVALIDVLANID);
	rtlglue_drvMutexLock();
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	LOCK_ERROR_CHECK((vlanPtr->valid == 0 || vlanPtr->vid != vid), TBLDRV_EINVALIDVLANID);
	LOCK_ERROR_CHECK((vlanPtr->fwdTxMirror == (isFwdTxMirror==TRUE? 1: 0)), SUCCESS);
	if(isFwdTxMirror == TRUE) {
		if(rtl8651_getAsicOperationLayer()>2){
			for(i=0, netIfPtr=&DrvTbl.netIface[0]; i< rtl8651_tblDrvPara.networkIntfTableSize; i++,netIfPtr++)
				if(netIfPtr->valid == 1 && netIfPtr->vid == vid) {
					rtlglue_drvMutexUnlock();
					return(TBLDRV_EVLANISREFERENCEDBYNETIF);
				}
			for(i=0, pppoePtr=&DrvTbl.pppoe[0]; i<RTL8651_PPPOE_NUMBER; i++, pppoePtr++)
				if(pppoePtr->valid == 1 && pppoePtr->vid == vid) {
					rtlglue_drvMutexUnlock();
					return(TBLDRV_EVLANISREFERENCEDBYPPPOE);
				}
		}
		if(vlanPtr->promiscuous == 1)
			return (TBLDRV_EVLANPROMISSET);
	}
	vlanPtr->fwdTxMirror= isFwdTxMirror==TRUE? 1: 0;
	if(isFwdTxMirror == TRUE)
		rtl8651_tblDrvCpuMirrorPortMask |= vlanPtr->memberPortMask;
	else
		rtl8651_tblDrvCpuMirrorPortMask &= ~vlanPtr->memberPortMask;
	RTL8651_SETASICVLAN(vlanPtr);
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}





#undef STP_DEBUG
#define __STPSTATE(s)	(((s)==0)?"DISABLE":((s)==1)?"BLK":((s)==2)?"LTN":((s)==3)?"LRN":((s)==4)?"FWD":"UNKNOW")


int32 rtl8651_addSpanningTreeInstance(uint16 sid) {
	rtl8651_tblDrv_spanningTreeTable_t *spanTreePtr, *stPtr;
	uint32 i;
	
	

	 
	UNLOCK_ERROR_CHECK((sid >= RTL8651_FDB_NUMBER), TBLDRV_EINVALIDSID);
	rtlglue_drvMutexLock();
	spanTreePtr = &DrvTbl.spanningTree[sid];
	LOCK_ERROR_CHECK((spanTreePtr->valid == 1), TBLDRV_ESIDALREADYEXIST);
	for(i = 0, stPtr=&DrvTbl.spanningTree[0]; i<RTL8651_FDB_NUMBER; i++, stPtr++) 
		if(stPtr->valid == 1)
			break;
	if(i==RTL8651_FDB_NUMBER)
	{
		rtl8651_setAsicSpanningEnable(FALSE);
		
		rtl8651_tblDrvSpanningTreeEnable = FALSE;
	}
	spanTreePtr->valid = 1;
	spanTreePtr->protocolWorking = 0;
	for(i=0;i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++) {
		spanTreePtr->portState[i] = RTL8651_PORTSTA_FORWARDING;
		rtl8651_setAsicMulticastSpanningTreePortState(i, RTL8651_PORTSTA_FORWARDING);
		rtl8651_tblDrvSpanningTreePortFwdStatus |= (1<<i);	
	}
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_setSpanningTreeInstanceProtocolWorking(uint16 sid, int8 working) {
	rtl8651_tblDrv_spanningTreeTable_t *spanTreePtr, *tmpPtr;
	uint32 i, workingCount;
	int8 previousWorking;
	
	UNLOCK_ERROR_CHECK((sid >= RTL8651_STI_NUMBER), TBLDRV_EINVALIDSID);
	rtlglue_drvMutexLock();
	spanTreePtr = &DrvTbl.spanningTree[sid];
	LOCK_ERROR_CHECK((spanTreePtr->valid == 0), TBLDRV_EINVALIDSID);
	previousWorking = spanTreePtr->protocolWorking == 1? TRUE: FALSE;
	spanTreePtr->protocolWorking = working == TRUE? 1: 0;
	workingCount = 0;
	for(i=0,tmpPtr=&DrvTbl.spanningTree[0]; i< RTL8651_STI_NUMBER; i++, tmpPtr++)
		if(tmpPtr->valid == 1 && tmpPtr->protocolWorking == 1)
			workingCount++;
	if(previousWorking == TRUE && working == FALSE && workingCount == 0) {
		rtl8651_setAsicSpanningEnable(FALSE);
		
		rtl8651_tblDrvSpanningTreeEnable = FALSE;
	}
	if(previousWorking == FALSE && working == TRUE && workingCount == 1) {
		rtl8651_setAsicSpanningEnable(TRUE);
		
		rtl8651_tblDrvSpanningTreeEnable = TRUE;
	}
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}




int32 rtl8651_setSpanningTreeInstancePortState(uint16 stid, uint16 port, uint8 portState) {
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	rtl8651_tblDrv_spanningTreeTable_t *spanTreePtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	uint16 i, vid;

	#ifdef STP_DEBUG
	uint32 oldState = rtl8651_tblDrvSpanningTreePortFwdStatus;
	printk("[%s]\n\t=> stid %d port %d portState %d\n", __FUNCTION__, stid, port, portState);
	#endif
	
	UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
	UNLOCK_ERROR_CHECK((stid >= RTL8651_STI_NUMBER), TBLDRV_EINVALIDSID);
	UNLOCK_ERROR_CHECK((portState > 4), TBLDRV_EINVALIDPORTSTATE);
	rtlglue_drvMutexLock();
	aggrePtr = &DrvTbl.aggregator[port];
	spanTreePtr = &DrvTbl.spanningTree[stid];
	LOCK_ERROR_CHECK((aggrePtr->ethernetPortMask == 0), TBLDRV_EINVALIDPORT);
	LOCK_ERROR_CHECK((spanTreePtr->valid == 0), TBLDRV_EINVALIDSID);
	
	for(i = 0; i< RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++)
		if(aggrePtr->ethernetPortMask & (1<<i)) {

			#ifdef STP_DEBUG
			uint32 tempOld = rtl8651_tblDrvSpanningTreePortFwdStatus;
			printk("[%s]\n\t=> Update port[%d] State: [%s] -> [%s]\n",	__FUNCTION__,
															i,
															__STPSTATE(spanTreePtr->portState[i]),
															__STPSTATE(portState));
			#endif

			
			spanTreePtr->portState[i] = portState; 
			rtl8651_setAsicMulticastSpanningTreePortState(i, portState);	
			
			rtl8651_tblDrvSpanningTreePortFwdStatus =
				(portState==RTL8651_PORTSTA_FORWARDING)?
					(rtl8651_tblDrvSpanningTreePortFwdStatus|(1<<i)):
					(rtl8651_tblDrvSpanningTreePortFwdStatus&~(1<<i));


			#ifdef STP_DEBUG
			if (rtl8651_tblDrvSpanningTreePortFwdStatus != tempOld) {
				printk("\tUpdate Port [%d]: %s\n",
					i,
					(portState==RTL8651_PORTSTA_FORWARDING)?
					"BLK -> FWD":"FWD -> BLK");
			}
			#endif
		}

	#ifdef STP_DEBUG
	if (oldState != rtl8651_tblDrvSpanningTreePortFwdStatus) {
		printk("[%s]\n\t=>Forwarding state update: (%x) --> (%x)\n",
					__FUNCTION__,
					oldState,
					rtl8651_tblDrvSpanningTreePortFwdStatus);
	} else
		printk("[%s]\n\t=>Forwarding state not change (%x)\n", __FUNCTION__, oldState);
	#endif

	
	for(vid = 0, vlanPtr=&DrvTbl.vlan[0]; vid<RTL8651_VLAN_NUMBER; vid++, vlanPtr++)
		if(vlanPtr->valid == 1) {
			assert(vlanPtr->fid<RTL8651_FDB_NUMBER);
			assert(DrvTbl.filterDB[vlanPtr->fid].valid == 1);
			assert(DrvTbl.filterDB[vlanPtr->fid].sid<RTL8651_STI_NUMBER);
			assert(DrvTbl.spanningTree[DrvTbl.filterDB[vlanPtr->fid].sid].valid == 1);
			if(DrvTbl.filterDB[vlanPtr->fid].sid == stid)
				RTL8651_SETASICVLAN(vlanPtr);
		}

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_delSpanningTreeInstance(uint16 sid) {
	rtl8651_tblDrv_spanningTreeTable_t *spanTreePtr;
	rtl8651_tblDrv_filterDbTable_t *fdbPtr;
	uint16 fid;

	
	UNLOCK_ERROR_CHECK((sid >= RTL8651_FDB_NUMBER), TBLDRV_EINVALIDSID);
	rtlglue_drvMutexLock();
	spanTreePtr = &DrvTbl.spanningTree[sid];
	LOCK_ERROR_CHECK((spanTreePtr->valid == 0), TBLDRV_EINVALIDSID);
	for(fid=0, fdbPtr=&DrvTbl.filterDB[0]; fid<RTL8651_FDB_NUMBER; fid++, fdbPtr++) {
		
		LOCK_ERROR_CHECK((fdbPtr->valid==1&&fdbPtr->sid==sid), TBLDRV_ESIDISREFERENCEEDBYFID);
		}
	spanTreePtr->valid = 0;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


#define RTL8651_FILTER_DATABASE_APIs


int32 rtl8651_addFilterDatabase(uint16 fid) {
	rtl8651_tblDrv_filterDbTable_t *fdbPtr;
	ether_addr_t mac = { {0xff, 0xff, 0xff, 0xff, 0xff, 0xff} };
	int32 retval, i;
	uint32 portmask=0xffffffff;

	
	UNLOCK_ERROR_CHECK((fid >= RTL8651_FDB_NUMBER), TBLDRV_EINVALIDFID);
	rtlglue_drvMutexLock();
	fdbPtr = &DrvTbl.filterDB[fid];
	LOCK_ERROR_CHECK((fdbPtr->valid == 1), TBLDRV_EFIDALREADYEXISTS);
	fdbPtr->valid = 1;	
	assert(DrvTbl.spanningTree[0].valid);
	fdbPtr->sid = 0;	
	for(i=0; i<RTL8651_L2TBL_ROW; i++)
		SLIST_INIT(&(fdbPtr->database[i]));
	
	#if 1
	retval = _rtl8651_addVlanRefFilterDatabaseEntry(RTL8651_L2_TYPEII, fid, 0, &mac, RTL8651_FORWARD_MAC, portmask);
	#else
	retval = _rtl8651_addVlanRefFilterDatabaseEntry(RTL8651_L2_TYPEII, fid, 0, &mac, RTL8651_TOCPU_MAC, portmask);
	#endif

	assert(retval == SUCCESS);
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_specifyFilterDatabaseSpanningTreeInstance(uint16 fid, uint16 sid) {
	rtl8651_tblDrv_filterDbTable_t *fdbPtr;
	int32 retval = SUCCESS;
	
	UNLOCK_ERROR_CHECK((fid >= RTL8651_FDB_NUMBER), TBLDRV_EINVALIDFID);
	UNLOCK_ERROR_CHECK((sid >= RTL8651_FDB_NUMBER), TBLDRV_EINVALIDSID);
	rtlglue_drvMutexLock();
	fdbPtr = &DrvTbl.filterDB[fid];
	if(fdbPtr->valid == 0){
		retval = TBLDRV_EINVALIDFID;
	}else if(DrvTbl.spanningTree[sid].valid == 0)
		retval = TBLDRV_EINVALIDSID;
	else fdbPtr->sid = sid;	
	rtlglue_drvMutexUnlock();
	return retval;
}


int32 rtl8651_delFilterDatabase(uint16 fid) {
	ether_addr_t mac = { {0xff, 0xff, 0xff, 0xff, 0xff, 0xff} };
	rtl8651_tblDrv_filterDbTable_t *fdbPtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	int32 retval, i;

	
	UNLOCK_ERROR_CHECK((fid >= RTL8651_FDB_NUMBER), TBLDRV_EINVALIDFID);
	rtlglue_drvMutexLock();
	fdbPtr = &DrvTbl.filterDB[fid];
	LOCK_ERROR_CHECK((fdbPtr->valid == 0), TBLDRV_EINVALIDFID);
	
	for(i=0, vlanPtr=&DrvTbl.vlan[0]; i<RTL8651_VLAN_NUMBER; i++, vlanPtr++)
		LOCK_ERROR_CHECK((vlanPtr->valid == 1 && vlanPtr->fid == fid), TBLDRV_EFIDISREFERENCEDBYVLAN);
	for(i=0; i<RTL8651_L2TBL_ROW; i++) 
		LOCK_ERROR_CHECK((SLIST_FIRST(&(fdbPtr->database[i]))), TBLDRV_EFIDISNOTEMPTY);
	
	retval = _rtl8651_delVlanRefFilterDatabaseEntry(RTL8651_L2_TYPEII, fid, &mac);
	if (retval == SUCCESS)
		fdbPtr->valid = 0;	
	rtlglue_drvMutexUnlock();
	return retval;
}


static void _rtl8651_arrangeAsicL2Entry(uint16 fid, uint32 l2Index) {
	rtl8651_tblDrv_filterDbTableEntry_t *l2_old[RTL8651_L2TBL_COLUMN];
	rtl8651_tblDrv_filterDbTableEntry_t *l2_new[RTL8651_L2TBL_COLUMN];
	rtl8651_tblDrv_filterDbTableEntry_t *l2Entry;
	rtl8651_tblDrv_filterDbTable_t *fdbPtr= &DrvTbl.filterDB[fid];
	int8 cpu , srcBlk , occupied[RTL8651_L2TBL_COLUMN] = { FALSE, FALSE, FALSE, FALSE };
	uint32 colIdx, i, j;
	int32 useNxtHopFlag=0;
	for(colIdx=0; colIdx<RTL8651_L2TBL_COLUMN; colIdx++) 
		l2_old[colIdx] = l2_new[colIdx] = NULL;
	SLIST_FOREACH(l2Entry, &(fdbPtr->database[l2Index]), nextFDB) 
		if (l2Entry->configToAsic == 1)
			l2_old[l2Entry->asicPos] = l2Entry;

	colIdx = 0;
	
	SLIST_FOREACH(l2Entry, &(fdbPtr->database[l2Index]), nextFDB) {
		if (colIdx == RTL8651_L2TBL_COLUMN)
			goto __pass;
		if (l2Entry->l2type & RTL8651_L2_TYPEII) 
			l2_new[colIdx++] = l2Entry; 
	}
	
	SLIST_FOREACH(l2Entry, &(fdbPtr->database[l2Index]), nextFDB)  {
		if (colIdx == RTL8651_L2TBL_COLUMN)
			goto __pass;
		if (l2Entry->l2type & RTL8651_L2_TYPEII) 
			continue; 
		if (l2Entry->l2type & RTL8651_L2_TYPEIII)
			l2_new[colIdx++] = l2Entry;
	}
	
	SLIST_FOREACH(l2Entry, &(fdbPtr->database[l2Index]), nextFDB) {
		if (colIdx == RTL8651_L2TBL_COLUMN)
			goto __pass;
		if (l2Entry->l2type & RTL8651_L2_TYPEII || l2Entry->l2type & RTL8651_L2_TYPEIII)
			continue; 
		if (l2Entry->l2type & RTL8651_L2_TYPEI)
			l2_new[colIdx++] = l2Entry;
	}

__pass:

	for(i=0; i<RTL8651_L2TBL_COLUMN; i++)
		for(j=0; l2_new[i]&&j<RTL8651_L2TBL_COLUMN; j++)
			if (l2_new[i] == l2_old[j]) {
				occupied[l2_old[j]->asicPos] = TRUE;
				l2_new[i] = l2_old[j] = NULL;
				break;
		}

	colIdx = 0;
	for(i=0; i<RTL8651_L2TBL_COLUMN; i++) {
		if ((l2Entry=l2_new[i]) == NULL)
			continue;
		while(colIdx < RTL8651_L2TBL_COLUMN && occupied[colIdx]==TRUE)
			colIdx++;
		assert(colIdx < RTL8651_L2TBL_COLUMN);
		l2Entry->configToAsic = 1;
		l2Entry->asicPos = colIdx;
		occupied[colIdx] = TRUE;
		switch(l2Entry->process) 
		{
		default:
		case RTL8651_FORWARD_MAC:
		case RTL8651_DSTBLOCK_MAC:  
			cpu = srcBlk = FALSE;
			break;
		case RTL8651_SRCBLOCK_MAC:  
			cpu = FALSE; srcBlk = TRUE;
			break;
		case RTL8651_TOCPU_MAC: 	
			cpu = TRUE; srcBlk = FALSE;			
		}

		 
		if(peripheralExtPortMask)
			useNxtHopFlag=1;  

		rtl8651_setAsicL2Table_Patch(
					l2Index, 
					l2Entry->asicPos, 
					&l2Entry->macAddr, 
					cpu, 
					srcBlk, 
					l2Entry->memberPortMask, 
					arpAgingTime, 
					TRUE, 
					useNxtHopFlag
					);
		if(rtl8651_L2statusNotifier)
			rtl8651_L2statusNotifier(l2Entry,NULL);
	}
	for(i=0; i<RTL8651_L2TBL_COLUMN; i++)
		if (l2_old[i]) {
			l2_old[i]->configToAsic = 0;
			if(rtl8651_L2statusNotifier)
				rtl8651_L2statusNotifier(l2_old[i],NULL);
		}
	for(i=0; i<RTL8651_L2TBL_COLUMN; i++)
		if (occupied[i] == FALSE)
			rtl8651_delAsicL2Table(l2Index, i);
}

	
int32 _rtl8651_addVlanRefFilterDatabaseEntry(uint16 l2Type, uint16 fid, uint16 vid, ether_addr_t * macAddr, uint32 type, uint32 portMask) {
	rtl8651_tblDrv_filterDbTable_t *fdb_t = &DrvTbl.filterDB[fid];
	rtl8651_tblDrv_filterDbTableEntry_t * l2entry_t, *tmpL2;
	uint32 rowIdx = rtl8651_filterDbIndex(macAddr), typeII = 0;

#ifdef RTL865XB_DCUT_SWVLAN
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr = NULL;
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];

	if (vlanPtr->valid == 0 || vlanPtr->vid != vid) {
		swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
		if (swVlanPtr->valid == 0)
			swVlanPtr = NULL;
	}
#endif

	#if 0
	rtlglue_printf("(1) macAddr: %x.%x.%x.%x.%x.%x\n", 
		macAddr->octet[0], macAddr->octet[1], macAddr->octet[2], 
		macAddr->octet[3], macAddr->octet[4], macAddr->octet[5]);
	#endif

	SLIST_FOREACH(l2entry_t, &(fdb_t->database[rowIdx]), nextFDB) {
		
		if (l2entry_t->l2type & RTL8651_L2_TYPEII)
			typeII++;
	}
	
	if (typeII == RTL8651_L2TBL_COLUMN && l2Type == RTL8651_L2_TYPEII) 
		return TBLDRV_ENOFREEBUFFER;
	
	
	SLIST_FOREACH(l2entry_t, &(fdb_t->database[rowIdx]), nextFDB) 
		if (!memcmp(&l2entry_t->macAddr, macAddr, sizeof(ether_addr_t))) 
			break; 
	if (l2entry_t != (rtl8651_tblDrv_filterDbTableEntry_t *)NULL) {
		switch(l2Type)
		{
		case RTL8651_L2_TYPEI:	
			if (l2entry_t->process != 0)	
				return FAILED;
			if (l2entry_t->memberPortMask != portMask) {
				
				l2entry_t->memberPortMask = portMask;

				if (	(l2entry_t->linkId > 0) &&
					((portMask & peripheralExtPortMask) == 0))
				{
					l2entry_t->linkId = 0;
				}
#if defined(RTL865X_MODEL_USER) || defined(RTL865X_MODEL_KERNEL)
				
#else
	#ifdef CONFIG_RTL865X_MULTILAYER_BSP
				
				_rtl8651_removeArpByL2Entry(l2entry_t);
	#endif
#endif
				rtl8651_setAsicL2Table_Patch(
					rowIdx, 
					l2entry_t->asicPos, 
					&l2entry_t->macAddr, 
					FALSE, 
					FALSE, 
					l2entry_t->memberPortMask, 
					arpAgingTime, 
					TRUE, 
					FALSE
					);
				return SUCCESS;
			}
#if 0		
			 if (l2entry_t->process != 0 || l2entry_t->memberPortMask != portMask) {
				rtlglue_printf("[new]: %x:%x:%x:%x:%x:%x portMask: %x, vid:%d\n", macAddr->octet[0], macAddr->octet[1], macAddr->octet[2], macAddr->octet[3], macAddr->octet[4], macAddr->octet[5], portMask, vid);
				rtlglue_printf("[old]: %x:%x:%x:%x:%x:%x portMask: %x, refCount: %d, vid: %d\n\ttype: %x, pro: %x\n",
						l2entry_t->macAddr.octet[0], l2entry_t->macAddr.octet[1], l2entry_t->macAddr.octet[2], 
						l2entry_t->macAddr.octet[3], l2entry_t->macAddr.octet[4], l2entry_t->macAddr.octet[5],
						l2entry_t->memberPortMask, l2entry_t->refCount, l2entry_t->vid, l2entry_t->l2type,
						l2entry_t->process);
				return FAILED;
			 }
#endif

#ifdef RTL865XB_DCUT_SWVLAN
			if (swVlanPtr != NULL)
				rtl8651_setAsicL2Table_Patch(
					rowIdx, 
					l2entry_t->asicPos, 
					&l2entry_t->macAddr, 
					FALSE, 
					FALSE, 
					l2entry_t->memberPortMask, 
					arpAgingTime,
					TRUE,
					FALSE
					);
#endif

			 l2entry_t->l2type |= RTL8651_L2_TYPEI;
			 l2entry_t->refCount++;
			 return SUCCESS;
			 
		case RTL8651_L2_TYPEII:	
			 if (l2entry_t->l2type & RTL8651_L2_TYPEII || l2entry_t->memberPortMask != portMask)
			 	return TBLDRV_EL2ENTRYEXISTS;
			 l2entry_t->l2type |= RTL8651_L2_TYPEII;
			 break;
			 
		case RTL8651_L2_TYPEIII:	
			 if (l2entry_t->l2type & RTL8651_L2_TYPEIII || l2entry_t->memberPortMask != portMask)
			 	return TBLDRV_EL2ENTRYEXISTS;
			 l2entry_t->l2type |= RTL8651_L2_TYPEIII;
		}	
		_rtl8651_arrangeAsicL2Entry(fid, rowIdx);
		return SUCCESS;
	}

	
	if(SLIST_FIRST(&DrvTbl.freeList.filterDBentry) == NULL) 
		return(TBLDRV_ENOFREEBUFFER);	
	
	
	l2entry_t = SLIST_FIRST(&DrvTbl.freeList.filterDBentry);
	SLIST_REMOVE_HEAD(&DrvTbl.freeList.filterDBentry, nextFDB);
	
	
	l2entry_t->refCount = ((l2Type == RTL8651_L2_TYPEI)? 1: 0);
	l2entry_t->macAddr = *macAddr;
	l2entry_t->vid = vid;
	l2entry_t->configToAsic = 0;
	l2entry_t->l2type = l2Type;
	l2entry_t->linkId=0; 
	
	switch(type) {	
	case RTL8651_FORWARD_MAC:
	 	 l2entry_t->process = RTL8651_FORWARD_MAC;
		 l2entry_t->memberPortMask = portMask;
		 break;
	case RTL8651_DSTBLOCK_MAC:
		 l2entry_t->process = RTL8651_DSTBLOCK_MAC;
		 l2entry_t->memberPortMask = 0;
		 break;
	case RTL8651_SRCBLOCK_MAC:
		 l2entry_t->process = RTL8651_SRCBLOCK_MAC;
		 l2entry_t->memberPortMask = 0;
		 break;
	case RTL8651_TOCPU_MAC:
		 l2entry_t->process = RTL8651_TOCPU_MAC;
		 #if 1
		 l2entry_t->memberPortMask = 0;
		 #else
		 l2entry_t->memberPortMask = portMask;
		 #endif
	 	 break;
	default: assert(0);
	}
	if (SLIST_FIRST(&(fdb_t->database[rowIdx]))) {
		SLIST_FOREACH(tmpL2, &(fdb_t->database[rowIdx]), nextFDB) 
			if (tmpL2->nextFDB.sle_next == NULL) {
				tmpL2->nextFDB.sle_next = l2entry_t;
				l2entry_t->nextFDB.sle_next = NULL;
			break;
		}
	} else 
		SLIST_INSERT_HEAD(&(fdb_t->database[rowIdx]), l2entry_t, nextFDB);


	
	if(l2Type&RTL8651_L2_TYPEIII &&rtl8651_L2statusNotifier){
		
		rtl8651_L2statusNotifier(NULL,NULL);
	}


	_rtl8651_arrangeAsicL2Entry(fid, rowIdx);
	return SUCCESS;
}

 int32 _rtl8651_modifyVlanRefFilterDatabaseEntry(uint32 fid, ether_addr_t *mac, uint32 *memberPortMask, uint16 *process, uint32 *linkId, uint32 attr){
	rtl8651_tblDrv_filterDbTableEntry_t * thisL2entry;
	rtl8651_tblDrv_filterDbTable_t *fdbPtr;
	uint32 rowIdx = rtl8651_filterDbIndex(mac);
	assert(fid < RTL8651_FDB_NUMBER);
	assert(mac);
	fdbPtr = &DrvTbl.filterDB[fid];
	assert(fdbPtr->valid == 1);

	
	SLIST_FOREACH(thisL2entry, &(fdbPtr->database[rowIdx]), nextFDB){ 
		if(memcmp(&thisL2entry->macAddr, mac, sizeof(ether_addr_t)) == 0)
			break;
	}
	if(!thisL2entry)
		return FAILED;
	if(memberPortMask){
		
		thisL2entry->memberPortMask=*memberPortMask;
	}
	if(process)
		thisL2entry->process=*process;
	if(linkId)
		thisL2entry->linkId=*linkId;
	if(thisL2entry->configToAsic){
		rtl865x_tblAsicDrv_l2Param_t asic_l2;
		bzero(&asic_l2, sizeof(rtl865x_tblAsicDrv_l2Param_t));
		rtl8651_getAsicL2Table_Patch(rowIdx, thisL2entry->asicPos, &asic_l2);

		if(peripheralExtPortMask)
			asic_l2.nhFlag=1;

		if (attr == L2_FORCE_STATIC) {
			asic_l2.isStatic = TRUE;
			asic_l2.nhFlag = 0;
		}
		else if (attr == L2_FORCE_DYNAMIC) {
			asic_l2.isStatic = FALSE;
			asic_l2.nhFlag = 0;
		}
		asic_l2.macAddr = thisL2entry->macAddr;
		asic_l2.memberPortMask = thisL2entry->memberPortMask&(RTL8651_PHYSICALPORTMASK|rtl8651_allExtPortMask);
		rtl8651_setAsicL2Table(rowIdx, thisL2entry->asicPos, &asic_l2);
	}

	if(rtl8651_L2statusNotifier)
		rtl8651_L2statusNotifier(NULL,NULL);

return SUCCESS;
}


int32 _rtl8651_delVlanRefFilterDatabaseEntry(uint16 l2Type, uint16 fid, ether_addr_t * macAddr) {
	rtl8651_tblDrv_filterDbTable_t *fdb_t = &DrvTbl.filterDB[fid];
	rtl8651_tblDrv_filterDbTableEntry_t * l2entry_t;
	uint32 rowIdx = rtl8651_filterDbIndex(macAddr);

	SLIST_FOREACH(l2entry_t, &(fdb_t->database[rowIdx]), nextFDB)
		if (!memcmp(&l2entry_t->macAddr, macAddr, sizeof(ether_addr_t)))
			break;
	if (l2entry_t == (rtl8651_tblDrv_filterDbTableEntry_t *)NULL)
		return TBLDRV_EL2ENTRYNOTFOUND;
		
	switch(l2Type) 
	{
	case RTL8651_L2_TYPEI:
		 if (!(l2entry_t->l2type & RTL8651_L2_TYPEI))
			 return TBLDRV_EL2ENTRYNOTFOUND;
		 assert(l2entry_t->refCount > 0);
		 if (--l2entry_t->refCount == 0)
		 	l2entry_t->l2type &= ~RTL8651_L2_TYPEI;
		 break;
		 
	case RTL8651_L2_TYPEII:
		 if (!(l2entry_t->l2type & RTL8651_L2_TYPEII))
			 return TBLDRV_EL2ENTRYNOTFOUND;
		 l2entry_t->l2type &= ~RTL8651_L2_TYPEII;
		 break;
	
	case RTL8651_L2_TYPEIII:
		 if (!(l2entry_t->l2type & RTL8651_L2_TYPEIII))
			 return TBLDRV_EL2ENTRYNOTFOUND;
		 l2entry_t->l2type &= ~RTL8651_L2_TYPEIII;
		 break;
	}

	if (l2entry_t->l2type == 0x00) {
		SLIST_REMOVE(
			&(fdb_t->database[rowIdx]), 
			l2entry_t, 
			 rtl8651_tblDrv_filterDbTableEntry_s,
			 nextFDB
		);
		SLIST_INSERT_HEAD(&DrvTbl.freeList.filterDBentry, l2entry_t, nextFDB);
	}
	_rtl8651_arrangeAsicL2Entry(fid, rowIdx);
	return SUCCESS;
}
				
 rtl8651_tblDrv_filterDbTableEntry_t * 
_rtl8651_getVlanFilterDatabaseEntry(uint16 vid, ether_addr_t * macAddr) {
	rtl8651_tblDrv_filterDbTableEntry_t * tempFilterDbEntry;
	rtl8651_tblDrv_filterDbTable_t *fdbPtr;

	fdbPtr = &DrvTbl.filterDB[0];
	
	
	
	
	
	
	
	
	
	
	#if 0
	printk("_rtl8651_getVlanFilterDatabaseEntry mac: %x.%x.%x.%x.%x.%x\n", 
		macAddr->octet[0], macAddr->octet[1], macAddr->octet[2],
		macAddr->octet[3], macAddr->octet[4], macAddr->octet[5]);
	#endif
	SLIST_FOREACH(tempFilterDbEntry, &(fdbPtr->database[rtl8651_filterDbIndex(macAddr)]), nextFDB) 
		if(memcmp(&tempFilterDbEntry->macAddr, macAddr, sizeof(ether_addr_t)) == 0)
			return tempFilterDbEntry;
	return (rtl8651_tblDrv_filterDbTableEntry_t *)NULL;
}


int32 rtl8651_addFilterDatabaseEntry(uint16 fid, ether_addr_t * macAddr, uint32 type, uint32 portMask) {
	int32 retval;

	UNLOCK_ERROR_CHECK(
		( (type != RTL8651_FORWARD_MAC)&&(type != RTL8651_DSTBLOCK_MAC)&&
		  (type != RTL8651_SRCBLOCK_MAC)&&(type != RTL8651_TOCPU_MAC)
		), TBLDRV_EINVALIDACTIONTYPE
	);
	UNLOCK_ERROR_CHECK((fid >= RTL8651_FDB_NUMBER), TBLDRV_EINVALIDFID);
	UNLOCK_ERROR_CHECK((macAddr == (ether_addr_t *)NULL), TBLDRV_ENULLMACADDR);	
	rtlglue_drvMutexLock();
	LOCK_ERROR_CHECK((DrvTbl.filterDB[fid].valid == 0), TBLDRV_EINVALIDFID);
	retval = _rtl8651_addVlanRefFilterDatabaseEntry(RTL8651_L2_TYPEII, fid, 0, macAddr, type, portMask);
	rtlglue_drvMutexUnlock();
	return retval;
}


int32 rtl8651_delFilterDatabaseEntry(uint16 fid, ether_addr_t * macAddr) {
	int32 retval;
	
	UNLOCK_ERROR_CHECK((fid >=RTL8651_FDB_NUMBER), TBLDRV_EINVALIDFID);
	UNLOCK_ERROR_CHECK((macAddr == NULL), TBLDRV_EINVALIDINPUT);
	rtlglue_drvMutexLock();
	LOCK_ERROR_CHECK((DrvTbl.filterDB[fid].valid == 0), TBLDRV_EINVALIDFID);
	retval = _rtl8651_delVlanRefFilterDatabaseEntry(RTL8651_L2_TYPEII, fid, macAddr);
	rtlglue_drvMutexUnlock();
	return retval;
}



	
#define RTL8651_PORT_AGGREAGATOR_APIs

static uint32 _rtl8651_returnPortMaskPortNumber(uint32 portMask) {
	uint32 i, portNumber;

	for(i=0, portNumber = 0; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++)
		if(portMask & (1<<i))
			portNumber++;
	return portNumber;
}


int32 rtl8651_getAggregatorActiveStatus(uint16 aggregator, int8 * isActive) {

	UNLOCK_ERROR_CHECK((aggregator >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDAGGREGATORID);
	UNLOCK_ERROR_CHECK((isActive == NULL), TBLDRV_EINVALIDINPUT);
	rtlglue_drvMutexLock();
	*isActive = DrvTbl.aggregator[aggregator].ethernetPortUpStatus != 0? TRUE: FALSE;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_setAggregatorIndividual(uint16 aggregator, int8 individual) {
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	
	UNLOCK_ERROR_CHECK((aggregator >=RTL8651_PORT_NUMBER+ rtl8651_totalExtPortNum), TBLDRV_EINVALIDAGGREGATORID);
	rtlglue_drvMutexLock();
	aggrePtr = &DrvTbl.aggregator[aggregator];
	
	LOCK_ERROR_CHECK(
		( (aggrePtr->individual == 1 && individual == TRUE) ||
		  (aggrePtr->individual == 0 && individual == FALSE)
		),	SUCCESS
	);
	
	LOCK_ERROR_CHECK((aggrePtr->aggregated == 1&&individual == TRUE), TBLDRV_EALREADYTRUNKING);
	
	LOCK_ERROR_CHECK((aggrePtr->ethernetPortMask == 0), TBLDRV_EAGGREGATORHASNOPORT);
	aggrePtr->individual = (individual == TRUE) ? 1: 0;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_setPortAggregator(uint32 port, uint16 aggregator) {
	uint32 i, j, orgAggregator, fid, aggregaedNumber;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	rtl8651_tblDrv_filterDbTable_t *fdbPtr;
	rtl8651_tblDrv_spanningTreeTable_t *spanTreePtr;
	rtl8651_tblDrv_linkAggregation_t *orgAggrePtr, *aggrePtr, *tmpAggrePtr;
	int8 portLinkUp;
	
	UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
	UNLOCK_ERROR_CHECK((aggregator >= RTL8651_AGGREGATOR_NUMBER), TBLDRV_EINVALIDAGGREGATORID);
	
	UNLOCK_ERROR_CHECK((aggregator > port), TBLDRV_EAGGREGATORIDGTPORTNO);
	rtlglue_drvMutexLock();
	aggrePtr = &DrvTbl.aggregator[aggregator];
	orgAggrePtr = &DrvTbl.aggregator[0];
	for(orgAggregator=0; orgAggregator<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; orgAggregator++, orgAggrePtr++) {
		if(orgAggrePtr->ethernetPortMask & (1<<port))
			break;
	}
	assert(orgAggregator < RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum);
	
	LOCK_ERROR_CHECK((orgAggregator == aggregator), SUCCESS);
	
	LOCK_ERROR_CHECK(
		(orgAggrePtr->individual == 1 ||aggrePtr->individual == 1), 
		TBLDRV_EAGGREGATORSETINDIVIDUAL
	);
	
	tmpAggrePtr = &DrvTbl.aggregator[0];
	for(i=0, aggregaedNumber = 0; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++, tmpAggrePtr++) {
		assert(tmpAggrePtr->aggregated == 1 ? _rtl8651_returnPortMaskPortNumber(tmpAggrePtr->ethernetPortMask)>1 : _rtl8651_returnPortMaskPortNumber(tmpAggrePtr->ethernetPortMask)<= 1);
		if(tmpAggrePtr->aggregated == 1) 
			aggregaedNumber++;
	}
	LOCK_ERROR_CHECK(
		( (aggregaedNumber>=RTL8651_MAX_AGGREGATION_NUM)&& 
		  (aggrePtr->aggregated==0)&&
		  (orgAggrePtr->aggregated == 0)
		), TBLDRV_EAGGREGATOREXCEED
	);
	
	LOCK_ERROR_CHECK(
		(_rtl8651_returnPortMaskPortNumber(orgAggrePtr->ethernetPortMask)>2),
		TBLDRV_EAGGREGATOREXCEED
	);
	for(i=0,vlanPtr=&DrvTbl.vlan[0]; i<RTL8651_VLAN_NUMBER; i++, vlanPtr++) {
		LOCK_ERROR_CHECK(
			( (vlanPtr->valid==1) &&
			  ((vlanPtr->memberPortMask&(1<<port))==0)!=((vlanPtr->memberPortMask&aggrePtr->ethernetPortMask)==0)
			), TBLDRV_EDIFFBROADCASTDOMAIN
		);
		}
	
	orgAggrePtr->ethernetPortMask &= (~(1<<port));
	if(orgAggrePtr->ethernetPortUpStatus & (1<<port))
		portLinkUp = TRUE;
	else
		portLinkUp = FALSE;
	orgAggrePtr->ethernetPortUpStatus &= ~(1<<port);
	if(_rtl8651_returnPortMaskPortNumber(orgAggrePtr->ethernetPortMask)<= 1 && orgAggrePtr->aggregated == 1) {
		orgAggrePtr->aggregated = 0;
		rtl8651_setAsicLinkAggregator(0);
	}
	aggrePtr->ethernetPortMask |= (1<<port);
	if(portLinkUp==TRUE)
		aggrePtr->ethernetPortUpStatus |= (1<<port);
	if(_rtl8651_returnPortMaskPortNumber(aggrePtr->ethernetPortMask) > 1) {
		aggrePtr->aggregated = 1;
		rtl8651_setAsicLinkAggregator(aggrePtr->ethernetPortMask); 
	}
	
	
	if((orgAggrePtr->ethernetPortMask & (~(1<<port))) == 0) {
		assert(orgAggrePtr->aggregated == 0);
		for(i=0,spanTreePtr=&DrvTbl.spanningTree[0]; i<RTL8651_STI_NUMBER; i++,spanTreePtr++) 
			if(spanTreePtr->valid == 1)
				for(j=0; j< RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; j++)
					if((aggrePtr->ethernetPortMask & (1<<j) ) && j != aggregator)
						spanTreePtr->portState[j] = spanTreePtr->portState[aggregator];
		
		for(fid=0,fdbPtr=&DrvTbl.filterDB[0]; fid<RTL8651_FDB_NUMBER; fid++, fdbPtr++)
			if(fdbPtr->valid == 1) {
				rtl8651_tblDrv_filterDbTableEntry_t * tempFilterDbEntry;
				for(i=0; i<RTL8651_L2TBL_ROW; i++) {
					int32 useNxtHopFlag=0;
					
					SLIST_FOREACH(tempFilterDbEntry, &(fdbPtr->database[i]), nextFDB) {
						if(tempFilterDbEntry->memberPortMask & (1<<port)) {
							tempFilterDbEntry->memberPortMask &= (~(1<<port));
							tempFilterDbEntry->memberPortMask |= (1<<aggregator);
							
							

useNxtHopFlag=1;

							rtl8651_setAsicL2Table_Patch(rtl8651_filterDbIndex(&tempFilterDbEntry->macAddr), tempFilterDbEntry->asicPos, &tempFilterDbEntry->macAddr, tempFilterDbEntry->process == RTL8651_SRCBLOCK_MAC?TRUE : FALSE, tempFilterDbEntry->process == RTL8651_TOCPU_MAC ? TRUE: FALSE, tempFilterDbEntry->memberPortMask, arpAgingTime, TRUE, 	useNxtHopFlag  );
						}
					}
				}
			}
	}
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}

uint16  rtl8651_getPvid(uint32 port){
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	aggrePtr = &DrvTbl.aggregator[port];
	return aggrePtr->pvid;
}

int32 _rtl8651_setPvid(uint32 port, uint16 vid) {
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	int32 i;

	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	aggrePtr = &DrvTbl.aggregator[port];
	if (vlanPtr->valid == 0 || vlanPtr->vid != vid)
		return TBLDRV_EINVALIDVLANID;
	
	if (aggrePtr->ethernetPortMask == 0)
		return TBLDRV_EAGGREGATORHASNOPORT;
	aggrePtr->pvid = vid;	
	for(i = 0; i< RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++)
		if(aggrePtr->ethernetPortMask & (1<<i))
			rtl8651_setAsicPvid(i, rtl8651_vlanTableIndex(vid));
	return SUCCESS;
}




int32 rtl8651_setPvid(uint32 port, uint16 vid) 
{
	int32 retval;	
	
	if  (port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)
		return TBLDRV_EINVALIDPORT;
	if (vid == 0 || vid > 4094)
		return TBLDRV_EINVALIDVLANID;

	rtlglue_drvMutexLock();
	retval = _rtl8651_setPvid(port, vid);
	rtlglue_drvMutexUnlock();
	return retval;
}




#define RTL8651_VLAN_TABLE_APIs


#if 0
#define RTL8651_SETASICVLAN(_vlan_t)\
{\
	rtl8651_setAsicVlan(\
				(_vlan_t)->vid,\
				&((_vlan_t)->macAddr),\
				\
																						\
				(_vlan_t)->memberPortMask & phyPortLinkStatus,\
				\
				(_vlan_t)->inAclStart,\
				(_vlan_t)->inAclEnd,\
				(_vlan_t)->outAclStart,\
				(_vlan_t)->outAclEnd,\
				(_vlan_t)->internal == 1 ? TRUE: FALSE,\
				pureSoftFwd == TRUE? FALSE: ((_vlan_t)->ipAttached==1? TRUE: FALSE),\
				DrvTbl.spanningTree[DrvTbl.filterDB[(_vlan_t)->fid].sid].portState,\
				TRUE,\
				(_vlan_t)->promiscuous==1? TRUE: FALSE,\
				(_vlan_t)->untagPortMask,\
				(_vlan_t)->macAddrNumber,\
				1500\
	);\
}
#endif



static void _rtl8651_updateAsicAllVlan(void) {
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	uint32 i;

	for(i=0, vlanPtr=&DrvTbl.vlan[0]; i<RTL8651_VLAN_NUMBER; i++, vlanPtr++) {
		if(vlanPtr->valid == 1) {
			if (pureSoftFwd)
				vlanPtr->softRoute = 1;
			else vlanPtr->softRoute = 0;
			RTL8651_SETASICVLAN(vlanPtr);
		}
	}
}


int32 rtl8651_pureSoftwareFwd(int8 isSoftFwd) {
	rtlglue_drvMutexLock();
	pureSoftFwd = isSoftFwd;
	_rtl8651_updateAsicAllVlan();
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 _rtl8651_addVlan(uint16 vid)
{
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	uint32 vlanCount, vidx;

	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	UNLOCK_ERROR_CHECK((vlanPtr->valid == 1), TBLDRV_EVLANALREADYEXISTS);
	vlanPtr->valid = 1; 
	#if 1
	vlanPtr->broadcastToCpu = 1; 
	#else
	vlanPtr->broadcastToCpu = 0; 
	#endif
	vlanPtr->vid = vid; 
	vlanPtr->netif_t = NULL;
	assert(DrvTbl.filterDB[0].valid == 1); 
	vlanPtr->fid = 0; 
	vlanPtr->memberPortMask = 0; 
	vlanPtr->untagPortMask = 0; 
	vlanPtr->memberPortUpStatus = 0; 
	vlanPtr->macAddrNumber = 0;
	vlanPtr->internal = 1;

#ifdef CONFIG_RTL865XB_ENRT
	
	vlanPtr->macNonExist = 1;
	vlanPtr->ipAttached = 1;	
#else
	vlanPtr->ipAttached = 0;
#endif

	vlanPtr->promiscuous = 0;
	vlanPtr->fwdTxMirror = 0;
	vlanPtr->softRoute = 0; 
	vlanPtr->fvlan_t = NULL;
	vlanPtr->mtu = 1500;
	vlanPtr->extPortAsicAlwaysTag = FALSE;
	assert(vlanPtr->fid < RTL8651_FDB_NUMBER);
	assert(DrvTbl.filterDB[vlanPtr->fid].valid == 1); 
	assert(DrvTbl.spanningTree[DrvTbl.filterDB[vlanPtr->fid].sid].valid == 1); 

	
 	vlanPtr->inAclStart = vlanPtr->inAclEnd = RTL8651_ACLTBL_PERMIT_ALL;
	vlanPtr->outAclStart = vlanPtr->outAclEnd = RTL8651_ACLTBL_PERMIT_ALL;	
	RTL8651_SETASICVLAN(vlanPtr);
	vlanCount = 0;
	for(vidx = 0, vlanPtr=&DrvTbl.vlan[0]; vidx<RTL8651_VLAN_NUMBER; vidx++, vlanPtr++)
		if(vlanPtr->valid == 1)
			vlanCount++;
	if(vlanCount == 1)
		rtl8651_setAsicOperationLayer(2);

#ifdef CONFIG_RTL865XB 
	
	_rtl8651_arrangeAllExtDeviceVlanMbr();
#endif

	return SUCCESS;
}

#ifdef RTL865XB_DCUT_SWVLAN
int32 _rtl8651_addSwVlan(uint16 vid)
{
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;

	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
	UNLOCK_ERROR_CHECK((swVlanPtr->valid == 1), TBLDRV_EVLANALREADYEXISTS);
	swVlanPtr->valid = 1;
	swVlanPtr->vid = vid;
	assert(DrvTbl.filterDB[0].valid == 1);
	swVlanPtr->fid = 0;
	swVlanPtr->memberPortMask = 0;
	swVlanPtr->memberPortUpStatus = 0;
	swVlanPtr->untagPortMask = 0;
	assert(swVlanPtr->fid < RTL8651_FDB_NUMBER);
	assert(DrvTbl.filterDB[swVlanPtr->fid].valid == 1);
	assert(DrvTbl.spanningTree[DrvTbl.filterDB[swVlanPtr->fid].sid].valid == 1);

	return SUCCESS;	
}


int32 rtl8651_addSwVlan(uint16 vid)
{
	int32 retval;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	
	
	UNLOCK_ERROR_CHECK((vid < 1 || vid > 4094), TBLDRV_EINVALIDVLANID);
	rtlglue_drvMutexLock();
	
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	LOCK_ERROR_CHECK((vlanPtr->valid == 1 && vlanPtr->vid == vid), TBLDRV_EVLANALREADYEXISTS);
	
	retval = _rtl8651_addSwVlan(vid);
	rtlglue_drvMutexUnlock();
	return retval;
}

int32 _rtl8651_delSwVlan(uint16 vid) 
{
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;

	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
	UNLOCK_ERROR_CHECK((swVlanPtr->valid == 0), TBLDRV_EINVALIDVLANID);
	swVlanPtr->valid = 0;

	return SUCCESS;
}

int32 rtl8651_delSwVlan(uint16 vid) 
{
	int32 retval;
	
	UNLOCK_ERROR_CHECK((vid < 1 || vid > 4094), TBLDRV_EINVALIDVLANID);
	rtlglue_drvMutexLock();
	retval = _rtl8651_delSwVlan( vid );
	rtlglue_drvMutexUnlock();
	return retval;
}

#if 0	
int32 rtl8651_specifySwVlanFilterDatabase(uint16 vid, uint16 fid) {
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;

	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094), TBLDRV_EINVALIDVLANID);
	UNLOCK_ERROR_CHECK((fid >= RTL8651_FDB_NUMBER), TBLDRV_EINVALIDFID);
	rtlglue_drvMutexLock();
	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
	LOCK_ERROR_CHECK((swVlanPtr->valid == 0), TBLDRV_EINVALIDVLANID);
	LOCK_ERROR_CHECK((swVlanPtr->memberPortMask), TBLDRV_EVLANHASHPORTMEMBER);
	LOCK_ERROR_CHECK((DrvTbl.filterDB[fid].valid == 0), TBLDRV_EINVALIDFID);
	swVlanPtr->fid = fid;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_addSwVlanPortMember(uint16 vid, uint32 port) {
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	
	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094), TBLDRV_EINVALIDVLANID);
	UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
	aggrePtr = &DrvTbl.aggregator[port];
	LOCK_ERROR_CHECK((swVlanPtr->valid == 0), TBLDRV_EINVALIDVLANID);
	LOCK_ERROR_CHECK((DrvTbl.aggregator[port].ethernetPortMask == 0), TBLDRV_EAGGREGATORHASNOPORT);	
	LOCK_ERROR_CHECK((swVlanPtr->memberPortMask & aggrePtr->ethernetPortMask), SUCCESS);
	swVlanPtr->memberPortMask |= aggrePtr->ethernetPortMask;
	swVlanPtr->untagPortMask |= aggrePtr->ehternetPortMask;	
	swVlanPtr->memberPortUpStatus |= aggrePtr->ethernetPortUpStatus;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}

int32 rtl8651_setSwVlanPortUntag(uint16 vid, uint32 port, int8 untag) {
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;

	
	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094), TBLDRV_EINVALIDVLANID);
	UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
	aggrePtr = &DrvTbl.aggregator[port];
	LOCK_ERROR_CHECK(((swVlanPtr->memberPortMask & aggrePtr->ethernetPortMask) == 0), 
		TBLDRV_EINVALIDPORT
	);
	if(untag == TRUE)
		swVlanPtr->untagPortMask |= aggrePtr->ethernetPortMask;
	else swVlanPtr->untagPortMask &= ~aggrePtr->ethernetPortMask;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}
#endif	
#endif

int32 _rtl8651_delVlan(uint16 vid) 
{
	rtl8651_tblDrv_networkIntfTable_t *netIfPtr;
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	rtl8651_tblDrv_pppTable_t *pppoePtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	uint32 i, vlanCount;

	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	UNLOCK_ERROR_CHECK((vlanPtr->valid == 0 || vlanPtr->vid != vid), TBLDRV_EINVALIDVLANID);
	if(rtl8651_getAsicOperationLayer()>2){
		
		netIfPtr = &DrvTbl.netIface[0];
		for(i=0; i<rtl8651_tblDrvPara.networkIntfTableSize; i++, netIfPtr++) {
			UNLOCK_ERROR_CHECK(
				( (netIfPtr->valid == 1) && (netIfPtr->linkLayerType != 0) && 
				  (netIfPtr->vid == vid) 
				), TBLDRV_EVLANISREFERENCEDBYNETIF
			);
		}
		
		for(i=0, pppoePtr=&DrvTbl.pppoe[0]; i<RTL8651_PPPOE_NUMBER; i++,pppoePtr++) {
			UNLOCK_ERROR_CHECK((pppoePtr->valid == 1&& pppoePtr->vid == vid), TBLDRV_EVLANISREFERENCEDBYPPPOE);
		}
	}
	
	UNLOCK_ERROR_CHECK((vlanPtr->macAddrNumber), TBLDRV_EVLANHASMACALLOCATED);
	
	for(i=0,aggrePtr=&DrvTbl.aggregator[0]; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++, aggrePtr++)
		if(aggrePtr->ethernetPortMask && aggrePtr->pvid == vid)
			rtl8651_setPvid(i, 1);
	vlanPtr->valid = 0;
	rtl8651_delAsicVlan(vid);
	
	vlanCount = 0;
	for(i=0, vlanPtr=&DrvTbl.vlan[0]; i<RTL8651_VLAN_NUMBER; i++, vlanPtr++)
		if(vlanPtr->valid == 1)
			vlanCount++;
	if(vlanCount == 0)
		rtl8651_setAsicOperationLayer(1);

#ifdef CONFIG_RTL865XB 
	
	_rtl8651_arrangeAllExtDeviceVlanMbr();
#endif

	return SUCCESS;
}




int32 rtl8651_addVlan(uint16 vid) {
	int32 retval;
	
	UNLOCK_ERROR_CHECK((vid < 1 || vid > 4094), TBLDRV_EINVALIDVLANID);
	rtlglue_drvMutexLock();
#ifdef RTL865XB_DCUT_SWVLAN
	
	{
		rtl8651_tblDrv_swVlanTable_t *swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
		LOCK_ERROR_CHECK((swVlanPtr->valid == 1), TBLDRV_EVLANALREADYEXISTS);
	}
	
#endif
	retval = _rtl8651_addVlan(vid);
	rtlglue_drvMutexUnlock();
	return retval;
}


int32 rtl8651_delVlan(uint16 vid) 
{
	rtl8651_tblDrv_vlanTable_t *vlan_t;
	int32 retval;
	
	UNLOCK_ERROR_CHECK((vid < 1 || vid > 4094), TBLDRV_EINVALIDVLANID);
	
	UNLOCK_ERROR_CHECK((vid == 1), TBLDRV_ECANNOTREMOVEDEFVLAN);
	rtlglue_drvMutexLock();
	vlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	if (vlan_t->fvlan_t != NULL) {
		retval = TBLDRV_EINVALIDVLANID;
		goto out;
	}
	retval = _rtl8651_delVlan( vid );
out:
	rtlglue_drvMutexUnlock();
	return retval;
}


#ifdef RTL865X_PSEUDO_VLAN


int32 rtl8651_addSubVlan(uint16 fvid, uint16 vid, uint32 portMask)
{
	rtl8651_tblDrv_vlanTable_t *vlan_t, *fvlan_t;
	int32 retval, port, vidx;
	
	if (vid<1 || vid>4094)
		return TBLDRV_EINVALIDVLANID;
	rtlglue_drvMutexLock();
	
	for(vlan_t=DrvTbl.vlan, vidx=0; vidx<RTL8651_VLAN_NUMBER; vidx++, vlan_t++) {
		if (vlan_t->valid != 1 || vlan_t->internal == 1)
			continue;
		
		if (vlan_t->memberPortMask & portMask) {
			retval = TBLDRV_EINVALIDVLANID;
			goto out;
		}
	}
	
	fvlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(fvid)];
	
	if (fvlan_t->valid == 0) {
		retval = TBLDRV_EENTRYNOTFOUND;
		goto out;
	}
	
	if (fvlan_t->netif_t == NULL) {
		retval = TBLDRV_EINVALIDVLANID;
		goto out;
	}
	if ((retval=_rtl8651_addVlan(vid)) == SUCCESS) {
		rtl8651_tblDrv_ethernet_t *phyPortPtr;

		vlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
		vlan_t->netif_t 		= fvlan_t->netif_t;
		vlan_t->fvlan_t			= fvlan_t;
		#ifdef CONFIG_RTL865XB_ENRT		
		if ( fvlan_t->macAddrNumber != 0 )
			vlan_t->macNonExist	= 0;
		else
			vlan_t->macNonExist	= 1;
		vlan_t->ipAttached		= 1;
		#endif
		vlan_t->ipAttached		= 1;

		vlan_t->inAclStart		= fvlan_t->inAclStart;
		vlan_t->inAclEnd		= fvlan_t->inAclEnd;
		vlan_t->outAclStart		= fvlan_t->outAclStart;
		vlan_t->outAclEnd		= fvlan_t->outAclEnd;
		vlan_t->macAddr			= fvlan_t->macAddr;
		vlan_t->macAddrNumber	= fvlan_t->macAddrNumber;
		for(port=0; port<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; port++) {
			if (portMask & (1<<port)) {
                                phyPortPtr = &DrvTbl.phyPort[port];
                                if (phyPortPtr->linkUp == TRUE)
                                        vlan_t->memberPortUpStatus |= (1 << port);

				vlan_t->memberPortMask |= (1<<port);
				_rtl8651_setPvid(port, vid);
			}
		}
		vlan_t->untagPortMask	= vlan_t->memberPortMask;
		vlan_t->extPortAsicAlwaysTag = fvlan_t->extPortAsicAlwaysTag;
		RTL8651_SETASICVLAN(vlan_t);
	}

out:
	rtlglue_drvMutexUnlock();
	return retval;
}


int32 rtl8651_delSubVlan(uint16 vid)
{
	rtl8651_tblDrv_vlanTable_t *vlan_t;
	int32 retval, port;
	
	if (vid<1 || vid>4094)
		return TBLDRV_EINVALIDVLANID;
	rtlglue_drvMutexLock();
	vlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	if (vlan_t->valid == 0 || vlan_t->fvlan_t == NULL) {
		retval = TBLDRV_EENTRYNOTFOUND;
		goto out;
	}
	vlan_t->macAddrNumber = 0;
	if ((retval=_rtl8651_delVlan(vid)) == SUCCESS) {
		for(port=0; port<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; port++)
			if (vlan_t->memberPortMask & (1<<port))
				_rtl8651_setPvid(port, vlan_t->fvlan_t->vid);
	} else vlan_t->macAddrNumber = 1;
	
out:
	rtlglue_drvMutexUnlock();
	return retval;
}

#endif


uint16 _rtl8651_getOneVidx(int8 internal)
{
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	uint16 bakup_vidx = 0;
	uint32 i;

	for(i = 0, vlanPtr = &DrvTbl.vlan[0];  i < RTL8651_VLAN_NUMBER; i++, vlanPtr++) {
		if (vlanPtr->valid == 1) {
			if (vlanPtr->internal == internal)
				return rtl8651_vlanTableIndex(vlanPtr->vid);
			else
				bakup_vidx = rtl8651_vlanTableIndex(vlanPtr->vid);
		}
	}
	return bakup_vidx;
}

int8 _rtl8651_isInternal(uint16 vid) {
	uint16 vidx = rtl8651_vlanTableIndex(vid);

	if (DrvTbl.vlan[vidx].internal== 1)
		return TRUE;
	return FALSE;
}


int32 _rtl8651_setVlanExtPortAsicAlwaysTag(rtl8651_tblDrv_vlanTable_t *vlanPtr, uint32 alwaysTag)
{
	UNLOCK_ERROR_CHECK((vlanPtr == NULL), TBLDRV_EINVALIDINPUT);

	vlanPtr->extPortAsicAlwaysTag = (alwaysTag)?TRUE:FALSE;
	RTL8651_SETASICVLAN(vlanPtr);

	return SUCCESS;
}


int32 rtl8651_specifyVlanFilterDatabase(uint16 vid, uint16 fid) {
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
#ifdef RTL865XB_DCUT_SWVLAN
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;
#endif
	
	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094), TBLDRV_EINVALIDVLANID);
	UNLOCK_ERROR_CHECK((fid >= RTL8651_FDB_NUMBER), TBLDRV_EINVALIDFID);
	rtlglue_drvMutexLock();
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];

#ifdef RTL865XB_DCUT_SWVLAN
	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
	LOCK_ERROR_CHECK((DrvTbl.filterDB[fid].valid == 0), TBLDRV_EINVALIDFID);

	if (vlanPtr->valid == 1 && vlanPtr->vid == vid) {
		LOCK_ERROR_CHECK((vlanPtr->memberPortMask), TBLDRV_EVLANHASHPORTMEMBER);
		vlanPtr->fid = fid;
	}
	else if (swVlanPtr->valid == 1) {
		LOCK_ERROR_CHECK((swVlanPtr->memberPortMask), TBLDRV_EVLANHASHPORTMEMBER);
		swVlanPtr->fid = fid;
	}
	else {
		rtlglue_drvMutexUnlock();
		return TBLDRV_EINVALIDVLANID;
	}
#else
	
	LOCK_ERROR_CHECK((vlanPtr->valid == 0 || vlanPtr->vid != vid), TBLDRV_EINVALIDVLANID);
	LOCK_ERROR_CHECK((vlanPtr->memberPortMask), TBLDRV_EVLANHASHPORTMEMBER);
	LOCK_ERROR_CHECK((DrvTbl.filterDB[fid].valid == 0), TBLDRV_EINVALIDFID);
	vlanPtr->fid = fid;
#endif
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_setVlanPromiscuous(uint16 vid, int8 isPromiscuous) {
	rtl8651_tblDrv_networkIntfTable_t *netIfPtr;
	rtl8651_tblDrv_pppTable_t *pppoePtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	uint32 i;

	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094), TBLDRV_EINVALIDVLANID);
	rtlglue_drvMutexLock();
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	LOCK_ERROR_CHECK((vlanPtr->valid == 0 || vlanPtr->vid != vid), TBLDRV_EINVALIDVLANID);
	LOCK_ERROR_CHECK((vlanPtr->promiscuous == (isPromiscuous==TRUE? 1: 0)), SUCCESS);
	if(isPromiscuous == TRUE) {
		if(rtl8651_getAsicOperationLayer()>2){
			netIfPtr = &DrvTbl.netIface[0];
			for(i=0; i< rtl8651_tblDrvPara.networkIntfTableSize; i++,netIfPtr++) {
				LOCK_ERROR_CHECK(
					( (netIfPtr->valid == 1) && (netIfPtr->vid == vid) && 
					  (netIfPtr->linkLayerType == RTL8651_LL_VLAN)
					), TBLDRV_EVLANISREFERENCEDBYNETIF
				);
				}
			for(i=0, pppoePtr=&DrvTbl.pppoe[0]; i<RTL8651_PPPOE_NUMBER; i++, pppoePtr++) {
				LOCK_ERROR_CHECK((pppoePtr->valid == 1 && pppoePtr->vid == vid), 
					TBLDRV_EVLANISREFERENCEDBYPPPOE
				);
				}
		}
		LOCK_ERROR_CHECK((vlanPtr->fwdTxMirror == 1), TBLDRV_EFWDTXMIRRORSET);
	}
	vlanPtr->promiscuous = isPromiscuous==TRUE? 1: 0;
	RTL8651_SETASICVLAN(vlanPtr);
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_getVlanActiveStatus(uint16 vid, int8 * isActive) {
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
#ifdef RTL865XB_DCUT_SWVLAN
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;
#endif
	
	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094) , TBLDRV_EINVALIDVLANID);
	UNLOCK_ERROR_CHECK((isActive==NULL), TBLDRV_EINVALIDINPUT);
	rtlglue_drvMutexLock();
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
#ifdef RTL865XB_DCUT_SWVLAN
	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
	if (vlanPtr->valid == 1 && vlanPtr->vid == vid)
		*isActive = vlanPtr->memberPortUpStatus != 0 ? TRUE: FALSE;
	else if (swVlanPtr->valid == 1)
		*isActive = swVlanPtr->memberPortUpStatus != 0 ? TRUE: FALSE;
	else {
		rtlglue_drvMutexUnlock();
		return TBLDRV_EINVALIDVLANID;
	}
#else
	LOCK_ERROR_CHECK((vlanPtr->valid == 0 || vlanPtr->vid != vid), TBLDRV_EINVALIDVLANID);
	*isActive = vlanPtr->memberPortUpStatus!= 0? TRUE: FALSE;
#endif
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_addVlanPortMember(uint16 vid, uint32 port) {
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
#ifdef RTL865XB_DCUT_SWVLAN
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;
#endif

	
	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094), TBLDRV_EINVALIDVLANID);
	UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	aggrePtr = &DrvTbl.aggregator[port];

#ifdef RTL865XB_DCUT_SWVLAN
	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
	LOCK_ERROR_CHECK((DrvTbl.aggregator[port].ethernetPortMask == 0), TBLDRV_EAGGREGATORHASNOPORT);
	
	if (vlanPtr->valid == 1 && vlanPtr->vid == vid) {
		
		LOCK_ERROR_CHECK((vlanPtr->memberPortMask & aggrePtr->ethernetPortMask), SUCCESS);
		
		vlanPtr->memberPortMask |= aggrePtr->ethernetPortMask;
		vlanPtr->untagPortMask |= aggrePtr->ethernetPortMask;
		vlanPtr->memberPortUpStatus |= aggrePtr->ethernetPortUpStatus;
		if(vlanPtr->fwdTxMirror == 1)
			rtl8651_tblDrvCpuMirrorPortMask |= aggrePtr->ethernetPortMask;
		
		RTL8651_SETASICVLAN(vlanPtr);
	}
	else if (swVlanPtr->valid == 1) {
		LOCK_ERROR_CHECK((swVlanPtr->memberPortMask & aggrePtr->ethernetPortMask), SUCCESS);
		swVlanPtr->memberPortMask |= aggrePtr->ethernetPortMask;
		swVlanPtr->untagPortMask |= aggrePtr->ethernetPortMask;	
		swVlanPtr->memberPortUpStatus |= aggrePtr->ethernetPortUpStatus;
	}
	else {
		rtlglue_drvMutexUnlock();
		return TBLDRV_EINVALIDVLANID;
	}
#else
	LOCK_ERROR_CHECK((vlanPtr->valid == 0 || vlanPtr->vid != vid), TBLDRV_EINVALIDVLANID);
	
	LOCK_ERROR_CHECK((DrvTbl.aggregator[port].ethernetPortMask == 0), TBLDRV_EAGGREGATORHASNOPORT);
	
	LOCK_ERROR_CHECK((vlanPtr->memberPortMask & aggrePtr->ethernetPortMask), SUCCESS);
	
	vlanPtr->memberPortMask |= aggrePtr->ethernetPortMask;
	vlanPtr->untagPortMask |= aggrePtr->ethernetPortMask;
	vlanPtr->memberPortUpStatus |= aggrePtr->ethernetPortUpStatus;
	if(vlanPtr->fwdTxMirror == 1)
		rtl8651_tblDrvCpuMirrorPortMask |= aggrePtr->ethernetPortMask;
	
	RTL8651_SETASICVLAN(vlanPtr);
#endif

#ifdef CONFIG_RTL865X_MULTILAYER_BSP
	
	_rtl8651_arrangeMulticastPortStatus();
#endif

#ifdef CONFIG_RTL865XB 
	
	_rtl8651_arrangeAllExtDeviceVlanMbr();
#endif

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_setVlanPortUntag(uint16 vid, uint32 port, int8 untag) {
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
#ifdef RTL865XB_DCUT_SWVLAN
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;
#endif

	
	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094), TBLDRV_EINVALIDVLANID);
	UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	aggrePtr = &DrvTbl.aggregator[port];
	
#ifdef RTL865XB_DCUT_SWVLAN
	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];

	if (vlanPtr->valid == 1 && vlanPtr->vid == vid) {
		LOCK_ERROR_CHECK(((vlanPtr->memberPortMask & aggrePtr->ethernetPortMask) == 0), 
			TBLDRV_EINVALIDPORT
		);
		if(untag == TRUE)
			vlanPtr->untagPortMask |= aggrePtr->ethernetPortMask;
		else vlanPtr->untagPortMask &= ~aggrePtr->ethernetPortMask;
		RTL8651_SETASICVLAN(vlanPtr);
	}
	else if (swVlanPtr->valid == 1) {
		LOCK_ERROR_CHECK(((swVlanPtr->memberPortMask & aggrePtr->ethernetPortMask) == 0), 
			TBLDRV_EINVALIDPORT
		);		
		if(untag == TRUE)
			swVlanPtr->untagPortMask |= aggrePtr->ethernetPortMask;
		else swVlanPtr->untagPortMask &= ~aggrePtr->ethernetPortMask;
	}
	else {
		rtlglue_drvMutexUnlock();
		return TBLDRV_EINVALIDVLANID;
	}
#else
	LOCK_ERROR_CHECK(((vlanPtr->memberPortMask & aggrePtr->ethernetPortMask) == 0), 
		TBLDRV_EINVALIDPORT
	);
	if(untag == TRUE)
		vlanPtr->untagPortMask |= aggrePtr->ethernetPortMask;
	else vlanPtr->untagPortMask &= ~aggrePtr->ethernetPortMask;
	RTL8651_SETASICVLAN(vlanPtr);
#endif

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}



int32 _rtl8651_assignVlanMacAddress(uint16 vid, ether_addr_t * macAddress, uint16 macAddrNumber) 
{
	rtl8651_tblDrv_vlanTable_t *vlan_t;
	int32 retval = SUCCESS;

	if (vid < 1 || vid > 4094)
		return TBLDRV_EINVALIDVLANID;
	if (macAddrNumber > 1 && (macAddress->octet[5]&(macAddrNumber-1)))
		return TBLDRV_EINVALIDINPUT;

	vlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	if (vlan_t->valid == 0 || vlan_t->vid != vid) {
		retval = TBLDRV_EINVALIDVLANID;
		goto out;
	}
	
	vlan_t->macAddr 			= *macAddress;
	vlan_t->macAddrNumber 	= macAddrNumber;
	vlan_t->manualAssign 		= 1;
	RTL8651_SETASICVLAN(vlan_t);
out:
	return retval;
}


int32 rtl8651_assignVlanMacAddress(uint16 vid, ether_addr_t * macAddress, uint16 macAddrNumber) {
#if 1

	int32 retval = SUCCESS;

	if (vid < 1 || vid > 4094)
		return TBLDRV_EINVALIDVLANID;
	if (macAddrNumber > 1 && (macAddress->octet[5]&(macAddrNumber-1)))
		return TBLDRV_EINVALIDINPUT;

	rtlglue_drvMutexLock();
	retval = _rtl8651_assignVlanMacAddress( vid, macAddress, macAddrNumber );
	rtlglue_drvMutexUnlock();
	return retval;
	
#else
	rtl8651_tblDrv_networkIntfTable_t *netIfPtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
	rtl8651_tblDrv_pppoeTable_t *pppoePtr;
	uint32 i;
	
	UNLOCK_ERROR_CHECK((vid < 1 || vid > 4094), TBLDRV_EINVALIDVLANID);
	if (macAddrNumber>1) 
	UNLOCK_ERROR_CHECK((macAddress->octet[5] & (macAddrNumber-1)), TBLDRV_EINVALIDINPUT);
	rtlglue_drvMutexLock();
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	LOCK_ERROR_CHECK((vlanPtr->valid == 0 || vlanPtr->vid != vid), TBLDRV_EINVALIDVLANID);
	if(rtl8651_getAsicOperationLayer()>2){
		for(i=0, pppoePtr=&DrvTbl.pppoe[0]; i<RTL8651_PPPOE_NUMBER; i++, pppoePtr++) {
			LOCK_ERROR_CHECK(
				(pppoePtr->valid == 1 && pppoePtr->vid == vid), 
				TBLDRV_EVLANMACREFERENCEDBYPPPOE
			);
		}
		netIfPtr = &DrvTbl.netIface[0];
		for(i=0;i< rtl8651_tblDrvPara.networkIntfTableSize; i++,netIfPtr++) {
			LOCK_ERROR_CHECK(
				( (netIfPtr->valid == 1) && (netIfPtr->vid == vid) &&
				  (netIfPtr->linkLayerType == RTL8651_LL_VLAN)
				), TBLDRV_EVLANMACREFERENCEDBYNETIF
			);
		}
	}
	
	vlanPtr->macAddr = *macAddress;
	vlanPtr->macAddrNumber = macAddrNumber;
	vlanPtr->manualAssign = 1;
	RTL8651_SETASICVLAN(vlanPtr);
	rtlglue_drvMutexUnlock();
	return SUCCESS;
#endif
}

		

int32 rtl8651_getVlanMacAddress(uint16 vid, ether_addr_t * macAddr, uint16 * macAddrNumber) {
	rtl8651_tblDrv_vlanTable_t *vlanPtr; 
	
	UNLOCK_ERROR_CHECK((vid < 1 || vid > 4094), TBLDRV_EINVALIDVLANID);
	rtlglue_drvMutexLock();
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	LOCK_ERROR_CHECK((vlanPtr->valid == 0 || vlanPtr->vid != vid ), TBLDRV_EINVALIDVLANID);
	
	if(vlanPtr->macAddrNumber > 0) {
		*macAddr = vlanPtr->macAddr;
		if(macAddrNumber)
			*macAddrNumber = vlanPtr->macAddrNumber;
		rtlglue_drvMutexUnlock();
		return SUCCESS;
	}
	rtlglue_drvMutexUnlock();
	return(TBLDRV_EVLANNOMAC);
}


int32 rtl8651_delVlanPortMember(uint16 vid, uint32 port) {
	rtl8651_tblDrv_linkAggregation_t *aggrePtr;
	rtl8651_tblDrv_vlanTable_t *vlanPtr;
#ifdef RTL865XB_DCUT_SWVLAN
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;
#endif

	
	UNLOCK_ERROR_CHECK((vid == 0 || vid > 4094), TBLDRV_EINVALIDVLANID);
	UNLOCK_ERROR_CHECK((port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum), TBLDRV_EINVALIDPORT);
	rtlglue_drvMutexLock();
	vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
	aggrePtr = &DrvTbl.aggregator[port];

#ifdef RTL865XB_DCUT_SWVLAN
	swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
	
	LOCK_ERROR_CHECK((aggrePtr->ethernetPortMask == 0), TBLDRV_EAGGREGATORHASNOPORT);

	if (vlanPtr->valid == 1 && vlanPtr->vid == vid) {
		
		LOCK_ERROR_CHECK(
			((vlanPtr->memberPortMask & aggrePtr->ethernetPortMask) == 0), 
			TBLDRV_ENOTVLANPORTMEMBER
		);
		
		vlanPtr->memberPortMask &=  ~aggrePtr->ethernetPortMask;
		vlanPtr->untagPortMask &=  ~aggrePtr->ethernetPortMask;
		vlanPtr->memberPortUpStatus &= ~aggrePtr->ethernetPortUpStatus;
		if(vlanPtr->fwdTxMirror == 1)
			rtl8651_tblDrvCpuMirrorPortMask &= ~aggrePtr->ethernetPortMask;
		RTL8651_SETASICVLAN(vlanPtr);
	}
	else if (swVlanPtr->valid == 1) {
		
		LOCK_ERROR_CHECK(
			((swVlanPtr->memberPortMask & aggrePtr->ethernetPortMask) == 0), 
			TBLDRV_ENOTVLANPORTMEMBER
		);
		
		swVlanPtr->memberPortMask &=  ~aggrePtr->ethernetPortMask;
		swVlanPtr->untagPortMask &=  ~aggrePtr->ethernetPortMask;
		swVlanPtr->memberPortUpStatus &= ~aggrePtr->ethernetPortUpStatus;
	}
	else {
		rtlglue_drvMutexUnlock();
		return TBLDRV_EINVALIDVLANID;
	}
	
#else
	LOCK_ERROR_CHECK((vlanPtr->valid == 0 || vlanPtr->vid != vid), TBLDRV_EINVALIDVLANID);
	
	LOCK_ERROR_CHECK((aggrePtr->ethernetPortMask == 0), TBLDRV_EAGGREGATORHASNOPORT);
	
	LOCK_ERROR_CHECK(
		((vlanPtr->memberPortMask & aggrePtr->ethernetPortMask) == 0), 
		TBLDRV_ENOTVLANPORTMEMBER
	);
	
	vlanPtr->memberPortMask &=  ~aggrePtr->ethernetPortMask;
	vlanPtr->untagPortMask &=  ~aggrePtr->ethernetPortMask;
	vlanPtr->memberPortUpStatus &= ~aggrePtr->ethernetPortUpStatus;
	if(vlanPtr->fwdTxMirror == 1)
		rtl8651_tblDrvCpuMirrorPortMask &= ~aggrePtr->ethernetPortMask;
	RTL8651_SETASICVLAN(vlanPtr);
#endif

#ifdef CONFIG_RTL865X_MULTILAYER_BSP
	
	_rtl8651_arrangeMulticastPortStatus();
#endif	

#ifdef CONFIG_RTL865XB 
	
	_rtl8651_arrangeAllExtDeviceVlanMbr();
#endif

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}



#define RTL8651_MISC_APIs


uint32 peripheralExtPortMask = 0;
int32 _rtl8651_addPeripheralExtPort(uint32 port)
{
	RTL_NOTICE(	RTL_MSG_EXTDEV,
					"Add Peripheral Extension port: %d",
					port);

	if (port >= RTL8651_AGGREGATOR_NUMBER)
	{
		RTL_ERR(	RTL_MSG_EXTDEV,
					"Illegal peripheral extension port : %d (Too large, Max: %d)",
					port,
					RTL8651_AGGREGATOR_NUMBER);

		return FAILED;
	}
	peripheralExtPortMask |= 1<<port;

	RTL_NOTICE(	RTL_MSG_EXTDEV,
					"Reserve port %d for peripheral device. Current peripheral Port Mask: 0x%x",
					port,
					peripheralExtPortMask);

	return SUCCESS;
}

int32 _rtl8651_delPeripheralExtPort(uint32 port)
{
	RTL_NOTICE(	RTL_MSG_EXTDEV,
					"Remove Peripheral Extension port: %d",
					port);

	if (port >= RTL8651_AGGREGATOR_NUMBER)
	{
		RTL_ERR(	RTL_MSG_EXTDEV,
					"Illegal peripheral extension port : %d (Too large, Max: %d)",
					port,
					RTL8651_AGGREGATOR_NUMBER);

		return FAILED;
	}

	peripheralExtPortMask &= ~ ( 1 << port);

	RTL_NOTICE(	RTL_MSG_EXTDEV,
					"Remove port %d for peripheral device. Current peripheral Port Mask: 0x%x",
					port,
					peripheralExtPortMask);

	return SUCCESS;
}




int32 rtl8651_setLoopbackPortPHY(uint32 phy, int32 flag){
	
	
	if(phy>RTL8651_PHY_NUMBER)
		return FAILED;
	if(phy==RTL8651_MII_PORTNUMBER){
		
		if(rtl8651_setAsicEthernetMII(8, P5_LINK_MII_PHY,flag))
			return FAILED;
	}else{
		
		if(rtl8651_setAsicEthernetPHYLoopback(phy, flag))
			return FAILED;
	}
	
	rtl8651_setEthernetPortLinkStatus(phy, flag);
	return SUCCESS;
}

#define RTL8651_PROTOCOL_TRAP_APIs

#define ILLEGAL_PROTOTRAP_TYPE(type)\
	((type)!=RTL8651_PROTOTRAP_ETHER && (type)!=RTL8651_PROTOTRAP_IP &&\
	 (type)!=RTL8651_PROTOTRAP_TCPPORT && (type)!=RTL8651_PROTOTRAP_UDPPORT)



int32 _rtl8651_queryProtoTrap(uint8 protoType, uint16 protoContent) {
#if 0
	rtl8651_tblDrvprotoTrapAsicArrangementEnty_t *ptPtr;
	int8 isEnable;
	int32 index,asicPosition ;
	
	if (ILLEGAL_PROTOTRAP_TYPE(protoType))
		return FAILED;
	asicPosition=rtl8651_getHardwiredProtoTrap(protoType, protoContent, &isEnable);
	if ( asicPosition>=0 && isEnable==TRUE)
		return asicPosition;
	for(index=0,ptPtr=&AsicTableUsage.protoTrap[0]; index<RTL8651_PROTOCOLTRAP_SIZE; index++,ptPtr++)
		if ((ptPtr->valid==1)&&(protoType==(uint8)ptPtr->trapType)&&(protoContent==ptPtr->trapContent))
			return RTL8651_HARDWIRED_PROTOTRAP_SIZE+index;
#endif
	return FAILED;	
}


int32 rtl8651_addProtoTrap(uint8 protoType, uint16 protoContent) {
#if 0
	rtl8651_tblDrvprotoTrapAsicArrangementEnty_t *ptPtr, *addPtr;
	uint32 protoIndex = RTL8651_PROTOCOLTRAP_SIZE, i = 0;

	UNLOCK_ERROR_CHECK(ILLEGAL_PROTOTRAP_TYPE(protoType), TBLDRV_EUNKNOWPROTOTYPE);
#ifdef CONFIG_RTL865X_WLAN_ACCELERATION	
	return FAILED;
#endif
	rtlglue_drvMutexLock();
	if (rtl8651_turnOnHardwiredProtoTrap(protoType, protoContent) == SUCCESS) {
		rtlglue_drvMutexUnlock();
		return SUCCESS;
	}	
	for(ptPtr=&AsicTableUsage.protoTrap[0]; i<RTL8651_PROTOCOLTRAP_SIZE; i++, ptPtr++) {
		
		LOCK_ERROR_CHECK(
			( (ptPtr->valid==1) && (protoType==(uint8)ptPtr->trapType) && 
			  (protoContent==ptPtr->trapContent)
			), TBLDRV_EENTRYALREADYEXIST
		);
		if (ptPtr->valid == 0 && protoIndex == RTL8651_PROTOCOLTRAP_SIZE) {
			protoIndex = i;
			addPtr = ptPtr;
		}
	}
	LOCK_ERROR_CHECK((protoIndex == RTL8651_PROTOCOLTRAP_SIZE), TBLDRV_ENOFREEBUFFER);
	addPtr->valid = 1;
	addPtr->trapType = protoType;
	addPtr->trapContent = protoContent;
	convert_setAsicProtoTrap(protoIndex, protoType, protoContent);
	rtlglue_drvMutexUnlock();
#endif
	rtlglue_printf("%s is legacy now and deprecated\n", __FUNCTION__);
	return SUCCESS;
}



int32 rtl8651_delProtoTrap(uint8 protoType, uint16 protoContent) {
#if 0
	rtl8651_tblDrvprotoTrapAsicArrangementEnty_t *ptPtr;
	uint32 protoIndex;
	
 	UNLOCK_ERROR_CHECK((ILLEGAL_PROTOTRAP_TYPE(protoType)), TBLDRV_EUNKNOWPROTOTYPE);
	rtlglue_drvMutexLock();
	LOCK_ERROR_CHECK((rtl8651_turnOffHardwiredProtoTrap(protoType, protoContent)==SUCCESS), SUCCESS);
 	ptPtr=&AsicTableUsage.protoTrap[0];
	for(protoIndex=0 ;protoIndex<RTL8651_PROTOCOLTRAP_SIZE; protoIndex++, ptPtr++) 
		if ((ptPtr->valid==1)&&(protoType==(uint8)ptPtr->trapType)&&(protoContent==ptPtr->trapContent))
			break;
	LOCK_ERROR_CHECK((protoIndex == RTL8651_PROTOCOLTRAP_SIZE), TBLDRV_EENTRYNOTFOUND);
	ptPtr->valid = 0;
	rtl8651_delAsicProtoTrap(protoIndex);
	rtlglue_drvMutexUnlock();
#endif
	rtlglue_printf("%s is legacy now and deprecated\n", __FUNCTION__);
	return SUCCESS;
}



#define RTL8651_BROADCAST_STORM_API

int32 rtl8651_enableBroadCastStormPrevention(int8 enable) {
	UNLOCK_ERROR_CHECK((enable!=TRUE && enable!=FALSE), TBLDRV_EINVALIDINPUT);
	rtlglue_drvMutexLock();
	rtl8651_setBroadCastStormReg(enable);
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}

int32 rtl8651_layer2_alloc(void){
	int32 index;
	memset(&AsicTableUsage, 0, sizeof(struct AsicTableUsage_S)) ;
	
	TBL_MEM_ALLOC(AsicTableUsage.mac, rtl8651_tblDrv_macAddressEntry_t, rtl8651_tblDrvPara.macAddressDbSize);

	memset( &DrvTbl, 0, sizeof( DrvTbl ) );
	TBL_MEM_ALLOC(DrvTbl.phyPort, rtl8651_tblDrv_ethernet_t, RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum);
	TBL_MEM_ALLOC(DrvTbl.aggregator, rtl8651_tblDrv_linkAggregation_t, RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum);
	TBL_MEM_ALLOC(DrvTbl.vlan, rtl8651_tblDrv_vlanTable_t, RTL8651_VLAN_NUMBER);
#ifdef RTL865XB_DCUT_SWVLAN
	TBL_MEM_ALLOC(DrvTbl.swVlan, rtl8651_tblDrv_swVlanTable_t, RTL8651_SWVLAN_NUMBER);
#endif
	TBL_MEM_ALLOC(DrvTbl.filterDB, rtl8651_tblDrv_filterDbTable_t, RTL8651_FDB_NUMBER);
  	TBL_MEM_ALLOC(DrvTbl.spanningTree, rtl8651_tblDrv_spanningTreeTable_t, RTL8651_FDB_NUMBER);

	

	
	{
		rtl8651_tblDrv_filterDbTableEntry_t * tempFilterDb;
		TBL_MEM_ALLOC(tempFilterDb, rtl8651_tblDrv_filterDbTableEntry_t, rtl8651_tblDrvPara.filterDbSize);
		SLIST_INIT(&DrvTbl.freeList.filterDBentry);
		for(index=0; index<rtl8651_tblDrvPara.filterDbSize; index++)
			SLIST_INSERT_HEAD(&DrvTbl.freeList.filterDBentry, &tempFilterDb[index], nextFDB);
	}

	return SUCCESS;
}


int32 rtl8651_layer2_init(void){
	int32 index, index1,i;

	

	memset(&rtl8651AsicEthernetTable[0], 0, (RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)*sizeof(rtl8651_tblAsic_ethernet_t));
		
	
	linkChangePendingCount = 0;
	rtl8651_l2protoPassThrough=0;
	miiPhyAddress=-1;
	rtl8651_tblDrvCpuMirrorPortMask=0;
	arpAgingTime = 30;
	
#ifndef RTL865X_TEST	
	phyPortLinkStatus = 0;
#else
	phyPortLinkStatus = 0xffffffff; 
#endif

	
	rtl8651_tblDrvSpanningTreeEnable = 0;
	rtl8651_tblDrvSpanningTreePortFwdStatus = 0xffffffff;

	pureSoftFwd = TRUE; 
	
	rtl8651_L2statusNotifier= NULL;
	rtl8651_linkStatusNotifier = NULL;	 
#ifdef CONFIG_RTL865X_MULTILAYER_BSP
	rtl8651_externalMulticastPortMask = 0;	
#endif
	

	 
	memset((int8 *)DrvTbl.vlan, 0, sizeof(rtl8651_tblDrv_vlanTable_t)*RTL8651_VLAN_NUMBER);

#ifdef RTL865XB_DCUT_SWVLAN
	
	memset((int8 *)DrvTbl.swVlan, 0, sizeof(rtl8651_tblDrv_swVlanTable_t) * RTL8651_SWVLAN_NUMBER);
#endif

	memset(&AsicTableUsage.mac[0],0,rtl8651_tblDrvPara.macAddressDbSize*sizeof(rtl8651_tblDrv_macAddressEntry_t));
	{ 
		rtl8651_tblDrv_macAddressEntry_t *asicMac;
		ether_addr_t macAddress;
		uint32 number;
		rtlglue_getMacAddress(&macAddress, &number);
		
		for(i=0,asicMac=&AsicTableUsage.mac[0]; i< number && i < rtl8651_tblDrvPara.macAddressDbSize; i++,asicMac++) {
			asicMac->mac = macAddress;
			asicMac->mac.octet[4] += (uint8) (i>>8);
			asicMac->mac.octet[5] += (uint8) (i&0xff);
			asicMac->allocated = 0;
			asicMac->valid = 1;
		}
	}



	{ 
		rtl8651_tblDrv_spanningTreeTable_t *spt_t=&DrvTbl.spanningTree[0];
		for(index=0; index<RTL8651_FDB_NUMBER; index++, spt_t++)
			spt_t->valid = 0;
	}	

	{ 
		rtl8651_tblDrv_ethernet_t *phyPtr=&DrvTbl.phyPort[0];
		rtl8651_tblDrv_linkAggregation_t *aggrePtr=&DrvTbl.aggregator[0];
		
		for(i=0,phyPtr=&DrvTbl.phyPort[0],aggrePtr=&DrvTbl.aggregator[0]; i<(RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum); i++,phyPtr++,aggrePtr++) {
			
			phyPtr->speed = 1;	
			phyPtr->duplex = 1; 
			phyPtr->autoNegotiation = 1; 
			phyPtr->fake_forceMode = 0; 
			phyPtr->autoAdvCapability = 0; 
			phyPtr->aggregatorIndex = i;
			phyPtr->linkUp = 0;			
			phyPtr->inputBandwidthControl = RTL8651_BC_FULL;
			phyPtr->outputBandwidthControl = RTL8651_BC_FULL;
			
			aggrePtr->pvid = 1; 
			aggrePtr->individual = 0; 
			aggrePtr->aggregated = 0; 
			aggrePtr->ethernetPortMask = 1<<i;
			aggrePtr->ethernetPortUpStatus = 0;
		}
	}
	
	{ 
		rtl8651_tblDrv_filterDbTable_t *fdb_t=&DrvTbl.filterDB[0];
		for(index=0; index<RTL8651_FDB_NUMBER; index++) {
			for(index1=0; index1<RTL8651_L2TBL_ROW; index1++)
				SLIST_INIT(&(fdb_t->database[index1]));
			fdb_t->valid = 0;
		}
	}

	
	for(i=0; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++) {
		rtl8651_setAsicMulticastPortInternal(i, TRUE);
		rtl8651_setAsicMulticastSpanningTreePortState(i, RTL8651_PORTSTA_FORWARDING);
		rtl8651_setAsicEthernetBandwidthControl(i, TRUE, RTL8651_BC_FULL);
		rtl8651_setAsicEthernetBandwidthControl(i, FALSE, RTL8651_BC_FULL);
	}

	
	{
                int8 autoNego, fullDuplex;
                uint32 speed, advCap, port;
		 rtl8651_tblDrv_ethernet_t *phyPortPtr;
	
		for(port=0; port<RTL8651_PORT_NUMBER; port++) {
		 	phyPortPtr = &DrvTbl.phyPort[port];
                	rtl8651_getAsicEthernetPHY(port, &autoNego, &advCap, &speed, &fullDuplex);
                	phyPortPtr->speed = (speed==1)? 1: 0;
                	phyPortPtr->duplex = (fullDuplex==TRUE)? 1: 0;
                	phyPortPtr->autoNegotiation = (autoNego==1)? 1: 0;
                	phyPortPtr->autoAdvCapability = advCap;
		}

        }

	
	memset(fake_DisableFlowControl, 0, sizeof(uint32) * RTL8651_PHY_NUMBER);
	memset(prePortState, 0, sizeof(uint32) * RTL8651_PHY_NUMBER);

	return SUCCESS;	
}

int32 rtl8651_layer2_collect(void) {
	uint32 entry, index, index1;

	{ 
		rtl8651_tblDrv_filterDbTableEntry_t * tempFilterDbPtr;
		rtl8651_tblDrv_filterDbTable_t *filterDbPtr;
		
		for(index=0,filterDbPtr=&DrvTbl.filterDB[0]; index<RTL8651_FDB_NUMBER; index++,filterDbPtr++) {
			for(index1=0; index1<RTL8651_L2TBL_ROW; index1++)
				while(SLIST_FIRST(&(filterDbPtr->database[index1]))) {
					tempFilterDbPtr = SLIST_FIRST(&(filterDbPtr->database[index1]));
					SLIST_REMOVE_HEAD(&(filterDbPtr->database[index1]), nextFDB);
					SLIST_INSERT_HEAD(&DrvTbl.freeList.filterDBentry, tempFilterDbPtr, nextFDB);
				}
		}
		entry = 0;
		SLIST_FOREACH(tempFilterDbPtr, &DrvTbl.freeList.filterDBentry, nextFDB) 
			entry++;
		assert(entry == rtl8651_tblDrvPara.filterDbSize);
	}

	
	return SUCCESS;
}



int32 rtl8651_initDrvParam(rtl8651_tblDrvInitPara_t * configPara) {
	if(configPara == NULL) {
		rtl8651_tblDrvPara.macAddressDbSize = 8;
		rtl8651_tblDrvPara.filterDbSize = 1024;
		rtl8651_tblDrvPara.networkIntfTableSize = 8;
		rtl8651_tblDrvPara.ipIntfEntryNumber = 16;
		rtl8651_tblDrvPara.ipIntfIpAddrNumber = 24;
		rtl8651_tblDrvPara.arpTableSize = 512;
		rtl8651_tblDrvPara.routingTableSize = 64;
		rtl8651_tblDrvPara.natSize = 8;
		rtl8651_tblDrvPara.naptServerPortEntryNumber = 64;
		rtl8651_tblDrvPara.naptTcpUdpFlowSize = 4096;
		
		rtl8651_tblDrvPara.naptIcmpFlowSize = 128;
		rtl8651_tblDrvPara.aclSize = 256;
		rtl8651_tblDrvPara.algSize = 128;
		rtl8651_tblDrvPara.urlfilterDBSize = 16;			
		rtl8651_tblDrvPara.urlfilterStringLen = 32;		
		rtl8651_tblDrvPara.pathfilterStringLen = 32;		
		rtl8651_tblDrvPara.urlPktfilterDBSize = 64;		
		rtl8651_tblDrvPara.dialSessionNumber = 4;		
		rtl8651_tblDrvPara.dmzHostsNum = 2;			
		rtl8651_tblDrvPara.policyRules = 8;
		rtl8651_tblDrvPara.dynamicPolicy = 32;
		rtl8651_tblDrvPara.pptpSize = 2;
		rtl8651_tblDrvPara.l2tpSize = 2;
		rtl8651_tblDrvPara.pppoePassthruSize = 8;
		rtl8651_tblDrvPara.protocolBasedNatSize = 8;
		rtl8651_tblDrvPara.mCastTblSize = 64;
		rtl8651_tblDrvPara.macAccessControllSize = 8;
		rtl8651_tblDrvPara.ipUnnumberSize = 1;
#ifdef CONFIG_RTL865X_IPSEC
		rtl8651_tblDrvPara.ipSecTunnelNumber = 3;		
#endif
#ifdef RTL8651_ALG_QOS
		rtl8651_tblDrvPara.algQosTblSize = 32;
#endif

#ifdef RTL865XB_URLFILTER_TRUSTED_USER
		rtl8651_tblDrvPara.urlfilterTrustedUserEntryCnt = 8;
#endif

		rtl8651_tblDrvPara.advRouteEntryCnt = 16;
		rtl8651_tblDrvPara.advDynamicRouteEntryCnt = 64;

	}
	else {
		rtl8651_tblDrvPara = *configPara;
		if(rtl8651_tblDrvPara.macAddressDbSize == 0)
			rtl8651_tblDrvPara.macAddressDbSize = 8;
		if(rtl8651_tblDrvPara.filterDbSize == 0)
			rtl8651_tblDrvPara.filterDbSize = 1024;
		if(rtl8651_tblDrvPara.networkIntfTableSize == 0)
			rtl8651_tblDrvPara.networkIntfTableSize = 8;
		if(rtl8651_tblDrvPara.ipIntfEntryNumber == 0)
			rtl8651_tblDrvPara.ipIntfEntryNumber = 16;
		if(rtl8651_tblDrvPara.ipIntfIpAddrNumber == 0)
			rtl8651_tblDrvPara.ipIntfIpAddrNumber = 24;
		if(rtl8651_tblDrvPara.arpTableSize == 0)
			rtl8651_tblDrvPara.arpTableSize = 512;
		if(rtl8651_tblDrvPara.routingTableSize == 0)
			rtl8651_tblDrvPara.routingTableSize = 64;
		if(rtl8651_tblDrvPara.natSize == 0)
			rtl8651_tblDrvPara.natSize = 8;
		if(rtl8651_tblDrvPara.naptServerPortEntryNumber == 0)
			rtl8651_tblDrvPara.naptServerPortEntryNumber = 8;
		if(rtl8651_tblDrvPara.naptTcpUdpFlowSize == 0)
			rtl8651_tblDrvPara.naptTcpUdpFlowSize = 4096;
		if(rtl8651_tblDrvPara.naptIcmpFlowSize == 0)
			rtl8651_tblDrvPara.naptIcmpFlowSize = 128;
		if(rtl8651_tblDrvPara.aclSize == 0)
			rtl8651_tblDrvPara.aclSize = 256;
		if(rtl8651_tblDrvPara.algSize == 0)
			rtl8651_tblDrvPara.algSize = 128;
		if(rtl8651_tblDrvPara.dialSessionNumber == 0)
			rtl8651_tblDrvPara.dialSessionNumber = 4;
		if(rtl8651_tblDrvPara.dmzHostsNum== 0)
			rtl8651_tblDrvPara.dmzHostsNum= 2;
		if (rtl8651_tblDrvPara.urlfilterDBSize == 0)
			rtl8651_tblDrvPara.urlfilterDBSize = 16;
		if (rtl8651_tblDrvPara.urlfilterStringLen == 0)
			rtl8651_tblDrvPara.urlfilterStringLen = 32;
		if (rtl8651_tblDrvPara.pathfilterStringLen == 0)
			rtl8651_tblDrvPara.pathfilterStringLen = 32;
		if (rtl8651_tblDrvPara.urlPktfilterDBSize == 0)
			rtl8651_tblDrvPara.urlPktfilterDBSize = 64;
		if (rtl8651_tblDrvPara.policyRules == 0)
			rtl8651_tblDrvPara.policyRules = 8;
		if (rtl8651_tblDrvPara.dynamicPolicy == 0)
			rtl8651_tblDrvPara.dynamicPolicy = 32;
		if (rtl8651_tblDrvPara.pptpSize == 0)
			rtl8651_tblDrvPara.pptpSize = 2;
		if (rtl8651_tblDrvPara.l2tpSize == 0)
			rtl8651_tblDrvPara.l2tpSize = 2;
		if (rtl8651_tblDrvPara.pppoePassthruSize == 0)
			rtl8651_tblDrvPara.pppoePassthruSize = 8;
		if (rtl8651_tblDrvPara.protocolBasedNatSize == 0)
			rtl8651_tblDrvPara.protocolBasedNatSize = 8;
		if (rtl8651_tblDrvPara.mCastTblSize == 0)
			rtl8651_tblDrvPara.mCastTblSize = 64;
		if (rtl8651_tblDrvPara.macAccessControllSize == 0)
			rtl8651_tblDrvPara.macAccessControllSize = 8;
		if (rtl8651_tblDrvPara.ipUnnumberSize == 0)
			rtl8651_tblDrvPara.ipUnnumberSize = 1;
#ifdef CONFIG_RTL865X_IPSEC
		if (rtl8651_tblDrvPara.ipSecTunnelNumber == 0)
			rtl8651_tblDrvPara.ipSecTunnelNumber = 3;
#endif
#ifdef RTL8651_ALG_QOS
		if (rtl8651_tblDrvPara.algQosTblSize == 0)
			rtl8651_tblDrvPara.algQosTblSize = 32;
#endif

#ifdef RTL865XB_URLFILTER_TRUSTED_USER
	if (rtl8651_tblDrvPara.urlfilterTrustedUserEntryCnt == 0)
		rtl8651_tblDrvPara.urlfilterTrustedUserEntryCnt = 8;
#endif

	if (rtl8651_tblDrvPara.advRouteEntryCnt == 0)
		rtl8651_tblDrvPara.advRouteEntryCnt = 16;
	if (rtl8651_tblDrvPara.advDynamicRouteEntryCnt == 0)
		rtl8651_tblDrvPara.advDynamicRouteEntryCnt = 64;
	}
	
	
	if(rtl8651_tblDrvPara.macAddressDbSize==0)
		return FAILED;
	if(rtl8651_tblDrvPara.filterDbSize < RTL8651_L2TBL_ROW * RTL8651_L2TBL_COLUMN)
		return FAILED;

	if(rtl8651_tblDrvPara.naptIcmpFlowSize < RTL8651_ICMPTBL_SIZE)
		return FAILED;
	assert(RTL8651_FDB_NUMBER >= 1);	
	_sysUpSeconds = 0;				
	return SUCCESS;
}



int32 _rtl8651_portStatusPatch(uint32 port) 
{
	rtl8651_tblDrv_vlanTable_t *vlan_t;
	uint32 vidx;

	for(vidx=0,vlan_t=DrvTbl.vlan; vidx<RTL8651_VLAN_NUMBER; vidx++, vlan_t++) {
		if (vlan_t->valid == 0)
			continue;
		if (vlan_t->memberPortMask & (1 << port)) {	
			if ((vlan_t->memberPortUpStatus & (1 << port)) == 0)	
				return RTL8651_LINKPATCH_DRIVERDOWN;
			else												
				return RTL8651_LINKPATCH_DRIVERUP;
		}
	}
	return RTL8651_LINKPATCH_NOTINVLAN;
}

