#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl8651_tblAsicDrv.h"
#include "rtl8651_tblDrvLocal.h"
#include "asicRegs.h"
#include "rtl8651_tblAsicDrv.h"
#ifdef __TO_BE_DELETED__
#include "rtl_bdinfo.h"
#include "board.h"
#endif
#ifdef RTL865X_TEST
#include <stdio.h>
#include "drvTest.h"
#endif
#ifdef RTL865X_MODEL_USER
#include "rtl_glue.h"
#include <stdio.h>
#include <string.h>
#endif
#include "mbuf.h" 






int8 rtl8651_tblAsicDrv_Id[] = "$Id: rtl8651_tblAsicDrv.c,v 1.62 2006-01-18 03:42:01 darcy_lu Exp $";




#define RTL8651_ASICDRV_FUNCTION_PROTOTYPE
uint32	 _rtl8651_NaptAgingToSec(uint32 value);
uint32 	_rtl8651_NaptAgingToUnit(uint32 sec);
void 		_rtl8651_asicTableAccessForward(uint32, uint32, void *);








int8 RtkHomeGatewayChipName[16];
int32 RtkHomeGatewayChipRevisionID;
#define RTL865X_ASICDRV_GLOBAL_VARIABLE

#if defined(RTL865X_TEST) || defined(RTL865X_MODEL_USER) || defined(RTL865X_MODEL_KERNEL)
void rtl8651_setChipVersion(int8 *name, int32 *rev){
	uint32 revision;
	if(!rev)
		revision=0;
	else
		revision=(*rev)&0xf;

	if(strcmp(name,"8650B")==0){	
		WRITE_MEM32(CRMR,0x00005788|revision<<16);
		WRITE_MEM32(CHIPID,0x86510000);
	}else if(strcmp(name,"8651B")==0){	
		WRITE_MEM32(CRMR,0x02005788|revision<<16);
		WRITE_MEM32(CHIPID,0x86510000);
	}else if(strcmp(name,"8650")==0){
		WRITE_MEM32(CRMR,0);
		WRITE_MEM32(CHIPID,0x86500000);
	}else if(strcmp(name,"8651")==0){
		WRITE_MEM32(CRMR,0);
		WRITE_MEM32(CHIPID,0x86510000);
	}else
		rtlglue_printf("Illegal Chip ID: %s\n", name);
	

	rtl8651_getChipVersion(RtkHomeGatewayChipName, sizeof(RtkHomeGatewayChipName), &RtkHomeGatewayChipRevisionID);
}
#endif
int32 rtl8651_getChipVersion(int8 *name,uint32 size, int32 *rev){

	uint32 id = READ_MEM32(CRMR);
	if(!id){
		id = READ_MEM32(CHIPID);
		if((uint16)(id>>16)==0x8650)
			strncpy(name,"8650",size);
		else
			strncpy(name,"8651",size);
		if(rev)
			*rev=0;
	}else if((uint16)id==0x5788){
		int revId;
		revId = (id>>16)&0xf;
#if 1
		
		if (revId >= 2 )
		{
			strncpy(name, "865xB", size);
		}else
#endif
		
		{
			if(id&0x02000000)
				strncpy(name,"8651B",size);
			else
				strncpy(name,"8650B",size);
		}

		if(rev)
			*rev=revId;
	}else
		snprintf(name, size, "%08x", id);
	
	return SUCCESS;
}




uint32 rtl8651_naptTcpUdpTableIndex(int8 isTCP, ipaddr_t srcAddr, uint16 srcPort, ipaddr_t destAddr, uint16 destPort) {
	uint32 eidx;

	if(destAddr==0 && destPort==0){
		 
		eidx = ( isTCP<< 9 | ((srcPort>>7)&0x1fe) | isTCP ) ^ ( (srcPort & 0xff)<<2 | srcAddr >>30) ^
			((srcAddr >>20)&0x3ff)^((srcAddr >>10)&0x3ff) ^ (srcAddr & 0x3ff);
		assert(eidx < RTL8651_TCPUDPTBL_SIZE);
		return eidx;
	} 
	eidx = srcAddr ^ (srcAddr >> 10) ^ (srcAddr >> 20) ^ (srcAddr >> 30) ^ (srcPort << 2) ^ (srcPort >> 8) ^ 
		destAddr ^ (destAddr >> 10) ^ (destAddr >> 20) ^ (destAddr >> 30) ^ (destPort << 2) ^ (destPort >> 8);
	if(destPort & 0x8000 )
		eidx ^= 0x300;

	if(isTCP)
		eidx = (eidx ^ 0x300) & (RTL8651_TCPUDPTBL_SIZE-1);
	else
		eidx &= (RTL8651_TCPUDPTBL_SIZE-1);;
	if((READ_MEM32(MISCCR)&L4_HASH)==0)
		eidx=((eidx>>1)<<1)| (srcPort&1);
	assert(eidx < RTL8651_TCPUDPTBL_SIZE);
	return eidx;
}

uint32 rtl8651_naptIcmpTableIndex(ipaddr_t srcAddr, uint16 icmpId, ipaddr_t destAddr, uint32 * tblIdx) 
{
	uint32 eidx;

	eidx = srcAddr ^ (srcAddr >> 10) ^ (srcAddr >> 20) ^ (srcAddr >> 30) ^ (icmpId << 2) ^ (icmpId >> 8) ^
	        destAddr ^ (destAddr >> 10) ^ (destAddr >> 20) ^ (destAddr >> 30);
	
	eidx &= (RTL8651_TCPUDPTBL_SIZE-1);
	if((READ_MEM32(MISCCR)&L4_HASH)==0)
	        eidx=((eidx>>1)<<1)| (icmpId&1);
	*tblIdx = eidx &(RTL8651_ICMPTBL_SIZE-1);
	return eidx;
}

uint32 rtl8651_ipMulticastTableIndex(ipaddr_t srcAddr, ipaddr_t dstAddr) {
	uint32 idx;

	idx = srcAddr ^ (srcAddr>>8) ^ (srcAddr>>16) ^ (srcAddr>>24) ^ dstAddr ^ (dstAddr>>8) ^ (dstAddr>>16) ^ (dstAddr>>24);
	idx = ((idx >> 2) ^ (idx & 0x3)) & (RTL8651_IPMULTICASTTBL_SIZE-1);

	return idx;
}

uint32 _rtl8651_NaptAgingToSec(uint32 value) {
	
	uint32 unit = 0, G = value>>3, S = 1;

	value &= 0x07;
	while (G > 0) {
		unit += (S << 3);
		S = S << 2;
		G--;
	}
	unit += (S * (value + 1));
	unit = (unit-1)*5/3 - (S>1? S: 0);
	return unit;
}

 uint32 _rtl8651_NaptAgingToUnit(uint32 sec) {
	
	uint32 value = 0, S = 1;

	sec++;
	sec = sec * 3 / 5;
	while(sec >= (S<<3)) {
		sec -= (S << 3);
		S = S << 2;
		value++;
	}
	return (sec%S > (S>>1))? ((value << 3) + (sec / S) + 1) : ((value << 3) + (sec / S) - 1 + 1);
}



uint32 _Is4WayHashEnabled(void)
{
	uint32 regValue = READ_MEM32( SWTECR );
	return ( regValue & EN_TCPUDP_4WAY_HASH );
}


int32 _set4WayHash( int32 enable )
{
	uint32 regValue = READ_MEM32( SWTECR );
	if ( enable )
	{
		regValue |= EN_TCPUDP_4WAY_HASH;
	}
	else
	{
		regValue &= ~EN_TCPUDP_4WAY_HASH;
	}

	
	WRITE_MEM32( SWTECR, regValue );
	
	return SUCCESS;
}



#define RTL865X_ASIC_DRIVER_ACL_TBL_API

int32 rtl8651_setAsicAclRule(uint32 index, _rtl8651_tblDrvAclRule_t *rule) {
	rtl8651_tblAsic_aclTable_t    entry;

	if(index >= RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE || rule == NULL)
		return FAILED;

	rule->aclIdx = index;
	memset(&entry, 0, sizeof(entry));
	switch(rule->ruleType_) {

	case RTL8651_ACL_MAC: 
		 entry.is.ETHERNET.dMacP47_32 = rule->dstMac_.octet[0]<<8 | rule->dstMac_.octet[1];
		 entry.is.ETHERNET.dMacP31_16 = rule->dstMac_.octet[2]<<8 | rule->dstMac_.octet[3];
		 entry.is.ETHERNET.dMacP15_0 = rule->dstMac_.octet[4]<<8 | rule->dstMac_.octet[5];
	 	 entry.is.ETHERNET.dMacM47_32 = rule->dstMacMask_.octet[0]<<8 | rule->dstMacMask_.octet[1];
		 entry.is.ETHERNET.dMacM31_16 = rule->dstMacMask_.octet[2]<<8 | rule->dstMacMask_.octet[3];
		 entry.is.ETHERNET.dMacM15_0 = rule->dstMacMask_.octet[4]<<8 | rule->dstMacMask_.octet[5];
		 entry.is.ETHERNET.sMacP47_32 = rule->srcMac_.octet[0]<<8 | rule->srcMac_.octet[1];
		 entry.is.ETHERNET.sMacP31_16 = rule->srcMac_.octet[2]<<8 | rule->srcMac_.octet[3];
		 entry.is.ETHERNET.sMacP15_0 = rule->srcMac_.octet[4]<<8 | rule->srcMac_.octet[5];
		 entry.is.ETHERNET.sMacM47_32 = rule->srcMacMask_.octet[0]<<8 | rule->srcMacMask_.octet[1];
		 entry.is.ETHERNET.sMacM31_16 = rule->srcMacMask_.octet[2]<<8 | rule->srcMacMask_.octet[3];
		 entry.is.ETHERNET.sMacM15_0 = rule->srcMacMask_.octet[4]<<8 | rule->srcMacMask_.octet[5];
		 entry.is.ETHERNET.ethTypeP = rule->typeLen_;
		 entry.is.ETHERNET.ethTypeM = rule->typeLenMask_;
		 entry.ruleType = 0x0;
		 break;
		 
	case RTL8651_ACL_IFSEL: 
		 entry.is.IFSEL.gidxSel = rule->gidxSel_;
		 entry.ruleType = 0x3;
		 break;
		 
	case RTL8651_ACL_IP: 
		 entry.is.L3L4.is.IP.IPTOSP = rule->tos_;
		 entry.is.L3L4.is.IP.IPTOSM = rule->tosMask_;
		 entry.is.L3L4.is.IP.IPProtoP = rule->ipProto_;
		 entry.is.L3L4.is.IP.IPProtoM = rule->ipProtoMask_;
		 entry.is.L3L4.is.IP.IPFlagP = rule->ipFlag_;
		 entry.is.L3L4.is.IP.IPFlagM = rule->ipFlagMask_;
 		 entry.is.L3L4.is.IP.FOP = rule->ipFOP_;
		 entry.is.L3L4.is.IP.FOM = rule->ipFOM_;
		 entry.is.L3L4.is.IP.HTTPP = entry.is.L3L4.is.IP.HTTPM = rule->ipHttpFilter_;
		 entry.is.L3L4.is.IP.identSDIPP = entry.is.L3L4.is.IP.identSDIPM = rule->ipIdentSrcDstIp_;
		 entry.ruleType = 0x2;
		 goto l3l4_shared;
		 
	case RTL8651_ACL_ICMP:
		 entry.is.L3L4.is.ICMP.IPTOSP = rule->tos_;
		 entry.is.L3L4.is.ICMP.IPTOSM = rule->tosMask_;
		 entry.is.L3L4.is.ICMP.ICMPTypeP = rule->icmpType_;
		 entry.is.L3L4.is.ICMP.ICMPTypeM = rule->icmpTypeMask_;
		 entry.is.L3L4.is.ICMP.ICMPCodeP = rule->icmpCode_;
		 entry.is.L3L4.is.ICMP.ICMPCodeM = rule->icmpCodeMask_;
		 entry.ruleType = 0x4;
		 goto l3l4_shared;

	case RTL8651_ACL_IGMP:
		 entry.is.L3L4.is.IGMP.IPTOSP = rule->tos_;
		 entry.is.L3L4.is.IGMP.IPTOSM = rule->tosMask_;
		 entry.is.L3L4.is.IGMP.IGMPTypeP = rule->igmpType_;
		 entry.is.L3L4.is.IGMP.IGMPTypeM = rule->igmpTypeMask_; 
		 entry.ruleType = 0x5;
 		 goto l3l4_shared;

	case RTL8651_ACL_TCP:
		 entry.is.L3L4.is.TCP.IPTOSP = rule->tos_;
		 entry.is.L3L4.is.TCP.IPTOSM = rule->tosMask_;
		 entry.is.L3L4.is.TCP.TCPFlagP = rule->tcpFlag_;
		 entry.is.L3L4.is.TCP.TCPFlagM = rule->tcpFlagMask_;
		 entry.is.L3L4.is.TCP.TCPSPUB = rule->tcpSrcPortUB_;
		 entry.is.L3L4.is.TCP.TCPSPLB = rule->tcpSrcPortLB_;
		 entry.is.L3L4.is.TCP.TCPDPUB = rule->tcpDstPortUB_;
		 entry.is.L3L4.is.TCP.TCPDPLB = rule->tcpDstPortLB_;
		 entry.ruleType = 0x6;
         goto l3l4_shared;

	case RTL8651_ACL_UDP:
		 entry.is.L3L4.is.UDP.IPTOSP = rule->tos_;
		 entry.is.L3L4.is.UDP.IPTOSM = rule->tosMask_;
		 entry.is.L3L4.is.UDP.UDPSPUB = rule->udpSrcPortUB_;
		 entry.is.L3L4.is.UDP.UDPSPLB = rule->udpSrcPortLB_;
		 entry.is.L3L4.is.UDP.UDPDPUB = rule->udpDstPortUB_;
		 entry.is.L3L4.is.UDP.UDPDPLB = rule->udpDstPortLB_;
		 entry.ruleType = 0x7;

l3l4_shared:
		 entry.is.L3L4.sIPP = rule->srcIpAddr_;
		 entry.is.L3L4.sIPM = rule->srcIpAddrMask_;
		 entry.is.L3L4.dIPP = rule->dstIpAddr_;
		 entry.is.L3L4.dIPM = rule->dstIpAddrMask_;
		 break;

 	case RTL8651_ACL_SRCFILTER:
		 entry.is.SRC_FILTER.sMacP47_32 = rule->srcFilterMac_.octet[0]<<8 | rule->srcFilterMac_.octet[1];
		 entry.is.SRC_FILTER.sMacP31_16 = rule->srcFilterMac_.octet[2]<<8 | rule->srcFilterMac_.octet[3];
		 entry.is.SRC_FILTER.sMacP15_0 = rule->srcFilterMac_.octet[4]<<8 | rule->srcFilterMac_.octet[5];
		 entry.is.SRC_FILTER.sMacM47_32 = rule->srcFilterMacMask_.octet[0]<<8 | rule->srcFilterMacMask_.octet[1];
		 entry.is.SRC_FILTER.sMacM31_16 = rule->srcFilterMacMask_.octet[2]<<8 | rule->srcFilterMacMask_.octet[3];
		 entry.is.SRC_FILTER.sMacM15_0 = rule->srcFilterMacMask_.octet[4]<<8 | rule->srcFilterMacMask_.octet[5];
		 entry.is.SRC_FILTER.spaP = rule->srcFilterPort_;
		 entry.is.SRC_FILTER.spaM = rule->srcFilterPortMask_;
		 entry.is.SRC_FILTER.sVidxP = rule->srcFilterVlanIdx_;
		 entry.is.SRC_FILTER.sVidxM = rule->srcFilterVlanIdxMask_;
		 if(rule->srcFilterIgnoreL3L4_) entry.is.SRC_FILTER.protoType = 1;
		 else if(rule->srcFilterIgnoreL4_) entry.is.SRC_FILTER.protoType = 2;
		 else entry.is.SRC_FILTER.protoType = 0;
		 entry.is.SRC_FILTER.sIPP = rule->srcFilterIpAddr_;
		 entry.is.SRC_FILTER.sIPM = rule->srcFilterIpAddrMask_;
		 entry.is.SRC_FILTER.SPORTUB = rule->srcFilterPortUpperBound_;
		 entry.is.SRC_FILTER.SPORTLB = rule->srcFilterPortLowerBound_;
		 entry.ruleType = 0x08;
		 break;
		 
	case RTL8651_ACL_DSTFILTER:
		 entry.is.DST_FILTER.dMacP47_32 = rule->dstFilterMac_.octet[0]<<8 | rule->dstFilterMac_.octet[1];
		 entry.is.DST_FILTER.dMacP31_16 = rule->dstFilterMac_.octet[2]<<8 | rule->dstFilterMac_.octet[3];
		 entry.is.DST_FILTER.dMacP15_0 = rule->dstFilterMac_.octet[4]<<8 | rule->dstFilterMac_.octet[5];
		 entry.is.DST_FILTER.dMacM47_32 = rule->dstFilterMacMask_.octet[0]<<8 | rule->dstFilterMacMask_.octet[1];
		 entry.is.DST_FILTER.dMacM31_16 = rule->dstFilterMacMask_.octet[2]<<8 | rule->dstFilterMacMask_.octet[3];
		 entry.is.DST_FILTER.dMacM15_0 = rule->dstFilterMacMask_.octet[4]<<8 | rule->dstFilterMacMask_.octet[5];
		 entry.is.DST_FILTER.vidxP = rule->dstFilterVlanIdx_;
		 entry.is.DST_FILTER.vidxM = rule->dstFilterVlanIdxMask_;
		 if(rule->dstFilterIgnoreL3L4_) entry.is.DST_FILTER.protoType = 2;
		 else if(rule->dstFilterIgnoreL4_) entry.is.DST_FILTER.protoType = 1;
		 else entry.is.DST_FILTER.protoType = 0;
		 entry.is.DST_FILTER.dIPP = rule->dstFilterIpAddr_;
		 entry.is.DST_FILTER.dIPM = rule->dstFilterIpAddrMask_;
		 entry.is.DST_FILTER.DPORTUB = rule->dstFilterPortUpperBound_;
		 entry.is.DST_FILTER.DPORTLB = rule->dstFilterPortLowerBound_;
		 entry.ruleType = 0x09;
		 break;
 
	default: return FAILED; 
	
	}
	
	switch(rule->actionType_) {
	case RTL8651_ACL_PERMIT:			entry.actionType = 0x00;
		 goto _common_action;
	case RTL8651_ACL_DROP:			entry.actionType = 0x02;
		 goto _common_action;
	case RTL8651_ACL_CPU:		 	 	entry.actionType = 0x03;
		 goto _common_action;
	case RTL8651_ACL_DROP_LOG:
	case RTL8651_ACL_DROP_NOTIFY:
#ifndef CONFIG_RTL8650B
		entry.actionType = 0x03;
#else
		entry.actionType = 0x05;
#endif
		goto _common_action;
	case RTL8651_ACL_REDIRECT:	 	entry.actionType = 0x01;
		 entry.vid = rule->dvid_;
		 entry.PPPoEIndex = rule->pppoeIdx_;
		 entry.nextHop = rule->nextHop_;
		 goto _common_action;
	case RTL8651_ACL_REDIRECT_PPPOE: 	entry.actionType = 0x07;
		 entry.vid = rule->dvid_;
		 entry.PPPoEIndex = rule->pppoeIdx_;
		 entry.nextHop = rule->nextHop_;
		 goto _common_action;
	case RTL8651_ACL_MIRROR:			entry.actionType = 0x06;
		goto _common_action;
	case RTL8651_ACL_MIRROR_KEEP_MATCH: entry.actionType = 0x09;
		goto _common_action;
	case RTL8651_ACL_DROP_RATE_EXCEED_PPS: entry.actionType = 0x0a;
		entry.nextHop = rule->rlIndex;
		goto _common_action;
	case RTL8651_ACL_LOG_RATE_EXCEED_PPS: entry.actionType = 0x0b;
		entry.nextHop = rule->rlIndex;
		goto _common_action;
	case RTL8651_ACL_DROP_RATE_EXCEED_BPS: entry.actionType = 0x0c;
		entry.nextHop = rule->rlIndex;
		goto _common_action;
	case RTL8651_ACL_LOG_RATE_EXCEED_BPS: entry.actionType = 0x0d;
		entry.nextHop = rule->rlIndex;
		goto _common_action;
	case RTL8651_ACL_POLICY: entry.actionType = 0x08;
		entry.nextHop = rule->nhIndex;
		goto _common_action;

_common_action:
		entry.hPriority = rule->priority_;
 		entry.pktOpApp = rule->pktOpApp;
 		 break;
	}
	return _rtl8651_forceAddAsicEntry(TYPE_ACL_RULE_TABLE, index, &entry);
}


int32 rtl8651_getAsicAclRule(uint32 index, _rtl8651_tblDrvAclRule_t *rule) {
	rtl8651_tblAsic_aclTable_t    entry;

	if(index >= RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE || rule == NULL)
		return FAILED;
	_rtl8651_readAsicEntry(TYPE_ACL_RULE_TABLE, index, &entry);
	bzero(rule, sizeof(_rtl8651_tblDrvAclRule_t));

	switch(entry.ruleType) {

	case 0x00: 
		 rule->dstMac_.octet[0]     = entry.is.ETHERNET.dMacP47_32 >> 8;
		 rule->dstMac_.octet[1]     = entry.is.ETHERNET.dMacP47_32 & 0xff;
		 rule->dstMac_.octet[2]     = entry.is.ETHERNET.dMacP31_16 >> 8;
	 	 rule->dstMac_.octet[3]     = entry.is.ETHERNET.dMacP31_16 & 0xff;
		 rule->dstMac_.octet[4]     = entry.is.ETHERNET.dMacP15_0 >> 8;
		 rule->dstMac_.octet[5]     = entry.is.ETHERNET.dMacP15_0 & 0xff;
		 rule->dstMacMask_.octet[0] = entry.is.ETHERNET.dMacM47_32 >> 8;
		 rule->dstMacMask_.octet[1] = entry.is.ETHERNET.dMacM47_32 & 0xff;
		 rule->dstMacMask_.octet[2] = entry.is.ETHERNET.dMacM31_16 >> 8;
		 rule->dstMacMask_.octet[3] = entry.is.ETHERNET.dMacM31_16 & 0xff;
	 	 rule->dstMacMask_.octet[4] = entry.is.ETHERNET.dMacM15_0 >> 8;
		 rule->dstMacMask_.octet[5] = entry.is.ETHERNET.dMacM15_0 & 0xff;
	 	 rule->srcMac_.octet[0]     = entry.is.ETHERNET.sMacP47_32 >> 8;
		 rule->srcMac_.octet[1]     = entry.is.ETHERNET.sMacP47_32 & 0xff;
		 rule->srcMac_.octet[2]     = entry.is.ETHERNET.sMacP31_16 >> 8;
		 rule->srcMac_.octet[3]     = entry.is.ETHERNET.sMacP31_16 & 0xff;
		 rule->srcMac_.octet[4]     = entry.is.ETHERNET.sMacP15_0 >> 8;
		 rule->srcMac_.octet[5]     = entry.is.ETHERNET.sMacP15_0 & 0xff;
		 rule->srcMacMask_.octet[0] = entry.is.ETHERNET.sMacM47_32 >> 8;
		 rule->srcMacMask_.octet[1] = entry.is.ETHERNET.sMacM47_32 & 0xff;
		 rule->srcMacMask_.octet[2] = entry.is.ETHERNET.sMacM31_16 >> 8;
		 rule->srcMacMask_.octet[3] = entry.is.ETHERNET.sMacM31_16 & 0xff;
		 rule->srcMacMask_.octet[4] = entry.is.ETHERNET.sMacM15_0 >> 8;
		 rule->srcMacMask_.octet[5] = entry.is.ETHERNET.sMacM15_0 & 0xff;
		 rule->typeLen_             = entry.is.ETHERNET.ethTypeP;
		 rule->typeLenMask_         = entry.is.ETHERNET.ethTypeM;
		 rule->ruleType_            = RTL8651_ACL_MAC;
		 break;

	case 0x02: 
		 rule->tos_         = entry.is.L3L4.is.IP.IPTOSP;
		 rule->tosMask_     = entry.is.L3L4.is.IP.IPTOSM;
		 rule->ipProto_     = entry.is.L3L4.is.IP.IPProtoP;
		 rule->ipProtoMask_ = entry.is.L3L4.is.IP.IPProtoM;
		 rule->ipFlag_      = entry.is.L3L4.is.IP.IPFlagP;
		 rule->ipFlagMask_  = entry.is.L3L4.is.IP.IPFlagM;
 		 rule->ipFOP_ = entry.is.L3L4.is.IP.FOP;
		 rule->ipFOM_ = entry.is.L3L4.is.IP.FOM;
		 rule->ipHttpFilterM_ = entry.is.L3L4.is.IP.HTTPM;
		 rule->ipHttpFilter_  = entry.is.L3L4.is.IP.HTTPP;
		 rule->ipIdentSrcDstIp_ = entry.is.L3L4.is.IP.identSDIPM;
 		 rule->ruleType_    = RTL8651_ACL_IP;
		 goto l3l4_shared;

	case 0x03: 
		 rule->gidxSel_ = entry.is.IFSEL.gidxSel;
		 rule->ruleType_ = RTL8651_ACL_IFSEL;
	     break;
	     
	case 0x04: 
		 rule->tos_ = entry.is.L3L4.is.ICMP.IPTOSP;
		 rule->tosMask_ = entry.is.L3L4.is.ICMP.IPTOSM;
		 rule->icmpType_ = entry.is.L3L4.is.ICMP.ICMPTypeP;
		 rule->icmpTypeMask_ = entry.is.L3L4.is.ICMP.ICMPTypeM;
		 rule->icmpCode_ = entry.is.L3L4.is.ICMP.ICMPCodeP;
		 rule->icmpCodeMask_ = entry.is.L3L4.is.ICMP.ICMPCodeM;
		 rule->ruleType_ = RTL8651_ACL_ICMP;
		 goto l3l4_shared;

	case 0x05: 
		 rule->tos_ = entry.is.L3L4.is.IGMP.IPTOSP;
		 rule->tosMask_ = entry.is.L3L4.is.IGMP.IPTOSM;
		 rule->igmpType_ = entry.is.L3L4.is.IGMP.IGMPTypeP;
		 rule->igmpTypeMask_ = entry.is.L3L4.is.IGMP.IGMPTypeM;
		 rule->ruleType_ = RTL8651_ACL_IGMP;
		 goto l3l4_shared;

	case 0x06: 
		 rule->tos_ = entry.is.L3L4.is.TCP.IPTOSP;
		 rule->tosMask_ = entry.is.L3L4.is.TCP.IPTOSM;
		 rule->tcpFlag_ = entry.is.L3L4.is.TCP.TCPFlagP;
		 rule->tcpFlagMask_ = entry.is.L3L4.is.TCP.TCPFlagM;
		 rule->tcpSrcPortUB_ = entry.is.L3L4.is.TCP.TCPSPUB;
		 rule->tcpSrcPortLB_ = entry.is.L3L4.is.TCP.TCPSPLB;
		 rule->tcpDstPortUB_ = entry.is.L3L4.is.TCP.TCPDPUB;
		 rule->tcpDstPortLB_ = entry.is.L3L4.is.TCP.TCPDPLB;
		 rule->ruleType_ = RTL8651_ACL_TCP;
         goto l3l4_shared;

	case 0x07: 
		 rule->tos_ = entry.is.L3L4.is.UDP.IPTOSP;
		 rule->tosMask_ = entry.is.L3L4.is.UDP.IPTOSM;
		 rule->udpSrcPortUB_ = entry.is.L3L4.is.UDP.UDPSPUB;
		 rule->udpSrcPortLB_ = entry.is.L3L4.is.UDP.UDPSPLB;
		 rule->udpDstPortUB_ = entry.is.L3L4.is.UDP.UDPDPUB;
		 rule->udpDstPortLB_ = entry.is.L3L4.is.UDP.UDPDPLB;
		 rule->ruleType_ = RTL8651_ACL_UDP;
		 
l3l4_shared:
		rule->srcIpAddr_ = entry.is.L3L4.sIPP;
		rule->srcIpAddrMask_ = entry.is.L3L4.sIPM;
		rule->dstIpAddr_ = entry.is.L3L4.dIPP;
		rule->dstIpAddrMask_ = entry.is.L3L4.dIPM;
		break;

 	case 0x08: 
	 	 rule->srcFilterMac_.octet[0]     = entry.is.SRC_FILTER.sMacP47_32 >> 8;
		 rule->srcFilterMac_.octet[1]     = entry.is.SRC_FILTER.sMacP47_32 & 0xff;
		 rule->srcFilterMac_.octet[2]     = entry.is.SRC_FILTER.sMacP31_16 >> 8;
		 rule->srcFilterMac_.octet[3]     = entry.is.SRC_FILTER.sMacP31_16 & 0xff;
		 rule->srcFilterMac_.octet[4]     = entry.is.SRC_FILTER.sMacP15_0 >> 8;
		 rule->srcFilterMac_.octet[5]     = entry.is.SRC_FILTER.sMacP15_0 & 0xff;
		 rule->srcFilterMacMask_.octet[0] = entry.is.SRC_FILTER.sMacM47_32 >> 8;
		 rule->srcFilterMacMask_.octet[1] = entry.is.SRC_FILTER.sMacM47_32 & 0xff;
		 rule->srcFilterMacMask_.octet[2] = entry.is.SRC_FILTER.sMacM31_16 >> 8;
		 rule->srcFilterMacMask_.octet[3] = entry.is.SRC_FILTER.sMacM31_16 & 0xff;
		 rule->srcFilterMacMask_.octet[4] = entry.is.SRC_FILTER.sMacM15_0 >> 8;
		 rule->srcFilterMacMask_.octet[5] = entry.is.SRC_FILTER.sMacM15_0 & 0xff;
		 rule->srcFilterPort_ = entry.is.SRC_FILTER.spaP;
		 rule->srcFilterPortMask_ = entry.is.SRC_FILTER.spaM;
		 rule->srcFilterVlanIdx_ = entry.is.SRC_FILTER.sVidxP;
		 rule->srcFilterVlanIdxMask_ = entry.is.SRC_FILTER.sVidxM;
		 if(entry.is.SRC_FILTER.protoType == 2) rule->srcFilterIgnoreL4_ = 1;
		 else if(entry.is.SRC_FILTER.protoType == 1) rule->srcFilterIgnoreL3L4_ = 1;
		 rule->srcFilterIpAddr_ = entry.is.SRC_FILTER.sIPP;
		 rule->srcFilterIpAddrMask_ = entry.is.SRC_FILTER.sIPM;
		 rule->srcFilterPortUpperBound_ = entry.is.SRC_FILTER.SPORTUB;
		 rule->srcFilterPortLowerBound_ = entry.is.SRC_FILTER.SPORTLB;
		 rule->ruleType_ = RTL8651_ACL_SRCFILTER;
		 break;
		 
	case 0x09: 
	 	 rule->dstFilterMac_.octet[0]     = entry.is.DST_FILTER.dMacP47_32 >> 8;
		 rule->dstFilterMac_.octet[1]     = entry.is.DST_FILTER.dMacP47_32 & 0xff;
		 rule->dstFilterMac_.octet[2]     = entry.is.DST_FILTER.dMacP31_16 >> 8;
		 rule->dstFilterMac_.octet[3]     = entry.is.DST_FILTER.dMacP31_16 & 0xff;
		 rule->dstFilterMac_.octet[4]     = entry.is.DST_FILTER.dMacP15_0 >> 8;
		 rule->dstFilterMac_.octet[5]     = entry.is.DST_FILTER.dMacP15_0 & 0xff;
		 rule->dstFilterMacMask_.octet[0] = entry.is.DST_FILTER.dMacM47_32 >> 8;
		 rule->dstFilterMacMask_.octet[1] = entry.is.DST_FILTER.dMacM47_32 & 0xff;
		 rule->dstFilterMacMask_.octet[2] = entry.is.DST_FILTER.dMacM31_16 >> 8;
		 rule->dstFilterMacMask_.octet[3] = entry.is.DST_FILTER.dMacM31_16 & 0xff;
		 rule->dstFilterMacMask_.octet[4] = entry.is.DST_FILTER.dMacM15_0 >> 8;
		 rule->dstFilterMacMask_.octet[5] = entry.is.DST_FILTER.dMacM15_0 & 0xff;
		 rule->dstFilterVlanIdx_ = entry.is.DST_FILTER.vidxP;
		 rule->dstFilterVlanIdxMask_ = entry.is.DST_FILTER.vidxM;
		 if(entry.is.DST_FILTER.protoType == 2) rule->dstFilterIgnoreL3L4_ = 1;
		 else if(entry.is.DST_FILTER.protoType == 1) rule->dstFilterIgnoreL4_ = 1;
		 rule->dstFilterIpAddr_ = entry.is.DST_FILTER.dIPP;
		 rule->dstFilterIpAddrMask_ = entry.is.DST_FILTER.dIPM;
		 rule->dstFilterPortUpperBound_ = entry.is.DST_FILTER.DPORTUB;
		 rule->dstFilterPortLowerBound_ = entry.is.DST_FILTER.DPORTLB;
		 rule->ruleType_ = RTL8651_ACL_DSTFILTER;
		 break;
 
	default: return FAILED; 

	}
              rule->aclIdx=index;
	switch(entry.actionType) {
	
	case 0x00: 
			rule->actionType_ = RTL8651_ACL_PERMIT;
		 	goto _common_action;
		 		
	case 0x01:  	
			rule->actionType_ 	= RTL8651_ACL_REDIRECT;
			rule->dvid_ 		= entry.vid;
 		 	rule->nextHop_ 	= entry.nextHop;
 		 	rule->pppoeIdx_ 	= entry.PPPoEIndex;
		 	goto _common_action;

	case 0x03: 
			rule->actionType_ = RTL8651_ACL_CPU;
			goto _common_action;

	case 0x02: 
	case 0x04: 	
			rule->actionType_ = RTL8651_ACL_DROP;
		 	goto _common_action;
		 	
	case 0x05: 
			rule->actionType_ = RTL8651_ACL_DROP_LOG;
			goto _common_action;
	
	case 0x06: 
			rule->actionType_	= RTL8651_ACL_MIRROR;
			goto _common_action;
	
	case 0x07: 
			rule->actionType_ 	= RTL8651_ACL_REDIRECT_PPPOE;
			rule->dvid_ 		= entry.vid;
 		 	rule->nextHop_ 	= entry.nextHop;
 		 	rule->pppoeIdx_ 	= entry.PPPoEIndex;
		 	goto _common_action;
		 	
	case 0x08: 
			rule->actionType_	= RTL8651_ACL_POLICY;
			rule->nhIndex		= entry.nextHop;
			goto _common_action;

	case 0x09: 
			rule->actionType_	= RTL8651_ACL_MIRROR_KEEP_MATCH;
			goto _common_action;

	case 0x0a: 
			rule->actionType_	= RTL8651_ACL_DROP_RATE_EXCEED_PPS;
			rule->rlIndex		= entry.nextHop;
			goto _common_action;

	case 0x0b: 
			rule->actionType_	= RTL8651_ACL_LOG_RATE_EXCEED_PPS;
			rule->rlIndex		= entry.nextHop;
			goto _common_action;

	case 0x0c: 
			rule->actionType_	= RTL8651_ACL_DROP_RATE_EXCEED_BPS;
			rule->rlIndex		= entry.nextHop;
			goto _common_action;

	case 0x0d: 
			rule->actionType_	= RTL8651_ACL_LOG_RATE_EXCEED_BPS;
			rule->rlIndex		= entry.nextHop;
			goto _common_action;

	case 0x0e: 

	case 0x0f: 

	default: return FAILED;

_common_action:
		rule->priority_ = entry.hPriority;
 		rule->pktOpApp = entry.pktOpApp;
 
		 break;
	}
	return SUCCESS;
}




#define RTL865X_ASIC_DRIVER_PPPoE_TBL_API

int32 rtl8651_setAsicPppoe(uint32 index, rtl865x_tblAsicDrv_pppoeParam_t *pppoep) {
	rtl8651_tblAsic_pppoeTable_t entry;

	if((index >= RTL8651_PPPOETBL_SIZE) || (pppoep == NULL) || (pppoep->sessionId == 0xffff))
		return FAILED;

	bzero(&entry, sizeof(entry));
	entry.sessionID = pppoep->sessionId;
#if 1 
	entry.ageTime = pppoep->age;
#endif 

	return _rtl8651_forceAddAsicEntry(TYPE_PPPOE_TABLE, index, &entry);
}

int32 rtl8651_getAsicPppoe(uint32 index, rtl865x_tblAsicDrv_pppoeParam_t *pppoep) {
	rtl8651_tblAsic_pppoeTable_t entry;

	if((index >= RTL8651_PPPOETBL_SIZE) || (pppoep == NULL))
		return FAILED;

	_rtl8651_readAsicEntry(TYPE_PPPOE_TABLE, index, &entry);
	pppoep->sessionId = entry.sessionID;
#if 1 
	pppoep->age = entry.ageTime;
#endif 

	return SUCCESS;
}




#define RTL865X_ASIC_DRIVER_L3_TBL_API

int32 rtl8651_setAsicRouting(uint32 index, rtl865x_tblAsicDrv_routingParam_t *routingp) {
	uint32 i, asicMask;
	rtl8651_tblAsic_l3RouteTable_t entry;
    
	if((index >= RTL8651_ROUTINGTBL_SIZE) || (routingp == NULL))
		return FAILED;

	if (routingp->ipMask) {
		for(i=0; i<32; i++)
			if(routingp->ipMask & (1<<i)) break;
		asicMask = 31 - i;
	} else asicMask = 0;
    
	bzero(&entry, sizeof(entry));
	entry.IPAddr = routingp->ipAddr;
	switch(routingp->process) {
	case 0:
		entry.linkTo.PPPoEEntry.PPPoEIndex = routingp->pppoeIdx;
		entry.linkTo.PPPoEEntry.nextHop = (routingp->nextHopRow <<2) | routingp->nextHopColumn;
		entry.linkTo.PPPoEEntry.IPMask = asicMask;
		entry.linkTo.PPPoEEntry.vid = routingp->vidx;
		entry.linkTo.PPPoEEntry.hPriority = 0;
		entry.linkTo.PPPoEEntry.process = routingp->process;
		entry.linkTo.PPPoEEntry.valid = 1;
		break;
	case 1:
		entry.linkTo.L2Entry.nextHop = (routingp->nextHopRow <<2) | routingp->nextHopColumn;
		entry.linkTo.L2Entry.IPMask = asicMask;
		entry.linkTo.L2Entry.vid = routingp->vidx;
		entry.linkTo.L2Entry.hPriority = 0;
		entry.linkTo.L2Entry.process = routingp->process;
		entry.linkTo.L2Entry.valid = 1;
		break;
	case 2:
		entry.linkTo.ARPEntry.ARPEnd = routingp->arpEnd;
		entry.linkTo.ARPEntry.ARPStart = routingp->arpStart;
		entry.linkTo.ARPEntry.IPMask = asicMask;
		entry.linkTo.ARPEntry.vid = routingp->vidx;
		entry.linkTo.ARPEntry.hPriority = 0;
		entry.linkTo.ARPEntry.process = routingp->process;
		entry.linkTo.ARPEntry.valid = 1;
		entry.linkTo.ARPEntry.ARPIpIdx = routingp->arpIpIdx; 
		break;
	case 4:
	case 6:
		
		entry.linkTo.ARPEntry.vid = routingp->vidx;
		entry.linkTo.ARPEntry.IPMask = asicMask;
		entry.linkTo.ARPEntry.process = routingp->process;
		entry.linkTo.ARPEntry.valid = 1;
		break;
#if 1 
	case 5:
		entry.linkTo.NxtHopEntry.nhStart = routingp->nhStart >> 1;
		switch (routingp->nhNum)
		{
		    case 2: entry.linkTo.NxtHopEntry.nhNum = 0; break;
		    case 4: entry.linkTo.NxtHopEntry.nhNum = 1; break;
		    case 8: entry.linkTo.NxtHopEntry.nhNum = 2; break;
		    case 16: entry.linkTo.NxtHopEntry.nhNum = 3; break;
		    case 32: entry.linkTo.NxtHopEntry.nhNum = 4; break;
		    default: return FAILED;
		}
		entry.linkTo.NxtHopEntry.nhNxt = routingp->nhNxt;
		entry.linkTo.NxtHopEntry.nhAlgo = routingp->nhAlgo;
		entry.linkTo.NxtHopEntry.hPriority = 0;
		entry.linkTo.NxtHopEntry.IPMask = asicMask;
		entry.linkTo.NxtHopEntry.process = routingp->process;
		entry.linkTo.NxtHopEntry.valid = 1;
		entry.linkTo.NxtHopEntry.IPDomain = routingp->ipDomain;
		break;
#endif 
	default: return FAILED;
	}
    	return _rtl8651_forceAddAsicEntry(TYPE_L3_ROUTING_TABLE, index, &entry);
}

int32 rtl8651_delAsicRouting(uint32 index) {
	rtl8651_tblAsic_l3RouteTable_t entry;

	if(index >= RTL8651_ROUTINGTBL_SIZE)
		return FAILED;
	bzero(&entry, sizeof(entry));
	entry.linkTo.ARPEntry.valid = 0;
	return _rtl8651_forceAddAsicEntry(TYPE_L3_ROUTING_TABLE, index, &entry);
}

int32 rtl8651_getAsicRouting(uint32 index, rtl865x_tblAsicDrv_routingParam_t *routingp) {
	uint32 i;
	rtl8651_tblAsic_l3RouteTable_t entry;
    
	if((index >= RTL8651_ROUTINGTBL_SIZE) || (routingp == NULL))
		return FAILED;

	_rtl8651_readAsicEntry(TYPE_L3_ROUTING_TABLE, index, &entry);
	if(entry.linkTo.ARPEntry.valid == 0)
		return FAILED;

	routingp->ipAddr = entry.IPAddr;
	routingp->process = entry.linkTo.ARPEntry.process;
	for(i=0, routingp->ipMask = 0; i<=entry.linkTo.ARPEntry.IPMask; i++)
		routingp->ipMask |= 1<<(31-i);
    
    	routingp->vidx = entry.linkTo.ARPEntry.vid;
	switch(routingp->process) {
	case 0:
		routingp->arpStart = 0;
		routingp->arpEnd = 0;
		routingp->pppoeIdx = entry.linkTo.PPPoEEntry.PPPoEIndex;
		routingp->nextHopRow = entry.linkTo.PPPoEEntry.nextHop>>2;
		routingp->nextHopColumn = entry.linkTo.PPPoEEntry.nextHop & 0x3;
		break;
	case 1:
		routingp->arpStart = 0;
		routingp->arpEnd = 0;
		routingp->pppoeIdx = 0;
		routingp->nextHopRow = entry.linkTo.L2Entry.nextHop>>2;
		routingp->nextHopColumn = entry.linkTo.L2Entry.nextHop&0x3;
		break;
	case 2:
		routingp->arpEnd = entry.linkTo.ARPEntry.ARPEnd;
		routingp->arpStart = entry.linkTo.ARPEntry.ARPStart;
		routingp->pppoeIdx = 0;
		routingp->nextHopRow = 0;
		routingp->nextHopColumn = 0;
		routingp->arpIpIdx = entry.linkTo.ARPEntry.ARPIpIdx;
		break;
	case 4: 
	case 6: 
		routingp->arpStart = 0;
		routingp->arpEnd = 0;
		routingp->pppoeIdx = 0;
		routingp->nextHopRow = 0;
		routingp->nextHopColumn = 0;
		break;
#if 1 
	case 5:
		routingp->nhStart = (entry.linkTo.NxtHopEntry.nhStart) << 1;
		switch (entry.linkTo.NxtHopEntry.nhNum)
		{
		case 0: routingp->nhNum = 2; break;
		case 1: routingp->nhNum = 4; break;
		case 2: routingp->nhNum = 8; break;
		case 3: routingp->nhNum = 16; break;
		case 4: routingp->nhNum = 32; break;
		default: return FAILED;
		}
		routingp->nhNxt = entry.linkTo.NxtHopEntry.nhNxt;
		routingp->nhAlgo = entry.linkTo.NxtHopEntry.nhAlgo;
		routingp->ipDomain = entry.linkTo.NxtHopEntry.IPDomain;
		break;
#endif
	default: return FAILED;
	}
    return SUCCESS;
}





#define RTL865X_ASIC_DRIVER_ARP_TBL_API

int32 rtl8651_setAsicArp(uint32 index, rtl865x_tblAsicDrv_arpParam_t *arpp) {
	rtl8651_tblAsic_arpTable_t   entry;
	if((index >= RTL8651_ARPTBL_SIZE) || (arpp == NULL))
		return FAILED;

	bzero(&entry, sizeof(entry));
	entry.nextHop = (arpp->nextHopRow<<2) | (arpp->nextHopColumn&0x3);
	entry.valid = 1;
	return _rtl8651_forceAddAsicEntry(TYPE_ARP_TABLE, index, &entry);
}

int32 rtl8651_delAsicArp(uint32 index) {
	rtl8651_tblAsic_arpTable_t   entry;
	if(index >= RTL8651_ARPTBL_SIZE)
		return FAILED;

	bzero(&entry, sizeof(entry));
	entry.valid = 0;
	return _rtl8651_forceAddAsicEntry(TYPE_ARP_TABLE, index, &entry);
}

int32 rtl8651_getAsicArp(uint32 index, rtl865x_tblAsicDrv_arpParam_t *arpp) {
	rtl8651_tblAsic_arpTable_t   entry;
	if((index >= RTL8651_ARPTBL_SIZE) || (arpp == NULL))
		return FAILED;
	_rtl8651_readAsicEntry(TYPE_ARP_TABLE, index, &entry);
	if(entry.valid == 0)
		return FAILED;
	arpp->nextHopRow = entry.nextHop>>2;
	arpp->nextHopColumn = entry.nextHop&0x3;
	return SUCCESS;
}


int32 rtl8651_setAsicGidxRegister(uint32 regValue) {

#if 0
#ifdef CONFIG_RTL865XB
#ifndef RTL865X_TEST
	
	rtlglue_printf("%s: Hey, don't use me in 8651B!!!\n", __FUNCTION__);
	return FAILED;
#endif
#else
	WRITE_MEM32(GIDXMCR,regValue);
	return SUCCESS;
#endif 
#endif
	
	WRITE_MEM32(GIDXMCR,regValue);
	return SUCCESS;
}

int32 rtl8651_getAsicGidxRegister(uint32 * regValue) {
#if 0
#ifdef CONFIG_RTL865XB
	rtlglue_printf("%s: Hey, don't use me in 8651B!!!\n", __FUNCTION__);
	return FAILED;
#else
	if(regValue == NULL)
		return FAILED;

	*regValue = READ_MEM32(GIDXMCR);
	
	return SUCCESS;
#endif 
#endif
	if(regValue == NULL)
		return FAILED;
	*regValue = READ_MEM32(GIDXMCR);
	return SUCCESS;
}




#define RTL865X_ASIC_DRIVER_IP_TBL_API

int32 rtl8651_setAsicExtIntIpTable(uint32 index, rtl865x_tblAsicDrv_extIntIpParam_t *extIntIpp) {
	rtl8651_tblAsic_extIpTable_t   entry;
	int32 retval;

	if((index >= RTL8651_IPTABLE_SIZE) || (extIntIpp == NULL) || 
	((extIntIpp->localPublic == TRUE) && (extIntIpp->nat == TRUE))) 
		return FAILED;

	bzero(&entry, sizeof(entry));
	entry.externalIP = extIntIpp->extIpAddr;
	entry.internalIP = extIntIpp->intIpAddr;
	entry.isLocalPublic = extIntIpp->localPublic==TRUE? 1: 0;
	entry.isOne2One = extIntIpp->nat==TRUE? 1: 0;
    	entry.nextHop = extIntIpp->nhIndex;
	entry.valid = 1;
	retval = _rtl8651_forceAddAsicEntry(TYPE_EXT_INT_IP_TABLE, index, &entry);

#if defined(RTL865xB_MCAST_CUTCD_TTL_PATCH)&&defined(CONFIG_RTL865X_MULTILAYER_BSP)
	_rtl8651_arrangeAllMulticast();	
#endif 

	return retval;

}

#ifdef RTL865xB_MCAST_CUTCD_TTL_PATCH
int32 rtl8651_setInvalidAsicExtIntIpTable(uint32 index, rtl865x_tblAsicDrv_extIntIpParam_t *extIntIpp) {
	rtl8651_tblAsic_extIpTable_t   entry;
	rtl865x_tblAsicDrv_extIntIpParam_t dummy;

	if((index >= RTL8651_IPTABLE_SIZE) || (extIntIpp == NULL))
		return FAILED;

	if ( rtl8651_getAsicExtIntIpTable( index, &dummy ) == SUCCESS )
		return FAILED;

	bzero(&entry, sizeof(entry));
	entry.externalIP = extIntIpp->extIpAddr;
	entry.internalIP = extIntIpp->intIpAddr;
	entry.isLocalPublic = extIntIpp->localPublic==TRUE? 1: 0;
	entry.isOne2One = extIntIpp->nat==TRUE? 1: 0;
    	entry.nextHop = extIntIpp->nhIndex;
	entry.valid = 0;
	return _rtl8651_forceAddAsicEntry(TYPE_EXT_INT_IP_TABLE, index, &entry);

}
#endif 


int32 rtl8651_delAsicExtIntIpTable(uint32 index) {
    	rtl8651_tblAsic_extIpTable_t   entry;

	if(index >= RTL8651_IPTABLE_SIZE)
		return FAILED;
        
	bzero(&entry, sizeof(entry));
	entry.valid = 0;
	return _rtl8651_forceAddAsicEntry(TYPE_EXT_INT_IP_TABLE, index, &entry);
}

int32 rtl8651_getAsicExtIntIpTable(uint32 index, rtl865x_tblAsicDrv_extIntIpParam_t *extIntIpp) {
    	rtl8651_tblAsic_extIpTable_t   entry;
    
	if((index>=RTL8651_IPTABLE_SIZE) || (extIntIpp == NULL))
		return FAILED;
	_rtl8651_readAsicEntry(TYPE_EXT_INT_IP_TABLE, index, &entry);
	if(entry.valid == 0)
		return FAILED;
	extIntIpp->extIpAddr = entry.externalIP;
	extIntIpp->intIpAddr = entry.internalIP;
	extIntIpp->localPublic = entry.isLocalPublic==1? TRUE: FALSE;
	extIntIpp->nat = entry.isOne2One==1? TRUE: FALSE;
    	extIntIpp->nhIndex = entry.nextHop;
    	return SUCCESS;
}


#if 0

int32  _rtl8651_findAsicExtIpTableIdx(ipaddr_t extIp) 
{
	rtl8651_tblAsic_extIpTable_t   entry;
	int32 i;
	for(i=0;  i<RTL8651_IPTABLE_SIZE; i++){
		_rtl8651_readAsicEntry(TYPE_EXT_INT_IP_TABLE, i, &entry);
		if(entry.valid == 1 && entry.externalIP== extIp && entry.isLocalPublic== 0 && entry.isOne2One==0)
			break;
	}
	if(i==RTL8651_IPTABLE_SIZE)
		return -1;
	return i;
}
#endif



#define RTL865X_ASIC_DRIVER_SERVER_PORT_TBL_API

int32 rtl8651_setAsicServerPortTable(uint32 index, rtl865x_tblAsicDrv_serverPortParam_t *serverPortp) {
	rtl8651_tblAsic_srvPortTable_t   entry;
	if((index>=RTL8651_SERVERPORTTBL_SIZE) || (serverPortp == NULL))
		return FAILED;
        
	bzero(&entry, sizeof(entry));
	entry.externalIP = serverPortp->extIpAddr;
	entry.externalPort = serverPortp->extPort;
	entry.internalIP = serverPortp->intIpAddr;
	entry.internalPort = serverPortp->intPort;

#if 1 
	entry.nextHop = serverPortp->nhIndex;
	entry.isPortRange = serverPortp->portRange==TRUE? 1: 0;
#endif 
entry.nextHop = 31;

	entry.valid = serverPortp->valid;
	return _rtl8651_forceAddAsicEntry(TYPE_SERVER_PORT_TABLE, index, &entry);
}

int32 rtl8651_delAsicServerPortTable(uint32 index) {
	rtl8651_tblAsic_srvPortTable_t   entry;
	if(index>=RTL8651_SERVERPORTTBL_SIZE)
		return FAILED;
        
	bzero(&entry, sizeof(entry));
	entry.valid = 0;
	return _rtl8651_forceAddAsicEntry(TYPE_SERVER_PORT_TABLE, index, &entry);
}

int32 rtl8651_getAsicServerPortTable(uint32 index, rtl865x_tblAsicDrv_serverPortParam_t *serverPortp) {
    	rtl8651_tblAsic_srvPortTable_t   entry;
    
	if((index>=RTL8651_SERVERPORTTBL_SIZE) || (serverPortp == NULL))
		return FAILED;
	_rtl8651_readAsicEntry(TYPE_SERVER_PORT_TABLE, index, &entry);
	if(entry.valid == 0)
		return FAILED;
	serverPortp->extIpAddr = entry.externalIP;
	serverPortp->extPort = entry.externalPort;
	serverPortp->intIpAddr = entry.internalIP;
	serverPortp->intPort = entry.internalPort;
#if 1 
	serverPortp->nhIndex = entry.nextHop;
	serverPortp->portRange = entry.isPortRange==TRUE? 1: 0;
#endif 
	serverPortp->valid = entry.valid;
   	return SUCCESS;
}





int32 rtl8651_setAsicNaptAutoAddDelete(int8 autoAdd, int8 autoDelete) {
	if(autoAdd == TRUE)
		WRITE_MEM32(SWTMCR,READ_MEM32(SWTMCR)|EN_NAPT_AUTO_LEARN);
	else
		WRITE_MEM32(SWTMCR,READ_MEM32(SWTMCR)&~EN_NAPT_AUTO_LEARN);
	if(autoDelete == TRUE)
		WRITE_MEM32(SWTMCR,READ_MEM32(SWTMCR)|EN_NAPT_AUTO_DELETE);
	else
		WRITE_MEM32(SWTMCR,READ_MEM32(SWTMCR)&~EN_NAPT_AUTO_DELETE);
	return SUCCESS;
}

int32 rtl8651_getAsicNaptAutoAddDelete(int8 *autoAdd, int8 *autoDelete) {

	if(autoAdd){
		if(READ_MEM32(SWTMCR)&EN_NAPT_AUTO_LEARN)
			*autoAdd = TRUE;
		else
			*autoAdd = FALSE;
	}
	if(autoDelete){
		if(READ_MEM32(SWTMCR)&EN_NAPT_AUTO_DELETE)
			*autoDelete = TRUE;
		else
			*autoDelete = FALSE;
	}
	return SUCCESS;
}




#define RTL865X_ASIC_DRIVER_NAPT_TIMER_API

int32 rtl8651_setAsicNaptIcmpTimeout(uint32 timeout) {
	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;

	if(timeUnit >= 0x400)
		return FAILED;
	timeMask = (uint32)0x3f<< 26;
	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit<<26));
	return SUCCESS;
}

int32 rtl8651_getAsicNaptIcmpTimeout(uint32 *timeout) {
	if(timeout == NULL)
		return FAILED;
	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)>>26) & 0x3f);
	return SUCCESS;
}

int32 rtl8651_setAsicNaptUdpTimeout(uint32 timeout) {
	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;

	if(timeUnit >= 0x400)
		return FAILED;
	timeMask = 0x3f << 20;
	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit<<20));

	return SUCCESS;
}

int32 rtl8651_getAsicNaptUdpTimeout(uint32 *timeout) {
	if(timeout == NULL)
		return FAILED;
	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)>>20) & 0x3f);
	return SUCCESS;
}

int32 rtl8651_setAsicNaptTcpLongTimeout(uint32 timeout) {
	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;

	if(timeUnit >= 0x400)
		return FAILED;
	timeMask = 0x3f << 14;
	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit<<14));

	return SUCCESS;
}

int32 rtl8651_getAsicNaptTcpLongTimeout(uint32 *timeout) {
	if(timeout == NULL)
		return FAILED;
	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)>>14) & 0x3f);
	return SUCCESS;
}

int32 rtl8651_setAsicNaptTcpMediumTimeout(uint32 timeout) {
	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;

	if(timeUnit >= 0x400)
		return FAILED;
	timeMask = 0x3f << 8;
	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit<<8));

	return SUCCESS;
}

int32 rtl8651_getAsicNaptTcpMediumTimeout(uint32 *timeout) {
	if(timeout == NULL)
		return FAILED;
	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)>>8) & 0x3f);
	return SUCCESS;
}

int32 rtl8651_setAsicNaptTcpFastTimeout(uint32 timeout) {
	uint32 timeUnit = _rtl8651_NaptAgingToUnit(timeout), timeMask;

	if(timeUnit >= 0x400)
		return FAILED;
	timeMask = 0x3f << 2;
	WRITE_MEM32(TEATCR,(READ_MEM32(TEATCR) & ~timeMask) | (timeUnit<<2));

	return SUCCESS;
}

int32 rtl8651_getAsicNaptTcpFastTimeout(uint32 *timeout) {
	if(timeout == NULL)
		return FAILED;
	*timeout = _rtl8651_NaptAgingToSec((READ_MEM32(TEATCR)>>2) & 0x3f);
	return SUCCESS;
}





#define RTL865X_ASIC_DRIVER_TCPUDP_TBL_API

int32 rtl8651_setAsicLiberalNaptTcpUdpTable( int8 forced, uint16 index,
        ipaddr_t insideLocalIpAddr, uint16 insideLocalPort, int8 selExtIPIdx, uint16 insideGlobalPort, 
        uint32 ageSec, int8 entryType, int8 isTcp, int8 isCollision, int8 isCollision2, int8 isValid ) 
{
	rtl8651_tblAsic_naptTcpUdpTable_t  entry;
	int8 tcpQuiet, directional, outbound;

	
	assert(entryType&RTL8651_STATIC_NAPT_ENTRY);
	assert(entryType & RTL8651_LIBERAL_NAPT_ENTRY);
	assert(index<RTL8651_TCPUDPTBL_SIZE);
	
	bzero(&entry, sizeof(entry));
	entry.collision = isCollision==TRUE? 1: 0;
	entry.collision2 = isCollision2==TRUE? 1: 0;
	entry.offset = insideGlobalPort>>RTL8651_TCPUDPTBL_BITS;

	
	
	entry.collision = entry.collision2 = 1;

	if(isValid){
		entry.valid = 1;
		entry.isStatic = entry.dedicate = 1;
		entry.intIPAddr = insideLocalIpAddr;
		entry.intPort = insideLocalPort;
		
		entry.agingTime = _rtl8651_NaptAgingToUnit(ageSec);

		
		tcpQuiet = (ISSET(entryType, RTL8651_NAPT_SYNFIN_QUIET))? 1:0;
		directional = (ISSET(entryType, RTL8651_NAPT_UNIDIRECTIONAL_FLOW))? 1:0;
		outbound = (directional&&ISSET(entryType, RTL8651_NAPT_OUTBOUND_FLOW))? 1:0;

		
		entry.selEIdx = insideGlobalPort & (RTL8651_TCPUDPTBL_SIZE-1);
		entry.selIPIdx = selExtIPIdx;

		
		entry.TCPFlag = (tcpQuiet<<2)|(directional<<1) | (outbound);
		entry.isTCP= isTcp==TRUE? 1: 0;
	}
	else
	{
		entry.isStatic = entry.dedicate= entry.intIPAddr=entry.intPort =0;
		entry.agingTime =entry.selEIdx=entry.selIPIdx= entry.TCPFlag = 0;
	}

	if(forced == TRUE)
		return _rtl8651_forceAddAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, &entry);
	else if(_rtl8651_addAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, &entry))
			return FAILED;
	return SUCCESS;
}

int32 rtl8651_setAsicNaptTcpUdpTable(int8 forced, uint32 index, rtl865x_tblAsicDrv_naptTcpUdpParam_t *naptTcpUdpp) {
	rtl8651_tblAsic_naptTcpUdpTable_t  entry;
	if((index >= RTL8651_TCPUDPTBL_SIZE) || (naptTcpUdpp == NULL))
		return FAILED;

	assert( naptTcpUdpp->tcpFlag < TCP_CLOSED_FLOW );

	memset(&entry, 0, sizeof(entry));
	entry.collision = 1; 
	entry.collision2 = 1; 
	entry.valid = naptTcpUdpp->isValid==TRUE? 1: 0;
	entry.intIPAddr = naptTcpUdpp->insideLocalIpAddr;
	entry.intPort = naptTcpUdpp->insideLocalPort;
	entry.offset = naptTcpUdpp->offset;
	entry.agingTime = _rtl8651_NaptAgingToUnit(naptTcpUdpp->ageSec);
	entry.isStatic = naptTcpUdpp->isStatic==TRUE? 1: 0;
	entry.isTCP = naptTcpUdpp->isTcp==TRUE? 1: 0;
	entry.TCPFlag = naptTcpUdpp->tcpFlag;
	entry.dedicate = naptTcpUdpp->isDedicated==TRUE? 1: 0;
	entry.selIPIdx = naptTcpUdpp->selExtIPIdx;
	entry.selEIdx = naptTcpUdpp->selEIdx;

	
	
	entry.collision = entry.collision2 = 1;
	
	if(forced == TRUE){
		_rtl8651_forceAddAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, &entry);
	}else if(_rtl8651_addAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, &entry))
		return FAILED;
	return SUCCESS;
}


int32 rtl8651_getAsicRawNaptTable(uint32 index, void   *entry){
	
	uint32  *pEntry=(uint32 *)entry;
	int32 retval;

	
	retval=_rtl8651_readAsicEntry(TYPE_L4_TCP_UDP_TABLE, index, entry);
	

	
	if(((pEntry[1]&0x1)==0)&&((pEntry[1]&0x10000)==0x10000))  
		pEntry[1] |=0x1;            

	return retval;
}

int32 rtl8651_setAsicRawNaptTable( uint32 index, void *vEntry, int8 forced )
{
	rtl8651_tblAsic_naptTcpUdpTable_t *entry = (rtl8651_tblAsic_naptTcpUdpTable_t *)vEntry;

	
	
	entry->collision = entry->collision2 = 1;
	if( forced == TRUE )
		return _rtl8651_forceAddAsicEntry( TYPE_L4_TCP_UDP_TABLE, index, vEntry );
	else if( _rtl8651_addAsicEntry( TYPE_L4_TCP_UDP_TABLE, index, vEntry ) )
		return FAILED;
	return SUCCESS;
}

	
int32 rtl8651_getAsicNaptTcpUdpTable(uint32 index, rtl865x_tblAsicDrv_naptTcpUdpParam_t *naptTcpUdpp) {
	rtl8651_tblAsic_naptTcpUdpTable_t  entry;
	if((index >= RTL8651_TCPUDPTBL_SIZE) || (naptTcpUdpp == NULL))
		return FAILED;

    rtl8651_getAsicRawNaptTable( index, &entry);
    
	naptTcpUdpp->insideLocalIpAddr = entry.intIPAddr;
	naptTcpUdpp->insideLocalPort = entry.intPort;
	naptTcpUdpp->offset = entry.offset;
	naptTcpUdpp->ageSec = _rtl8651_NaptAgingToSec(entry.agingTime);
	naptTcpUdpp->isStatic = entry.isStatic;
	naptTcpUdpp->isTcp = entry.isTCP;
	naptTcpUdpp->isCollision = entry.collision;
	naptTcpUdpp->isCollision2 = entry.collision2;
	naptTcpUdpp->isValid = entry.valid;
	naptTcpUdpp->isDedicated = entry.dedicate;
	naptTcpUdpp->selExtIPIdx = entry.selIPIdx;
	naptTcpUdpp->selEIdx = entry.selEIdx;
	naptTcpUdpp->tcpFlag = entry.TCPFlag;

   	 return SUCCESS;
}

int32 rtl8651_delAsicNaptTcpUdpTable(uint32 start, uint32 end) {
	if((start >= RTL8651_TCPUDPTBL_SIZE) || (end >= RTL8651_TCPUDPTBL_SIZE))
		return FAILED;

	_rtl8651_delAsicEntry(TYPE_L4_TCP_UDP_TABLE, start, end);
	return SUCCESS;
}





#define RTL865X_ASIC_DRIVER_ICMP_TBL_API

int32 rtl8651_setAsicNaptIcmpTable(int8 forced, uint32 index, rtl865x_tblAsicDrv_naptIcmpParam_t *naptIcmpp) {
	rtl8651_tblAsic_naptIcmpTable_t  entry;
	if((index >= RTL8651_ICMPTBL_SIZE) || (naptIcmpp == NULL))
		return FAILED;

	bzero(&entry, sizeof(entry));
	entry.intIPAddr = naptIcmpp->insideLocalIpAddr;
	entry.ICMPIDH = naptIcmpp->insideLocalId>>15;
	entry.ICMPIDL = naptIcmpp->insideLocalId&0x7fff;
	entry.offset = naptIcmpp->offset;
	entry.agingTime = _rtl8651_NaptAgingToUnit(naptIcmpp->ageSec);
	entry.isStatic = naptIcmpp->isStatic;
#if 1 
	
	assert( naptIcmpp->isCollision == TRUE );
#endif 
	entry.collision = 1;
   	entry.valid = 1;
#if 1 
    	entry.type = naptIcmpp->isSpi==TRUE? 1: naptIcmpp->isPptp==TRUE? 2: 0;
#endif 
	if(forced == TRUE)
		_rtl8651_forceAddAsicEntry(TYPE_L4_ICMP_TABLE, index, &entry);
	else if(_rtl8651_addAsicEntry(TYPE_L4_ICMP_TABLE, index, &entry))
        	return FAILED;
    return SUCCESS;
}

int32 rtl8651_getAsicNaptIcmpTable(uint32 index, rtl865x_tblAsicDrv_naptIcmpParam_t *naptIcmpp) {
	rtl8651_tblAsic_naptIcmpTable_t  entry;
	if((index >= RTL8651_ICMPTBL_SIZE) || (naptIcmpp == NULL))
		return FAILED;
        
	WRITE_MEM32(TEATCR, READ_MEM32(TEATCR) | 0x2);    
	_rtl8651_readAsicEntry(TYPE_L4_ICMP_TABLE, index, &entry);
	WRITE_MEM32(TEATCR, READ_MEM32(TEATCR) & ~0x2); 

	naptIcmpp->insideLocalIpAddr = entry.intIPAddr;
	naptIcmpp->insideLocalId = (entry.ICMPIDH << 15) | entry.ICMPIDL;
	naptIcmpp->ageSec = _rtl8651_NaptAgingToSec(entry.agingTime);
	naptIcmpp->isStatic = entry.isStatic==1? TRUE: FALSE;
	naptIcmpp->isCollision = entry.collision==1? TRUE: FALSE;
	naptIcmpp->offset = entry.offset;
	naptIcmpp->isValid = entry.valid == 1? TRUE: FALSE;
#if 1 
	naptIcmpp->isSpi = entry.type==1? TRUE: FALSE;
	naptIcmpp->isPptp = entry.type>=2? TRUE: FALSE;
	naptIcmpp->count = entry.count;
#endif 
	    
	return SUCCESS;
}




#define RTL865X_ASIC_DRIVER_NAPT_OFFSET_API

int32 rtl8651_setAsicL4Offset(uint16 start, uint16 end) {
	if(start > 0x3f || end > 0x3f || start > end)
		return FAILED;

	WRITE_MEM32(OCR,start<<26 | end<<20);	
	return SUCCESS;
}

int32 rtl8651_getAsicL4Offset(uint16 *start, uint16 *end) {
	if(start == NULL || end == NULL)
		return FAILED;
	*start = (READ_MEM32(OCR)>>26) & 0x3f;
	*end = (READ_MEM32(OCR)>>20) & 0x3f;
	return SUCCESS;
}


#if 0
int32 rtl8651_getAsicNaptTcpUdpOffset(uint16 index, uint16 * offset, int8 * isValid) {
	rtl8651_tblAsic_naptTcpUdpTable_t  entry;

	if(offset == NULL || isValid == NULL || index >= RTL8651_TCPUDPTBL_SIZE)
		return FAILED;

	rtl8651_getAsicRawNaptTable( index, &entry);

	*offset = entry.offset;
	*isValid = entry.valid == 1? TRUE: FALSE;
	
	return SUCCESS;
}
#endif

int32 rtl8651_getAsicNaptIcmpOffset(uint16 index, uint16 * offset, int8 * isValid) {
	rtl8651_tblAsic_naptIcmpTable_t  entry;

	if(offset == NULL || isValid == NULL || index>= RTL8651_ICMPTBL_SIZE)
		return FAILED;
	
	WRITE_MEM32(TEATCR, READ_MEM32(TEATCR) | 0x2); 
	_rtl8651_readAsicEntry(TYPE_L4_ICMP_TABLE, index, &entry);
	WRITE_MEM32(TEATCR, READ_MEM32(TEATCR) & ~0x2); 

	*offset = entry.offset;
	*isValid = entry.valid==1? TRUE: FALSE;
	
	return SUCCESS;
}






#define RTL865X_ASIC_DRIVER_ALG_TBL_API

int32 rtl8651_setAsicAlg(uint32 index, rtl865x_tblAsicDrv_algParam_t *algp) {
	rtl8651_tblAsic_algTable_t entry;

	if((index >= RTL8651_ALGTBL_SIZE) || (algp == NULL))
		return FAILED;

	bzero(&entry, sizeof(entry));
	entry.L4Port = algp->port;
	entry.valid = 1;
	return _rtl8651_forceAddAsicEntry(TYPE_ALG_TABLE, index, &entry);
}

int32 rtl8651_delAsicAlg(uint32 index) {
	rtl8651_tblAsic_algTable_t entry;

	if(index >= RTL8651_ALGTBL_SIZE)
		return FAILED;

	bzero(&entry, sizeof(entry));
	entry.valid = 0;
	return _rtl8651_forceAddAsicEntry(TYPE_ALG_TABLE, index, &entry);
}

int32 rtl8651_getAsicAlg(uint32 index, rtl865x_tblAsicDrv_algParam_t *algp) {
	rtl8651_tblAsic_algTable_t entry;

	if((index >= RTL8651_ALGTBL_SIZE) || (algp == NULL))
		return FAILED;

	_rtl8651_readAsicEntry(TYPE_ALG_TABLE, index, &entry);

	if(entry.valid == 0)
	return FAILED;
	algp->port = entry.L4Port;
	return SUCCESS;
}


#define RTL865X_ASIC_DRIVER_MULTICAST_TBL_API


int32 rtl8651_setAsicIpMulticastTable(rtl865x_tblAsicDrv_multiCastParam_t *mCast_t) {
	uint32 idx = rtl8651_ipMulticastTableIndex(mCast_t->sip, mCast_t->dip);
	rtl8651_tblAsic_ipMulticastTable_t entry;
	int16 age;

	if(mCast_t->dip >>28 != 0xe || mCast_t->port >= RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum)
		return FAILED;
	bzero(&entry, sizeof(entry));
	entry.srcIPAddr 		= mCast_t->sip;
	entry.destIPAddrLsbs 	= mCast_t->dip & 0xfffffff;
#if 1
	if (mCast_t->port >= RTL8651_PORT_NUMBER) {
		
		entry.srcPortExt = 1;
		entry.srcPortL 			= (mCast_t->port-RTL8651_PORT_NUMBER)& 0x1; 
		entry.srcPortH 			= (mCast_t->port-RTL8651_PORT_NUMBER)>>1;   
	} else {
		entry.srcPortExt = 0;
		entry.srcPortL 			= mCast_t->port& 0x1; 
		entry.srcPortH 			= mCast_t->port>>1;   
	}
#else
	entry.srcPortL 			= mCast_t->port& 0x1; 
	entry.srcPortH 			= mCast_t->port>>1;   

	entry.srcPortExt 		= mCast_t->port >>3; 
#endif
	entry.extPortList 		= mCast_t->mbr >> RTL8651_PORT_NUMBER;
	entry.srcVid 			= rtl8651_vlanTableIndex(mCast_t->svid);
	entry.toCPU 			= 0;
	entry.valid 			= 1;
	entry.extIPIndex 		= mCast_t->extIdx;
	entry.portList 			= mCast_t->mbr & (RTL8651_PHYSICALPORTMASK);
	entry.ageTime			= 0;
	age = (int16)mCast_t->age;
	while ( age > 0 ) {
		if ( (++entry.ageTime) == 7)
			break;
		age -= 5;
	}
	return _rtl8651_forceAddAsicEntry(TYPE_MULTICAST_TABLE, idx, &entry);
}

int32 rtl8651_delAsicIpMulticastTable(uint32 index) {
	rtl8651_tblAsic_ipMulticastTable_t entry;
	bzero(&entry, sizeof(entry));
	return _rtl8651_forceAddAsicEntry(TYPE_MULTICAST_TABLE, index, &entry);
}

int32 rtl8651_getAsicIpMulticastTable(uint32 index, rtl865x_tblAsicDrv_multiCastParam_t *mCast_t) {
	rtl8651_tblAsic_vlanTable_t vlanEntry;
	rtl8651_tblAsic_ipMulticastTable_t entry;

	if (mCast_t == NULL)
		return FAILED;
	_rtl8651_readAsicEntry(TYPE_MULTICAST_TABLE, index, &entry);
	if(entry.valid == 0)
		return FAILED;
	_rtl8651_readAsicEntry(TYPE_VLAN_TABLE, entry.srcVid, &vlanEntry);
 	if(vlanEntry.valid == 0)
 		return FAILED;
 	mCast_t->sip	= entry.srcIPAddr;
 	mCast_t->dip	= entry.destIPAddrLsbs | 0xe0000000;
	mCast_t->svid = vlanEntry.vhid<<3 | entry.srcVid;
#if 1

#if 1
	if (entry.srcPortExt) {
		mCast_t->port = (entry.srcPortH<<1 | entry.srcPortL) + RTL8651_PORT_NUMBER;
	} else {
		mCast_t->port = entry.srcPortH<<1 | entry.srcPortL;
	}
#else
	mCast_t->port = entry.srcPortExt<<3 | entry.srcPortH<<1 | entry.srcPortL;
#endif
	mCast_t->mbr = entry.extPortList<<RTL8651_PORT_NUMBER | entry.portList;
#else
	mCast_t->port = entry.srcPortH<<1 | entry.srcPortL;
	mCast_t->mbr = entry.portList;
#endif
	mCast_t->extIdx = entry.extIPIndex ;
	mCast_t->age	= entry.ageTime * 5;
	mCast_t->cpu = entry.toCPU;
	return SUCCESS;
}



#define RTL865X_ASIC_DRIVER_NEXTHOP_TBL_API

int32 rtl8651_setAsicNextHopTable(uint32 index, rtl865x_tblAsicDrv_nextHopParam_t *nextHopp) {
    rtl8651_tblAsic_nextHopTable_t  entry;
    if((index>=RTL8651_NEXTHOPTBL_SIZE) || (nextHopp == NULL))
        return FAILED;

	
    bzero(&entry, sizeof(entry));
    entry.nextHop = (nextHopp->nextHopRow <<2) | nextHopp->nextHopColumn;
    entry.PPPoEIndex = nextHopp->pppoeIdx;
    entry.dstVid = nextHopp->dvid;
    entry.IPIndex = nextHopp->extIntIpIdx;
    entry.type = nextHopp->isPppoe==TRUE? 1: 0;
    return _rtl8651_forceAddAsicEntry(TYPE_NEXT_HOP_TABLE, index, &entry);
}

int32 rtl8651_getAsicNextHopTable(uint32 index, rtl865x_tblAsicDrv_nextHopParam_t *nextHopp) {
    rtl8651_tblAsic_nextHopTable_t  entry;
    if((index>=RTL8651_NEXTHOPTBL_SIZE) || (nextHopp == NULL))
        return FAILED;

    _rtl8651_readAsicEntry(TYPE_NEXT_HOP_TABLE, index, &entry);
    nextHopp->nextHopRow = entry.nextHop>>2;
    nextHopp->nextHopColumn = entry.nextHop&0x3;
    nextHopp->pppoeIdx = entry.PPPoEIndex;
    nextHopp->dvid = entry.dstVid;
    nextHopp->extIntIpIdx = entry.IPIndex;
    nextHopp->isPppoe = entry.type==1? TRUE: FALSE;
    return SUCCESS;
}





#define RTL865X_ASIC_DRIVER_RATE_LIMIT_API

int32 rtl8651_setAsicRateLimitTable(uint32 index, rtl865x_tblAsicDrv_rateLimitParam_t *rateLimit_t)
{
	rtl8651_tblAsic_rateLimitTable_t entry;

	if (rateLimit_t == NULL || index >= RTL8651_RATELIMITTBL_SIZE)
		return FAILED;
	bzero(&entry, sizeof(rtl8651_tblAsic_rateLimitTable_t));
	entry.maxToken				= rateLimit_t->maxToken&0xFFFFFF;
	entry.refill				= rateLimit_t->refill_number&0xFFFFFF;
	entry.refillTime			= rateLimit_t->t_intervalUnit&0x3F;
	entry.refillRemainTime		= rateLimit_t->t_remainUnit&0x3F;
	entry.token					= rateLimit_t->token&0xFFFFFF;
	return _rtl8651_forceAddAsicEntry(TYPE_RATE_LIMIT_TABLE, index, &entry);
}


int32 rtl8651_delAsicRateLimitTable(uint32 index)
{
	rtl8651_tblAsic_rateLimitTable_t entry;
	
	if (index >= RTL8651_RATELIMITTBL_SIZE)
		return FAILED;
	bzero(&entry, sizeof(rtl8651_tblAsic_rateLimitTable_t));
	return _rtl8651_forceAddAsicEntry(TYPE_RATE_LIMIT_TABLE, index, &entry);
}


int32 rtl8651_getAsicRateLimitTable(uint32 index, rtl865x_tblAsicDrv_rateLimitParam_t *rateLimit_t)
{
	rtl8651_tblAsic_rateLimitTable_t entry;

	if (rateLimit_t == NULL || index >= RTL8651_RATELIMITTBL_SIZE)
		return FAILED;
	_rtl8651_readAsicEntry(TYPE_RATE_LIMIT_TABLE, index, &entry);
	if (entry.refillTime == 0)
		return FAILED;
	rateLimit_t->token			= entry.token & 0xFFFFFF;
	rateLimit_t->maxToken		= entry.maxToken & 0xFFFFFF;
	rateLimit_t->t_remainUnit = entry.refillRemainTime&0x3F;
	rateLimit_t->t_intervalUnit = entry.refillTime&0x3F;
	rateLimit_t->refill_number	= entry.refill&0xFFFFFF;
	return SUCCESS;
}



int32 rtl8651_flowContrlThreshold(uint32 a, uint32 value)
{
	
	uint32 tempValue;
	tempValue = READ_MEM32(0xbc805018) & ~((0xff)<<(8*a));
	tempValue = tempValue | (value<<(a*8));
	WRITE_MEM32(0xbc805018, tempValue);
	return SUCCESS;
}

int32 rtl8651_flowContrlPrimeThreshold(uint32 a, uint32 value)
{
	uint32 tempValue;
	tempValue = READ_MEM32(0xbc805028) & ~((0xffff)<<(16*a));
	tempValue = tempValue | (value<<(a*16));
	WRITE_MEM32(0xbc805028, tempValue);
	return SUCCESS;
}

uint32 * regStoragePtr[16];
struct rtl_mBuf *mbufStorage[16];

#ifdef RTL865X_MODEL_USER
int32 rtl8651_resetSwitchCoreStore(void)
{
	
	assert( 0 );
	return FAILED;
}
#else
int32 rtl8651_resetSwitchCoreStore(void) {
	uint32 i, j, k;
	uint32 *dataPtr;
	
	
	for(i=0; i<16; i++) {
		mbufStorage[i] = NULL;
		regStoragePtr[i] = NULL;
		if((mbufStorage[i] = mBuf_get(MBUF_DONTWAIT, MBUFTYPE_DATA, 1)) == NULL) {
			while(i) {
				assert((i-1)<16);
				mBuf_freeMbufChain(mbufStorage[i-1]);
				mbufStorage[i-1] = NULL;
				i--;
			}
			return FAILED;
		}
		regStoragePtr[i] = (uint32 *)mbufStorage[i]->m_data;
	}
	
	WRITE_MEM32(BISTCR, READ_MEM32(BISTCR) & ~(0x2));

	
	i = 0;
	dataPtr = (uint32 *)0xbc000000; 
	for(j=0; j<1024; j++) 
		for(k=0; k<2; k++) {
			regStoragePtr[(i>>9)][i&0x1FF] = dataPtr[(j<<3)+k];
			i++;
		}
	
	dataPtr = (uint32 *)0xbc010000;
	for(j=0; j<512; j++)
		regStoragePtr[4][j] = dataPtr[j<<3];
	
	i = 0;
	dataPtr = (uint32 *)0xbc020000; 
	for(j=0; j<8; j++) 
		for(k=0; k<2; k++) 
			regStoragePtr[5][i++] = dataPtr[(j<<3)+k];
	dataPtr = (uint32 *)0xbc030000; 
	for(j=0; j<64; j++) 
		for(k=0; k<3; k++) 
			regStoragePtr[5][i++] = dataPtr[(j<<3)+k];
	dataPtr = (uint32 *)0xbc040000; 
	for(j=0; j<8; j++) 
		regStoragePtr[5][i++] = dataPtr[(j<<3)];
	dataPtr = (uint32 *)0xbc050000; 
	for(j=0; j<8; j++) 
		for(k=0; k<5; k++) 
			regStoragePtr[5][i++] = dataPtr[(j<<3)+k];
	dataPtr = (uint32 *)0xbc060000; 
	for(j=0; j<16; j++) 
		for(k=0; k<3; k++) 
			regStoragePtr[5][i++] = dataPtr[(j<<3)+k];
	dataPtr = (uint32 *)0xbc070000; 
	for(j=0; j<128; j++) 
		regStoragePtr[5][i++] = dataPtr[(j<<3)];
	dataPtr = (uint32 *)0xbc080000; 
	for(j=0; j<16; j++) 
		for(k=0; k<4; k++) 
			regStoragePtr[5][i++] = dataPtr[(j<<3)+k];
	assert(i<512);
	i = 0;
	dataPtr = (uint32 *)0xbc090000; 
	for(j=0; j<1024; j++) 
		for(k=0; k<3; k++) {
			regStoragePtr[6+(i>>9)][i&0x1FF] = dataPtr[(j<<3)+k];
			i++;
		}
	
	i = 0;
	dataPtr = (uint32 *)0xbc0a0000; 
	for(j=0; j<32; j++) 
		for(k=0; k<3; k++) 
			regStoragePtr[12][i++] = dataPtr[(j<<3)+k];
	dataPtr = (uint32 *)0xbc0b0000; 
	for(j=0; j<8; j++) 
		regStoragePtr[12][i++] = dataPtr[(j<<3)];
	dataPtr = (uint32 *)0xbc0d0000; 
	for(j=0; j<32; j++) 
		regStoragePtr[12][i++] = dataPtr[(j<<3)];
	dataPtr = (uint32 *)0xbc0e0000; 
	for(j=0; j<32; j++) 
		for(k=0; k<3; k++) 
			regStoragePtr[12][i++] = dataPtr[(j<<3)+k];
	assert(i<512);
	i = 0;
	dataPtr = (uint32 *)0xbc0c0000; 
	for(j=0; j<128; j++) 
		for(k=0; k<8; k++) {
			regStoragePtr[13+(i>>9)][i&0x1FF] = dataPtr[(j<<3)+k];
			i++;
		}
	
	i = 0;
	regStoragePtr[15][i++] = READ_MEM32(CPUICR);
	regStoragePtr[15][i++] = READ_MEM32(CPUIIMR);
	regStoragePtr[15][i++] = READ_MEM32(MIB_CONTROL);
	regStoragePtr[15][i++] = READ_MEM32(MIB_CONTROL_1);
	regStoragePtr[15][i++] = READ_MEM32(MIB_CONTROL_2);
	regStoragePtr[15][i++] = READ_MEM32(PORT0_PHY_AUTONEGO_ADVERTISEMENT);
	regStoragePtr[15][i++] = READ_MEM32(PORT0_PHY_CONTROL);
	regStoragePtr[15][i++] = READ_MEM32(PORT1_PHY_AUTONEGO_ADVERTISEMENT);
	regStoragePtr[15][i++] = READ_MEM32(PORT1_PHY_CONTROL);
	regStoragePtr[15][i++] = READ_MEM32(PORT2_PHY_AUTONEGO_ADVERTISEMENT);
	regStoragePtr[15][i++] = READ_MEM32(PORT2_PHY_CONTROL);
	regStoragePtr[15][i++] = READ_MEM32(PORT3_PHY_AUTONEGO_ADVERTISEMENT);
	regStoragePtr[15][i++] = READ_MEM32(PORT3_PHY_CONTROL);
	regStoragePtr[15][i++] = READ_MEM32(PORT4_PHY_AUTONEGO_ADVERTISEMENT);
	regStoragePtr[15][i++] = READ_MEM32(PORT4_PHY_CONTROL);
	for(j=SYSTEM_BASE; j<= SWTMCR; j+=4)
		regStoragePtr[15][i++] = READ_MEM32(j);
	for(j=MISC_BASE; j<= PBVR6E; j+=4)
		regStoragePtr[15][i++] = READ_MEM32(j);

	return SUCCESS;
}
#endif

#ifdef RTL865X_MODEL_USER
int32 rtl8651_resetSwitchCoreActionAndConfigure(void)
{
	
	assert( 0 );
	return FAILED;
}
#else

static void _rtl8651_phyRegConfig(uint32 address, uint32 data) {
	while ( (READ_MEM32(SWTACR) & ACTION_MASK) != ACTION_DONE );
	WRITE_MEM32(TCR0, data);
	WRITE_MEM32(SWTAA, address);
 	WRITE_MEM32(SWTACR, ACTION_START | CMD_FORCE);
	while ( (READ_MEM32(SWTACR) & ACTION_MASK) != ACTION_DONE );
}

int32 rtl8651_resetSwitchCoreActionAndConfigure(void) {
	uint32 i, j, k;
	uint32 entry[8];

	
	for(i=0; i<16; i++)
		if(regStoragePtr[i] == NULL)
			return FAILED;
	
	
	WRITE_MEM32(MACCR, 0x3000000);
	
	
	bzero(&entry, sizeof entry);
	i=0;
	for(j=0; j<1024; j++) {
		for(k=0; k<2; k++) {
			entry[k] = regStoragePtr[(i>>9)][i&0x1FF];
			i++;
		}
		_rtl8651_forceAddAsicEntry(TYPE_L2_SWITCH_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<512; j++) {
		entry[0] = regStoragePtr[4][j];
		_rtl8651_forceAddAsicEntry(TYPE_ARP_TABLE, j, &entry);
	}
	
	i = 0;
	 
	bzero(&entry, sizeof entry);
	for(j=0; j<8; j++) {
		for(k=0; k<2; k++) 
			entry[k] = regStoragePtr[5][i++];
		_rtl8651_forceAddAsicEntry(TYPE_L3_ROUTING_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<64; j++) {
		for(k=0; k<3; k++) 
			entry[k] = regStoragePtr[5][i++];
		_rtl8651_forceAddAsicEntry(TYPE_MULTICAST_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<8; j++) {
		entry[0] = regStoragePtr[5][i++];
		_rtl8651_forceAddAsicEntry(TYPE_PROTOCOL_TRAP_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<8; j++) {
		for(k=0; k<5; k++) 
			entry[k] = regStoragePtr[5][i++];
		_rtl8651_forceAddAsicEntry(TYPE_VLAN_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<16; j++) {
		for(k=0; k<3; k++) 
			entry[k] = regStoragePtr[5][i++];
		_rtl8651_forceAddAsicEntry(TYPE_EXT_INT_IP_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<128; j++) {
		entry[0] = regStoragePtr[5][i++];
		_rtl8651_forceAddAsicEntry(TYPE_ALG_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<16; j++) {
		for(k=0; k<4; k++) 
			entry[k] = regStoragePtr[5][i++];
		_rtl8651_forceAddAsicEntry(TYPE_SERVER_PORT_TABLE, j, &entry);
	}
	
	i = 0;
	bzero(&entry, sizeof entry);
	for(j=0; j<1024; j++) {
		for(k=0; k<3; k++) {
			entry[k] = regStoragePtr[6+(i>>9)][i&0x1FF];
			i++;
		}
		_rtl8651_forceAddAsicEntry(TYPE_L4_TCP_UDP_TABLE, j, &entry);
	}

	
	
	i = 0;
	bzero(&entry, sizeof entry);
	for(j=0; j<32; j++) {
		for(k=0; k<3; k++) 
			entry[k] = regStoragePtr[12][i++];
		_rtl8651_forceAddAsicEntry(TYPE_L4_ICMP_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<8; j++) {
		entry[0] = regStoragePtr[12][i++];
		_rtl8651_forceAddAsicEntry(TYPE_PPPOE_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<32; j++) {
		entry[0] = regStoragePtr[12][i++];
		_rtl8651_forceAddAsicEntry(TYPE_NEXT_HOP_TABLE, j, &entry);
	}
	
	bzero(&entry, sizeof entry);
	for(j=0; j<32; j++) {
		for(k=0; k<3; k++) 
			entry[k] = regStoragePtr[12][i++];
		_rtl8651_forceAddAsicEntry(TYPE_RATE_LIMIT_TABLE, j, &entry);
	}
	i = 0;
	
	for(j=0; j<128; j++) {
		for(k=0; k<8; k++) {
			entry[k] = regStoragePtr[13+(i>>9)][i&0x1FF];
			i++;
		}
		_rtl8651_forceAddAsicEntry(TYPE_ACL_RULE_TABLE, j, &entry);
	}

	i = 0;
	WRITE_MEM32(CPUICR, regStoragePtr[15][i++]);
	WRITE_MEM32(CPUIIMR, regStoragePtr[15][i++]);
	WRITE_MEM32(MIB_CONTROL, regStoragePtr[15][i++]);
	WRITE_MEM32(MIB_CONTROL_1, regStoragePtr[15][i++]);
	WRITE_MEM32(MIB_CONTROL_2, regStoragePtr[15][i++]);
	_rtl8651_phyRegConfig(PORT0_PHY_AUTONEGO_ADVERTISEMENT, regStoragePtr[15][i++]);
	_rtl8651_phyRegConfig(PORT0_PHY_CONTROL , regStoragePtr[15][i++] | RESTART_AUTONEGO);
	_rtl8651_phyRegConfig(PORT1_PHY_AUTONEGO_ADVERTISEMENT, regStoragePtr[15][i++]);
	_rtl8651_phyRegConfig(PORT1_PHY_CONTROL , regStoragePtr[15][i++] | RESTART_AUTONEGO);
	_rtl8651_phyRegConfig(PORT2_PHY_AUTONEGO_ADVERTISEMENT, regStoragePtr[15][i++]);
	_rtl8651_phyRegConfig(PORT2_PHY_CONTROL, regStoragePtr[15][i++] | RESTART_AUTONEGO);
	_rtl8651_phyRegConfig(PORT3_PHY_AUTONEGO_ADVERTISEMENT, regStoragePtr[15][i++]);
	_rtl8651_phyRegConfig(PORT3_PHY_CONTROL, regStoragePtr[15][i++] | RESTART_AUTONEGO);
	_rtl8651_phyRegConfig(PORT4_PHY_AUTONEGO_ADVERTISEMENT, regStoragePtr[15][i++]);
	_rtl8651_phyRegConfig(PORT4_PHY_CONTROL, regStoragePtr[15][i++] | RESTART_AUTONEGO);
	for(j=SYSTEM_BASE; j<= SWTMCR; j+=4)
		WRITE_MEM32(j, regStoragePtr[15][i++]);
	for(j=MISC_BASE; j<= PBVR6E; j+=4)
		WRITE_MEM32(j, regStoragePtr[15][i++]);

	
	WRITE_MEM32(BISTCR, READ_MEM32(BISTCR) | 0x2);
	for(i=0; i<16; i++)
		if(mbufStorage[i])
			mBuf_freeMbufChain(mbufStorage[i]);
	
	return SUCCESS;
}
#endif



#define RTL865X_ASIC_DRIVER_SYSTEM_INIT_API
#if 0
static void _rtl8651_clearSpecifiedAsicTable(uint32 type, uint32 count) {
	rtl8651_tblAsic_aclTable_t entry;
	uint32 idx;
	
	bzero(&entry, sizeof(entry));
	for (idx=0; idx<count; idx++)
		_rtl8651_forceAddAsicEntry(type, idx, &entry);

}
#endif



