#include "rtl_types.h"
#include "types.h"
#include "rtl_cle.h" 
#include "rtl8651_layer2local.h"
#include "rtl8651_tblAsicDrv.h"
#include <linux/string.h>

#define PHY_SPEED_DUPLEX 	5
static int8 _phySpeedDuplex[PHY_SPEED_DUPLEX][5]={
	"100f", "100h", "10f", "10h", "an"
};

static int32	_rtl8651_phyCmd(uint32 userId,  int32 argc,int8 **saved){
	int32 size, result;
	int8 *nextToken;
	uint32 i, port;
	
	cle_getNextCmdToken(&nextToken,&size,saved); 
	if(size == 0)
		port = RTL8651_PORT_NUMBER;
	else
		port=U32_value(nextToken);
	
	cle_getNextCmdToken(&nextToken,&size,saved); 
	if(!strcmp(nextToken, "an")) {
		if(port == RTL8651_PORT_NUMBER) {
			for(i=0; i< RTL8651_PORT_NUMBER; i++)
				rtl8651_setAsicEthernetPHY( i, TRUE, RTL8651_ETHER_AUTO_100FULL, 100, TRUE);
			result = SUCCESS;
		}
		else
			result = rtl8651_setAsicEthernetPHY(port, TRUE, RTL8651_ETHER_AUTO_100FULL, 100, TRUE);
	}
	else if(!strcmp(nextToken, "100f")){
		if(port == RTL8651_PORT_NUMBER) {
			for(i=0; i< RTL8651_PORT_NUMBER; i++)
				rtl8651_setAsicEthernetPHY( i, FALSE, RTL8651_ETHER_AUTO_100FULL, 100, TRUE);
			result = SUCCESS;
		}
		else
			result = rtl8651_setAsicEthernetPHY(port, FALSE, RTL8651_ETHER_AUTO_100FULL, 100, TRUE);
	}
	else if(!strcmp(nextToken, "100h")){
		if(port == RTL8651_PORT_NUMBER) {
			for(i=0; i< RTL8651_PORT_NUMBER; i++)
				rtl8651_setAsicEthernetPHY( i, FALSE, RTL8651_ETHER_AUTO_100FULL, 100, FALSE);
			result = SUCCESS;
		}
		else
			result = rtl8651_setAsicEthernetPHY(port, FALSE, RTL8651_ETHER_AUTO_100FULL, 100, FALSE);
	}
	else if(!strcmp(nextToken, "10f")){
		if(port == RTL8651_PORT_NUMBER) {
			for(i=0; i< RTL8651_PORT_NUMBER; i++)
				rtl8651_setAsicEthernetPHY( i, FALSE, RTL8651_ETHER_AUTO_100FULL, 10, TRUE);
			result = SUCCESS;
		}
		else
			result = rtl8651_setAsicEthernetPHY(port, FALSE, RTL8651_ETHER_AUTO_100FULL, 10, TRUE);
	}
	else {
		if(port == RTL8651_PORT_NUMBER) {
			for(i=0; i< RTL8651_PORT_NUMBER; i++)
				rtl8651_setAsicEthernetPHY( i, FALSE, RTL8651_ETHER_AUTO_100FULL, 10, FALSE);
			result = SUCCESS;
		}
		else
			result = rtl8651_setAsicEthernetPHY(port, FALSE, RTL8651_ETHER_AUTO_100FULL, 10, FALSE);
	}
	return result;
}


static  int32 _checkPhySpeedDuplexState(void **token, int8 *input, int32 size, cle_exec_t **nextCmd){
	int32 i,numsize =cle_checkDynCmdParam_String(token, input, size, nextCmd);
	if(numsize)
		return FAILED;
	for(i=0;i < PHY_SPEED_DUPLEX;i++)
		if(strcmp(input, _phySpeedDuplex[i])==0)
			break;
	if(i==PHY_SPEED_DUPLEX)
		return FAILED;
	 *((int32 *) *((memaddr *)token))=i;
	return 4;

}

static int32 _enumPhySpeedDuplexState(int32 entries, struct enumList *list){
	int32 i;

	if (list && entries < PHY_SPEED_DUPLEX)
		return FAILED; 
	else if(list){
		for(i=0; i < PHY_SPEED_DUPLEX; i++){
			list[i].tokenName =(int8 *)_phySpeedDuplex[i];
			list[i].helpString= "";
		}
	}
	return PHY_SPEED_DUPLEX;
}

static cle_paramType_t _tblAsicDrvPhySpeedDuplexCheckFunc[] ={
	{"%phySpeedDuplexState", 4, _checkPhySpeedDuplexState, 	_enumPhySpeedDuplexState,	"Physical layer speed and duplex state"},
};


cle_exec_t rtl8651_tblAsicDrv_cmds[] = {

	{	"phy",
		"Configure physical ports",
		"{ %d'port number' | all'All ports' } { 100f | 100h | 10f | 10h | an }",
		_rtl8651_phyCmd,
		CLE_USECISCOCMDPARSER,	
		sizeof(_tblAsicDrvPhySpeedDuplexCheckFunc)/sizeof(cle_paramType_t),
		(cle_paramType_t *)&_tblAsicDrvPhySpeedDuplexCheckFunc
	},
};


