# 1 "src/lx4180/lx4180.S"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "src/lx4180/lx4180.S"
# 43 "src/lx4180/lx4180.S"
# current interrupt priority level
        .extern _currIlev

        .text






        .globl lx4180_ReadStatus
        .ent lx4180_ReadStatus
lx4180_ReadStatus:
        mfc0 $2,$12
        jr $31
        .end lx4180_ReadStatus
# 69 "src/lx4180/lx4180.S"
        .globl lx4180_WriteStatus
        .ent lx4180_WriteStatus
lx4180_WriteStatus:
        .globl writeStatus
# .aent writeStatus
writeStatus:
        mfc0 $2,$12
        mtc0 $4,$12
        jr $31
        .end lx4180_WriteStatus
# 88 "src/lx4180/lx4180.S"
        .globl lx4180_ReadCause
        .ent lx4180_ReadCause
lx4180_ReadCause:
        mfc0 $2,$13
        jr $31
        .end lx4180_ReadCause
# 103 "src/lx4180/lx4180.S"
        .globl lx4180_WriteCause
        .ent lx4180_WriteCause
lx4180_WriteCause:
        mtc0 $4,$13
        jr $31
        .end lx4180_WriteCause
# 118 "src/lx4180/lx4180.S"
        .globl lx4180_ReadEPC
        .ent lx4180_ReadEPC
lx4180_ReadEPC:
        mfc0 $2,$14
        jr $31
        .end lx4180_ReadEPC
# 133 "src/lx4180/lx4180.S"
        .globl lx4180_WriteCCTL
        .ent lx4180_WriteCCTL
lx4180_WriteCCTL:
        mtc0 $4,$20
        jr $31
        .end lx4180_WriteCCTL
# 152 "src/lx4180/lx4180.S"
        .globl setIlev
        .ent setIlev
setIlev:
        b TCT_Control_Interrupts
        nop
        .end setIlev

# alternative name to support nucleus
        .globl TCT_Control_Interrupts
        .ent TCT_Control_Interrupts
TCT_Control_Interrupts:

        .set noreorder
        # mask all interrupts
        mfc0 $8,$12
        nop
        la $9,0xffff00ff
        and $10,$8,$9
        mtc0 $10,$12
        nop
        nop

        lw $2,_currIlev # pickup the previous value

        # calculate new status register value
        la $8,0xff00
        sll $8,$8,$4
        andi $8,$8,0xff00
        or $8,$8,$10

        sw $4,_currIlev # change to new value

        # write into status register
        mtc0 $8,$12
        nop
        nop
        jr $31
        nop
        .set reorder

        .end TCT_Control_Interrupts
# 204 "src/lx4180/lx4180.S"
        .globl getIlev
        .ent getIlev
getIlev:
        lw $2,_currIlev # pickup the previous value
        nop
        nop
        jr $31
        nop
        .end getIlev

#if 1
# 222 "src/lx4180/lx4180.S"
        .text
        .globl _saveContext
        .ent _saveContext
_saveContext:
        .set noreorder
        .set noat

        addiu $26,$29,-128 # allocate stack
                                                                                                # two more words for gp,sp to support gdb
        sw $1,4($26) # backup at
        .set at
        sw $2,8($26) # backup v0,v1
        sw $3,12($26)
        sw $4,16($26) # backup a0~a3
        sw $5,20($26)
        sw $6,24($26)
        sw $7,28($26)
        sw $8,32($26) # backup t0~t7
        sw $9,36($26)
        sw $10,40($26)
        sw $11,44($26)
        sw $12,48($26)
        sw $13,52($26)
        sw $14,56($26)
        sw $15,60($26)
        sw $16,64($26) # backup s0~s7 for stub read
        sw $17,68($26)
        sw $18,72($26)
        sw $19,76($26)
        sw $20,80($26)
        sw $21,84($26)
        sw $22,88($26)
        sw $23,92($26)
        sw $24,96($26) # backup t8,t9
        sw $25,100($26)
        #skip k0,k1
        #skip gp
        #skip sp
        sw $30,104($26) # backup s8
        sw $27,108($26) # backup ra which is moved to k1 in vector

        mfc0 $8,$12 # load status
        nop
        nop
        mfc0 $9,$14 # load EPC
        nop
        nop
        sw $8,112($26) # backup status
        sw $9,116($26) # backup EPC

        # save gp & sp to support gdb
        sw $28,120($26)
        sw $29,124($26)
        # setup context base for gdb to read registers
        sw $26,pExceptionContext

        j $31 # return
        move $29,$26

        .set reorder
        .end _saveContext
# 292 "src/lx4180/lx4180.S"
        .text
        .globl _restoreContext
        .ent _restoreContext
_restoreContext:
        .set noreorder
        .set noat

        move $26,$29
        lw $1,4($26) # restore at
        lw $2,8($26) # restore v0,v1
        lw $3,12($26)
        lw $4,16($26) # restore a0~a3
        lw $5,20($26)
        lw $6,24($26)
        lw $7,28($26)
        lw $8,32($26) # restore t0~t7
        lw $9,36($26)
        lw $10,40($26)
        lw $11,44($26)
        lw $12,48($26)
        lw $13,52($26)
        lw $14,56($26)
        lw $15,60($26)
        lw $16,64($26) # restore s0~s7 for stub write
        lw $17,68($26)
        lw $18,72($26)
        lw $19,76($26)
        lw $20,80($26)
        lw $21,84($26)
        lw $22,88($26)
        lw $23,92($26)
        lw $24,96($26) # restore t8,t9
        lw $25,100($26)
        # skip k0,k1
        # skip gp
        # skip sp
        lw $30,104($26) # restore s8

        lw $27,112($26) # restore status
        # restore gp & sp to support gdb
        lw $28,120($26)
        lw $29,124($26)
        mtc0 $27,$12 # write status
        nop
        nop

        lw $27,108($26) # restore ra

        j $31
        lw $26,116($26) # fetch saved EPC

        .set at
        .set reorder
        .end _restoreContext
#endif
