# 1 "src/lx4180/vectors.S"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "src/lx4180/vectors.S"
# 46 "src/lx4180/vectors.S"


#include "../stub/include/pkgconf/system.h"
#include "../stub/include/pkgconf/hal.h"
#include "../stub/include/hal/arch.inc"
#include "../stub/eregdef.h"
#include <linux/autoconf.h>

#define WDTCNR	0xbd01203c
#define TCCNR	0xbd012030
#define GIMR	0xbd012000
###define		ADD_BP_GDB_STUB_SERVICE	0xBE000120


        .globl _rstvector
        .globl _ram_int_vector
        .globl _rom_int_vector
        .extern _start
        .extern _saveContext
        .extern genexcpt_handler
        .extern _restoreContext
# 73 "src/lx4180/vectors.S"
        .section ".rstvector", "ax"
# .text
        .ent _rstvector
_rstvector:
        j _start
        nop
        j _start
        nop
        j _start
        nop
        j _start
        nop
        j _start
        nop
        j _start
        nop
        j _start
        nop
        j _start
        nop
        j _start
        nop
        j _start
        nop
        .end _rstvector

        #--- General exception handler for RAM, offset 80
        #.align 7 #force next address to multiple of 0x80
        .set noreorder
        .set noat
        .section ".ram_int_vector", "ax"
        .ent _ram_int_vector
_ram_int_vector:
#if 0
        move $27,$31 # backup ra
        la $26,_saveContext
        jal $26
        nop
        la $26,genexcpt_handler
        jal $26
        nop
        la $26,_restoreContext
        jal $26
        nop
        move $31,$27 # restore ra
        j $26 # return from exception
        rfe
#endif
#ifdef	CONFIG_RTL865X_LOADER_SUPPORT_GDB_STUB
		mfc0	k0,C0_CAUSE
		nop
		andi	k0, CAUSE_EXCMASK
		sub		k0, EXC_BP
		bnez	k0, _not_handled	# if not "break", jump to _not_handled
		nop


		/*is "break", jump to exception handler*/
		#la		k0, ADD_BP_GDB_STUB_SERVICE
		la		k0, 0x81700200
		jr		k0
#		j	__default_exception_vsr
		nop
		#.globl  _not_handled

_not_handled:
#endif
		move $27,$31 # backup ra
        la $26,_saveContext
        jal $26
        nop
        la $26,genexcpt_handler
        jal $26
        nop

        la $26,_restoreContext
        jal $26
        nop
        move $31,$27 # restore ra
        j $26 # return from exception
        rfe
		nop
		nop
		nop
		nop
		nop
		nop
		.set at
        .set reorder
        .end _ram_int_vector




        #.align 8 #force next address to multiple of 0x100
        #nop


        #--- General exception handler for ROM, offset 180
        .align 7 #force next address to multiple of 0x80
        .section ".rom_int_vector", "ax"
        .ent _rom_int_vector
_rom_int_vector:
        la $26, _gen_exception_rom
        jr $26
        .end _rom_int_vector



#ifdef	CONFIG_RTL865X_LOADER_SUPPORT_GDB_STUB

	.section ".exception_vector", "ax"
	.set	noreorder
	.globl	exception_vsr
	.ent	exception_vsr
exception_vsr:
	#j		__default_exception_vsr
	la	k0, __default_exception_vsr
	jr	k0
	nop
	nop
	.end	exception_vsr
	.set	reorder


	.section ".text","ax"
	.set	noreorder

FUNC_START(__default_exception_vsr)


		#############################################
		##	First of all
		##	stop interrupt watchdog and timer
		#############################################
		.set	noat
		addi	sp,sp,-mips_exception_decrement
		
	#	la		k0, GIMR
	#	lw		k1, 0(k0)
	#	#nop
	#	sw		k1, mipsreg_gimr(sp)
	#	sw		$0, 0(k0)
		
		la		k0, WDTCNR	#WatchDog Control Register
		lw		k1, 0(k0)
		nop
		sw		k1,mipsreg_wdtcnr(sp)
		la		k0,0x00ffffff
		and		k1,k1,k0
		la		k0,0xA5000000
		or		k1,k1,k0
		la		k0, WDTCNR
		sw		k1,0(k0)

#if 1

		la		k0, TCCNR	#Timer/counter Control Register
		lw	k1, 0(k0)
		nop
		sw	k1, mipsreg_tccnr(sp)
	#	and	k1,k1,0xA0000000
	#	beqz k1,1f
	#	nop
	#	lw	k1, mipsreg_tccnr(sp)
	#	and k1, 0x5fffffff
		sw	$0, 0(k0)
1:	
#endif	
		addi	sp,sp,mips_exception_decrement
		#############################################
		##	k0 = address of _saveContext
		##	k1 = ra
		#############################################
		mfc0	k0, $14
		move	k1,sp					# K0 = original SP
		addi	sp,sp,-mips_exception_decrement
		#ori     k0,$0,9*4           # RTNUM_HAL_VECTOR_BREAKPOINT
		nop
		nop
		nop
		sw		k0,mipsreg_vector(sp)	# store vector
		
		/* store General Purpose Registers	*/

		#if (CROSS_COMPILER == COMPILER_GNU_GCC)
/*	sgpr	0,sp		#--	S0		 --> zero		*/
	sgpr	1,sp		/*	$1		 --> at			*/
	sgpr	2,sp		/*	$2, $3   --> v0, v1		*/
	sgpr	3,sp
	sgpr	4,sp		/*	$4 - $7  --> a0 - a3	*/
	sgpr	5,sp
	sgpr	6,sp
	sgpr	7,sp
	sgpr	8,sp		/*	$8 - $15 --> t0 - t7	*/
	sgpr	9,sp
	sgpr	10,sp
	sgpr	11,sp
	sgpr	12,sp
	sgpr	13,sp
	sgpr	14,sp
	sgpr	15,sp
	sgpr	16,sp		/*	$16 - $23--> s0 - s7	*/
	sgpr	17,sp
	sgpr	18,sp
	sgpr	19,sp
	sgpr	20,sp
	sgpr	21,sp
	sgpr	22,sp
	sgpr	23,sp
	sgpr	24,sp		/*	$24, $25 --> t8, t9		*/
	sgpr	25,sp
/*	sgpr	26,sp		# == K0	*/
/*	sgpr	27,sp		# == K1	*/
	sgpr	28,sp		/*  $28		 --> GP			*/
/*	sgpr	29,sp		# == SP	*/
	sgpr	30,sp		/*	$30		 --> FP			*/
	sgpr	31,sp		/*	$31		 --> RA			*/
#endif	/* END of (CROSS_COMPILER == COMPILER_GNU_GCC)	*/

#if (CROSS_COMPILER == COMPILER_GREEN_HILLS)
/*	sgpr	$0,0,sp		#--	S0		 --> zero		*/
	sgpr	$1,1,sp		/*	$1		 --> at			*/
	sgpr	$2,2,sp		/*	$2, $3   --> v0, v1		*/
	sgpr	$3,3,sp
	sgpr	$4,4,sp		/*	$4 - $7  --> a0 - a3	*/
	sgpr	$5,5,sp
	sgpr	$6,6,sp
	sgpr	$7,7,sp
	sgpr	$8,8,sp		/*	$8 - $15 --> t0 - t7	*/
	sgpr	$9,9,sp
	sgpr	$10,10,sp
	sgpr	$11,11,sp
	sgpr	$12,12,sp
	sgpr	$13,13,sp
	sgpr	$14,14,sp
	sgpr	$15,15,sp
	sgpr	$16,16,sp	/*	$16 - $23--> s0 - s7	*/
	sgpr	$17,17,sp	
	sgpr	$18,18,sp
	sgpr	$19,19,sp
	sgpr	$20,20,sp
	sgpr	$21,21,sp
	sgpr	$22,22,sp
	sgpr	$23,23,sp
	sgpr	$24,24,sp	/*	$24, $25 --> t8, t9		*/
	sgpr	$25,25,sp
/*	sgpr	$26,26,sp	#--	$26, $27 --> k0, k1		*/
/*	sgpr	$27,27,sp								*/
	sgpr	$28,28,sp	/*	$28		 --> gp			*/
/*	sgpr	$29,29,sp	#--	$29		 --> sp			*/
	sgpr	$30,30,sp	/*	$30		 --> s8/fp		*/
	sgpr	$31,31,sp	/*	$31		 --> ra			*/
#endif	/* END of (CROSS_COMPILER == COMPILER_GREEN_HILLS)

	.set at

#ifndef	ROS_HAL_MIPS_4180
	mfhi	a0
	mflo	a1
	shi		a0,sp
	slo		a1,sp
#endif

	/* K1 contains original SP	*/
	ssp		k1,sp				# store in reg dump	
	
	/* save remaining machine state registers	*/
	mfc0	t0,cause
	mfc0	t1,status
/*	mfc0	t2,cachectrl	*/
	mvafc0	t3,badvr
/*	mfc0	t4,config		*/
	mfc0	t5,prid
	mvafc0	t6,epc
	
	sw		t0,mipsreg_cause(sp)
	lui		t0,0xffff
	addiu		t0,t0,0x03ff
	and		t1,t1,t0
	sw		t1,mipsreg_sr(sp)
/*	sw		t2,mipsreg_cachectrl(sp)	*/
	sva		t3,mipsreg_badvr(sp)
/*	sw		t4,mipsreg_config(sp)		*/
	sw		t5,mipsreg_prid(sp)


	sva		t6,mipsreg_pc(sp)

	hal_fpu_save sp				/* Lx4180 doesn't have a FPU, nothing to do here	*/

#if   LX5280_PATCH                              /*Guevara add this to support LX5280 at 20031029*/
      mflxc0    t0,$0       
      mflxc0    t1,$1
      mflxc0    t2,$2
      mfru      t3,$0
      mfru      t4,$1
      mfru      t5,$2

      sw     t0,mipsreg_estatus(sp)
      sw     t1,mipsreg_ecause(sp)
      sw     t2,mipsreg_intvec(sp)
      sw     t3,mipsreg_cbs0(sp)
      sw     t4,mipsreg_cbs1(sp)
      sw     t5,mipsreg_cbs2(sp)

      mfru   t0,$4
      mfru   t1,$5
      mfru   t2,$6
      mfru   t3,$16
      mfru   t4,$17
      mfru   t5,$18
      mfru   t6,$24

      sw    t0,mipsreg_cbe0(sp)
      sw    t1,mipsreg_cbe1(sp)
      sw    t2,mipsreg_cbe2(sp)
      sw    t3,mipsreg_lps0(sp)
      sw    t4,mipsreg_lpe0(sp)
      sw    t5,mipsreg_lpc0(sp)
      sw    t6,mipsreg_mmd(sp)

      mfa   t0,$1
	  mfa   t1,$1,8
	  mfa   t2,$2
	  mfa   t3,$2,8
	  sw    t0,mipsreg_m0ll(sp)
	  srl   t4,t1,24
	  sw    t4,mipsreg_m0lh(sp)
          sw    t2,mipsreg_m0hl(sp)
	  srl   t4,t3,24
	  sw    t4,mipsreg_m0hh(sp)

	  mfa   t0,$5
	  mfa   t1,$5,8
	  mfa   t2,$6
	  mfa   t3,$6,8
	  sw    t0,mipsreg_m1ll(sp)
	  srl   t4,t1,24
	  sw    t4,mipsreg_m1lh(sp)
          sw    t2,mipsreg_m1hl(sp)
	  srl   t4,t3,24
	  sw    t4,mipsreg_m1hh(sp)

	  mfa   t0,$9
	  mfa   t1,$9,8
	  mfa   t2,$10
	  mfa   t3,$10,8
	  sw    t0,mipsreg_m2ll(sp)
	  srl   t4,t1,24
	  sw    t4,mipsreg_m2lh(sp)
          sw    t2,mipsreg_m2hl(sp)
	  srl   t4,t3,24
	  sw    t4,mipsreg_m2hh(sp)

	  mfa   t0,$13
	  mfa   t1,$13,8
	  mfa   t2,$14
	  mfa   t3,$14,8
	  sw    t0,mipsreg_m3ll(sp)
	  srl   t4,t1,24
	  sw    t4,mipsreg_m3lh(sp)
          sw    t2,mipsreg_m3hl(sp)
	  srl   t4,t3,24
	  sw    t4,mipsreg_m3hh(sp)
      
#endif

	/* The machine state is now all saved on the stack.	*/

	hal_diag_excpt_start		# nothing to do here
	
	/* Load Global Pointer register.	*/
	la		gp,_gp
	
	move	s0,sp				# save pointer to saved state

	addi	sp,sp,-mips_stack_frame_size	# make a null frame

	hal_cpu_except_enable		# reenable exceptions, in this case, disable the interrupts
//	hal_cpu_int_enable			# enable interrupts

	.extern	rt_hal_exception_handler
	jal		rt_hal_exception_handler		# call C code
	move	a0,s0				# arg0 = register dump (delay slot)

	/* All done, restore CPU state and continue	*/
	
	addi	sp,sp,mips_stack_frame_size	# retrieve CPU state ptr
	
	/* Disable interrupts again while we restore state.	*/
	hal_cpu_int_disable
	hal_diag_restore		# do nothing here
	hal_fpu_load sp			# do nothing here

#ifndef	ROS_HAL_MIPS_4180
/*	lw		t0,mipsreg_cachectrl(sp)	*/
	lhi		t1,sp
	llo		t2,sp

/*	mtc0	t0,cachectrl	*/
	mthi	t1
	mtlo	t2
#endif


#if   LX5280_PATCH                              /*Guevara add this to support LX5280 at 20031029*/
      lw     t0,mipsreg_estatus(sp)
  /*    lw     t1,mipsreg_ecause(sp)      */
      lw     t2,mipsreg_intvec(sp)
      lw     t3,mipsreg_cbs0(sp)
      lw     t4,mipsreg_cbs1(sp)
      lw     t5,mipsreg_cbs2(sp)

      mtlxc0    t0,$0       
  /*   mtlxc0    t1,$1                    */
      mtlxc0    t2,$2
      mtru      t3,$0
      mtru      t4,$1
      mtru      t5,$2

      lw    t0,mipsreg_cbe0(sp)
      lw    t1,mipsreg_cbe1(sp)
      lw    t2,mipsreg_cbe2(sp)
      lw    t3,mipsreg_lps0(sp)
      lw    t4,mipsreg_lpe0(sp)
      lw    t5,mipsreg_lpc0(sp)
      lw    t6,mipsreg_mmd(sp)   
      
      mtru   t0,$4
      mtru   t1,$5
      mtru   t2,$6
      mtru   t3,$16
      mtru   t4,$17
      mtru   t5,$18
      mtru   t6,$24

      lw    t0,mipsreg_m0ll(sp)
      lw    t1,mipsreg_m0lh(sp)
      lw    t2,mipsreg_m0hl(sp)
      lw    t3,mipsreg_m0hh(sp)
	  mta2  t0,$1
	  sll   t4,t1,24
	  mta2.g t4,$1
	  mta2  t2,$2
	  sll   t4,t3,24
	  mta2.g t4,$2

	  lw    t0,mipsreg_m1ll(sp)
      lw    t1,mipsreg_m1lh(sp)
      lw    t2,mipsreg_m1hl(sp)
      lw    t3,mipsreg_m1hh(sp)
	  mta2  t0,$5
	  sll   t4,t1,24
	  mta2.g t4,$5
	  mta2  t2,$6
	  sll   t4,t3,24
	  mta2.g t4,$6

      lw    t0,mipsreg_m2ll(sp)
      lw    t1,mipsreg_m2lh(sp)
      lw    t2,mipsreg_m2hl(sp)
      lw    t3,mipsreg_m2hh(sp)
	  mta2  t0,$9
	  sll   t4,t1,24
	  mta2.g t4,$9
	  mta2  t2,$10
	  sll   t4,t3,24
	  mta2.g t4,$10

      lw    t0,mipsreg_m3ll(sp)
      lw    t1,mipsreg_m3lh(sp)
      lw    t2,mipsreg_m3hl(sp)
      lw    t3,mipsreg_m3hh(sp)
	  mta2  t0,$13
	  sll   t4,t1,24
	  mta2.g t4,$13
	  mta2  t2,$14
	  sll   t4,t3,24
	  mta2.g t4,$14
#endif

	/* load GPRs	*/
	.set	noat
#if (CROSS_COMPILER == COMPILER_GNU_GCC)
/*	lgpr	0,sp	*/
	lgpr	1,sp
	lgpr	2,sp
	lgpr	3,sp
	lgpr	4,sp
	lgpr	5,sp
	lgpr	6,sp
	lgpr	7,sp
	lgpr	8,sp
	lgpr	9,sp
	lgpr	10,sp
	lgpr	11,sp
	lgpr	12,sp
	lgpr	13,sp
	lgpr	14,sp
	lgpr	15,sp
	lgpr	16,sp
	lgpr	17,sp
	lgpr	18,sp
	lgpr	19,sp
	lgpr	20,sp
	lgpr	21,sp
	lgpr	22,sp
	lgpr	23,sp
	lgpr	24,sp
	lgpr	25,sp
/*	lgpr	26,sp	# == K0	*/
/*	lgpr	27,sp	# == K1	*/
	lgpr	28,sp	# == GP
/*	lgpr	29,sp	# == SP	*/
	lgpr	30,sp	# == FP
	lgpr	31,sp	# == RA
#endif	/* END of (CROSS_COMPILER == COMPILER_GNU_GCC)	*/

#if (CROSS_COMPILER == COMPILER_GREEN_HILLS)
/*	lgpr	$0,0,sp	*/
	lgpr	$1,1,sp
	lgpr	$2,2,sp
	lgpr	$3,3,sp
	lgpr	$4,4,sp
	lgpr	$5,5,sp
	lgpr	$6,6,sp
	lgpr	$7,7,sp
	lgpr	$8,8,sp
	lgpr	$9,9,sp
	lgpr	$10,10,sp
	lgpr	$11,11,sp

	lgpr	$12,12,sp
	lgpr	$13,13,sp
	lgpr	$14,14,sp
	lgpr	$15,15,sp
	lgpr	$16,16,sp
	lgpr	$17,17,sp
	lgpr	$18,18,sp
	lgpr	$19,19,sp
	lgpr	$20,20,sp
	lgpr	$21,21,sp
	lgpr	$22,22,sp
	lgpr	$23,23,sp
	lgpr	$24,24,sp
	lgpr	$25,25,sp
/*	lgpr	$26,26,sp	# == K0	*/
/*	lgpr	$27,27,sp	# == K1	*/
	lgpr	$28,28,sp	# == GP
/*	lgpr	$29,29,sp	# == SP	*/
	lgpr	$30,30,sp	# == FP
	lgpr	$31,31,sp	# == RA
#endif	/* END of (CROSS_COMPILER == COMPILER_GREEN_HILLS)	*/
	#.set	at

#if 1
	#############################################
	##	
	##	enable timer/counter
	#############################################
#	lw	k1, mipsreg_tccnr(sp)
#	and	k1,k1,0xA0000000
#	beqz k1,1f
#	nop

	la	k0, TCCNR
	lw	k1, mipsreg_tccnr(sp)
	sw	k1, 0(k0)
#1:

#endif
	#############################################
	##	
	##	enable watchdog timer and interrupt
	#############################################
	
	la	k0, WDTCNR
	lw  k1,mipsreg_wdtcnr(sp)
	sw	k1,0(k0)


	#la	k0, GIMR
	#lw	k1, mipsreg_gimr(sp)
	#sw	k1,0(k0)


#1:
/* 	lva		k0,mipsreg_pc(sp)			# K0 = return PC	*/
/* 	lw		k1,mipsreg_sr(sp)			# K1 = saved SR		*/
	/*
	## Some ISRs do nothing but masking the corresponding interrupt mask bit in
	## Status register, and let the DSRs do all the right stuff. In case the
	## scheduler is locked while the interrupt occurred, the DSR will not be run
	## until the scheduler is unlocked. In such case, if we restore the Status
	## register here, then the interrupt will get unmasked again but its corresponding
	## pending bit is still set since the interrupt is not acknowledged yet. The
	## interrupt will be triggered again. The DSR will get no chance to run to
	## stop (acknowledge) the interrupt, and the ISR runs repeatedly forever.
	*/


	lva		k1, mipsreg_sr(sp)		# K1 = saved SR
	li		k0, 0xffff00ff
	and		k1, k1, k0
	mfc0	k0, status
	nop
	andi	k0, 0xff00

	or		k1, k1, k0			# We need to change code here for ROS on LX4180, Bryan...
#if 0
        /*Guevara add this to support profiler,it enable cop 3 */
	lui    k0,0x8000
	or     k1,k1,k0
	mtc0   k1,status
	nop
	lw     k0,0xa8(k0)
	nop
	ctc3   k0,$0
#endif
	/*Guevara add above code  to support profiler  */
	lva		k0, mipsreg_pc(sp)		# K0 = return PC
	lsp		sp,sp					# load SP

	/* Invoke CPU specific mechanism for returning from this exception	*/
	
	hal_cpu_eret k0,k1				# restore status register and return back to interrupted code

FUNC_END(__default_exception_vsr)
	.set	at



































	.globl	____hal_disable_interrupts
____hal_disable_interrupts:
	mfc0   $4,$12
	nop
	move	$5,$4
	and    $5,$5,0XFFFFFFFE
	mtc0   $5,$12
	and		$4,$4,0x1
	nop
	jr		$31
	lw		$31,20($29)
	

	.globl	____hal_disable_interrupt
____hal_disable_interrupt:
	mfc0   $4,$12
	nop
	and    $4,$4,0XFFFFFFFE
	mtc0   $4,$12
	nop
	nop
	jr		$31
	nop

	
	.globl	____hal_enable_interrupts
____hal_enable_interrupts:
	mfc0   $4,$12
	nop
	or     $4,$4,1
	mtc0   $4,$12
	nop
	nop
	jr		$31
	nop


	.globl	____hal_restore_interrupts
____hal_restore_interrupts:
	mfc0	$5,$12
	and		$4,$4,0x1
	and		$5,$5,0XFFFFFFFE
	or		$5,$5,$4
	mtc0	$5,$12
	nop
	jr	$31
	lw		$31,20($29)



	.globl	____hal_query_interrupts
____hal_query_interrupts:
	mfc0	$4,$12
	and		$4,$4,0x1
	jr		$31
	nop

	

	.globl	____hal_cache_invalidate_all
____hal_cache_invalidate_all:
	.set	noreorder
	mtc0	$0,	$20
	nop
	nop
	nop
	mtc0	$4,	$20
	nop
	nop
	nop
	mtc0	$0,	$20
	nop
	nop
	.set	reorder
	jr		$31
	lw		$31,20($29)

	

	.globl	____hal_interrup_mask
____hal_interrup_mask:
	mfc0   $5,$12
	la     $4,0x00000400
	sllv   $4,$4,$6
	nor    $4,$4,$0
	and    $5,$5,$4
	mtc0   $3,$12
	nop
	nop
	jr	$31
	nop



	
	.globl	____hal_interrup_unmask
____hal_interrup_unmask:
	mfc0   $5,$12
	la     $4,0x00000400
	sllv   $4,$4,$6
	or	   $5,$5,$4
	mtc0   $3,$12
	nop
	nop
	jr	$31
	nop



	.globl	____hal_interrup_acknowledge
____hal_interrup_acknowledge:
	mfc0   $5,$13
	la     $4,0x00000400
	sllv   $4,$4,$6
	nor    $4,$4,$0
	and    $5,$5,$4
	mtc0   $3,$12
	nop
	nop
	jr	$31
	nop
	

#endif

