#ifndef RTONCE_HAL_PLF_INTR_H
#define RTONCE_HAL_PLF_INTR_H

//==========================================================================
//
//      plf_intr.h
//
//      RTL8601 Interrupt and clock support
//
//==========================================================================


/*
#include	<include\pkgconf\hal.h>

#include	<include\kernel\ktypes.h>
#include	<include\infra\rt_type.h>
*/

#include	"../pkgconf/hal.h"
#include	"../kernel/ktypes.h"
#include	"../infra/rt_type.h"

/*--------------------------------------------------------------------------*
 *			Global Interrupt Controller registers (GICR) of RTL8601			*
 *--------------------------------------------------------------------------*/
#define	RTL8601_GICR_BASE				0xbd010000

#define	GIMR_REG						0x00	// Global interrupt mask register
#define	GISR_REG						0x04	// Global interrupt status register
#define	IRR_REG							0x08	// Interrupt routing register

#define	TIMER_INT_ENABLE				0x001	// Enable timer/counter interrupts
#define	UART_INT_ENABLE					0x008	// Enable UART interrupt
#define	GPIO_PORTB_INT_ENABLE			0x080	// Enable GPIO port B interrupt
#define LBC_TIMEOUT_INT_ENABLE			0x100	// Enable LBC time-out interrupt

#define TIMER_INT_PENDING_FLAG			0x001	// Timers/counters interrupt pending flag
#define	UART_INT_PENDING_FLAG			0x008	// UART interrupt pending flag
#define	GPIO_INT_PENDING_FLAG			0x080	// GPIO portB interrupt pending flag
#define	LBC_TIMEOUT_INT_PENDING_FLAG	0x100	// LBC time-out interrupt pending flag


// IRQ0 and IRQ1 are reserved for SWI. IRQ1 and IRQ7 are reserved for system usage.
// The users can only use IRQ3, IRQ4, IRQ5 and IRQ6 in his/her application program.
#define	TIMER_INT_ROUTE_MODE1			0x0000	// Timers/counters interrupt route to IRQ3
#define	TIMER_INT_ROUTE_MODE2			0x0001	// Timers/counters interrupt route to IRQ4
#define	TIMER_INT_ROUTE_MODE3			0x0002	// Timers/counters interrupt route to IRQ5
#define	TIMER_INT_ROUTE_MODE4			0x0003	// Timers/counters interrupt route to IRQ6

#define	UART_INT_ROUTE_MODE1			0x0000	// UART interrupt route to IRQ3
#define	UART_INT_ROUTE_MODE2			0x0004	// UART interrupt route to IRQ4
#define	UART_INT_ROUTE_MODE3			0x0008	// UART interrupt route to IRQ5
#define	UART_INT_ROUTE_MODE4			0x000C	// UART interrupt route to IRQ6

#define	GPIO_INT_ROUTE_MODE1			0x0000	// GPIO interrupt route to IRQ3
#define	GPIO_INT_ROUTE_MODE2			0x4000	// GPIO interrupt route to IRQ4
#define	GPIO_INT_ROUTE_MODE3			0x8000	// GPIO interrupt route to IRQ5
#define	GPIO_INT_ROUTE_MODE4			0xC000	// GPIO interrupt route to IRQ6


//---------------------------------------------------------------------------------
//	Timer/counter relative registers of RTL8601
//---------------------------------------------------------------------------------
#define	TIMER_COUNTER_BASE				0xbd010050

#define	TIMER_CONTROL_REG				0x00	// Timer/Counter Control Register address
#define	TIMER_INTERRUPT_REG				0x04	// Timer/Counter Interrupt Control Register address
#define	TIMER_WATCHDOG_CONTROL_REG		0x0C	// Watchdog Timer Control Register address
#define	TIMER_TC0_DATA_REG				0x10	// Timer 0 Data Register address
#define	TIMER_TC0_COUNT_REG				0x20	// Timer 0 Count Register address
#define	TIMER_TC1_DATA_REG				0x14	// Timer 1 Data Register address
#define	TIMER_TC1_COUNT_REG				0x24	// Timer 1 Count Register address
#define	TIMER_TC2_DATA_REG				0x18	// Timer 2 Data Register address
#define	TIMER_TC2_COUNT_REG				0x28	// Timer 2 Count Register address
#define	TIMER_TC3_DATA_REG				0x1C	// Timer 3 Data Register address
#define	TIMER_TC3_COUNT_REG				0x2C	// Timer 3 Count Register address

#define	TIMER_TC0_CTR_MODE0				0x03	// Mode0 set timer0 to operate in timer mode
#define	TIMER_TC0_CTR_MODE1				0x01	// Mode1 set timer0 to operate in counter mode

#define	TIMER_TC0_INT_ENABLE			0x01	// Timer/counter0 interrupt enable
#define	TIMER_TC0_INT_ACK				0x11	// Acknowledge the timer/counter0 interrupt


//---------------------------------------------------------------------------------
//	IRQ number to vector number mapping of RTL8601
//---------------------------------------------------------------------------------
#define	HAL_IRQ2_VECTOR_NUM				0
#define	HAL_IRQ3_VECTOR_NUM				1
#define	HAL_IRQ4_VECTOR_NUM				2
#define	HAL_IRQ5_VECTOR_NUM				3
#define	HAL_IRQ6_VECTOR_NUM				4
#define	HAL_IRQ7_VECTOR_NUM				5



// UART interrupt number
//
#define RTNUM_HAL_INTERRUPT_DUART	RTNUM_HAL_INTERRUPT_2
#define RTHWR_HAL_GDB_PORT_VECTOR	RTNUM_HAL_INTERRUPT_DUART

//--------------------------------------------------------------------------
// Control-C support.

#if defined(RTDBG_HAL_MIPS_DEBUG_GDB_CTRLC_SUPPORT)

externC rt_uint32 hal_ctrlc_isr(RT_ADDRWORD vector, RT_ADDRWORD data);

# define HAL_CTRLC_ISR hal_ctrlc_isr

#endif


//--------------------------------------------------------------------------
// Reset.
#define HAL_PLATFORM_RESET()             RT_EMPTY_STATEMENT


//--------------------------------------------------------------------------
// Function prototype for platform dependent ISR
externC	rt_uint32 ROSTickISR(rt_vector vector, RT_ADDRWORD data);



//--------------------------------------------------------------------------
#endif // ifndef RTONCE_HAL_PLF_INTR_H
// End of plf_intr.h
