#ifndef RTONCE_HAL_IMP_INTR_H
#define RTONCE_HAL_IMP_INTR_H

//==========================================================================
//
//      var_intr.h
//
//      LX4180 Interrupt and clock support
//
//==========================================================================

/*
#include <include\pkgconf\hal.h>

#include <include\infra\rt_type.h>

#include <include\hal\plf_intr.h>
*/

#include "../pkgconf/hal.h"
#include "../infra/rt_type.h"
#include "plf_intr.h"

/*
//--------------------------------------------------------------------------
// Interrupt vectors.

#ifndef RTHWR_HAL_INTERRUPT_VECTORS_DEFINED

// These are decoded via the IP bits of the cause
// register when an external interrupt is delivered.

#define RTNUM_HAL_INTERRUPT_1                0
#define RTNUM_HAL_INTERRUPT_2                1
#define RTNUM_HAL_INTERRUPT_3                2
#define RTNUM_HAL_INTERRUPT_4                3
#define RTNUM_HAL_INTERRUPT_5                4
#define RTNUM_HAL_INTERRUPT_6                5
#define RTNUM_HAL_INTERRUPT_7                6
#define RTNUM_HAL_INTERRUPT_DMAC1_CH3        7
#define RTNUM_HAL_INTERRUPT_DMAC1_CH2        8
#define RTNUM_HAL_INTERRUPT_DMAC0_CH1        9
#define RTNUM_HAL_INTERRUPT_DMAC0_CH0        10
#define RTNUM_HAL_INTERRUPT_SIO_0            11
#define RTNUM_HAL_INTERRUPT_SIO_1            12
#define RTNUM_HAL_INTERRUPT_TMR_0            13
#define RTNUM_HAL_INTERRUPT_TMR_1            14
#define RTNUM_HAL_INTERRUPT_TMR_2            15
#define RTNUM_HAL_INTERRUPT_0                16

// Min/Max ISR numbers and how many there are
#define RTNUM_HAL_ISR_MIN                     0
#define RTNUM_HAL_ISR_MAX                     16
#define RTNUM_HAL_ISR_COUNT                   17

// The vector used by the Real time clock
#define RTNUM_HAL_INTERRUPT_RTC            RTNUM_HAL_INTERRUPT_TMR_0

#define RTHWR_HAL_INTERRUPT_VECTORS_DEFINED

#endif

*/



//--------------------------------------------------------------------------
// Interrupt controller access.

/*
#ifndef RTHWR_HAL_INTERRUPT_CONTROLLER_ACCESS_DEFINED

#if defined(RTPKG_HAL_MIPS_TX3904)

#define RT_HAL_MIPS_TX3904_ILR0     0xFFFFC010
#define RT_HAL_MIPS_TX3904_CConR    0xFFFFE000

// Array which stores the configured priority levels for the configured
// interrupts.
externC volatile RT_BYTE hal_interrupt_level[RTNUM_HAL_ISR_COUNT];


#define HAL_INTERRUPT_MASK( _vector_ )                       \
{                                                            \
    HAL_IO_REGISTER _reg_ = RT_HAL_MIPS_TX3904_ILR0;        \
    RT_WORD32 _ilr_;                                        \
    _reg_ += (_vector_)&0xC;                                 \
    HAL_READ_UINT32( _reg_, _ilr_ );                         \
    _ilr_ &= ~(7 << (((_vector_)&0x3)<<3));                  \
    HAL_WRITE_UINT32( _reg_, _ilr_ );                        \
}

#define HAL_INTERRUPT_UNMASK( _vector_ )                                \
{                                                                       \
    HAL_IO_REGISTER _reg_ = RT_HAL_MIPS_TX3904_ILR0;                   \
    RT_WORD32 _ilr_;                                                   \
    _reg_ += (_vector_)&0xC;                                            \
    HAL_READ_UINT32( _reg_, _ilr_ );                                    \
    _ilr_ |= hal_interrupt_level[_vector_] << (((_vector_)&0x3)<<3);    \
    HAL_WRITE_UINT32( _reg_, _ilr_ );                                   \
}

#define HAL_INTERRUPT_ACKNOWLEDGE( _vector_ )                           \
{                                                                       \
    if( _vector_ <= RTNUM_HAL_INTERRUPT_7 ||                           \
        _vector_ == RTNUM_HAL_INTERRUPT_0 )                            \
    {                                                                   \
        rt_uint32 _v_ = _vector_ + 1;                                  \
        rt_uint8 _reg_;                                                \
                                                                        \
        // adjust vector to bit offset in CConR                         \
        if( _v_ == RTNUM_HAL_INTERRUPT_0 + 1 ) _v_ = 0;                \
                                                                        \
        // get CConR                                                    \
        HAL_READ_UINT8( RT_HAL_MIPS_TX3904_CConR+1, _reg_ );           \
                                                                        \
        // clear old value and set new //                               \
        _reg_ &= ~(7 << 5);                                             \
        _reg_ |= _v_ << 5;                                              \
        HAL_WRITE_UINT8( RT_HAL_MIPS_TX3904_CConR+1, _reg_);           \
    }                                                                   \
}

#define HAL_INTERRUPT_CONFIGURE( _vector_, _level_, _up_ )              \
{                                                                       \
    if( _vector_ <= RTNUM_HAL_INTERRUPT_7 ||                           \
        _vector_ == RTNUM_HAL_INTERRUPT_0 )                            \
    {                                                                   \
        rt_uint32 _v_ = _vector_ + 1;                                  \
        rt_uint32 _val_ = 0;                                           \
        rt_uint16 _reg_;                                               \
                                                                        \
        // adjust vector to bit offset in CConR //                      \
        if( _v_ == RTNUM_HAL_INTERRUPT_0 + 1 ) _v_ = 0;                \
        _v_ <<= 1;                                                      \
                                                                        \
        // set bits according to requirements //                        \
        if( _up_ ) _val_ |= 1;                                          \
        if( !(_level_) ) _val_ |= 2;                                    \
                                                                        \
        // get CConR //                                                 \
        HAL_READ_UINT16( RT_HAL_MIPS_TX3904_CConR+2, _reg_ );          \
                                                                        \
        // clear old value and set new //                               \
        _reg_ &= ~(3 << _v_);                                           \
        _reg_ |= _val_ << _v_;                                          \
        HAL_WRITE_UINT16( RT_HAL_MIPS_TX3904_CConR+2, _reg_ );         \
    }                                                                   \
}

#define HAL_INTERRUPT_SET_LEVEL( _vector_, _level_ )    \
{                                                       \
    HAL_IO_REGISTER _reg_ = RT_HAL_MIPS_TX3904_ILR0;   \
    RT_WORD32 _ilr_;                                   \
    _reg_ += (_vector_)&0xC;                            \
    HAL_READ_UINT32( _reg_, _ilr_ );                    \
    _ilr_ |= (_level_) << (((_vector_)&0x3)<<3);        \
    HAL_WRITE_UINT32( _reg_, _ilr_ );                   \
    hal_interrupt_level[_vector_] = _level_;            \
}

#define RTHWR_HAL_INTERRUPT_CONTROLLER_ACCESS_DEFINED

#else

#error Unspecified TX39 variant

#endif

#endif

*/



//--------------------------------------------------------------------------
// Clock control

/*
#ifndef RTHWR_HAL_CLOCK_CONTROL_DEFINED

#if defined(RTPKG_HAL_MIPS_TX3904)

#define RT_HAL_MIPS_TX3904_TIMER_BASE 0xFFFFF000
#define RT_HAL_MIPS_TX3904_TIMER_CR  (RT_HAL_MIPS_TX3904_TIMER_BASE + 0x00)
#define RT_HAL_MIPS_TX3904_TIMER_SR  (RT_HAL_MIPS_TX3904_TIMER_BASE + 0x04)
#define RT_HAL_MIPS_TX3904_TIMER_CPR (RT_HAL_MIPS_TX3904_TIMER_BASE + 0x08)
#define RT_HAL_MIPS_TX3904_TIMER_IMR (RT_HAL_MIPS_TX3904_TIMER_BASE + 0x10)
#define RT_HAL_MIPS_TX3904_TIMER_DR  (RT_HAL_MIPS_TX3904_TIMER_BASE + 0x20)
#define RT_HAL_MIPS_TX3904_TIMER_RR  (RT_HAL_MIPS_TX3904_TIMER_BASE + 0xF0)

#define HAL_CLOCK_INITIALIZE( _period_ )                             \
{                                                                    \
    HAL_WRITE_UINT32( RT_HAL_MIPS_TX3904_TIMER_DR, 0x00000003 );    \
    HAL_WRITE_UINT32( RT_HAL_MIPS_TX3904_TIMER_CPR, _period_ );     \
    HAL_WRITE_UINT32( RT_HAL_MIPS_TX3904_TIMER_SR, 0x00000000 );    \
    HAL_WRITE_UINT32( RT_HAL_MIPS_TX3904_TIMER_IMR, 0x00008001 );   \
    HAL_WRITE_UINT32( RT_HAL_MIPS_TX3904_TIMER_CR, 0x000000C0 );    \
}

#define HAL_CLOCK_RESET( _vector_, _period_ )                        \
{                                                                    \
    HAL_WRITE_UINT32( RT_HAL_MIPS_TX3904_TIMER_SR, 0x00000000 );    \
}

#if defined(RTHWR_HAL_MIPS_TX3904_TRR_REQUIRES_SYNC) && \
    !defined(RTPKG_HAL_MIPS_SIM)

// We need to sync and check the coprocessor 0 condition - this
// indicates whether data is present in the write buffer. We need to
// wait until the data to be written is flushed out. This works
// around a LX4180 bug.  gcc will insert a NOP after the asm insns.

# define HAL_CLOCK_READ( _pvalue_ )                                     \
RT_MACRO_START                                                         \
    asm volatile (                                                      \
        "sync; nop; 1: ; bc0f 1b"                                       \
        :                                                               \
        :                                                               \
        : "$0"                                                          \
        );                                                              \
     HAL_READ_UINT32( RT_HAL_MIPS_TX3904_TIMER_RR, *(_pvalue_) );      \
RT_MACRO_END

#else

# define HAL_CLOCK_READ( _pvalue_ )                                     \
RT_MACRO_START                                                         \
    HAL_READ_UINT32( RT_HAL_MIPS_TX3904_TIMER_RR, *(_pvalue_) );       \
RT_MACRO_END

#endif

#if defined(RTVAR_KERNEL_COUNTERS_CLOCK_LATENCY) && \
    !defined(HAL_CLOCK_LATENCY)
#define HAL_CLOCK_LATENCY( _pvalue_ ) HAL_CLOCK_READ(_pvalue_)
#endif

#define RTHWR_HAL_CLOCK_CONTROL_DEFINED

#else

#error Unspecified TX39 variant

#endif

#endif

*/



//--------------------------------------------------------------------------
// Timeout exception support. This is TX39 specific.

/*
#if defined(RTPKG_HAL_MIPS_TX3904)

#define HAL_TX39_DEBUG_TOE_ENABLE()                     \
{                                                       \
    HAL_IO_REGISTER _reg_ = RT_HAL_MIPS_TX3904_CConR;  \
    RT_WORD32 _cconr_;                                 \
    HAL_READ_UINT32( _reg_, _cconr_);                   \
    _cconr_ |= 0x04000000;                              \
    HAL_WRITE_UINT32( _reg_, _cconr_);                  \
}

#define HAL_TX39_DEBUG_TOE_DISABLE()                    \
{                                                       \
    HAL_IO_REGISTER _reg_ = RT_HAL_MIPS_TX3904_CConR;  \
    RT_WORD32 _cconr_;                                 \
    HAL_READ_UINT32( _reg_, _cconr_);                   \
    _cconr_ &= 0xFBFFFFFF;                              \
    HAL_WRITE_UINT32( _reg_, _cconr_);                  \
}

#else

#define HAL_TX39_DEBUG_TOE_ENABLE()

#define HAL_TX39_DEBUG_TOE_DISABLE()

#endif

*/

//--------------------------------------------------------------------------
#endif // ifndef RTONCE_HAL_IMP_INTR_H
// End of imp_intr.h
