





#include "rtl_types.h"
#include "rtl8651_config.h"
#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_multicast_local.h"
#include "rtl8651_ipQueue_local.h"
#include "rtl8651_layer2local.h"
#include "rtl8651_dos_local.h"
#include "rtl8651_dos.h"
#include "asicRegs.h"
#include "rtl8651_tblAsicDrv.h"
#ifdef CONFIG_RTL865X_ROMEPERF
#include "../romeperf.h"
#endif
#ifdef CONFIG_RTL865X_IPSEC
#include "rtl8651_ipsec_local.h"
#endif
#include "rtl8651_dns_local.h"
#include "rtl8651_dns_domainBlock_local.h"

#include "rtl8651_debug.h"



#define	_RTL8651_L4_NAT_INPUT	1
#define	_RTL8651_L4_NAT_OUTPUT	2

#define _RTL8651_NAT_PASS		0 	
#define _RTL8651_NAT_IGNORE	1	
#define _RTL8651_NAT_DROP		2   	

#define FWDENG_INTERNAL_VARIABLES




int8 rtl8651_tblDrvFwd_Id[] = "$Id: rtl8651_tblDrvFwd.c,v 1.390 2006-03-03 07:15:42 chenyl Exp $";
rtl8651_tblDrvFwdEngineCounts_t rtl8651_fwdEngineCounter;
rtl8651_fwdEngineInitPara_t rtl8651_fwdEnginePara;
int8 rtl8651_drvPacketFastSend = FALSE;			
static int8 _dropCases[FWDENG_TOTALERRS];			
static int32 (*rtl8651_pppoeInput)(struct rtl_mBuf *);	
extern  int32 *rtl8651_wanStatus;					



static int8		rtl8651_drvIcmpReplyEnable = 0;
static int8		rtl8651_PPPoEEnable = 0;	
static int8		rtl8651_drvRoutingEnable = 1;
int8 			rtl8651_drvIcmpRoutingMsgEnable = 1;	
static int8		rtl8651_drvIcmpAlwaysReplyErrForFrag = 0;	
static int8		rtl8651_DMZHostIcmpPassthroughEnable = 0;	
static int8		rtl8651_drvArpProcessEnable	= 0;	
static int8		rtl8651_drvArpProxyProcessEnable = 0;	
static int8		rtl8651_drvProcessUpnpPortBouncing = FALSE;
static int8		rtl8651_drvFwdOtherL4ToDMZEnable = FALSE;
static int8		rtl8651_drvFwdUnicastIGMPEnable = FALSE;
int8			rtl8651_drvSoftwareBroadcastEnable[RTL8651_VLANTBL_SIZE] = {FALSE}; 
static int8		rtl8651_drvEnPortBouncingPSaction = 1;	
static int8		rtl8651_drvPktDemandRouteTrigger = 1;	
static int8		rtl8651_drvProtocolStackDontTimeout = FALSE;	
static int8		rtl8651_drvProtocolStackErrMsgDontTimeout = TRUE;	

static int8		rtl8651_drvDynamicRPPolicyRoute = FALSE;	

#ifdef _RTL_NAPT_ADVANCED

static int8		rtl8651_drvInexactUdpNaptEnable = 0;	
static int8		rtl8651_drvStaticUdpNaptPortTranslation = 0;
static int8		rtl8651_drvStaticTcpNaptPortTranslation = 0;
#endif 
#ifdef _RTL_WEAK_NAPT_CTRL
static int8		rtl8651_drvWeakTcpNaptEnable = 0; 
#endif	

#ifdef CONFIG_RTL865X_MULTICAST
int8			rtl8651_drvMulticastProcessEnable = 1;	
static uint8	IP_MULTICAST_SYSTEM_ENABLE = TRUE;	
#endif 

static int8		rtl8651_drvFragmentProcessEnable = 1;	
static uint8	IP_QUEUE_SYSTEM_ENABLE = TRUE;	




#ifdef _RTL_NAPT_FRAG
#undef RTL8651_FRAGCACHE_DEBUG

static uint32 _rtl8651_max_fragCache_count = DEFAULT_MAX_FRAGPKT_NUM;
static uint32 _rtl8651_max_fragCache_age = DEFAULT_MAX_FRAGCACHE_AGE;
static struct _rtl8651_frag * _rtl8651_fragCache[RTL8651_FRAGCACHE_TYPE_COUNT];

static uint32 _rtl8651_fragCacheInit(void);
static void _rtl8651_fragCacheReinit(void);
static inline uint32 _rtl8651_getFragCache(int32 FlowType, ipaddr_t org_sip, ipaddr_t org_dip, uint16 ip_id, ipaddr_t *newIp, int8 *routeIdx, rtl8651_tblDrv_naptTcpUdpFlowEntry_t **naptEntryp, uint8* dsid);
static inline _rtl8651_frag_t *_rtl8651_getFragCacheEntry(int32 FlowType, ipaddr_t org_sip, ipaddr_t org_dip, uint16 ip_id);
static inline void _rtl8651_updateFragCache(int32 FlowType, ipaddr_t org_sip, ipaddr_t org_dip, uint16 ip_id, ipaddr_t ip_addr, int8 routeIdx, rtl8651_tblDrv_naptTcpUdpFlowEntry_t *naptEntry, uint8 dsid);
void _rtl8651_fragCache_timeUpdate(uint32 secPassed);
#endif 

#ifdef _RTL_QUEUE_FRAG_PKT

uint8 _rtl8651_fragQueueProcess = FALSE;
uint8 _rtl8651_fragQueueDropChain = FALSE;			
#ifdef _RTL_NAPT_REDIRECT

ipaddr_t _rtl8651_fragQueueNaptRedirect_MatchedIP = 0;
#endif 
uint8 _rtl8651_fragQueueProcessOk = FALSE;			
uint16 *_rtl8651_udpSizeThreshValue;
uint8 _rtl8651_udpBlockingEnable = FALSE;
#endif 



#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
_rtl8651_FragmentShortestPathFwdCache_t fragmentShortestPathCache[RTL8651_FRAGMENTSHORTESTPATH_TBLSIZE];

static inline void _rtl8651_fragmentShortestPathCacheSet_firstHalf(struct rtl_pktHdr *pkthdr, uint8 *l4hdr, struct ip *pip, ipaddr_t sip, ipaddr_t dip, uint32 mode, ipaddr_t aliasIp);
static inline void _rtl8651_fragmentShortestPathCache_clear(struct rtl_pktHdr *pkthdr, struct ip*pip);
static void _rtl8651_fragmentShortestPathCache_timeUpdate(uint32 passed);
static inline int32 _rtl8651_fragmentShortestPathFwd(struct rtl_pktHdr*pkthdr, struct ip *pip);
#endif	






#ifdef DRAM_FWD
__DRAM_L34_FWD static uint32 *_ageTimer[TCP_CLOSED_FLOW+1];
static uint32 *__ageTimer[TCP_CLOSED_FLOW+1] ={ 
#else
static uint32 *_ageTimer[TCP_CLOSED_FLOW+1] ={
#endif
	NULL,	
	NULL, 	
	&rtl8651GlobalControl.tcpFastTimeout, 
	&rtl8651GlobalControl.tcpFastTimeout, 
	NULL, 
	 &rtl8651GlobalControl.tcpLongTimeout, 
	 &rtl8651GlobalControl.tcpMediumTimeout, 
	 &rtl8651GlobalControl.tcpMediumTimeout, 
	 &rtl8651GlobalControl.tcpFinTimeout 
};

#ifdef DRAM_FWD
__DRAM_L34_FWD static int8  _inNextState[2][8];
static int8  __inNextState[2][8]={
#else
static int8  _inNextState[2][8]={
#endif
	
	{ TCP_INBOUND_SYN_RCVD_FLOW, TCP_ESTABLISHED_FLOW, 0, -1, 0,0,0,TCP_INBOUND_SYN_RCVD_FLOW},
	
	{ 0, TCP_INBOUND_FIN_RCVD_FLOW,TCP_INBOUND_FIN_RCVD_FLOW,-1,TCP_INBOUND_FIN_RCVD_FLOW,TCP_CLOSED_FLOW,0,0}
};

#ifdef DRAM_FWD
__DRAM_L34_FWD static int8  _outNextState[2][8];
static int8  __outNextState[2][8]={
#else
static int8  _outNextState[2][8]={
#endif
	
	{ TCP_OUTBOUND_SYN_RCVD_FLOW, 0, TCP_ESTABLISHED_FLOW, -1, 0,0,0,TCP_OUTBOUND_SYN_RCVD_FLOW},
	
	{ TCP_OUTBOUND_FIN_RCVD_FLOW, TCP_OUTBOUND_FIN_RCVD_FLOW,TCP_OUTBOUND_FIN_RCVD_FLOW,-1,TCP_OUTBOUND_FIN_RCVD_FLOW,0, TCP_CLOSED_FLOW,0}
};




#ifdef _RTL_UPNP
static struct _RTL8651_UPNP_ENTRY *upnp_tb;

static void _rtl8651_initUpnpDb(void);
static void _rtl8651_ReinitUpnpDb(void);
static inline int32 _rtl8651_findInboundUpnpMapping(	uint32 isTcp,
														ipaddr_t remote_ip, uint16 remote_port,
														ipaddr_t alias_ip, uint16 alias_port,
														ipaddr_t *local_ip, uint16 *local_port,
														uint32 *flags, uint32 *algIdx);
static inline int32 _rtl8651_findOutboundUpnpMapping(	uint32 isTcp,
														ipaddr_t IntIp, uint16 IntPort,
														ipaddr_t *ExtIp, uint16 *ExtPort,
														ipaddr_t RemoteIp, uint16 RemotePort,
														uint32 *flags, uint32 *algIdx);

static inline int32 _rtl8651_checkUsableUpnpEntry(	uint32 isTcp,
													ipaddr_t IntIp, uint32 IntPort,
													ipaddr_t ExtIp, uint32 ExtPort,
													ipaddr_t RemoteIp, uint32 RemotePort);


#endif 



#ifdef _RTL_TRIGGER_PORT

#undef TRIGGER_PORT_DEBUG


static uint32 triggerPort_entry_cnt = 0;
static _rtl8651_triggerPort_entry_t *triggerPort_entry_tbl = NULL;
static _rtl8651_triggerPort_entry_t *triggerPort_entry_freeList = NULL;
static _rtl8651_triggerPort_entry_t *triggerPort_entry_Hdr[RTL8651_MAX_DIALSESSION] = {NULL};

static uint32 triggerPort_cache_cnt = 0;
static _rtl8651_triggerPort_cache_t *triggerPort_cache_tbl = NULL;
static _rtl8651_triggerPort_cache_t *triggerPort_cache_freeList = NULL;
static _rtl8651_triggerPort_cache_t *triggerPort_cache_lruHdr = NULL;
static _rtl8651_triggerPort_cache_t *triggerPort_cache_lruTail = NULL;
#ifdef DRAM_FWD
__DRAM_L34_FWD static _rtl8651_triggerPort_cache_t *triggerPort_cache_hashTbl[RTL8651_TRIGGER_PORT_HASH_CACHE_TBLSIZE];
#else
static _rtl8651_triggerPort_cache_t *triggerPort_cache_hashTbl[RTL8651_TRIGGER_PORT_HASH_CACHE_TBLSIZE] = {NULL};
#endif
static _rtl8651_triggerPort_cache_t *triggerPort_cache_staticEntry = NULL;	

static int32 _rtl8651_TriggerPortInit(rtl8651_fwdEngineInitPara_t *para);
static void _rtl8651_TriggerPortReinit(void);

static void _rtl8651_flushNetTriggerPortRules(uint32 netIntfId);
static int32 _rtl8651_addTriggerPortRule(uint32 netIntfId, uint8 inType, uint16 inPortStart, uint16 inPortEnd, _rtl8651_triggerPort_param_t *mappingInfo);

static inline void  _rtl8651_TriggerPort_FreeCache(uint8 isStatic, _rtl8651_triggerPort_cache_t *cache);
static inline void _rtl8651_TriggerPort_FreeEntry(_rtl8651_triggerPort_entry_t *entry);

static inline _rtl8651_triggerPort_cache_t * _rtl8651_TriggerPort_getCache(void);

static inline _rtl8651_triggerPort_cache_t *_rtl8651_getTriggerPortCache(uint8 refreshAge, uint8 isTcp, uint32 netIntfId, ipaddr_t extIp, uint16 extPort);
static inline void _rtl8651_addTriggerPortCache(_rtl8651_triggerPort_entry_t *entry, ipaddr_t extIp, ipaddr_t localIpAddr);

static inline int32 _rtl8651_tryActiveTriggerPort(uint8 isTcp, uint32 netIntfId, uint16 outPort, ipaddr_t extIp, ipaddr_t localIpAddr);
static inline int32 _rtl8651_getTriggeredIpAddr(uint8 isTcp, uint32 netIntfId, ipaddr_t extIp, uint16 inPort, ipaddr_t *localIpAddrp);

static inline int32 _rtl8651_checkUsableTriggeredPortEntry(uint32 isTcp, uint32 netIntfId, ipaddr_t intIp, uint32 extPort);

static void _rtl8651_TriggerPortTimeUpdate(uint32 secPassed);

#endif




#ifdef _RTL_PORT_BOUNCING
static struct _RTL8651_PORT_BOUNCING_ENTRY *portBouncingTable;
void _rtl8651_flushPortBouncingEntry(void);
static struct _RTL8651_PORT_BOUNCING_ENTRY * _rtl8651_addPortBouncingEntry(uint8 flowType,ipaddr_t cip,uint16 cport,ipaddr_t gip,uint16 gport,ipaddr_t sip,uint16 sport, uint16 id, uint32 tcpFlag, uint16 age);
void _rtl8651_portBouncingTimeUpdate(uint32 secPassed);
static int32 _rtl8651_l34PortBouncingIcmpErrMsg(struct rtl_pktHdr *, struct ip *, struct icmp *);
static inline int32 _rtl8651_l4NaptPortBouncing(struct rtl_pktHdr*, struct ip*);
static inline int32 _rtl8651_l4NatPortBouncing(struct rtl_pktHdr*, struct ip*);
static inline uint32 _rtl8651_portBouncingTcpMonitor(struct tcphdr *, uint32 *, int8);
#endif 



int32 rtl8651_mss=1460; 
uint16 pppoe_mss[8]={1452,1452,1452,1452,1452,1452,1452,1452};



#ifdef _RTL_PS_ACTION
rtl8651_PS_Action_Entry_t *rtl8651_ProtoStackActions;

static int32 _rtl8651_doProtoStackAction(struct rtl_pktHdr *pktHdr, struct ip *iph);
static void _rtl8651_aliasProtoStackSentPkt(uint32 outbound, uint32 dsid, struct ip *ip);
static void _rtl8651_aliasProtoStackSentIcmpErr(struct ip *ip); 
static int32 _rtl8651_aliasProtoStackRecvPkt(struct rtl_pktHdr *pktHdr, uint32 fromOutbound, struct ip *ip);
static inline int32 _rtl8651_protoStackAction_filter(struct rtl_pktHdr* pktHdr, rtl8651_tblDrv_vlanTable_t *svlan, struct ip *pip);
static inline rtl8651_PS_Action_Entry_t *_rtl8651_checkProtoStackRegistedPort(uint16 port, uint8 l4proto);
#endif 



#ifdef DRAM_FWD
__DRAM_L34_FWD static uint8 _RTL8651_PROC[_RTL8651_HOST_MAX][_RTL8651_HOST_MAX];
static uint8 __RTL8651_PROC[_RTL8651_HOST_MAX][_RTL8651_HOST_MAX] = {
#else
static uint8 _RTL8651_PROC[_RTL8651_HOST_MAX][_RTL8651_HOST_MAX] = {
#endif

	{ _RTL8651_DEC_RT_NPNP,	_RTL8651_DEC_RT_NPN,	_RTL8651_DEC_RT_NPL,	_RTL8651_DEC_NPT,	_RTL8651_DEC_NPTBC_NP,	_RTL8651_DEC_NTBC_NP},
	{ _RTL8651_DEC_RT_NNP,	_RTL8651_DEC_RT_NN,		_RTL8651_DEC_RT_NL,		_RTL8651_DEC_NT,	_RTL8651_DEC_NPTBC_N,	_RTL8651_DEC_NTBC_N},
	{ _RTL8651_DEC_RT_LNP,	_RTL8651_DEC_RT_LN,		_RTL8651_DEC_RT_LL,		_RTL8651_DEC_RT_LR,	_RTL8651_DEC_NPTBC_L,	_RTL8651_DEC_NTBC_L},
	{_RTL8651_DEC_DP,		_RTL8651_DEC_DP,		_RTL8651_DEC_RT_RL,		_RTL8651_DEC_RT_RR,	_RTL8651_DEC_NPTR,		_RTL8651_DEC_NTR},
	{_RTL8651_DEC_DP,		_RTL8651_DEC_DP,		_RTL8651_DEC_DP,		_RTL8651_DEC_DP,	_RTL8651_DEC_DP,		_RTL8651_DEC_DP},
	{_RTL8651_DEC_DP,		_RTL8651_DEC_DP,		_RTL8651_DEC_DP,		_RTL8651_DEC_DP,	_RTL8651_DEC_DP,		_RTL8651_DEC_DP}
};




#ifdef DRAM_FWD
__DRAM_L34_FWD static uint8 _RTL8651_ADDITIONAL_PROC[_RTL8651_DEC_MAX];
static uint8 __RTL8651_ADDITIONAL_PROC[_RTL8651_DEC_MAX] = {0};
#else
static uint8 _RTL8651_ADDITIONAL_PROC[_RTL8651_DEC_MAX] = {0};
#endif

static void _rtl8651_l34AdditionalExec_init(void);
static inline int32 _rtl8651_l34AddtionalExec(int32 decision, ipaddr_t dip, void *pkt);



#ifdef _RTL_TRAPPING_DISPATCH
_rtl8651_trapping_dispatch_entry_t *rtl8651_trappingDispatchSystem_inUsed;
_rtl8651_trapping_dispatch_entry_t *rtl8651_trappingDispatchSystem_freeHdr;

_rtl8651_trapping_dispatch_cache_t rtl8651_trappingDispatchSystem_cache;

static int32 _rtl8651_trappingDispatchInit(rtl8651_fwdEngineInitPara_t *para);
static void _rtl8651_trappingDispatchReinit(void);
static _rtl8651_trapping_dispatch_entry_t *_rtl8651_findTrappingDispatchEntry(uint8 l4Proto, ipaddr_t srcIp, ipaddr_t dstIp, int32 srcPort, int32 dstPort, uint8 isExactlyMatch);
static int32 _rtl8651_registerTrappingDispatchEntry(uint8 l4Proto, ipaddr_t srcIp, ipaddr_t dstIp, int32 srcPort, int32 dstPort, uint16 category);
static void _rtl8651_removeTrappingDispatchEntry(_rtl8651_trapping_dispatch_entry_t *delEntry);
static int32 _rtl8651_unregisterTrappingDispatchEntry(uint8 l4Proto, ipaddr_t srcIp, ipaddr_t dstIp, int32 srcPort, int32 dstPort);
static uint16 _rtl8651_getTrappingDispatchCategory(struct ip * pip);

#endif 


#ifdef _RTL_TOS_REMARKING
static void _rtl8651_setDSCPDefaultAction(int8 enable, uint8 value);
static int32 _rtl8651_DSCPRemark_init(rtl8651_fwdEngineInitPara_t *para);
static void  _rtl8651_DSCPRemark(struct rtl_pktHdr * pkthdrPtr, struct ip *ip, ipaddr_t sip, ipaddr_t dip, uint8 dsid, rtl8651_tblDrv_vlanTable_t *pVlan);

static int8 rtl8651_diffServEnable = FALSE;
static int8 rtl8651_drvDSCPDefaultRemark = FALSE;
static uint8 rtl8651_drvDSCPDefaultRemarkValue = 0;
#endif



#ifdef _RTL8651_FWDENG_RETURN_STATISTIC
#define TOTAL_RETURNVALUE	(FWDENG_TOTALERRS + 3)
uint8 rtl8651_returnValue[TOTAL_RETURNVALUE];	
void _rtl8651_fwdEngineRetValueStatisticInit(void);
void _rtl8651_fwdEngineRetValueStatisticReset(void);
void _rtl8651_fwdEngineRetValueStatisticUpdate(int32);
int32 _rtl8651_fwdEngineRetValueStaticDump(void);
#endif 


static _rtl8651_pppoeActiveSession_entry_t * pppoeActiveSessionHead, * pppoeFreeActiveSession;
int8 rtl8651_drvPppoeNotExistedSessionTerminationEnable		= FALSE;		
void _rtl8651_freeAllPppoeActiveSession(void);
void _rtl8651_updatePppoeActiveSession(uint16 pppoeSessionId);
void _rtl8651_terminatePppoeActiveSession(uint16 pppoeSessionId);
int32 inline _rtl8651_pppoeSessionActive(uint16 pppoeSessionId);
uint16 * _rtl8651_getNextPppoeActiveSession(uint16 *curPppoeSessionId, uint16 * nextPppoeSessionId);



static inline int32 _rtl8651_l4SeqDiff(uint32 x, uint32 y);
static int32 _rtl8651_l4GetDeltaAckIn(struct ip * pip, struct tcphdr *tc, rtl8651_tblDrv_naptTcpUdpFlowEntry_t* tb);



static int32 _rtl8651_pktAccessGateway (ipaddr_t srcIpAddr, ipaddr_t dstIpAddr, uint16 vid);
static int32 _rtl8651_l2Relay(struct rtl_mBuf *arpMbufPtr);
static int32 _rtl8651_drvArpAgent(struct rtl_pktHdr *pkthdrPtr, struct rtl_mBuf *mbufPtr, uint16 vid);
static int32 _rtl8651_l3ActRouting(struct rtl_pktHdr * pkthdrPtr, ipaddr_t dst_ip, struct ip *ip);

static inline void _rtl8651_l34Decision(struct rtl_pktHdr *pkthdr, rtl8651_tblDrv_vlanTable_t *vlanp, uint32 *decision_p, uint32 *srcType_p, uint32 *dstType_p, uint32 *optLayer_p);
static inline int32 _rtl8651_l34PacketProcess(struct rtl_pktHdr *pkthdr, struct ip *pip, uint32 decision);
static inline int32 _rtl8651_l34ActExec(struct rtl_pktHdr *, struct ip* ,uint8, int32);
static inline int32 _rtl8651_l4napt_process(struct rtl_pktHdr *,struct ip  *ip, uint8, int32);
static inline int32 _rtl8651_l4nat_in_process(struct rtl_pktHdr *, struct ip*);
static inline int32 _rtl8651_l4nat_out_process(struct rtl_pktHdr *, struct ip*);

#ifdef _RTL_NAPT_SHORT_CUT			
static inline int32 _rtl8651_l4TcpFastAliasOut(struct rtl_pktHdr *, struct ip *pip);
static inline int32 _rtl8651_l4TcpFastAliasIn(struct rtl_pktHdr *, struct ip *pip);
static inline int32 _rtl8651_l4UdpFastAliasIn(struct rtl_pktHdr *, struct ip *pip);
static inline int32 _rtl8651_l4UdpFastAliasOut(struct rtl_pktHdr *, struct ip *pip);
#endif 

static int8 _rtl8651_l4CheckOccupiedConnection(uint32 isTcp, uint32 dsid, ipaddr_t IntIp, uint16 IntPort, ipaddr_t ExtIp, uint16 ExtPort, ipaddr_t RemoteIp, uint16 RemotePort);
static int32 _rtl8651_inboundL4DMZForward(struct rtl_pktHdr *phdr, struct ip *ip, ipaddr_t dip);
static int32 _rtl8651_outboundL4DMZForward(struct rtl_pktHdr * phdr, struct ip * ip, ipaddr_t sip);
static inline int32 _rtl8651_l4TcpMonitorIn(struct tcphdr *, rtl8651_tblDrv_naptTcpUdpFlowEntry_t *);
static inline int32 _rtl8651_l4TcpMonitorOut(struct tcphdr *, rtl8651_tblDrv_naptTcpUdpFlowEntry_t *);
static inline int32 _rtl8651_l4IcmpNaptAliasIn1(struct rtl_pktHdr *, struct ip *,struct icmp *ic);
static inline int32 _rtl8651_l4IcmpNaptAliasIn2(struct rtl_pktHdr *, struct ip *,struct icmp *ic);
static inline int32 _rtl8651_l4IcmpNaptAliasIn3(struct rtl_pktHdr *, struct ip *,struct icmp *ic);
static inline int32 _rtl8651_L4IcmpNaptAliasIn(struct rtl_pktHdr *, struct ip *);
static inline int32 _rtl8651_l4IcmpNaptAliasOut1(struct rtl_pktHdr *, struct ip *,struct icmp *);
static inline int32 _rtl8651_l4IcmpNaptAliasOut2(struct rtl_pktHdr *, struct ip *,struct icmp *);
static inline int32 _rtl8651_l4IcmpNaptAliasOut3(struct rtl_pktHdr *, struct ip *,struct icmp *);
static inline int32 _rtl8651_l4IcmpNaptAliasOut(struct rtl_pktHdr *, struct ip *);
static inline int32 _rtl8651_l4UdpNaptAliasOut(struct rtl_pktHdr *, struct ip *);
static inline int32 _rtl8651_l4UdpNaptAliasIn(struct rtl_pktHdr *, struct ip *);
static inline int32 _rtl8651_l4TcpNaptAliasOut(struct rtl_pktHdr *, struct ip *);
static inline int32 _rtl8651_l4TcpNaptAliasIn(struct rtl_pktHdr *, struct ip *);
static inline int32 _rtl8651_drvIcmpAgent(struct rtl_pktHdr *,struct ip*, uint16);
static inline int32 _rtl8651_drvIcmp(struct rtl_pktHdr *, struct ip*, struct icmp *, uint16);
static inline int32 _rtl8651_l4NaptFlowGetDSID (uint8 fromInternal, struct rtl_pktHdr *pkthdr, struct ip *pip);

static inline int32 _rtl8651_drvPktDemandRouteTrigger(struct ip *pip);

static inline int32 _rtl8651_l4UdpNatAlgAliasOut(struct rtl_pktHdr *, struct ip *, rtl8651_tblDrv_natEntry_t *);
static inline int32 _rtl8651_l4UdpNatAlgAliasIn(struct rtl_pktHdr *, struct ip *, rtl8651_tblDrv_natEntry_t *);
static inline int32 _rtl8651_l4TcpNatAlgAliasOut(struct rtl_pktHdr *, struct ip *, rtl8651_tblDrv_natEntry_t *);
static inline int32 _rtl8651_l4TcpNatAlgAliasIn(struct rtl_pktHdr *, struct ip *, rtl8651_tblDrv_natEntry_t *);
static int32 _rtl8651_uPnPOneSecondTimer(void);
static int32 _rtl8651_queuePacketSecondTimer(void);


static int32 _rtl8651_fwdEngineProtocolStackSend(void * pkthdr, int16 dvid, int32 iphdrOffset, int32 highPriority);
static void _rtl8651_fwdEnginePsFlowCacheCreate(struct ip *iphdr);



#ifdef _RTL_QUEUE_ARP_PACKET
struct _RTL8651_QUEUE_PACKET_ENTRY *queue_packet_tb;

static int32 _rtl8651_protoStackActionInit(rtl8651_fwdEngineInitPara_t *para);
static int32 _rtl8651_queueInit(void);
static int32 _rtl8651_queueReinit(void);
static int32 _rtl8651_enQueuePacket(struct rtl_pktHdr * , struct ip*, ipaddr_t, uint8 );
static int32 _rtl8651_queuePacketSecondTimer(void);
static struct rtl_pktHdr *  _rtl8651_queryQuenePacket(struct ip*, uint8, uint32 *, struct ip** );
#endif 



extern rtl8651_loggingFuncPtr_t _pUserLoggingFunc;
extern uint32 *_loggingModule;
#ifdef RTL8651_DSID_SUPPORT
extern uint8 *_rtl8651_acl_drop_nolog;
#endif




int32 (*rtl8651_l4GreNaptAliasIn)(struct rtl_pktHdr *, struct ip *);
int32 (*rtl8651_l4GreNaptAliasOut)(struct rtl_pktHdr *, struct ip *);

int32 (*rtl8651_l4EspNaptAliasIn)(struct rtl_pktHdr *, struct ip *);
int32 (*rtl8651_l4EspNaptAliasOut)(struct rtl_pktHdr *, struct ip *);

int32 (*rtl8651_l4RsvpNaptAliasIn)(struct rtl_pktHdr *, struct ip *);
int32 (*rtl8651_l4RsvpNaptAliasOut)(struct rtl_pktHdr *, struct ip *);




#ifdef _RTL_NAPT_REDIRECT

static _rtl8651_naptRedirectEntry_t *_rtl8651_naptRedirectEntry_inuse = NULL;
static _rtl8651_naptRedirectEntry_t *_rtl8651_naptRedirectEntry_freelist = NULL;

static _rtl8651_naptRedirectFlow_t *_rtl8651_naptRedirectFlowCache_lru_head = NULL;
static _rtl8651_naptRedirectFlow_t *_rtl8651_naptRedirectFlowCache_lru_tail = NULL;
static _rtl8651_naptRedirectFlow_t *_rtl8651_naptRedirectFlowCache_freelist = NULL;

static int32 _rtl8651_naptRedirectInit(rtl8651_fwdEngineInitPara_t *para);
static void _rtl8651_naptRedirectReinit(void);
static inline int32 _rtl8651_findNaptRedirectEntry(uint8 isTcp, ipaddr_t sip, uint16 sport, ipaddr_t dip, uint16 dport, ipaddr_t *pNewDip, uint16 *pNewDport, uint8 createCache, uint16 vlanIdx);
static _rtl8651_naptRedirectEntry_t *_rtl8651_findExistNaptRedirectEntry(uint8 isExceptionList, uint8 isTcp, ipaddr_t sip, uint16 sport, ipaddr_t originalDip, uint16 originalDport);
static inline _rtl8651_naptRedirectFlow_t *_rtl8651_findNaptRedirectFlow(uint8 isTcp, ipaddr_t sip, uint16 sport, ipaddr_t originalDip, uint16 originalDport, ipaddr_t newDip, uint16 newDport, uint8 isExternalQuery, uint8 refresh);
static inline int32 _rtl8651_addNaptRedirectFlow(uint8 isTcp, ipaddr_t sip, uint16 sport, ipaddr_t originalDip, uint16 originalDport, ipaddr_t newDip, uint16 newDport);
static void _rtl8651_naptRedirectFlowTimeUpdate(uint32 secPassed);
static int32 _rtl8651_resolveProxyInboundFlow(rtl8651_tblDrv_vlanTable_t * dvlan, struct ip * pip);
static inline int32 _rtl8651_queryRedirectOutboundNaptFlow(uint8 isTcp, ipaddr_t sip, uint16 sport, ipaddr_t *pOriginalDip, uint16 *pOriginalDport, ipaddr_t newDip, uint16 newDport);

#endif 



#ifdef _RTL_PPTPL2TP_HDR_REFILL
_rtl8651_pptpHdrCacheEntry_t	*_rtl8651_pptpHdrCache_hashTbl[RTL8651_PPTPHDR_CACHE_HASH_TBLSIZE] = {NULL};
_rtl8651_pptpHdrCacheEntry_t	*_rtl8651_pptpHdrCache_lru_head = NULL;
_rtl8651_pptpHdrCacheEntry_t	*_rtl8651_pptpHdrCache_lru_tail = NULL;
_rtl8651_pptpHdrCacheEntry_t	*_rtl8651_pptpHdrCache_unused = NULL;

static int32 _rtl8651_pptpHdrCacheInit(rtl8651_fwdEngineInitPara_t *para);
static void _rtl8651_pptpHdrCacheReinit(void);
static void _rtl8651_pptpHdrCache_Del(_rtl8651_pptpHdrCacheEntry_t* ptr);
static inline int32 _rtl8651_pptpHdrCache_Find(uint16 ip_id, uint16 ip_off, uint32 *pSeq, uint32 *pAck, uint8 *pType);
static inline int32 _rtl8651_refillHeader(int32 result, struct rtl_pktHdr *pkthdr, struct ip*pip, rtl8651_tblDrv_vlanTable_t *svlan, uint16 srcPortList);
#endif 

#define FWDENG_EXTERNAL_FUNCTIONS




static int32 _rtl8651_initFwdEngineParam(rtl8651_fwdEngineInitPara_t *configPara)
{

	memset(&rtl8651_fwdEnginePara, 0, sizeof(rtl8651_fwdEngineInitPara_t));

	{
		
		rtl8651_fwdEnginePara.MaxFragPktCnt =
			(configPara && configPara->MaxFragPktCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxFragPktCnt:RTL8651_DefaultDrvMaxFragPktCnt;
		rtl8651_fwdEnginePara.MaxFragSubPktCnt =
			(configPara && configPara->MaxFragSubPktCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxFragSubPktCnt:RTL8651_DefaultDrvMaxFragSubPktCnt;
		rtl8651_fwdEnginePara.MaxNegativeListEntryCnt =
			(configPara && configPara->MaxNegativeListEntryCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxNegativeListEntryCnt:RTL8651_DefaultDrvMaxNegativeListCnt;
		rtl8651_fwdEnginePara.MaxPositiveListEntryCnt =
			(configPara && configPara->MaxPositiveListEntryCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxPositiveListEntryCnt:RTL8651_DefaultDrvMaxPositiveListCnt;
		rtl8651_fwdEnginePara.MaxFragPoolCnt =
			(configPara && configPara->MaxFragPoolCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxFragPoolCnt:RTL8651_DefaultDrvMaxFragPoolCnt;
		rtl8651_fwdEnginePara.MaxFragTimeOut =
			(configPara && configPara->MaxFragTimeOut != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxFragTimeOut:RTL8651_DefaultDrvMaxFragTimeOut;
		rtl8651_fwdEnginePara.MaxNegativeListTimeOut =
			(configPara && configPara->MaxNegativeListTimeOut != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxNegativeListTimeOut:RTL8651_DefaultDrvMaxNegativeListTimeOut;

		
		rtl8651_fwdEnginePara.MCastDefaultVersion =
			(configPara && configPara->MCastDefaultVersion != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MCastDefaultVersion:RTL8651_MCAST_IGMP_MAX_VERSION;
		rtl8651_fwdEnginePara.MCastProcessOption =
			(configPara && configPara->MCastProcessOption != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MCastProcessOption:RTL8651_MCAST_PROCOPT_DEFAULT;
		rtl8651_fwdEnginePara.MaxMCastCnt =
			(configPara && configPara->MaxMCastCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxMCastCnt:RTL8651_DefaultDrvMaxMCastCnt;
		rtl8651_fwdEnginePara.MaxMCastMemberCnt =
			(configPara && configPara->MaxMCastMemberCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxMCastMemberCnt:RTL8651_DefaultDrvMaxMCastMemberCnt;
		rtl8651_fwdEnginePara.MaxMCastTotalMemberCnt	 =
			(configPara && configPara->MaxMCastTotalMemberCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxMCastTotalMemberCnt:RTL8651_DefaultDrvMaxTotalMemberCnt;
		rtl8651_fwdEnginePara.MaxMCastTotalSourceCnt =
			(configPara && configPara->MaxMCastTotalSourceCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MaxMCastTotalSourceCnt:RTL8651_DefaultDrvMaxTotalSourceCnt;
		rtl8651_fwdEnginePara.MCastMember_ExpireTime =
			(configPara && configPara->MCastMember_ExpireTime != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MCastMember_ExpireTime:RTL8651_DefaultDrvMcastMemberTimeout;
		rtl8651_fwdEnginePara.MCastUpstream_Timeout =
			(configPara && configPara->MCastUpstream_Timeout != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MCastUpstream_Timeout:RTL8651_DefaultDrvMCastUpstreamTimeout;
		rtl8651_fwdEnginePara.MCastFilterEntryCnt =
			(configPara && configPara->MCastFilterEntryCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->MCastFilterEntryCnt:RTL8651_DefaultDrvMaxMCastFilterEntryCnt;
		rtl8651_fwdEnginePara.igmp_qi =
			(configPara && configPara->igmp_qi != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_qi:RTL8651_IGMP_QI;
		rtl8651_fwdEnginePara.igmp_qri =
			(configPara && configPara->igmp_qri != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_qri:RTL8651_IGMP_QRI;
		rtl8651_fwdEnginePara.igmp_oqpi =
			(configPara && configPara->igmp_oqpi != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_oqpi:RTL8651_IGMP_OQPI;
		rtl8651_fwdEnginePara.igmp_sqc =
			(configPara && configPara->igmp_sqc != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_sqc:RTL8651_IGMP_SQC;
		rtl8651_fwdEnginePara.igmp_sqi =
			(configPara && configPara->igmp_sqi != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_sqi:RTL8651_IGMP_SQI;
		rtl8651_fwdEnginePara.igmp_lmqc =
			(configPara && configPara->igmp_lmqc != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_lmqc:RTL8651_IGMP_LMQC;
		rtl8651_fwdEnginePara.igmp_lmqi =
			(configPara && configPara->igmp_lmqi != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_lmqi:RTL8651_IGMP_LMQI;
		rtl8651_fwdEnginePara.igmp_gmi =
			(configPara && configPara->igmp_gmi != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_gmi:RTL8651_IGMP_GMI;
		rtl8651_fwdEnginePara.igmp_group_query_interval =
			(configPara && configPara->igmp_group_query_interval != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_group_query_interval:RTL8651_IGMP_GROUP_QUERY_INTERVAL;
		rtl8651_fwdEnginePara.igmp_response_tolerance_delay =
			(configPara && configPara->igmp_response_tolerance_delay != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->igmp_response_tolerance_delay:RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY;

		
		rtl8651_fwdEnginePara.dos_SynFlood_trackCnt =
			(configPara && configPara->dos_SynFlood_trackCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dos_SynFlood_trackCnt:RTL8651_DOS_SYN_TRACKCNT;
		rtl8651_fwdEnginePara.dos_StealthFin_trackCnt =
			(configPara && configPara->dos_StealthFin_trackCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dos_StealthFin_trackCnt:RTL8651_DOS_FIN_TRACKCNT;
		rtl8651_fwdEnginePara.dos_UdpFlood_trackCnt =
			(configPara && configPara->dos_UdpFlood_trackCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dos_UdpFlood_trackCnt:RTL8651_DOS_UDP_TRACKCNT;
		rtl8651_fwdEnginePara.dos_IcmpFlood_trackCnt =
			(configPara && configPara->dos_IcmpFlood_trackCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dos_IcmpFlood_trackCnt:RTL8651_DOS_ICMP_TRACKCNT;
		rtl8651_fwdEnginePara.dos_total_trackCnt =
			(configPara && configPara->dos_total_trackCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dos_total_trackCnt:RTL8651_DOS_TOTAL_TRACKCNT;
		rtl8651_fwdEnginePara.dos_total_portScan_trackCnt =
			(configPara && configPara->dos_total_portScan_trackCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dos_total_portScan_trackCnt:RTL8651_DOS_SCAN_TOTAL_TRACKCNT;
		rtl8651_fwdEnginePara.dos_TcpConn_trackCnt =
			(configPara && configPara->dos_TcpConn_trackCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dos_TcpConn_trackCnt:RTL8651_DOS_TCPCONN_TRACKCNT;
		rtl8651_fwdEnginePara.dos_UdpConn_trackCnt =
			(configPara && configPara->dos_UdpConn_trackCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dos_UdpConn_trackCnt:RTL8651_DOS_UDPCONN_TRACKCNT;
		rtl8651_fwdEnginePara.dos_totalConn_trackCnt =
			(configPara && configPara->dos_totalConn_trackCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dos_totalConn_trackCnt:RTL8651_DOS_TOTALCONN_TRACKCNT;


		
		rtl8651_fwdEnginePara.dosProc_sipblock_count =
			(configPara && configPara->dosProc_sipblock_count != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->dosProc_sipblock_count:RTL8651_DOSPROC_SIPBLOCK_CNT;

		
		rtl8651_fwdEnginePara.pppoeActiveSessionTrackingNumber =
			(configPara && configPara->pppoeActiveSessionTrackingNumber != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->pppoeActiveSessionTrackingNumber:4;	

		
		rtl8651_fwdEnginePara.mbufHeadroom =
			(configPara && configPara->mbufHeadroom != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->mbufHeadroom:FWDENG_MBUF_HEADROOM;

		
		rtl8651_fwdEnginePara.protoStackMaxActions =
			(configPara && configPara->protoStackMaxActions != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->protoStackMaxActions:RTL8651_MAX_PROTO_STACK_ACTIONS;

		
#ifdef _RTL_NAPT_REDIRECT
		rtl8651_fwdEnginePara.redirectTblSize =
			(configPara && configPara->redirectTblSize != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->redirectTblSize:RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE;
		rtl8651_fwdEnginePara.redirectFlowCacheSize =
			(configPara && configPara->redirectFlowCacheSize != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
			configPara->redirectFlowCacheSize:RTL8651_NAPTREDIRECT_DEFAULT_FLOWCACHESIZE;
#endif 

		
#ifdef _RTL_PPTPL2TP_HDR_REFILL
		rtl8651_fwdEnginePara.pptpHdrCacheSize =
		(configPara && configPara->pptpHdrCacheSize != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->pptpHdrCacheSize:RTL8651_PPTPHDR_CACHE_DEFAULT_ENTRYCNT;
#endif 

#ifdef _RTL_TRAPPING_DISPATCH
		rtl8651_fwdEnginePara.trappingPktDispatchTblSize =
		(configPara && configPara->trappingPktDispatchTblSize != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->trappingPktDispatchTblSize:RTL8651_TRAPPING_DISPATCH_DEFAULT_ENTRYCNT;
#endif 

		rtl8651_fwdEnginePara.dns_dnsDB_processCnt =
		(configPara && configPara->dns_dnsDB_processCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->dns_dnsDB_processCnt:RTL8651_DNSDB_DEFAULT_PROCESSCNT;
		rtl8651_fwdEnginePara.dns_dnsDB_tblSize =
		(configPara && configPara->dns_dnsDB_tblSize != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->dns_dnsDB_tblSize:RTL8651_DNSDB_DEFAULT_TABLESIZE;
		rtl8651_fwdEnginePara.dns_dnsDB_cnameMapTblSize =
		(configPara && configPara->dns_dnsDB_cnameMapTblSize != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->dns_dnsDB_cnameMapTblSize:RTL8651_DNSDB_DEFAULT_CNAMEMAPTABLESIZE;
		rtl8651_fwdEnginePara.dns_dnsDB_cnameMapTimeout =
		(configPara && configPara->dns_dnsDB_cnameMapTimeout != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->dns_dnsDB_cnameMapTimeout:RTL8651_DNSDB_DEFAULT_CNAMEMAPTIMEOUT;

		rtl8651_fwdEnginePara.domainBlock_tblSize =
		(configPara && configPara->domainBlock_tblSize != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->domainBlock_tblSize:RTL8651_DOMAINBLOCKING_DEFAULT_TABLESIZE;
		rtl8651_fwdEnginePara.domainBlock_maxBlockEntryCnt =
		(configPara && configPara->domainBlock_maxBlockEntryCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->domainBlock_maxBlockEntryCnt:RTL8651_DOMAINBLOCKING_DEFAULT_BLKENTRYCNT;
		rtl8651_fwdEnginePara.domainBlock_blockEntryTimeout =
		(configPara && configPara->domainBlock_blockEntryTimeout != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->domainBlock_blockEntryTimeout:RTL8651_DOMAINBLOCKING_DEFAULT_BLKENTRYTIMEOUT;

#ifdef _RTL_TRIGGER_PORT
		rtl8651_fwdEnginePara.triggerPortEntryCnt =
		(configPara && configPara->triggerPortEntryCnt != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->triggerPortEntryCnt:RTL8651_TRIGGER_PORT_DEFAULT_ENTRYCNT;
		rtl8651_fwdEnginePara.triggerPortCacheSize =
		(configPara && configPara->triggerPortCacheSize != RTL8651_FWDENGINE_PARA_UNDEFINED_VALUE)?
		configPara->triggerPortCacheSize:RTL8651_TRIGGER_PORT_DEFAULT_CACHESIZE;
#endif 

	}

	
	if ((!rtl8651_fwdEnginePara.MaxFragPktCnt) ||
		((!rtl8651_fwdEnginePara.MaxFragSubPktCnt) && (!rtl8651_fwdEnginePara.MaxFragPoolCnt)))
	{
		IP_QUEUE_SYSTEM_ENABLE = FALSE;
		rtl8651_drvFragmentProcessEnable = FALSE;

	}else
	{
		IP_QUEUE_SYSTEM_ENABLE = TRUE;
		rtl8651_drvFragmentProcessEnable = TRUE;
	}

#ifdef CONFIG_RTL865X_MULTICAST
	
	if ((!rtl8651_fwdEnginePara.MaxMCastCnt) ||
		((!rtl8651_fwdEnginePara.MaxMCastMemberCnt) && (!rtl8651_fwdEnginePara.MaxMCastTotalMemberCnt)) ||
		(!rtl8651_fwdEnginePara.MaxMCastTotalSourceCnt))
	{
		IP_MULTICAST_SYSTEM_ENABLE = FALSE;
		rtl8651_drvMulticastProcessEnable = FALSE;
	}else
	{
		IP_MULTICAST_SYSTEM_ENABLE = TRUE;
		rtl8651_drvMulticastProcessEnable = FALSE;	
	}
#endif 
	return SUCCESS;
}


static void _rtl8651_fwdEngineDropPktCaseReset(void)
{
	int32 trueFlag = TRUE;

	assert(sizeof(uint8)*256 >=FWDENG_TOTALERRS);

	
	memset(&_dropCases[0],0, sizeof(_dropCases));

	
	rtl8651_fwdEngineDropPktCase(FWDENG_VLANINVALID,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_VLANCFI,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_MACBLOCK,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_ACL_IN_DROP,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_ACL_OUT_DROP,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_IP_CANTQUEUEFRAGMENT,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_IP_BADCKSUM,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_ARP_OTHERS,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_NETIFACENOTFOUND,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_ICMP_BADCKSUM,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_BADCKSUM,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAPT_OUT_IGNORE,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAPT_IN_IGNORE,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAT_IN_ALGIGNORE,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAT_OUT_ALGIGNORE,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_BADCKSUM,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAPT_OUT_IGNORE,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAPT_IN_IGNORE,&trueFlag);	
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAT_OUT_ALGIGNORE,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAT_IN_ALGIGNORE,&trueFlag);
#ifndef RTL865X_TEST
	rtl8651_fwdEngineDropPktCase(FWDENG_ICMP_OUT_ADDFAIL, &trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_ICMP_IN_ADDFAIL, &trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAPT_OUT_ADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAPT_OUT_ADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAPT_IN_ADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAPT_IN_ADDFAIL,&trueFlag);

	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAPT_OUT_SVRALGADDFAIL, &trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAPT_OUT_CLIALGADDFAIL, &trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAPT_IN_ALGADDFAIL, &trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAT_OUT_SVRALGADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAT_OUT_CLIALGADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAT_IN_SVRALGADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_UDP_NAT_IN_CLIALGADDFAIL,&trueFlag);

	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAPT_OUT_SVRALGADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAPT_OUT_CLIALGADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAPT_IN_SVRALGADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAPT_IN_CLIALGADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAT_OUT_ADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_NAT_IN_ALGADDFAIL,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_DECISION_DROP,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_USER_DROP,&trueFlag);
	rtl8651_fwdEngineDropPktCase(FWDENG_TCP_URLFILTERED,&trueFlag);
#endif 

}

#ifdef DRAM_FWD
static void _rtl8651_dramInit(void)
{
	memcpy(_ageTimer, __ageTimer, sizeof(_ageTimer));
	memcpy(_inNextState, __inNextState, sizeof(_inNextState));
	memcpy(_outNextState, __outNextState, sizeof(_outNextState));
	memset(triggerPort_cache_hashTbl, 0, sizeof(triggerPort_cache_hashTbl));
	memcpy(_RTL8651_PROC, __RTL8651_PROC, sizeof(_RTL8651_PROC));
	memcpy(_RTL8651_ADDITIONAL_PROC, __RTL8651_ADDITIONAL_PROC, sizeof(_RTL8651_ADDITIONAL_PROC));
}
#endif


int32 rtl8651_fwdEngineInit(rtl8651_fwdEngineInitPara_t * configPara)
{

	rtlglue_drvMutexLock();

	FWD_INIT_CHECK(_rtl8651_initFwdEngineParam(configPara));

	#ifdef DRAM_FWD
	_rtl8651_dramInit();
	#endif

	rtl8651_resetFwdEngineCounter();

	
	

	rtl8651_installArpAgent(_rtl8651_drvArpAgent);

#ifdef _RTL_NAPT_FRAG
	_rtl8651_fragCacheInit();
#endif 		

	
	rtl8651_setNaptTcpUdpPortRange(32768,65535);
	_rtl8651_setl4NaptFindEmptyAsicRetry( 8 );
	rtl8651_enable4WayHash( TRUE );

#ifdef _RTL_UPNP	
	_rtl8651_initUpnpDb();
#endif 

#ifdef _RTL_TRIGGER_PORT
	FWD_INIT_CHECK(_rtl8651_TriggerPortInit(&rtl8651_fwdEnginePara));
#endif 

#ifdef _RTL_PORT_BOUNCING
	portBouncingTable = (struct _RTL8651_PORT_BOUNCING_ENTRY *)
				rtlglue_malloc(PORT_BOUNCING_ITEM  * sizeof (struct _RTL8651_PORT_BOUNCING_ENTRY));	
	_rtl8651_flushPortBouncingEntry();
#endif 

#ifdef _RTL_PPTPL2TP_HDR_REFILL
	_rtl8651_pptpHdrCacheInit(&rtl8651_fwdEnginePara);
#endif 

#ifdef _RTL_QUEUE_ARP_PACKET
	_rtl8651_queueInit();
#endif 

#ifdef _RTL_PS_ACTION
	_rtl8651_protoStackActionInit(&rtl8651_fwdEnginePara);
#endif

#ifdef _RTL_DOS_PLUGIN
	_rtl8651_dos_init(&rtl8651_fwdEnginePara);
#endif 

#ifdef _RTL_QUEUE_FRAG_PKT
	
	_rtl8651_IpFragQueueInit(&rtl8651_fwdEnginePara);
#endif 

#ifdef CONFIG_RTL865X_MULTICAST
	
	_rtl8651_multicastInit(&rtl8651_fwdEnginePara);
	_rtl8651_multicast_FilterInit(&rtl8651_fwdEnginePara);
#endif 
	rtl8651_fwdEngineEnableWanRouting(TRUE);

#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
	memset(fragmentShortestPathCache, 0, (sizeof(_rtl8651_FragmentShortestPathFwdCache_t)*RTL8651_FRAGMENTSHORTESTPATH_TBLSIZE));
#endif 

#ifdef _RTL_NAPT_REDIRECT
	_rtl8651_naptRedirectInit(&rtl8651_fwdEnginePara);
#endif 

#ifdef _RTL_TRAPPING_DISPATCH
	_rtl8651_trappingDispatchInit(&rtl8651_fwdEnginePara);
#endif 

#ifdef _RTL_TOS_REMARKING
	_rtl8651_DSCPRemark_init(&rtl8651_fwdEnginePara);
#endif

	_rtl8651_dns_init(&rtl8651_fwdEnginePara);
	_rtl8651_registerDomainBlock();					

	
	{
		_rtl8651_pppoeActiveSession_entry_t * tempPtr;
		uint32 cntr = rtl8651_fwdEnginePara.pppoeActiveSessionTrackingNumber;

		pppoeActiveSessionHead = pppoeFreeActiveSession = NULL;
		while(cntr--) {
			tempPtr = (_rtl8651_pppoeActiveSession_entry_t *) rtlglue_malloc(sizeof (_rtl8651_pppoeActiveSession_entry_t));
			tempPtr->next = pppoeFreeActiveSession;
			pppoeFreeActiveSession = tempPtr;
		}
		rtl8651_drvPppoeNotExistedSessionTerminationEnable = FALSE;
	}

#ifdef _RTL_WEAK_NAPT_CTRL
	
	rtl8651_drvWeakTcpNaptEnable = FALSE;
#endif

	
	_rtl8651_udpBlockingEnable = FALSE;

	
	rtl8651_drvIcmpAlwaysReplyErrForFrag = FALSE;

	
	rtl8651_drvFwdOtherL4ToDMZEnable = FALSE;

	
	rtl8651_drvFwdUnicastIGMPEnable = FALSE;

	
	rtl8651_drvProcessUpnpPortBouncing = FALSE;

	
	rtl8651_drvEnPortBouncingPSaction = TRUE;

	
	rtl8651_drvPktDemandRouteTrigger = TRUE;

	
	rtl8651_drvProtocolStackDontTimeout = FALSE;

	
	rtl8651_drvProtocolStackErrMsgDontTimeout = TRUE;

	
	rtl8651_drvDynamicRPPolicyRoute = FALSE;


	
	memset(&rtl8651_drvSoftwareBroadcastEnable, FALSE, (sizeof(int8) * RTL8651_VLAN_NUMBER));

#ifdef _RTL8651_FWDENG_RETURN_STATISTIC
	_rtl8651_fwdEngineRetValueStatisticInit();
#endif 

	
	_rtl8651_fwdEngineDropPktCaseReset();

	
	_rtl8651_l34AdditionalExec_init();

	
	_rtl8651_layer2fwd_init();

	rtlglue_drvMutexUnlock();

	return SUCCESS;
	
}


int32 rtl8651_fwdEngineReinit(void)
{

	rtlglue_drvMutexLock();

	#ifdef DRAM_FWD
	_rtl8651_dramInit();
	#endif

	rtl8651_resetFwdEngineCounter();

#ifdef _RTL_NAPT_FRAG
	_rtl8651_fragCacheReinit();
#endif 

	
	rtl8651_setNaptTcpUdpPortRange(32768,65535);
	_rtl8651_setl4NaptFindEmptyAsicRetry( 8 );
	rtl8651_enable4WayHash( TRUE );

#ifdef _RTL_UPNP	
	_rtl8651_ReinitUpnpDb();
#endif 

#ifdef _RTL_TRIGGER_PORT
	_rtl8651_TriggerPortReinit();
#endif 

#ifdef _RTL_PORT_BOUNCING
	assert(portBouncingTable);
	_rtl8651_flushPortBouncingEntry();
#endif 

#ifdef _RTL_PPTPL2TP_HDR_REFILL
	_rtl8651_pptpHdrCacheReinit();
#endif 

#ifdef _RTL_QUEUE_ARP_PACKET
	_rtl8651_queueReinit();
#endif 


#ifdef _RTL_DOS_PLUGIN
	_rtl8651_dos_Reinit();
#endif 

#ifdef _RTL_QUEUE_FRAG_PKT
	rtl8651_IpFragQueueReinit();
#endif 

#ifdef CONFIG_RTL865X_MULTICAST
	rtl8651_multicastReinit();
	rtl8651_multicast_FilterReinit();
#endif 

#ifdef _RTL_PS_ACTION
	rtl8651_flushProtoStackActions();
#endif 

#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
	memset(fragmentShortestPathCache, 0, (sizeof(_rtl8651_FragmentShortestPathFwdCache_t)*RTL8651_FRAGMENTSHORTESTPATH_TBLSIZE));
#endif 

#ifdef _RTL_NAPT_REDIRECT
	_rtl8651_naptRedirectReinit();
#endif 

#ifdef _RTL_WEAK_NAPT_CTRL
	
	rtl8651_drvWeakTcpNaptEnable = FALSE;
#endif

#ifdef _RTL_TRAPPING_DISPATCH
	_rtl8651_trappingDispatchReinit();
#endif 

#ifdef _RTL_TOS_REMARKING
	_rtl8651_DSCPRemark_init(&rtl8651_fwdEnginePara);
#endif

	_rtl8651_dns_reinit();

	
	rtl8651_algReInit();

	
	{
		_rtl8651_freeAllPppoeActiveSession();		
		rtl8651_drvPppoeNotExistedSessionTerminationEnable = FALSE;
	}

	{
		uint32 index;
		rtl8651_mss=1460; 
		for(index=0; index<8; index++)
			pppoe_mss[index] = 1452;
	}

	
	rtl8651_drvIcmpAlwaysReplyErrForFrag = FALSE;
	
	
	_rtl8651_udpBlockingEnable = FALSE;

	
	rtl8651_drvFwdOtherL4ToDMZEnable = FALSE;

	
	rtl8651_drvFwdUnicastIGMPEnable = FALSE;

	
	rtl8651_drvProcessUpnpPortBouncing = FALSE;

	
	rtl8651_drvEnPortBouncingPSaction = TRUE;

	
	rtl8651_drvPktDemandRouteTrigger = TRUE;

	
	rtl8651_drvProtocolStackDontTimeout = FALSE;

	
	rtl8651_drvProtocolStackErrMsgDontTimeout = TRUE;

	
	rtl8651_drvDynamicRPPolicyRoute = FALSE;

	
	memset(&rtl8651_drvSoftwareBroadcastEnable, FALSE, (sizeof(int8) * RTL8651_VLAN_NUMBER));

#ifdef _RTL8651_FWDENG_RETURN_STATISTIC
	_rtl8651_fwdEngineRetValueStatisticReset();
#endif 

	
	_rtl8651_fwdEngineDropPktCaseReset();

	
	_rtl8651_l34AdditionalExec_init();

	
	_rtl8651_layer2fwd_reinit();

	rtlglue_drvMutexUnlock();

	return SUCCESS;	
}


int32 rtl8651_getFwdEngineCounter(rtl8651_tblDrvFwdEngineCounts_t * counter)
{

	rtlglue_drvMutexLock();

	if (counter == NULL)
	{
		rtlglue_drvMutexUnlock();
		return FAILED;
	}
	*counter = rtl8651_fwdEngineCounter;

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_resetFwdEngineCounter(void)
{
	rtlglue_drvMutexLock();
	memset(&rtl8651_fwdEngineCounter, 0, sizeof(rtl8651_tblDrvFwdEngineCounts_t));
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEngineDropPktCase(uint32 fwdengDropCase, int32 *flag)
{

	rtlglue_drvMutexLock();

	if (fwdengDropCase>=FWDENG_TOTALERRS)
	{
		rtlglue_drvMutexUnlock();
		return FAILED;
	}
	if (!flag)
	{
		rtlglue_drvMutexUnlock();
		return _dropCases[fwdengDropCase]; 
	}

	
	_dropCases[fwdengDropCase]= (*flag)? 1: 0;

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}



int32 rtl8651_fwdEngineArp(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvArpProcessEnable = enable;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEngineIcmp(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvIcmpReplyEnable = enable;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEngineIcmpRoutingMsg(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvIcmpRoutingMsgEnable= enable;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEngineAlwaysReplyICMPErrForFragment(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvIcmpAlwaysReplyErrForFrag = enable;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEngineDMZHostIcmpPassThrough(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_DMZHostIcmpPassthroughEnable = enable;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEngineArpProxy(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvArpProxyProcessEnable = enable;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}

int32 rtl8651_fwdEngineProcessL34(int8 routingEnable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvRoutingEnable = routingEnable;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEngineProcessIPFragment(int8 enable)
{
	rtlglue_drvMutexLock();
	if (IP_QUEUE_SYSTEM_ENABLE == FALSE)	
	{
		rtl8651_drvFragmentProcessEnable = FALSE;
		rtlglue_drvMutexUnlock();
		return SUCCESS;
	}

	if (rtl8651_drvFragmentProcessEnable != enable)
	{
		rtl8651_IpFragQueueReinit();						
		rtl8651_drvFragmentProcessEnable = enable;
	}

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}

#ifdef CONFIG_RTL865X_MULTICAST

int32 rtl8651_fwdEngineProcessIPMulticast(int8 enable)
{
	rtlglue_drvMutexLock();

	if (IP_MULTICAST_SYSTEM_ENABLE == FALSE)	
	{
		rtl8651_drvMulticastProcessEnable = FALSE;

		rtlglue_drvMutexUnlock();

		return SUCCESS;
	}

	if (rtl8651_drvMulticastProcessEnable != enable)
	{
		
		rtl8651_multicastReinit();
		
		rtl8651_drvMulticastProcessEnable = enable;
		
		rtl8651_multicastPeriodicQuery(enable);
	}

	rtlglue_drvMutexUnlock();

	return SUCCESS;
}
#endif 

int32 rtl8651_fwdEnginePPPoE(int8 enable, int32 (*pppoeInput)(struct rtl_mBuf *)) {

	rtlglue_drvMutexLock();

	if (enable&&!pppoeInput)
	{
		rtlglue_drvMutexUnlock();
		return FAILED;
	}
	rtl8651_PPPoEEnable = enable;
	rtl8651_pppoeInput = pppoeInput;

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEnginePppoeNotExistedSessionTermination(int8 enable)
{
	rtlglue_drvMutexLock();

	
	if (rtl8651_drvPppoeNotExistedSessionTerminationEnable == TRUE && enable== FALSE) {
		_rtl8651_freeAllPppoeActiveSession();		
		rtl8651_drvPppoeNotExistedSessionTerminationEnable = FALSE;
	} else 
		rtl8651_drvPppoeNotExistedSessionTerminationEnable = enable;

	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEngineEnableWanRouting(int8 enable)
{
	_rtl8651_l34AdditionalExec_t param;
	uint8 newProperty;

	rtlglue_drvMutexLock();
	_rtl8651_l34AdditionalExec_getParam(_RTL8651_HOST_RP, _RTL8651_HOST_RP, &param);
	if (enable)
	{
		newProperty = (param.property &~ _RTL8651_L34ADDTIONALEXEC_BLOCK);
	} else
	{
		newProperty = (param.property | _RTL8651_L34ADDTIONALEXEC_BLOCK);
	}

	if (newProperty != param.property)
	{
		param.property = newProperty;
		_rtl8651_l34AdditionalExec_setParam(_RTL8651_HOST_RP, _RTL8651_HOST_RP, &param);
	}
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}

int32 rtl8651_fwdEngineProcessPortBouncing(int8 enable)
{
	_rtl8651_l34AdditionalExec_t param;
	uint8 newProperty;
	int32 srcIdx, dstIdx;
	uint32 src[] = {_RTL8651_HOST_NPI, _RTL8651_HOST_NI, _RTL8651_HOST_LP};
	uint32 dst[] = {_RTL8651_HOST_NPE, _RTL8651_HOST_NE};

	rtlglue_drvMutexLock();

	if (enable == FALSE)
	{
		_rtl8651_flushPortBouncingEntry();
	}

	for (srcIdx = 0 ; srcIdx < (sizeof(src) / sizeof(uint32)) ; srcIdx ++)
	for (dstIdx = 0 ; dstIdx < (sizeof(dst) / sizeof(uint32)) ; dstIdx ++)
	{
		_rtl8651_l34AdditionalExec_getParam(src[srcIdx], dst[dstIdx], &param);
		if (enable)
		{
			newProperty = (param.property &~ _RTL8651_L34ADDTIONALEXEC_BLOCK);
		} else
		{
			newProperty = (param.property | _RTL8651_L34ADDTIONALEXEC_BLOCK);
		}

		if (newProperty != param.property)
		{
			param.property = newProperty;
			_rtl8651_l34AdditionalExec_setParam(src[srcIdx], dst[dstIdx], &param);
		}
	}

	rtlglue_drvMutexUnlock();

	return SUCCESS;
}


int32 rtl8651_fwdEngineProcessUpnpPortBouncing(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvProcessUpnpPortBouncing = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}


int32 rtl8651_fwdEngineFwdGeneralL4ToDMZ(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvFwdOtherL4ToDMZEnable = enable;
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}


int32 rtl8651_fwdEngineFwdUnicastIGMPPkt(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvFwdUnicastIGMPEnable = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}


int32 rtl8651_fwdEnginePortBouncingDoProtocolStackAction(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvEnPortBouncingPSaction = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}


int32 rtl8651_fwdEngineTrapPktDemandRouteTrigger(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvPktDemandRouteTrigger = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}

#ifdef _RTL_NAPT_ADVANCED

int32 rtl8651_fwdEngineInexactUdpFlow(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvInexactUdpNaptEnable = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}
#if 0

int32 rtl8651_fwdEngineInexactTcpFlow(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvInexactTcpNaptEnable = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}
#endif

int32 rtl8651_fwdEngineUdpStaticNaptPortTranslation(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvStaticUdpNaptPortTranslation = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}

int32 rtl8651_fwdEngineTcpStaticNaptPortTranslation(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvStaticTcpNaptPortTranslation = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}
#endif 

#ifdef _RTL_WEAK_NAPT_CTRL

int32 rtl8651_fwdEngineWeakTcpNaptProcess(int8 enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvWeakTcpNaptEnable = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}
#endif	


int32 rtl8651_fwdEnginePsDontTimeout(int enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvProtocolStackDontTimeout = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}


int32 rtl8651_fwdEnginePsToWanErrMsgDontTimeout(int enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvProtocolStackErrMsgDontTimeout = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}


int32 rtl8651_fwdEngineDynamicRemoteHostPolicyRT(int enable)
{
	rtlglue_drvMutexLock();
	rtl8651_drvDynamicRPPolicyRoute = enable;
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}



int32 rtl8651_fwdEngineSend(void * pkthdr, int16 dvid, int32 iphdrOffset)
{
	int32 retval = FAILED;

	rtlglue_drvMutexLock();		

	
	retval = _rtl8651_fwdEngineProtocolStackSend(pkthdr,
												dvid,
												iphdrOffset,
												FALSE  );

	rtlglue_drvMutexUnlock();	

	return retval;
}



int32 rtl8651_fwdEngineQosSend(void *pkthdr, int16 dvid, int32 iphdrOffset, int32 qualityId)
{
	int32 retval = FAILED;

	rtlglue_drvMutexLock();		

	retval = _rtl8651_fwdEngineProtocolStackSend(pkthdr,
												dvid,
												iphdrOffset,
												qualityId?TRUE:FALSE);	

	rtlglue_drvMutexUnlock();	

	return retval;
}


static int32 _rtl8651_fwdEngineProtocolStackSend(void * pkthdr, int16 dvid, int32 iphdrOffset, int32 highPriority)
{
	int32 retval = FAILED;
	rtl8651_tblDrv_vlanTable_t *local_vlanp;
	uint32 dsid = 0, portmask = 0,l2portmask = 0; 
#ifdef RTL8651_DSID_SUPPORT	
	uint32 sip = 0;
	struct ip *iphdr = NULL;
#endif	
	struct rtl_mBuf *mbuf;
	struct rtl_pktHdr * pkthdrPtr = (struct rtl_pktHdr *)pkthdr;
	uint32 assignedPortMask = pkthdrPtr->ph_portlist;
	int32 realIphdrOffset;
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	uint8 isToWanPptpL2tpOther = FALSE;	
#endif

	mbuf=pkthdrPtr->ph_mbuf;
	pkthdrPtr->ph_vlanIdx= dvid & (RTL8651_VLAN_NUMBER-1);
	local_vlanp = &DrvTbl.vlan[pkthdrPtr->ph_vlanIdx];
	realIphdrOffset = iphdrOffset;	

	 
	pkthdrPtr->ph_rxdesc = -1;
	pkthdrPtr->ph_property = PH_PROPER_FROMPS;

	
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	{
		rtl8651_tblDrv_routeTable_t *rt_t;

		
		rt_t = DrvTbl.route + (rtl8651_tblDrvPara.routingTableSize - 1);

		if (((rt_t->valid) && (rt_t->ifrt_flag == 0)) &&
			((rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP) || (rt_t->netif_t->linkLayerType == RTL8651_LL_L2TP)))
		{	
			rtl8651_tblDrv_pppTable_t *pppEntry_t;
			pppEntry_t = rt_t->rt_nhSession_t;
			
			if (pppEntry_t && pppEntry_t->initiated && tunnel.valid && (local_vlanp->vid == tunnel.wanVid))
			{
				struct ip *outerIp;

				
				if (realIphdrOffset <= 0)
				{
					goto TO_WAN_PPTPL2TP_OTHER;
				}

				outerIp = (struct ip *)((uint32)(mbuf->m_data) + realIphdrOffset);

				if ( IS_FRAGMENT_REMAIN(outerIp->ip_off) )
				{	
					goto TO_WAN_PPTPL2TP_OTHER;
				}

				if (rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP)
				{	
					if (outerIp->ip_p == IPPROTO_GRE)
					{
						struct wan_gre_header *gre = (struct wan_gre_header*)L4HDR_ADDR(outerIp);
						uint32 l4Len = 8;
						uint32 grePayloadLen = 0;
						uint8 *ptr = (uint8 *)gre;

						assert(ntohs(outerIp->ip_len) >= 28);

						if (gre->flags & 0x10)
							l4Len += 4;
						if (gre->ver & 0x80)
							l4Len += 4;

						if ((ptr[l4Len] == 0xff) && (ptr[l4Len + 1] == 0x03))
						{	
							l4Len += 2;
							grePayloadLen += 2;
						}

						if (	((ptr[l4Len] == 0x00) && (ptr[l4Len + 1] == 0x21) ) ||
							(ptr[l4Len] == 0x21 ))
						{
							struct ip *innerIp = NULL;

							if (ptr[l4Len] == 0x21)
							{	
								l4Len += 1;
								grePayloadLen += 1;
							} else
							{	
								l4Len += 2;
								grePayloadLen += 2;
							}

							innerIp = (struct ip*)((uint32)gre + l4Len);

							
							if (	( (grePayloadLen + IPHDR_LEN(innerIp)) > ntohs(gre->payload_len) ) ||
								
								( (grePayloadLen + ntohs(innerIp->ip_len)) != ntohs(gre->payload_len) ))
							{
								goto TO_WAN_PPTPL2TP_OTHER;
							}

							if ((uint32)ntohs(outerIp->ip_len) != (ntohs(innerIp->ip_len) + ((uint32)innerIp - (uint32)outerIp)))
							{
								goto TO_WAN_PPTPL2TP_OTHER;
							}

							
							realIphdrOffset = l4Len + ((uint32)gre - (uint32)(mbuf->m_data));

							
							_rtl8651_fwdEngineTxChecksumOffload(	(struct ip *)&(mbuf->m_data[realIphdrOffset]),
																	(pkthdrPtr->ph_pkt_property & PH_PKT_PROPER_IPIP_L3CSM),
																	(pkthdrPtr->ph_pkt_property & PH_PKT_PROPER_IPIP_L4CSM)	);
							goto IPHDROFFSET_MODIFY_DONE;
						}
					}
				} else if (rt_t->netif_t->linkLayerType == RTL8651_LL_L2TP)
				{	
					if (outerIp->ip_p == IPPROTO_UDP)
					{
						struct udphdr *udp = (struct udphdr *)L4HDR_ADDR(outerIp);

						if (udp->uh_sport == htons(1701))
						{
							struct wan_l2tp_header *l2tp = (struct wan_l2tp_header*)(udp + 1);

							if (l2tp->flags_type == 0)	
							{
								uint8 *u8p_l2tp = (uint8 *)l2tp;
								struct ip *innerIp = NULL;
								uint32 l2tpPppChkLen = 6 ; 

								if (l2tp->flags_length)
								{
									l2tpPppChkLen += 2;
								}
								if (l2tp->flags_offset)
								{
									l2tpPppChkLen += 2;
								}

								if ((u8p_l2tp[l2tpPppChkLen] == 0xff) && (u8p_l2tp[l2tpPppChkLen + 1] == 0x03))
								{	
									l2tpPppChkLen += 2;
								}

								if (u8p_l2tp[l2tpPppChkLen] == 0x21)
								{	
									l2tpPppChkLen += 1;
								} else if ((u8p_l2tp[l2tpPppChkLen] == 0x00) && (u8p_l2tp[l2tpPppChkLen + 1] == 0x21))
								{	
									l2tpPppChkLen += 2;
								}
								else
									goto TO_WAN_PPTPL2TP_OTHER;

								innerIp = (struct ip*)((uint32)u8p_l2tp + l2tpPppChkLen);

								
								if (	( (l2tpPppChkLen + IPHDR_LEN(innerIp) + sizeof(struct udphdr)) > ntohs(udp->uh_ulen) ) ||
									
									( (l2tpPppChkLen + ntohs(innerIp->ip_len) + sizeof(struct udphdr)) != ntohs(udp->uh_ulen)))
								{
									goto TO_WAN_PPTPL2TP_OTHER;
								}

								if ((uint32)ntohs(outerIp->ip_len) != (ntohs(innerIp->ip_len) + ((uint32)innerIp-(uint32)outerIp)))
								{
									goto TO_WAN_PPTPL2TP_OTHER;
								}

								
								realIphdrOffset = ((uint32)innerIp - (uint32)mbuf->m_data);

								iphdr = (struct ip *)&(mbuf->m_data[realIphdrOffset]);

								
								if (pkthdrPtr->ph_pkt_property & PH_PKT_PROPER_IPIP_L3CSM) {
									uint16 org_l3cksum = iphdr->ip_sum;		
									iphdr->ip_sum = 0;
									iphdr->ip_sum = _rtl8651_ipChecksum(iphdr);
									_RTL8651_DATA_ADJUST_CHECKSUM(iphdr->ip_sum, org_l3cksum, udp->uh_sum);
								}
								if (pkthdrPtr->ph_pkt_property & PH_PKT_PROPER_IPIP_L4CSM) {
									uint16 org_l4cksum;
									
									uint16 ipcsm_tmp = iphdr->ip_sum;

									if (IS_FRAGMENT_REMAIN(iphdr->ip_off))
										goto IPHDROFFSET_MODIFY_DONE;

									switch (iphdr->ip_p)
									{
										case IPPROTO_TCP:
											{
												struct tcphdr *inner_tcp;
												inner_tcp = (struct tcphdr *)L4HDR_ADDR(iphdr);
												org_l4cksum = inner_tcp->th_sum;		
												iphdr->ip_sum = 0;
												inner_tcp->th_sum = 0;
												inner_tcp->th_sum = _rtl8651_tcpChecksum(iphdr);
												iphdr->ip_sum = ipcsm_tmp;
												
												_RTL8651_DATA_ADJUST_CHECKSUM(inner_tcp->th_sum, org_l4cksum, udp->uh_sum);
											}
											break;
										case IPPROTO_UDP:
											{
												struct udphdr *inner_udp;
												inner_udp = (struct udphdr *)L4HDR_ADDR(iphdr);
												org_l4cksum = inner_udp->uh_sum;		
												iphdr->ip_sum = 0;
												inner_udp->uh_sum = 0;
												inner_udp->uh_sum = _rtl8651_tcpChecksum(iphdr);
												iphdr->ip_sum = ipcsm_tmp;
												
												_RTL8651_DATA_ADJUST_CHECKSUM(inner_udp->uh_sum, org_l4cksum, udp->uh_sum);
											}
											break;
										case IPPROTO_ICMP:
											{
												struct icmp *inner_ic;
												inner_ic = (struct icmp *)L4HDR_ADDR(iphdr);
												org_l4cksum = inner_ic->icmp_cksum;		
												inner_ic->icmp_cksum = 0;
												inner_ic->icmp_cksum = _rtl8651_icmpChecksum(iphdr);
												
												_RTL8651_DATA_ADJUST_CHECKSUM(inner_ic->icmp_cksum, org_l4cksum, udp->uh_sum);
											}
											break;
										case IPPROTO_IGMP:
											{
												struct igmp *inner_ig;
												inner_ig = (struct igmp *)L4HDR_ADDR(iphdr);
												org_l4cksum = inner_ig->igmp_cksum;		
												inner_ig->igmp_cksum = 0;
												inner_ig->igmp_cksum = _rtl8651_icmpChecksum(iphdr);
												
												_RTL8651_DATA_ADJUST_CHECKSUM(inner_ig->igmp_cksum, org_l4cksum, udp->uh_sum);
											}
											break;
									}
								}
								
								goto IPHDROFFSET_MODIFY_DONE;
							}
						}
					}
				}
TO_WAN_PPTPL2TP_OTHER:
				
				isToWanPptpL2tpOther = TRUE;
			}
		}
	}
IPHDROFFSET_MODIFY_DONE:
#endif
	

	
	if (mbuf->m_data[12] == 0x88 && (mbuf->m_data[13] == 0x63 || mbuf->m_data[13] == 0x64)) {
		rtl8651_tblDrv_pppTable_t * pppoePtr;
		uint16 sessionId = (mbuf->m_data[16] << 8) + mbuf->m_data[17];

		pppoePtr = _rtl8651_getPppoeSessionByPppoeSessionId(sessionId);
		pkthdrPtr->ph_pppoeIdx = PPPOE_TABLE_INDEX(pppoePtr);
	}

	
	if(realIphdrOffset>=0){

		
		iphdr=(struct ip *)&mbuf->m_data[realIphdrOffset];
#ifdef RTL8651_DSID_SUPPORT
		sip = PKTGET_UINT32_UNALIGNED(&iphdr->ip_src.s_addr);
		dsid= _rtl8651_getpppDSID(sip);
#endif

		

		

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
		
		if (isToWanPptpL2tpOther == FALSE)
#endif
		{

#ifdef CONFIG_RTL865X_IPSEC
			
			if ( iphdr )
			{
				struct udphdr *udp = NULL;
				espHdr_t *esphdr = NULL;
				uint32 authLen = 0;

				#define AUTHDATA_LEN (12)

				
				if ( iphdr->ip_p==IPPROTO_ESP )
				{
					esphdr = (espHdr_t*)(iphdr+1);
					authLen = ntohs(iphdr->ip_len)-IPHDR_LEN(iphdr)-AUTHDATA_LEN;
				}
				else if ( iphdr->ip_p==IPPROTO_UDP )
				{
					udp = (struct udphdr*)(iphdr+1);
					esphdr = (espHdr_t*)(udp+1);
					authLen = ntohs(udp->uh_ulen)-sizeof(*udp)-AUTHDATA_LEN;
				}
				
				
				if ( esphdr ||
				     ( udp && ntohs(udp->uh_sport)==rtl865x_ipsecNatTraversalUdpPort ) )
				{
					ipsecSpi_t *spi;

					

					if ( udp && 
					     udp->uh_ulen == (sizeof(*udp)+1) &&
					     *((uint8*)(udp+1)) == 0xff )
					{
						
						
					}
					else if ( esphdr->spi == 0x00000000 )
					{
						
						
					}
					else
					{
						
						
						if ( _rtl8651_findIpsecSpi( ntohl(iphdr->ip_dst.s_addr), esphdr->spi, IPSEC_ESP, &spi )==SUCCESS )
						{
							static uint8 newDigest[RTL8651_MAX_IPSEC_KEY_LENGTH];
							static uint8 authBuf[2048]; 
							
							
							esphdr->seq = spi->seq++;
							
							

#ifdef RTL865X_TEST
							
#else
							
							memcpy( (uint8*)UNCACHED_ADDRESS(authBuf), esphdr, authLen );
							retval = rtl8651b_authEngine( (spi->authType-1) | RTL8651_AUTH_IOPAD_READY, 
							                              (uint8*)UNCACHED_ADDRESS(authBuf),
							                              authLen,
							                              (uint8*)UNCACHED_ADDRESS(spi->ipad), 0, 
							                              (uint8*)UNCACHED_ADDRESS(newDigest) );
							if ( retval != SUCCESS )
							{
								rtlglue_printf("%s():%d rtl8651b_authEngine() failed: %d\n", __FUNCTION__, __LINE__, retval );
							}
							else
							{
								
								memcpy( ((uint8*)iphdr)+ntohs(iphdr->ip_len)-AUTHDATA_LEN, (uint8*)UNCACHED_ADDRESS(newDigest), AUTHDATA_LEN );
							}
#endif
						}
					}
				}
			}
#endif

			
#ifdef _RTL_PS_ACTION
			if((mbuf->m_data[12]!=0x88)||(mbuf->m_data[13]!=0x64)||((mbuf->m_data[20]==0x00) && (mbuf->m_data[21]==0x21)))
			{
				_rtl8651_aliasProtoStackSentPkt( !local_vlanp->internal,dsid, iphdr );
			}
#endif
			
#ifdef _RTL_DOS_PLUGIN
			
			_rtl8651_dosScanCheckComplain(dsid, iphdr);	
#endif

			
#ifdef _RTL_NAPT_REDIRECT
			
			_rtl8651_resolveProxyInboundFlow(local_vlanp, iphdr);
#endif
		}


			

#ifdef _RTL_PS_FLOWCACHE
		if ((!local_vlanp->internal) && (!IS_FRAGMENT_REMAIN(iphdr->ip_off)))
		{
			_rtl8651_fwdEnginePsFlowCacheCreate(iphdr);
		}
#endif 
	}
	if (assignedPortMask == 0)
	{
		l2portmask=rtl8651_asicL2DAlookup(mbuf->m_data);
		if (l2portmask == 0)	
		{
			l2portmask = local_vlanp->memberPortMask;
		}
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
		else if (l2portmask == (1<<CONFIG_RTL865XB_PPTPL2TP_PORT))
		{
		    	l2portmask = (1<<tunnel.wanPort); 
		}
#endif
	} else
	{
		l2portmask = assignedPortMask;
	}
	portmask = local_vlanp->memberPortMask & l2portmask;

	if (!portmask)
	{
		retval = FWDENG_NOTXPORT;
		mBuf_driverFreeMbufChain(mbuf);
		goto out;
	}	

	if (	(pkthdrPtr->ph_flags & (CSUM_IP|CSUM_L4)) &&
		(pkthdrPtr->ph_proto != PKTHDR_ETHERNET) &&
		(iphdrOffset > 0) &&
		VLAN_TAGGED(pkthdrPtr->ph_mbuf->m_data))
	{
		
		_rtl8651_fwdEngineTxChecksumOffload(	(struct ip *)&(mbuf->m_data[iphdrOffset]),
												(pkthdrPtr->ph_flags & CSUM_IP),
												(pkthdrPtr->ph_flags & CSUM_L4)	);
		pkthdrPtr->ph_flags &= ~(CSUM_IP|CSUM_L4);
	}

	pkthdrPtr->ph_portlist = portmask;
	pkthdrPtr->ph_dsid = dsid; 
	pkthdrPtr->ph_flags |= (0x8800 | ((highPriority == TRUE)?PKTHDR_HPRIORITY:0));	

	
	retval = _rtl8651_fwdEngineSend(FWDENG_OTHERPROC|FWDENG_FROMPS, pkthdr, dvid, iphdrOffset);

	
	if (retval != SUCCESS)
	{
		mBuf_driverFreeMbufChain(mbuf);
	}
out:
	return retval;
}


static void _rtl8651_fwdEnginePsFlowCacheCreate(struct ip *iphdr)
{
	
	uint8 protocol;

	protocol = iphdr->ip_p;

	if ((protocol == IPPROTO_TCP) || (protocol == IPPROTO_UDP))
	{
		struct tcphdr *tc;
		struct udphdr *ud;
		ipaddr_t sip;
		ipaddr_t dip;
		uint16 sport;
		uint16 dport;
		struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry;
		struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tbl;

		tbl = &entry;

		sip = PKTGET_UINT32_UNALIGNED(&iphdr->ip_src);
		dip = PKTGET_UINT32_UNALIGNED(&iphdr->ip_dst);

		if (protocol == IPPROTO_TCP)
		{	
			tc = (struct tcphdr *)L4HDR_ADDR(iphdr);

			sport = ntohs(tc->th_sport);
			dport = ntohs(tc->th_dport);

			if (_rtl8651_getOutboundNaptFlow(TRUE, sip, sport, dip, dport, &tbl) != SUCCESS)
			{	
				int8 flowType;
				int32 retval;
				int16 retryCnt = 10;
				uint16 newSport = sport;

				if (tc->th_flags == TH_SYN)
				{
					flowType = TCP_OUTBOUND_SYN_RCVD_FLOW;
				}else
				{
					
					flowType = TCP_ESTABLISHED_FLOW;
				}

				tbl = NULL;

				
				while ( _rtl8651_getInboundNaptFlow(TRUE, sip, newSport, dip, dport, &tbl) == SUCCESS )
				{
					retryCnt --;
					newSport += 4096;	
					tbl = NULL;
					if (retryCnt == 0) break;
				}

				
				if ( (retryCnt > 0) &&
					((retval = _rtl8651_addNaptConnection(TRUE, (TRUE|PURE_SW|DONT_CHECK_INTIP|TO_PROTOCOL_STACK), flowType, sip, sport, &sip, &newSport, dip, dport)) == SUCCESS) )
				{
					tbl = &entry;
					if ((retval = _rtl8651_getInboundNaptFlow(TRUE, sip, newSport, dip, dport, &tbl)) != SUCCESS)
					{
#ifdef RTL865X_DEBUG
						rtlglue_printf("[FATAL] %s(%d) Add NAPT Success but get Inbound flow FAILED (ret:%d)!\n", __FUNCTION__, __LINE__, retval);
						rtlglue_printf("\tTCP %u.%u.%u.%u(%d) --- %u.%u.%u.%u(%d)\n", NIPQUAD(sip), newSport, NIPQUAD(dip), dport);
#endif	
						tbl = NULL;
					}
				}
				
			}
			if (tbl)
			{
				if ( tbl->insideLocalPort != tbl->insideGlobalPort)
				{	
					assert(sport == tbl->insideLocalPort);
					tc->th_sport = htons(tbl->insideGlobalPort);
					_RTL8651_L4_ADJUST_CHECKSUM(0, 0, tbl->insideGlobalPort, sport, tc->th_sum);
					sport = tbl->insideGlobalPort;
				}
				assert(tbl->toProtocolStack == TRUE);
				_rtl8651_l4TcpMonitorOut(tc, tbl);
			}
		}else
		{	
			ud = (struct udphdr *)L4HDR_ADDR(iphdr);

			sport = ntohs(ud->uh_sport);
			dport = ntohs(ud->uh_dport);

			if (_rtl8651_getOutboundNaptFlow(FALSE, sip, sport, dip, dport, &tbl) != SUCCESS)
			{	
				int32 retval;
				int16 retryCnt = 10;
				uint16 newSport = sport;

				tbl = NULL;

				
				while ( _rtl8651_getInboundNaptFlow(FALSE, sip, newSport, dip, dport, &tbl) == SUCCESS )
				{
					retryCnt --;
					newSport += 4096;	
					tbl = NULL;
					if (retryCnt == 0) break;
				}

				
				if ( (retryCnt > 0) && ((retval = _rtl8651_addNaptConnection(TRUE, (TRUE|PURE_SW|DONT_CHECK_INTIP|TO_PROTOCOL_STACK), UDP_FLOW,
					sip, sport, &sip, &newSport, dip, dport)) == SUCCESS) )
				{
					tbl = &entry;
					if ((retval = _rtl8651_getInboundNaptFlow(FALSE, sip, newSport, dip, dport, &tbl)) != SUCCESS)
					{
#ifdef RTL865X_DEBUG
						rtlglue_printf("[FATAL] %s(%d) Add NAPT Success but get Inbound flow FAILED (ret:%d)!\n", __FUNCTION__, __LINE__, retval);
						rtlglue_printf("\tUDP %u.%u.%u.%u(%d) --- %u.%u.%u.%u(%d)\n", NIPQUAD(sip), newSport, NIPQUAD(dip), dport);
#endif	
						tbl = NULL;
					}
				}

				
			}
			if (tbl)
			{
				if ( tbl->insideLocalPort != tbl->insideGlobalPort)
				{	
					assert(sport == tbl->insideLocalPort);
					ud->uh_sport = htons(tbl->insideGlobalPort);
					if (ud->uh_sum);
						_RTL8651_L4_ADJUST_CHECKSUM(0, 0, tbl->insideGlobalPort, sport, ud->uh_sum);
					sport = tbl->insideGlobalPort;
				}
				assert(tbl->toProtocolStack == TRUE);
				_rtl8651_updateNaptConnection(tbl, UDP_FLOW, rtl8651GlobalControl.udpTimeout);
			}
		}
	}

	return;
}

int32 rtl8651_offloadEngineL3Send(void * pPkt, uint32 L3PktLength, uint32 l34CkumOffload, int32 highPriority)
{
	
	struct rtl_pktHdr *pkthdr = (struct rtl_pktHdr*)pPkt;
	struct rtl_mBuf *mBuf = NULL;
	struct ip *iphdr = NULL;
	int32 retval = FAILED;

	

	if (pkthdr==NULL||pkthdr->ph_mbuf==NULL)
	{
		return OFFENG_EINVALIDINPUT;
	}

	mBuf = pkthdr->ph_mbuf;
	#define L3OFFLOAD_MIN_HEADROOM	(14 + rtl8651_fwdEnginePara.mbufHeadroom)
	if (((uint32)(mBuf->m_data) - (uint32)(mBuf->m_extbuf)) < L3OFFLOAD_MIN_HEADROOM)
	{
		return OFFENG_EHEADROOM2SMALL;
	}

	iphdr = (struct ip*)(mBuf->m_data);

	pkthdr->ph_property = PH_PROPER_OLENG;	

	
	mBuf->m_data -= 14;
	memset(mBuf->m_data, 0, 2 * sizeof(ether_addr_t));	
	*(uint16*)&(mBuf->m_data[12]) = htons(0x0800);		

	
	if (l34CkumOffload)
	{
		if (!IPHDRLEN_IS_TWENTY(iphdr))
		{	
			_rtl8651_fwdEngineTxChecksumOffload(	iphdr,
													(l34CkumOffload & OFFLOAD_IP_CKSUM),
													(l34CkumOffload & OFFLOAD_L4_CKSUM));
		}
	}

	
	pkthdr->ph_sip = PKTGET_UINT32_UNALIGNED(&iphdr->ip_src);
	pkthdr->ph_dip = PKTGET_UINT32_UNALIGNED(&iphdr->ip_dst);
	switch (iphdr->ip_p)
	{
		case IPPROTO_TCP:	pkthdr->ph_proto = PKTHDR_TCP;	break;
		case IPPROTO_UDP:	pkthdr->ph_proto = PKTHDR_UDP;	break;
		case IPPROTO_ICMP:	pkthdr->ph_proto = PKTHDR_ICMP;	break;
		case IPPROTO_IGMP:	pkthdr->ph_proto = PKTHDR_IGMP;	break;
		case IPPROTO_GRE:	pkthdr->ph_proto = PKTHDR_PPTP;	break;
		default:			pkthdr->ph_proto = PKTHDR_IP;	break;
	}

	pkthdr->ph_dataLen = 0;		
	pkthdr->ph_fragOffset = 0;		
	pkthdr->ph_reason = 2;		
	pkthdr->ph_sport = 0;			

	pkthdr->ph_flags &= ~(PKT_BCAST|PKT_MCAST|PKTHDR_BRIDGING|PKTHDR_HWLOOKUP|PKTHDR_HPRIORITY|PKTHDR_PPPOE_AUTOADD|PKTHDR_VLAN_AUTOADD|CSUM_IP|CSUM_L4);
	pkthdr->ph_flags |= ((highPriority == TRUE)?PKTHDR_HPRIORITY:0);	
	pkthdr->ph_portlist = RTL8651_PSOFFLOAD_RESV_PORT;
	pkthdr->ph_extPortList = 0;		
	pkthdr->ph_srcExtPortNum = 0;	
	pkthdr->ph_vlanIdx = 0;		
	pkthdr->ph_pppoeIdx = 0;		
	pkthdr->ph_unnumber = 0;		
	pkthdr->ph_vlanTagged = 0;	
	pkthdr->ph_LLCTagged = 0;		

	pkthdr->ph_routeIdx = 0;
	pkthdr->ph_dsid = _rtl8651_getpppDSID(pkthdr->ph_sip);
	pkthdr->ph_iphdrOffset = 14;
	pkthdr->ph_len = mBuf->m_len = 14 + L3PktLength;

	
	if (pkthdr->ph_dsid != _rtl8651_DefaultDialSessionId)
	{
		rtl8651_tblDrv_routeTable_t *rt_t = NULL;
		rtl8651_tblDrv_vlanTable_t *vlan_t;

		
		rt_t = _rtl8651_getRoutingEntry(pkthdr->ph_dip);

		if (rt_t && rt_t->valid)
		{
			vlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(rt_t->dvid)];
			if (vlan_t->internal == FALSE)
			{
				rtl8651_tblDrv_pppTable_t *ppp_tb = NULL;

				ppp_tb = _rtl8651_getPppoeSessionByDsid((uint32)(pkthdr->ph_dsid));
				if (ppp_tb)
				{
					uint32 rtIdx;

					rt_t = DrvTbl.route;
					for(rtIdx = 0; rtIdx < rtl8651_tblDrvPara.routingTableSize; rtIdx++,rt_t++)
					{
						if (	(rt_t->netif_t->linkLayerType == RTL8651_LL_PPPOE) &&
							(rt_t->rt_nhSession_t == ppp_tb))
						{
							
							vlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(rt_t->dvid)];
							if (vlan_t->internal == FALSE)
							{
								pkthdr->ph_routeIdx = (rt_t - &DrvTbl.route[0]) + 1;
								goto policyRoute_done;
							}
						}
					}
				}

			}
		}
	}
policyRoute_done:
	

	rtlglue_drvMutexLock();
	retval = _rtl8651_l3FastActRouting(FWDENG_OFFLOAD, pkthdr, pkthdr->ph_dip, iphdr, NULL);
	rtlglue_drvMutexUnlock();

	if (retval != SUCCESS)
	{
		
		mBuf_freeMbufChain(mBuf);
	}

	return retval;

}

static void _rtl8651_fwdEnginePSOffload_L3ExtraProcess(struct rtl_pktHdr *pPkt, struct ip *iphdr, rtl8651_tblDrv_vlanTable_t *vlan_t)
{
	uint8 dsid = pPkt->ph_dsid;

	
	_rtl8651_aliasProtoStackSentPkt(!vlan_t->internal, dsid, iphdr);

	
#ifdef _RTL_DOS_PLUGIN
	
	_rtl8651_dosScanCheckComplain(dsid, iphdr);	
#endif

	
#ifdef _RTL_NAPT_REDIRECT
	
	_rtl8651_resolveProxyInboundFlow(vlan_t, iphdr);
#endif

	

#ifdef _RTL_PS_FLOWCACHE
	if ((!vlan_t->internal) && (!IS_FRAGMENT_REMAIN(iphdr->ip_off)))
	{
		_rtl8651_fwdEnginePsFlowCacheCreate(iphdr);
	}
#endif 

	
	if (	(pPkt->ph_flags & (CSUM_IP|CSUM_L4)) &&
		(pPkt->ph_proto != PKTHDR_ETHERNET) &&
		(iphdr) &&
		VLAN_TAGGED(pPkt->ph_mbuf->m_data))
	{
		_rtl8651_fwdEngineTxChecksumOffload(	iphdr,
												(pPkt->ph_flags & CSUM_IP),
												(pPkt->ph_flags & CSUM_L4)	);
		pPkt->ph_flags &= ~(CSUM_IP|CSUM_L4);
	}

}


static int32 _getEthTypeIpOffset(struct rtl_pktHdr *ph, uint8 *m_data, uint32 *ethtypeOffset, uint32 *iphdrOffset, uint32 *ncp){
	uint32 ip_offset = *iphdrOffset;
	uint32 ethTypePos= *ethtypeOffset;
	if( ph->ph_vlanTagged){		
		ip_offset+=4;
		ethTypePos+=4;
		
		if(m_data[ethTypePos-2] & 0x10 )
			return FWDENG_VLANCFI;
	}
	if(ph->ph_LLCTagged){
		ip_offset+=6;
		ethTypePos+=8;
	}
	if(ph->ph_pppeTagged){
		*ncp= ntohs(*((uint16 *)(m_data+ip_offset+6)));
		ip_offset+=8;
	}
	*ethtypeOffset=ethTypePos;
	*iphdrOffset=ip_offset;
	return SUCCESS;
}


int32 rtl8651_fwdEngineInput(void * pkthdr)
{
	struct rtl_pktHdr * pkthdrPtr = (struct rtl_pktHdr *)pkthdr;
	struct rtl_mBuf *mbufPtr;
	ipaddr_t sip,dip;
	uint16 vid, ethType = 0;
	uint32 ethTypePos;
	uint8 *m_data;
	int32 local_val;
	uint8 ip_protocol;
	struct ip *ip=NULL;
	int32 ip_offset;
	uint32 ncp = 0;
	uint16 srcPortlist = 0;
	rtl8651_tblDrv_vlanTable_t *local_vlanp;
	int32 inAcl_done = FALSE;
	uint32 inAcl_index = 0;
	uint8 *l4hdr;
	uint8 direction; 
	struct tcphdr *tc;
	struct udphdr *ud;
	uint8 isMulticast;

	
	uint32 srcType = _RTL8651_HOST_NONE;
	uint32 dstType = _RTL8651_HOST_NONE;
	uint32 decision = _RTL8651_DEC_NONE;
	uint32 optLayer = _RTL8651_OPERATION_OTHER;

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_RECVLOOP);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_BEFORE_CRYPTO_ENCAP);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_BEFORE_CRYPTO_DECAP);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_UNTIL_ACLDB);
#endif

	rtlglue_drvMutexLock();	

	local_vlanp = &DrvTbl.vlan[pkthdrPtr->ph_vlanIdx];	

	
	mbufPtr = pkthdrPtr->ph_mbuf;
	m_data = mbufPtr->m_data;
	pkthdrPtr->ph_procFlag = 0;
	pkthdrPtr->ph_property = PH_PROPER_DRVFWD;
	srcPortlist = pkthdrPtr->ph_portlist;

	assert((((uint32)m_data)&1)==0);	
	ip_offset = 14;
	ethTypePos = 12;
	ncp = 0;
	
	
	if (( *((uint16 *)(((uint8 *)pkthdrPtr)+8))&0x1c00)==0)
	{
		
	} else
	{
		
		local_val = _getEthTypeIpOffset(pkthdrPtr,m_data, &ethTypePos, &ip_offset, &ncp);
		if (local_val != SUCCESS)
		{
			goto out;
		}
	}
	ethType = ntohs(*((uint16*)(m_data+ethTypePos)));

	
	if ((ethType == 0x0800) || ((ethType == 0x8864) && (ncp == 0x0021)))
	{
		pkthdrPtr->ph_iphdrOffset = ip_offset;
	} else
	{
		pkthdrPtr->ph_iphdrOffset = 0;
	}

	ip = (struct ip *)(pkthdrPtr->ph_mbuf->m_data + ip_offset);	

	
	if ( ( pkthdrPtr->ph_reason & 0x1c ) == 0x04 )	
	{
		uint8 l4proto;
		l4proto = ip->ip_p;

		inAcl_done = FALSE;
		inAcl_index = ((pkthdrPtr->ph_reason >> 5) & 0x7f);

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_UNTIL_ACLDB);
#endif

#ifdef RTL865XB_ACLDB
		if ( _rtl8651_jumptoACLDB(inAcl_index, pkthdrPtr, ip) == SUCCESS )
		{
			switch (l4proto)
			{
				case IPPROTO_TCP:
					rtl8651_fwdEngineCounter.tcpReceive ++;
					rtl8651_fwdEngineCounter.tcpSend ++;
					break;
				case IPPROTO_UDP:
					rtl8651_fwdEngineCounter.udpReceive ++;
					rtl8651_fwdEngineCounter.udpSend ++;
					break;
				case IPPROTO_ICMP:
					rtl8651_fwdEngineCounter.icmpReceive ++;
					rtl8651_fwdEngineCounter.icmpSend ++;
					break;
			}
			local_val = SUCCESS;

			goto out;
		}
		PH_PROCFLAG_SET(pkthdrPtr,PH_PROCFLAG_DSCP_ACTION);
#endif 
	}else if ( pkthdrPtr->ph_reason & 0x18 )	
	{
		rtl8651_fwdEngineCounter.inAclPermit ++;	
		inAcl_done = TRUE;
		inAcl_index = 0;
	} else 
	{
		inAcl_done = FALSE;
		inAcl_index = 0;

#ifdef RTL865XB_DCUT_SWVLAN
		
		if ( pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_INGRESSTAG )
		{
			rtl8651_tblDrv_vlanTable_t *vlanPtr;
			rtl8651_tblDrv_swVlanTable_t *swVlanPtr;
			uint16 vid = pkthdrPtr->ph_svid;

			
			vlanPtr = &DrvTbl.vlan[rtl8651_vlanTableIndex(vid)];
			if (	(vlanPtr->valid == FALSE) ||
				(vlanPtr->vid != vid) )
			{
				local_vlanp = NULL;

				
				swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];

				if (	(swVlanPtr->valid == FALSE) ||
					(swVlanPtr->vid != vid) )
				{	
					local_val = FWDENG_VLANINVALID;
					goto out;
				}

				
				pkthdrPtr->ph_fwd_property |= PH_FWD_PROPER_SWVLAN;
			}
		}
#endif

	}

	
	
	local_val = _rtl8651_fwdEngineL2Input(pkthdrPtr, local_vlanp, m_data, ethType);

	if (local_val == SUCCESS)
	{
		goto out;
	}

#ifdef RTL865XB_DCUT_SWVLAN
	
	if ( pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_SWVLAN )
	{
		local_val = FWDENG_DROP;	
		goto out;
	}
#endif

	if (local_val != FAILED)
	{
		if (local_val == FWDENG_IP_MULTICAST)
		{	
			isMulticast = TRUE;
		}else
		{
			
			
			if (local_val == FWDENG_PPPOE8863)
				rtl8651_fwdEngineCounter.pppoeDiscoveryReceive++;
			goto out;
		}
	}

	vid = local_vlanp->vid;

	
	pkthdrPtr->ph_svid = vid;
	pkthdrPtr->ph_routeIdx = 0;
#ifdef RTL865X_TEST
	pkthdrPtr->ph_sip=PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	pkthdrPtr->ph_dip=PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
#else
	
	pkthdrPtr->ph_sip=(ntohs(*((uint16*)&ip->ip_src))<<16)+ntohs(*(((uint16*)&ip->ip_src)+1));
	pkthdrPtr->ph_dip=(ntohs(*((uint16*)&ip->ip_dst))<<16)+ntohs(*(((uint16*)&ip->ip_dst)+1));
#endif

	
	_rtl8651_fragQueueProcessOk = FALSE;

	

	if ((rtl8651_drvRoutingEnable == TRUE) && (ip->ip_ttl > 1) && (FALSE==rtl8651_diffServEnable) )
	{
		if (((ethType == 0x0800) || (ncp == 0x0021)))
		{
			uint8 l4proto;
			l4proto = ip->ip_p;
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			if (l4proto == IPPROTO_UDP)
			{
				if (_rtl8651_fragmentShortestPathFwd(pkthdrPtr, ip) == SUCCESS)
				{
					rtl8651_fwdEngineCounter.udpReceive ++;
					rtl8651_fwdEngineCounter.udpSend ++;
					local_val = SUCCESS;
					goto out;
				}
			}else if (l4proto == IPPROTO_TCP)
			{
				if (_rtl8651_fragmentShortestPathFwd(pkthdrPtr, ip) == SUCCESS)
				{
					rtl8651_fwdEngineCounter.tcpReceive ++;
					rtl8651_fwdEngineCounter.tcpSend ++;
					local_val = SUCCESS;
					goto out;
				}
			}
#endif 
			if (_rtl8651_dos_enable == TRUE)
			{
				
				
				if (_rtl8651_dosProc_blockSip_check(vid, pkthdrPtr->ph_sip) == SUCCESS)
				{
					local_val = FWDENG_DROP;
					goto out;
				}
			}
		}
		
#ifdef _RTL_NAPT_SHORT_CUT
		if ((_rtl8651_dos_enable == FALSE) && (_rtl8651_udpBlockingEnable == FALSE))
		{

#ifdef CONFIG_RTL865X_ROMEPERF
			rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_FASTPATH);
#endif

			rtl8651_drvPacketFastSend = TRUE;
			if (local_vlanp->internal) {
				if (ip->ip_p == IPPROTO_UDP)
				{
					local_val = _rtl8651_l4UdpFastAliasOut(pkthdrPtr, ip);
					assert(local_val != FWDENG_TO_GW);
					if (local_val == SUCCESS)
					{
						rtl8651_fwdEngineCounter.udpReceive ++;
						rtl8651_fwdEngineCounter.udpSend++;

#ifdef CONFIG_RTL865X_ROMEPERF
						rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FASTPATH);
#endif
						goto out;
					}else if ((local_val > 0) && (local_val & FWDENG_DROP))
					{
						rtl8651_fwdEngineCounter.udpReceive ++;
						goto out;
					}
				} else if (ip->ip_p == IPPROTO_TCP)
				{
					local_val = _rtl8651_l4TcpFastAliasOut(pkthdrPtr,ip);
					assert(local_val != FWDENG_TO_GW);
					if (local_val == SUCCESS)
					{
						rtl8651_fwdEngineCounter.tcpReceive ++;
						rtl8651_fwdEngineCounter.tcpSend++;

#ifdef CONFIG_RTL865X_ROMEPERF
						rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FASTPATH);
#endif
						goto out;
					}else if ((local_val > 0) && (local_val & FWDENG_DROP))
					{
						rtl8651_fwdEngineCounter.tcpReceive ++;
						goto out;
					}
				}
			}
			else	{
				if (ip->ip_p == IPPROTO_UDP)
				{
					local_val=_rtl8651_l4UdpFastAliasIn(pkthdrPtr, ip);
					assert(local_val != FWDENG_TO_GW);
					if (local_val == SUCCESS)
					{
						rtl8651_fwdEngineCounter.udpReceive ++;
						rtl8651_fwdEngineCounter.udpSend++;

#ifdef CONFIG_RTL865X_ROMEPERF
						rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FASTPATH);
#endif
						goto out;
					}else if ((local_val > 0) && (local_val&FWDENG_DROP))
					{
						rtl8651_fwdEngineCounter.udpReceive ++;
						goto out;
					}
				} else if (ip->ip_p == IPPROTO_TCP)
				{
					local_val = _rtl8651_l4TcpFastAliasIn(pkthdrPtr,ip);
					assert(local_val != FWDENG_TO_GW);
					if (local_val == SUCCESS)
					{
						rtl8651_fwdEngineCounter.tcpReceive ++;
						rtl8651_fwdEngineCounter.tcpSend++;

#ifdef CONFIG_RTL865X_ROMEPERF
						rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FASTPATH);
#endif
						goto out;
					}else if ((local_val > 0) && (local_val&FWDENG_DROP))
					{
						rtl8651_fwdEngineCounter.tcpReceive ++;
						goto out;
					}
				}
			}			
			rtl8651_drvPacketFastSend = FALSE;
		}
#endif 
	}

	
	
	

	
	tc = NULL;
	ud = NULL;
	ip_protocol = 0;
	local_val = FAILED;
	l4hdr = NULL;
	direction = 0;
	isMulticast = FALSE;



	

	if (pkthdrPtr->ph_proto == PKTHDR_ETHERNET)
	{
		
		if (!inAcl_done)
		{
			local_val = _rtl8651_ingressAcl(	pkthdrPtr->ph_dsid,
											inAcl_index,
											local_vlanp,
											vid,
											m_data,
											NULL,
											RTL8651_ACL_GENERIC,
											_RTL8651_OPERATION_OTHER);

			if (((local_val > 0) && (local_val&FWDENG_DROP))||(local_val==FWDENG_ACL_IN_USERTRAP))
			{
				goto out;
			}
			inAcl_done = TRUE;		
		}

		
		if(ethType == 0x0806) {
			
			local_val = _rtl8651_drvArpAgent(pkthdrPtr, mbufPtr, vid);
			goto out;
		}else if(ethType == 0x8863) {
			
			if(rtl8651_drvPppoeNotExistedSessionTerminationEnable == TRUE) {
				pppoeHdr_t * pppoeHdrPtr;
				pppoeHdrPtr = (pppoeHdr_t *)&(mbufPtr->m_data[ethTypePos+2]);
				if(pppoeHdrPtr->code == 0x65) {
					rtlglue_printf("Active Session Detection receive PADS to update session ID %x\n", ntohs(pppoeHdrPtr->sessionId));
					_rtl8651_updatePppoeActiveSession(ntohs(pppoeHdrPtr->sessionId));
				} else if(pppoeHdrPtr->code == 0xa7) {
					rtlglue_printf("Active Session Detection receive PADT to terminate session ID %x\n", ntohs(pppoeHdrPtr->sessionId));
					_rtl8651_terminatePppoeActiveSession(ntohs(pppoeHdrPtr->sessionId));
				}
			}
			rtl8651_fwdEngineCounter.pppoeDiscoveryReceive++;

			if (rtl8651_PPPoEEnable){
				
				assert( rtl8651_pppoeInput);
				if(rtl8651_pppoeInput(mbufPtr)) {
					local_val = FAILED;
				}else{
					rtl8651_fwdEngineCounter.pppoeDiscoveryProcessed++;
					local_val = SUCCESS;
				}
			}else
				local_val=FWDENG_PPPOE8863;

			

			
			goto out;
		}
	}

	if(pkthdrPtr->ph_pppeTagged){
		
		pppoeHdr_t * pppoeHdrPtr;
		rtl8651_tblDrv_pppTable_t * pppoePtr;

		pppoeHdrPtr = (pppoeHdr_t *)&(mbufPtr->m_data[ethTypePos+2]);		
		pppoePtr = _rtl8651_getPppoeSessionByPppoeSessionId(ntohs(pppoeHdrPtr->sessionId));
		if(pppoePtr == NULL) {
			if(rtl8651_drvPppoeNotExistedSessionTerminationEnable == TRUE && 
				_rtl8651_pppoeSessionActive(ntohs(pppoeHdrPtr->sessionId)) == FALSE) {
				uint16 i;
				uint8 charValue;

				
				rtlglue_printf("SID %x should be invalid send PADT\n", ntohs(pppoeHdrPtr->sessionId));
				
				for(i=0; i<6; i++) {
					charValue = mbufPtr->m_data[i];
					mbufPtr->m_data[i] = mbufPtr->m_data[i+6];
					mbufPtr->m_data[i+6] = charValue;
				}
				mbufPtr->m_data[ethTypePos] = 0x88;
				mbufPtr->m_data[ethTypePos+1] = 0x63;
				pppoeHdrPtr->code = 0xa7; 
				pppoeHdrPtr->length = 0;
				pkthdrPtr->ph_flags &= ~(PKT_BCAST | PKT_MCAST | PKTHDR_BRIDGING | PKTHDR_HWLOOKUP	| PKTHDR_HPRIORITY |
										PKTHDR_PPPOE_AUTOADD | PKTHDR_VLAN_AUTOADD | CSUM_IP_OK | CSUM_L4_OK | CSUM_IP | CSUM_L4);
				pkthdrPtr->ph_pppeTagged = 0;
				pkthdrPtr->ph_proto = PKTHDR_ETHERNET;
				pkthdrPtr->ph_srcExtPortNum = 0;
				pkthdrPtr->ph_extPortList = 0;
				pkthdrPtr->ph_portlist = 1<<pkthdrPtr->ph_portlist;
				pkthdrPtr->ph_len = mbufPtr->m_len = 60;
				if (_rtl8651_fwdEngineSend (FWDENG_L2PROC|FWDENG_FROMDRV, (void*)pkthdrPtr, vid,-1) != SUCCESS)
				{
					mBuf_driverFreeMbufChain(pkthdrPtr->ph_mbuf);
				}
				local_val = SUCCESS;
				goto out;
			}
		}
		else {
			pppoePtr->rxBytes += pkthdrPtr->ph_len;
			pppoePtr->rxPackets ++;
		}
		assert(ethType==0x8864);
		
			rtl8651_fwdEngineCounter.pppoeSessionReceive++;
		if(ncp!=0x0021){ 
			if (rtl8651_PPPoEEnable){
				
				assert( rtl8651_pppoeInput);
				if(rtl8651_pppoeInput(mbufPtr)){
					local_val=FAILED;
				}else{
					rtl8651_fwdEngineCounter.pppoeSessionProcessed++;
					local_val=SUCCESS;
				}
			}else
				local_val=FWDENG_PPPOE8864; 
			goto out;
		}
		else {
		}
		rtl8651_fwdEngineCounter.pppoeSessionProcessed++;
	}else if(ethType!=0x0800){
		local_val=FWDENG_NOTIPPACKET;
		goto out;
	}

	

	if(rtl8651_drvRoutingEnable == FALSE){
		local_val=FWDENG_L34DISABLED;
		goto out;
	}
	
	if(ISCLEARED(pkthdrPtr->ph_flags, CSUM_IP_OK)) {
		rtl8651_fwdEngineCounter.ipErrorReceive++;
		local_val = FWDENG_IP_BADCKSUM;
		goto out;	
	}

	ip_protocol = ip->ip_p;
	l4hdr = (uint8 *) L4HDR_ADDR(ip);

	sip = pkthdrPtr->ph_sip;
	dip = pkthdrPtr->ph_dip;

	
	if (!IPHDRLEN_IS_TWENTY(ip))
	{
		switch(ip->ip_p)
		{
			case IPPROTO_TCP:
				pkthdrPtr->ph_proto = PKTHDR_TCP;
				break;
			case IPPROTO_UDP:
				pkthdrPtr->ph_proto = PKTHDR_UDP;
				break;
			case IPPROTO_ICMP:
				pkthdrPtr->ph_proto = PKTHDR_ICMP;
				break;
			case IPPROTO_IGMP:
				pkthdrPtr->ph_proto = PKTHDR_IGMP;
				break;
			
		}
	}
	
	if(!dip||((dip&0xff000000)==0x7f000000)){
		local_val=FWDENG_IP_INVALID;
		goto out;
	}
	if(sip&&(sip==0xffffffff|| (sip&0xff000000)==0x7f000000||(sip & 0xf0000000) == 0xe0000000)){
		local_val=FWDENG_IP_INVALID;
		goto out;
	}

	if (IN_MULTICAST(dip))
		isMulticast = TRUE;

	
	if (pkthdrPtr->ph_proto == PKTHDR_IGMP)
	{
		struct igmp *ig = (struct igmp*)l4hdr;
		rtl8651_fwdEngineCounter.igmpReceive++;

		
		if (!(rtl8651_drvFwdUnicastIGMPEnable && (IN_UNICAST(dip))))
		{
			local_val = FWDENG_IGMPPKT;
			#ifdef CONFIG_RTL865X_MULTICAST
			if (rtl8651_drvMulticastProcessEnable && (!IS_FRAGMENT(ip->ip_off)))
			{
				local_val = _rtl8651_igmp_process(pkthdr,  ip, ig);
			}
			#endif 
			goto out;
		}
	}

	
	if((ip->ip_ttl < 2) && (!isMulticast))
	{
		local_val=FWDENG_IP_TTLEXCEED;
		if (rtl8651_drvIcmpRoutingMsgEnable)
		{
			uint32 netIdx;
			if ((_rtl8651_extIpAddr(dip, &netIdx) == FALSE)
				&& (_rtl8651_intIpAddr(dip) == FALSE))
			{
				
				_rtl8651_IcmpPktField_t icmp_info;
				icmp_info.ic_type = ICMP_TIMXCEED;	
				icmp_info.ic_code = 0;	
				icmp_info.ic_mtu = 0;
				local_val = _rtl8651_drvIcmpErrorGeneration(pkthdrPtr, ip, &icmp_info, vid);
			}
		}
		goto out;
	}

	
	{
		if(!local_vlanp->internal)
			direction=1;
	}

#ifdef RTL8651_DSID_SUPPORT

	{
		int32 flowBasedDsid = FALSE;

		pkthdrPtr->ph_unnumber = 0;

		
		pkthdrPtr->ph_dsid = 0xff;

		
		if (_rtl8651_l4NaptFlowGetDSID(	!direction,
										pkthdrPtr,
										ip) == SUCCESS)
		{
			flowBasedDsid = TRUE;
		}

		if (!direction)
		{	
			if ( flowBasedDsid == FALSE )
			{
				if (!IS_FRAGMENT_REMAIN(ip->ip_off))
				{
					switch (pkthdrPtr->ph_proto)
					{
						case PKTHDR_TCP:
						{
							tc = (struct tcphdr *)l4hdr;

							pkthdrPtr->ph_dsid = _rtl8651_getPolicyRoutingDSID(	pkthdrPtr,
																				sip,
																				dip,
																				IPPROTO_TCP,
																				ntohs(tc->th_sport),
																				ntohs(tc->th_dport));
							break;
						}
						case PKTHDR_UDP:
						{
							ud = (struct udphdr *)l4hdr;

							pkthdrPtr->ph_dsid = _rtl8651_getPolicyRoutingDSID(	pkthdrPtr,
																				sip,
																				dip,
																				IPPROTO_UDP,
																				ntohs(ud->uh_sport),
																				ntohs(ud->uh_dport));
							break;
						}
						default:
							goto l3_getDsid;
					}
				} else
				{
					l3_getDsid:
					pkthdrPtr->ph_dsid = _rtl8651_getPolicyRoutingDSID(	pkthdrPtr,
																		sip,
																		dip,
																		ip->ip_p,
																		-1,
																		-1);
				}
			}
		} else
		{	
			_rtl8651_getPolicyRoutingDSID(	pkthdrPtr,
											dip,			
											0,
											ip->ip_p,
											-1,
											-1);

			if ( flowBasedDsid == FALSE )
			{
				pkthdrPtr->ph_dsid= _rtl8651_getpppDSID(dip);
			}
		}
		pkthdrPtr->ph_unnumber|=direction<<1;

		
		if (pkthdrPtr->ph_dsid == 0xff)
		{
			RTL_BUG("dsid is not set !\n");
		}
	}
#endif

	

#ifdef CONFIG_RTL865X_IPSEC
	
	
	if ( local_val != FWDENG_TO_GW )
	{
		ipsecERoute_t *pIpsec;

		
		if ( _rtl8651_findIpsecERouteBySrcDstIp( pkthdrPtr->ph_sip, pkthdrPtr->ph_dip, &pIpsec ) == SUCCESS )
		{
			local_val = _rtl8651_encapIpsec( -1, pkthdrPtr, ip, pIpsec );
			if(local_val == SUCCESS)
				goto out;
		}
		
		if ( ( ( ip->ip_p==IPPROTO_ESP ) ||
		       ( ip->ip_p==IPPROTO_UDP && ntohs(((struct udphdr*)(ip+1))->uh_dport)==rtl865x_ipsecNatTraversalUdpPort )
		     ) &&
		     _rtl8651_findIpsecERouteBySrcEdstIp( pkthdrPtr->ph_sip, pkthdrPtr->ph_dip, &pIpsec ) == SUCCESS )
		{
			local_val = _rtl8651_decapIpsec( -1, pkthdrPtr, ip, pIpsec );
			if(local_val == SUCCESS)
				goto out;
		}
	}
#endif

#ifdef _RTL_QUEUE_FRAG_PKT
	if (IS_FRAGMENT(ip->ip_off))
	{
		if (rtl8651_drvFragmentProcessEnable)
		{
			if (!_rtl8651_fragQueueProcess)	
			{
				pkthdrPtr->ph_dataLen = pkthdrPtr->ph_len - ip_offset;
				
				local_val = _rtl8651_ip_defrag(pkthdrPtr, ip);
				if (local_val != FAILED)
				{
					
					goto frag_out;
				}
			}
		}else
		{	
			local_val = FWDENG_IP_CANTFRAG;
			goto out;
		}
		
		_rtl8651_fragQueueProcessOk = TRUE;

	}
#endif 

#ifdef _RTL_TOS_REMARKING
	if(TRUE==rtl8651_diffServEnable) 
		_rtl8651_DSCPRemark(pkthdrPtr, ip, sip, dip, pkthdrPtr->ph_dsid, local_vlanp);
#endif

	
	if (isMulticast == TRUE)
	{
#ifdef CONFIG_RTL865X_MULTICAST
		if (rtl8651_drvMulticastProcessEnable)
		{
			local_val = _rtl8651_multicast_Fastfwd(pkthdrPtr, ip, local_vlanp);
			if ((local_val == SUCCESS) || (local_val == FWDENG_IP_MULTICAST))
			{	
				goto out;
			}
		}else
#endif 
		{
			
			local_val = FWDENG_IP_MULTICAST;
			goto out;
		}
	}

	
	if (pkthdrPtr->ph_proto == PKTHDR_TCP)
	{
		rtl8651_fwdEngineCounter.tcpReceive++;
		tc=(struct tcphdr *)l4hdr;
		pkthdrPtr->ph_sport = ntohs(tc->th_sport);

		
		if(ISCLEARED(pkthdrPtr->ph_flags, (CSUM_L4_OK)))
		{
			rtl8651_fwdEngineCounter.tcpErrorReceive++;
			local_val=FWDENG_TCP_BADCKSUM;
			goto out;	
		}

		
		if(!sip || dip==0xffffffff)
		{
			local_val = FWDENG_IP_INVALID;
			goto out;
		}

		#ifdef _RTL_DOS_PLUGIN

		
		if (rtl8651a_dosTcpCheck(pkthdrPtr->ph_dsid,vid,ip,&local_val,direction,
			rtl8651_wanStatus[pkthdrPtr->ph_dsid], pkthdrPtr, RTL8651_DOS_FAST_CHECK) == SUCCESS)
		{
			goto dos_out;
		}
		#endif 

		#ifdef _RTL_NAPT_SHORT_CUT

		
		rtl8651_drvPacketFastSend = TRUE;	
		{
			if(local_vlanp->internal)	
				local_val = _rtl8651_l4TcpFastAliasOut(pkthdrPtr,ip);
			else {		
				local_val = _rtl8651_l4TcpFastAliasIn(pkthdrPtr,ip);
			}
		}
		rtl8651_drvPacketFastSend = FALSE;	

		if (local_val == SUCCESS)
		{	
			rtl8651_fwdEngineCounter.tcpSend++;
			goto out;
		}

		if (local_val == FWDENG_TO_GW)
		{	
			goto out;
		}

		if (((local_val > 0) && (local_val & FWDENG_DROP)) || (local_val == FWDENG_TCP_URLFILTERED))
		{
			rtl8651_fwdEngineCounter.natdrop++;
			local_val |= FWDENG_DROP;
			goto out;
		}
		

		#endif 	

		#ifdef _RTL_DOS_PLUGIN
		
		if (rtl8651a_dosTcpCheck(pkthdrPtr->ph_dsid,vid,ip,&local_val,direction,
			rtl8651_wanStatus[pkthdrPtr->ph_dsid], pkthdrPtr, RTL8651_DOS_SLOW_CHECK) == SUCCESS)
		{
			goto dos_out;
		}
		
		_rtl8651_dosScanTracking(pkthdrPtr, ip, IPPROTO_TCP, (void*)tc);	
		#endif 

		
		_rtl8651_l34Decision(	pkthdrPtr,
								local_vlanp,
								&decision,
								&srcType,
								&dstType,
								&optLayer);
		

		
		if (inAcl_done == FALSE)
		{
			local_val = _rtl8651_ingressAcl(	pkthdrPtr->ph_dsid,
											inAcl_index,
											local_vlanp,
											vid,
											m_data,
											(uint8 *)ip,
											RTL8651_ACL_GENERIC,
											optLayer);

			if (local_val & FWDENG_DROP)
			{
				goto out;
			}
			if (local_val == FWDENG_ACL_IN_USERTRAP)
			{
				goto out;
			}
				
			inAcl_done = TRUE;
		}

		
		goto normal_process;
	}else if (pkthdrPtr->ph_proto == PKTHDR_UDP)
	{
		rtl8651_fwdEngineCounter.udpReceive++;
		ud=(struct udphdr *)l4hdr;
		pkthdrPtr->ph_sport = ntohs(ud->uh_sport);

		
		if(ISCLEARED(pkthdrPtr->ph_flags, (CSUM_L4_OK)))
		{
			rtl8651_fwdEngineCounter.udpErrorReceive++;
			local_val = FWDENG_UDP_BADCKSUM;
			goto out;
		}

		
		if (sip == 0)
		{
			
			if (IS_FRAGMENT_REMAIN(ip->ip_off) ||	
				((ntohs(ud->uh_sport) != 68) && (ntohs(ud->uh_sport) != 67)))
			{
				local_val = FWDENG_IP_INVALID;
				goto out;
			}
		}

		#ifdef _RTL_DOS_PLUGIN
		
		if (rtl8651a_dosUdpCheck(pkthdrPtr->ph_dsid,vid,ip,&local_val,direction,
			rtl8651_wanStatus[pkthdrPtr->ph_dsid], pkthdrPtr, RTL8651_DOS_FAST_CHECK) == SUCCESS)
		{
			goto dos_out;
		}
		#endif 	

		#ifdef _RTL_NAPT_SHORT_CUT
		
		rtl8651_drvPacketFastSend = TRUE;		
		{
			if (local_vlanp->internal)
				local_val = _rtl8651_l4UdpFastAliasOut(pkthdrPtr, ip);
			else
				local_val = _rtl8651_l4UdpFastAliasIn(pkthdrPtr, ip);
		}
		rtl8651_drvPacketFastSend = FALSE;		

		if (local_val == SUCCESS)
		{
			rtl8651_fwdEngineCounter.udpSend++;
			goto out;
		}

		if (local_val == FWDENG_TO_GW)
		{	
			goto out;
		}

		if ((local_val > 0) && (local_val & FWDENG_DROP))
		{
			rtl8651_fwdEngineCounter.natdrop++;
			goto out;
		}
		
		#endif 

		#ifdef _RTL_DOS_PLUGIN
		
		if (rtl8651a_dosUdpCheck(pkthdrPtr->ph_dsid,vid,ip,&local_val,direction,
			rtl8651_wanStatus[pkthdrPtr->ph_dsid], pkthdrPtr, RTL8651_DOS_SLOW_CHECK) == SUCCESS)
		{
			goto dos_out;
		}
		
		_rtl8651_dosScanTracking(pkthdrPtr, ip, IPPROTO_UDP, (void*)ud);	
		#endif 	

		
		_rtl8651_l34Decision(	pkthdrPtr,
								local_vlanp,
								&decision,
								&srcType,
								&dstType,
								&optLayer);
		

		
		if (inAcl_done == FALSE)
		{
			local_val = _rtl8651_ingressAcl(	pkthdrPtr->ph_dsid,
											inAcl_index,
											local_vlanp,
											vid,
											m_data,
											(uint8 *)ip,
											RTL8651_ACL_GENERIC,
											optLayer);

			if (	((local_val > 0) && (local_val&FWDENG_DROP)) ||
				(local_val == FWDENG_ACL_IN_USERTRAP)
			)
			{
				goto out;
			}
			inAcl_done=TRUE;
		}

		goto normal_process;
	}else if (pkthdrPtr->ph_proto==PKTHDR_ICMP)
	{
		struct icmp *ic;
		assert(ip);
		ic = (struct icmp *) l4hdr;
		pkthdrPtr->ph_sid = ntohs(ic->icmp_id);
		rtl8651_fwdEngineCounter.icmpReceive++;
		
		if(ISCLEARED(pkthdrPtr->ph_flags, (CSUM_L4_OK)))
		{
			rtl8651_fwdEngineCounter.icmpErrorReceive++;
			local_val=FWDENG_ICMP_BADCKSUM;
			goto out;
		}

		
		if (sip == 0)
		{
			local_val = FWDENG_IP_INVALID;
			goto out;
		}

		#ifdef _RTL_DOS_PLUGIN
		
		if (rtl8651a_dosIcmpCheck(pkthdrPtr->ph_dsid,vid,ip,&local_val,direction,
			rtl8651_wanStatus[pkthdrPtr->ph_dsid], pkthdrPtr) == SUCCESS)
		{
			goto dos_out;
		}
		#endif 

		
		_rtl8651_l34Decision(	pkthdrPtr,
								local_vlanp,
								&decision,
								&srcType,
								&dstType,
								&optLayer);
		

		
		if (inAcl_done == FALSE)
		{
			local_val=_rtl8651_ingressAcl(	pkthdrPtr->ph_dsid,
										inAcl_index,
										local_vlanp,
										vid,
										m_data,
										(uint8 *)ip,
										RTL8651_ACL_GENERIC,
										optLayer);

			if (((local_val > 0) && (local_val&FWDENG_DROP))||(local_val==FWDENG_ACL_IN_USERTRAP))
			{
				goto out;
			}
			inAcl_done = TRUE;
		}

		if (_rtl8651_isLocalBcastAddr(vid, pkthdrPtr->ph_dip))
		{
			_rtl8651_l2Relay(mbufPtr);
		}
			
		goto normal_process;
	}else if (pkthdrPtr->ph_proto == PKTHDR_IP||pkthdrPtr->ph_proto == PKTHDR_PPTP)
	{
		rtl8651_fwdEngineCounter.ipReceive++;
#ifdef _RTL_DOS_PLUGIN
		
		
		if (rtl8651a_dosIpCheck(pkthdrPtr->ph_dsid,vid,ip,&local_val,direction,rtl8651_wanStatus[pkthdrPtr->ph_dsid], pkthdrPtr)
			== SUCCESS)
		{
			goto dos_out;
		}
#endif 	

		
		_rtl8651_l34Decision(	pkthdrPtr,
								local_vlanp,
								&decision,
								&srcType,
								&dstType,
								&optLayer);
		

		if (inAcl_done == FALSE)
		{
			local_val = _rtl8651_ingressAcl(	pkthdrPtr->ph_dsid,
											inAcl_index,
											local_vlanp,
											vid,
											m_data,
											(uint8*)ip,
											RTL8651_ACL_GENERIC,
											optLayer);

			if (((local_val > 0) && (local_val&FWDENG_DROP))||(local_val==FWDENG_ACL_IN_USERTRAP))
			{
				goto out;
			}
			inAcl_done = TRUE;
		}

		
		if (_rtl8651_isLocalBcastAddr(vid, pkthdrPtr->ph_dip))
		{
			_rtl8651_l2Relay(mbufPtr);
		}

		
		if (rtl8651_drvProtocolBasedNatEnable)
		{	
			if ( local_vlanp->internal )
			{
				
				ipaddr_t newExtIp;
				if ( SUCCESS == _rtl8651_getOutboundProtocolBasedNAT(ip_protocol, &newExtIp, sip))
				{
					
					PKTSET_UINT32_UNALIGNED(newExtIp, &ip->ip_src);
					if (!IPHDRLEN_IS_TWENTY(ip))
					{	
						_RTL8651_L3_ADJUST_CHECKSUM(newExtIp, pkthdrPtr->ph_sip, ip->ip_sum);
					}
					pkthdrPtr->ph_proto = PKTHDR_IP;	
					local_val = _rtl8651_l3ActRouting( pkthdr, pkthdrPtr->ph_dip, ip );
					goto out;
				}
			}else
			{
				
				ipaddr_t newIntIp;
				if ( SUCCESS == _rtl8651_getInboundProtocolBasedNAT(ip_protocol, dip, &newIntIp))
				{
					
					PKTSET_UINT32_UNALIGNED(newIntIp, &ip->ip_dst);
					if (!IPHDRLEN_IS_TWENTY(ip))
					{	
						_RTL8651_L3_ADJUST_CHECKSUM(newIntIp, pkthdrPtr->ph_dip, ip->ip_sum);
					}
					pkthdrPtr->ph_proto = PKTHDR_IP;	
					local_val = _rtl8651_l3ActRouting(pkthdr, newIntIp, ip );
					goto out;
				}
			}
		}

		goto normal_process;
	}else if (pkthdrPtr->ph_proto == PKTHDR_IGMP)
	{
		
		assert(rtl8651_drvFwdUnicastIGMPEnable == TRUE);

		#ifdef _RTL_DOS_PLUGIN
		
		if (rtl8651a_dosIpCheck(pkthdrPtr->ph_dsid,vid,ip,&local_val,direction,rtl8651_wanStatus[pkthdrPtr->ph_dsid], pkthdrPtr)
			== SUCCESS)
		{
			goto dos_out;
		}
		#endif 	

		
		_rtl8651_l34Decision(	pkthdrPtr,
								local_vlanp,
								&decision,
								&srcType,
								&dstType,
								&optLayer);
		

		if (inAcl_done == FALSE)
		{
			local_val = _rtl8651_ingressAcl(	pkthdrPtr->ph_dsid,
											inAcl_index,
											local_vlanp,
											vid,
											m_data,
											(uint8*)ip,
											RTL8651_ACL_GENERIC,
											optLayer);

			if (((local_val > 0) && (local_val&FWDENG_DROP))||(local_val==FWDENG_ACL_IN_USERTRAP))
			{
				goto out;
			}
			inAcl_done = TRUE;
		}

		goto normal_process;
	}

	
	if (inAcl_done == FALSE)
	{
		
		local_val=_rtl8651_ingressAcl(	pkthdrPtr->ph_dsid,
									inAcl_index,
									local_vlanp,
									vid,
									m_data,
									(uint8*)ip,
									RTL8651_ACL_GENERIC,
									_RTL8651_OPERATION_OTHER);

		if (((local_val > 0) && (local_val&FWDENG_DROP))||(local_val==FWDENG_ACL_IN_USERTRAP))
		{
			goto out;
		}
		inAcl_done = TRUE;
	}

	local_val = FWDENG_L3UNKNOWNPROTO;
	goto out;		

normal_process:

	assert(ip);

#ifdef CONFIG_RTL865X_MULTICAST

	if (	(isMulticast == TRUE) && 
		(rtl8651_drvMulticastProcessEnable))
	{
		local_val = _rtl8651_multicast_process(pkthdrPtr, ip);
		goto out;
	}
#endif 

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FASTPATH);
#endif

	
	
	

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_SLOWPATH);
#endif

	
	if (decision == _RTL8651_DEC_NONE)
	{
		_rtl8651_l34Decision(	pkthdrPtr,
								local_vlanp,
								&decision,
								&srcType,
								&dstType,
								&optLayer);
	}


	
	local_val = 0;
	local_val = _rtl8651_l34PacketProcess(pkthdrPtr, ip, decision);
	if(local_val != SUCCESS)
	{
		rtl8651_fwdEngineCounter.l34actionLookupFailed++;
		goto out;
	}

	
	local_val = _rtl8651_l34ActExec(pkthdrPtr, ip, ip_protocol, decision);

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_SLOWPATH);
#endif

	
	if(local_val != SUCCESS)
	{
		if ( local_val > 0 )
		{
			if ((local_val & ~FWDENG_DROP) == FWDENG_USER_IDSCHECKDROP)
			{
				goto dos_out;
			}
			if ( local_val & FWDENG_DROP )
			{
				rtl8651_fwdEngineCounter.l34actionFailed++;
				goto out;
			}
		}

		
		if ( local_vlanp->internal && ( decision == _RTL8651_DEC_NT  || 
			decision == _RTL8651_DEC_NPT  ||decision == _RTL8651_DEC_RT_RR  || 
			_rtl8651_intIpAddr(pkthdrPtr->ph_dip) ) )
			_rtl8651_drvPktDemandRouteTrigger(ip);

		
		if (rtl8651_drvIcmpReplyEnable && ip_protocol == IPPROTO_ICMP)
		{
			if (_rtl8651_drvIcmpAgent(pkthdrPtr,ip,vid) == SUCCESS)
			{
				local_val = SUCCESS;
			}else
			{
				rtl8651_fwdEngineCounter.l34actionFailed++;
			}
			goto out;
		}

		
		

		rtl8651_fwdEngineCounter.l34actionFailed++;
		goto out;
	}

	switch (ip_protocol)
	{
		case IPPROTO_TCP:
			rtl8651_fwdEngineCounter.tcpSend++;
			break;
		case IPPROTO_UDP:
			rtl8651_fwdEngineCounter.udpSend++;
			break;
		case IPPROTO_ICMP:			
			rtl8651_fwdEngineCounter.icmpSend++;
			break;
	}
	goto out;

dos_out:
	rtl8651_fwdEngineCounter.dosDrop++;

out:	

#ifdef _RTL_PS_ACTION
		{
			
			if (	(local_val != SUCCESS) &&
				((local_val & FWDENG_DROP) == 0) &&
				(_dropCases[local_val&(FWDENG_DROP-1)] == FALSE) &&
				(ip)
			)
			{
				int32 ps_result;
				if ((ps_result = _rtl8651_protoStackAction_filter(pkthdrPtr, local_vlanp, ip)) != SUCCESS)
				{
					local_val = ps_result;
				}
			}
		}
#endif	

frag_out:	

	

	
	rtl8651_drvPacketFastSend = FALSE;

#ifdef _RTL8651_FWDENG_RETURN_STATISTIC
	if (local_val != SUCCESS)
	{
		_rtl8651_fwdEngineRetValueStatisticUpdate(local_val);
	}
#endif 

	
	if (local_val > 0)
	{
		if (	((local_val & FWDENG_DROP) == 0) &&
			(_dropCases[local_val&(FWDENG_DROP-1)]))
		{
			local_val |= FWDENG_DROP;	
		}

		if (	((local_val & ~FWDENG_DROP) == FWDENG_ACL_DROP_NOTIFY) &&
			(pkthdrPtr->ph_proto!=PKTHDR_ETHERNET))
		{
			int32 DropBit = (local_val & FWDENG_DROP);
			_rtl8651_IcmpPktField_t icmpInfo;
			icmpInfo.ic_type	= ICMP_UNREACH;
			icmpInfo.ic_code	= ICMP_UNREACH_HOST;
			icmpInfo.ic_mtu		= 0;
			pkthdrPtr->ph_portlist	= srcPortlist;
			local_val = _rtl8651_drvIcmpErrorGeneration(pkthdrPtr, ip, &icmpInfo, local_vlanp->vid);
			if (local_val != SUCCESS)
			{
				local_val |= DropBit;
			}
		}
		
		if (local_val & FWDENG_DROP)
		{
			mBuf_driverFreeMbufChain(pkthdrPtr->ph_mbuf);
#ifdef _RTL_QUEUE_FRAG_PKT
			_rtl8651_fragQueueDropChain = TRUE;
#endif
			local_val = SUCCESS;
		}
		if (local_val == FWDENG_QUEUED)
		{
			local_val = SUCCESS;
		}

		
		
	}


	
	if (local_val != SUCCESS)
	{
#ifdef _RTL_TRAPPING_DISPATCH
		{
			
			uint16 category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

			if ( (ethType == 0x0800 || ((ethType == 0x8864) && (ncp = 0x0021))) &&
				(pkthdrPtr->ph_iphdrOffset) &&
				(!_rtl8651_fragQueueProcess))
			{
				
				category = _rtl8651_getTrappingDispatchCategory((struct ip *)(pkthdrPtr->ph_mbuf->m_data + pkthdrPtr->ph_iphdrOffset));
			}

			
			{
				struct rtl_pktHdr *pHdr = pkthdrPtr;

				while (pHdr)
				{
					pHdr->ph_category = category;	
					pHdr = pHdr->ph_nextHdr;		
				}
			}
		}
#endif 

#ifdef _RTL_PPTPL2TP_HDR_REFILL
		if ( (ethType == 0x0800) &&
		      (pkthdrPtr->ph_iphdrOffset) &&
		      (!_rtl8651_fragQueueProcess))
		{
			
			_rtl8651_refillHeader( local_val,
								  pkthdrPtr,
								  (struct ip *)(pkthdrPtr->ph_mbuf->m_data + pkthdrPtr->ph_iphdrOffset),
								  local_vlanp,
								  srcPortlist);
		}
#endif	

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
		
		{
			struct rtl_pktHdr *pHdr = pkthdrPtr;
			while (pHdr)
			{
				if (pHdr->ph_vlanIdx == rtl8651_vlanTableIndex(tunnel.loopBackVid))
				{
					pHdr->ph_vlanIdx = rtl8651_vlanTableIndex(tunnel.wanVid);
					pHdr->ph_portlist = tunnel.wanPort;
				}

				pHdr = pHdr->ph_nextHdr;	
			}
		}
#endif	

#ifdef RTL865X_PSEUDO_VLAN
		
		{
			struct rtl_pktHdr *pHdr = pkthdrPtr;
			rtl8651_tblDrv_vlanTable_t *srcVlan = NULL;

			while (pHdr)
			{
				srcVlan = &DrvTbl.vlan[pkthdrPtr->ph_vlanIdx];

				assert(srcVlan->valid);

				if (srcVlan->fvlan_t)	
				{
					pHdr->ph_vlanIdx = rtl8651_vlanTableIndex(srcVlan->fvlan_t->vid);
				}

				pHdr = pHdr->ph_nextHdr;	
			}
		}
#endif	

	}

	rtlglue_drvMutexUnlock();
	return local_val;	
}



#ifdef RTL8651_ALG_MODULE_UPDATE

 int32 rtl8651_fwdEngineRegisterAlgModule( 
 	uint16 startPort, uint16 endPort, uint8 isTcp, 
 	uint8 isServer, uint8 isClient, 
 	int32 (*alg_init)(void *),
	alg_funcptr alg_outboundClientcb,
	alg_funcptr alg_inboundClientcb,
	alg_funcptr alg_outboundServercb,
	alg_funcptr alg_inboundServercb )
{	
	rtl8651_tblDrv_algEntry_t *tb;
	int32 retval = FAILED;

	
	rtlglue_drvMutexLock();

	
	tb = _rtl8651_getAlgEntry( isTcp, startPort, endPort );

	
	if (tb != NULL)
	{
		
		retval = (tb->fwEngAdd == 1) ? SUCCESS : FAILED;
		goto out;
	}

	
	if ((alg_init != NULL) && (alg_init( NULL ) != SUCCESS))
	{
		retval = FAILED;
		goto out;
	}

	
	retval = _rtl8651_addALGRule( startPort, endPort, isTcp, isServer, isClient );
	if (retval != SUCCESS)
	{
		goto out;
	}

	
	tb = _rtl8651_getAlgEntry( isTcp, startPort, endPort );
	assert( tb != NULL );

	
	tb->fwEngAdd = 1; 
	tb->alg_outboundClientcb = (alg_funcptr_t)alg_outboundClientcb; 
	tb->alg_inboundClientcb =  (alg_funcptr_t)alg_inboundClientcb;
	tb->alg_outboundServercb = (alg_funcptr_t)alg_outboundServercb; 
	tb->alg_inboundServercb =  (alg_funcptr_t)alg_inboundServercb;	

	retval = SUCCESS;

out:
	rtlglue_drvMutexUnlock();

	return retval;
}




int32 rtl8651_fwdEngineRemoveAlgModule( uint16 startPort, uint16 endPort, uint16 isTcp )
{
	rtl8651_tblDrv_algEntry_t *tb;
	int8 isServer, isClient;
	int32 retval = FAILED;

	
	rtlglue_drvMutexLock();

	
	tb = _rtl8651_getAlgEntry( isTcp, startPort, endPort );
	
	if (tb != NULL)
	{
		if (tb->fwEngAdd != 1)
		{
			retval = FAILED;
			goto out;
		}
	}
	else
	{
		retval = FAILED;
		goto out;
	}

	
	isServer = tb->isServer;
	isClient = tb->isClient;
	retval = _rtl8651_delALGRule( startPort, endPort, isTcp, isServer, isClient );
out:
	rtlglue_drvMutexUnlock();
	
	return retval;
}




int32 rtl8651_fwdEngineFlushAlgModule( void )
{
	
	rtlglue_drvMutexLock();

	
	int n;
	for (n = 0; n < RTL8651_MAX_DIALSESSION; n++)
	{
		rtl8651a_flushAlgServerIn( n );
	}
	_rtl8651_flushALGRule();

	
	rtlglue_drvMutexUnlock();
	
	return SUCCESS;
}

#else


 int32 rtl8651_fwdEngineRegisterAlgModule(uint16 alg_port, uint16 isTcp, 
	int32	(*alg_init)(void *),
	alg_funcptr alg_outboundClientcb,
	alg_funcptr alg_inboundClientcb,
	alg_funcptr alg_outboundServercb,
	alg_funcptr alg_inboundServercb) 	
{									
	
	rtl8651_tblDrv_algEntry_t *tb;
	int8 isServer, isClient;
	int32 retval = FAILED;

	rtlglue_drvMutexLock();

	tb = _rtl8651_getAlgEntry(isTcp, &isServer, &isClient, alg_port, alg_port);
	
	if (tb)
	{ 
		if ( tb->fwEngAdd)
		{
			retval = SUCCESS;
			goto out;
		}else
		{
			retval = FAILED;
			goto out;
		}
	}
	if (alg_init && (SUCCESS != alg_init(NULL)))
	{
		retval = FAILED;
		goto out;
	}

	isClient = TRUE;
	isServer = TRUE;
	retval = rtl8651_addALGRule(alg_port, alg_port, isTcp, isServer, isClient);

	if (retval != SUCCESS)
	{
		goto out;
	}

	tb = _rtl8651_getAlgEntry(isTcp, &isServer, &isClient, alg_port, alg_port);

	assert(tb);
	
	tb->fwEngAdd = 1; 
	tb->alg_outboundClientcb = (alg_funcptr_t)alg_outboundClientcb; 
	tb->alg_inboundClientcb =  (alg_funcptr_t)alg_inboundClientcb;
	tb->alg_outboundServercb = (alg_funcptr_t)alg_outboundServercb; 
	tb->alg_inboundServercb =  (alg_funcptr_t)alg_inboundServercb;	

	retval = SUCCESS;

out:
	rtlglue_drvMutexUnlock();

	return retval;
	
}


int32 rtl8651_fwdEngineRemoveAlgModule(uint16 alg_port, uint16 isTcp)
{

	rtl8651_tblDrv_algEntry_t *tb;
	int8 isServer, isClient;
	int32 retval = FAILED;

	rtlglue_drvMutexLock();

	tb = _rtl8651_getAlgEntry(isTcp, &isServer, &isClient, alg_port, alg_port);
	
	if(tb)
	{ 
		if( tb->fwEngAdd == 0)
		{
			retval = FAILED;
			goto out;
		}
	} else
	{
		retval = FAILED;
		goto out;
	}

	retval = rtl8651_delALGRule(alg_port, alg_port, isTcp, isServer, isClient);

out:
	rtlglue_drvMutexUnlock();
	return retval;
}
#endif

void _rtl8651_fwdEngineTimeUpdate(uint32 secPassed)
{

#ifdef _RTL_QUEUE_ARP_PACKET
	_rtl8651_queuePacketSecondTimer();
#endif 

#ifdef _RTL_UPNP
	_rtl8651_uPnPOneSecondTimer();
#endif 

#ifdef _RTL_DOS_PLUGIN
	rtl8651_dosOneSecondTimer();
#endif 

#ifdef _RTL_PORT_BOUNCING
	_rtl8651_portBouncingTimeUpdate(secPassed);
#endif

#ifndef RTL865X_TEST
	rtl8651_algOneSecondTimer();
#endif 

#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
	_rtl8651_fragmentShortestPathCache_timeUpdate(secPassed);
#endif 

#ifdef _RTL_NAPT_REDIRECT
	_rtl8651_naptRedirectFlowTimeUpdate(secPassed);
#endif  

#ifdef _RTL_NAPT_FRAG
	_rtl8651_fragCache_timeUpdate(secPassed);
#endif 

#ifdef _RTL_TRIGGER_PORT
	_rtl8651_TriggerPortTimeUpdate(secPassed);
#endif 

}




static inline int32 _rtl8651_l4SeqDiff(uint32 x, uint32 y)
{

	
	return ((y) - (x));
}


int32 _rtl8651_l4GetDeltaSeqOut(struct ip * pip, struct tcphdr *tc, rtl8651_tblDrv_naptTcpUdpFlowEntry_t  *tb)
{

	int32     i;
	int32     delta, seq_diff_min;
	uint32    seq;

	seq = PKTGET_UINT32_UNALIGNED(&tc->th_seq);

	delta = 0;
	seq_diff_min = -1;
	for (i = 0; i < L4_N_LINK_TCP_DATA; i++)
	{
		struct l4ack_data_record x;

		rtl8651_memcpy(&x,&tb->ack[i], sizeof(struct l4ack_data_record));
		
		if (x.active == 1)
		{
			int32     seq_diff;

			seq_diff = _rtl8651_l4SeqDiff(x.ack_old, seq);
			if (seq_diff >= 0)
			{
				if (seq_diff_min >= 0)
				{
					if (seq_diff < seq_diff_min)
					{
						delta = x.delta;
						seq_diff_min = seq_diff;
					}
				}
				else
				{
					delta = x.delta;
					seq_diff_min = seq_diff;
				}
			}
		}
	}

	return (delta);
}



#define FWDENG_INTERNAL_FUNCTIONS




#define _rtl8651__INRANGE(c,l,h) (((uint32) ((c) - (l))) <= ((uint32) ((h)-(l))))

int32 _rtl8651_isdigit(int32 c)
{
	return  _rtl8651__INRANGE(c,'0','9');
}

int32 _rtl8651_isspace(int32 c )
{
	return (c==0x20) | _rtl8651__INRANGE(c,'\t','\r');
}

#ifdef _RTL_NAPT_FRAG




static uint32 _rtl8651_fragCacheInit(void)
{
	int i;

	
	for ( i = 0 ; i < RTL8651_FRAGCACHE_TYPE_COUNT ; i ++)
	{
		_rtl8651_fragCache[i] = NULL;
	}

	
	if (_rtl8651_max_fragCache_count)
	{
		for ( i = 0 ; i < RTL8651_FRAGCACHE_TYPE_COUNT ; i ++)
		{
			_rtl8651_fragCache[i] = (_rtl8651_frag_t *)rtlglue_malloc(sizeof(_rtl8651_frag_t) * (_rtl8651_max_fragCache_count));
			if (_rtl8651_fragCache[i] == NULL)
				return FAILED;
			
			memset(_rtl8651_fragCache[i], 0, (sizeof(_rtl8651_frag_t) * (_rtl8651_max_fragCache_count)));
		}
	}

	return SUCCESS;
}


static void _rtl8651_fragCacheReinit(void)
{

	int i;

	for ( i = 0 ; i < RTL8651_FRAGCACHE_TYPE_COUNT ; i ++)
	{
		if (_rtl8651_fragCache[i])
		{
			memset(_rtl8651_fragCache[i], 0, (sizeof(_rtl8651_frag_t) * (_rtl8651_max_fragCache_count)));
		}
	}
}




static inline uint32 _rtl8651_getFragCache(int32 FlowType, ipaddr_t org_sip, ipaddr_t org_dip, uint16 ip_id, ipaddr_t *newIp, int8 *routeIdx, rtl8651_tblDrv_naptTcpUdpFlowEntry_t **naptEntryp, uint8 *dsid)
{
	int i;
	_rtl8651_frag_t *cachePtr;

	assert((FlowType >= 0) && (FlowType < RTL8651_FRAGCACHE_TYPE_COUNT));

#ifdef RTL8651_FRAGCACHE_DEBUG
	printk("[FRAG CACHE] -Get- Type[%d] sip[%u.%u.%u.%u] dip[%u.%u.%u.%u] id[%d]\n", FlowType, NIPQUAD(org_sip), NIPQUAD(org_dip), ip_id);
#endif 

	cachePtr = _rtl8651_fragCache[FlowType];

	for (i = 0 ; i < _rtl8651_max_fragCache_count ; i ++)
	{
#ifdef RTL8651_FRAGCACHE_DEBUG
	printk("[FRAG CACHE] -Entry Check- Entry [%d]\n\tage[%d]\n\torg sip[%u.%u.%u.%u] <-> [%u.%u.%u.%u]\n\torg dip[%u.%u.%u.%u] <-> [%u.%u.%u.%u]\n\tid[%d] <-> [%d]\n",
		i,
		cachePtr[i].age,
		NIPQUAD(cachePtr[i].org_sip), NIPQUAD(org_sip),
		NIPQUAD(cachePtr[i].org_dip), NIPQUAD(org_dip),
		cachePtr[i].ip_id, ip_id
		);
#endif 

		if (	(cachePtr[i].age > 0) &&
			(org_sip == cachePtr[i].org_sip) &&
			(org_dip == cachePtr[i].org_dip) &&
			(ip_id == cachePtr[i].ip_id)	)
		{
#ifdef RTL8651_FRAGCACHE_DEBUG
	printk("[FRAG CACHE] -Get OK- new Ip[%u.%u.%u.%u] rtIdx[%d] naptEntry[%p] dsid[%d]\n"
		, NIPQUAD(cachePtr[i].new_ip), cachePtr[i].routeIdx, cachePtr[i].napt_entry_t, cachePtr[i].dsid);
#endif 

			
			if (newIp)
				*newIp = cachePtr[i].new_ip;
			if (routeIdx)
				*routeIdx = cachePtr[i].routeIdx;
			if (naptEntryp)
			{
				if (cachePtr[i].napt_entry_t && ((rtl8651_tblDrv_naptTcpUdpFlowEntry_t*)(cachePtr[i].napt_entry_t))->alive)
					*naptEntryp = cachePtr[i].napt_entry_t;
				else
					*naptEntryp = NULL;
			}
			if (dsid)
				*dsid = cachePtr[i].dsid;

			return SUCCESS;
		}
	}

#ifdef RTL8651_FRAGCACHE_DEBUG
	printk("[FRAG CACHE] -Get FAIL-\n");
#endif 

	return FAILED;
}


static inline _rtl8651_frag_t *_rtl8651_getFragCacheEntry(int32 FlowType, ipaddr_t org_sip, ipaddr_t org_dip, uint16 ip_id)
{
	int i;
	_rtl8651_frag_t *cachePtr;

	assert((FlowType >= 0) && (FlowType < RTL8651_FRAGCACHE_TYPE_COUNT));

	cachePtr = _rtl8651_fragCache[FlowType];

	for (i = 0 ; i < _rtl8651_max_fragCache_count ; i ++)
	{
		if (	(cachePtr[i].age > 0) &&
			(org_sip == cachePtr[i].org_sip) &&
			(org_dip == cachePtr[i].org_dip) &&
			(ip_id == cachePtr[i].ip_id)	)
		{
			return &cachePtr[i];
		}
	}
	return NULL;
}



static inline void _rtl8651_updateFragCache(int32 FlowType, ipaddr_t org_sip, ipaddr_t org_dip, uint16 ip_id, ipaddr_t ip_addr, int8 routeIdx, rtl8651_tblDrv_naptTcpUdpFlowEntry_t *naptEntry, uint8 dsid)
{
	int i;
	_rtl8651_frag_t *cachePtr;
	_rtl8651_frag_t *entryToAdd;
	uint32 minAge = _rtl8651_max_fragCache_age + 1;

	assert((FlowType >= 0) && (FlowType < RTL8651_FRAGCACHE_TYPE_COUNT));
	assert(dsid < RTL8651_MAX_DIALSESSION);

#ifdef RTL8651_FRAGCACHE_DEBUG
	printk("[FRAG CACHE] -Update- Type[%d] sip[%u.%u.%u.%u] dip[%u.%u.%u.%u] id[%d]\n", FlowType, NIPQUAD(org_sip), NIPQUAD(org_dip), ip_id);
	printk("[FRAG CACHE] -data- new Ip[%u.%u.%u.%u] routeIdx[%d] naptEntry[%p] dsid[%d]\n", NIPQUAD(ip_addr), routeIdx, naptEntry, dsid);
#endif 

	
	cachePtr = _rtl8651_getFragCacheEntry(FlowType, org_sip, org_dip, ip_id);
	if (cachePtr)
	{	
#ifdef RTL8651_FRAGCACHE_DEBUG
	printk("[FRAG CACHE] -Exist- update IP[%s] -- RouteIdx[%s] -- NaptEntry[%s] -- dsid[%s]\n",
			(cachePtr->new_ip==ip_addr)?"No":"Yes",
			(cachePtr->routeIdx==routeIdx)?"No":"Yes",
			(cachePtr->napt_entry_t==naptEntry)?"No":"Yes",
			(cachePtr->dsid==dsid)?"No":"Yes"
			);
#endif 
		
		cachePtr->age = _rtl8651_max_fragCache_age;
		
		cachePtr->new_ip = ip_addr;
		cachePtr->routeIdx = routeIdx;
		cachePtr->napt_entry_t = naptEntry;
		cachePtr->dsid = dsid;

		return;
	}

	
	cachePtr = _rtl8651_fragCache[FlowType];
	entryToAdd = NULL;

#ifdef RTL8651_FRAGCACHE_DEBUG
	int dbg_i = -1;
#endif 

	for ( i = 0 ; i < _rtl8651_max_fragCache_count ; i ++ )
	{
		if (cachePtr[i].age == 0)
		{
			entryToAdd = &cachePtr[i];

#ifdef RTL8651_FRAGCACHE_DEBUG
	printk("[FRAG CACHE] -Find Empty Entry to add- Entry index [%d]\n", i);
#endif 

			goto found;
		}
		if (cachePtr[i].age < minAge)
		{
			entryToAdd = &cachePtr[i];
			minAge = cachePtr[i].age;

#ifdef RTL8651_FRAGCACHE_DEBUG
			dbg_i = i;
#endif 

		}
	}
#ifdef RTL8651_FRAGCACHE_DEBUG
	printk("[FRAG CACHE] -Find Min age Entry to add- Entry index [%d]\n", dbg_i);
#endif 

found:
	assert(entryToAdd);
	
	entryToAdd->age = _rtl8651_max_fragCache_age;
	
	entryToAdd->org_sip = org_sip;
	entryToAdd->org_dip = org_dip;
	entryToAdd->ip_id = ip_id;
	
	entryToAdd->new_ip = ip_addr;
	entryToAdd->routeIdx = routeIdx;
	entryToAdd->napt_entry_t = naptEntry;
	entryToAdd->dsid = dsid;

	return;
}


void _rtl8651_fragCache_timeUpdate(uint32 secPassed)
{
	int i;
	_rtl8651_frag_t *cachePtr;

	for ( i = 0 ; i < RTL8651_FRAGCACHE_TYPE_COUNT ; i ++)
	{
		cachePtr = _rtl8651_fragCache[i];
		if (cachePtr)
		{
			int j;
			for ( j = 0 ; j < _rtl8651_max_fragCache_count ; j ++ )
			{
				if (cachePtr[j].age > secPassed)
					cachePtr[j].age -= secPassed;
				else
				{
#ifdef RTL8651_FRAGCACHE_DEBUG
					if (cachePtr[j].age > 0)
						printk("[FRAG CACHE] -Expire - Type [%d] Entry index [%d] -- Time[%d]\n", i, j, _sysUpSeconds);
#endif 

					cachePtr[j].age = 0;
				}
			}	
		}
	}
}


#endif 




static int32 _rtl8651_pktAccessGateway (ipaddr_t srcIpAddr, ipaddr_t dstIpAddr, uint16 vid)
{
	uint32 natIdx;

	if (_rtl8651_extIpAddr(dstIpAddr, &natIdx) == TRUE)
	{
		goto true;
	}else if (_rtl8651_intIpAddr(dstIpAddr) == TRUE)
	{
		rtl8651_tblDrv_vlanTable_t *vlanp;

		vlanp = &DrvTbl.vlan[vid & (RTL8651_VLAN_NUMBER - 1)];

		if ((vlanp->internal) && (_rtl8651_intNetIpAddr(srcIpAddr) == TRUE))	
		{
			goto true;
 		}
	}

	return FALSE;
true:
	return TRUE;
}




static int32 _rtl8651_l2Relay(struct rtl_mBuf *inMbufPtr)
{
	struct rtl_pktHdr *phdr;
	uint16 vid = 0, memberPort = 0;

	phdr = inMbufPtr->m_pkthdr;

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	if (DrvTbl.vlan[phdr->ph_vlanIdx].vid == tunnel.loopBackVid)
	{
		
	} else
#endif
	{
		struct rtl_mBuf *mbufPtr;
	
		mbufPtr = mBuf_dupPacket(inMbufPtr, MBUF_DONTWAIT);

		if(mbufPtr == NULL)
		{
			#ifdef RTL865X_DEBUG
			rtlglue_printf("No more mbufs for relaying brdcast pkt\n");
			#endif
			return FAILED;
		}

		
#ifdef RTL865XB_DCUT_SWVLAN
		if ( mbufPtr->m_pkthdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN )
		{
			vid = phdr->ph_svid;
			memberPort = DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)].memberPortUpStatus;
		} else
#endif 
		{
			vid = DrvTbl.vlan[phdr->ph_vlanIdx].vid;
			memberPort = DrvTbl.vlan[phdr->ph_vlanIdx].memberPortUpStatus;
		}

		
		mbufPtr->m_pkthdr->ph_flags &= (~(CSUM_IP | CSUM_L4));
		
		mbufPtr->m_pkthdr->ph_portlist = memberPort & ~(1<<phdr->ph_portlist);	
		if (_rtl8651_fwdEngineSend(FWDENG_L2PROC|FWDENG_FROMDRV, (void*)mbufPtr->m_pkthdr, vid, -1) != SUCCESS)
		{
			mBuf_driverFreeMbufChain(mbufPtr);
		}
	}

	return SUCCESS;
}


static int32 _rtl8651_drvArpGeneration(ipaddr_t ipAddr)
{
	uint32 natIdx;
	int32 retval;
	int8 *bufptr;
	ether_addr_t macAddr;
	rtl8651_tblDrv_networkIntfTable_t * netIntfPtr;
	rtl8651_tblDrv_ipIntfEntry_t * ipIntfPtr;
	struct rtl_mBuf *mbufPtr;

	if(_rtl8651_intNetIpAddr(ipAddr) == FALSE && _rtl8651_extNetIpAddr(ipAddr, &natIdx) == FALSE)
		return FAILED;
	if(_rtl8651_getArpEntry(NULL, ipAddr, TRUE) != NULL)	
		return FAILED;
	if((netIntfPtr =  _rtl8651_getNetworkIntfEntryByAddr(ipAddr)) == NULL)
		return FAILED;	
	if((ipIntfPtr = _rtl8651_getIpIntfEntryByAddr(ipAddr)) == NULL)
		return FAILED;	
	if((mbufPtr = mBuf_get(MBUF_DONTWAIT, MBUFTYPE_DATA, 1)) == NULL)
		return FAILED;
	if(mBuf_getPkthdr(mbufPtr, MBUF_DONTWAIT) == (struct rtl_mBuf *) NULL)
	{
		mBuf_freeMbufChain(mbufPtr);
		return FAILED;
	}
	
	mbufPtr->m_data = (void *)rtlglue_mbufClusterToData(mbufPtr->m_data);

	if (mBuf_reserve(mbufPtr,rtl8651_fwdEnginePara.mbufHeadroom))
	{
		mBuf_freeMbufChain(mbufPtr);
		return FAILED;
	}
	bufptr=(int8 *)mbufPtr->m_data;
	
	memset(bufptr,0xff, 6);
	rtl8651_getVlanMacAddress(netIntfPtr->vid, &macAddr, NULL);
	
	rtl8651_memcpy(bufptr + 6,(int8 *)&macAddr.octet[0],6);
	
	*(uint32 *)(bufptr + 12) = htonl(0x08060001);
	*(uint32 *)(bufptr + 16) = htonl(0x08000604);
	*(uint16 *)(bufptr + 20) = htons(0x0001);
	rtl8651_memcpy(bufptr + 22,(int8 *)&macAddr.octet[0],6);
	*(uint32 *)(bufptr + 28) = htonl(ipIntfPtr->ipAddr.slh_first->ipAddr);
	*(uint32 *)(bufptr + 32) = htonl(0x0);
	*(uint16 *)(bufptr + 36) = htonl(0x0);
	PKTSET_UINT32_UNALIGNED(ipAddr, bufptr+38);
	
	mbufPtr->m_len = 60;
	mbufPtr->m_pkthdr->ph_len = 60;
	mbufPtr->m_pkthdr->ph_portlist = (DrvTbl.vlan[netIntfPtr->vid&(RTL8651_VLAN_NUMBER-1)].memberPortMask);	
	mbufPtr->m_pkthdr->ph_property = PH_PROPER_DRVFWD;
	retval = _rtl8651_fwdEngineSend(	FWDENG_L34PROC|FWDENG_FROMDRV,	
									(void*)mbufPtr->m_pkthdr,
									netIntfPtr->vid,
									-1);
	if(retval == SUCCESS)
	{
		rtl8651_fwdEngineCounter.arpGenerate++;
	}else
	{
		mBuf_driverFreeMbufChain(mbufPtr);
	}
	return SUCCESS;	
}


static int32 _rtl8651_drvArpAgent(struct rtl_pktHdr *pkthdrPtr, struct rtl_mBuf *mbufPtr, uint16 vid)
{
	ipaddr_t srcIpAddr, dstIpAddr;
	int8 *bufptr;
	int32 retval;
	ether_addr_t macAddr;
	rtl8651_tblDrv_networkIntfTable_t * netIntfPtr;
	uint32 dummy = 14;
	uint32 etherTypePosition = 12;

	rtl8651_fwdEngineCounter.arpReceive++;	
	mbufPtr = pkthdrPtr->ph_mbuf;

	if ((netIntfPtr = _rtl8651_getNetworkIntfEntryByVid(vid)) == NULL)
	{
		return FWDENG_NETIFACENOTFOUND;	
	}

	bufptr = (int8 *)mbufPtr->m_data;	

	if (_getEthTypeIpOffset(pkthdrPtr, bufptr, &etherTypePosition, &dummy, &dummy) != SUCCESS)
	{
		assert(0);
		return FWDENG_DROP;	
	}

	
	memcpy(&macAddr, (bufptr+etherTypePosition+10),6);						
	srcIpAddr = PKTGET_UINT32_UNALIGNED(bufptr+(etherTypePosition+16));	

	if (srcIpAddr == 0)
	{
		return FWDENG_DROP;
	}

	if (_rtl8651_addLocalArp(TRUE, srcIpAddr, &macAddr, netIntfPtr, pkthdrPtr->ph_portlist) == SUCCESS)
	{
		rtl8651_fwdEngineCounter.arpAddSuccess++;

#ifdef _RTL_QUEUE_ARP_PACKET
		{
			struct rtl_pktHdr * q_pkt;
			struct ip *local_ip_p;
			uint32 local_dst_ip;
			int32 local_cnt = 0;
			struct ip fake_ip;
			fake_ip.ip_dst.s_addr = srcIpAddr;

			while (1)
			{
				local_cnt++;
				if (local_cnt > QUEUE_PACKET_ITEM)
				{
					_rtl8651_queuePacketSecondTimer();
					break;
				}
				q_pkt = _rtl8651_queryQuenePacket(&fake_ip, Q_ARP, &local_dst_ip, &local_ip_p);
				if (q_pkt == NULL)
				{
					break;
				}			
				
				if (_rtl8651_l3ActRouting(q_pkt, local_dst_ip, local_ip_p) != SUCCESS)
				{
					mBuf_freeMbufChain(q_pkt->ph_mbuf);
				}
			}
		}
#endif 

	}else
	{
		rtl8651_fwdEngineCounter.arpAddFail ++;
	}
	
	if (*(uint16 *)(bufptr + (etherTypePosition+8)) == htons(0x1))
	{	

		
		srcIpAddr = PKTGET_UINT32_UNALIGNED(bufptr + (etherTypePosition + 16));
		dstIpAddr = PKTGET_UINT32_UNALIGNED(bufptr + (etherTypePosition + 26));

		
		if (_rtl8651_pktAccessGateway(srcIpAddr, dstIpAddr, vid) == FALSE)
		{
			
			if (rtl8651_drvArpProxyProcessEnable)
			{	
				rtl8651_tblDrv_vlanTable_t *vlanp;
				vlanp = &DrvTbl.vlan[vid & (RTL8651_VLAN_NUMBER - 1)];
				if (vlanp->internal)	
				{
					rtl8651_tblDrv_routeTable_t *rt;
					rt =  _rtl8651_getRoutingEntry(dstIpAddr);
					if ((rt == NULL) || (rt->dvid != vid))	
					{
						goto send_reply;
					}
				}
			}
			return FWDENG_ARP_OTHERS;	
		}
		
		if (!rtl8651_drvArpProcessEnable)
		{	
			return FWDENG_ARP_REQUEST;	
		}

send_reply:
		
		{
			struct rtl_mBuf *mbuf_arpReply = NULL;
			struct rtl_pktHdr *pkthdr_arpReply = NULL;
			uint8 *bufptr_reply;

			
			if ((mbuf_arpReply = mBuf_dupPacket(pkthdrPtr->ph_mbuf, MBUF_DONTWAIT)) == NULL )
			{
				retval = FAILED;
				goto reply_out;
			}

			pkthdr_arpReply = mbuf_arpReply->m_pkthdr;
			bufptr_reply = mbuf_arpReply->m_data;

			rtl8651_memcpy((bufptr_reply + (etherTypePosition+20)), (bufptr_reply + (etherTypePosition+10)), 10);	
			*(uint16 *)(bufptr_reply + (etherTypePosition+8)) = htons(0x2);										
			rtl8651_memcpy(bufptr_reply, (bufptr_reply + 6), 6);												
			rtl8651_getVlanMacAddress(vid, &macAddr, NULL);												
			rtl8651_memcpy((bufptr_reply+6), ((int8 *)&macAddr.octet[0]), 6);									
			rtl8651_memcpy((bufptr_reply+(etherTypePosition+10)), ((int8 *)&macAddr.octet[0]), 6);				
			PKTSET_UINT32_UNALIGNED(dstIpAddr, (bufptr_reply+(etherTypePosition+16)));						

			
			pkthdr_arpReply->ph_portlist = (1 << pkthdr_arpReply->ph_portlist);
			pkthdr_arpReply->ph_property = PH_PROPER_DRVFWD;
			pkthdr_arpReply->ph_iphdrOffset = 0;

			retval = _rtl8651_fwdEngineSend(	FWDENG_L2PROC|FWDENG_FROMDRV,	
											(void*)pkthdr_arpReply,
											vid,
											-1);

reply_out:

			if ( retval == SUCCESS )
			{
				rtl8651_fwdEngineCounter.arpReply ++;
			} else
			{
				if ( mbuf_arpReply )
				{
					mBuf_driverFreeMbufChain( mbuf_arpReply );
				}
			}

			
			mBuf_driverFreeMbufChain( pkthdrPtr->ph_mbuf );

			
			return SUCCESS; 
		}
	}
	return FWDENG_ARP_NOTREQ;
}


int32 _rtl8651_drvIcmpErrorGeneration(struct rtl_pktHdr *pkthdrPtr, struct ip* ip, _rtl8651_IcmpPktField_t *icmp_info, uint16 vid) {
	rtl8651_tblDrv_networkIntfTable_t * netIntf;
	rtl8651_tblDrv_ipIntfEntry_t *ipIntf;
	int8 org_pkt[((ip->ip_vhl&0xf)<<2) + 8];
	uint16 org_pkt_len;
	struct icmp *ic;
	ipaddr_t sip;
	void *macHdr;
	ether_addr_t macAddr;
	int32 retval;
	uint16 trailer_len;		
	uint16 icmp_ip_len;		
	uint16 icmp_total_len;	
	
	switch (icmp_info->ic_type)
	{
		case ICMP_TIMXCEED:
		case ICMP_UNREACH:
			break;
		default:
			return FAILED;	
	}


	
	netIntf = _rtl8651_getNetworkIntfEntryByVid(vid);
	if ((netIntf == NULL) ||(netIntf->valid == 0) || (SLIST_FIRST(&netIntf->IpHead) == NULL))
	{
		return FAILED;
	}
	ipIntf = SLIST_FIRST(&netIntf->IpHead);
	sip =ipIntf->ipAddr.slh_first->ipAddr;

	
	{
		uint16 org_iphdr_len = (ip->ip_vhl&0xf)<<2;
		uint16 org_ip_len = ntohs(ip->ip_len);
		
		if ((org_ip_len - org_iphdr_len) > 8)
		{
			org_pkt_len = org_iphdr_len + 8;
			trailer_len = 0;
		}else
		{
			org_pkt_len = org_ip_len;
			trailer_len = 8 - (org_ip_len - org_iphdr_len);
		}
	}
	icmp_ip_len = 20 + 8 + org_pkt_len + trailer_len;		
	memset(org_pkt, 0, org_pkt_len);
	rtl8651_memcpy(org_pkt, ip, org_pkt_len);			

	
	icmp_total_len = pkthdrPtr->ph_iphdrOffset + icmp_ip_len;
	{
		uint16 org_total_len = pkthdrPtr->ph_len;
		if (org_total_len > icmp_total_len)
		{
			mBuf_adjTail(pkthdrPtr->ph_mbuf, (uint32)(org_total_len - icmp_total_len));
		}else
		{
			pkthdrPtr->ph_len = icmp_total_len;
			pkthdrPtr->ph_mbuf->m_len = icmp_total_len;
		}
	}

	
	ic = (struct icmp *)((uint32)ip + 20);	
	ic->icmp_type = icmp_info->ic_type;
	ic->icmp_code = icmp_info->ic_code;
	if (icmp_info->ic_mtu)
	{
		ic->icmp_pmvoid = 0;
		ic->icmp_nextmtu = htons(icmp_info->ic_mtu);
	}else
	{
		PKTSET_UINT32_UNALIGNED((uint32)0, &ic->icmp_void);
	}
	rtl8651_memcpy(&ic->icmp_ip, org_pkt, org_pkt_len);

	if (trailer_len)
	{
		memset((void*)((uint32)ip + (uint32)icmp_ip_len - (uint32)trailer_len), 0, trailer_len);
	}
	
	ip->ip_vhl = 0x45;
	ip->ip_tos = 0;
	ip->ip_len = htons(icmp_ip_len);
	ip->ip_off = 0;
	ip->ip_ttl = 0x80;
	ip->ip_p = IPPROTO_ICMP;
	
	rtl8651_memcpy(&ip->ip_dst, &ip->ip_src, 4);			
	PKTSET_UINT32_UNALIGNED(sip, &ip->ip_src);			

	
	pkthdrPtr->ph_proto = PKTHDR_ICMP;					
	pkthdrPtr->ph_flags |= CSUM_L4;
	pkthdrPtr->ph_flags |= CSUM_IP;

	
	if( pkthdrPtr->ph_pppeTagged)
	{
		int8 tmpEther[14];
		
		rtl8651_memcpy(tmpEther, pkthdrPtr->ph_mbuf->m_data, 14);
		
		mBuf_adjHead(pkthdrPtr->ph_mbuf, 8);
		
		rtl8651_memcpy(pkthdrPtr->ph_mbuf->m_data, tmpEther, 14);
		
		PKTSET_UINT16_UNALIGNED(0x0800, (pkthdrPtr->ph_mbuf->m_data + 12));
		
		pkthdrPtr->ph_pppeTagged = 0;
	}

	if (netIntf->linkLayerType == RTL8651_LL_PPPOE)		
	{
		
		pkthdrPtr->ph_flags &= PKTHDR_PPPOE_AUTOADD;
	}

	
	macHdr = pkthdrPtr->ph_mbuf->m_data;
	rtl8651_memcpy(&macAddr, macHdr,6);			
	rtl8651_memcpy(macHdr,macHdr+6,6);			
	rtl8651_memcpy(macHdr+6,&macAddr,6);		

	pkthdrPtr->ph_portlist = (1<<pkthdrPtr->ph_portlist);
	pkthdrPtr->ph_property = PH_PROPER_DRVFWD;

	retval=_rtl8651_fwdEngineSend(	FWDENG_L34PROC|FWDENG_FROMDRV,	
									(void*)pkthdrPtr,
									vid,
									-1);

	if(retval==SUCCESS)
	{
		rtl8651_fwdEngineCounter.icmpReply++;
	}else
	{
		mBuf_driverFreeMbufChain(pkthdrPtr->ph_mbuf);
		rtl8651_fwdEngineCounter.icmpReplyFailed++;
	}
	return SUCCESS;
}

static inline int32 _rtl8651_drvIcmp(struct rtl_pktHdr *pkthdrPtr, struct ip* ip, struct icmp *icmp, uint16 vid) {
	rtl8651_tblDrv_networkIntfTable_t *netintf;
	ether_addr_t macAddr;
	ipaddr_t ipAddr;
	uint8 *cp = pkthdrPtr->ph_mbuf->m_data;
	int32 retval, tol_len;
	uint32 mtu;
	uint8 ttl;
	uint16 srcPortList;
	ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	ipaddr_t dip = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);

	if (ntohs(ip->ip_off) & (IP_OFFMASK))
	{		
		if (_rtl8651_getFragCache(ICMP_REPLY_FRAG, sip, dip, ntohs(ip->ip_id), NULL, NULL, NULL, &(pkthdrPtr->ph_dsid)) == SUCCESS)
		{
			goto proc_icmp;
		}else
		{
			return FAILED;
		}
	}

	switch (icmp->icmp_type)
	{
		case ICMP_ECHO:		
			break;
		default:
			return FAILED;	
	}

proc_icmp:

	
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	if (tunnel.valid && vid == tunnel.loopBackVid && pkthdrPtr->ph_portlist == tunnel.loopbackPort) {
		netintf = _rtl8651_getNetworkIntfEntryByVid(tunnel.wanVid);
	}else
#endif
	{
		netintf = _rtl8651_getNetworkIntfEntryByVid(vid);
	}
	if ((netintf == NULL) || (netintf->valid == 0))
	{
		return FAILED;
	}

	
	mtu = netintf->mtu;
	tol_len=mBuf_getPktlen(pkthdrPtr->ph_mbuf);

	
	rtl8651_memcpy(&macAddr, cp,6);		
	rtl8651_memcpy(cp,cp+6,6);			
	rtl8651_memcpy(cp+6,&macAddr,6);	

	
	rtl8651_memcpy(&ipAddr, &ip->ip_src, 4);		
	rtl8651_memcpy(&ip->ip_src, &ip->ip_dst, 4);	
	rtl8651_memcpy(&ip->ip_dst, &ipAddr, 4);		

	ttl			= ip->ip_ttl;		
	ip->ip_ttl	= 0x80;			

	if (!(ntohs(ip->ip_off) & IP_OFFMASK))
	{
		icmp->icmp_type = ICMP_ECHOREPLY;	
	}

	pkthdrPtr->ph_flags |= (CSUM_IP|CSUM_L4);
	if ((ntohs(ip->ip_off) & (IP_MF|IP_OFFMASK)) || ((ip->ip_vhl & 0x0f) != 5))
	{
		if ((ip->ip_vhl & 0x0f) != 5)
		{	
			pkthdrPtr->ph_flags &= ~CSUM_IP;
			_RTL8651_DATA_ADJUST_CHECKSUM((ip->ip_ttl << 8), (ttl << 8), ip->ip_sum);
		}
		if (!(ntohs(ip->ip_off) & IP_OFFMASK))
		{	
			_RTL8651_DATA_ADJUST_CHECKSUM((ICMP_ECHOREPLY<<8), (ICMP_ECHO<<8), icmp->icmp_cksum);
			if (ntohs(ip->ip_off) & IP_MF)
			{	
				_rtl8651_updateFragCache(ICMP_REPLY_FRAG, sip, dip, ntohs(ip->ip_id), (ipaddr_t)htonl(ipAddr), 0, NULL, pkthdrPtr->ph_dsid);
			}
		}
		pkthdrPtr->ph_flags &= ~CSUM_L4;
		pkthdrPtr->ph_proto = PKTHDR_IP;
	}

	pkthdrPtr->ph_flags |= CSUM_IP;

	srcPortList = pkthdrPtr->ph_portlist;
	pkthdrPtr->ph_portlist = (1<<pkthdrPtr->ph_portlist);
	pkthdrPtr->ph_property = PH_PROPER_DRVFWD;

	if (tol_len > (mtu+14)) 
	{
		int8 old_IcmpRoutingMsgEnable = rtl8651_drvIcmpRoutingMsgEnable;
		rtl8651_drvIcmpRoutingMsgEnable = FALSE;
		retval = _rtl8651_mtuFragment(FWDENG_L34PROC|FWDENG_FROMDRV, pkthdrPtr, mtu, vid, FALSE, srcPortList);
		rtl8651_drvIcmpRoutingMsgEnable = old_IcmpRoutingMsgEnable;
	}else 
		retval = _rtl8651_fwdEngineSend(FWDENG_L34PROC|FWDENG_FROMDRV, (void*)pkthdrPtr, vid,-1);

	if(retval==SUCCESS)
	{
		rtl8651_fwdEngineCounter.icmpReply++;
		return SUCCESS;
	}
	else
	{
		rtl8651_fwdEngineCounter.icmpReplyFailed++;
		rtl8651_fwdEngineCounter.icmpDrop++;
		return FWDENG_DROP;
	}
}


static inline int32 _rtl8651_drvPktDemandRouteTrigger(struct ip *pip)
{
	if (rtl8651_drvPktDemandRouteTrigger != TRUE)
	{
		return SUCCESS;
	}

	{
		
		if (!IS_FRAGMENT_REMAIN(pip->ip_off))
		{
			switch (pip->ip_p)
			{
				case IPPROTO_TCP:
				{
					struct tcphdr *tc;
					ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
					ipaddr_t dip = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);

					tc = (struct tcphdr *)L4HDR_ADDR(pip);

					if (ntohs(tc->th_dport) == 53)
					{
						_rtl8651_getDemandRoutingEntry(sip, dip, IPPROTO_TCP, ntohs(tc->th_sport), ntohs(tc->th_dport));
					}
				}
					break;
				case IPPROTO_UDP:
				{
					struct udphdr *ud;
					ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
					ipaddr_t dip = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);

					ud = (struct udphdr *)L4HDR_ADDR(pip);

					if (ntohs(ud->uh_dport) == 53)
					{
						_rtl8651_getDemandRoutingEntry(sip, dip, IPPROTO_UDP, ntohs(ud->uh_sport), ntohs(ud->uh_dport));
					}
				}
			}
		}
	}

	return SUCCESS;
}

static int32 _rtl8651_drvIcmpAgent(struct rtl_pktHdr * pkthdrPtr, struct ip* ip, uint16 vid)
{

	if (_rtl8651_pktAccessGateway(pkthdrPtr->ph_sip, pkthdrPtr->ph_dip, vid) != TRUE)
	{
		return FAILED;
	}

	
	return _rtl8651_drvIcmp(pkthdrPtr, ip, (struct icmp *)L4HDR_ADDR(ip), vid);
}

int32 _rtl8651_ingressAcl(uint32 dsid, uint32 startIdx, rtl8651_tblDrv_vlanTable_t *pVlan, int32 vid, uint8 *m_data, uint8 *ip, uint32 matchType, uint32 optLayer){
	_rtl8651_tblDrvAclRule_t *acl_tb;
	rtl8651_tblDrv_networkIntfTable_t *netif_tb;
	int8 defPermit = TRUE;
	struct ip *pip=(struct ip*)ip;
	
	netif_tb = _rtl8651_getNetworkIntfEntryByVid(vid);
	if(netif_tb){
		acl_tb = _rtl8651_aclLookUp(dsid, netif_tb, TRUE, startIdx, (int8 *)m_data, (int8*)ip,&defPermit, matchType, optLayer);
		if(acl_tb){
			switch(acl_tb->actionType_){
				case RTL8651_ACL_PERMIT:
					rtl8651_fwdEngineCounter.inAclPermit++;
					return SUCCESS;
				case RTL8651_ACL_DROP:
					rtl8651_fwdEngineCounter.inAclDrop++;
					return FWDENG_ACL_IN_DROP|FWDENG_DROP;
				case RTL8651_ACL_DROP_LOG:
					rtl8651_fwdEngineCounter.inAclDrop++;
					if (  (_loggingModule[dsid]&RTL8651_LOGMODULE_ACL)
						&& _pUserLoggingFunc
						&& ip											
#ifdef RTL8651_DSID_SUPPORT						
						&& (_rtl8651_acl_drop_nolog[dsid]==0)
#endif
					){
#ifdef _RTL_NEW_LOGGING_MODEL
						rtl8651_logInfo_t info;
						struct tcphdr *tc = NULL;
						struct udphdr *ud = NULL;
						struct icmp *ic = NULL;
						uint16 sport = 0xffff;
						uint16 dport = 0xffff;
						uint8 type = 0xff;
						uint16 id = 0xffff;

						if (!IS_FRAGMENT_REMAIN(pip->ip_off))
						{
							switch(pip->ip_p)
							{
								case IPPROTO_TCP:
									tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
									sport = ntohs(tc->th_sport);
									dport = ntohs(tc->th_dport);
									break;
								case IPPROTO_UDP:
									ud = (struct udphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
									sport = ntohs(ud->uh_sport);
									dport = ntohs(ud->uh_dport);
									break;
								case IPPROTO_ICMP:
									ic = (struct icmp *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
									type = ic->icmp_type;
									id = ntohs(ic->icmp_id);
									break;
							}
						}

						info.infoType		= RTL8651_LOG_INFO_PKT;
						info.pkt_dsid		= dsid;
						info.pkt_sip		= PKTGET_UINT32_UNALIGNED(&pip->ip_src);
						info.pkt_dip		= PKTGET_UINT32_UNALIGNED(&pip->ip_dst);
						info.pkt_proto		= pip->ip_p;
						info.pkt_direction	= (pVlan->internal?RTL8651_LAN2WAN:RTL8651_WAN2LAN);
						info.pkt_sport		= sport;
						info.pkt_dport		= dport;
						info.pkt_icmpType	= type;
						info.pkt_icmpId	= id;
						info.action		= RTL8651_LOGACTION_DROP;
						(* _pUserLoggingFunc)(RTL8651_LOGMODULE_ACL, RTL8651_LOG_ACL_IngressAclDropLog, &info);
#else
						struct tcphdr * tc =NULL;
						
						if (pip->ip_p==6||pip->ip_p==17) 
							tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
						
						
					  	(*_pUserLoggingFunc)(
					  		dsid,
						  	RTL8651_LOGMODULE_ACL,
						    (unsigned char)pip->ip_p, 
						    (unsigned char)(pVlan->internal?RTL8651_LAN2WAN:RTL8651_WAN2LAN), 
							(unsigned long)PKTGET_UINT32_UNALIGNED(&pip->ip_src.s_addr),
							(unsigned long)PKTGET_UINT32_UNALIGNED(&pip->ip_dst.s_addr),
							(unsigned short)(tc?(ntohs(tc->th_sport)):0xffffffff),
							(unsigned short)(tc?(ntohs(tc->th_dport)):0xffffffff),
							0, 
							RTL8651_LOGACTION_DROP, 
							"Ingress" );
#endif
					}
					return (FWDENG_ACL_IN_DROP|FWDENG_DROP);
				case RTL8651_ACL_CPU:
					rtl8651_fwdEngineCounter.inAclCpu++;
					return FWDENG_ACL_IN_USERTRAP;
				case RTL8651_ACL_DROP_NOTIFY:
					rtl8651_fwdEngineCounter.inAclDrop++;
					return (FWDENG_ACL_DROP_NOTIFY|FWDENG_DROP);
				case RTL8651_ACL_REDIRECT:
				case RTL8651_ACL_REDIRECT_PPPOE:
					
					rtl8651_fwdEngineCounter.inAclDrop++;
					return FWDENG_ACL_IN_DROP|FWDENG_DROP;
				default:
					if(defPermit != TRUE){
						rtl8651_fwdEngineCounter.inAclDrop++;
						return FWDENG_ACL_IN_DROP|FWDENG_DROP;
					}else{
						rtl8651_fwdEngineCounter.inAclPermit++;
						return SUCCESS;
					}
			}	
		}
		#if 1
		else {
			
			int8 defAction;
			int32 ret;
			ret=_rtl8651_getDefaultAcl(netif_tb->ifName,&defAction);
			assert(ret==SUCCESS);
			switch(defAction){
				case RTL8651_ACL_L34_DROP:
				case RTL8651_ACL_DROP:
					
					rtl8651_fwdEngineCounter.inAclDrop++;
					return FWDENG_ACL_IN_DROP|FWDENG_DROP;
				case RTL8651_ACL_DROP_LOG:
					
					rtl8651_fwdEngineCounter.inAclDrop++;
					if (
						(_loggingModule[dsid]&RTL8651_LOGMODULE_ACL)
						&&_pUserLoggingFunc
						&& ip											
					)
					{
#ifdef _RTL_NEW_LOGGING_MODEL
						rtl8651_logInfo_t info;
						struct tcphdr *tc = NULL;
						struct udphdr *ud = NULL;
						struct icmp *ic = NULL;
						uint16 sport = 0xffff;
						uint16 dport = 0xffff;
						uint8 type = 0xff;
						uint16 id = 0xffff;

						if (!IS_FRAGMENT_REMAIN(pip->ip_off))
						{
							switch(pip->ip_p)
							{
								case IPPROTO_TCP:
									tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
									sport = ntohs(tc->th_sport);
									dport = ntohs(tc->th_dport);
									break;
								case IPPROTO_UDP:
									ud = (struct udphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
									sport = ntohs(ud->uh_sport);
									dport = ntohs(ud->uh_dport);
									break;
								case IPPROTO_ICMP:
									ic = (struct icmp *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
									type = ic->icmp_type;
									id = ntohs(ic->icmp_id);
									break;
							}
						}

						info.infoType		= RTL8651_LOG_INFO_PKT;
						info.pkt_dsid		= dsid;
						info.pkt_sip		= PKTGET_UINT32_UNALIGNED(&pip->ip_src);
						info.pkt_dip		= PKTGET_UINT32_UNALIGNED(&pip->ip_dst);
						info.pkt_proto		= pip->ip_p;
						info.pkt_direction	= (pVlan->internal?RTL8651_LAN2WAN:RTL8651_WAN2LAN);
						info.pkt_sport		= sport;
						info.pkt_dport		= dport;
						info.pkt_icmpType	= type;
						info.pkt_icmpId	= id;
						info.action		= RTL8651_LOGACTION_DROP;
						(* _pUserLoggingFunc)(RTL8651_LOGMODULE_ACL, RTL8651_LOG_ACL_IngressAclDropLog, &info);
#else
						struct tcphdr * tc =NULL;
						
						if (pip->ip_p==6||pip->ip_p==17) 
							tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));						
						(*_pUserLoggingFunc)(
							dsid,
							RTL8651_LOGMODULE_ACL,
						    (unsigned char)pip->ip_p, 
						    (unsigned char)(pVlan->internal?RTL8651_LAN2WAN:RTL8651_WAN2LAN), 
							(unsigned long)PKTGET_UINT32_UNALIGNED(&pip->ip_src.s_addr),
							(unsigned long)PKTGET_UINT32_UNALIGNED(&pip->ip_dst.s_addr),
							(unsigned short)(tc?(ntohs(tc->th_sport)):0xffffffff),
							(unsigned short)(tc?(ntohs(tc->th_dport)):0xffffffff),
							0, 
							RTL8651_LOGACTION_DROP, 
							"Ingress" );
#endif
					}					
					return FWDENG_ACL_IN_DROP|FWDENG_DROP;
				case RTL8651_ACL_PERMIT:
					
					rtl8651_fwdEngineCounter.inAclPermit++;
					return SUCCESS;					
				case RTL8651_ACL_CPU:
					
					rtl8651_fwdEngineCounter.inAclPermit++;
					return SUCCESS;
				default:
					assert(0);
					break;
			}
		}
		#endif
	}
	return SUCCESS;
}

int32 _rtl8651_egressAcl(uint32 dsid,rtl8651_tblDrv_vlanTable_t *pVlan,int32 vid, uint8 *ethHdr, uint8 *ip){
	_rtl8651_tblDrvAclRule_t *acl_tb;
	rtl8651_tblDrv_networkIntfTable_t *netif_tb;
	int8 defPermit = TRUE;
	struct ip *pip=(struct ip*)ip;	
	netif_tb = _rtl8651_getNetworkIntfEntryByVid(vid);

	if(netif_tb){
		acl_tb = _rtl8651_aclLookUp(dsid,netif_tb,FALSE,0,(int8 *)ethHdr,(int8*)ip,&defPermit, 0, _RTL8651_OPERATION_OTHER);

		
		
		

		if(acl_tb) { 
			switch(acl_tb->actionType_){
			case RTL8651_ACL_PERMIT:
				rtl8651_fwdEngineCounter.outAclPermit++;
				return SUCCESS;
			case RTL8651_ACL_DROP:
				rtl8651_fwdEngineCounter.outAclDrop++;
				return FWDENG_ACL_OUT_DROP|FWDENG_DROP;
			case RTL8651_ACL_DROP_LOG:
				rtl8651_fwdEngineCounter.outAclDrop++;
				
				if (  (_loggingModule[dsid]&RTL8651_LOGMODULE_ACL)
					&& _pUserLoggingFunc
					&& ip											
#ifdef RTL8651_DSID_SUPPORT
					&& (_rtl8651_acl_drop_nolog[dsid]==0) 
#endif					
				){
#ifdef _RTL_NEW_LOGGING_MODEL
					rtl8651_logInfo_t info;
					struct tcphdr *tc = NULL;
					struct udphdr *ud = NULL;
					struct icmp *ic = NULL;
					uint16 sport = 0xffff;
					uint16 dport = 0xffff;
					uint8 type = 0xff;
					uint16 id = 0xffff;

					if (!IS_FRAGMENT_REMAIN(pip->ip_off))
					{
						switch(pip->ip_p)
						{
							case IPPROTO_TCP:
								tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
								sport = ntohs(tc->th_sport);
								dport = ntohs(tc->th_dport);
								break;
							case IPPROTO_UDP:
								ud = (struct udphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
								sport = ntohs(ud->uh_sport);
								dport = ntohs(ud->uh_dport);
								break;
							case IPPROTO_ICMP:
								ic = (struct icmp *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
								type = ic->icmp_type;
								id = ntohs(ic->icmp_id);
								break;
						}
					}

					info.infoType		= RTL8651_LOG_INFO_PKT;
					info.pkt_dsid		= dsid;
					info.pkt_sip		= PKTGET_UINT32_UNALIGNED(&pip->ip_src);
					info.pkt_dip		= PKTGET_UINT32_UNALIGNED(&pip->ip_dst);
					info.pkt_proto		= pip->ip_p;
					info.pkt_direction	= (pVlan->internal?RTL8651_LAN2WAN:RTL8651_WAN2LAN);
					info.pkt_sport		= sport;
					info.pkt_dport		= dport;
					info.pkt_icmpType	= type;
					info.pkt_icmpId	= id;
					info.action		= RTL8651_LOGACTION_DROP;
					(* _pUserLoggingFunc)(RTL8651_LOGMODULE_ACL, RTL8651_LOG_ACL_EgressAclDropLog, &info);
#else
					struct tcphdr * tc =NULL;
					if (pip->ip_p==6||pip->ip_p==17) 
						tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
					(*_pUserLoggingFunc)(
						dsid,
						RTL8651_LOGMODULE_ACL,
					    (unsigned char)pip->ip_p, 
					    (unsigned char)(pVlan->internal?RTL8651_LAN2WAN:RTL8651_WAN2LAN), 
						(unsigned long)PKTGET_UINT32_UNALIGNED(&pip->ip_src.s_addr),
						(unsigned long)PKTGET_UINT32_UNALIGNED(&pip->ip_dst.s_addr),
						(unsigned short)(tc?(ntohs(tc->th_sport)):0xffffffff),
						(unsigned short)(tc?(ntohs(tc->th_dport)):0xffffffff),
						0, 
						RTL8651_LOGACTION_DROP, 
						"Egress" );
#endif
				}
				return (FWDENG_ACL_OUT_DROP|FWDENG_DROP);
			
			
			
			
			
			
			
			default:
				if(defPermit != TRUE){
					rtl8651_fwdEngineCounter.outAclDrop++;
					return FWDENG_ACL_OUT_DROP|FWDENG_DROP;
				}else{
					rtl8651_fwdEngineCounter.outAclPermit++;
					return SUCCESS;
				}
			}
		}
		else {
			
			int8 defAction;
			int32 ret;
			ret=_rtl8651_getDefaultAcl(netif_tb->ifName,&defAction);
			assert(ret==SUCCESS);
			switch(defAction){
				case RTL8651_ACL_L34_DROP:
				case RTL8651_ACL_DROP:
					rtl8651_fwdEngineCounter.outAclDrop++;
					return FWDENG_ACL_OUT_DROP|FWDENG_DROP;
				case RTL8651_ACL_DROP_LOG:
					rtl8651_fwdEngineCounter.outAclDrop++;
					if (	(_loggingModule[dsid]&RTL8651_LOGMODULE_ACL)
						&& ip											
						&&_pUserLoggingFunc
					)
					{
#ifdef _RTL_NEW_LOGGING_MODEL
						rtl8651_logInfo_t info;
						struct tcphdr *tc = NULL;
						struct udphdr *ud = NULL;
						struct icmp *ic = NULL;
						uint16 sport = 0xffff;
						uint16 dport = 0xffff;
						uint8 type = 0xff;
						uint16 id = 0xffff;

						if (!IS_FRAGMENT_REMAIN(pip->ip_off))
						{
							switch(pip->ip_p)
							{
								case IPPROTO_TCP:
									tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
									sport = ntohs(tc->th_sport);
									dport = ntohs(tc->th_dport);
									break;
								case IPPROTO_UDP:
									ud = (struct udphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
									sport = ntohs(ud->uh_sport);
									dport = ntohs(ud->uh_dport);
									break;
								case IPPROTO_ICMP:
									ic = (struct icmp *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
									type = ic->icmp_type;
									id = ntohs(ic->icmp_id);
									break;
							}
						}

						info.infoType		= RTL8651_LOG_INFO_PKT;
						info.pkt_dsid		= dsid;
						info.pkt_sip		= PKTGET_UINT32_UNALIGNED(&pip->ip_src);
						info.pkt_dip		= PKTGET_UINT32_UNALIGNED(&pip->ip_dst);
						info.pkt_proto		= pip->ip_p;
						info.pkt_direction	= (pVlan->internal?RTL8651_LAN2WAN:RTL8651_WAN2LAN);
						info.pkt_sport		= sport;
						info.pkt_dport		= dport;
						info.pkt_icmpType	= type;
						info.pkt_icmpId	= id;
						info.action		= RTL8651_LOGACTION_DROP;
						(* _pUserLoggingFunc)(RTL8651_LOGMODULE_ACL, RTL8651_LOG_ACL_EgressAclDropLog, &info);
#else
						struct tcphdr * tc =NULL;
						
						if (pip->ip_p==6||pip->ip_p==17) 
							tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
						(*_pUserLoggingFunc)(
							dsid,
							RTL8651_LOGMODULE_ACL,
						    (unsigned char)pip->ip_p, 
						    (unsigned char)(pVlan->internal?RTL8651_LAN2WAN:RTL8651_WAN2LAN), 
							(unsigned long)PKTGET_UINT32_UNALIGNED(&pip->ip_src.s_addr),
							(unsigned long)PKTGET_UINT32_UNALIGNED(&pip->ip_dst.s_addr),
							(unsigned short)(tc?(ntohs(tc->th_sport)):0xffffffff),
							(unsigned short)(tc?(ntohs(tc->th_dport)):0xffffffff),
							0, 
							RTL8651_LOGACTION_DROP, 
							"Egress" );
#endif
					}					
					return FWDENG_ACL_OUT_DROP|FWDENG_DROP;
				case RTL8651_ACL_PERMIT:
				case RTL8651_ACL_CPU:
					rtl8651_fwdEngineCounter.outAclPermit++;
					return SUCCESS;
				default:
					assert(0);
					break;
			}
		}
	}
	return SUCCESS;
}


static inline void _rtl8651_l34Decision(	struct rtl_pktHdr *pkthdr,
										rtl8651_tblDrv_vlanTable_t *vlanp,
										uint32 *decision_p,
										uint32 *srcType_p,
										uint32 *dstType_p,
										uint32 *optLayer_p)
{
	ipaddr_t sip = pkthdr->ph_sip;
	ipaddr_t dip = pkthdr->ph_dip;

	assert(pkthdr && vlanp && decision_p && srcType_p && dstType_p && optLayer_p);

	
	if (_rtl8651_localServerIpAddr(sip) == TRUE)
	{
		*srcType_p = _RTL8651_HOST_LP;
	} else
	{
		if ( vlanp->internal )
		{	
			if (_rtl8651_getNatInternalMappingEntry(sip, pkthdr))
			{
				*srcType_p = _RTL8651_HOST_NI;
			} else
			{
				*srcType_p = _RTL8651_HOST_NPI;
			}
		} else
		{	
			*srcType_p = _RTL8651_HOST_RP;
		}
	}
	
	if (_rtl8651_getNatExternalMappingEntry(dip, pkthdr))
	{	
		*dstType_p = _RTL8651_HOST_NE;
	}else if (_rtl8651_localServerIpAddr(dip) == TRUE)
	{	
		*dstType_p = _RTL8651_HOST_LP;
	}else if (_rtl8651_extIpAddr(dip, NULL) == TRUE)
	{	
		*dstType_p = _RTL8651_HOST_NPE;
	}else
	{	
		rtl8651_tblDrv_routeTable_t *rt = NULL;

		rt = _rtl8651_getRoutingEntry(dip);

		if (	(rt == NULL)
			|| (rt && (rt->ipAddr == 0))
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
			|| (rt->netif_t->linkLayerType == RTL8651_LL_PPTP)
			|| (rt->netif_t->linkLayerType == RTL8651_LL_L2TP) 
#endif
		)
		{
			
			*dstType_p = _RTL8651_HOST_RP;

			

		} else
		{	
			rtl8651_tblDrv_vlanTable_t *dst_vlanp;

			dst_vlanp = &DrvTbl.vlan[rt->dvid & (RTL8651_VLAN_NUMBER-1)];

			if (dst_vlanp->internal)
			{
				if (_rtl8651_getNatInternalMappingEntry(dip, pkthdr) != NULL)
				{	
					*dstType_p = _RTL8651_HOST_NI;
				}else
				{	
					*dstType_p = _RTL8651_HOST_NPI;
				}
			}else
			{	
				*dstType_p = _RTL8651_HOST_RP;
			}

			
			pkthdr->ph_routeIdx = (rt - &DrvTbl.route[0]) + 1;
		}
	}

	
	assert( ((*dstType_p) < _RTL8651_HOST_MAX) && ((*srcType_p) < _RTL8651_HOST_MAX) );

	*decision_p = _RTL8651_PROC[*srcType_p][*dstType_p];
	*optLayer_p = _RTL8651_OPTLAYER(*decision_p);

	return;
}



static inline int32 _rtl8651_l34PacketProcess(	struct rtl_pktHdr *pkthdr,
												struct ip *pip,
 												uint32 decision)
{
	int32 val;
	ipaddr_t sip = pkthdr->ph_sip;
	ipaddr_t dip = pkthdr->ph_dip;

	
	if ((val = _rtl8651_l34AddtionalExec(decision, pkthdr->ph_dip, pkthdr->ph_mbuf->m_data)) != SUCCESS)
	{
		return val;
	}

	if (pkthdr->ph_routeIdx == 0	 )
	{
		rtl8651_tblDrv_routeTable_t *policy_rt = NULL;
		rtl8651_tblDrv_routeTable_t *rt = NULL;

		
		if (decision == _RTL8651_DEC_NPT)
		{
			if ( !IS_FRAGMENT_REMAIN(pip->ip_off) )
			{

				

				switch (pip->ip_p)
				{
					case IPPROTO_TCP:
					{
						struct tcphdr *tc;

						tc = (struct tcphdr *)L4HDR_ADDR(pip);

						if ((policy_rt = _rtl8651_getSoftRoutingEntry(sip, dip, IPPROTO_TCP, ntohs(tc->th_sport), ntohs(tc->th_dport))) == NULL)
						{
							if (_rtl8651_getDemandRoutingEntry(sip, dip, IPPROTO_TCP, ntohs(tc->th_sport), ntohs(tc->th_dport)) == SUCCESS)
							{
								return FWDENG_DEMANDRT_FOUND;
							}
						}
					}
						break;

					case IPPROTO_UDP:
					{
						struct udphdr *ud;

						ud = (struct udphdr *)L4HDR_ADDR(pip);

						if ((policy_rt = _rtl8651_getSoftRoutingEntry(sip, dip, IPPROTO_UDP, ntohs(ud->uh_sport), ntohs(ud->uh_dport))) == NULL)
						{
							if (_rtl8651_getDemandRoutingEntry(sip, dip, IPPROTO_UDP, ntohs(ud->uh_sport), ntohs(ud->uh_dport)) == SUCCESS)
							{
								return FWDENG_DEMANDRT_FOUND;
							}
						}
					}
						break;
					default:

						if ((policy_rt = _rtl8651_getSoftRoutingEntry(sip, dip, pip->ip_p, -1, -1)) == NULL)
						{
							if (_rtl8651_getDemandRoutingEntry(sip, dip, pip->ip_p, -1, -1) == SUCCESS)
							{
								return FWDENG_DEMANDRT_FOUND;
							}
						}
						break;
				}
			}
		} 

		

		if (	(policy_rt == NULL) &&
			(decision != _RTL8651_DEC_NTR) &&
			(decision != _RTL8651_DEC_NPTR) &&
			(decision != _RTL8651_DEC_NTBC_NP) &&
			(decision != _RTL8651_DEC_NTBC_N) &&
			(decision != _RTL8651_DEC_NTBC_L) &&
			(decision != _RTL8651_DEC_NPTBC_NP) &&
			(decision != _RTL8651_DEC_NPTBC_N) &&
			(decision != _RTL8651_DEC_NPTBC_L) &&
			(decision != _RTL8651_DEC_DP)	)
		{
			rt = _rtl8651_getRoutingEntry(dip);

			if (rt == NULL)
			{
				return FWDENG_RT_NOTFOUND;
			}
		}

		if ( policy_rt )
		{
			pkthdr->ph_routeIdx = (policy_rt - &DrvTbl.route[0]) + 1;
		}else if ( rt )
		{
			pkthdr->ph_routeIdx = (rt - &DrvTbl.route[0]) + 1;
		}

	}
 	return SUCCESS;
}


static inline int32 _rtl8651_l34ActExec (	struct rtl_pktHdr * pkthdrPtr,  	
										struct ip* ip, 
										uint8 proto,  
										int32 decision 	)
{
	int32 val;

	switch ( decision )
	{
		
		case _RTL8651_DEC_NPT:	
		{
			val = _rtl8651_l4napt_process(pkthdrPtr, ip, proto, _RTL8651_L4_NAT_OUTPUT);

			switch (val)
			{
				 case _RTL8651_NAT_PASS:
				 {
					if ((val = _rtl8651_l3ActRouting(pkthdrPtr,pkthdrPtr->ph_dip, ip)) == SUCCESS)
					{
						return SUCCESS;
					}
					
				 }
				case _RTL8651_NAT_DROP:
				{
					rtl8651_fwdEngineCounter.natdrop++;
					return FWDENG_DROP;
				}
				case _RTL8651_NAT_IGNORE:
				{
					return FAILED;
				}
			}

			
			return val;
		}

		case _RTL8651_DEC_NPTR:	
		{
			val = _rtl8651_l4napt_process(pkthdrPtr, ip, proto, _RTL8651_L4_NAT_INPUT);

			switch (val)
			{
				 case _RTL8651_NAT_PASS:
				 {
				 	
					ipaddr_t dip;
					uint32 dsid = pkthdrPtr->ph_dsid;
					ipaddr_t org_sip = pkthdrPtr->ph_sip;
					ipaddr_t org_dip = pkthdrPtr->ph_dip;

					dip = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
					pkthdrPtr->ph_routeIdx = 0;					

					if ((val = _rtl8651_l3ActRouting(pkthdrPtr, dip, ip)) == SUCCESS)
					{
						
						if (	( rtl8651_drvDynamicRPPolicyRoute == TRUE ) &&
							( dsid != 0 )	)
						{
							rtl8651_tblDrvPolicyRoute_t policyRt;
							memset(&policyRt, 0, sizeof(rtl8651_tblDrvPolicyRoute_t));
							policyRt.type = (DYNAMIC_POLICY_ROUTE|TRIGGER_SIPDIPPAIR);
							policyRt.ip_alias = org_dip;
							policyRt.trigger.sipDipPair.dip = (uint32)org_sip;
							policyRt.trigger.sipDipPair.sip = (uint32)dip;
							_rtl8651_addPolicyRoute( &policyRt, RTL8651_DPOLICYRT_INT_AGE );
						}

						return SUCCESS;
					}
					
				 }
				case _RTL8651_NAT_DROP:
				{
					rtl8651_fwdEngineCounter.natdrop++;
					return FWDENG_DROP;
				}
				case _RTL8651_NAT_IGNORE:
				{
					return FAILED;
				}
			}

			
			return val;
		}

		
		case _RTL8651_DEC_NT:	
			return _rtl8651_l4nat_out_process(pkthdrPtr, ip);
		case _RTL8651_DEC_NTR:	
			return _rtl8651_l4nat_in_process(pkthdrPtr, ip);

		
		case _RTL8651_DEC_RT_LR:	
		case _RTL8651_DEC_RT_RL:	
		case _RTL8651_DEC_RT_LNP:	
		case _RTL8651_DEC_RT_NPL:	
		case _RTL8651_DEC_RT_LN:	
		case _RTL8651_DEC_RT_NL:	
		case _RTL8651_DEC_RT_LL:	
		case _RTL8651_DEC_RT_NN:	
		case _RTL8651_DEC_RT_NPNP:	
		case _RTL8651_DEC_RT_NPN:	
		case _RTL8651_DEC_RT_NNP:	
		case _RTL8651_DEC_RT_RR:	

			return _rtl8651_l3ActRouting(pkthdrPtr, pkthdrPtr->ph_dip, ip);

		

		case _RTL8651_DEC_NPTBC_NP:		
		case _RTL8651_DEC_NPTBC_N:		
		case _RTL8651_DEC_NPTBC_L:		
			return _rtl8651_l4NaptPortBouncing(pkthdrPtr, ip);
		case _RTL8651_DEC_NTBC_NP:		
		case _RTL8651_DEC_NTBC_N:		
		case _RTL8651_DEC_NTBC_L:		
			return _rtl8651_l4NatPortBouncing(pkthdrPtr, ip);

		

		case _RTL8651_DEC_DP:	
			return FWDENG_DECISION_DROP;

		default:
			assert(0);
			 
	}

	return FAILED;  
}

int32 _rtl8651_mtuFragment(uint32 property, struct rtl_pktHdr *pkthdrPtr, uint32 mtu, uint16 dvid, int8 isNapt, uint16 srcPortList)
{
	struct ip *ip = (struct ip *)(pkthdrPtr->ph_mbuf->m_data + pkthdrPtr->ph_iphdrOffset);
	struct rtl_pktHdr *orgPkthdr=NULL;
	uint32 local_ph_reason;
	int32 retval;

	
#ifdef _RTL_IP_FRAG


	local_ph_reason = 0x0064;

	switch (local_ph_reason & 0x007f) {
		struct rtl_mBuf *new_m;
		struct ip *new_ip;
		int32 offset;
		int32 ip_hlen;
		uint8 *cp1;
		uint32 payloadLen, hdrLen;
		uint32 segLen;
		uint32 seg_seq;
	case 0x0064: 		
		
		ip_hlen = (ip->ip_vhl &0xf) << 2;

		
		if (IS_FRAGMENT(ip->ip_off))
			pkthdrPtr->ph_proto = PKTHDR_IP;

		switch(pkthdrPtr->ph_proto){

			struct tcphdr *tcp_p;
			struct udphdr*udp_p;
			struct icmp *icmp_p;
			int32 totalLen ;
		case PKTHDR_TCP:
			totalLen = ntohs(ip->ip_len);
			tcp_p = (struct tcphdr *) ((int8 *) ip + ip_hlen);
			tcp_p->th_sum = 0;
			ip->ip_sum = 0;
			tcp_p->th_sum = htons(_rtl8651_tcpChecksum(ip));
			ip->ip_sum = htons(_rtl8651_ipChecksum((struct ip*)ip));
			break;
		case PKTHDR_UDP:
			udp_p = (struct udphdr *) ((int8 *) ip + ip_hlen);
			totalLen = ntohs(ip->ip_len);
			ip->ip_sum = 0;
			if (udp_p->uh_sum)
			{	
				udp_p->uh_sum = 0;
				udp_p->uh_sum = htons(_rtl8651_tcpChecksum(ip));
			}
			ip->ip_sum = htons(_rtl8651_ipChecksum(ip));
			break;
		case PKTHDR_ICMP:	
			totalLen = ntohs(ip->ip_len);
			icmp_p = (struct icmp *) ((int8 *) ip + ip_hlen);			
			icmp_p->icmp_cksum = 0;
			ip->ip_sum = 0;		
			icmp_p->icmp_cksum = htons(_rtl8651_icmpChecksum(ip));
			ip->ip_sum = htons(_rtl8651_ipChecksum((struct ip*)ip));
			break;
#if 0	
		case PKTHDR_IP:
			totalLen = ntohs(ip->ip_len);
			if (!IPHDRLEN_IS_TWENTY(ip))
			{
				ip->ip_sum = 0;
				ip->ip_sum = htons(_rtl8651_ipChecksum(ip));
			}
			break;
#endif
		default:
			break;
		}


		
		if ((rtl8651_drvIcmpRoutingMsgEnable == TRUE) &&
			(property == FWDENG_FROMDRV)  &&
			(rtl8651_drvIcmpAlwaysReplyErrForFrag == TRUE || DONT_FRAG(ip->ip_off))) {
			struct ip *iphdr;
			rtl8651_tblDrv_vlanTable_t *vlan_t;
			rtl8651_tblDrv_arpEntry_t *arp_t;

			uint32 ip_hlen, totalLen, ipAddr;


			if ((new_m=mBuf_dupPacket(pkthdrPtr->ph_mbuf, MBUF_DONTWAIT)) == NULL) 
				return FAILED;
			orgPkthdr = new_m->m_pkthdr;

			
			orgPkthdr->ph_flags &= ~(PKTHDR_PPPOE_AUTOADD|PKTHDR_VLAN_AUTOADD|CSUM_IP|CSUM_L4);

			iphdr = (struct ip *)(new_m->m_data + orgPkthdr->ph_iphdrOffset);
			iphdr->ip_ttl ++;
			if (isNapt == TRUE) {
				PKTSET_UINT32_UNALIGNED(orgPkthdr->ph_sip, &iphdr->ip_src);
			}
			else {
				rtl8651_memcpy(&ipAddr, &iphdr->ip_src, 4);		
				rtl8651_memcpy(&iphdr->ip_src, &iphdr->ip_dst, 4);	
				rtl8651_memcpy(&iphdr->ip_dst, &ipAddr, 4);			
			}
			ip_hlen = (iphdr->ip_vhl &0xf) << 2;
			totalLen = ntohs(iphdr->ip_len);
			
			
			if ((arp_t=_rtl8651_getArpEntry(NULL, orgPkthdr->ph_sip, FALSE))) {
				vlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(orgPkthdr->ph_vlanIdx)];
				rtl8651_memcpy((new_m->m_data+6), &arp_t->macInfo->macAddr, 6);
				rtl8651_memcpy(new_m->m_data, &vlan_t->macAddr, 6);
			}
			
			switch(orgPkthdr->ph_proto){
				struct tcphdr *tcp_p;
				struct udphdr*udp_p;
				struct icmp *icmp_p;
			case PKTHDR_TCP:
				tcp_p = (struct tcphdr *) ((int8 *) iphdr + ip_hlen);
				tcp_p->th_sport = htons(orgPkthdr->ph_sport);
				tcp_p->th_sum = 0;
				iphdr->ip_sum = 0;
				tcp_p->th_sum = htons(_rtl8651_tcpChecksum((struct ip*)iphdr));
				iphdr->ip_sum = htons(_rtl8651_ipChecksum((struct ip*)iphdr));
				break;
				
			case PKTHDR_UDP:
				udp_p = (struct udphdr *) ((int8 *) iphdr + ip_hlen);
				udp_p->uh_sport = htons(orgPkthdr->ph_sport);
				iphdr->ip_sum = 0;
				if (udp_p->uh_sum)
				{
					udp_p->uh_sum = 0;
					udp_p->uh_sum= htons(_rtl8651_tcpChecksum((struct ip*)iphdr));
				}
				iphdr->ip_sum = htons(_rtl8651_ipChecksum((struct ip*)iphdr));			
				break;
				
			case PKTHDR_ICMP:
				icmp_p = (struct icmp *) ((int8 *) iphdr + ip_hlen);
				icmp_p->icmp_id = htons(orgPkthdr->ph_sid);
				icmp_p->icmp_cksum = 0;
				iphdr->ip_sum = 0;		
				icmp_p->icmp_cksum = htons(_rtl8651_icmpChecksum((struct ip*)iphdr));
				iphdr->ip_sum = htons(_rtl8651_ipChecksum((struct ip*)iphdr));
				break;

			case PKTHDR_IP:
				if (!IPHDRLEN_IS_TWENTY(iphdr))
				{
					iphdr->ip_sum = 0;
					iphdr->ip_sum = htons(_rtl8651_ipChecksum((struct ip*)iphdr));
				}
			default: break;

			}
			
			if (p_mtuHandler)
			{
				p_mtuHandler(orgPkthdr);
			}else
			{
				_rtl8651_IcmpPktField_t icmpInfo;
				icmpInfo.ic_type	= ICMP_UNREACH;
				icmpInfo.ic_code	= ICMP_UNREACH_NEEDFRAG;
				icmpInfo.ic_mtu	= mtu;
				vlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(orgPkthdr->ph_vlanIdx)];
				orgPkthdr->ph_portlist = srcPortList;
				if (_rtl8651_drvIcmpErrorGeneration(orgPkthdr, iphdr, &icmpInfo, vlan_t->vid) != SUCCESS)
				{
					mBuf_freeMbufChain(orgPkthdr->ph_mbuf);
				}
			}
		}
		
		if (DONT_FRAG(ip->ip_off))
			return FAILED;
		
		
		offset = (uint8 *)ip - (uint8 *)pkthdrPtr->ph_mbuf->m_data;
		if(offset <= 0 ){
#if 0
			if (orgPkthdr)
				mBuf_freeMbufChain(orgPkthdr->ph_mbuf);
#endif
			return FAILED;
		}

		hdrLen = offset + ip_hlen;			
		payloadLen = ntohs(ip->ip_len) - ip_hlen;		
		segLen = ((mtu - ip_hlen)>>3)<<3; 	
		
		for(seg_seq=0 ; payloadLen > segLen; payloadLen-=segLen, seg_seq++) {
			if ((new_m=mBuf_dupPacket(pkthdrPtr->ph_mbuf, MBUF_DONTWAIT)) == NULL) {
				
#if 0
				if (orgPkthdr)
					mBuf_freeMbufChain(orgPkthdr->ph_mbuf);
#endif
				return FAILED;
			}
			new_m->m_pkthdr->ph_flags &= ~(CSUM_L4);
			if (ip_hlen == 20)
				new_m->m_pkthdr->ph_flags |= (CSUM_IP);
			else
				new_m->m_pkthdr->ph_flags &= ~(CSUM_IP);
			if (seg_seq > 0) {
				cp1 = (uint8 *)new_m->m_data + (seg_seq*segLen);
				rtl8651_memcpy(cp1, (uint8 *)new_m->m_data, hdrLen);
				mBuf_adjHead(new_m,  segLen*seg_seq);
			}
			mBuf_adjTail(new_m,  payloadLen-segLen);
			
			new_ip = (struct ip *)(new_m->m_data + offset);
			{
				uint16 ip_len = ntohs(new_ip->ip_len);
				uint16 ip_off =ntohs(ip->ip_off);
				
				ip_len = ip_hlen + segLen;
				new_ip->ip_len = htons(ip_len);
				
				ip_off = seg_seq*(segLen>>3);
				new_ip->ip_off += htons(ip_off) ;
				new_ip->ip_off |= htons(IP_MF);
			}	
			assert(new_m->m_pkthdr);
			new_m->m_pkthdr->ph_proto = PKTHDR_IP;
			
			if ((retval=_rtl8651_fwdEngineSend(property, (void*)(new_m->m_pkthdr),dvid,-1)) != SUCCESS) {
				mBuf_freeMbufChain(new_m);
#if 0				
				if (orgPkthdr)
					mBuf_freeMbufChain(orgPkthdr->ph_mbuf);
#endif
				return retval;
			}
		}


		cp1 = (uint8 *)pkthdrPtr->ph_mbuf->m_data + (seg_seq*segLen);
		rtl8651_memcpy(cp1, (uint8 *)pkthdrPtr->ph_mbuf->m_data, hdrLen);
		mBuf_adjHead(pkthdrPtr->ph_mbuf,  segLen*seg_seq);
		
		ip = (struct ip *)(pkthdrPtr->ph_mbuf->m_data + offset);
		{
			uint16 ip_len = ntohs(ip->ip_len);
			uint16 ip_off =ntohs(ip->ip_off);
			
			ip_len = ip_hlen + payloadLen;
			ip->ip_len = htons(ip_len);
			
			ip_off = seg_seq*(segLen>>3);
			ip->ip_off += htons(ip_off);
		}
		pkthdrPtr->ph_flags &= ~(CSUM_L4);
		if (ip_hlen == 20)
			pkthdrPtr->ph_flags |= (CSUM_IP);
		else
			pkthdrPtr->ph_flags &= ~(CSUM_IP);
#if 0
		if (p_mtuHandler) {
			if ((retval = _rtl8651_fwdEngineSend(property, (void*)pkthdrPtr,dvid,-1)) != SUCCESS) {
				mBuf_freeMbufChain(orgPkthdr->ph_mbuf);
				return retval;
			}
			p_mtuHandler(orgPkthdr);
			return retval;
		}
#endif
		pkthdrPtr->ph_proto = PKTHDR_IP;
		return _rtl8651_fwdEngineSend(property, (void*)pkthdrPtr,dvid,-1);
		
	case 0x0066: 	 
		return FAILED;
	}
#endif 

	return FAILED;
}



static int32 _rtl8651_l3ActRouting(struct rtl_pktHdr * pkthdrPtr, ipaddr_t dst_ip, struct ip *ip)
{
	{
		#ifdef _RTL_DOS_PLUGIN
		
		_rtl8651_dosScanCheckComplain(pkthdrPtr->ph_dsid, ip);	
		#endif
	}


	return _rtl8651_l3FastActRouting(FWDENG_FROMDRV, pkthdrPtr, dst_ip, ip, NULL);
}


__IRAM_L34_FWD int32 _rtl8651_l3FastActRouting(uint32 property, struct rtl_pktHdr * pkthdrPtr, ipaddr_t dst_ip, struct ip *ip, void  **arp_t)
{

	rtl8651_tblDrv_arpEntry_t *arp_tb;		
	rtl8651_tblDrv_vlanTable_t *vlan_t; 
	rtl8651_tblDrv_pppTable_t *nhSession_t;
	int8 *cp;
	ipaddr_t next_ip;
	rtl8651_tblDrv_routeTable_t *tb;
	int32 pktPPPoE = 0;
	uint32 mtu, tol_len;
	uint16 dvid;
	uint16 srcPortList;

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_GET_MTU_AND_SOURCE_MAC);
#endif

	if (pkthdrPtr->ph_routeIdx >= 1)
	{
		tb = DrvTbl.route + (pkthdrPtr->ph_routeIdx - 1);
	}else
	{
		tb = _rtl8651_getRoutingEntry(dst_ip);			
		if(tb == NULL || ip == NULL)
		{
			return FWDENG_RT_NOTFOUND;
		}
	}

	
	mtu = tb->netif_t->mtu;

	
	vlan_t = &DrvTbl.vlan[rtl8651_vlanTableIndex(tb->dvid)];
	if (vlan_t->macAddrNumber == 0)
		return FAILED;

	switch (tb->nextHopType)
	{
		case RTL8651_LL_NONE:
		case RTL8651_LL_VLAN:
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
		case RTL8651_LL_PPTP:
		case RTL8651_LL_L2TP:
#endif
			if( pkthdrPtr->ph_pppeTagged)
			{
				
				mBuf_adjHead( pkthdrPtr->ph_mbuf, 8);
				cp = (int8*)(pkthdrPtr->ph_mbuf->m_data);

				
				PKTSET_UINT16_UNALIGNED(0x0800, (cp+12));
				
				pkthdrPtr->ph_pppeTagged = 0;
				pkthdrPtr->ph_iphdrOffset -= 8;
			} else	
				cp = (int8*)(pkthdrPtr->ph_mbuf->m_data);

			nhSession_t = NULL; 
			break;
		case RTL8651_LL_PPPOE:
			pktPPPoE = 1;	
			cp = (int8*)(pkthdrPtr->ph_mbuf->m_data);
			if( pkthdrPtr->ph_pppeTagged == 0 )
			{	
				if( tb->rt_nhSession_t == NULL || tb->rt_nhSession_t->valid == 0) 
#if 0
				nhSession_t = (rtl8651_tblDrv_pppTable_t *)tb->rt_nhstart_t->nexthop_t;
				if (nhSession_t == NULL || nhSession_t->valid == 0)
#endif
				{
					return FAILED;
				}
				#if 0
				
				*((uint16*)(cp+12)) = htons(0x8864);
				#endif
				
				rtl8651_memcpy(cp+6, &(vlan_t->macAddr), sizeof(ether_addr_t));
			}else
			{
				
				 return FAILED;
			}
			break;
		default:
			return FAILED;
	}

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_GET_MTU_AND_SOURCE_MAC);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_PPTPL2TP_1);
#endif

	
	srcPortList = pkthdrPtr->ph_portlist;

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)

	if(tb->nextHopType==RTL8651_LL_PPTP||tb->nextHopType==RTL8651_LL_L2TP)
	{
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD	
		_rtl8651_fragmentShortestPathCache_clear(pkthdrPtr, ip);
#endif 
		if((tb-DrvTbl.route) != (rtl8651_tblDrvPara.routingTableSize-1))
		{
			 tb = &DrvTbl.route[rtl8651_tblDrvPara.routingTableSize-1];
			
			
		}
#if 1
		if (tb->rt_nhSession_t->valid == 0 || tb->rt_nhSession_t->initiated == 0)
			return FAILED;
		rtl8651_memcpy(cp, &(tb->rt_nhSession_t->macInfo->macAddr), sizeof(ether_addr_t));
#else
		nhSession_t = (rtl8651_tblDrv_pppTable_t *)tb->rt_nhstart_t->nexthop_t;
		if (nhSession_t == NULL || nhSession_t->valid == 0 || nhSession_t->initiated == 0)
			return FAILED;
		rtl8651_memcpy(cp, &nhSession_t->macInfo->macAddr, 6);
#endif 
		rtl8651_memcpy(cp+6, &(vlan_t->macAddr), sizeof(ether_addr_t));
		pkthdrPtr->ph_portlist = DrvTbl.vlan[tb->dvid & (RTL8651_VLAN_NUMBER - 1)].memberPortMask;		 
		pkthdrPtr->ph_dsid = 0;
		goto pptpL2tpSend;	
	}
#endif

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_PPTPL2TP_1);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_PPPOE_ARP_CACHE);
#endif

	if (pktPPPoE == 0)
	{
#if 1
		if (tb->ifrt_flag == 0)	
		{
			
			next_ip = tb->nextHop;
#if 1
			arp_tb = tb->rt_nharp_t; 
#else
			arp_tb = (rtl8651_tblDrv_arpEntry_t *)tb->rt_nhstart_t->nexthop_t;
#endif 
		} else				
		{
			next_ip = dst_ip;

			if (arp_t && *arp_t)
			{
				arp_tb = (rtl8651_tblDrv_arpEntry_t *)(*arp_t);
				if (	(arp_tb->age > 0) &&
					(arp_tb->vid ==tb->dvid) &&
					(arp_tb->ipAddr == next_ip)	)
				{
					
				} else
				{	
					goto arp_lookup;
				}
			} else
			{
			arp_lookup:
				arp_tb = _rtl8651_getArpEntry(tb->netif_t, dst_ip, TRUE);
			}
		}

		
		if (arp_t)
		{
			*arp_t = (void *)arp_tb;
		}

#else
		
		if (arp_t == NULL || *arp_t == NULL)
		{
			if (tb->ifrt_flag == 0)
			{ 
#if 1
				arp_tb = tb->rt_nharp_t; 
#else
				arp_tb = (rtl8651_tblDrv_arpEntry_t *)tb->rt_nhstart_t->nexthop_t;
#endif 
				next_ip = tb->nextHop;
			}else
			{ 
				arp_tb = _rtl8651_getArpEntry(tb->netif_t, dst_ip, TRUE);
				next_ip = dst_ip;
			}
			if (arp_t)
				*arp_t = (void *)arp_tb;
		}else
		{
			arp_tb = (rtl8651_tblDrv_arpEntry_t *)(*arp_t);
			next_ip = arp_tb->ipAddr;
		}
#endif
		
		if (tb->ipClass == 1 && arp_tb && tb->ipintf_t && !tb->ipintf_t->ipUnnumber)
			_rtl8651_ipClassMonitoring(next_ip, arp_tb);

		if (arp_tb == NULL || arp_tb->macInfo == NULL)
		{	
			rtl8651_tblDrv_ipIntfEntry_t *iftb;
			iftb = _rtl8651_getIpIntfEntryByAddr(next_ip);
			
			if(iftb && iftb->ipAddr.slh_first )
			{
				if (iftb->ipAddr.slh_first->ipAddr == next_ip)
				{
					return FAILED;
				}
			}
			_rtl8651_drvArpGeneration(next_ip);
#ifdef _RTL_QUEUE_ARP_PACKET
			if(_rtl8651_enQueuePacket(pkthdrPtr,ip, next_ip,Q_ARP) == SUCCESS)
			{
				return SUCCESS;	
			}			
#endif  

			return FAILED;
		}

		{
			uint32 mbrMask = arp_tb->macInfo->memberPortMask;
			rtl8651_memcpy(cp, &(arp_tb->macInfo->macAddr), sizeof(ether_addr_t));
			rtl8651_memcpy(cp+6, &vlan_t->macAddr, sizeof(ether_addr_t));
			if (mbrMask == 0xffffffff)
				pkthdrPtr->ph_portlist = DrvTbl.vlan[rtl8651_vlanTableIndex(tb->dvid)].memberPortMask;
			else
				pkthdrPtr->ph_portlist = mbrMask;
		}
	}else
	{	
		rtl8651_tblDrv_pppTable_t *poe_tb;
		rtl8651_tblDrv_filterDbTableEntry_t *fb;		

#if 0
		if (pkthdrPtr->ph_unnumber & 0x1)
		{	
#endif
			poe_tb = (rtl8651_tblDrv_pppTable_t *)_rtl8651_getPppoeSessionByDsid(pkthdrPtr->ph_dsid);
			if(poe_tb == NULL)
			{
				return FAILED;
			}
#if 0
		} else  poe_tb = tb->rt_nhSession_t;
#endif
		fb = poe_tb->macInfo;
		if(fb == NULL)
		{
			return FAILED;
		}
		poe_tb->txPackets++;
		poe_tb->txBytes += pkthdrPtr->ph_len;
		pkthdrPtr->ph_pppoeIdx=PPPOE_TABLE_INDEX(poe_tb); 
		pkthdrPtr->ph_portlist = fb->memberPortMask;
		rtl8651_memcpy(cp, &(fb->macAddr), sizeof(ether_addr_t));
		
		pkthdrPtr->ph_flags |= (PKTHDR_PPPOE_AUTOADD);
		pkthdrPtr->ph_dsid=poe_tb->dsid;

		mtu = (poe_tb->mss + 40);
	}

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_PPPOE_ARP_CACHE);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_PPTPL2TP_SEND);
#endif

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
pptpL2tpSend:
#endif
	
	if (property == FWDENG_FROMDRV)
	{
		ip->ip_ttl--;
	}

	
	if (IPHDRLEN_IS_TWENTY(ip))
	{
		
		pkthdrPtr->ph_flags |= CSUM_IP;
		if ((pkthdrPtr->ph_proto == PKTHDR_IP) ||
			(property == FWDENG_FROMDRV && pkthdrPtr->ph_proto == PKTHDR_PPTP) ||
			(IS_FRAGMENT(ip->ip_off)))
		{
			
			pkthdrPtr->ph_flags &= (~CSUM_L4);
			pkthdrPtr->ph_proto = PKTHDR_IP;
		}else
		{
			pkthdrPtr->ph_flags |= CSUM_L4;
			if (property == FWDENG_FROMDRV && ip->ip_p == IPPROTO_UDP)
			{
				struct udphdr *ud;
				ud = (struct udphdr*)L4HDR_ADDR(ip);
				if (!ud->uh_sum)
					pkthdrPtr->ph_flags &= (~CSUM_L4);
			}
		}
	}else
	{	
		if (property == FWDENG_FROMDRV)
		{
			int32 accumulate = 0x0100;
			_RTL8651_ADJUST_CHECKSUM(accumulate, ip->ip_sum);
		}
		
		pkthdrPtr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		pkthdrPtr->ph_proto = PKTHDR_IP;
	}
	

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_PPTPL2TP_SEND);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_FRAG);
#endif

	dvid = tb->dvid;

	
	if (property == FWDENG_OFFLOAD)
	{
		_rtl8651_fwdEnginePSOffload_L3ExtraProcess(pkthdrPtr, ip, vlan_t);
	}

	
	tol_len = mBuf_getPktlen(pkthdrPtr->ph_mbuf);	
	if (tol_len > (mtu+14))
	{
		#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD	
		_rtl8651_fragmentShortestPathCache_clear(pkthdrPtr, ip);
		#endif 
		return _rtl8651_mtuFragment(FWDENG_L34PROC|property, pkthdrPtr, mtu, tb->dvid, TRUE, srcPortList);
	}

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FRAG);
#endif

	return _rtl8651_fwdEngineSend(FWDENG_L34PROC|property, (void*)pkthdrPtr, dvid, -1);
}



inline void _rtl8651_l4TcpAdjustMss(struct ip *ip, struct tcphdr *tc, ipaddr_t intfIp, int32 delta)
{
	if (tc->th_flags & TH_SYN)
	{
		
		
		uint8 *ptr;
		uint32 cnt;
		int32 optLen;
		int32 opt;

		ptr = (uint8 *)((uint8 *)tc + sizeof(struct tcphdr));			
		cnt = ((tc->th_off_x >> 2) & 0x3c) - sizeof(struct tcphdr);	

		for (; cnt > 0 ; cnt -= optLen, ptr += optLen)
		{
			opt = (uint32)ptr[0];
			
			if (opt == TCPOPT_EOL)
				return;

			
			if (opt == TCPOPT_MAXSEG)
			{
				uint16 mss, new_mss;
				rtl8651_tblDrv_pppTable_t * pppoeEntry;

				mss = ntohs(*(uint16*)(&ptr[2]));
				new_mss = mss;
				pppoeEntry=_rtl8651_getPppoeSessionByIpAddr(intfIp);
				if (pppoeEntry)
				{
					if (mss > pppoe_mss[pppoeEntry->dsid]+delta)
					{
						new_mss = pppoe_mss[pppoeEntry->dsid]+delta;
						*(uint16*)(&ptr[2]) = htons(new_mss);
					}
				}else if (mss > rtl8651_mss+delta)
				{
					new_mss = rtl8651_mss+delta;
					*(uint16*)(&ptr[2]) = htons(new_mss);
				}
				
				
				if ( 1  )
				{
					_RTL8651_DATA_ADJUST_CHECKSUM(new_mss, mss, tc->th_sum);
				}
			}
						
			if (opt == TCPOPT_NOP)
			{
				optLen = 1;
			}else
			{
				optLen= ptr[1];
				if (optLen <= 0)
					return;
			}
		}
	}
}



static inline int32 _rtl8651_l4TcpMonitorIn(struct tcphdr *tc, rtl8651_tblDrv_naptTcpUdpFlowEntry_t* tb)
{
	uint32 pktFlags, currentState;
	int32 retval;
	

	pktFlags = tc->th_flags &  (TH_RST|TH_SYN|TH_FIN);
	currentState = tb->tcpFlag;
	
	assert(currentState<=TCP_CLOSED_FLOW-1);
	if(pktFlags==0){ 
resetage:
		
		if (_ageTimer[currentState+1])
			retval=_rtl8651_updateNaptConnection( tb, 0, *_ageTimer[currentState+1]);
		else
			retval = SUCCESS;
		return retval;
	} 

	retval = FAILED;
	if (pktFlags>=TH_RST){
		retval=_rtl8651_updateNaptConnection( tb, TCP_CLOSED_FLOW, rtl8651GlobalControl.tcpFastTimeout);
	} else if(pktFlags==TH_SYN){
		
		int32 state=_inNextState[0][currentState];
		if(state>0){
			if (_ageTimer[state])
				retval=_rtl8651_updateNaptConnection( tb, state, *_ageTimer[state]);
			else
				retval = SUCCESS;
		}else if(state==0) 
			goto resetage;
	}else{
		
		int32 state=_inNextState[1][currentState];
		if(state>0){
			if (_ageTimer[state])
				retval=_rtl8651_updateNaptConnection( tb, state, *_ageTimer[state]);
			else
				retval = SUCCESS;
		}else if(state==0) 
			goto resetage;
	}
	return retval;

}



static inline int32 _rtl8651_l4TcpMonitorOut(struct tcphdr *tc, rtl8651_tblDrv_naptTcpUdpFlowEntry_t* tb)
{
	uint32 pktFlags, currentState;
	int32 retval;
	

	pktFlags = tc->th_flags &  (TH_RST|TH_SYN|TH_FIN);
	currentState = tb->tcpFlag;
	
	assert(currentState<=TCP_CLOSED_FLOW-1);
	if(pktFlags==0){ 
resetage:
		
		if (_ageTimer[currentState+1])
			retval=_rtl8651_updateNaptConnection( tb, 0, *_ageTimer[currentState+1]);
		else
			retval = SUCCESS;
		return retval;
	}

	retval = FAILED;
	if (pktFlags >= TH_RST) {
		retval=_rtl8651_updateNaptConnection( tb, TCP_CLOSED_FLOW, rtl8651GlobalControl.tcpFastTimeout);
	}else if(pktFlags==TH_SYN){
		
		
		int32 state=_outNextState[0][currentState];
		if(state>0){
			if ( _ageTimer[state] )
				retval=_rtl8651_updateNaptConnection( tb, state, *_ageTimer[state]);
			else
				retval = SUCCESS;
		}else if(state==0) 
			goto resetage;
	}else{
		
		int32 state=_outNextState[1][currentState];
		if(state>0){
			if ( _ageTimer[state] )
				retval=_rtl8651_updateNaptConnection( tb, state, *_ageTimer[state]);
			else
				retval = SUCCESS;
		}
		else if(state==0) 
			goto resetage;
	}
	return retval;
}

#ifdef _RTL_NAPT_ADVANCED

static int8 _rtl8651_l4CheckOccupiedConnection(uint32 isTcp, uint32 dsid, ipaddr_t IntIp, uint16 IntPort, ipaddr_t ExtIp, uint16 ExtPort, ipaddr_t RemoteIp, uint16 RemotePort)
{
	rtl8651_tblDrv_naptServerPortEntry_t *sp_t = NULL;

	
	

	
	if ((sp_t = _rtl8651_getOutsideNaptServerPortMapping(isTcp, ExtIp, ExtPort)) != NULL)
	{
		if (((IntPort + sp_t->endLocalPort - sp_t->localPort) != ExtPort) || (sp_t->localIp != IntIp))
		{
			return TRUE;
		}
	}

	
	if (_rtl8651_checkProtoStackRegistedPort(ExtPort, (isTcp?IPPROTO_TCP:IPPROTO_UDP)))
	{
		return TRUE;
	}

	
	if (_rtl8651_checkUsableUpnpEntry(isTcp, IntIp, IntPort, ExtIp, ExtPort, RemoteIp, RemotePort) == FALSE)
	{
		return TRUE;
	}

	
	if (_rtl8651_checkUsableTriggeredPortEntry(isTcp, dsid, IntIp, ExtPort) == FALSE)
	{
		return TRUE;
	}

	return FALSE;
}
#endif 


static int32 _rtl8651_inboundL4DMZForward(struct rtl_pktHdr *phdr, struct ip *ip, ipaddr_t dip)
{
	ipaddr_t dmzIp = 0;

	if (!rtl8651_drvFwdOtherL4ToDMZEnable)
		goto errout;

	if (_rtl8651_getDmzHost(phdr->ph_dsid, dip, &dmzIp) != SUCCESS)
		goto errout;

	
	PKTSET_UINT32_UNALIGNED(dmzIp, &ip->ip_dst);

	
	if (!IPHDRLEN_IS_TWENTY(ip))
	{	
		
		_RTL8651_L3_ADJUST_CHECKSUM(dmzIp, dip, ip->ip_sum);	
		
	}
	if (IS_FRAGMENT_FIRST(ip->ip_off))
	{	
		_rtl8651_updateFragCache(INBOUND_FRAG, phdr->ph_sip, phdr->ph_dip, ntohs(ip->ip_id), dmzIp, 0, NULL, phdr->ph_dsid);
	}

	return SUCCESS;

errout:
	return FAILED;
}


static int32 _rtl8651_outboundL4DMZForward(struct rtl_pktHdr *phdr, struct ip *ip, ipaddr_t sip)
{
	ipaddr_t naptIp = 0;

	if (!rtl8651_drvFwdOtherL4ToDMZEnable)
		goto errout;

	if (_rtl8651_fromDmzHost(phdr->ph_dsid, sip, &naptIp) != SUCCESS)
		goto errout;

	
	PKTSET_UINT32_UNALIGNED(naptIp, &ip->ip_src);

	
	if (!IPHDRLEN_IS_TWENTY(ip))
	{	
		
		_RTL8651_L3_ADJUST_CHECKSUM(naptIp, sip, ip->ip_sum);	
		
	}
	if (IS_FRAGMENT_FIRST(ip->ip_off))
	{	
		_rtl8651_updateFragCache(OUTBOUND_FRAG, phdr->ph_sip, phdr->ph_dip, ntohs(ip->ip_id), naptIp, 0, NULL, phdr->ph_dsid);
	}

	return SUCCESS;

errout:
	return FAILED;
}



static inline int32 _rtl8651_l4IcmpNaptAliasIn1(struct rtl_pktHdr *phdr, struct ip *pip,struct icmp *ic)
{

	rtl8651_tblDrv_naptIcmpFlowEntry_t * tb;
		 
	ipaddr_t  ip_org = 0;
	uint16 id, id_org = 0;
	
	id = ntohs(ic->icmp_id);

	tb = _rtl8651_getOutsideNaptIcmpEntry(phdr->ph_dip, id, phdr->ph_sip, TRUE, TRUE);

	if (tb != NULL)
	{
		id_org = tb->insideLocalId;
		ip_org= tb->insideLocalIpAddr;

		if (((pip->ip_vhl & 0x0f) != 5) || (ntohs(pip->ip_off) & IP_MF))
		{
			if ((pip->ip_vhl & 0x0f) != 5)
			{	
				
				_RTL8651_L3_ADJUST_CHECKSUM(ip_org, phdr->ph_sip, pip->ip_sum);	
			}
			
			_RTL8651_L4_ADJUST_CHECKSUM(0, 0, id_org, id, ic->icmp_cksum);	
		}
		#if 0
		
		if (ntohs(pip->ip_off) & IP_MF)
		{
			_RTL8651_L4_ADJUST_CHECKSUM(0 , 0, id_org, id, ic->icmp_cksum);
		}
		#endif
		
		PKTSET_UINT32_UNALIGNED(ip_org, &pip->ip_dst);


		
		ic->icmp_id = htons(id_org);		
		return (SUCCESS);
	}
	
	return (FWDENG_ICMP_IN_NOTFOUND);
}



static inline int32 _rtl8651_l4IcmpNaptAliasIn2(struct rtl_pktHdr *phdr, struct ip *pip,struct icmp *ic)
{


	struct ip *ip;
	struct icmp *ic2=NULL;
	struct udphdr *ud=NULL;
	struct tcphdr *tc=NULL;
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry;

	rtl8651_tblDrv_naptIcmpFlowEntry_t * tb_icmp = NULL;
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t * tb_tcpudp = &entry;

	ipaddr_t ip_s, ip_d;
	
	ip = &ic->icmp_ip;

	ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
	ip_d =PKTGET_UINT32_UNALIGNED(&ip->ip_src);

	if (IS_FRAGMENT_REMAIN(ip->ip_off))
	{
		RTL_NOTICE(	RTL_MSG_FWD,
						"Forwarding Engine don't support ICMP error message for fragmented remaining packet yet.\n");
		tb_tcpudp = NULL;
		tb_icmp = NULL;
	} else
	{
		if (ip->ip_p == IPPROTO_UDP)
		{
			ud = (struct udphdr *) ((int8 *)ip + ((ip->ip_vhl & 0x0f) << 2));
			if(_rtl8651_getInboundNaptFlow(FALSE, ip_d, ntohs(ud->uh_sport),
						ip_s, ntohs(ud->uh_dport), &tb_tcpudp )!=SUCCESS)
			{
				tb_tcpudp = NULL;
			}
		} else if (ip->ip_p == IPPROTO_TCP){
			tc = (struct tcphdr *) ((int8 *) ip + ((ip->ip_vhl & 0x0f) << 2));
			if(_rtl8651_getInboundNaptFlow(TRUE, ip_d, ntohs(tc->th_sport),
						ip_s, ntohs(tc->th_dport), &tb_tcpudp )!=SUCCESS)
			{
				tb_tcpudp = NULL;
			}
		} else if (ip->ip_p == IPPROTO_ICMP)
		{
			ic2 = (struct icmp *) ((int8 *) ip + ( (ip->ip_vhl & 0x0f) << 2));
			tb_icmp = _rtl8651_getOutsideNaptIcmpEntry(ip_d, ntohs(ic2->icmp_id), ip_s, FALSE, FALSE);
			tb_tcpudp = NULL;
		} else
		{	
			RTL_NOTICE(	RTL_MSG_FWD,
							"Icmp error message with payload L4 type is %d\n", (uint32)ip->ip_p);
			tb_icmp = NULL;
			tb_tcpudp = NULL;
		}
	}
	
	if (tb_tcpudp){
		ipaddr_t original_address;
		uint16    original_port;

		
		if (tb_tcpudp->toProtocolStack == TRUE)
		{
			
			if (!IS_FRAGMENT_REMAIN(ip->ip_off))
			{
				int32 retval;
				uint16 orgSPort, orgDPort;
				uint16 *pnewSPort;
				uint16 *pnewDPort;
				if (ip->ip_p == IPPROTO_TCP)
				{
					orgSPort = ntohs(tc->th_sport);
					orgDPort = ntohs(tc->th_dport);
					pnewSPort = &(tc->th_sport);
					pnewDPort = &(tc->th_dport);

					if ( tb_tcpudp->insideLocalPort != orgSPort )
					{
						tc->th_sport = htons(tb_tcpudp->insideLocalPort);
						_RTL8651_L4_ADJUST_CHECKSUM(0, 0, tb_tcpudp->insideLocalPort, orgSPort, ic->icmp_cksum);
						orgSPort = tb_tcpudp->insideLocalPort;	
					}
				}else	
				{
					orgSPort = ntohs(ud->uh_sport);
					orgDPort = ntohs(ud->uh_dport);
					pnewSPort = &(ud->uh_sport);
					pnewDPort = &(ud->uh_dport);

					if ( tb_tcpudp->insideLocalPort != orgSPort )
					{
						ud->uh_sport = htons(tb_tcpudp->insideLocalPort);
						_RTL8651_L4_ADJUST_CHECKSUM(0, 0, tb_tcpudp->insideLocalPort, orgSPort, ic->icmp_cksum);
						orgSPort = tb_tcpudp->insideLocalPort;	
					}
				}

				retval = _rtl8651_aliasProtoStackRecvPkt(phdr, TRUE, ip);
				switch ( retval )
				{
					case PS_ACTION_TO_PS:
					{
						
						_RTL8651_L4_ADJUST_CHECKSUM(0, 0, ntohs(*pnewSPort), orgSPort, ic->icmp_cksum);
						_RTL8651_L4_ADJUST_CHECKSUM(0, 0, ntohs(*pnewDPort), orgDPort, ic->icmp_cksum);
						break;
					}
					case PS_ACTION_DROP:
					{
						
						#ifdef RTL865X_DEBUG
						rtlglue_printf("[WARNING] %s (%d) ICMP error message for prohibited flow.\n");
						#endif
						return FWDENG_USER_DROP;
					}
				}
			}
			return FWDENG_TO_GW;
		}

		original_address = tb_tcpudp->insideLocalIpAddr;
		original_port = tb_tcpudp->insideLocalPort;

		
		 
		 _RTL8651_L3_ADJUST_CHECKSUM(original_address, ip_d, ip->ip_sum);

		
		if (((pip->ip_vhl & 0x0f) != 5) || (ntohs(pip->ip_off) & IP_MF))
		{
			if ((pip->ip_vhl & 0x0f) != 5)
			{	
				
				_RTL8651_L3_ADJUST_CHECKSUM(original_address, ip_d, pip->ip_sum);	
			}
			
			if (ip->ip_p == IPPROTO_TCP)
			{
				_RTL8651_L4_ADJUST_CHECKSUM(original_address, ip_d, original_port, ntohs(tc->th_sport), ic->icmp_cksum);
			}else	
			{
				_RTL8651_L4_ADJUST_CHECKSUM(original_address, ip_d, original_port, ntohs(ud->uh_sport), ic->icmp_cksum);
			}
		}
		#if 0
		 
		if (ntohs(pip->ip_off) & IP_MF)
		{
			if (ip->ip_p == IPPROTO_TCP)
			{
				_RTL8651_L4_ADJUST_CHECKSUM(original_address, ip_d, original_port, tc->th_sport, ic->icmp_cksum);
			}else
			{	
				_RTL8651_L4_ADJUST_CHECKSUM(original_address, ip_d, original_port, ud->uh_sport, ic->icmp_cksum);
			}
		}
		#endif
		
		
		PKTSET_UINT32_UNALIGNED(original_address, &pip->ip_dst);

		
		PKTSET_UINT32_UNALIGNED(original_address, &ip->ip_src);
		if (ip->ip_p == IPPROTO_UDP)
		{
			ud->uh_sport = htons(original_port);
		}
		else if (ip->ip_p == IPPROTO_TCP)
		{
			tc->th_sport = htons(original_port);
		}
		return (SUCCESS);

	}else if (tb_icmp)
	{
		ipaddr_t original_address;
		uint16    original_id;

		original_address = tb_icmp->insideLocalIpAddr;
		original_id = tb_icmp->insideLocalId;

		
		 
		_RTL8651_L3_ADJUST_CHECKSUM(original_address, ip_d, ip->ip_sum);

		
		if (((pip->ip_vhl & 0x0f) != 5) || (ntohs(pip->ip_off) & IP_MF))
		{
			if ((pip->ip_vhl & 0x0f) != 5)
			{	
				
				_RTL8651_L3_ADJUST_CHECKSUM(original_address, ip_d, pip->ip_sum);	
			}
			
			_RTL8651_L4_ADJUST_CHECKSUM(original_address, ip_d, original_id, ntohs(ic2->icmp_id), ic->icmp_cksum);
		}
		#if 0
		
		if (ntohs(pip->ip_off) & IP_MF)
		{
			_RTL8651_L4_ADJUST_CHECKSUM(original_address, ip_d, original_id, ic2->icmp_id, ic->icmp_cksum);
		}
		#endif
		

		
		PKTSET_UINT32_UNALIGNED(original_address, &pip->ip_dst);

		
		PKTSET_UINT32_UNALIGNED(original_address, &ip->ip_src);
		ic2->icmp_id = htons(original_id);	
		return (SUCCESS);
	}else
	{
		return (FWDENG_ICMP_IN_ERRFLOWNOTFOUND);
	}
}


static inline int32 _rtl8651_l4IcmpNaptAliasIn3(struct rtl_pktHdr *phdr, struct ip *pip,struct icmp *ic)
{
	ipaddr_t ip_s, ip_d;
	ipaddr_t dmzhost;
	int r;
	
	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;

#ifdef _RTL_PS_ACTION
		r = _rtl8651_doProtoStackAction(phdr, pip);
		if(r==PS_ACTION_DROP) return FWDENG_USER_DROP;
#endif
	if (!rtl8651_DMZHostIcmpPassthroughEnable)
	{
		return FWDENG_ICMP_IN_NOTFOUND;
	}
	
	if (_rtl8651_getDmzHost(phdr->ph_dsid, ip_d, &dmzhost) == SUCCESS)
	{
		uint16 id;
		rtl8651_tblDrv_naptIcmpFlowEntry_t* icmp_tb;

		id = ntohs(ic->icmp_id);		
		icmp_tb = _rtl8651_getOutsideNaptIcmpEntry(ip_d, id, ip_s, TRUE, FALSE);

		if (!icmp_tb)
		{	
			{
				
				int32 local_val;
				rtl8651_tblDrv_vlanTable_t *local_vlanp = &DrvTbl.vlan[phdr->ph_vlanIdx];
				local_val = _rtl8651_ingressAcl(phdr->ph_dsid, 0, local_vlanp, local_vlanp->vid, phdr->ph_mbuf->m_data, (uint8 *) pip, RTL8651_ACL_L4NEWFLOW, _RTL8651_OPERATION_OTHER);
				if (((local_val > 0) && (local_val & FWDENG_DROP)) ||(local_val == FWDENG_ACL_IN_USERTRAP))
					return local_val;
			}

			if( _rtl8651_addNaptIcmpNonCandidateFlow(TRUE, dmzhost, id, ip_d, id, ip_s)!= SUCCESS)
			{
				return FWDENG_ICMP_IN_ADDFAIL;
			}

			
			icmp_tb = _rtl8651_getOutsideNaptIcmpEntry(ip_d, id, ip_s, TRUE, FALSE);
		}

		
		assert(icmp_tb);
		icmp_tb->dsid = phdr->ph_dsid;

		
		
		
		if ((pip->ip_vhl & 0x0f) != 5)
			_RTL8651_L3_ADJUST_CHECKSUM(dmzhost, ip_d, pip->ip_sum);

				
		PKTSET_UINT32_UNALIGNED(dmzhost, &pip->ip_dst);
		return SUCCESS;
	} else
	{		
		return FWDENG_ICMP_IN_NOTFOUND;
	}
}



static inline int32 _rtl8651_L4IcmpNaptAliasIn(struct rtl_pktHdr *phdr, struct ip *pip)
{
	int32     iresult;
	struct icmp *ic;	


	ic = (struct icmp *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));	
	switch (ic->icmp_type)
	{
		case ICMP_ECHOREPLY:
		case ICMP_TSTAMPREPLY:
			iresult = _rtl8651_l4IcmpNaptAliasIn1(phdr, pip, ic);
			break;
		case ICMP_UNREACH:
		case ICMP_SOURCEQUENCH:
		case ICMP_TIMXCEED:
		case ICMP_PARAMPROB:
			iresult = _rtl8651_l4IcmpNaptAliasIn2(phdr, pip, ic);		
			break;
		case ICMP_ECHO:
		case ICMP_TSTAMP:
			iresult = _rtl8651_l4IcmpNaptAliasIn3(phdr, pip, ic);
			break;
		default:
			return (FWDENG_ICMP_IN_NOTFOUND);
	}

	if (iresult == SUCCESS)
	{
#ifdef _RTL_NAPT_FRAG	
		if(ntohs(pip->ip_off) &  (IP_MF|IP_OFFMASK)){
			int32 ta;
			phdr->ph_proto = PKTHDR_IP;
			ta = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);
			_rtl8651_updateFragCache(INBOUND_FRAG, phdr->ph_sip, phdr->ph_dip, ntohs(pip->ip_id), ta, 0, NULL, phdr->ph_dsid);
		}
#endif 	
	}
	return (iresult);
}



static inline int32 _rtl8651_l4IcmpNaptAliasOut1(struct rtl_pktHdr *phdr, struct ip *pip,struct icmp *ic)
{	    	
	rtl8651_tblDrv_naptIcmpFlowEntry_t * tb;

	ipaddr_t ip_s, ip_d, ip_alias = 0;
	uint16 id, id_alias = 0;

	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	id = ntohs(ic->icmp_id);
	
	tb = _rtl8651_getInsideNaptIcmpEntry(ip_s, id, ip_d, TRUE, FALSE);
	
	if(tb)
	{		
		ip_alias = tb->insideGlobalIpAddr;
		id_alias = tb->insideGlobalId;		
	}
	else
	{

		{
			
			int32 local_val;
			rtl8651_tblDrv_vlanTable_t *local_vlanp = &DrvTbl.vlan[phdr->ph_vlanIdx];
			local_val = _rtl8651_ingressAcl(phdr->ph_dsid, 0, local_vlanp, local_vlanp->vid, phdr->ph_mbuf->m_data, (uint8 *) pip, RTL8651_ACL_L4NEWFLOW, _RTL8651_OPERATION_OTHER);
			if (((local_val > 0) && (local_val & FWDENG_DROP)) ||(local_val == FWDENG_ACL_IN_USERTRAP))
				return local_val;
		}

		if (_rtl8651_softIcmpPolicyRoute(ip_s, ip_d, id, &ip_alias, &id_alias) == SUCCESS)
		{
			int32 retval;
			while ((retval = _rtl8651_addNaptIcmpNonCandidateFlow(TRUE, ip_s, id, ip_alias, id_alias, ip_d))
					!= SUCCESS)
			{
				if (retval == TBLDRV_EEXTIDINUSE)
				{
					
					id_alias ++;
				}
				else
				{
					return FWDENG_ICMP_OUT_ADDFAIL;
				}
			}
		}
		else
		{
			if (_rtl8651_getIcmpUsableExtIpAndID(ip_s, id, ip_d, 
				&ip_alias, &id_alias) != SUCCESS)
			{
				return FWDENG_ICMP_OUT_INVALIDIPID;				
			}
			if( _rtl8651_addNaptIcmpNonCandidateFlow(
				TRUE, ip_s, id, ip_alias, id_alias, ip_d)!= SUCCESS ){
				return FWDENG_ICMP_OUT_ADDFAIL;
			}
		}

		
		tb = _rtl8651_getInsideNaptIcmpEntry(ip_s, id, ip_d, TRUE, FALSE);
	}	

	
	assert(tb);
	tb->dsid = phdr->ph_dsid;

	if (((pip->ip_vhl & 0x0f) != 5) || (ntohs(pip->ip_off) & IP_MF))
	{
		if ((pip->ip_vhl & 0x0f) != 5)
		{	
			
			_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, ip_s, pip->ip_sum);	
		}
		
		_RTL8651_L4_ADJUST_CHECKSUM(0, 0, id_alias, id, ic->icmp_cksum);	
	}
	#if 0
	
	if (ntohs(pip->ip_off) & IP_MF)
	{	
		_RTL8651_L4_ADJUST_CHECKSUM(0, 0, id_alias, id, ic->icmp_cksum);
	}
	#endif
							
	
	ic->icmp_id = htons(id_alias);

			
	PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);	
	return (SUCCESS);
}


static inline int32 _rtl8651_l4IcmpNaptAliasOut2(struct rtl_pktHdr *phdr, struct ip *pip,struct icmp *ic)
{

	struct ip *ip;
	struct icmp *ic2=NULL;
	struct udphdr *ud=NULL;
	struct tcphdr *tc=NULL;
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb_tcpudp = &entry;
	rtl8651_tblDrv_naptIcmpFlowEntry_t * tb_icmp = NULL;

	ipaddr_t ip_s, ip_d;

	ip = &ic->icmp_ip;

	ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
	ip_d =PKTGET_UINT32_UNALIGNED(&ip->ip_src);

	if (IS_FRAGMENT_REMAIN(ip->ip_off))
	{
		RTL_NOTICE(	RTL_MSG_FWD,
						"Forwarding Engine don't support ICMP error message for fragmented remaining packet yet.\n");
		tb_tcpudp = NULL;
		tb_icmp = NULL;
	} else
	{
		if (ip->ip_p == IPPROTO_UDP)
		{
			ud = (struct udphdr *) ((int8 *) ip + ( (ip->ip_vhl & 0x0f) << 2));
			if(_rtl8651_getOutboundNaptFlow(FALSE,ip_s, ntohs(ud->uh_dport),
						ip_d,ntohs(ud->uh_sport),&tb_tcpudp )!=SUCCESS)
			{
				tb_tcpudp = NULL;
			}
		}else if (ip->ip_p == IPPROTO_TCP)
		{
			tc = (struct tcphdr *) ((int8 *) ip + ( (ip->ip_vhl & 0x0f) << 2));
			if(_rtl8651_getOutboundNaptFlow(TRUE,ip_s, ntohs(tc->th_dport),
						ip_d,ntohs(tc->th_sport),&tb_tcpudp )!=SUCCESS)
			{
				tb_tcpudp = NULL;
			}
		}else if (ip->ip_p == IPPROTO_ICMP)
		{
			ic2 = (struct icmp *) ((int8 *) ip + ( (ip->ip_vhl & 0x0f) << 2));
			tb_icmp = _rtl8651_getInsideNaptIcmpEntry(ip_s, ntohs(ic2->icmp_id), ip_d, FALSE, FALSE);
			tb_tcpudp = NULL;
		}else
		{	
			RTL_NOTICE(	RTL_MSG_FWD,
							"Icmp error message with payload L4 type is %d\n", ip->ip_p);
			tb_icmp = NULL;
			tb_tcpudp = NULL;
		}
	}
	
	if (tb_tcpudp){
		ipaddr_t alias_address;
		uint16    alias_port;


		alias_address = tb_tcpudp->insideGlobalIpAddr;
		alias_port = tb_tcpudp->insideGlobalPort;
		
		if (tb_tcpudp->out_rt_t)
		{
			phdr->ph_routeIdx = L3_TABLE_INDEX((rtl8651_tblDrv_routeTable_t *)tb_tcpudp->out_rt_t) + 1;
		}

		
		 
		 _RTL8651_L3_ADJUST_CHECKSUM(alias_address, ip_s, ip->ip_sum);

		
		if (((pip->ip_vhl & 0x0f) != 5) || (ntohs(pip->ip_off) & IP_MF))
		{
			if ((pip->ip_vhl & 0x0f) != 5)
			{	
				
				_RTL8651_L3_ADJUST_CHECKSUM(alias_address, ip_s, pip->ip_sum);	
			}
			
			if (ip->ip_p == IPPROTO_TCP)
			{
				_RTL8651_L4_ADJUST_CHECKSUM(alias_address, ip_s, alias_port, ntohs(tc->th_dport), ic->icmp_cksum);
			}else	
			{
				_RTL8651_L4_ADJUST_CHECKSUM(alias_address, ip_s, alias_port, ntohs(ud->uh_dport), ic->icmp_cksum);
			}
		}
		#if 0
		 
		if (ntohs(pip->ip_off) && IP_MF)
		{
			if (ip->ip_p == IPPROTO_TCP)
			{
				_RTL8651_L4_ADJUST_CHECKSUM(alias_address, ip_s, alias_port, tc->th_dport, ic->icmp_cksum);
			}else
			{	
				_RTL8651_L4_ADJUST_CHECKSUM(alias_address, ip_s, alias_port, ud->uh_dport, ic->icmp_cksum);
			}
		}
		#endif
		
		
		PKTSET_UINT32_UNALIGNED(alias_address, &pip->ip_src);

		
		PKTSET_UINT32_UNALIGNED(alias_address, &ip->ip_dst);
		if (ip->ip_p == IPPROTO_UDP)
		{
			ud->uh_dport = htons(alias_port);
		}
		else if (ip->ip_p == IPPROTO_TCP)
		{
			tc->th_dport = htons(alias_port);
		}

		
		phdr->ph_dsid = tb_tcpudp->dsid;
		
		return (SUCCESS);

	}
	else if (tb_icmp){
		ipaddr_t alias_address;
		uint16    alias_id;


		alias_address = tb_icmp->insideGlobalIpAddr;
		alias_id = tb_icmp->insideGlobalId;

		
		 
		 _RTL8651_L3_ADJUST_CHECKSUM(alias_address, ip_s, ip->ip_sum);

		
		if (((pip->ip_vhl & 0x0f) != 5) || (ntohs(pip->ip_off) & IP_MF))
		{
			if ((pip->ip_vhl & 0x0f) != 5)
			{	
				
				_RTL8651_L3_ADJUST_CHECKSUM(alias_address, ip_s, pip->ip_sum);	
			}
			
			_RTL8651_L4_ADJUST_CHECKSUM(alias_address, ip_s, alias_id, ntohs(ic2->icmp_id), ic->icmp_cksum);
		}
		#if 0
		
		if (ntohs(pip->ip_off) & IP_MF)
		{
			_RTL8651_L4_ADJUST_CHECKSUM(alias_address, ip_s, alias_id, ic2->icmp_id, ic->icmp_cksum);
		}
		#endif
		
		
		PKTSET_UINT32_UNALIGNED(alias_address, &pip->ip_src);

		
		PKTSET_UINT32_UNALIGNED(alias_address, &ip->ip_dst);
		ic2->icmp_id = htons(alias_id);

		
		phdr->ph_dsid = tb_icmp->dsid;

		return (SUCCESS);
	}
	else{
		return (FWDENG_ICMP_OUT_ERRFLOWNOTFOUND);
	}
}


static inline int32 _rtl8651_l4IcmpNaptAliasOut3(struct rtl_pktHdr *phdr, struct ip *pip,struct icmp *ic)
{	    	
	rtl8651_tblDrv_naptIcmpFlowEntry_t * icmp_tb;
	ipaddr_t ip_s, ip_d;
	uint16 id;
	
	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	id = ntohs(ic->icmp_id);

	icmp_tb = _rtl8651_getInsideNaptIcmpEntry(ip_s, id, ip_d, TRUE, TRUE);

	if(icmp_tb){
		ipaddr_t ip_alias;
		uint16 id_alias;

		ip_alias = icmp_tb->insideGlobalIpAddr;
		id_alias = icmp_tb->insideGlobalId;

		
		if (((pip->ip_vhl & 0x0f) != 5) || (ntohs(pip->ip_off) & IP_MF))
		{
			if (((pip->ip_vhl) & 0x0f) != 5)
			{	
				
				_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, ip_s, pip->ip_sum);	
			}
			
			_RTL8651_L4_ADJUST_CHECKSUM(0, 0, id_alias, id, ic->icmp_cksum);	
		}
		#if 0
		if (ntohs(pip->ip_off) & IP_MF)
		{
			_RTL8651_L4_ADJUST_CHECKSUM( 0, 0, id_alias, id, ic->icmp_cksum);
		}
		#endif

		
		ic->icmp_id = htons(id_alias);

				
		PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);

		
		phdr->ph_dsid = icmp_tb->dsid;

		return (SUCCESS);
	}	
	return (FWDENG_ICMP_OUT_INVALIDIPID);
}



static inline int32 _rtl8651_l4IcmpNaptAliasOut(struct rtl_pktHdr *phdr, struct ip *pip)
{
	int32     iresult;
	struct icmp *ic;
	
	ic = (struct icmp *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));

	switch (ic->icmp_type)
	{
		case ICMP_ECHO:
		case ICMP_TSTAMP:
			iresult = _rtl8651_l4IcmpNaptAliasOut1(phdr, pip, ic);
			break;
		case ICMP_UNREACH:
		case ICMP_SOURCEQUENCH:
		case ICMP_TIMXCEED:
		case ICMP_PARAMPROB:
			iresult = _rtl8651_l4IcmpNaptAliasOut2(phdr, pip, ic);
			break;
		case ICMP_ECHOREPLY:
		case ICMP_TSTAMPREPLY:
			iresult = _rtl8651_l4IcmpNaptAliasOut3(phdr, pip, ic);
			break;
		default:
			return (FWDENG_ICMP_OUT_INVALIDIPID);
	}

	if (iresult == SUCCESS)
	{
#ifdef _RTL_NAPT_FRAG
		if(IS_FRAGMENT(pip->ip_off))
		{
			int32 ta;
			phdr->ph_proto = PKTHDR_IP;
			ta = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
			_rtl8651_updateFragCache(OUTBOUND_FRAG, phdr->ph_sip, phdr->ph_dip, ntohs(pip->ip_id), ta, phdr->ph_routeIdx, NULL, phdr->ph_dsid);
		}	
#endif 	
	}
	return (iresult);
}



static int32 _rtl8651_l4GetDeltaAckIn(struct ip * pip, struct tcphdr *tc, rtl8651_tblDrv_naptTcpUdpFlowEntry_t* tb)
{

	int32     i;
	int32     delta, ack_diff_min;
	uint32    ack;

	ack = PKTGET_UINT32_UNALIGNED(&tc->th_ack);

	delta = 0;
	ack_diff_min = -1;
	for (i = 0; i < L4_N_LINK_TCP_DATA; i++)
	{
		struct l4ack_data_record x;

		rtl8651_memcpy(&x,&tb->ack[i],sizeof(struct l4ack_data_record));
		
		if (x.active == 1)
		{
			int32     ack_diff;

			ack_diff = _rtl8651_l4SeqDiff(x.ack_new, ack);
			if (ack_diff >= 0)
			{
				if (ack_diff_min >= 0)
				{
					if (ack_diff < ack_diff_min)
					{
						delta = x.delta;
						ack_diff_min = ack_diff;
					}
				}
				else
				{
					delta = x.delta;
					ack_diff_min = ack_diff;
				}
			}
		}
	}
	return (delta);
}



static inline int32 _rtl8651_l4UdpNaptAliasIn(struct rtl_pktHdr *phdr, struct ip *pip)
{
	struct udphdr *ud;
	ipaddr_t ip_s, ip_d, dmzhost;
	ipaddr_t ip_org = 0;
	uint16 ip_sp, ip_dp, ip_orgp = 0;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb = &entry;
	rtl8651_tblDrv_algEntry_t *client_alg_link = NULL;
	rtl8651_tblDrv_algEntry_t *server_alg_link = NULL;
	rtl8651_tblDrv_naptServerPortEntry_t *tb2;
	uint32 actionFlag = 0,i,inTrigger=0;
	rtl8651_tblDrv_arpEntry_t *arp_t;
	int32 retval = FAILED;

	ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));

	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(ud->uh_sport);
	ip_dp =  ntohs(ud->uh_dport);	

	
	
	
	if(_rtl8651_getInboundNaptFlow(FALSE,ip_d,ip_dp,ip_s,ip_sp,  &tb)!=SUCCESS){
 		tb=NULL;
 	}else
  	{	
		if (tb->toProtocolStack == TRUE)
		{	
			if (ip_dp != tb->insideLocalPort)
			{
				ud->uh_dport = htons(tb->insideLocalPort);
				if (ud->uh_sum)
					_RTL8651_L4_ADJUST_CHECKSUM(0, 0, tb->insideLocalPort, ip_dp, ud->uh_sum);
			}
			_rtl8651_doProtoStackAction(phdr, pip);
			_rtl8651_updateNaptConnection(tb, UDP_FLOW, rtl8651GlobalControl.udpTimeout);
			return FWDENG_TO_GW;
		}
 	}

	tb2 = _rtl8651_getOutsideNaptServerPortMapping(FALSE,ip_d,ip_dp);
	
	if (tb2 && (arp_t=_rtl8651_getArpEntry(NULL, tb2->localIp, FALSE))) {
		if (_rtl8651_isMacAccessControlPermit(&arp_t->macInfo->macAddr) == FALSE)
			return FWDENG_MACBLOCK;
	}


	client_alg_link = _rtl8651_l4FindLinkAlg(ip_sp, FALSE);
	if(ip_sp!=ip_dp){
		server_alg_link = _rtl8651_l4FindLinkAlg(ip_dp, FALSE);
	}

	if(tb2 && server_alg_link && tb == NULL){
		tb=&entry;
		if(_rtl8651_getOutboundAlgCtrlFlow(FALSE,tb2->localIp,ip_dp-tb2->globalPort+tb2->localPort,ip_s,ip_sp, &tb)!=SUCCESS){
			tb=NULL;			
		}
	}


	if (tb == NULL) {
		
		int32 local_val;
		rtl8651_tblDrv_vlanTable_t *local_vlanp = &DrvTbl.vlan[phdr->ph_vlanIdx];
		local_val = _rtl8651_ingressAcl(phdr->ph_dsid, 0, local_vlanp, local_vlanp->vid, phdr->ph_mbuf->m_data, (uint8 *) pip, RTL8651_ACL_L4NEWFLOW, _RTL8651_OPERATION_OTHER);
		if (((local_val > 0) && (local_val & FWDENG_DROP)) ||(local_val == FWDENG_ACL_IN_USERTRAP))
			return local_val;
	}

	
#define UDP_IN_UDP_ENTRY 0x01
#define UDP_IN_SERVER_PORT_ENTRY 0x02
#define UDP_IN_CLIENT_ALG 0x04
#define UDP_IN_SERVER_ALG	0x08

	if(tb)
		actionFlag |= UDP_IN_UDP_ENTRY;	
	
	if(tb2)
		actionFlag |= UDP_IN_SERVER_PORT_ENTRY;

#ifdef _RTL_TRIGGER_PORT
	if(actionFlag==0) 
	{
		if (_rtl8651_getTriggeredIpAddr(	FALSE,
										phdr->ph_dsid,
										0,			
										ip_dp,
										&ip_org) == SUCCESS)
		{
			if ((retval = _rtl8651_addNaptConnection(	TRUE,
													(TRUE|DOS_NAPT_ENCOUNT),
													UDP_FLOW,
													ip_org, ip_dp, & ip_d, &ip_dp, ip_s, ip_sp)) != SUCCESS)
			{
				return FWDENG_TCP_NAPT_IN_ADDFAIL;
			}
			tb = &entry;
			if (_rtl8651_getInboundNaptFlow(FALSE, ip_d, ip_dp, ip_s, ip_sp, &tb) != SUCCESS)
			{
				assert(0);
				return FWDENG_UDP_NAPT_IN_NOTFOUND;
			}
			inTrigger = 1;
		}
	}
#endif	

	if(inTrigger==0)
	{
		if(client_alg_link)
			actionFlag |= UDP_IN_CLIENT_ALG;
		
		if(server_alg_link)
			actionFlag |= UDP_IN_SERVER_ALG;
	}

#ifdef _TONY_DEBUG
{
	uint32 sip=GET_UINT32_UNALIGNED(&pip->ip_src);
	uint32 dip=GET_UINT32_UNALIGNED(&pip->ip_dst);	
	rtlglue_printf("l4UdpNaptAliasIn src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d actionFlag=%d\n",NIPQUAD(sip),ip_sp,NIPQUAD(dip),ip_dp,actionFlag);
}
#endif

	switch(actionFlag){
		case 0:
		case 4:
		case 8:
		case 12:
			if(inTrigger==1) break;
			
			
#ifdef _RTL_UPNP	
			{
					
			ipaddr_t local_ip = 0;
			uint16 local_port = 0;
			uint32 flags=0;
			uint32 algIdx=0;

			if (_rtl8651_findInboundUpnpMapping(FALSE, ip_s, ip_sp,ip_d, ip_dp, &local_ip, &local_port,&flags,&algIdx) != SUCCESS)
				goto newDmzHostConn;

			flags&=(UPNP_ALG_QOS);

			if(actionFlag==0)				
			{
				
				
				
				if (_rtl8651_addNaptConnection( TRUE, TRUE|DOS_NAPT_ENCOUNT|flags, UDP_FLOW, local_ip, local_port, &ip_d, &ip_dp, ip_s, ip_sp ) != SUCCESS )
				{
					return FWDENG_UDP_NAPT_IN_ADDFAIL;
				}

				tb=&entry;
				if(_rtl8651_getInboundNaptFlow(FALSE,ip_d,ip_dp,ip_s,ip_sp, &tb)!=SUCCESS)
				{
#ifdef _RTL_PS_ACTION			
					i=_rtl8651_doProtoStackAction(phdr, pip);
					if(i==PS_ACTION_DROP) return FWDENG_USER_DROP;		
#endif					
 					return FWDENG_UDP_NAPT_IN_NOTFOUND;
				}	
			}
 			else
 			{
				tb = _rtl8651_addAlgCtrlConnection(
						(TRUE|DOS_NAPT_ENCOUNT|flags),
						UDP_FLOW,local_ip,local_port,&ip_d, &ip_dp, ip_s, ip_sp);
				if(!tb)
				{
					return FWDENG_UDP_NAPT_IN_ALGADDFAIL;
				}
				if(tb)
				{
					tb->	tcpAckModified = 0;
					tb->	tcpFtpLastLineCRLFTermed = 0;
					tb->tcpStateINdex = 0;			
					memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);				
				}
 			
				
				if( (actionFlag & 4) && (client_alg_link->fwEngAdd) && (client_alg_link->alg_inboundClientcb)){
					client_alg_link->alg_inboundClientcb(phdr, pip, tb);
					tb->alg_client_in = client_alg_link->alg_inboundClientcb;
				}
				
				if( (actionFlag & 8) && (server_alg_link->fwEngAdd) && (server_alg_link->alg_inboundServercb)){
					int32 r;					
					tb->alg_server_in = server_alg_link->alg_inboundServercb;
					r = server_alg_link->alg_inboundServercb(phdr, pip, tb);
					if(r==FWDENG_USER_DROP) {
						return FWDENG_USER_DROP;
					}
				}
 			}
			break; 				
 			
		}
#endif 	
newDmzHostConn:


#ifdef _RTL_PS_ACTION			
			i=_rtl8651_doProtoStackAction(phdr, pip);
			if(i==PS_ACTION_DROP) return FWDENG_USER_DROP;
			if(i==PS_ACTION_TO_PS) return FWDENG_TCP_NAPT_IN_NOTFOUND;
#endif

		if (_rtl8651_getDmzHost(phdr->ph_dsid,ip_d, &dmzhost) == SUCCESS)
		{

			
#if 0			
			for(i=0;i<RTL8651_MAX_PROTO_STACK_USED_UDP_PORTS;i++)
			{				
				if(rtl8651_ProtoStackUsedUdpPorts[i]==0) 
				{
					break;
				}
				else if(rtl8651_ProtoStackUsedUdpPorts[i]==ntohs(ud->uh_sport)) 
				{
					
					return FWDENG_UDP_NAPT_IN_NOTFOUND; 
				}
			}
#endif

			
			if(_rtl8651_addNaptConnection(TRUE,
					(TRUE|DOS_NAPT_ENCOUNT), UDP_FLOW,
					dmzhost,ip_dp, &ip_d, &ip_dp, ip_s, ip_sp)
					!= SUCCESS)
			{
				return FWDENG_UDP_NAPT_IN_ADDFAIL;
			}
		
			tb=&entry;
			if(_rtl8651_getInboundNaptFlow(FALSE,ip_d,ip_dp,ip_s,ip_sp, &tb)!=SUCCESS) 
	 			return FWDENG_UDP_NAPT_IN_NOTFOUND;
			break;
		}else
			return FWDENG_UDP_NAPT_IN_NOTFOUND;
		
		case 3: 
		case 1:
			
			if(tb->alg_client_in){
				int r;
				r=tb->alg_client_in(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}				
			}
			if(tb->alg_server_in){
				int r;
				r=tb->alg_server_in(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}
			break;
#if 0
		case 2:		
						
			ud->th_dport = ip_dp-tb2->globalPort+tb2->localPort;
			PKTSET_UINT32_UNALIGNED(tb2->localIp, &pip->ip_dst);
			return (SUCCESS);	
#else			

		case 2:

			if(_rtl8651_addNaptConnection(TRUE,
					(TRUE|DOS_NAPT_ENCOUNT),
					UDP_FLOW,tb2->localIp,ip_dp-tb2->globalPort+tb2->localPort, &ip_d, &ip_dp, ip_s, ip_sp)
					!= SUCCESS)
			{
				return FWDENG_UDP_NAPT_IN_ADDFAIL;
			}

			tb=&entry;
			
			if(_rtl8651_getInboundNaptFlow(FALSE,ip_d,ip_dp,ip_s,ip_sp, &tb)!=SUCCESS) 
	 			return FWDENG_UDP_NAPT_IN_NOTFOUND;
			break;
#endif	
		case 6:
		case 10:
			tb = _rtl8651_addAlgCtrlConnection((TRUE|DOS_NAPT_ENCOUNT),
				UDP_FLOW,tb2->localIp,ip_dp-tb2->globalPort+tb2->localPort,&ip_d, &ip_dp, ip_s, ip_sp);
			if(!tb)
			{
				return FWDENG_UDP_NAPT_IN_ALGADDFAIL;
			}
			if(tb)
			{
				tb->	tcpAckModified = 0;
				tb->	tcpFtpLastLineCRLFTermed = 0;
				tb->tcpStateINdex = 0;			
				memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);				
			}
			break;
	
		case 7: 
		case 5:		
			
			if(client_alg_link->fwEngAdd && client_alg_link->alg_inboundClientcb){
				client_alg_link->alg_inboundClientcb(phdr, pip, tb);							
			}		
			break;
		case 11:
		case 9:			
			
			 if(server_alg_link->fwEngAdd && server_alg_link->alg_inboundServercb){
				server_alg_link->alg_inboundServercb(phdr, pip, tb);							
		 	}			
			break;
		case 15: 
		case 13:
			if( (actionFlag & 4) && (client_alg_link->fwEngAdd) && (client_alg_link->alg_inboundClientcb)){
				client_alg_link->alg_inboundClientcb(phdr, pip, tb);					
			}
				
			if( (actionFlag & 8) && (server_alg_link->fwEngAdd) && (server_alg_link->alg_inboundServercb)){	
				server_alg_link->alg_inboundServercb(phdr, pip, tb);
			}
			break;

		default:			
			rtlglue_printf("%s: action=%d\n",__FUNCTION__,actionFlag );	
			return FWDENG_UDP_NAPT_IN_IGNORE;
		
	}
	assert(tb);

	
	tb->dsid = phdr->ph_dsid;

	
	_rtl8651_updateNaptConnection(tb, UDP_FLOW, rtl8651GlobalControl.udpTimeout);

	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(ud->uh_sport);
	ip_dp =  ntohs(ud->uh_dport);	
		
	ip_org = tb->insideLocalIpAddr;
	ip_orgp = tb->insideLocalPort;

	
	if ((!(actionFlag&UDP_IN_UDP_ENTRY)) && tb)
	{
		assert(tb->dosEnCount == TRUE && tb->dosFromInternal == FALSE);
	
		
		if ((_loggingModule[phdr->ph_dsid]&RTL8651_LOGMODULE_NEWFLOW)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			rtl8651_logInfo_t info;
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= phdr->ph_dsid;
			info.pkt_sip		= ip_s;
			info.pkt_dip		= ip_org;
			info.pkt_proto		= IPPROTO_UDP;
			info.pkt_direction	= 1;	
			info.pkt_sport		= ip_sp;
			info.pkt_dport		= ip_orgp;
			info.action		= RTL8651_LOGACTION_FORWARD;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_NEWFLOW, RTL8651_LOG_NEWFLOW_NewUdpNaptInbound, &info);
#else
			(*_pUserLoggingFunc)(
				phdr->ph_dsid,
				RTL8651_LOGMODULE_NEWFLOW,
				    (unsigned char)pip->ip_p, 
				    (unsigned char)1, 
					(unsigned long)ip_s,
					(unsigned long)ip_org,
					(unsigned short)ip_sp,
					(unsigned short)ip_orgp,
					0, 
					RTL8651_LOGACTION_FORWARD, 
					"New UDP Inbound Flow" );
#endif
		}
	}
	

#ifdef _RTL_NAPT_FRAG
	if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK)) == IP_MF))
	{
		if ((pip->ip_vhl & 0x0f) != 5)
		{	
			_RTL8651_L3_ADJUST_CHECKSUM(ip_org, ip_d, pip->ip_sum);
		}
		
		if (ud->uh_sum)
		{
			_RTL8651_L4_ADJUST_CHECKSUM(ip_org, ip_d, ip_orgp, ip_dp, ud->uh_sum);
		}
		
		if (IS_FRAGMENT(pip->ip_off))
		{
			phdr->ph_proto = PKTHDR_IP;
			_rtl8651_updateFragCache(INBOUND_FRAG, phdr->ph_sip, phdr->ph_dip, ntohs(pip->ip_id), ip_org, 0, NULL, phdr->ph_dsid);
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			_rtl8651_fragmentShortestPathCacheSet_firstHalf(phdr, (uint8*)ud, pip, ip_s, ip_d, RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYDIP, ip_org);
#endif 
		}
	}
#endif 	

	
	ud->uh_dport = htons(ip_orgp);
			
	PKTSET_UINT32_UNALIGNED(ip_org, &pip->ip_dst);

	return (SUCCESS);
} 



static inline int32 _rtl8651_l4UdpNatAlgAliasIn(struct rtl_pktHdr *phdr, struct ip *pip, rtl8651_tblDrv_natEntry_t *natEntry)
{
	struct udphdr *ud;
	ipaddr_t ip_s, ip_d, ip_org = 0;
	uint16 ip_sp, ip_dp, ip_orgp = 0;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb = &entry;
	rtl8651_tblDrv_algEntry_t *client_alg_link = NULL;
	rtl8651_tblDrv_algEntry_t *server_alg_link = NULL;
	uint32 actionFlag = 0;

	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;

	if (ip_d == natEntry->localIp)
	{	
		return FWDENG_UDP_NAT_IN_ALGNOTFOUND;
	}

	ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));

	ip_sp = ntohs(ud->uh_sport);
	ip_dp =  ntohs(ud->uh_dport);	
	
	client_alg_link = _rtl8651_l4FindLinkAlg(ip_sp, FALSE);
	if(ip_sp != ip_dp){
		server_alg_link = _rtl8651_l4FindLinkAlg(ip_dp, FALSE);	
	}

	if(client_alg_link == NULL && server_alg_link == NULL){
		return FWDENG_UDP_NAT_IN_ALGNOTFOUND;
	}

	
	if(_rtl8651_getInboundNaptFlow(FALSE,ip_d,ip_dp,ip_s,ip_sp,  &tb)!=SUCCESS){
 		tb=NULL;
 	}

	
#define UDP_IN_UDP_ENTRY 0x01
#define UDP_IN_SERVER_PORT_ENTRY 0x02
#define UDP_IN_CLIENT_ALG 0x04
#define UDP_IN_SERVER_ALG	0x08

	if(tb)
		actionFlag |= UDP_IN_UDP_ENTRY;	
		 
	if(client_alg_link)
		actionFlag |= UDP_IN_CLIENT_ALG;
		
	if(server_alg_link)
		actionFlag |= UDP_IN_SERVER_ALG;

#ifdef _TONY_DEBUG
		rtlglue_printf("l4UdpNatAlgAliasIn src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d actionFlag=%d\n",NIPQUAD(ip_s),ip_sp,NIPQUAD(ip_d),ip_dp,actionFlag);
#endif

	switch(actionFlag){		
		case 1:
			
			if(tb->alg_client_in){
				int r;
				r=tb->alg_client_in(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}
			if(tb->alg_server_in){
				int r;
				r=tb->alg_server_in(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}			
			break;
		case 4:	
			
			tb = _rtl8651_addAlgCtrlConnection(
					(TRUE|DOS_NAPT_ENCOUNT),
					UDP_FLOW,natEntry->localIp, ip_dp, &ip_d, &ip_dp, ip_s, ip_sp);
			if(!tb)
				return FWDENG_UDP_NAT_IN_CLIALGADDFAIL;
			if(client_alg_link->fwEngAdd && client_alg_link->alg_inboundClientcb){
				tb->natlink = 1;
				client_alg_link->alg_inboundClientcb(phdr, pip, tb);							
			}
			break;			
		case 8:
			
			tb = _rtl8651_addAlgCtrlConnection(
					(TRUE|DOS_NAPT_ENCOUNT),
					UDP_FLOW,natEntry->localIp, ip_dp, &ip_d, &ip_dp, ip_s, ip_sp);
			if(!tb)
				return FWDENG_UDP_NAT_IN_SVRALGADDFAIL;
			 if( server_alg_link->fwEngAdd && server_alg_link->alg_outboundServercb){
			 	int r;
				tb->natlink = 1;
				r=server_alg_link->alg_outboundServercb(phdr, pip, tb);							
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			 }			
			break;
		case 5:		
			
			if(client_alg_link->fwEngAdd && client_alg_link->alg_inboundClientcb){
				client_alg_link->alg_inboundClientcb(phdr, pip, tb);							
			}		
			break;
		case 9:		
			 
			 if(server_alg_link->fwEngAdd && server_alg_link->alg_inboundServercb){
				server_alg_link->alg_inboundServercb(phdr, pip, tb);							
			 }
			break;		
			
		default:			
			rtlglue_printf("%s: action=%d\n",__FUNCTION__,actionFlag);	
			return FWDENG_UDP_NAT_IN_ALGIGNORE;
	}

	assert(tb);

	
	_rtl8651_updateNaptConnection(tb, UDP_FLOW, rtl8651GlobalControl.udpTimeout);
	
	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(ud->uh_sport);
	ip_dp =  ntohs(ud->uh_dport);	
		
	ip_org = tb->insideLocalIpAddr;
	ip_orgp = tb->insideLocalPort;


#ifdef _RTL_NAPT_FRAG
	if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK)) == IP_MF))
	{
		if ((pip->ip_vhl & 0x0f) != 5)
		{
			_RTL8651_L3_ADJUST_CHECKSUM(ip_org, ip_d, pip->ip_sum);
		}
		if(ud->uh_sum)
		{
			_RTL8651_L4_ADJUST_CHECKSUM(ip_org, ip_d, ip_orgp, ip_dp, ud->uh_sum);
		}
	}
#endif 	

	
	ud->uh_dport = htons(ip_orgp);
		
	PKTSET_UINT32_UNALIGNED(ip_org, &pip->ip_dst);
	
	return (SUCCESS);
} 



static inline int32 _rtl8651_l4UdpNaptAliasOut(struct rtl_pktHdr *phdr, struct ip *pip)
{
	struct udphdr *ud;
	ipaddr_t ip_s, ip_d, ip_alias = 0;
	uint16 ip_sp, ip_dp, ip_aliasp = 0;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb=&entry;
	rtl8651_tblDrv_algEntry_t *client_alg_link = NULL; 
	rtl8651_tblDrv_algEntry_t *server_alg_link = NULL; 
	
	rtl8651_tblDrv_naptServerPortEntry_t *tb2;

	
	int32 isUpnpMapping = FALSE;
	ipaddr_t upnpExtIp;
	uint16 upnpExtPort;
	uint32 upnpFlags;
	uint32 upnpAlgIdx;

	uint32 actionFlag = 0;
	int inTrigger = 0;

	ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));

	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(ud->uh_sport);
	ip_dp =  ntohs(ud->uh_dport);

	
	if( _rtl8651_getOutboundNaptFlow(FALSE,ip_s,ip_sp,ip_d,ip_dp, &tb) != SUCCESS )
	{
		tb = &entry;
		if( _rtl8651_getOutboundAlgCtrlFlow(FALSE,ip_s,ip_sp,ip_d,ip_dp, &tb) != SUCCESS )
		{
			tb = NULL;
		}
	}

	
	tb2 = _rtl8651_getInsideNaptServerPortMapping(FALSE,ip_s,ip_sp);

	
	client_alg_link = _rtl8651_l4FindLinkAlg(ip_dp, FALSE);

	if(ip_dp != ip_sp)
	{
		if( tb )
		{
			server_alg_link = _rtl8651_l4FindLinkAlg(tb->insideGlobalPort, FALSE);
		}else
		{
			server_alg_link = _rtl8651_l4FindLinkAlg(ip_sp, FALSE);
		}
	}

	
	if ((tb == NULL) && (tb2 == NULL))
	{
		if (_rtl8651_findOutboundUpnpMapping(
			FALSE,
			ip_s,
			ip_sp,
			&upnpExtIp,
			&upnpExtPort,
			ip_d,
			ip_dp,
			&upnpFlags,
			&upnpAlgIdx) == SUCCESS)
		{
			isUpnpMapping = TRUE;
		}
	}

#ifdef _RTL_NAPT_REDIRECT
		
		if ((tb == NULL) && (tb2 == NULL) && (isUpnpMapping == FALSE))
		{
			ipaddr_t redirectIp;
			uint16 redirectPort;
			if (_rtl8651_findNaptRedirectEntry(FALSE, ip_s, ip_sp, ip_d, ip_dp, &redirectIp, &redirectPort, TRUE, phdr->ph_vlanIdx) == SUCCESS)
			{	
				
				PKTSET_UINT32_UNALIGNED(redirectIp, &pip->ip_dst);
				ud->uh_dport = htons(redirectPort);
				
				if (ud->uh_sum)
					_RTL8651_L4_ADJUST_CHECKSUM(redirectIp, ip_d, redirectPort, ip_dp, ud->uh_sum);
				_RTL8651_L3_ADJUST_CHECKSUM(redirectIp, ip_d, pip->ip_sum);
				
				if (IS_FRAGMENT_FIRST(pip->ip_off))
				{
					_rtl8651_updateFragCache(NAPT_REDIRECT_FRAG, ip_s, ip_d, ntohs(pip->ip_id), redirectIp, 0, NULL, phdr->ph_dsid);
				}
#ifdef _RTL_QUEUE_FRAG_PKT
				if (_rtl8651_fragQueueProcess == TRUE)
				{	
					_rtl8651_fragQueueNaptRedirect_MatchedIP = redirectIp;
				}
#endif 
				return FWDENG_TO_GW;
			}
		}
#endif  

	if (tb == NULL) {
		
		int32 local_val;
		rtl8651_tblDrv_vlanTable_t *local_vlanp = &DrvTbl.vlan[phdr->ph_vlanIdx];
		local_val = _rtl8651_ingressAcl(phdr->ph_dsid, 0, local_vlanp, local_vlanp->vid, phdr->ph_mbuf->m_data, (uint8 *) pip, RTL8651_ACL_L4NEWFLOW, _RTL8651_OPERATION_OTHER);
		if (((local_val > 0) && (local_val & FWDENG_DROP)) ||(local_val == FWDENG_ACL_IN_USERTRAP))
			return local_val;
	}

#define UDP_OUT_UDP_ENTRY				0x01
#define UDP_OUT_SERVER_PORT_ENTRY	0x02
#define UDP_OUT_CLIENT_ALG				0x04
#define UDP_OUT_SERVER_ALG			0x08
#define UDP_OUT_UPNP_ENTRY			0x10

	if(tb)
	{
		actionFlag |= UDP_OUT_UDP_ENTRY;
	}
	
	if(tb2)
	{
		actionFlag |= UDP_OUT_SERVER_PORT_ENTRY;
	}

	if (isUpnpMapping == TRUE)
	{
		actionFlag |= UDP_OUT_UPNP_ENTRY;
	}


#ifdef _RTL_TRIGGER_PORT
	if ( actionFlag==0 ) 
	{
		if (_rtl8651_tryActiveTriggerPort(	FALSE,
										phdr->ph_dsid,
										ip_dp,
										0,				
										ip_s) > 0)
		{
			inTrigger = 1;
		}
	}
#endif	

	
	if(inTrigger==0)
	{
		if(client_alg_link)
		{
			actionFlag |= UDP_OUT_CLIENT_ALG;
		}
		
		if(server_alg_link)
		{
			actionFlag |= UDP_OUT_SERVER_ALG;
		}
	}

#ifdef _TONY_DEBUG
{
	uint32 sip=GET_UINT32_UNALIGNED(&pip->ip_src);
	uint32 dip=GET_UINT32_UNALIGNED(&pip->ip_dst);	
	rtlglue_printf("l4UdpNaptAliasOut src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d actionFlag=%d\n",NIPQUAD(sip),ip_sp,NIPQUAD(dip),ip_dp,actionFlag);
}
#endif

	

	switch ( actionFlag )
	{

		case 0:

		
			_rtl8651_softNaptPolicyRoute(	ip_s,
											ip_d,
											IPPROTO_UDP,
											ip_sp,
											ip_dp,
											&ip_alias,
											&ip_aliasp);
			if (ip_alias)
			{
#ifdef _RTL_NAPT_ADVANCED
				
				if ((rtl8651_drvStaticUdpNaptPortTranslation == TRUE) &&
					(_rtl8651_l4CheckOccupiedConnection(FALSE, phdr->ph_dsid, ip_s, ip_sp, ip_alias, ip_sp, ip_d, ip_dp) == FALSE))
				{
					
					if (_rtl8651_addNaptConnection(TRUE,
							(TRUE|PURE_SW|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL|DO_REDUNDANCY_CHECK),
							UDP_FLOW, ip_s, ip_sp, &ip_alias, &ip_sp,
							(rtl8651_drvInexactUdpNaptEnable?0:ip_d),(rtl8651_drvInexactUdpNaptEnable?0:ip_dp))
							== SUCCESS)
						ip_aliasp = ip_sp;	
					else
						goto UdpPolicyDynamicPortAssign; 	
				}else
				{
UdpPolicyDynamicPortAssign:
					if(_rtl8651_addNaptConnection(TRUE, 
							(TRUE|PURE_SW|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
							UDP_FLOW,ip_s,ip_sp, &ip_alias,&ip_aliasp,
							(rtl8651_drvInexactUdpNaptEnable?0:ip_d),(rtl8651_drvInexactUdpNaptEnable?0:ip_dp))
							!= SUCCESS)  
						return FWDENG_UDP_NAPT_OUT_ADDFAIL;
				}
#else
				if(_rtl8651_addNaptConnection(TRUE,
						(TRUE|PURE_SW|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
						UDP_FLOW, ip_s, ip_sp, &ip_alias, &ip_aliasp, ip_d, ip_dp) != SUCCESS)
					return FWDENG_UDP_NAPT_OUT_ADDFAIL;
#endif 
			}else
			{
			
#ifdef _RTL_NAPT_ADVANCED
				if (rtl8651_drvStaticUdpNaptPortTranslation == TRUE)
				{
					ip_alias = _rtl8651_getNaptInsideGlobalIpAddr(FALSE, ip_s, ip_sp, ip_d, ip_dp);

					if ((!ip_alias) || (_rtl8651_l4CheckOccupiedConnection(FALSE, phdr->ph_dsid, ip_s, ip_sp, ip_alias, ip_sp, ip_d, ip_dp) == TRUE))
						goto UdpNormalDynamicPortAssign;

					if (_rtl8651_addNaptConnection(TRUE,
							(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL|DO_REDUNDANCY_CHECK),
							UDP_FLOW, ip_s, ip_sp, &ip_alias, &ip_sp,
							(rtl8651_drvInexactUdpNaptEnable?0:ip_d), (rtl8651_drvInexactUdpNaptEnable?0:ip_dp))
							== SUCCESS)
						ip_aliasp = ip_sp;	
					else
						goto UdpNormalDynamicPortAssign;	
				}else
				{
UdpNormalDynamicPortAssign:
					if(_rtl8651_addNaptConnection(TRUE,
							(FALSE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
							UDP_FLOW, ip_s, ip_sp, &ip_alias, &ip_aliasp,
							(rtl8651_drvInexactUdpNaptEnable?0:ip_d), (rtl8651_drvInexactUdpNaptEnable?0:ip_dp))
							!= SUCCESS )
						return FWDENG_UDP_NAPT_OUT_ADDFAIL;
				}
#else
				if(_rtl8651_addNaptConnection(TRUE,
						(FALSE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
						UDP_FLOW, ip_s, ip_sp,
						&ip_alias, &ip_aliasp, ip_d, ip_dp) != SUCCESS)
				{
					return FWDENG_UDP_NAPT_OUT_ADDFAIL;
				}
#endif 
			}
			tb=&entry;
			if(_rtl8651_getOutboundNaptFlow(FALSE,ip_s,ip_sp,ip_d,ip_dp, &tb)!=SUCCESS)
			{
 				return FWDENG_UDP_NAPT_OUT_NOTFOUND;
 			}
			break;
		

		case 1:
		case 3: 
		case 17:	

		
			
			
			if(tb->alg_client_out){
				int r;
				r=tb->alg_client_out(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}
			if(tb->alg_server_out){
				int r;
				r=tb->alg_server_out(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}					
			break;

		

		
		case 2:
		case 10:	 

		
		case 16:	
		case 24:	

		

			if (tb2)
			{	
				assert(isUpnpMapping == FALSE);

				ip_alias = tb2->globalIp;
				ip_aliasp = ip_sp - tb2->localPort + tb2->globalPort;
			}else
			{	
				assert(isUpnpMapping == TRUE);

				ip_alias = upnpExtIp;
				ip_aliasp = upnpExtPort;
			}

			if(_rtl8651_addNaptConnection(TRUE,
					(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
					UDP_FLOW,ip_s,ip_sp,&ip_alias,&ip_aliasp,ip_d,ip_dp)!=SUCCESS)
			{
				goto ServerPortOut;
			}

			tb=&entry;
			if(_rtl8651_getOutboundNaptFlow(FALSE,ip_s,ip_sp,ip_d,ip_dp, &tb)!=SUCCESS){
				goto ServerPortOut;
 			}

			if (actionFlag & UDP_OUT_SERVER_ALG)
				goto serverAlg_entry_run;
			break;

		ServerPortOut:
			
			ud->uh_sport = htons(ip_aliasp);
			PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);

			return SUCCESS;

		

		case 6: 
		case 4:

		
		case 20:	

		

			_rtl8651_softNaptPolicyRoute(	ip_s,
											ip_d,
											IPPROTO_UDP,
											ip_sp,
											ip_dp,
											&ip_alias,
											&ip_aliasp);
			if (ip_alias)
			{
				tb = _rtl8651_addAlgCtrlConnection(
						(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
						UDP_FLOW,ip_s,ip_sp,&ip_alias,&ip_aliasp,ip_d,ip_dp);
			}else
			{	
				tb = _rtl8651_addAlgCtrlConnection(
					(FALSE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
					UDP_FLOW,ip_s,ip_sp,&ip_alias,&ip_aliasp,ip_d,ip_dp);
			}
			
			if(!tb)
				return FWDENG_UDP_NAPT_OUT_CLIALGADDFAIL;			 
			if ( client_alg_link->fwEngAdd && client_alg_link->alg_outboundClientcb){
				int r;
				tb->alg_client_out=client_alg_link->alg_outboundClientcb;	
				r = client_alg_link->alg_outboundClientcb(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}
			break;

		
			
		case 7: 
		case 5:

		case 19:	

		
			
			if ( client_alg_link->fwEngAdd && client_alg_link->alg_outboundClientcb){
				int r;
				tb->alg_client_out=client_alg_link->alg_outboundClientcb;
				r = client_alg_link->alg_outboundClientcb(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}				
			break;

		
	
		case 8: 

		

			
			tb = _rtl8651_addAlgCtrlConnection(
					(FALSE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
					UDP_FLOW,ip_s,ip_sp,&ip_alias,&ip_aliasp,ip_d,ip_dp);			
			if(!tb)
				return FWDENG_UDP_NAPT_OUT_SVRALGADDFAIL;			

			
		
			
		case 9: 
		case 11:	

		

serverAlg_entry_run:
			 
			 if(server_alg_link->fwEngAdd && server_alg_link->alg_outboundServercb){
			 	int r;
			 	tb->alg_server_out=server_alg_link->alg_outboundServercb;	
				r=server_alg_link->alg_outboundServercb(phdr, pip, tb);							
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			 }
			break;

		
			
		case 12:
		case 14: 

		case 28:	

		
			tb = _rtl8651_addAlgCtrlConnection(
				(FALSE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
				UDP_FLOW,ip_s,ip_sp, &ip_alias,&ip_aliasp,ip_d,ip_dp);
			if(!tb)
				return FWDENG_UDP_NAPT_OUT_SVRALGADDFAIL;

		
		

		case 13:	 
		case 15: 

		case 29:	

		
			if ( client_alg_link->fwEngAdd && client_alg_link->alg_outboundClientcb){
				int r;
				tb->alg_client_out=client_alg_link->alg_outboundClientcb;				
				r = client_alg_link->alg_outboundClientcb(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}
			if ( server_alg_link->fwEngAdd && server_alg_link->alg_outboundServercb){
				int r;
				tb->alg_server_out=server_alg_link->alg_outboundServercb;
				r = server_alg_link->alg_outboundServercb(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}
			break;

		

		default:			
			rtlglue_printf("%s: action=%d\n",__FUNCTION__,actionFlag );	
			return (FWDENG_UDP_NAPT_OUT_IGNORE);
	}

	assert(tb);

		
	assert( phdr->ph_routeIdx);
	tb->out_rt_t = (void *)&DrvTbl.route[phdr->ph_routeIdx-1];
	tb->dsid = phdr->ph_dsid;

	
	_rtl8651_updateNaptConnection(tb, UDP_FLOW, rtl8651GlobalControl.udpTimeout);

	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(ud->uh_sport);
	ip_dp =  ntohs(ud->uh_dport);
	
	ip_alias = tb->insideGlobalIpAddr;
	ip_aliasp = tb->insideGlobalPort;

	
	if ((!(actionFlag&UDP_OUT_UDP_ENTRY)) && tb)
	{
		assert(tb->dosEnCount == TRUE && tb->dosFromInternal == TRUE);
	
		
		if ((_loggingModule[phdr->ph_dsid]&RTL8651_LOGMODULE_NEWFLOW)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			rtl8651_logInfo_t info;

			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= phdr->ph_dsid;
			info.pkt_sip		= ip_s;
			info.pkt_dip		= ip_d;
			info.pkt_proto		= IPPROTO_UDP;
			info.pkt_direction	= 0;	
			info.pkt_sport		= ip_sp;
			info.pkt_dport		= ip_dp;
			info.action		= RTL8651_LOGACTION_FORWARD;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_NEWFLOW, RTL8651_LOG_NEWFLOW_NewUdpNaptOutbound, &info);
#else
			(*_pUserLoggingFunc)(
				phdr->ph_dsid,
				RTL8651_LOGMODULE_NEWFLOW,
				    (unsigned char)pip->ip_p, 
				    (unsigned char)0, 
					(unsigned long)ip_s,
					(unsigned long)ip_d,
					(unsigned short)ip_sp,
					(unsigned short)ip_dp,
					0, 
					RTL8651_LOGACTION_FORWARD, 
					"New UDP Outbound Flow" );
#endif
		}
	}
	

#ifdef _RTL_NAPT_FRAG	
	if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK)) == IP_MF))
	{
		if ((pip->ip_vhl & 0x0f) != 5)
		{	
			
			_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, ip_s, pip->ip_sum);	
		}
		
		if( ud->uh_sum)
		{
			_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, ip_s, ip_aliasp, ip_sp, ud->uh_sum);	
		}

		if ((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK)) == IP_MF)
		{	
			phdr->ph_proto = PKTHDR_IP;
			_rtl8651_updateFragCache(OUTBOUND_FRAG, ip_s, ip_d, ntohs(pip->ip_id), ip_alias, phdr->ph_routeIdx, NULL, phdr->ph_dsid);
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			_rtl8651_fragmentShortestPathCacheSet_firstHalf(phdr, (uint8*)ud, pip, ip_s, ip_d, RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYSIP, ip_alias);
#endif 
		}
	}

#endif 	

	
	ud->uh_sport = htons(ip_aliasp);

	
	PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);

	return (SUCCESS);
}




static inline int32 _rtl8651_l4UdpNatAlgAliasOut(struct rtl_pktHdr *phdr, struct ip *pip, rtl8651_tblDrv_natEntry_t *natEntry)
{
	struct udphdr *ud;
	ipaddr_t ip_s, ip_d, ip_alias = 0;
	uint16 ip_sp, ip_dp, ip_aliasp = 0;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb=&entry;
	rtl8651_tblDrv_algEntry_t *client_alg_link = NULL; 
	rtl8651_tblDrv_algEntry_t *server_alg_link = NULL; 
	
	uint32 actionFlag = 0;

	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;

	if (ip_s == natEntry->globalIp)
	{	
		return FWDENG_UDP_NAT_OUT_ALGNOTFOUND;
	}

	ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));

	ip_sp = ntohs(ud->uh_sport);
	ip_dp =  ntohs(ud->uh_dport);

	client_alg_link = _rtl8651_l4FindLinkAlg(ip_dp, FALSE);		
	if(ip_dp != ip_sp){
		server_alg_link = _rtl8651_l4FindLinkAlg(ip_sp, FALSE);
	}

	if(client_alg_link == NULL && server_alg_link == NULL){
		return FWDENG_UDP_NAT_OUT_ALGNOTFOUND;
	}
	
	if(_rtl8651_getOutboundAlgCtrlFlow(FALSE,ip_s,ip_sp,ip_d,ip_dp, &tb)!=SUCCESS){
			tb=NULL;
	}
	

#define UDP_OUT_UDP_ENTRY 0x01
#define UDP_OUT_SERVER_PORT_ENTRY 0x02
#define UDP_OUT_CLIENT_ALG 0x04
#define UDP_OUT_SERVER_ALG 0x08

	if(tb)
		actionFlag |= UDP_OUT_UDP_ENTRY;	
		 
	if(client_alg_link)
		actionFlag |= UDP_OUT_CLIENT_ALG;
		
	if(server_alg_link)
		actionFlag |= UDP_OUT_SERVER_ALG;

#ifdef _TONY_DEBUG
		rtlglue_printf("l4UdpNaptAlgAliasOut src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d actionFlag=%d\n",NIPQUAD(ip_s),ip_sp,NIPQUAD(ip_d),ip_dp,actionFlag);
#endif	

	switch(actionFlag){
		case 1:
			
			if(tb->alg_client_out){
				int r;
				r=tb->alg_client_out(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			}
			if(tb->alg_server_out){
				int r;
				r=tb->alg_server_out(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			}			
			break;		
		case 4:		
			 
			 ip_alias = natEntry->globalIp;
			 ip_aliasp = ip_sp;
			tb = _rtl8651_addAlgCtrlConnection(
					(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
					UDP_FLOW,ip_s,ip_sp, &ip_alias,&ip_aliasp,ip_d,ip_dp);
			if(!tb)
				return FWDENG_UDP_NAT_OUT_CLIALGADDFAIL;
			if ( client_alg_link->fwEngAdd && client_alg_link->alg_outboundClientcb){
				int r;
				tb->natlink = 1;
				r=client_alg_link->alg_outboundClientcb(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			}		
			break;		
		case 5:		
			 
			if ( client_alg_link->fwEngAdd && client_alg_link->alg_outboundClientcb){
				int r;
				r=client_alg_link->alg_outboundClientcb(phdr, pip, tb);				
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			}				
			break;
		case 8:		
			 
			 ip_alias = natEntry->globalIp;
			 ip_aliasp = ip_sp;			 
			tb = _rtl8651_addAlgCtrlConnection(
					(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
					UDP_FLOW,ip_s,ip_sp, &ip_alias,&ip_aliasp,ip_d,ip_dp);
			if(!tb)
				return FWDENG_UDP_NAT_OUT_SVRALGADDFAIL;

			if ( server_alg_link->fwEngAdd && server_alg_link->alg_outboundServercb){							
				int r;
				tb->natlink = 1;
				r=server_alg_link->alg_outboundServercb(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			}		
			break;		
			
		case 9:		
			 
			 if(server_alg_link->fwEngAdd && server_alg_link->alg_outboundServercb){
			 	int r;
				r=server_alg_link->alg_outboundServercb(phdr, pip, tb);											
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			 }
			break;	

		default:		
			rtlglue_printf("%s: action=%d\n",__FUNCTION__,actionFlag );	
			return FWDENG_UDP_NAT_OUT_ALGIGNORE;
	}

	assert(tb);

	
	_rtl8651_updateNaptConnection(tb, UDP_FLOW, rtl8651GlobalControl.udpTimeout);
	
	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(ud->uh_sport);
	ip_dp =  ntohs(ud->uh_dport);
		
	ip_alias = tb->insideGlobalIpAddr;
	ip_aliasp = tb->insideGlobalPort;
						 
#ifdef _RTL_NAPT_FRAG
	if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF | IP_OFFMASK)) == IP_MF))
	{
		
		if ((pip->ip_vhl & 0x0f) != 5)
		{
			_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, ip_s, pip->ip_sum);
		}
		
		if (ud->uh_sum)
		{
			_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, ip_s, ip_aliasp, ip_sp, ud->uh_sum);
		}
	}
#endif 	

	
	ud->uh_sport = htons(ip_aliasp);

	
	PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);

	return (SUCCESS);
}


static inline int32 _rtl8651_l4TcpNaptAliasIn(struct rtl_pktHdr *phdr, struct ip *pip)
{
	struct tcphdr *tc;
	ipaddr_t ip_s, ip_d, ip_org = 0, dmzhost=0;
	uint16 ip_sp, ip_dp, ip_orgp = 0;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb = &entry;
	int32 accumulate = 0;
	rtl8651_tblDrv_algEntry_t *client_alg_link = NULL;
	rtl8651_tblDrv_algEntry_t *server_alg_link = NULL;
	rtl8651_tblDrv_naptServerPortEntry_t *tb2;
	uint32 actionFlag = 0,i,inTrigger=0;
	rtl8651_tblDrv_pppTable_t *thisPPPoE;
	rtl8651_tblDrv_arpEntry_t *arp_t;
	uint16 mtu;
	int8 initFlag = TCP_INBOUND_SYN_RCVD_FLOW;
	int32 retval = FAILED;


	tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
		
	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(tc->th_sport);
	ip_dp =  ntohs(tc->th_dport);

#define TCP_IN_TCP_SYN 0x01
#define TCP_IN_TCP_ENTRY 0x02
#define TCP_IN_SERVER_PORT_ENTRY 0x04
#define TCP_IN_CLIENT_ALG 0x08
#define TCP_IN_SERVER_ALG	0x10

	if(_rtl8651_getInboundNaptFlow(TRUE,ip_d,ip_dp,ip_s,ip_sp, &tb)!=SUCCESS){
 		tb=NULL;
 	}else
 	{	
		if (tb->toProtocolStack == TRUE)
		{	
			if (ip_dp != tb->insideLocalPort)
			{
				tc->th_dport = htons(tb->insideLocalPort);
				_RTL8651_L4_ADJUST_CHECKSUM(0, 0, tb->insideLocalPort, ip_dp, tc->th_sum);
			}
			_rtl8651_doProtoStackAction(phdr, pip);
			_rtl8651_l4TcpMonitorIn(tc, tb);
			return FWDENG_TO_GW;
		}
 	}

	tb2 = _rtl8651_getOutsideNaptServerPortMapping(TRUE,ip_d,ip_dp);
	
	if (tb2 && (arp_t=_rtl8651_getArpEntry(NULL, tb2->localIp, FALSE))) {
		if (_rtl8651_isMacAccessControlPermit(&arp_t->macInfo->macAddr) == FALSE)
			return FWDENG_MACBLOCK;
	}
	
	client_alg_link = _rtl8651_l4FindLinkAlg(ip_sp, TRUE);	
	if(ip_sp != ip_dp){	
		server_alg_link = _rtl8651_l4FindLinkAlg(ip_dp, TRUE);
	}

#if 0 
	if(tb2 && server_alg_link && tb == NULL){		
		tb=&entry;
		if(_rtl8651_getOutboundAlgCtrlFlow(TRUE,tb2->localIp,ip_dp-tb2->globalPort+tb2->localPort,ip_s,ip_sp, &tb)!=SUCCESS){
			tb=NULL;
		}
	}
#endif	

	if (tb == NULL) {
		
		int32 local_val;
		rtl8651_tblDrv_vlanTable_t *local_vlanp = &DrvTbl.vlan[phdr->ph_vlanIdx];
		local_val = _rtl8651_ingressAcl(phdr->ph_dsid, 0, local_vlanp, local_vlanp->vid, phdr->ph_mbuf->m_data, (uint8 *) pip, RTL8651_ACL_L4NEWFLOW, _RTL8651_OPERATION_OTHER);
		if (((local_val > 0) && (local_val & FWDENG_DROP)) ||(local_val == FWDENG_ACL_IN_USERTRAP))
			return local_val;
	}




	if(tc->th_flags == TH_SYN)
		actionFlag |= TCP_IN_TCP_SYN;

	if(tb)
		actionFlag |= TCP_IN_TCP_ENTRY;	
	
	if(tb2)
		actionFlag |= TCP_IN_SERVER_PORT_ENTRY;	

#ifdef _RTL_WEAK_NAPT_CTRL
	if ((actionFlag == TCP_IN_TCP_SYN) || ((actionFlag == 0) && rtl8651_drvWeakTcpNaptEnable)) 
#else
	if (actionFlag == TCP_IN_TCP_SYN) 
#endif 
	{

		
#ifdef _RTL_TRIGGER_PORT

#ifdef _RTL_WEAK_NAPT_CTRL
		if (actionFlag == TCP_IN_TCP_SYN)
			initFlag = TCP_INBOUND_SYN_RCVD_FLOW;	
		else
			initFlag = TCP_ESTABLISHED_FLOW;			
#endif 

		if (_rtl8651_getTriggeredIpAddr(	TRUE,
										phdr->ph_dsid,
										0,			
										ip_dp,
										&ip_org) == SUCCESS)
		{
			if ((retval = _rtl8651_addNaptConnection(	TRUE,
													(TRUE|DOS_NAPT_ENCOUNT),
													initFlag,
													ip_org, ip_dp, &ip_d, &ip_dp, ip_s, ip_sp)) != SUCCESS)
			{
				return FWDENG_TCP_NAPT_IN_ADDFAIL;
			}
			tb = &entry;
			if (_rtl8651_getInboundNaptFlow(TRUE, ip_d, ip_dp, ip_s, ip_sp, &tb) != SUCCESS)
			{
				assert(0);
				return FWDENG_TCP_NAPT_IN_NOTFOUND;
			}
			inTrigger = 1;
		}
#endif			
	}

	
	if(inTrigger==0)
	{
		if(client_alg_link)
			actionFlag |= TCP_IN_CLIENT_ALG;
		
		if(server_alg_link)
			actionFlag |= TCP_IN_SERVER_ALG;
	}

#ifdef _TONY_DEBUG
{
	uint32 sip=GET_UINT32_UNALIGNED(&pip->ip_src);
	uint32 dip=GET_UINT32_UNALIGNED(&pip->ip_dst);	
	rtlglue_printf("l4TcpNaptAliasIn src=%u.%u.%u.%u:%d dst=%u.%u.%u.%u:%d actionFlag=%d\n",NIPQUAD(sip),ip_sp,NIPQUAD(dip),ip_dp,actionFlag);
	if(tc->th_flags&TH_SYN) rtlglue_printf("SYN ");
	if(tc->th_flags&TH_ACK) rtlglue_printf("ACK ");
	if(tc->th_flags&TH_RST) rtlglue_printf("RST ");
	if(tc->th_flags&TH_FIN) rtlglue_printf("FIN ");
	if(tc->th_flags&TH_PUSH) rtlglue_printf("PUSH ");	
	rtlglue_printf("\n");
}
#endif	









#ifdef _RTL_WEAK_NAPT_CTRL
	if((actionFlag&(TCP_IN_TCP_SYN|TCP_IN_TCP_ENTRY))==0)
	{
		if (actionFlag == TCP_IN_SERVER_PORT_ENTRY)
		{
			initFlag = TCP_ESTABLISHED_FLOW;
		}else if (rtl8651_drvWeakTcpNaptEnable)
		{
			
			initFlag = TCP_ESTABLISHED_FLOW;
			actionFlag |= TCP_IN_TCP_SYN;
		}else
		{
			actionFlag = 0;
		}
	}
#else 
	if((actionFlag&(TCP_IN_TCP_SYN|TCP_IN_TCP_ENTRY)) == 0)
	{
		if (actionFlag == 4)
		{
			initFlag = TCP_ESTABLISHED_FLOW;
		}else
			actionFlag = 0;
	}
#endif 









if((actionFlag&(TCP_IN_TCP_SYN|TCP_IN_TCP_ENTRY))==(TCP_IN_TCP_SYN|TCP_IN_TCP_ENTRY))
{
	
	if ((tb->tcpFlag > (TCP_LISTEN_FLOW - 1)) &&
		(tb->tcpFlag < (TCP_CLOSED_FLOW - 1)) &&
		(tb->tcpFlag != (TCP_INBOUND_SYN_RCVD_FLOW - 1)))
	{
		return FWDENG_TCP_NAPT_IN_NOTFOUND;
	}
	actionFlag = 3;
}

	switch(actionFlag){
	case 0:
#ifdef _RTL_PS_ACTION
			i=_rtl8651_doProtoStackAction(phdr, pip);
			if(i==PS_ACTION_DROP) return FWDENG_USER_DROP;	
#endif	
		return FWDENG_TCP_NAPT_IN_NOTFOUND;
	case 1: 
	case 9: 
	case 17: 
		if(inTrigger==1) {
			
			break;
		}
		
		
#ifdef _RTL_UPNP	
		{
					
			ipaddr_t local_ip = 0;
			uint16 local_port = 0;
			uint32 flags = 0, algIdx = 0;

			if (_rtl8651_findInboundUpnpMapping(TRUE, ip_s, ip_sp,ip_d, ip_dp, &local_ip, &local_port, &flags, &algIdx) != SUCCESS)
			{
				goto newDmzHostConn;
			}

			if(actionFlag==1)
			{
				struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s ttbe,*ttb;
				ttb=&ttbe;
				if(_rtl8651_getInboundNaptFlow(TRUE,ip_d,ip_dp,ip_s,20, &ttb)==SUCCESS) 
				{
					if(ttb->tcpFlag==0)
					{
						_rtl8651_delNaptConnection(ttb);
					}
				}

				if (_rtl8651_addNaptConnection( TRUE, TRUE|DOS_NAPT_ENCOUNT|(flags & UPNP_ALG_QOS), TCP_INBOUND_SYN_RCVD_FLOW, local_ip, local_port, &ip_d, &ip_dp, ip_s, ip_sp ) != SUCCESS )
				{
					return FWDENG_TCP_NAPT_IN_ADDFAIL;
				}
				
				tb=&entry;
				if(_rtl8651_getInboundNaptFlow(TRUE,ip_d,ip_dp,ip_s,ip_sp, &tb) != SUCCESS)
				{
					rtlglue_printf("error: _rtl8651_getInboundNaptFlow connection in upnp \n");
		 			return FWDENG_TCP_NAPT_IN_NOTFOUND;
				}
				else
				{	
					
					
					break;
				}			
	 		}
			else
			{				
				tb = _rtl8651_addAlgCtrlConnection(
						(TRUE|DOS_NAPT_ENCOUNT),TCP_INBOUND_SYN_RCVD_FLOW,
						local_ip,local_port,&ip_d, &ip_dp, ip_s, ip_sp);
				if(!tb)
					return FWDENG_TCP_NAPT_IN_SVRALGADDFAIL;
				if(tb){	
					tb->	tcpAckModified = 0;
					tb->	tcpFtpLastLineCRLFTermed = 0;
					tb->tcpStateINdex = 0;			
					memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);				
					}
				break;
			}
		}
#endif 		
			
			
newDmzHostConn:
		

#ifdef _RTL_PS_ACTION
			i=_rtl8651_doProtoStackAction(phdr, pip);
			if(i==PS_ACTION_DROP) return FWDENG_USER_DROP;
			if(i==PS_ACTION_TO_PS) return FWDENG_TCP_NAPT_IN_NOTFOUND;
#endif
		if (_rtl8651_getDmzHost(phdr->ph_dsid,ip_d, &dmzhost) == SUCCESS)
		{
#if 0	
			for(i=0;i<RTL8651_MAX_PROTO_STACK_SERVER_USED_TCP_PORTS;i++)
			{				
				if(rtl8651_ProtoStackServerUsedTcpPorts[i]==0) 
				{
					break;
				}
				else if(rtl8651_ProtoStackServerUsedTcpPorts[i]==tc->th_dport) 
				{
					
					return FWDENG_TCP_NAPT_IN_NOTFOUND; 
				}
			}			
#endif			
			

			
			
			if (actionFlag!=1)
			{

				tb = _rtl8651_addAlgCtrlConnection(
					(TRUE|DOS_NAPT_ENCOUNT), TCP_INBOUND_SYN_RCVD_FLOW,
					dmzhost, ip_dp, &ip_d, &ip_dp, ip_s, ip_sp);
				if(!tb)
					return FWDENG_TCP_NAPT_IN_SVRALGADDFAIL;
				if(tb){	
					tb->	tcpAckModified = 0;
					tb->	tcpFtpLastLineCRLFTermed = 0;
					tb->tcpStateINdex = 0;			
					memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);				
					}

			}
			else {
				if(_rtl8651_addNaptConnection(TRUE,
					(TRUE|DOS_NAPT_ENCOUNT), TCP_INBOUND_SYN_RCVD_FLOW,
					dmzhost,ip_dp, &ip_d, &ip_dp, ip_s, ip_sp) != SUCCESS)
				{
					printk("add connection failed\n");
					return FWDENG_TCP_NAPT_IN_ADDFAIL;
				}
				tb=&entry;
				if(_rtl8651_getInboundNaptFlow(TRUE,ip_d,ip_dp,ip_s,ip_sp, &tb)!=SUCCESS) {
					printk("getInboundflow failed\n");
		 			return FWDENG_TCP_NAPT_IN_NOTFOUND;
				}
			}
			
			break;
		}else
			return FWDENG_TCP_NAPT_IN_NOTFOUND;
	case 2: 
	case 6: 



			
		if(tb->alg_client_in){
			int r;
			r = tb->alg_client_in(phdr, pip, tb);
			if(r==FWDENG_USER_DROP) {
				return FWDENG_USER_DROP;
			}
		}
#if 0		
		if(tb->alg_server_in){
			int r;
			r = tb->alg_server_in(phdr, pip, tb);
			if(r==FWDENG_USER_DROP) {
				return FWDENG_USER_DROP;
			}
		}			
#endif			
		break;			
	case 3: 
		
		break;				
	case 4: 
		if((retval =
			_rtl8651_addNaptConnection(TRUE,
				(TRUE|DOS_NAPT_ENCOUNT), TCP_ESTABLISHED_FLOW,
				tb2->localIp, ip_dp-tb2->globalPort+tb2->localPort, &ip_d, &ip_dp, ip_s, ip_sp)) != SUCCESS)
		{
			return FWDENG_TCP_NAPT_IN_ADDFAIL;
		}
		tb=&entry;
			
		if(_rtl8651_getInboundNaptFlow(TRUE,ip_d,ip_dp,ip_s,ip_sp, &tb)!=SUCCESS)
		{
			rtlglue_printf("error: _rtl8651_getInboundNaptFlow connection Failed\n");
 			return FWDENG_TCP_NAPT_IN_NOTFOUND;
		}
		break;
	case 5: 

		if((retval = _rtl8651_addNaptConnection(TRUE,
				(TRUE|DOS_NAPT_ENCOUNT), TCP_INBOUND_SYN_RCVD_FLOW,
				tb2->localIp,ip_dp-tb2->globalPort+tb2->localPort,&ip_d, &ip_dp, ip_s, ip_sp)) != SUCCESS)
		{
			return FWDENG_TCP_NAPT_IN_ADDFAIL;
		}
		tb=&entry;
			
		if(_rtl8651_getInboundNaptFlow(TRUE,ip_d,ip_dp,ip_s,ip_sp, &tb)!=SUCCESS) {
			rtlglue_printf("error: _rtl8651_getInboundNaptFlow connection in upnp \n");
 			return FWDENG_TCP_NAPT_IN_NOTFOUND;
		}
		break;

	case 10: 
	case 14: 
		 if(client_alg_link->fwEngAdd && client_alg_link->alg_inboundClientcb){
			client_alg_link->alg_inboundClientcb(phdr, pip, tb);
		 }
		 break;
	
	case 13: 
	case 21: 
	case 29: 
	
		tb=_rtl8651_addAlgCtrlConnection(
				(TRUE|DOS_NAPT_ENCOUNT),TCP_INBOUND_SYN_RCVD_FLOW,
				tb2->localIp,ip_dp+tb2->localPort-tb2->globalPort,&ip_d, &ip_dp, ip_s, ip_sp);
		if(!tb)
			return FWDENG_TCP_NAPT_IN_SVRALGADDFAIL;
		if(tb){	
			tb->	tcpAckModified = 0;
			tb->	tcpFtpLastLineCRLFTermed = 0;
			tb->tcpStateINdex = 0;			
			memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);

#if 0 
			 if(client_alg_link->fwEngAdd && client_alg_link->alg_inboundClientcb){
				client_alg_link->alg_inboundClientcb(phdr, pip, tb);							
			 }			
#endif			 
		}
		break;	


	case 18:	
	case 22: 
		 if(server_alg_link->fwEngAdd && server_alg_link->alg_inboundServercb){
			server_alg_link->alg_inboundServercb(phdr, pip, tb);							
		 }
		break;		
	default:	
		rtlglue_printf("%s: action=%d, flag=%d\n",__FUNCTION__,actionFlag,tc->th_flags );	
		return FWDENG_TCP_NAPT_IN_IGNORE;
	}

	assert(tb);
	
#ifdef _RTL_WEAK_NAPT_CTRL
	
	if (rtl8651_drvWeakTcpNaptEnable && (initFlag == TCP_ESTABLISHED_FLOW) && (actionFlag != 4))
	{
		if (actionFlag & TCP_IN_SERVER_ALG)
		{
			 if(server_alg_link->fwEngAdd && server_alg_link->alg_inboundServercb)
			 {
				server_alg_link->alg_inboundServercb(phdr, pip, tb);							
			 }
		}
		if (actionFlag & TCP_IN_CLIENT_ALG)
		{
			 if(client_alg_link->fwEngAdd && client_alg_link->alg_inboundClientcb)
			 {
				client_alg_link->alg_inboundClientcb(phdr, pip, tb);
			 }
		}
	}
#endif 

			
	if(tc->th_flags & TH_SYN){
		int8 auto_add = FALSE,auto_delete;			
		rtl8651_getAsicNaptAutoAddDelete(&auto_add,&auto_delete);				
		if(auto_add == FALSE){							
			uint8 *cp;
			int32 opt, optlen,cnt;		
			uint16 mss;
		
			cp = (uint8 *)(tc+1);
			cnt = ((tc->th_off_x >>2)&0x3c)  -sizeof(struct tcphdr);
	
			for(; cnt > 0; cnt -= optlen, cp+= optlen){
				opt = cp[0];
				if(opt == TCPOPT_EOL)
					break;
				if(opt == TCPOPT_NOP)
					optlen = 1;
				else{
					optlen = cp[1];
					if(optlen <= 0)
						break;
				}

				switch (opt) {
				case TCPOPT_MAXSEG:
					mss = ntohs(*(uint16*)(&cp[2]));

					
					thisPPPoE=_rtl8651_getPppoeSessionByIpAddr(ip_d);
					if (thisPPPoE)
					{
						if (mss >pppoe_mss[thisPPPoE->dsid])
						{
							mtu=pppoe_mss[thisPPPoE->dsid];
							accumulate -=(mss-pppoe_mss[thisPPPoE->dsid]);
							*(uint16*)(&cp[2]) = htons(mtu);
						}
					}else if(mss > rtl8651_mss){
						mtu=rtl8651_mss;
						accumulate -=(mss-rtl8651_mss);
						*(uint16*)(&cp[2]) = htons(mtu);
					}					
					break;
				default:
					continue;
				}			
			}				
		}
	}

	
	tb->dsid = phdr->ph_dsid;

#if 0 
	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = tc->th_sport;
	ip_dp =  tc->th_dport;
#endif	
	ip_org = tb->insideLocalIpAddr;
	ip_orgp = tb->insideLocalPort;

	
	if (tb->tcpAckModified == 1)
	{
		int32     delta;
		uint32    ack_32_x;
		
		delta = _rtl8651_l4GetDeltaAckIn(pip, tc, tb);
		accumulate += delta;
		if (delta != 0)
		{
			ack_32_x=PKTGET_UINT32_UNALIGNED(&tc->th_ack);
			ack_32_x = htonl(ntohl(ack_32_x) - delta);
			PKTSET_UINT32_UNALIGNED(ack_32_x, &tc->th_ack);
		}
	}

	
	_rtl8651_l4TcpMonitorIn(tc, tb);


	
#ifdef RTL865XB_URL_FILTER
	if ((_urlFilterAclRuleNum>=0) &&
		(!tb->urlFiltered||((phdr->ph_reason&0xe)==4
		&& ((phdr->ph_reason&0xff0)>>5)==_urlFilterAclRuleNum)))
#else
	if (!tb->urlFiltered||phdr->ph_reason==65)
#endif
	{
		int32 position, len=64;
		int8 matched[64];
		int32 hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;

		if (	((ntohs(pip->ip_len))>hlen))
		{
			position = _rtl8651_urlFilter(phdr->ph_dsid,phdr,pip,RTL8651_WAN2LAN,matched, &len);

			if (position > 0)
			{
				
				#ifdef RTL865X_DEBUG
				rtlglue_printf("string '%s'(%d bytes) in URL at %dth byte. Filtered...\n",matched, len, position );
				#endif
				_rtl8651_updateNaptConnection(tb,TCP_CLOSED_FLOW, 3);	
				return FWDENG_TCP_URLFILTERED;
			}
			tb->urlFiltered = TRUE; 
		}
	}

	
	if ((!(actionFlag&TCP_IN_TCP_ENTRY)) && tb)
	{
		assert(tb->dosEnCount == TRUE && tb->dosFromInternal == FALSE);
	
		
		if ((_loggingModule[phdr->ph_dsid]&RTL8651_LOGMODULE_NEWFLOW)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			rtl8651_logInfo_t info;
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= phdr->ph_dsid;
			info.pkt_sip		= ip_s;
			info.pkt_dip		= ip_org;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= 1;	
			info.pkt_sport		= ip_sp;
			info.pkt_dport		= ip_orgp;
			info.action		= RTL8651_LOGACTION_FORWARD;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_NEWFLOW, RTL8651_LOG_NEWFLOW_NewTcpNaptInbound, &info);
#else
			(*_pUserLoggingFunc)(
				phdr->ph_dsid,
				RTL8651_LOGMODULE_NEWFLOW,
				    (unsigned char)pip->ip_p, 
				    (unsigned char)1, 
					(unsigned long)ip_s,
					(unsigned long)ip_org,
					(unsigned short)ip_sp,
					(unsigned short)ip_orgp,
					0, 
					RTL8651_LOGACTION_FORWARD, 
					"New TCP Inbound Flow" );
#endif
		}
	}
	

#ifdef _RTL_NAPT_FRAG
	if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_OFFMASK|IP_MF)) == IP_MF))
	{
		if ((pip->ip_vhl & 0x0f) != 5)
		{	
			_RTL8651_L3_ADJUST_CHECKSUM(ip_org, ip_d, pip->ip_sum);
		}
		
		_RTL8651_L4_ADJUST_CHECKSUM(ip_org, ip_d, ip_orgp, ip_dp, tc->th_sum);
		_RTL8651_ADJUST_CHECKSUM(accumulate, tc->th_sum);	
		
		if (IS_FRAGMENT(pip->ip_off))
		{
			_rtl8651_updateFragCache(INBOUND_FRAG, phdr->ph_sip, phdr->ph_dip, ntohs(pip->ip_id), ip_org, 0, NULL, phdr->ph_dsid);
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			_rtl8651_fragmentShortestPathCacheSet_firstHalf(phdr, (uint8*)tc, pip, ip_s, ip_d, RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYDIP, ip_org);
#endif 
		}
	}
#endif 	

	
	tc->th_dport = htons(ip_orgp);
	
	PKTSET_UINT32_UNALIGNED(ip_org, &pip->ip_dst);

	return (SUCCESS);
}


static inline int32 _rtl8651_l4TcpNatAlgAliasIn(struct rtl_pktHdr *phdr, struct ip *pip, rtl8651_tblDrv_natEntry_t *natEntry)
{

	struct tcphdr *tc;
	ipaddr_t ip_s, ip_d, ip_org = 0;
	uint16 ip_sp, ip_dp, ip_orgp = 0;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb = &entry;
	int32 accumulate = 0;
	rtl8651_tblDrv_algEntry_t *client_alg_link = NULL;
	rtl8651_tblDrv_algEntry_t *server_alg_link = NULL;
	uint32 actionFlag = 0;
	rtl8651_tblDrv_pppTable_t *thisPPPoE;
	uint16 mtu;

	tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
		
	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(tc->th_sport);
	ip_dp =  ntohs(tc->th_dport);

	if (ip_d == natEntry->localIp)
	{	
		tb = NULL;
		goto adjust_mss;
	}

#define TCP_IN_TCP_SYN 0x01
#define TCP_IN_TCP_ENTRY 0x02
#define TCP_IN_SERVER_PORT_ENTRY 0x04
#define TCP_IN_CLIENT_ALG 0x08
#define TCP_IN_SERVER_ALG	0x10

	client_alg_link = _rtl8651_l4FindLinkAlg(ip_sp, TRUE);		
	if(ip_sp != ip_dp){
		server_alg_link = _rtl8651_l4FindLinkAlg(ip_dp, TRUE);
	}
	



		
	if(_rtl8651_getInboundNaptFlow(TRUE,ip_d,ip_dp,ip_s,ip_sp, &tb)!=SUCCESS){
 		tb=NULL;
 	}
	

	
	if(tc->th_flags & TH_SYN)
		actionFlag |= TCP_IN_TCP_SYN;
	
	if(tb)
		actionFlag |= TCP_IN_TCP_ENTRY;	
		 
	if(client_alg_link)
		actionFlag |= TCP_IN_CLIENT_ALG;
		
	if(server_alg_link)
		actionFlag |= TCP_IN_SERVER_ALG;

#ifdef _TONY_DEBUG
		rtlglue_printf("l4TcpNatAliasIn src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d actionFlag=%d\n",NIPQUAD(ip_s),ip_sp,NIPQUAD(ip_d),ip_dp,actionFlag);
#endif
	
	switch(actionFlag){
		case 2:
		
			
			if(tb->alg_client_in){
				int r;
				r = tb->alg_client_in(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}
			if(tb->alg_server_in){
				int r;
				r = tb->alg_server_in(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}				
		case 10:
		case 11:
			 
			 if(client_alg_link->fwEngAdd && client_alg_link->alg_inboundClientcb){
				client_alg_link->alg_inboundClientcb(phdr, pip, tb);							
			 }
			 break;
		case 18:
		case 19:
			 
			 if(server_alg_link->fwEngAdd && server_alg_link->alg_inboundServercb){
				server_alg_link->alg_inboundServercb(phdr, pip, tb);							
			 }
			break;		
		case 9: 	
		case 17: 		
					
			tb = _rtl8651_addAlgCtrlConnection(
				(TRUE|DOS_NAPT_ENCOUNT), TCP_INBOUND_SYN_RCVD_FLOW,
				natEntry->localIp, ip_dp, &ip_d, &ip_dp, ip_s, ip_sp);										
			if(!tb)
				return FWDENG_TCP_NAT_IN_ALGADDFAIL;
			tb->natlink = 1;

			break;	
		case 1:
			goto adjust_mss;
		case 0:
			return FWDENG_TCP_NAT_IN_ALGNOTFOUND;
		default:			
			rtlglue_printf("%s: action=%d, flag=%d\n",__FUNCTION__,actionFlag,tc->th_flags );
			return FWDENG_TCP_NAT_IN_ALGIGNORE;
	}

	assert(tb);
	
	_rtl8651_l4TcpMonitorIn(tc, tb);

			
adjust_mss:
	if(tc->th_flags & TH_SYN){
		int8 auto_add = FALSE,auto_delete;			
		rtl8651_getAsicNaptAutoAddDelete(&auto_add,&auto_delete);				
		if(auto_add == FALSE){							
			uint8 *cp;
			int32 opt, optlen,cnt;		
			uint16 mss;
		
			cp = (uint8 *)(tc+1);
			cnt = ((tc->th_off_x >>2)&0x3c)  -sizeof(struct tcphdr);
	
			for(; cnt > 0; cnt -= optlen, cp+= optlen){
				opt = cp[0];
				if(opt == TCPOPT_EOL)
					break;
				if(opt == TCPOPT_NOP)
					optlen = 1;
				else{
					optlen = cp[1];
					if(optlen <= 0)
						break;
				}

				switch (opt) {
				case TCPOPT_MAXSEG:
					mss = ntohs(*(uint16*)(&cp[2]));

					
					thisPPPoE=_rtl8651_getPppoeSessionByIpAddr(ip_d);
					if (thisPPPoE)
					{
						if (mss >pppoe_mss[thisPPPoE->dsid])
						{ 		
							mtu=pppoe_mss[thisPPPoE->dsid];
							accumulate -=(mss-pppoe_mss[thisPPPoE->dsid]);
							*(uint16*)(&cp[2]) = htons(mtu);
						}
					}else if(mss > rtl8651_mss){ 						
						mtu=rtl8651_mss;
						accumulate -=(mss-rtl8651_mss);
						*(uint16*)(&cp[2]) = htons(mtu);
					}
					break;
				default:
					continue;
				}			
			}				
		}
	}


	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(tc->th_sport);
	ip_dp =  ntohs(tc->th_dport);
	
	
	if(tb){
		ip_org = tb->insideLocalIpAddr;
		ip_orgp = tb->insideLocalPort;

		
		tc->th_dport = htons(ip_orgp);

		
		if (tb->tcpAckModified == 1)
		{
			int32     delta;
			uint32    ack_32_x;
			
			delta = _rtl8651_l4GetDeltaAckIn(pip, tc, tb);
			accumulate += delta;
			if (delta != 0)
			{
				ack_32_x=PKTGET_UINT32_UNALIGNED(&tc->th_ack);
				ack_32_x = htonl(ntohl(ack_32_x) - delta);
				PKTSET_UINT32_UNALIGNED(ack_32_x, &tc->th_ack);
			}
		}
		PKTSET_UINT32_UNALIGNED(ip_org,&pip->ip_dst);
	}else{
		assert(natEntry);
		PKTSET_UINT32_UNALIGNED(natEntry->localIp,&pip->ip_dst);
	}

#ifdef _RTL_NAPT_FRAG	
	if(tb)
	{	
		if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK)) == IP_MF))
		{
			if ((pip->ip_vhl & 0x0f) != 5)
			{
				_RTL8651_L3_ADJUST_CHECKSUM(ip_org, ip_d, pip->ip_sum);
			}
			_RTL8651_L4_ADJUST_CHECKSUM(ip_org, ip_d, ip_orgp, ip_dp, tc->th_sum);
			_RTL8651_ADJUST_CHECKSUM(accumulate, tc->th_sum);	
		}
	}
	else {
		
		ip_org = natEntry->localIp;

		if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK)) == IP_MF))
		{
			if ((pip->ip_vhl & 0x0f) != 5)
			{
				_RTL8651_L3_ADJUST_CHECKSUM(ip_org, ip_d, pip->ip_sum);
			}
			_RTL8651_L4_ADJUST_CHECKSUM(ip_org, ip_d, 0, 0, tc->th_sum);
			_RTL8651_ADJUST_CHECKSUM(accumulate, tc->th_sum);	
		}
	}
#endif 	

	return (SUCCESS);
}


static inline int32 _rtl8651_l4TcpNaptAliasOut(struct rtl_pktHdr *phdr, struct ip *pip)
{
	struct tcphdr *tc;
	ipaddr_t ip_s, ip_d, ip_alias = 0;
	uint16 ip_sp, ip_dp, ip_aliasp = 0;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb=&entry;
	rtl8651_tblDrv_algEntry_t *client_alg_link = NULL; 
	rtl8651_tblDrv_algEntry_t *server_alg_link = NULL; 
	int32 accumulate = 0;
	rtl8651_tblDrv_naptServerPortEntry_t *tb2;	
	uint32 actionFlag = 0;
	int inTrigger = 0;
	rtl8651_tblDrv_pppTable_t *thisPPPoE;
	uint16 mtu;
	int8 initFlag = TCP_OUTBOUND_SYN_RCVD_FLOW;
	int32 retval = FAILED;

	
	int32 isUpnpMapping = FALSE;
	ipaddr_t upnpExtIp;
	uint16 upnpExtPort;
	uint32 upnpFlags;
	uint32 upnpAlgIdx;


#define TCP_OUT_TCP_SYN				0x01
#define TCP_OUT_TCP_ENTRY				0x02
#define TCP_OUT_SERVER_PORT_ENTRY	0x04
#define TCP_OUT_CLIENT_ALG				0x08
#define TCP_OUT_SERVER_ALG				0x10
#define TCP_OUT_UPNP_ENTRY			0x20

	tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));

	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(tc->th_sport);
	ip_dp =  ntohs(tc->th_dport);

	if(_rtl8651_getOutboundNaptFlow(TRUE,ip_s,ip_sp,ip_d,ip_dp, &tb)!=SUCCESS) {
		tb=&entry;
		if( _rtl8651_getOutboundAlgCtrlFlow(TRUE,ip_s,ip_sp,ip_d,ip_dp, &tb)!=SUCCESS) {
			tb=NULL;
		}
	} 

	tb2 = _rtl8651_getInsideNaptServerPortMapping(TRUE,ip_s,ip_sp);

	client_alg_link = _rtl8651_l4FindLinkAlg(ip_dp, TRUE);		

	if(ip_sp!= ip_dp)
	{
		
		if(tb)
		{
			server_alg_link = _rtl8651_l4FindLinkAlg(tb->insideGlobalPort, TRUE);
		}else
		{
			server_alg_link = _rtl8651_l4FindLinkAlg(ip_sp, TRUE);
		}
	}

	
	if ((tb == NULL) && (tb2 == NULL))
	{
		if (_rtl8651_findOutboundUpnpMapping(
			TRUE,
			ip_s,
			ip_sp,
			&upnpExtIp,
			&upnpExtPort,
			ip_d,
			ip_dp,
			&upnpFlags,
			&upnpAlgIdx) == SUCCESS)
		{
			isUpnpMapping = TRUE;
		}
	}

#ifdef _RTL_NAPT_REDIRECT
		
		if ((tb == NULL) && (tb2 == NULL) && (isUpnpMapping == FALSE))
		{
			ipaddr_t redirectIp;
			uint16 redirectPort;
			if (_rtl8651_findNaptRedirectEntry(TRUE, ip_s, ip_sp, ip_d, ip_dp, &redirectIp, &redirectPort, TRUE, phdr->ph_vlanIdx) == SUCCESS)
			{	
				
				PKTSET_UINT32_UNALIGNED(redirectIp, &pip->ip_dst);
				tc->th_dport = htons(redirectPort);
				
				_RTL8651_L4_ADJUST_CHECKSUM(redirectIp, ip_d, redirectPort, ip_dp, tc->th_sum);
				_RTL8651_L3_ADJUST_CHECKSUM(redirectIp, ip_d, pip->ip_sum);
				
				if (IS_FRAGMENT_FIRST(pip->ip_off))
				{
					_rtl8651_updateFragCache(NAPT_REDIRECT_FRAG, ip_s, ip_d, ntohs(pip->ip_id), redirectIp, 0, NULL, phdr->ph_dsid);
				}
#ifdef _RTL_QUEUE_FRAG_PKT
				if (_rtl8651_fragQueueProcess == TRUE)
				{	
					_rtl8651_fragQueueNaptRedirect_MatchedIP = redirectIp;
				}
#endif 
				return FWDENG_TO_GW;
			}
		}
#endif  


	if (tb == NULL) {
		
		int32 local_val;
		rtl8651_tblDrv_vlanTable_t *local_vlanp = &DrvTbl.vlan[phdr->ph_vlanIdx];
		local_val = _rtl8651_ingressAcl(phdr->ph_dsid, 0, local_vlanp, local_vlanp->vid, phdr->ph_mbuf->m_data, (uint8 *) pip, RTL8651_ACL_L4NEWFLOW, _RTL8651_OPERATION_OTHER);
		if (((local_val > 0) && (local_val & FWDENG_DROP)) ||(local_val == FWDENG_ACL_IN_USERTRAP))
			return local_val;
	}

#ifdef _RTL_WEAK_NAPT_CTRL
	if (rtl8651_drvWeakTcpNaptEnable == FALSE)
#endif
	
	if ((tc->th_flags & (TH_SYN|TH_ACK)) == (TH_SYN|TH_ACK) && tb == NULL)
	{
		return FWDENG_TCP_NAPT_OUT_NOTFOUND;
	}

	if(tc->th_flags == TH_SYN)
	{
		actionFlag |= TCP_OUT_TCP_SYN;
	}
	
	if(tb)
	{
		actionFlag |= TCP_OUT_TCP_ENTRY;
	}
	
	if(tb2)
	{
		actionFlag |= TCP_OUT_SERVER_PORT_ENTRY;
	}

	if (isUpnpMapping == TRUE)
	{
		actionFlag |= TCP_OUT_UPNP_ENTRY;
	}
	

#ifdef _RTL_TRIGGER_PORT
#ifdef _RTL_WEAK_NAPT_CTRL
		if ((actionFlag == TCP_OUT_TCP_SYN)||((actionFlag == 0) && rtl8651_drvWeakTcpNaptEnable)) 
#else
		if (actionFlag == TCP_OUT_TCP_SYN) 
#endif 
		{
			if (_rtl8651_tryActiveTriggerPort(	TRUE,
											phdr->ph_dsid,
											ip_dp,
											0,
											ip_s) > 0)
			{
				inTrigger = 1;
			}
		}
#endif

	
	if(inTrigger == 0)
	{
		if(client_alg_link)
			actionFlag |= TCP_OUT_CLIENT_ALG;
		
		if(server_alg_link)
			actionFlag |= TCP_OUT_SERVER_ALG;
	}

#ifdef _TONY_DEBUG
{
	uint32 sip=GET_UINT32_UNALIGNED(&pip->ip_src);
	uint32 dip=GET_UINT32_UNALIGNED(&pip->ip_dst);	
	rtlglue_printf("l4TcpNaptAliasOut src=%u.%u.%u.%u:%d dst=%u.%u.%u.%u:%d actionFlag=%d\n",NIPQUAD(sip),ip_sp,NIPQUAD(dip),ip_dp,actionFlag);
	if(tc->th_flags&TH_SYN) rtlglue_printf("SYN ");
	if(tc->th_flags&TH_ACK) rtlglue_printf("ACK ");
	if(tc->th_flags&TH_RST) rtlglue_printf("RST ");
	if(tc->th_flags&TH_FIN) rtlglue_printf("FIN ");
	if(tc->th_flags&TH_PUSH) rtlglue_printf("PUSH ");	
}
#endif

	
	initFlag = TCP_OUTBOUND_SYN_RCVD_FLOW;



#ifdef _RTL_WEAK_NAPT_CTRL
	if ((actionFlag & (TCP_OUT_TCP_SYN | TCP_OUT_TCP_ENTRY)) == 0)
	{
		if ((actionFlag == TCP_OUT_SERVER_PORT_ENTRY) || (actionFlag == TCP_OUT_UPNP_ENTRY))
		{
			initFlag = TCP_ESTABLISHED_FLOW;
		}else if (rtl8651_drvWeakTcpNaptEnable)
		{
			
			initFlag = TCP_ESTABLISHED_FLOW;
			actionFlag |= TCP_OUT_TCP_SYN;
		}else
		{
			actionFlag = 0;
		}
	}
#else
	if ((actionFlag&(TCP_OUT_TCP_SYN|TCP_OUT_TCP_ENTRY))==0)
	{
		if ((actionFlag == TCP_OUT_SERVER_PORT_ENTRY) || (actionFlag == TCP_OUT_UPNP_ENTRY))
		{
			initFlag = TCP_ESTABLISHED_FLOW;
		}else
		{
			actionFlag = 0;
		}
	}
#endif 

	if((actionFlag&(TCP_OUT_TCP_SYN|TCP_OUT_TCP_ENTRY)) == (TCP_OUT_TCP_SYN|TCP_OUT_TCP_ENTRY))
	{
		actionFlag = (TCP_OUT_TCP_SYN|TCP_OUT_TCP_ENTRY);
	}

	

	switch ( actionFlag )
	{
		case 0:

		

			_rtl8651_dosScanCheckTcpOutboundFailUnusual(phdr->ph_dsid, pip, tc);
			
			return FWDENG_TCP_NAPT_OUT_NOTFOUND;

		

		case 4:	
		case 5:	
		case 21:	

		case 32:	
		case 33:	
		case 49:	

		
			if (tb2)
			{
				assert(isUpnpMapping == FALSE);
				ip_alias = tb2->globalIp;
				ip_aliasp = ip_sp - tb2->localPort + tb2->globalPort;
			} else
			{
				assert(isUpnpMapping == TRUE);
				ip_alias = upnpExtIp;
				ip_aliasp = upnpExtPort;
			}

			if((retval = _rtl8651_addNaptConnection(TRUE,
					(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
					initFlag, ip_s, ip_sp, &ip_alias, &ip_aliasp, ip_d, ip_dp)) != SUCCESS)
			{
				return FWDENG_TCP_NAPT_OUT_ADDFAIL;
			}
			tb=&entry;
			if(_rtl8651_getOutboundNaptFlow(TRUE, ip_s, ip_sp, ip_d, ip_dp, &tb)!=SUCCESS)
			{
				rtlglue_printf("error: _rtl8651_getOutboundNaptFlow connection Failed \n");
 				return FWDENG_TCP_NAPT_OUT_NOTFOUND;
			}
			tb->	tcpAckModified = 0;
			tb->	tcpFtpLastLineCRLFTermed = 0;
			tb->tcpStateINdex = 0;
			memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);
			break;

		

		case 1:
		case 17: 

		

			_rtl8651_softNaptPolicyRoute(	ip_s,
											ip_d,
											IPPROTO_TCP,
											ip_sp,
											ip_dp,
											&ip_alias,
											&ip_aliasp);
#ifdef _RTL_NAPT_ADVANCED
			if (actionFlag == 1)
			{	
				if (ip_alias)
				{	
					if ((rtl8651_drvStaticTcpNaptPortTranslation == TRUE) &&
						(_rtl8651_l4CheckOccupiedConnection(TRUE, phdr->ph_dsid, ip_s, ip_sp, ip_alias, ip_sp, ip_d, ip_dp) == FALSE))
					{
						if (_rtl8651_addNaptConnection(TRUE,
								(TRUE|PURE_SW|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL|DO_REDUNDANCY_CHECK),
								initFlag, ip_s, ip_sp, &ip_alias, &ip_sp, ip_d, ip_dp)
								== SUCCESS)
							ip_aliasp = ip_sp;
						else
							goto TcpPolicyDynamicPortAssign;
					}else
					{
TcpPolicyDynamicPortAssign:
						if( _rtl8651_addNaptConnection(TRUE,
								(TRUE|PURE_SW|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
								initFlag, ip_s, ip_sp, &ip_alias, &ip_aliasp,
								ip_d, ip_dp)
								!= SUCCESS)
							return FWDENG_TCP_NAPT_OUT_ADDFAIL;
					}
				}else
				{	
					if (rtl8651_drvStaticTcpNaptPortTranslation == TRUE)
					{
						ip_alias = _rtl8651_getNaptInsideGlobalIpAddr(TRUE, ip_s, ip_sp, ip_d, ip_dp);

						if ((!ip_alias) ||(_rtl8651_l4CheckOccupiedConnection(TRUE, phdr->ph_dsid, ip_s, ip_sp, ip_alias, ip_sp, ip_d, ip_dp) == TRUE))
							goto TcpNormalDynamicPortAssign;

						if (_rtl8651_addNaptConnection(TRUE,
								(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL|DO_REDUNDANCY_CHECK),
								initFlag, ip_s, ip_sp, &ip_alias, &ip_sp, ip_d, ip_dp)
								== SUCCESS)
							ip_aliasp = ip_sp;
						else
							goto TcpNormalDynamicPortAssign;
					}else
					{
TcpNormalDynamicPortAssign:
						if(_rtl8651_addNaptConnection(TRUE,
								(FALSE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
								initFlag, ip_s, ip_sp, &ip_alias, &ip_aliasp, ip_d, ip_dp)
								!= SUCCESS)
							return FWDENG_TCP_NAPT_OUT_ADDFAIL;
					}
				}
			}else
			{	
				if (ip_alias)
				{
					if( _rtl8651_addNaptConnection(TRUE,
							(TRUE|PURE_SW|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
							initFlag, ip_s, ip_sp, &ip_alias, &ip_aliasp, ip_d, ip_dp) != SUCCESS)
						return FWDENG_TCP_NAPT_OUT_ADDFAIL;
				}
				else
				{
					
					if( _rtl8651_addNaptConnection(TRUE,
							(FALSE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
							initFlag, ip_s, ip_sp, &ip_alias, &ip_aliasp, ip_d, ip_dp) != SUCCESS )
						return FWDENG_TCP_NAPT_OUT_ADDFAIL;
				}
			}
#else 
			if (ip_alias)
			{
				if( _rtl8651_addNaptConnection(TRUE,
							(TRUE|PURE_SW|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
							sinitFlag, ip_s, ip_sp, &ip_alias, &ip_aliasp, ip_d, ip_dp) != SUCCESS)
					return FWDENG_TCP_NAPT_OUT_ADDFAIL;
			}else
			{	
				if( _rtl8651_addNaptConnection(TRUE,
						(FALSE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
						initFlag, ip_s, ip_sp, &ip_alias, &ip_aliasp, ip_d, ip_dp) != SUCCESS)
					return FWDENG_TCP_NAPT_OUT_ADDFAIL;
			} 
#endif 
			tb = &entry;
			if(_rtl8651_getOutboundNaptFlow(TRUE, ip_s, ip_sp, ip_d, ip_dp, &tb) == SUCCESS)
			{
				tb->	tcpAckModified = 0;
				tb->	tcpFtpLastLineCRLFTermed = 0;
				tb->tcpStateINdex = 0;
				memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);
				break;
			}
			return FWDENG_TCP_NAPT_OUT_NOTFOUND;

		

		case 2:	
		case 6:	

		case 34:	

		


#if 0
			if(tb->alg_server_out){
				int r;
				r = tb->alg_server_out(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}
#endif
			if(tb->alg_client_out)
			{
				int r;

				r = tb->alg_client_out(phdr, pip, tb);

				if(r == FWDENG_USER_DROP)
				{
					return FWDENG_USER_DROP;
				}
			}
			break;

		

		case 3:

		

			break;
#if 0 

		

		case 5:

		case 33:

		

			
			
			if (tb2)
			{
				tc->th_sport = ip_sp-tb2->localPort+tb2->globalPort;
				PKTSET_UINT32_UNALIGNED(tb2->globalIp, &pip->ip_src);
			}else
			{
				tc->th_sport = upnpExtPort;
				PKTSET_UINT32_UNALIGNED(upnpExtIp, &pip->ip_src);
			}

			return (SUCCESS);						

		

#endif

		case 9:	
		case 13:	

		case 41:	

		

			if (client_alg_link->fwEngAdd)
			{
				_rtl8651_softNaptPolicyRoute(	ip_s,
												ip_d,
												IPPROTO_TCP,
												ip_sp,
												ip_dp,
												&ip_alias,
												&ip_aliasp);
				if (ip_alias)
				{
					tb = _rtl8651_addAlgCtrlConnection(
						(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
						initFlag, ip_s, ip_sp, &ip_alias, &ip_aliasp, ip_d, ip_dp);
				}else
				{
					tb = _rtl8651_addAlgCtrlConnection(
						(FALSE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
						initFlag, ip_s, ip_sp, &ip_alias, &ip_aliasp, ip_d, ip_dp);
				}
					if(!tb)
						return FWDENG_TCP_NAPT_OUT_CLIALGADDFAIL;
			}

			tb=&entry;
			if(_rtl8651_getOutboundAlgCtrlFlow(TRUE, ip_s, ip_sp, ip_d, ip_dp, &tb) == SUCCESS)
			{
				tb->	tcpAckModified = 0;
				tb->	tcpFtpLastLineCRLFTermed = 0;
				tb->tcpStateINdex = 0;
				memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);
				break;
			}
			return FWDENG_TCP_NAPT_OUT_ALGNOTFOUND;								

		

		case 10:	
		case 14:	

		case 42:	

		

			 if(client_alg_link->fwEngAdd && client_alg_link->alg_outboundClientcb)
			 {
			 	int r;
				r=client_alg_link->alg_outboundClientcb(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			 }
			 break;

		

#if 0 
		case 21:

		case 49:

		

			
			{
				uint16 globalPort;
				ipaddr_t globalIp;
				if (tb2)
				{
					assert(isUpnpMapping == FALSE);
					globalPort = tb2->globalPort;
					globalIp = tb2->globalIp;
				}else
				{
					assert(isUpnpMapping == TRUE);
					globalPort = upnpExtPort;
					globalIp = upnpExtIp;
				}
				tb=_rtl8651_addAlgCtrlConnection(
					(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),
					initFlag,ip_s,ip_sp,&globalIp,&globalPort,ip_d,ip_dp);
			}
			if(!tb)
			{
				return FWDENG_TCP_NAPT_OUT_SVRALGADDFAIL;
			}
			tb->	tcpAckModified = 0;
			tb->	tcpFtpLastLineCRLFTermed = 0;
			tb->tcpStateINdex = 0;			
			memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);
			break;

		

#endif

		case 18: 
		case 22: 

		case 50:	

		

			 if(server_alg_link->fwEngAdd && server_alg_link->alg_outboundServercb)
			 {
			 	int r;
				r = server_alg_link->alg_outboundServercb(phdr, pip, tb);
				if( r == FWDENG_USER_DROP )
				{
					return FWDENG_USER_DROP;
				}
			 }
			break;

		

		default:	
			rtlglue_printf("%s: action=%d, flag=%d\n",__FUNCTION__,actionFlag,tc->th_flags );		
			return FWDENG_TCP_NAPT_OUT_IGNORE;
	}
	assert(tb);	
	assert(phdr->ph_routeIdx);

#ifdef _RTL_WEAK_NAPT_CTRL
	
	if (	rtl8651_drvWeakTcpNaptEnable &&
		(initFlag == TCP_ESTABLISHED_FLOW) &&
		(actionFlag != TCP_OUT_SERVER_PORT_ENTRY) &&
		(actionFlag != TCP_OUT_UPNP_ENTRY)
	)
	{
		if (actionFlag & TCP_OUT_SERVER_ALG)
		{
			 if(server_alg_link->fwEngAdd && server_alg_link->alg_outboundServercb)
			 {
			 	int r;
				r=server_alg_link->alg_outboundServercb(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			 }
		}
		if (actionFlag & TCP_OUT_CLIENT_ALG)
		{
			 if(client_alg_link->fwEngAdd && client_alg_link->alg_outboundClientcb)
			 {
			 	int r;
				r=client_alg_link->alg_outboundClientcb(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			 }
		}
	}
#endif 

	
	tb->out_rt_t = (void *)&DrvTbl.route[phdr->ph_routeIdx-1];	
	tb->dsid = phdr->ph_dsid;

	
	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;
	ip_sp = ntohs(tc->th_sport);
	ip_dp =  ntohs(tc->th_dport);
		
	ip_alias = tb->insideGlobalIpAddr;
	ip_aliasp = tb->insideGlobalPort;
	
	
	_rtl8651_l4TcpMonitorOut(tc, tb);

			
	if(tc->th_flags & TH_SYN){
		int8 auto_add = FALSE,auto_delete;			
		rtl8651_getAsicNaptAutoAddDelete(&auto_add,&auto_delete);			
		if(auto_add == FALSE){							
			uint8 *cp;
			int32 opt, optlen,cnt;		
			uint16 mss;
		
			cp = (uint8 *)(tc+1);
			cnt = ((tc->th_off_x >>2)&0x3c)  -sizeof(struct tcphdr);
	
			for(; cnt > 0; cnt -= optlen, cp+= optlen){
				opt = cp[0];
				if(opt == TCPOPT_EOL)
					break;
				if(opt == TCPOPT_NOP)
					optlen = 1;
				else{
					optlen = cp[1];
					if(optlen <= 0)
						break;
				}

				switch (opt) {
				case TCPOPT_MAXSEG:
					mss = ntohs(*(uint16*)(&cp[2]));

					
					thisPPPoE=_rtl8651_getPppoeSessionByIpAddr(ip_alias);
					if (thisPPPoE)
					{
						if (mss >pppoe_mss[thisPPPoE->dsid]) 
						{ 
							mtu=pppoe_mss[thisPPPoE->dsid];
							accumulate -=(mss-pppoe_mss[thisPPPoE->dsid]);
							*(uint16*)(&cp[2]) = htons(mtu);
						}
					}else if(mss > rtl8651_mss){
						mtu=rtl8651_mss;
						accumulate -=(mss-rtl8651_mss);
						*(uint16*)(&cp[2]) = htons(mtu);
					}
					break;
				default:
					continue;
				}			
			}				
		}
	}

	
	if (tb->tcpAckModified == 1)
	{
		int32     delta;
		
		delta = _rtl8651_l4GetDeltaSeqOut(pip, tc, tb);
		accumulate += delta;
		if (delta != 0)
		{
			uint32 seq_32_x = PKTGET_UINT32_UNALIGNED(&tc->th_seq);
			seq_32_x  = htonl(ntohl(seq_32_x) + delta);
			PKTSET_UINT32_UNALIGNED( seq_32_x,&tc->th_seq);
		}
	}

	
#ifdef RTL865XB_URL_FILTER
	if ((_urlFilterAclRuleNum>=0) &&
		((phdr->ph_reason&0xe)==4
		&& ((phdr->ph_reason&0xff0)>>5)==_urlFilterAclRuleNum))
#else
	if (!tb->urlFiltered||phdr->ph_reason==65)
#endif
	{
		int32 position, len=64;
		int8 matched[64];
		int32 hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;

		if (	((ntohs(pip->ip_len))>hlen))
		{
			position = _rtl8651_urlFilter(phdr->ph_dsid,phdr,pip,RTL8651_LAN2WAN,matched, &len);

			if (position > 0)
			{
				
				#ifdef RTL865X_DEBUG
				rtlglue_printf("string '%s'(%d bytes) in URL at %dth byte. Filtered...\n", matched, len, position );
				#endif
				_rtl8651_updateNaptConnection(tb,TCP_CLOSED_FLOW, 3);	
				return FWDENG_TCP_URLFILTERED;
			}
#ifndef RTL865XB_URL_FILTER
			tb->urlFiltered = TRUE;	
#endif
		}
	}

	
	if ((!(actionFlag&TCP_OUT_TCP_ENTRY)) && tb)
	{
		assert(tb->dosEnCount == TRUE && tb->dosFromInternal == TRUE);
	
		
		if ((_loggingModule[phdr->ph_dsid]&RTL8651_LOGMODULE_NEWFLOW)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			rtl8651_logInfo_t info;
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= phdr->ph_dsid;
			info.pkt_sip		= ip_s;
			info.pkt_dip		= ip_d;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= 0;	
			info.pkt_sport		= ip_sp;
			info.pkt_dport		= ip_dp;
			info.action		= RTL8651_LOGACTION_FORWARD;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_NEWFLOW, RTL8651_LOG_NEWFLOW_NewTcpNaptOutbound, &info);
#else
			(*_pUserLoggingFunc)(
				phdr->ph_dsid,
				RTL8651_LOGMODULE_NEWFLOW,
				    (unsigned char)pip->ip_p, 
				    (unsigned char)0, 
					(unsigned long)ip_s,
					(unsigned long)ip_d,
					(unsigned short)ip_sp,
					(unsigned short)ip_dp,
					0, 
					RTL8651_LOGACTION_FORWARD, 
					"New TCP Outbound Flow" );
#endif
		}
	}
	

#ifdef _RTL_NAPT_FRAG
	if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK)) == IP_MF))
	{
		if ((pip->ip_vhl & 0x0f) != 5)
		{	
			
			_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, ip_s, pip->ip_sum);	
		}
		
		_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, ip_s, ip_aliasp, ip_sp, tc->th_sum);	
		_RTL8651_ADJUST_CHECKSUM(accumulate, tc->th_sum);	

		if (IS_FRAGMENT(pip->ip_off))
		{	
			_rtl8651_updateFragCache(OUTBOUND_FRAG, phdr->ph_sip, phdr->ph_dip, ntohs(pip->ip_id), ip_alias, phdr->ph_routeIdx, NULL, phdr->ph_dsid);
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			_rtl8651_fragmentShortestPathCacheSet_firstHalf(phdr, (uint8*)tc, pip, ip_s, ip_d, RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYSIP, ip_alias);
#endif 
		}
	}
#endif 	

	
	tc->th_sport = htons(ip_aliasp);
	
	PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);

	return (SUCCESS);
}


static inline int32 _rtl8651_l4TcpNatAlgAliasOut(struct rtl_pktHdr *phdr, struct ip *pip, rtl8651_tblDrv_natEntry_t *natEntry)
{
	struct tcphdr *tc;
	ipaddr_t ip_s, ip_d, ip_alias = 0;
	uint16 ip_sp, ip_dp, ip_aliasp = 0;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb=&entry;
	rtl8651_tblDrv_algEntry_t *client_alg_link = NULL; 
	rtl8651_tblDrv_algEntry_t *server_alg_link = NULL; 
	int32 accumulate = 0;
	uint32 actionFlag = 0;
	rtl8651_tblDrv_pppTable_t *thisPPPoE;
	uint16 mtu;

#define TCP_OUT_TCP_SYN 0x01
#define TCP_OUT_TCP_ENTRY 0x02
#define TCP_OUT_SERVER_PORT_ENTRY 0x04
#define TCP_OUT_CLIENT_ALG 0x08
#define TCP_OUT_SERVER_ALG	0x10

	tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));

	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;	
	ip_sp = ntohs(tc->th_sport);
	ip_dp =  ntohs(tc->th_dport);

	if (ip_s == natEntry->globalIp)
	{	
		ip_alias = natEntry->globalIp;
		tb = NULL;
		goto adjust_mss;
	}

	client_alg_link = _rtl8651_l4FindLinkAlg(ip_dp, TRUE);		
	if(ip_sp != ip_dp)
	{
		server_alg_link = _rtl8651_l4FindLinkAlg(ip_sp, TRUE);	
	}

	



	
	if( _rtl8651_getOutboundAlgCtrlFlow(TRUE,ip_s,ip_sp,ip_d,ip_dp,  &tb)!=SUCCESS)
	{
		tb=NULL;
	}
	
	
	if(tc->th_flags & TH_SYN)
		actionFlag |= TCP_OUT_TCP_SYN;
	
	if(tb)
		actionFlag |= TCP_OUT_TCP_ENTRY;	
		 
	if(client_alg_link)
		actionFlag |= TCP_OUT_CLIENT_ALG;
		
	if(server_alg_link)
		actionFlag |= TCP_OUT_SERVER_ALG;

#ifdef _TONY_DEBUG
		rtlglue_printf("l4TcpNatAlgAliasOut src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d actionFlag=%d\n",NIPQUAD(ip_s),ip_sp,NIPQUAD(ip_d),ip_dp,actionFlag);
#endif		

	switch(actionFlag){

		case 2:
		
			
			if(tb->alg_client_out){
				int r;
				r = tb->alg_client_out(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}
			if(tb->alg_server_out){
				int r;
				r = tb->alg_server_out(phdr, pip, tb);
				if(r==FWDENG_USER_DROP) {
					return FWDENG_USER_DROP;
				}
			}						
			break;
		case 9: 
		case 17 :
			
			ip_alias = natEntry->globalIp;
			ip_aliasp = ip_sp;
			tb= _rtl8651_addAlgCtrlConnection(
				(TRUE|DOS_NAPT_ENCOUNT|DOS_NAPT_FROMINTERNAL),TCP_OUTBOUND_SYN_RCVD_FLOW,
				ip_s,ip_sp, &ip_alias,&ip_aliasp,ip_d,ip_dp);
			if(!tb)
				return FWDENG_TCP_NAT_OUT_ADDFAIL;

			tb->tcpAckModified = 0;
			tb->tcpFtpLastLineCRLFTermed = 0;
			tb->tcpStateINdex = 0;			
			memset(&tb->ack[0],0,sizeof(struct l4ack_data_record)*L4_N_LINK_TCP_DATA);
			tb->natlink = 1;
			break;

		case 10:
		case 11:
			 
			 if(client_alg_link->fwEngAdd && client_alg_link->alg_outboundClientcb){
			 	int r;
				r=client_alg_link->alg_outboundClientcb(phdr, pip, tb);	
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			 }
			 break;

		case 18:
		case 19:
			 
			 if(server_alg_link->fwEngAdd && server_alg_link->alg_outboundServercb){
			 	int r;
				r=server_alg_link->alg_outboundServercb(phdr, pip, tb);	
				if(r==FWDENG_USER_DROP) return FWDENG_USER_DROP;
			 }
			 break;
		case 1:
			ip_alias = natEntry->globalIp;
			goto adjust_mss;
		case 0:
			return FWDENG_TCP_NAT_OUT_ALGNOTFOUND;
		default:	
			rtlglue_printf("%s: action=%d, flag=%d\n",__FUNCTION__,actionFlag,tc->th_flags );		
			return FWDENG_TCP_NAT_OUT_ALGIGNORE;
	}
	
	assert(tb);
	ip_alias = tb->insideGlobalIpAddr;
	ip_aliasp = tb->insideGlobalPort;

	
	_rtl8651_l4TcpMonitorOut(tc, tb);

			
adjust_mss:
	if(tc->th_flags & TH_SYN)
	{
		int8 auto_add = FALSE,auto_delete;
		rtl8651_getAsicNaptAutoAddDelete(&auto_add,&auto_delete);			
		if(auto_add == FALSE){							
			uint8 *cp;
			int32 opt, optlen,cnt;		
			uint16 mss;
		
			cp = (uint8 *)(tc+1);
			cnt = ((tc->th_off_x >>2)&0x3c)  -sizeof(struct tcphdr);
	
			for(; cnt > 0; cnt -= optlen, cp+= optlen){
				opt = cp[0];
				if(opt == TCPOPT_EOL)
					break;
				if(opt == TCPOPT_NOP)
					optlen = 1;
				else{
					optlen = cp[1];
					if(optlen <= 0)
						break;
				}

				switch (opt) {
				case TCPOPT_MAXSEG:
					mss = ntohs(*(uint16*)(&cp[2]));

					
					thisPPPoE=_rtl8651_getPppoeSessionByIpAddr(ip_alias);
					
					
					
					if (thisPPPoE)
					{	
						if (mss >pppoe_mss[thisPPPoE->dsid])
						{
							mtu=pppoe_mss[thisPPPoE->dsid];
							accumulate -=(mss-pppoe_mss[thisPPPoE->dsid]);
							*(uint16*)(&cp[2]) = htons(mtu);
						}						
					}else if(mss > rtl8651_mss){
						
						mtu=rtl8651_mss;
						accumulate -=(mss-rtl8651_mss);
						*(uint16*)(&cp[2]) = htons(mtu);
					}
					break;
				default:
					continue;
				}			
			}				
		}
	}

	
	if(tb){
		tc->th_sport = ip_aliasp;
		
		if (tb->tcpAckModified == 1)
		{
			int32     delta;
			
			delta = _rtl8651_l4GetDeltaSeqOut(pip, tc, tb);
			accumulate += delta;
			if (delta != 0){
				uint32 seq_32_x = PKTGET_UINT32_UNALIGNED(&tc->th_seq);
				seq_32_x  = htonl(ntohl(seq_32_x) + delta);
				PKTSET_UINT32_UNALIGNED( seq_32_x,&tc->th_seq);
			}
		}
		PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);
	}else{ 
		assert(natEntry);
		PKTSET_UINT32_UNALIGNED(natEntry->globalIp, &pip->ip_src);
	}	
#ifdef _RTL_NAPT_FRAG			
	if(tb)
	{	
		if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF | IP_OFFMASK)) == IP_MF))
		{
			
			if ((pip->ip_vhl & 0x0f) != 5)
			{
				_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, ip_s, pip->ip_sum);
			}
			
			_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, ip_s, ip_aliasp, ip_sp, tc->th_sum);
			_RTL8651_ADJUST_CHECKSUM(accumulate, tc->th_sum);	
		}
	} else
	{	
		ip_alias = natEntry->globalIp;

		if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF | IP_OFFMASK)) == IP_MF))
		{
			
			if ((pip->ip_vhl & 0x0f) != 5)
			{
				_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, ip_s, pip->ip_sum);
			}
			
			
			_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, ip_s, 0, 0, tc->th_sum);
			_RTL8651_ADJUST_CHECKSUM(accumulate, tc->th_sum);	
		}
	}
#endif 	

	return (SUCCESS);
}


static inline int32 _rtl8651_l4NaptFlowGetDSID (uint8 fromInternal, struct rtl_pktHdr *pkthdr, struct ip *pip)
{
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t tcpUdpDummy, *tcpUdpTb = &tcpUdpDummy;
	ipaddr_t sip = pkthdr->ph_sip;
	ipaddr_t dip = pkthdr->ph_dip;

	if ( fromInternal == TRUE )
	{	
		if ( IS_FRAGMENT_REMAIN(pip->ip_off) )
		{
			if (	_rtl8651_getFragCache(	OUTBOUND_FRAG,
										sip,
										dip,
										ntohs(pip->ip_id),
										NULL,
										NULL,
										NULL,
										&(pkthdr->ph_dsid)) == SUCCESS)
			{
				goto dsidGetSuccess;
			}
			goto dsidGetFail;
		}

		switch ( pip->ip_p )
		{
			case IPPROTO_TCP:
			{
				struct tcphdr *tc;
				uint16 sport;
				uint16 dport;

				tc = (struct tcphdr *)L4HDR_ADDR(pip);
				sport = tc->th_sport;
				dport = tc->th_dport;

				if (_rtl8651_getOutboundNaptFlow(	TRUE,
													sip,
													sport,
													dip,
													dport,
													&tcpUdpTb) != SUCCESS)
				{
					tcpUdpTb = &tcpUdpDummy;
					if (_rtl8651_getOutboundAlgCtrlFlow(	TRUE,
													sip,
													sport,
													dip,
													dport,
													&tcpUdpTb) != SUCCESS)
					{
						tcpUdpTb = NULL;
					}
				}

				
				if ( tcpUdpTb )
				{
					pkthdr->ph_dsid = tcpUdpTb->dsid;
					goto dsidGetSuccess;
				}

				break;
			}
			case IPPROTO_UDP:
			{
				struct udphdr *ud;
				uint16 sport;
				uint16 dport;

				ud = (struct udphdr *)L4HDR_ADDR(pip);
				sport = ud->uh_sport;
				dport = ud->uh_dport;

				if (_rtl8651_getOutboundNaptFlow(	FALSE,
													sip,
													sport,
													dip,
													dport,
													&tcpUdpTb) != SUCCESS)
				{
					tcpUdpTb = &tcpUdpDummy;
					if (_rtl8651_getOutboundAlgCtrlFlow(	FALSE,
													sip,
													sport,
													dip,
													dport,
													&tcpUdpTb) != SUCCESS)
					{
						tcpUdpTb = NULL;
					}
				}

				
				if ( tcpUdpTb )
				{
					pkthdr->ph_dsid = tcpUdpTb->dsid;
					goto dsidGetSuccess;
				}

				break;
			}
			case IPPROTO_ICMP:
			{
				rtl8651_tblDrv_naptIcmpFlowEntry_t *icmpTb;
				struct icmp *ic;
				uint16 id;

				icmpTb = NULL;
				tcpUdpTb = NULL;

				ic = (struct icmp *)L4HDR_ADDR(pip);
				id = ic->icmp_id;

				switch ( ic->icmp_type )
				{
					case ICMP_ECHOREPLY:
					case ICMP_TSTAMPREPLY:
					case ICMP_ECHO:
					case ICMP_TSTAMP:

						icmpTb = _rtl8651_getInsideNaptIcmpEntry(	sip,
																	id,
																	dip,
																	FALSE,
																	FALSE);
						break;

					case ICMP_TIMXCEED:
					case ICMP_UNREACH:
					case ICMP_SOURCEQUENCH:
					case ICMP_PARAMPROB:
					{
						struct ip *eip = NULL;
						ipaddr_t esip, edip;

						eip = &(ic->icmp_ip);
						esip = PKTGET_UINT32_UNALIGNED(&(eip->ip_src));
						edip = PKTGET_UINT32_UNALIGNED(&(eip->ip_dst));

						if (IS_FRAGMENT_REMAIN(eip->ip_off))
						{
							RTL_NOTICE(	RTL_MSG_FWD, 
											"Forwarding Engine don't support ICMP error message for fragmented remaining packet yet.\n");
						} else
						{
							if (eip->ip_p == IPPROTO_UDP)
							{
								struct udphdr *ud = (struct udphdr *)L4HDR_ADDR(eip);
								tcpUdpTb = &tcpUdpDummy;
								if (	_rtl8651_getOutboundNaptFlow(	FALSE,
																	edip,
																	ntohs(ud->uh_dport),
																	esip,
																	ntohs(ud->uh_sport)
																	,&tcpUdpTb )
									!= SUCCESS )
								{
									tcpUdpTb = NULL;
								}
							} else if (eip->ip_p == IPPROTO_TCP)
							{
								struct tcphdr *tc = (struct tcphdr *)L4HDR_ADDR(eip);
								tcpUdpTb = &tcpUdpDummy;
								if(_rtl8651_getOutboundNaptFlow(	TRUE,
																	edip,
																	ntohs(tc->th_dport),
																	esip,
																	ntohs(tc->th_sport),
																	&tcpUdpTb )
									!= SUCCESS )
								{
									tcpUdpTb = NULL;
								}
							} else if (eip->ip_p == IPPROTO_ICMP)
							{
								struct icmp *eic = (struct icmp *) L4HDR_ADDR(eip);
								icmpTb = _rtl8651_getInsideNaptIcmpEntry(	edip,
																			ntohs(eic->icmp_id),
																			esip,
																			FALSE,
																			FALSE);
							} else
							{	
								RTL_NOTICE(	RTL_MSG_FWD,
												"Icmp error message with payload L4 type is %d\n", eip->ip_p);
							}
						}
					}
					break;
				}

				if ( icmpTb )
				{
					pkthdr->ph_dsid = icmpTb->dsid;
					goto dsidGetSuccess;
				}

				if ( tcpUdpTb )
				{
					pkthdr->ph_dsid = tcpUdpTb->dsid;
					goto dsidGetSuccess;
				}


				break;
			}
			default:
			{
				break;
			}
		}
	} else
	{	
		if ( IS_FRAGMENT_REMAIN(pip->ip_off) )
		{
			if (	_rtl8651_getFragCache(	INBOUND_FRAG,
										sip,
										dip,
										ntohs(pip->ip_id),
										NULL,
										NULL,
										NULL,
										&(pkthdr->ph_dsid)) == SUCCESS)
			{
				goto dsidGetSuccess;
			}
			goto dsidGetFail;
		}

		switch ( pip->ip_p )
		{
			case IPPROTO_TCP:
			{
				struct tcphdr *tc;
				uint16 sport;
				uint16 dport;

				tc = (struct tcphdr *)L4HDR_ADDR(pip);
				sport = tc->th_sport;
				dport = tc->th_dport;

				if ( _rtl8651_getInboundNaptFlow(	TRUE,
													dip,
													dport,
													sip,
													sport,
													&tcpUdpTb) != SUCCESS)
				{
					tcpUdpTb = NULL;
				}

				
				if ( tcpUdpTb )
				{
					pkthdr->ph_dsid = tcpUdpTb->dsid;
					goto dsidGetSuccess;
				}

				break;
			}
			case IPPROTO_UDP:
			{
				struct udphdr *ud;
				uint16 sport;
				uint16 dport;

				ud = (struct udphdr *)L4HDR_ADDR(pip);
				sport = ud->uh_sport;
				dport = ud->uh_dport;

				if ( _rtl8651_getInboundNaptFlow(	FALSE,
													dip,
													dport,
													sip,
													sport,
													&tcpUdpTb) != SUCCESS)
				{
					tcpUdpTb = NULL;
				}

				
				if ( tcpUdpTb )
				{
					pkthdr->ph_dsid = tcpUdpTb->dsid;
					goto dsidGetSuccess;
				}

				break;
			}
			case IPPROTO_ICMP:
			{
				rtl8651_tblDrv_naptIcmpFlowEntry_t *icmpTb;
				struct icmp *ic;
				uint16 id;

				icmpTb = NULL;
				tcpUdpTb = NULL;

				ic = (struct icmp *)L4HDR_ADDR(pip);
				id = ic->icmp_id;

				switch ( ic->icmp_type )
				{
					case ICMP_ECHOREPLY:
					case ICMP_TSTAMPREPLY:
					case ICMP_ECHO:
					case ICMP_TSTAMP:
					{
						icmpTb = _rtl8651_getOutsideNaptIcmpEntry(	sip,
																	id,
																	dip,
																	FALSE,
																	FALSE);
						break;
					}
					case ICMP_TIMXCEED:
					case ICMP_UNREACH:
					case ICMP_SOURCEQUENCH:
					case ICMP_PARAMPROB:
					{
						struct ip *eip = NULL;
						ipaddr_t esip, edip;

						eip = &(ic->icmp_ip);
						esip = PKTGET_UINT32_UNALIGNED(&(eip->ip_src));
						edip = PKTGET_UINT32_UNALIGNED(&(eip->ip_dst));

						if (IS_FRAGMENT_REMAIN(eip->ip_off))
						{
							RTL_NOTICE(	RTL_MSG_FWD,
											"Forwarding Engine don't support ICMP error message for fragmented remaining packet yet.\n");
						} else
						{
							if (eip->ip_p == IPPROTO_UDP)
							{
								struct udphdr *ud = (struct udphdr *)L4HDR_ADDR(eip);
								tcpUdpTb = &tcpUdpDummy;
								if ( _rtl8651_getInboundNaptFlow(	FALSE,
																	esip,
																	ntohs(ud->uh_sport),
																	edip,
																	ntohs(ud->uh_dport),
																	&tcpUdpTb )
									!= SUCCESS )
								{
									tcpUdpTb = NULL;
								}
							} else if (eip->ip_p == IPPROTO_TCP)
							{
								struct tcphdr *tc = (struct tcphdr *)L4HDR_ADDR(eip);
								tcpUdpTb = &tcpUdpDummy;
								if (	_rtl8651_getInboundNaptFlow(	TRUE,
																	esip,
																	ntohs(tc->th_sport),
																	edip,
																	ntohs(tc->th_dport),
																	&tcpUdpTb )
									!= SUCCESS )
								{
									tcpUdpTb = NULL;
								}
							} else if (eip->ip_p == IPPROTO_ICMP)
							{
								struct icmp *eic = (struct icmp *)L4HDR_ADDR(eip);
								icmpTb = _rtl8651_getOutsideNaptIcmpEntry(	esip,
																			ntohs(eic->icmp_id),
																			edip,
																			FALSE,
																			FALSE);
							} else
							{	
								RTL_NOTICE(	RTL_MSG_FWD,
												"Icmp error message with payload L4 type is %d\n", (uint32)eip->ip_p);
							}
						}
						break;
					}
				}

				if ( icmpTb )
				{
					pkthdr->ph_dsid = icmpTb->dsid;
					goto dsidGetSuccess;
				}

				if ( tcpUdpTb )
				{
					pkthdr->ph_dsid = tcpUdpTb->dsid;
					goto dsidGetSuccess;
				}

				break;
			}
			default:
			{
				break;
			}
		}

	}
dsidGetFail:
	return FAILED;

dsidGetSuccess:
	return SUCCESS;
}

#ifdef _RTL_NAPT_SHORT_CUT			

static inline int32 _rtl8651_l4TcpFastAliasIn(struct rtl_pktHdr *phdr, struct ip *pip)
{
	struct tcphdr *tc;
	ipaddr_t ip_org;
	ipaddr_t ip_s,  ip_d;
	uint16 ip_sp, ip_dp, ip_orgp;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb;
	
	ip_s=phdr->ph_sip;
	ip_d=phdr->ph_dip;
	
#ifdef _TONY_DEBUG
{
	uint32 sip=GET_UINT32_UNALIGNED(&pip->ip_src);
	uint32 dip=GET_UINT32_UNALIGNED(&pip->ip_dst);	
	rtlglue_printf("l4TcpFastAliasIn src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d seq=%u\n",NIPQUAD(sip),ip_sp,NIPQUAD(dip),ip_dp,GET_UINT32_UNALIGNED(&tc->th_seq));
}
#endif

#ifdef _RTL_NAPT_FRAG
		if (IS_FRAGMENT_REMAIN(pip->ip_off))
		{	
			uint32 org_ip;
			if (_rtl8651_getFragCache(INBOUND_FRAG, ip_s, ip_d, ntohs(pip->ip_id), &org_ip, &(phdr->ph_routeIdx), NULL, &(phdr->ph_dsid)) == SUCCESS)
			{
				PKTSET_UINT32_UNALIGNED(org_ip, &pip->ip_dst);
				if (!IPHDRLEN_IS_TWENTY(pip))
				{	
					_RTL8651_L3_ADJUST_CHECKSUM(org_ip, ip_d, pip->ip_sum);
				}
				if (_rtl8651_l3FastActRouting(FWDENG_FROMDRV, phdr, org_ip, pip, NULL) == SUCCESS)
					return SUCCESS;
			}
			return FAILED;
		}
#endif 

	tb = &entry;
	tc = (struct tcphdr *)L4HDR_ADDR(pip);
	ip_sp = ntohs(tc->th_sport);
	ip_dp = ntohs(tc->th_dport);

	if (tc->th_flags & (TH_SYN|TH_FIN|TH_RST))
		return FAILED;

#ifdef _RTL_NAPT_FRAG
	if ((IS_FRAGMENT(pip->ip_off)) && (_rtl8651_fragQueueProcessOk == FALSE) && (_rtl8651_frag_NeedFragmentProcess(ntohs(pip->ip_id), ip_s, ip_d, IPPROTO_TCP) == TRUE))
		return FAILED;
#endif 

	if (_rtl8651_getInboundNaptFlow(TRUE, ip_d, ip_dp, ip_s, ip_sp,  &tb) != SUCCESS)
	{
		return FAILED;
	}

	if (tb->inListType == NAPT_ALG_IN)
	{
		return FAILED;
	}

	if (tb->toProtocolStack == TRUE)
	{	
		return FAILED;
	}

	if(tb->alg_client_out || tb->alg_server_out || tb->alg_client_in || tb->alg_server_in ) 
		return FAILED; 

	if(tb->tcpFlag != (TCP_ESTABLISHED_FLOW-1))
	{
		return FAILED;
	}

	ip_org = tb->insideLocalIpAddr;
	ip_orgp = tb->insideLocalPort;



#ifdef RTL865XB_URL_FILTER
	if ((_urlFilterAclRuleNum>=0) &&
		((phdr->ph_reason&0xe)==4
		&& ((phdr->ph_reason&0xff0)>>5)==_urlFilterAclRuleNum))
#else
	if (!tb->urlFiltered||phdr->ph_reason==65)
#endif
	{
			return FAILED;
	}
	
	
	
	tc->th_dport = htons(ip_orgp);

	
	PKTSET_UINT32_UNALIGNED(ip_org, &pip->ip_dst);

	
	phdr->ph_dsid = tb->dsid;

	if (tb->in_rt_t)
	{
		phdr->ph_routeIdx = L3_TABLE_INDEX((rtl8651_tblDrv_routeTable_t *)tb->in_rt_t) + 1;
	}else
	{
		rtl8651_tblDrv_routeTable_t *rt_entry;
		if (((rt_entry = _rtl8651_getSoftRoutingEntry(ip_s, ip_org, IPPROTO_TCP, ip_sp, ip_orgp)) == NULL) &&
			((rt_entry = _rtl8651_getRoutingEntry(ip_org)) == NULL))
			return FWDENG_DROP;
		tb->in_rt_t = rt_entry;
		phdr->ph_routeIdx = L3_TABLE_INDEX(rt_entry) + 1;
	}

	if(_rtl8651_l4TcpMonitorIn(tc, tb)!=SUCCESS)	 
	{
		return FWDENG_DROP;
	}

	if ((IS_FRAGMENT(pip->ip_off)) || (!IPHDRLEN_IS_TWENTY(pip)))
	{
		if (!IPHDRLEN_IS_TWENTY(pip))
		{
			_RTL8651_L3_ADJUST_CHECKSUM(ip_org, ip_d, pip->ip_sum);
		}
		_RTL8651_L4_ADJUST_CHECKSUM(ip_org, ip_d, ip_orgp, ip_dp, tc->th_sum);
		if (IS_FRAGMENT(pip->ip_off))
		{
			_rtl8651_updateFragCache(INBOUND_FRAG, ip_s, ip_d, ntohs(pip->ip_id), ip_org, phdr->ph_routeIdx, NULL, phdr->ph_dsid);
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			_rtl8651_fragmentShortestPathCacheSet_firstHalf(phdr, (uint8*)tc, pip, ip_s, ip_d, RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYDIP, ip_org);
#endif 
		}
	}

	if( _rtl8651_l3FastActRouting(FWDENG_FROMDRV, phdr, ip_org, pip, &tb->in_macInfo_t) == SUCCESS)
	{
		return SUCCESS;
	}

	return FWDENG_DROP;
}




static inline int32 _rtl8651_l4TcpFastAliasOut(struct rtl_pktHdr *phdr, struct ip *pip)
{
	struct tcphdr *tc;
	ipaddr_t ip_alias;
	ipaddr_t ip_s, ip_d;
	uint16 ip_sp, ip_dp, ip_aliasp;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb;	

	ip_s=phdr->ph_sip;
	ip_d=phdr->ph_dip;

#ifdef _TONY_DEBUG
{
	uint32 sip=GET_UINT32_UNALIGNED(&pip->ip_src);
	uint32 dip=GET_UINT32_UNALIGNED(&pip->ip_dst);	
	rtlglue_printf("l4TcpFastAliasOut src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d seq=%u\n",NIPQUAD(sip),ip_sp,NIPQUAD(dip),ip_dp,GET_UINT32_UNALIGNED(&tc->th_seq));
	if(tc->th_flags&TH_SYN) rtlglue_printf("SYN ");
	if(tc->th_flags&TH_ACK) rtlglue_printf("ACK ");
	if(tc->th_flags&TH_RST) rtlglue_printf("RST ");
	if(tc->th_flags&TH_FIN) rtlglue_printf("FIN ");
	if(tc->th_flags&TH_PUSH) rtlglue_printf("PUSH ");	
}
#endif

#ifdef _RTL_NAPT_FRAG
	if (IS_FRAGMENT_REMAIN(pip->ip_off))
	{
		
		uint32 alias_ip;
		if (_rtl8651_getFragCache(OUTBOUND_FRAG, ip_s, ip_d, ntohs(pip->ip_id), &alias_ip, &(phdr->ph_routeIdx), NULL, &(phdr->ph_dsid)) == SUCCESS)
		{
			PKTSET_UINT32_UNALIGNED(alias_ip, &pip->ip_src);
			if (!IPHDRLEN_IS_TWENTY(pip))
			{	
				_RTL8651_L3_ADJUST_CHECKSUM(alias_ip, ip_s, pip->ip_sum);
			}
			if (_rtl8651_l3FastActRouting(FWDENG_FROMDRV, phdr, ip_d, pip, NULL) == SUCCESS)
				return SUCCESS;
		}
		return FAILED;
	}
#endif 

	tb = &entry;
	tc = (struct tcphdr *)L4HDR_ADDR(pip);
	ip_sp = ntohs(tc->th_sport);
	ip_dp =  ntohs(tc->th_dport);

	if (tc->th_flags & (TH_SYN|TH_FIN|TH_RST)) 
		return FAILED;

#ifdef _RTL_NAPT_FRAG
	if ((IS_FRAGMENT(pip->ip_off)) && (_rtl8651_fragQueueProcessOk == FALSE) && (_rtl8651_frag_NeedFragmentProcess(ntohs(pip->ip_id), ip_s, ip_d, IPPROTO_TCP) == TRUE))
		return FAILED;
#endif 

	if (_rtl8651_getOutboundNaptFlow(TRUE, ip_s, ip_sp, ip_d, ip_dp, &tb) != SUCCESS)
	{
		return FAILED;
	}

	if (tb->outListType == NAPT_ALG_OUT)
	{
		return FAILED;
	}

	if (tb->toProtocolStack == TRUE)
	{
		assert(0);	
		return FAILED;	
	}

	if(tb->alg_client_out  || tb->alg_server_out)  
		return FAILED; 

	if(tb->tcpFlag != (TCP_ESTABLISHED_FLOW-1))
	{
		return FAILED;
	}



#ifdef RTL865XB_URL_FILTER
	if((_urlFilterAclRuleNum>=0) &&
		((phdr->ph_reason&0xe)==4
		&& ((phdr->ph_reason&0xff0)>>5)==_urlFilterAclRuleNum))
#else
	if(!tb->urlFiltered||phdr->ph_reason==65)
#endif
	{		
			return FAILED;
	}


	ip_alias = tb->insideGlobalIpAddr;
	ip_aliasp = tb->insideGlobalPort;		

	
	phdr->ph_dsid = tb->dsid;

	if(_rtl8651_l4TcpMonitorOut(tc, tb)!=SUCCESS)	 	
	{
		return FWDENG_DROP;
	}

			
	tc->th_sport = htons(ip_aliasp);
	PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);
	if (tb->out_rt_t)
	{
		phdr->ph_routeIdx = L3_TABLE_INDEX((rtl8651_tblDrv_routeTable_t *)tb->out_rt_t) + 1;
	}else
	{
		rtl8651_tblDrv_routeTable_t *rt_entry;
		if (((rt_entry = _rtl8651_getSoftRoutingEntry(ip_s, ip_d, IPPROTO_TCP, ip_sp, ip_dp)) == NULL) &&
			((rt_entry = _rtl8651_getRoutingEntry(ip_d)) == NULL))
			return FWDENG_DROP;
		tb->out_rt_t = rt_entry;
		phdr->ph_routeIdx = L3_TABLE_INDEX(rt_entry) + 1;
	}

	if (IS_FRAGMENT_FIRST(pip->ip_off)||(!IPHDRLEN_IS_TWENTY(pip)))
	{
		if (!IPHDRLEN_IS_TWENTY(pip))
		{
			_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, ip_s, pip->ip_sum);
		}
		_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, ip_s, ip_aliasp, ip_sp, tc->th_sum);
		if (IS_FRAGMENT_FIRST(pip->ip_off))
		{
			_rtl8651_updateFragCache(OUTBOUND_FRAG, ip_s, ip_d, ntohs(pip->ip_id), ip_alias, phdr->ph_routeIdx, NULL, phdr->ph_dsid);
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			_rtl8651_fragmentShortestPathCacheSet_firstHalf(phdr, (uint8*)tc, pip, ip_s, ip_d, RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYSIP, ip_alias);
#endif 
		}
	}

	
	if( _rtl8651_l3FastActRouting(FWDENG_FROMDRV, phdr, ip_d, pip, &tb->out_macInfo_t) == SUCCESS)
	{
		return SUCCESS;
	}
	return FWDENG_DROP;
}



static inline int32 _rtl8651_l4UdpFastAliasIn(struct rtl_pktHdr *phdr, struct ip *pip)
{
	struct udphdr *ud;
	ipaddr_t ip_org;
	uint16 ip_sp, ip_dp, ip_orgp;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb;
	ipaddr_t ip_s, ip_d;

	ip_s=phdr->ph_sip;
	ip_d=phdr->ph_dip;
	
#ifdef _TONY_DEBUG
{
	uint32 sip=GET_UINT32_UNALIGNED(&pip->ip_src);
	uint32 dip=GET_UINT32_UNALIGNED(&pip->ip_dst);	
	rtlglue_printf("l4UdpFastAliasIn src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d\n",NIPQUAD(sip),ip_sp,NIPQUAD(dip),ip_dp);
}
#endif

#ifdef _RTL_NAPT_FRAG
	if (IS_FRAGMENT_REMAIN(pip->ip_off))
	{
		ipaddr_t newIp;
		rtl8651_tblDrv_naptTcpUdpFlowEntry_t *napt_t = NULL;
		if (_rtl8651_getFragCache(INBOUND_FRAG, ip_s, ip_d, ntohs(pip->ip_id), &newIp, &(phdr->ph_routeIdx), &napt_t, &(phdr->ph_dsid)) == SUCCESS)
		{
			PKTSET_UINT32_UNALIGNED(newIp, &pip->ip_dst);
			if (!IPHDRLEN_IS_TWENTY(pip))
			{
				_RTL8651_L3_ADJUST_CHECKSUM(newIp, ip_d, pip->ip_sum);
			}
			if (_rtl8651_l3FastActRouting(FWDENG_FROMDRV, phdr, newIp, pip, napt_t?(&napt_t->in_macInfo_t):NULL) == SUCCESS)
				return SUCCESS;
			else
				return FWDENG_DROP;
		}
		return FAILED;
	}
#endif 

	tb = &entry;
	ud = (struct udphdr *)L4HDR_ADDR(pip);
	ip_sp = ntohs(ud->uh_sport);
	ip_dp = ntohs(ud->uh_dport);

#ifdef _RTL_NAPT_FRAG
	if ((IS_FRAGMENT(pip->ip_off)) && (_rtl8651_fragQueueProcessOk == FALSE) && (_rtl8651_frag_NeedFragmentProcess(ntohs(pip->ip_id), ip_s, ip_d, IPPROTO_UDP) == TRUE))
		return FAILED;
#endif 

	if (_rtl8651_getInboundNaptFlow(FALSE,ip_d,ip_dp,ip_s,ip_sp,  &tb) != SUCCESS)
	{
		return FAILED;
	}

	if (tb->inListType == NAPT_ALG_IN)
	{
		return FAILED;
	}

	if (tb->toProtocolStack == TRUE)
	{	
		return FAILED;
	}

	if (tb->alg_client_in != NULL || tb->alg_server_in)
		return FAILED;

	
	_rtl8651_updateNaptConnection(tb, UDP_FLOW, rtl8651GlobalControl.udpTimeout);

	ip_org = tb->insideLocalIpAddr;
	ip_orgp = tb->insideLocalPort;

	
	phdr->ph_dsid = tb->dsid;

	
	ud->uh_dport = htons(ip_orgp);
	PKTSET_UINT32_UNALIGNED(ip_org, &pip->ip_dst);
	if (tb->in_rt_t)
	{
		phdr->ph_routeIdx = L3_TABLE_INDEX((rtl8651_tblDrv_routeTable_t *)tb->in_rt_t) + 1;
	}else
	{
		rtl8651_tblDrv_routeTable_t *rt_entry;
		if (((rt_entry = _rtl8651_getSoftRoutingEntry(ip_s, ip_org, IPPROTO_UDP, ip_sp, ip_orgp)) == NULL) &&
			((rt_entry = _rtl8651_getRoutingEntry(ip_org)) == NULL))
			return FWDENG_DROP;
		tb->in_rt_t = rt_entry;
		phdr->ph_routeIdx = L3_TABLE_INDEX(rt_entry) + 1;
	}

	if ((IS_FRAGMENT(pip->ip_off)) || (!IPHDRLEN_IS_TWENTY(pip)))
	{
		if (!IPHDRLEN_IS_TWENTY(pip))
		{
			_RTL8651_L3_ADJUST_CHECKSUM(ip_org, ip_d, pip->ip_sum);
		}
		if (ud->uh_sum)
		{
			_RTL8651_L4_ADJUST_CHECKSUM(ip_org, ip_d, ip_orgp, ip_dp, ud->uh_sum);
		}
		if (IS_FRAGMENT(pip->ip_off))
		{
			_rtl8651_updateFragCache(INBOUND_FRAG, ip_s, ip_d, ntohs(pip->ip_id), ip_org, phdr->ph_routeIdx, tb, phdr->ph_dsid);
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			_rtl8651_fragmentShortestPathCacheSet_firstHalf(phdr, (uint8*)ud, pip, ip_s, ip_d, RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYDIP, ip_org);
#endif 
		}
	}

	if( _rtl8651_l3FastActRouting(FWDENG_FROMDRV, phdr, ip_org, pip, &tb->in_macInfo_t) == SUCCESS)
		return SUCCESS;
	return FWDENG_DROP;	
 }


static inline int32 _rtl8651_l4UdpFastAliasOut(struct rtl_pktHdr *phdr, struct ip *pip)
{
	struct udphdr *ud;
	ipaddr_t ip_alias;
	uint16 ip_sp, ip_dp, ip_aliasp;	
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb;	
	ipaddr_t ip_s, ip_d;

	ip_s=phdr->ph_sip;
	ip_d=phdr->ph_dip;


#ifdef _TONY_DEBUG
{
	uint32 sip=GET_UINT32_UNALIGNED(&pip->ip_src);
	uint32 dip=GET_UINT32_UNALIGNED(&pip->ip_dst);	
	rtlglue_printf("l4UdpFastAliasOut src:%u.%u.%u.%u:%d dest:%u.%u.%u.%u:%d\n",NIPQUAD(sip),ip_sp,NIPQUAD(dip),ip_dp);
}
#endif

#ifdef _RTL_NAPT_FRAG
	if (IS_FRAGMENT_REMAIN(pip->ip_off))
	{
		ipaddr_t newIp;
		rtl8651_tblDrv_naptTcpUdpFlowEntry_t *napt_t = NULL;

		if (_rtl8651_getFragCache(OUTBOUND_FRAG, ip_s, ip_d, ntohs(pip->ip_id), &newIp, &(phdr->ph_routeIdx), &napt_t, &(phdr->ph_dsid)) == SUCCESS)
		{
			PKTSET_UINT32_UNALIGNED(newIp, &pip->ip_src);
			if (!IPHDRLEN_IS_TWENTY(pip))
			{
				_RTL8651_L3_ADJUST_CHECKSUM(newIp, ip_s, pip->ip_sum);
			}
			if (_rtl8651_l3FastActRouting(FWDENG_FROMDRV, phdr, ip_d, pip, napt_t?(&napt_t->out_macInfo_t):NULL) == SUCCESS)
				return SUCCESS;
			else
				return FWDENG_DROP;
		}
		return FAILED;
	}
#endif 
		
	tb = &entry;

	ud = (struct udphdr *)L4HDR_ADDR(pip);
	ip_sp = ntohs(ud->uh_sport);
	ip_dp =  ntohs(ud->uh_dport);

#ifdef _RTL_NAPT_FRAG
	if ((ntohs(pip->ip_off) & IP_MF) && (_rtl8651_fragQueueProcessOk == FALSE) && (_rtl8651_frag_NeedFragmentProcess(ntohs(pip->ip_id), ip_s, ip_d, IPPROTO_UDP) == TRUE))
		return FAILED;
#endif 

	if (_rtl8651_getOutboundNaptFlow(FALSE, ip_s, ip_sp, ip_d, ip_dp, &tb) != SUCCESS)
	{
		return FAILED;
	}

	if (tb->outListType == NAPT_ALG_OUT)
	{
		return FAILED;
	}

	if (tb->toProtocolStack == TRUE)
	{	
		assert(0);	
		return FAILED;
	}

	if (tb->alg_client_out || tb->alg_server_out || tb->alg_client_in || tb->alg_server_in )
		return FAILED;

	
	_rtl8651_updateNaptConnection(tb, UDP_FLOW, rtl8651GlobalControl.udpTimeout);

	ip_alias = tb->insideGlobalIpAddr;
	ip_aliasp = tb->insideGlobalPort;

	
	ud->uh_sport = htons(ip_aliasp);

	
	PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);

	
	phdr->ph_dsid = tb->dsid;

	
	if (tb->out_rt_t)
	{
		phdr->ph_routeIdx = L3_TABLE_INDEX((rtl8651_tblDrv_routeTable_t *)tb->out_rt_t) + 1;
	}else
	{
		rtl8651_tblDrv_routeTable_t *rt_entry;
		if (((rt_entry = _rtl8651_getSoftRoutingEntry(ip_s, ip_d, IPPROTO_UDP, ip_sp, ip_dp)) == NULL) &&
			((rt_entry = _rtl8651_getRoutingEntry(ip_d)) == NULL))
			return FWDENG_DROP;
		tb->out_rt_t = rt_entry;
		phdr->ph_routeIdx = L3_TABLE_INDEX(rt_entry) + 1;
	}

	if ((IS_FRAGMENT(pip->ip_off)) || (!IPHDRLEN_IS_TWENTY(pip)))
	{
		if (!IPHDRLEN_IS_TWENTY(pip))
		{
			_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, ip_s, pip->ip_sum);
		}
		if (ud->uh_sum)
		{
			_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, ip_s, ip_aliasp, ip_sp, ud->uh_sum);
		}
		if (IS_FRAGMENT(pip->ip_off))
		{
			_rtl8651_updateFragCache(OUTBOUND_FRAG, ip_s, ip_d, ntohs(pip->ip_id), ip_alias, phdr->ph_routeIdx, tb, phdr->ph_dsid);
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			_rtl8651_fragmentShortestPathCacheSet_firstHalf(phdr, (uint8*)ud, pip, ip_s, ip_d, RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYSIP, ip_alias);
#endif 
		}
	}

	if( _rtl8651_l3FastActRouting(FWDENG_FROMDRV, phdr, ip_d, pip, &tb->out_macInfo_t) == SUCCESS)
		return SUCCESS;

	return FWDENG_DROP;
}
#endif 




void _rtl8651_l4AddSeq(struct ip *pip, rtl8651_tblDrv_naptTcpUdpFlowEntry_t *tb, int32 delta)
{

	struct tcphdr *tc;
	struct l4ack_data_record x;
	int32     hlen, tlen, dlen;
	int32     i;
	uint32  seq_32_x;

	if ((pip->ip_p != IPPROTO_TCP) || IS_FRAGMENT_REMAIN(pip->ip_off))
	{
		return;
	}

	tc = (struct tcphdr *)L4HDR_ADDR(pip);
	seq_32_x = PKTGET_UINT32_UNALIGNED(&tc->th_seq);
	hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;
	tlen = (pip->ip_len);
	dlen = tlen - hlen;

	x.ack_old = ((seq_32_x) + dlen);
	x.ack_new = ((seq_32_x) + dlen + delta);
	
	x.delta = delta;
	x.active = 1;

	i = tb->tcpStateINdex;
	i %= L4_N_LINK_TCP_DATA;
	rtl8651_memcpy(&tb->ack[i],&x,sizeof(struct l4ack_data_record));

	i++;
	if (i == L4_N_LINK_TCP_DATA)
		tb->tcpStateINdex = 0;
	else
		tb->tcpStateINdex = i;
}





#ifdef RTL8651_ALG_MODULE_UPDATE

rtl8651_tblDrv_algEntry_t *_rtl8651_l4FindLinkAlg( uint16 alg_port, uint16 isTcp )								
{
	rtl8651_tblDrv_algEntry_t *tb;
	tb = _rtl8651_getAlgEntry( isTcp, alg_port, alg_port );
	
	if (tb != NULL)
	{ 
		if (tb->fwEngAdd == 1)
			return tb;
		else
			return NULL;
	}
	else
		return NULL;
}

#else
rtl8651_tblDrv_algEntry_t *_rtl8651_l4FindLinkAlg(uint16 alg_port, uint16 isTcp)								
{
	rtl8651_tblDrv_algEntry_t *tb;
	int8 isServer, isClient;

	tb = _rtl8651_getAlgEntry(isTcp, &isServer, &isClient, alg_port, alg_port);
	
	if(tb){ 
		if( tb->fwEngAdd)
			return tb;
		else
			return NULL;
	}

	return NULL;
}
#endif


static inline int32 _rtl8651_l4napt_process(struct rtl_pktHdr * pkthdrPtr , struct ip *ip,uint8 proto, int32 dir)
{
	int32     status;

	if (dir == _RTL8651_L4_NAT_OUTPUT){
		
#ifdef _RTL_NAPT_FRAG
		if(IS_FRAGMENT_REMAIN(ip->ip_off))
		{
			
			uint32 alias_ip;

			ipaddr_t org_sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
			ipaddr_t org_dip = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);

			if (_rtl8651_getFragCache(OUTBOUND_FRAG, org_sip, org_dip, ntohs(ip->ip_id), &alias_ip, &(pkthdrPtr->ph_routeIdx), NULL, &(pkthdrPtr->ph_dsid)) == SUCCESS)
			{	
				PKTSET_UINT32_UNALIGNED(alias_ip, &ip->ip_src);
				if (!IPHDRLEN_IS_TWENTY(ip))
				{	
					_RTL8651_L3_ADJUST_CHECKSUM(alias_ip, pkthdrPtr->ph_sip, ip->ip_sum);
				}
				pkthdrPtr->ph_proto = PKTHDR_IP;
				return _RTL8651_NAT_PASS;
			}else if (_rtl8651_getFragCache(NAPT_REDIRECT_FRAG, org_sip, org_dip, ntohs(ip->ip_id), &alias_ip, NULL, NULL, &(pkthdrPtr->ph_dsid)) == SUCCESS)
			{
				PKTSET_UINT32_UNALIGNED(alias_ip, &ip->ip_dst);
				_RTL8651_L3_ADJUST_CHECKSUM(alias_ip, pkthdrPtr->ph_dip, ip->ip_sum);
				return FWDENG_TO_GW;	
			}
			return FWDENG_IP_CANTFRAG;
		}
#else		
		if( IS_FRAGMENT(ip->ip_off))
		{
			return FWDENG_IP_CANTFRAG;	
		}		
#endif 

		switch (proto){
			case IPPROTO_TCP:
				status = _rtl8651_l4TcpNaptAliasOut(pkthdrPtr, ip);
				break;
			case IPPROTO_UDP:
				status = _rtl8651_l4UdpNaptAliasOut(pkthdrPtr, ip);
				break;
			case IPPROTO_ICMP:
				status = _rtl8651_l4IcmpNaptAliasOut(pkthdrPtr, ip);
				break;
			case IPPROTO_GRE:
				if(rtl8651_l4GreNaptAliasOut)
				{
					ipaddr_t ip_s;	
					ip_s = pkthdrPtr->ph_sip;
					
					status = (*rtl8651_l4GreNaptAliasOut)(pkthdrPtr, ip);
					if (status == SUCCESS)
					{	
						if (!IPHDRLEN_IS_TWENTY(ip))
						{	
							
							_RTL8651_L3_ADJUST_CHECKSUM(pkthdrPtr->ph_sip, ip_s, ip->ip_sum);	
						}
						if (IS_FRAGMENT_FIRST(ip->ip_off))
						{	
							_rtl8651_updateFragCache(OUTBOUND_FRAG, ip_s, pkthdrPtr->ph_dip, ntohs(ip->ip_id), pkthdrPtr->ph_sip, pkthdrPtr->ph_routeIdx, NULL, pkthdrPtr->ph_dsid);
						}
						pkthdrPtr->ph_sip = ip_s;	
					}
				}else
				{
					status = FWDENG_L4_NAPT_UNSUPPORTPROTO;
				}
				if (status != SUCCESS)
				{
					if (_rtl8651_outboundL4DMZForward(pkthdrPtr, ip, pkthdrPtr->ph_sip) == SUCCESS)
						status = SUCCESS;
				}
				break;
			case IPPROTO_ESP:			
				if(rtl8651_l4EspNaptAliasOut)
				{
					ipaddr_t ip_s;	
					ip_s = pkthdrPtr->ph_sip;
					
					status = (*rtl8651_l4EspNaptAliasOut)(pkthdrPtr, ip);
					if (status == SUCCESS)
					{
						if (!IPHDRLEN_IS_TWENTY(ip))
						{	
							
							_RTL8651_L3_ADJUST_CHECKSUM(pkthdrPtr->ph_sip, ip_s, ip->ip_sum);	
						}
						if (IS_FRAGMENT_FIRST(ip->ip_off))
						{	
							_rtl8651_updateFragCache(OUTBOUND_FRAG, ip_s, pkthdrPtr->ph_dip, ntohs(ip->ip_id), pkthdrPtr->ph_sip, pkthdrPtr->ph_routeIdx, NULL, pkthdrPtr->ph_dsid);
						}
						pkthdrPtr->ph_sip = ip_s;	
					}
				}else
				{
					status = FWDENG_L4_NAPT_UNSUPPORTPROTO;
				}
				if (status != SUCCESS)
				{
					if (_rtl8651_outboundL4DMZForward(pkthdrPtr, ip, pkthdrPtr->ph_sip) == SUCCESS)
						status = SUCCESS;
				}
				break;
			case IPPROTO_RSVP:			

				if(rtl8651_l4RsvpNaptAliasOut)
				{
					ipaddr_t ip_s;	
					ip_s = pkthdrPtr->ph_sip;
					
					status = (*rtl8651_l4RsvpNaptAliasOut)(pkthdrPtr, ip);
					if (status == SUCCESS)
					{
						if (!IPHDRLEN_IS_TWENTY(ip))
						{	
							
							_RTL8651_L3_ADJUST_CHECKSUM(pkthdrPtr->ph_sip, ip_s, ip->ip_sum);	
						}
						if (IS_FRAGMENT_FIRST(ip->ip_off))
						{	
							_rtl8651_updateFragCache(OUTBOUND_FRAG, ip_s, pkthdrPtr->ph_dip, ntohs(ip->ip_id), pkthdrPtr->ph_sip, pkthdrPtr->ph_routeIdx, NULL, pkthdrPtr->ph_dsid);
						}
						pkthdrPtr->ph_sip = ip_s;	
					}
				}else
				{
					status = FWDENG_L4_NAPT_UNSUPPORTPROTO;
				}
				if (status != SUCCESS)
				{
					if (_rtl8651_outboundL4DMZForward(pkthdrPtr, ip, pkthdrPtr->ph_sip) == SUCCESS)
						status = SUCCESS;
				}
				break;				
			default:
				if (_rtl8651_outboundL4DMZForward(pkthdrPtr, ip, pkthdrPtr->ph_sip) == SUCCESS)
					status = SUCCESS;
				else
				status = FWDENG_L4_UNKNOWNPROTO;
		}
		
	}else
	{
#ifdef _RTL_NAPT_FRAG		
		if( IS_FRAGMENT_REMAIN(ip->ip_off) )
		{
			
			uint32 org_ip;

			ipaddr_t org_sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
			ipaddr_t org_dip = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);

			if (_rtl8651_getFragCache(INBOUND_FRAG, org_sip, org_dip, ntohs(ip->ip_id), &org_ip, &(pkthdrPtr->ph_routeIdx), NULL, &(pkthdrPtr->ph_dsid)) == SUCCESS)
			{
				PKTSET_UINT32_UNALIGNED(org_ip, &ip->ip_dst);
				if (!IPHDRLEN_IS_TWENTY(ip))
				{	
					_RTL8651_L3_ADJUST_CHECKSUM(org_ip, pkthdrPtr->ph_dip, ip->ip_sum);
				}
				return _RTL8651_NAT_PASS;
			}
			return FWDENG_IP_CANTFRAG;
		}
#else
		if( IS_FRAGMENT(ip->ip_off))
		{
			return FWDENG_IP_CANTFRAG;	
		}				
#endif 		


		switch (proto){
		case IPPROTO_TCP:
			status = _rtl8651_l4TcpNaptAliasIn(pkthdrPtr, ip);
			break;
		case IPPROTO_UDP:
			status = _rtl8651_l4UdpNaptAliasIn(pkthdrPtr, ip);
			break;
		case IPPROTO_ICMP:				
			status = _rtl8651_L4IcmpNaptAliasIn(pkthdrPtr, ip);								
			break;
		case IPPROTO_GRE:	
			if(rtl8651_l4GreNaptAliasIn)
			{
				ipaddr_t ip_d;	
				ip_d = pkthdrPtr->ph_dip;
				
				status = (*rtl8651_l4GreNaptAliasIn)(pkthdrPtr, ip);
				if (status == SUCCESS)
				{
				
					if (!IPHDRLEN_IS_TWENTY(ip))
					{	
						
						_RTL8651_L3_ADJUST_CHECKSUM(pkthdrPtr->ph_dip, ip_d, ip->ip_sum);	
					}
					if (IS_FRAGMENT_FIRST(ip->ip_off))
					{	
						_rtl8651_updateFragCache(INBOUND_FRAG, pkthdrPtr->ph_sip, ip_d, ntohs(ip->ip_id), pkthdrPtr->ph_dip, 0, NULL, pkthdrPtr->ph_dsid);
					}
				}
			}else
			{
				status = FWDENG_L4_NAPT_UNSUPPORTPROTO;
			}
			if (status != SUCCESS)
			{
				if (_rtl8651_inboundL4DMZForward(pkthdrPtr, ip, pkthdrPtr->ph_dip) == SUCCESS)
					status = SUCCESS;
			}
			break;
		case IPPROTO_ESP:						
			if(rtl8651_l4EspNaptAliasIn)
			{
				ipaddr_t ip_d;	
				ip_d = pkthdrPtr->ph_dip;
				
				status = (*rtl8651_l4EspNaptAliasIn)(pkthdrPtr, ip);
				
				if (status == SUCCESS)
				{
					if (!IPHDRLEN_IS_TWENTY(ip))
					{	
						
						_RTL8651_L3_ADJUST_CHECKSUM(pkthdrPtr->ph_dip, ip_d, ip->ip_sum);	
					}
					if (IS_FRAGMENT_FIRST(ip->ip_off))
					{	
						_rtl8651_updateFragCache(INBOUND_FRAG, pkthdrPtr->ph_sip, ip_d, ntohs(ip->ip_id), pkthdrPtr->ph_dip, 0, NULL, pkthdrPtr->ph_dsid);
					}
				}
			}else
			{
				status = FWDENG_L4_NAPT_UNSUPPORTPROTO;
			}	
			if (status != SUCCESS)
			{
				if (_rtl8651_inboundL4DMZForward(pkthdrPtr, ip, pkthdrPtr->ph_dip) == SUCCESS)
					status = SUCCESS;
			}
			break;
		case IPPROTO_RSVP:

			if(rtl8651_l4RsvpNaptAliasIn)
			{
				ipaddr_t ip_d;	
				ip_d = pkthdrPtr->ph_dip;
				
				status = (*rtl8651_l4RsvpNaptAliasIn)(pkthdrPtr, ip);
				
				if (status == SUCCESS)
				{
					if (!IPHDRLEN_IS_TWENTY(ip))
					{	
						
						_RTL8651_L3_ADJUST_CHECKSUM(pkthdrPtr->ph_dip, ip_d, ip->ip_sum);	
					}
					if (IS_FRAGMENT_FIRST(ip->ip_off))
					{	
						_rtl8651_updateFragCache(INBOUND_FRAG, pkthdrPtr->ph_sip, ip_d, ntohs(ip->ip_id), pkthdrPtr->ph_dip, 0, NULL, pkthdrPtr->ph_dsid);
					}
				}
			}else
			{
				status = FWDENG_L4_NAPT_UNSUPPORTPROTO;
			}	
			if (status != SUCCESS)
			{
				if (_rtl8651_inboundL4DMZForward(pkthdrPtr, ip, pkthdrPtr->ph_dip) == SUCCESS)
					status = SUCCESS;
			}
			break;
		default:
			if (_rtl8651_inboundL4DMZForward(pkthdrPtr, ip, pkthdrPtr->ph_dip) == SUCCESS)
				status = SUCCESS;
			else
				status = FWDENG_L4_UNKNOWNPROTO;
		}
	
	}

	switch (status){	
	case SUCCESS:		
#ifdef _RTL_NAPT_FRAG
		if(ntohs(ip->ip_off) & (IP_MF| IP_OFFMASK))
		{
			pkthdrPtr->ph_proto = PKTHDR_IP;
		}
#endif
		return _RTL8651_NAT_PASS;
	case FWDENG_USER_DROP:
		
		return _RTL8651_NAT_DROP;
	default:
		return status;		
	}		
}


static inline int32 _rtl8651_l4nat_in_process(struct rtl_pktHdr *phdr, struct ip *pip)
{

	ipaddr_t ip_d, ip_org = 0;
	rtl8651_tblDrv_natEntry_t *tb =NULL;
	int32 iresult = SUCCESS;

			
	ip_d = phdr->ph_dip;

	tb = _rtl8651_getNatExternalMappingEntry(ip_d,phdr);

	if(tb == NULL || tb->localIp == 0){
		return _RTL8651_NAT_IGNORE;
	}
			
	ip_org = tb->localIp;

	if ((pip->ip_off) & IP_OFFMASK)
		goto change_ip;

	switch(pip->ip_p){
		case IPPROTO_TCP:

#ifdef RTL865XB_URL_FILTER
			if ((_urlFilterAclRuleNum>=0) && 
				((phdr->ph_reason&0xe)==4 && ((phdr->ph_reason&0xff0)>>5)==_urlFilterAclRuleNum))
#else
			if (phdr->ph_reason == 65)
#endif
			{
				struct tcphdr *tc=(struct tcphdr *)((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
				int32 hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;

				if (	((ntohs(pip->ip_len)) > hlen))
				{
					int32 position, len=64;
					int8 matched[64];
					position = _rtl8651_urlFilter(phdr->ph_dsid,phdr,pip,RTL8651_WAN2LAN,matched,&len);

					if (position > 0)
					{
						
						#ifdef RTL865X_DEBUG
						rtlglue_printf("string '%s'(%d bytes) in URL at %dth byte. Filtered...\n",matched, len, position );
						#endif
						return FWDENG_TCP_URLFILTERED;
					}
				}
			}

			iresult = _rtl8651_l4TcpNatAlgAliasIn(phdr, pip, tb);
			break;
		case IPPROTO_UDP:
			iresult = _rtl8651_l4UdpNatAlgAliasIn(phdr, pip, tb);
			break;	
		case IPPROTO_ICMP:
			{	
				struct icmp *ic = (struct icmp *)((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
				struct ip *ip = &ic->icmp_ip;

				switch (ic->icmp_type)
				{
					case ICMP_UNREACH:
					case ICMP_SOURCEQUENCH:
					case ICMP_TIMXCEED:
					case ICMP_PARAMPROB:
						PKTSET_UINT32_UNALIGNED(ip_org, &ip->ip_src);
							_RTL8651_L3_ADJUST_CHECKSUM(ip_org, tb->globalIp, ip->ip_sum);
				}
			}
			
		default:
			
			goto change_ip;		
	}

	if(iresult ==FWDENG_TCP_NAT_IN_ALGNOTFOUND||
		iresult==FWDENG_UDP_NAT_IN_ALGNOTFOUND)
	{
change_ip:
		if (((pip->ip_vhl & 0x0f) != 5) || (((ntohs(pip->ip_off)) & (IP_MF|IP_OFFMASK))  == IP_MF))
		{
			struct tcphdr *tc;
			struct udphdr *ud;

			if ((pip->ip_vhl & 0x0f) != 5)
			{
				_RTL8651_L3_ADJUST_CHECKSUM(ip_org, phdr->ph_dip, pip->ip_sum);
			}

			if ((ntohs(pip->ip_off)&IP_OFFMASK) == 0)
			{
				switch(pip->ip_p)
				{
					case IPPROTO_TCP:
						tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
						_RTL8651_L4_ADJUST_CHECKSUM(ip_org, phdr->ph_dip, 0, 0, tc->th_sum);
						break;
					case IPPROTO_UDP:
						ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
						if (ud->uh_sum)
						{
							_RTL8651_L4_ADJUST_CHECKSUM(ip_org, phdr->ph_dip, 0, 0, ud->uh_sum);
						}
						break;
				}
			}
		}
		PKTSET_UINT32_UNALIGNED(ip_org, &pip->ip_dst);
	} else if(iresult != SUCCESS)
	{
		rtlglue_printf("%s: errno=%d\n",__FUNCTION__, iresult);
		return iresult;
	}
#if 0
	if(iresult != SUCCESS && 
		((ntohs(pip->ip_off)) & (IP_MF|IP_OFFMASK))  == IP_MF){
		
		struct tcphdr *tc;
		struct udphdr *ud;

		
		accumulate = (phdr->ph_dip & 0xffff);
		accumulate +=  ((phdr->ph_dip >> 16) & 0xffff);
		accumulate -= (ip_org & 0xffff);
		accumulate -=  ((ip_org >> 16) & 0xffff);

		PKTSET_UINT32_UNALIGNED(ip_org, &pip->ip_dst);
		
		switch(pip->ip_p){
			case IPPROTO_TCP:
				tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
				_RTL8651_ADJUST_CHECKSUM(accumulate, tc->th_sum);	
				break;
			case IPPROTO_UDP:
				ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
				if (ud->uh_sum)
					_RTL8651_ADJUST_CHECKSUM(accumulate, ud->uh_sum);				
				break;		
		}		
	}
	else if(iresult ==FWDENG_TCP_NAT_IN_ALGNOTFOUND||
		iresult==FWDENG_UDP_NAT_IN_ALGNOTFOUND )
	{		
change_ip:

		
		accumulate = (ip_d & 0xffff);
		accumulate +=  ((ip_d >> 16) & 0xffff);
		accumulate -= (ip_org & 0xffff);
		accumulate -=  ((ip_org >> 16) & 0xffff);
		
		PKTSET_UINT32_UNALIGNED(ip_org, &pip->ip_dst);
	}else if(iresult!=SUCCESS){
		rtlglue_printf("%s: errno=%d\n",__FUNCTION__, iresult);
	}
#endif

	if(ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK))
	{
		phdr->ph_proto = PKTHDR_IP;
	}

	phdr->ph_routeIdx = 0;
	if(_rtl8651_l3ActRouting((struct rtl_pktHdr *)phdr,ip_org,pip) != SUCCESS){
		return _RTL8651_NAT_DROP;
	}
	return (_RTL8651_NAT_PASS);

}



static inline int32 _rtl8651_l4nat_out_process(struct rtl_pktHdr *phdr, struct ip *pip)
{
	ipaddr_t ip_s, ip_d, ip_alias = 0;
	rtl8651_tblDrv_natEntry_t *tb;
	int32 iresult = SUCCESS;

		
	ip_s = phdr->ph_sip;
	ip_d = phdr->ph_dip;


	tb = _rtl8651_getNatInternalMappingEntry(ip_s,phdr);
	
	#if 0
	if (tb==NULL && (phdr->ph_unnumber & 0x1)){
		tb=(rtl8651_tblDrv_natEntry_t*)rtlglue_malloc(sizeof(rtl8651_tblDrv_natEntry_t));
		assert(tb);
		memset(tb,0,sizeof(rtl8651_tblDrv_natEntry_t));
		
		if ((phdr->ph_unnumber & 0x2)==0){
						
			tb->localIp=ip_s;
			tb->globalIp=ip_s;
		}else{
			
			tb->localIp=ip_d;
			tb->globalIp=ip_d;
		}
	}
	#endif
	if(tb == NULL || tb->localIp == 0){
		return FWDENG_L4_NATNOENTRY;
	}

	ip_alias = tb->globalIp;

	if (ntohs(pip->ip_off) & IP_OFFMASK)
		goto change_ip;

	switch (pip->ip_p)
	{
		case IPPROTO_TCP:

#ifdef RTL865XB_URL_FILTER
			if ((_urlFilterAclRuleNum>=0) && 
				((phdr->ph_reason&0xe)==4 && ((phdr->ph_reason&0xff0)>>5)==_urlFilterAclRuleNum))
#else
			if (phdr->ph_reason == 65)
#endif
			{
				struct tcphdr *tc=(struct tcphdr *)((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
				int32 hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;

				if (	((ntohs(pip->ip_len)) > hlen))
				{
					int32 position, len=64;
					int8 matched[64];

					position = _rtl8651_urlFilter(phdr->ph_dsid,phdr,pip,RTL8651_LAN2WAN,matched, &len);

					if (position > 0)
					{
						
						#ifdef RTL865X_DEBUG
						rtlglue_printf("string '%s'(%d bytes) in URL at %dth byte. Filtered...\n",matched, len, position );
						#endif
						return FWDENG_TCP_URLFILTERED;
					}
				}
			}

			iresult = _rtl8651_l4TcpNatAlgAliasOut(phdr, pip, tb);
			break;
		case IPPROTO_UDP:
			iresult = _rtl8651_l4UdpNatAlgAliasOut(phdr, pip, tb);
			break;	
		case IPPROTO_ICMP:
			{	
				struct icmp *ic = (struct icmp *)((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
				struct ip *ip = &ic->icmp_ip;

				switch (ic->icmp_type)
				{
					case ICMP_UNREACH:
					case ICMP_SOURCEQUENCH:
					case ICMP_TIMXCEED:
					case ICMP_PARAMPROB:
						PKTSET_UINT32_UNALIGNED(ip_alias, &ip->ip_dst);
						_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, tb->localIp, ip->ip_sum);
				}
			}
			
		default:
			
			goto change_ip;		
	}

	if( (iresult == FWDENG_TCP_NAT_OUT_ALGNOTFOUND) ||
		(iresult == FWDENG_UDP_NAT_OUT_ALGNOTFOUND ))
	{
change_ip:
		if (((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK))  == IP_MF) ||((pip->ip_vhl & 0x0f) != 5))
		{	
			struct tcphdr *tc;
			struct udphdr *ud;
			
			if ((pip->ip_vhl & 0x0f) != 5)
			{
				_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, phdr->ph_sip, pip->ip_sum);
			}
			
			if ((ntohs(pip->ip_off) & IP_OFFMASK) == 0)
			{
				switch(pip->ip_p)
				{
					case IPPROTO_TCP:
						tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
						_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, phdr->ph_sip, 0, 0, tc->th_sum);
						break;
					case IPPROTO_UDP:
						ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
						if (ud->uh_sum)
						{
							_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, phdr->ph_sip, 0, 0, ud->uh_sum);
						}
						break;
				}
			}
		}
		PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);
		
	} else if (iresult != SUCCESS)
	{
		rtlglue_printf("%s: errno=%d\n",__FUNCTION__, iresult);
		return iresult;
	}
#if 0
	if((iresult != SUCCESS) &&
		(((ntohs(pip->ip_off) &  (IP_MF|IP_OFFMASK))  == IP_MF) ||
		((pip->ip_vhl & 0x0f) != 5)))
	{
			
		struct tcphdr *tc;
		struct udphdr *ud;
		
		if ((pip->ip_vhl & 0x0f) != 5)
			_RTL8651_L3_ADJUST_CHECKSUM(ip_alias, phdr->ph_sip, pip->ip_src);
		
		switch(pip->ip_p)
		{
			case IPPROTO_TCP:
				tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
				_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, phdr->ph_sip, 0, 0, tc->th_sum);
				break;
			case IPPROTO_UDP:
				ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
				_RTL8651_L4_ADJUST_CHECKSUM(ip_alias, phdr->ph_sip, 0, 0, ud->uh_sum);
				break;
		}

		
		PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);
		#if 0
		
		accumulate = (phdr->ph_sip & 0xffff);
		accumulate +=  ((phdr->ph_sip >> 16) & 0xffff);	
		accumulate -= (ip_alias & 0xffff);
		accumulate -=  ((ip_alias >> 16) & 0xffff);
		PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);		
		switch(pip->ip_p){
		case IPPROTO_TCP:
			tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
			_RTL8651_ADJUST_CHECKSUM(accumulate, tc->th_sum);	
			break;
		case IPPROTO_UDP:
			ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
			_RTL8651_ADJUST_CHECKSUM(accumulate, ud->uh_sum);				
			break;		
		}
		#endif
	}
	else if(iresult ==FWDENG_TCP_NAT_OUT_ALGNOTFOUND||
		iresult==FWDENG_UDP_NAT_OUT_ALGNOTFOUND )
	{
change_ip:
		
		
		accumulate = (phdr->ph_sip & 0xffff);
		accumulate +=  ((phdr->ph_sip >> 16) & 0xffff);	
		accumulate -= (ip_alias & 0xffff);
		accumulate -=  ((ip_alias >> 16) & 0xffff);

		PKTSET_UINT32_UNALIGNED(ip_alias, &pip->ip_src);
	}else if(iresult!=SUCCESS)
		rtlglue_printf("%s: errno=%d\n",__FUNCTION__, iresult);	

	if(ntohs(pip->ip_off) &  (IP_MF|IP_OFFMASK) ){
		phdr->ph_flags &= (~CSUM_L4);
		phdr->ph_proto = PKTHDR_IP;
	}
#endif

	if(ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK))
	{
		phdr->ph_flags &= (~CSUM_L4);
		phdr->ph_proto = PKTHDR_IP;
	}

	if(_rtl8651_l3ActRouting((struct rtl_pktHdr *)phdr,ip_d,pip) != SUCCESS)
	{
		return _RTL8651_NAT_DROP;
	}
	return (SUCCESS);
}

#define RTL8651_L34ADDITIONAL_EXECUTION_FUNCTIONS


static void _rtl8651_l34AdditionalExec_init(void)
{
	memset(_RTL8651_ADDITIONAL_PROC, 0, sizeof(_RTL8651_ADDITIONAL_PROC));

	
	_RTL8651_ADDITIONAL_PROC[_RTL8651_DEC_NPT] = _RTL8651_L34ADDTIONALEXEC_SMACFILTER;
	_RTL8651_ADDITIONAL_PROC[_RTL8651_DEC_NT] = _RTL8651_L34ADDTIONALEXEC_SMACFILTER;
	_RTL8651_ADDITIONAL_PROC[_RTL8651_DEC_RT_LR] = _RTL8651_L34ADDTIONALEXEC_SMACFILTER;

	
}


static inline int32 _rtl8651_l34AddtionalExec(int32 decision, ipaddr_t dip, void *pkt)
{
	int32 retval = SUCCESS;

	if (_RTL8651_DECISION_ISVALID(decision))
	{
		
		
		if (_RTL8651_ADDITIONAL_PROC[decision] & _RTL8651_L34ADDTIONALEXEC_BLOCK)
		{
			retval = FWDENG_DECISION_BLOCK;
			goto exception_check;
		}

		
		if (_RTL8651_ADDITIONAL_PROC[decision] & _RTL8651_L34ADDTIONALEXEC_SMACFILTER)
		{
			uint8 *ether = (uint8 *)pkt;
			assert( pkt );

			if (_rtl8651_isMacAccessControlPermit((ether_addr_t *)&ether[6]) == FALSE)
			{
				retval = FWDENG_MACBLOCK;
				goto exception_check;
			}

		}
	}else assert(0);

	
	return SUCCESS;

exception_check:

	
	{
		int8 is_gwip;
		_rtl8651_getIpInfo(dip, NULL, NULL, &is_gwip);
		if (is_gwip == TRUE)
		{
			return FWDENG_TO_GW;
		}
	}

	return retval;
}


int32 _rtl8651_l34AdditionalExec_setParam(uint32 srcType, uint32 dstType, _rtl8651_l34AdditionalExec_t *para)
{
	int32 decision;

	if ((!_RTL8651_HOSTTYPE_ISVALID(srcType)) ||(!_RTL8651_HOSTTYPE_ISVALID(dstType)))
	{
		return FAILED;
	}

	decision = _RTL8651_PROC[srcType][dstType];

	assert( para && _RTL8651_DECISION_ISVALID(decision) );

	
	if ((decision == _RTL8651_DEC_NPT) || (decision == _RTL8651_DEC_NT) || (decision == _RTL8651_DEC_RT_LR))
	{
		if ((para->property & _RTL8651_L34ADDTIONALEXEC_SMACFILTER) == 0)
		{
			#ifdef RTL865X_DEBUG
			rtlglue_printf("@ Error Configuration - User can not turn OFF SMAC filtering for outbound NAPT/NAT packet.\n");
			#endif
			return FAILED;
		}
	}

	
	_RTL8651_ADDITIONAL_PROC[decision] = para->property;

	return SUCCESS;
}

int32 _rtl8651_l34AdditionalExec_getParam(uint32 srcType, uint32 dstType, _rtl8651_l34AdditionalExec_t *para)
{
	int32 decision;

	if ((!_RTL8651_HOSTTYPE_ISVALID(srcType)) ||(!_RTL8651_HOSTTYPE_ISVALID(dstType)))
	{
		return FAILED;
	}

	decision = _RTL8651_PROC[srcType][dstType];

	assert( para && _RTL8651_DECISION_ISVALID(decision) );

	
	memset(para, 0, sizeof(_rtl8651_l34AdditionalExec_t));
	para->property = _RTL8651_ADDITIONAL_PROC[decision];

	return SUCCESS;
}


#define RTL8651_CHECKSUM_FUNCTIONS


void _rtl8651_fwdEngineTxChecksumOffload(	struct ip *pip,
													uint32 l3Cksum,
													uint32 l4Cksum)
{

	if (pip == NULL)
	{
		return;
	}

	if (l4Cksum)
	{
		if (IS_FRAGMENT(pip->ip_off))
		{
			
			goto l4cksum_done;
		}

		switch (pip->ip_p)
		{
			case IPPROTO_TCP:
			{
				struct tcphdr *tc;
				tc = (struct tcphdr *)L4HDR_ADDR(pip);

				tc->th_sum = 0;
				tc->th_sum = _rtl8651_tcpChecksum(pip);
				break;
			}
			case IPPROTO_UDP:
			{
				struct udphdr *ud;
				ud = (struct udphdr *)L4HDR_ADDR(pip);

				if (ud->uh_sum)
				{
					ud->uh_sum = 0;
					ud->uh_sum = _rtl8651_tcpChecksum(pip);
				}
				break;
			}
			case IPPROTO_ICMP:
			{
				struct icmp *ic;
				ic = (struct icmp *)L4HDR_ADDR(pip);

				ic->icmp_cksum = 0;
				ic->icmp_cksum = _rtl8651_icmpChecksum(pip);
				break;
			}
			case IPPROTO_IGMP:
			{
				struct igmp *ig;
				ig = (struct igmp *)L4HDR_ADDR(pip);

				ig->igmp_cksum = 0;
				ig->igmp_cksum = _rtl8651_icmpChecksum(pip);
				break;
			}
		}
	}
l4cksum_done:

	if (l3Cksum)
	{
		pip->ip_sum = 0;
		pip->ip_sum = _rtl8651_ipChecksum(pip);
	}

	return;
}



uint16 
_rtl8651_ipChecksum(struct ip * pip)
{


	uint32     sum=0,oddbyte=0;
	uint16 *ptr = (uint16 *)pip;
	uint32 nbytes = ((pip->ip_vhl & 0xf) << 2);	

	while (nbytes > 1)
	{
		
		sum += (*ptr++);
		nbytes -= 2;
	}
	if (nbytes == 1)
	{
		
		
		
		oddbyte = (*ptr & 0xff00);
		sum += oddbyte;
	}
	
	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);
	
	return (~sum);


}




uint16 _rtl8651_tcpChecksum(struct ip *pip)
{
	int32 sum, nbytes, nhdr, i;
	uint16 *sip, *dip, *ptr;

	nhdr =  ((pip->ip_vhl & 0xf) << 2);
	nbytes = ntohs(pip->ip_len) - nhdr;
	ptr = (uint16 *) ((char *) pip + nhdr);
	sum = 0;

	
	*(((uint8 *)pip) + nhdr + nbytes) = (uint8)0;
	for (i=0; i<nbytes ;i=i+2){
		sum += (unsigned long)*ptr++;
	}

	
	dip=(uint16 *)&pip->ip_dst;
	sum += *dip; dip++;
	sum += *dip;
	sip=(uint16 *)&pip->ip_src;
	sum += *sip; sip++;
	sum += *sip;	

	sum +=  nbytes;
	sum += ((uint16) pip->ip_p);

	
	while (sum>>16)
		sum = (sum & 0xFFFF)+(sum >> 16);
	
	
	sum = ~sum;
	return (uint16)sum;
	
}



uint16 
_rtl8651_icmpChecksum(struct ip * pip)
{
	uint16   *ptr;
	int32  nhdr, nbytes;
	int32  sum, i;


	nhdr =  ((pip->ip_vhl &0xf) << 2);
	nbytes = ntohs(pip->ip_len) - nhdr;
	ptr = (uint16 *) ((char *) pip + nhdr);
	sum = 0;

	
	*(((uint8 *)pip) + nhdr + nbytes) = (uint8)0;
	for (i=0; i<nbytes ; i=i+2){
		sum +=  (unsigned long) *ptr++;
	}

	
	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);

	
	return ((uint16) ~ sum);
}



#ifdef _RTL_UPNP
#define RTL8651_UPNP_FUNCTIONS

static void _rtl8651_initUpnpDb(void){
	upnp_tb = (struct _RTL8651_UPNP_ENTRY *)rtlglue_malloc(UPNP_ITEM * sizeof (struct _RTL8651_UPNP_ENTRY));
	memset(upnp_tb,0,UPNP_ITEM * sizeof (struct _RTL8651_UPNP_ENTRY));
}

static void _rtl8651_ReinitUpnpDb(void){
	memset(upnp_tb,0,UPNP_ITEM * sizeof (struct _RTL8651_UPNP_ENTRY));
}


void rtl8651_addUpnpMap(uint32 inFlags, 
	ipaddr_t remote_ip, uint16 remote_port, 
	ipaddr_t alias_ip, uint16 alias_port,
	ipaddr_t local_ip, uint16 local_port){
	int32 ii;
	struct _RTL8651_UPNP_ENTRY *tb;

	rtlglue_drvMutexLock();

	tb = upnp_tb;

	for (ii = 0 ; ii < UPNP_ITEM ; ii++, tb++){
		if( (tb->flags & UPNP_VALID) == 0 || ((tb->alias_port == alias_port)&&((tb->flags&UPNP_TCP) == (inFlags&UPNP_TCP)))){
			
			tb->remote_ip = remote_ip;
			tb->remote_port = remote_port; 
			tb->alias_ip = alias_ip;
			tb->alias_port = alias_port ;
			tb->local_ip = local_ip;
			tb->local_port = local_port;
			tb->algIdx = 0;
			
			tb->flags = UPNP_VALID;
			tb->flags |= inFlags;
			
			tb->age = UPNP_AGE;
			
			break;
		}
	}

	rtlglue_drvMutexUnlock();

}

void _rtl8651_addAlgQosUpnpMap(uint32 inFlags, 
	ipaddr_t remote_ip, uint16 remote_port, 
	ipaddr_t alias_ip, uint16 alias_port,
	ipaddr_t local_ip, uint16 local_port,uint32 algIdx){
	
	int32 ii;
	struct _RTL8651_UPNP_ENTRY *tb;

	rtlglue_drvMutexLock();

	tb = upnp_tb;

	for (ii = 0 ; ii < UPNP_ITEM ; ii++, tb++){
		if( (tb->flags & UPNP_VALID) == 0 || ((tb->alias_port == alias_port)&&((tb->flags&UPNP_TCP) == (inFlags&UPNP_TCP)))){
			
			tb->remote_ip = remote_ip;
			tb->remote_port = remote_port; 
			tb->alias_ip = alias_ip;
			tb->alias_port = alias_port ;
			tb->local_ip = local_ip;
			tb->local_port = local_port;
			tb->algIdx = algIdx;			
			tb->flags = UPNP_VALID;
			tb->flags |= inFlags;			
			tb->age = UPNP_AGE;
			
			break;
		}
	}

	rtlglue_drvMutexUnlock();
}

void rtl8651_addUpnpMapLeaseTime(uint32 inFlags, 
	ipaddr_t remote_ip, uint16 remote_port, 
	ipaddr_t alias_ip, uint16 alias_port,
	ipaddr_t local_ip, uint16 local_port,uint32 age){
	int32 ii;
	struct _RTL8651_UPNP_ENTRY *tb;

	rtlglue_drvMutexLock();

	tb = upnp_tb;

	for (ii = 0 ; ii < UPNP_ITEM ; ii++, tb++){
		if( (tb->flags & UPNP_VALID) == 0 || ((tb->alias_port == alias_port)&&((tb->flags&UPNP_TCP) == (inFlags&UPNP_TCP)))){
			
			tb->remote_ip = remote_ip;
			tb->remote_port = remote_port; 
			tb->alias_ip = alias_ip;
			tb->alias_port = alias_port ;
			tb->local_ip = local_ip;
			tb->local_port = local_port;
			tb->algIdx = 0;

			tb->flags = UPNP_VALID;
			tb->flags |= inFlags;

			if(age==0)
				tb->age = UPNP_AGE;
			else
				tb->age = age;
			
			break;
		}
	}

	rtlglue_drvMutexUnlock();

}



void rtl8651_delUpnpMap(uint32 isTcp, ipaddr_t remote_ip, uint16 remote_port, 
	ipaddr_t alias_ip, uint16 alias_port,
	ipaddr_t local_ip, uint16 local_port){
	int32 ii;
	struct _RTL8651_UPNP_ENTRY *tb;

	rtlglue_drvMutexLock();

	tb = upnp_tb;

	for (ii = 0 ; ii < UPNP_ITEM ; ii++, tb++){
		if( tb->flags & UPNP_VALID ){
			
			if(	(tb->remote_ip & remote_ip) == remote_ip && 
				(tb->remote_port &  remote_port)== remote_port &&
				tb->alias_ip == alias_ip &&
				tb->alias_port == alias_port &&
				((tb->local_ip == local_ip && tb->local_port == local_port) ||
				(tb->local_ip == local_ip && tb->local_port == 0) ||
				(tb->local_ip == 0 && tb->local_port == local_port) ||
				(tb->local_ip == 0 && tb->local_port == 0))
				){		
				
				if(isTcp == 0){
					if(tb->flags & UPNP_TCP) 
						continue;
				}
				
				tb->flags = 0;				
			}
		}
	}

	rtlglue_drvMutexUnlock();

}


static inline int32 _rtl8651_findInboundUpnpMapping (
	uint32 isTcp,
	ipaddr_t remote_ip, uint16 remote_port,
	ipaddr_t alias_ip, uint16 alias_port,
	ipaddr_t *local_ip, uint16 *local_port,
	uint32 *flags, uint32 *algIdx)
{
	int32 ii;
	struct _RTL8651_UPNP_ENTRY *tb = upnp_tb;	
	for (ii = 0 ; ii < UPNP_ITEM ; ii++, tb++){		
		if( tb->flags & UPNP_VALID ){
			if(	(tb->remote_ip & remote_ip) == tb->remote_ip && 
				(tb->remote_port &  remote_port)== tb->remote_port &&
				tb->alias_ip == alias_ip &&
				tb->alias_port == alias_port ){		

				if ((isTcp && (!(tb->flags&UPNP_TCP))) ||
						((!isTcp) && (tb->flags&UPNP_TCP)))
					continue;

				
				if(remote_port==20)
					return FAILED;

				assert(tb->local_ip);
				
				if (local_ip) *local_ip = tb->local_ip;
				if (local_port) *local_port = tb->local_port;
				if (flags) *flags = tb->flags;
				if (algIdx) *algIdx = tb->algIdx;

				if (tb->flags & UPNP_ONESHOT)
				{
					tb->flags = 0;					
				}
			
				return SUCCESS;
			}
		}
	}

	return FAILED;
}


static inline int32 _rtl8651_findOutboundUpnpMapping (
	uint32 isTcp,
	ipaddr_t IntIp, uint16 IntPort,
	ipaddr_t *ExtIp, uint16 *ExtPort,
	ipaddr_t RemoteIp, uint16 RemotePort,
	uint32 *flags, uint32 *algIdx)
{
	struct _RTL8651_UPNP_ENTRY *upnp_t = upnp_tb;
	int32 idx;

	
	for (idx = 0 ; idx < UPNP_ITEM ; idx++, upnp_t++)
	{
		
		if ((upnp_t->flags & UPNP_VALID) == FALSE)
			continue;

		
		if (	(isTcp && ((upnp_t->flags & UPNP_TCP) == FALSE)) ||
			((isTcp == FALSE) && ((upnp_t->flags & UPNP_TCP) == UPNP_TCP))
		   )
			continue;

		
		if (	(upnp_t->remote_port && (upnp_t->remote_port != RemotePort)) ||
			(upnp_t->remote_ip && (upnp_t->remote_ip != RemoteIp)) ||
			(upnp_t->local_port != IntPort) ||
			(upnp_t->local_ip != IntIp)
		   )
			continue;

		
		if(RemotePort == 20)
		{
			return FAILED;
		}

		assert(upnp_t->local_ip);

		
		if (ExtIp) 	*ExtIp = upnp_t->alias_ip;
		if (ExtPort)	*ExtPort = upnp_t->alias_port;
		if (flags)		*flags = upnp_t->flags;
		if (algIdx)	*algIdx = upnp_t->algIdx;

		
		if (upnp_t->flags & UPNP_ONESHOT)
		{
			upnp_t->flags = 0;			
		}

		return SUCCESS;
	}

	return FAILED;
}

uint32 rtl8651_queryUpnpMapTimeAge(uint32 isTcp, ipaddr_t remote_ip, uint16 remote_port, 
	ipaddr_t alias_ip, uint16 alias_port){

	int32 ii;
	struct _RTL8651_UPNP_ENTRY *tb;	
	uint32 retval = 0;

	rtlglue_drvMutexLock();

	tb = upnp_tb;

	for (ii = 0 ; ii < UPNP_ITEM ; ii++, tb++){		
		if( tb->flags & UPNP_VALID ){
			if(	(tb->remote_ip & remote_ip) == tb->remote_ip && 
				(tb->remote_port &  remote_port)== tb->remote_port &&
				tb->alias_ip == alias_ip &&
				tb->alias_port == alias_port ){		

				if ((isTcp && (!(tb->flags&UPNP_TCP))) ||
						((!isTcp) && (tb->flags&UPNP_TCP)))
					continue;

				retval = tb->age;
				goto out;
			}
		}
	}

out:
	rtlglue_drvMutexUnlock();

	return retval;
}


static inline int32 _rtl8651_checkUsableUpnpEntry(uint32 isTcp, ipaddr_t IntIp, uint32 IntPort, ipaddr_t ExtIp, uint32 ExtPort, ipaddr_t RemoteIp, uint32 RemotePort)
{
	int32 i;
	struct _RTL8651_UPNP_ENTRY *tb = upnp_tb, *candidate = NULL;

	for (i = 0 ; i < UPNP_ITEM ; i ++ , tb ++)
	{
		if ((tb->flags&UPNP_VALID) &&												
			(tb->alias_ip == ExtIp) &&												
			(tb->alias_port == ExtPort) &&											
			(tb->remote_ip == 0 || tb->remote_ip == RemoteIp) &&					
			(tb->remote_port == 0 || tb->remote_port == RemotePort) &&				
			((isTcp&&(tb->flags&UPNP_TCP)) ||((!isTcp)&&(!(tb->flags&UPNP_TCP))))	
			)
		{
			if ((IntIp == tb->local_ip) && (IntPort == tb->local_port))
			{
				return TRUE;
			}
			
			candidate = tb;
		}
	}

	

	
	if (candidate)
		return FALSE;

	
	return TRUE;
}

static int32 _rtl8651_uPnPOneSecondTimer(){

	int32 ii;
	struct _RTL8651_UPNP_ENTRY *tb = upnp_tb;
	for (ii = 0 ; ii < UPNP_ITEM ; ii++, tb++){

		if( (tb->flags & (UPNP_PERSIST|UPNP_VALID)) ==  
			(UPNP_PERSIST|UPNP_VALID)){
			continue;
		}
		
		if( tb->flags & UPNP_VALID ){
			tb->age--;			
			if(tb->age == 0){
				tb->flags &= (~UPNP_VALID);
			}				
		}
	}

	return SUCCESS;
}
#endif 

#define RTL8651_UDP_BLOCK_FUNCTIONS



void rtl8651a_setUdpSizeThreshValue(uint32 SessionID, uint32 value)
{	
	uint32 dsid;
	uint32 idx;

	rtlglue_drvMutexLock();

	dsid=_rtl8651_SessionIDToDSID(SessionID);

	_rtl8651_udpSizeThreshValue[dsid]=(uint16)value;

	_rtl8651_udpBlockingEnable = FALSE;

	for (idx = 0 ; idx < rtl8651_tblDrvPara.dialSessionNumber ; idx ++)
	{
		if (_rtl8651_udpSizeThreshValue[idx] != 0xffff)
			_rtl8651_udpBlockingEnable = TRUE;
	}

	rtlglue_drvMutexUnlock();
}

#define RTL8651_WAN_STATUS_FUNCTIONS


void rtl8651a_setWanStatus(uint32 SessionID, uint32 Status)
{	
	uint32 dsid;
	rtlglue_drvMutexLock();
	dsid=_rtl8651_SessionIDToDSID(SessionID);
	rtl8651_wanStatus[dsid]=Status;
	rtlglue_drvMutexUnlock();
}


void rtl8651_setWanStatus(uint32 Status)
{	
	rtlglue_drvMutexLock();
	rtl8651_wanStatus[0]=Status;
	rtlglue_drvMutexUnlock();
}


#ifdef _RTL_PS_ACTION
#define RTL8651_PROTOCOL_STACK_ACTION_FUNCTIONS

static int32 _rtl8651_protoStackActionInit(rtl8651_fwdEngineInitPara_t *para){

	rtl8651_ProtoStackActions = (rtl8651_PS_Action_Entry_t *)rtlglue_malloc(para->protoStackMaxActions * sizeof (rtl8651_PS_Action_Entry_t));
	memset(rtl8651_ProtoStackActions,0,para->protoStackMaxActions * sizeof (rtl8651_PS_Action_Entry_t));	
	return SUCCESS;
}


void rtl8651_flushProtoStackActions(void)
{
	rtlglue_drvMutexLock();
	memset(rtl8651_ProtoStackActions,0,sizeof(rtl8651_PS_Action_Entry_t)*rtl8651_fwdEnginePara.protoStackMaxActions);
	rtlglue_drvMutexUnlock();
}

int32 _rtl8651_delProtocolStackActions(rtl8651_PS_Action_Entry_t *PSA)
{
	int i;
	rtl8651_PS_Action_Entry_t *psa_t = rtl8651_ProtoStackActions;

	
	if (PSA->dstIp != 0 && _rtl8651_extIpAddr(PSA->dstIp, NULL) == FALSE)
		return FWDENG_EPSA_DSTIPNOTEXTGWIP;

	
	for (i = 0; i < rtl8651_fwdEnginePara.protoStackMaxActions; i++, psa_t++)
	{
		if (psa_t->action == PS_ACTION_NONE)
			continue;
		
		if (!memcmp(PSA, psa_t, sizeof(rtl8651_PS_Action_Entry_t)))
		{
			
			memset(psa_t, 0, sizeof(rtl8651_PS_Action_Entry_t));
			return SUCCESS;
		}
	}
	return FWDENG_EPSA_PSAENTRYNOTFOUND;
}

int32 _rtl8651_addProtocolStackActions(rtl8651_PS_Action_Entry_t *PSA)
{
	int i;
	rtl8651_PS_Action_Entry_t *empty_psa_t = NULL;
	rtl8651_PS_Action_Entry_t *psa_t = rtl8651_ProtoStackActions;

	
	if (PSA->dstIp != 0 && _rtl8651_extIpAddr(PSA->dstIp, NULL) == FALSE)
		return FWDENG_EPSA_DSTIPNOTEXTGWIP;;
	
	for(i = 0; i < rtl8651_fwdEnginePara.protoStackMaxActions; i++, psa_t++)
	{
		
		if (psa_t->action != PS_ACTION_NONE) {
			if ((PSA->dstIp == 0 || psa_t->dstIp == 0 || PSA->dstIp == psa_t->dstIp) 
				&& PSA->role == psa_t->role && PSA->protocol == psa_t->protocol) {
				
				if (!((PSA->upperIp < psa_t->lowerIp) || (PSA->lowerIp > psa_t->upperIp))) {
					
					if (!((PSA->orgPortEnd < psa_t->orgPort) ||(PSA->orgPort > psa_t->orgPortEnd)))
						return FWDENG_EPSA_IPPORTRANGE_CONFLICT;
					else {
						uint16 user_portRange = PSA->orgPortEnd - PSA->orgPort;
						uint16 tb_portRange = psa_t->orgPortEnd - psa_t->orgPort;

						
						if (!(((PSA->fwdPort + user_portRange) < psa_t->fwdPort) || (PSA->fwdPort > (psa_t->fwdPort + tb_portRange))))
							return FWDENG_EPSA_IPPORTRANGE_CONFLICT;
					}
				}
			}
		}
		else if (empty_psa_t == NULL)
			empty_psa_t = psa_t;
	}
	
	
	if (empty_psa_t != NULL)
	{
		empty_psa_t->dstIp = PSA->dstIp;
		empty_psa_t->action = PSA->action;
		empty_psa_t->lowerIp = PSA->lowerIp;
		empty_psa_t->upperIp = PSA->upperIp;
		empty_psa_t->role = PSA->role;
		empty_psa_t->protocol = PSA->protocol;
		empty_psa_t->orgPort = PSA->orgPort;
		empty_psa_t->orgPortEnd = PSA->orgPortEnd;
		empty_psa_t->fwdPort = PSA->fwdPort;			
		return SUCCESS;
	}
	else
		return FWDENG_EPSA_TABLEFULL;
	
}

#define LEGALPORT_UB	65535
int32 _rtl8651_checkPSAction(rtl8651_PS_Action_Entry_t *PSAction)
{
	if (!(PSAction->action == PS_ACTION_DROP || PSAction->action == PS_ACTION_TO_PS || PSAction->action == PS_ACTION_DONT_TIMEOUT))
		return FWDENG_EPSA_INVALIDPSACTION;
	if (!(PSAction->role == PS_ACTION_SERVER || PSAction->role == PS_ACTION_CLIENT))
		return FWDENG_EPSA_INVALIDPSROLE;
	if (PSAction->lowerIp > PSAction->upperIp)
		return FWDENG_EPSA_IPRANGENOTCORRECT;
	if (PSAction->protocol == IPPROTO_ICMP && ((PSAction->role != 0) || (PSAction->orgPort != 0) || (PSAction->orgPortEnd != 0) || (PSAction->fwdPort != 0)))
		return FWDENG_EPSA_ICMPARGISNOTZERO;
	if (PSAction->orgPort > PSAction->orgPortEnd)
		return FWDENG_EPSA_PORTRANGENOTCORRECT;
	if ((PSAction->orgPortEnd - PSAction->orgPort) > (LEGALPORT_UB - PSAction->fwdPort))
		return FWDENG_EPSA_PORTRANGETOOLARGE;

	return SUCCESS;
}



int32 rtl8651_addGenericProtoStackActions(rtl8651_PS_Action_Entry_t *PSAction)
{
	int32 retval;

	
	if ((retval = _rtl8651_checkPSAction(PSAction)) != SUCCESS)
		return retval;
	
	rtlglue_drvMutexLock();
	retval = _rtl8651_addProtocolStackActions(PSAction);
	rtlglue_drvMutexUnlock();

	return retval;
}



int32 rtl8651_delGenericProtoStackActions(rtl8651_PS_Action_Entry_t *PSAction)
{
	int32 retval;

	
	if ((retval = _rtl8651_checkPSAction(PSAction)) != SUCCESS)
		return retval;

	rtlglue_drvMutexLock();
	retval = _rtl8651_delProtocolStackActions(PSAction);
	rtlglue_drvMutexUnlock();

	return retval;
}


int32 rtl8651_addProtoStackActions(ipaddr_t lowerIp, ipaddr_t upperIp, uint8 action, uint8 role, uint8 protocol, uint16 orgPort, uint16 fwdPort)
{
	int32 retval;
	rtl8651_PS_Action_Entry_t PSAction;

	memset(&PSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	
	PSAction.lowerIp = lowerIp;
	PSAction.upperIp = upperIp;
	PSAction.action = action;
	PSAction.role = role;
	PSAction.protocol = protocol;
	PSAction.orgPort = orgPort;
	PSAction.orgPortEnd = orgPort;
	PSAction.fwdPort = fwdPort;
	PSAction.dstIp = 0;	
	
	
	if ((retval = _rtl8651_checkPSAction(&PSAction)) != SUCCESS)
		return retval;

	rtlglue_drvMutexLock();
	retval = _rtl8651_addProtocolStackActions(&PSAction);
	rtlglue_drvMutexUnlock();

	return retval;
}


int32 rtl8651_delProtoStackActions(ipaddr_t lowerIp, ipaddr_t upperIp, uint8 action, uint8 role, uint8 protocol, uint16 orgPort, uint16 fwdPort)
{
	int32 retval;
	rtl8651_PS_Action_Entry_t PSAction;

	memset(&PSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
        
        PSAction.lowerIp = lowerIp;
        PSAction.upperIp = upperIp;
        PSAction.action = action;
        PSAction.role = role;
        PSAction.protocol = protocol;
        PSAction.orgPort = orgPort;
        PSAction.orgPortEnd = orgPort;
        PSAction.fwdPort = fwdPort;
        PSAction.dstIp = 0;     

        
        if ((retval = _rtl8651_checkPSAction(&PSAction)) != SUCCESS)
                return retval;

	rtlglue_drvMutexLock();
	retval = _rtl8651_delProtocolStackActions(&PSAction);
	rtlglue_drvMutexUnlock();

	return retval;
}

int32 rtl8651_addProtoStackServerPortRange(ipaddr_t lowerIp, ipaddr_t upperIp, uint8 protocol, uint16 PortStart, uint16 PortEnd, uint16 fwdPortStart)
{
	int32 retval;
	rtl8651_PS_Action_Entry_t PSAction;

	memset(&PSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	
	PSAction.lowerIp = lowerIp;
	PSAction.upperIp = upperIp;
	PSAction.action = PS_ACTION_TO_PS;
	PSAction.role = PS_ACTION_SERVER;
	PSAction.protocol = protocol;
	PSAction.orgPort = PortStart;
	PSAction.orgPortEnd = PortEnd;
	PSAction.fwdPort = fwdPortStart;
	PSAction.dstIp = 0;	

	
	if ((retval = _rtl8651_checkPSAction(&PSAction)) != SUCCESS)
		return retval;

	rtlglue_drvMutexLock();
	retval = _rtl8651_addProtocolStackActions(&PSAction);
	rtlglue_drvMutexUnlock();

	return retval;
}

int32 rtl8651_delProtoStackServerPortRange(ipaddr_t lowerIp, ipaddr_t upperIp, uint8 protocol, uint16 PortStart, uint16 PortEnd, uint16 fwdPortStart)
{
	int32 retval;
	rtl8651_PS_Action_Entry_t PSAction;

	memset(&PSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	
	PSAction.lowerIp = lowerIp;
	PSAction.upperIp = upperIp;
	PSAction.action = PS_ACTION_TO_PS;
	PSAction.role = PS_ACTION_SERVER;
	PSAction.protocol = protocol;
	PSAction.orgPort = PortStart;
	PSAction.orgPortEnd = PortEnd;
	PSAction.fwdPort = fwdPortStart;
	PSAction.dstIp = 0;

	
	if ((retval = _rtl8651_checkPSAction(&PSAction)) != SUCCESS)
		return retval;

	rtlglue_drvMutexLock();
	retval = _rtl8651_delProtocolStackActions(&PSAction);
	rtlglue_drvMutexUnlock();

	return retval;
}

static int32 _rtl8651_doProtoStackAction(struct rtl_pktHdr *pktHdr, struct ip *iph)
{
	int i;
	ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&iph->ip_src);
	ipaddr_t dip = PKTGET_UINT32_UNALIGNED(&iph->ip_dst);
	uint16 *sport = NULL, *dport = NULL, *chksum = NULL;
	rtl8651_PS_Action_Entry_t *psa = rtl8651_ProtoStackActions;

	
	int32 retval = PS_ACTION_NONE;

	
	if (pktHdr->ph_procFlag & PH_PROCFLAG_PS_ACTION)
	{
		return retval;
	}

#if 0
	
#endif
	
	if (_rtl8651_extIpAddr(dip, NULL) == FALSE)
		return retval;

	
	if (IS_FRAGMENT_REMAIN(iph->ip_off))
	{		
		ipaddr_t returnValue;

		if (_rtl8651_getFragCache(PROTOCOL_STACK_FRAG, sip, dip, ntohs(iph->ip_id), &returnValue, NULL, NULL, NULL) == SUCCESS)
			return (int32)returnValue;
		return retval;
	}

	
	switch (iph->ip_p)
	{
		case IPPROTO_TCP:
		{
			struct tcphdr *tcp;
			tcp = (struct tcphdr *) ((int8 *) iph + ((iph->ip_vhl &0xf) << 2));	
			sport = &tcp->th_sport;
			dport = &tcp->th_dport;
			chksum = &tcp->th_sum;
			break;
		}
		
		case IPPROTO_UDP:
		{
			struct udphdr *udp;
			udp = (struct udphdr *) ((int8 *) iph + ((iph->ip_vhl &0xf) << 2));	
			sport = &udp->uh_sport;
			dport = &udp->uh_dport;
			chksum = &udp->uh_sum;
			break;
		}
	}

	
	for (i = 0; i < rtl8651_fwdEnginePara.protoStackMaxActions; i++, psa++)
	{
		if (psa->action == PS_ACTION_NONE)		
			continue;
			
		if ((psa->dstIp == 0 || dip == psa->dstIp) && iph->ip_p == psa->protocol)	
		{
			
			if (psa->protocol == IPPROTO_TCP || psa->protocol == IPPROTO_UDP)
			{
				uint16 *chkport = NULL;

				if (psa->role == PS_ACTION_SERVER)
					chkport = dport;
				else if (psa->role == PS_ACTION_CLIENT)
					chkport = sport;
				
				
				if ((psa->orgPort <= ntohs(*chkport)) && (psa->orgPortEnd >= ntohs(*chkport)))	
				{
					if ((sip >= psa->lowerIp) && (sip <= psa->upperIp))	
					{
						if (psa->action == PS_ACTION_TO_PS)	
						{
							if (psa->orgPort != psa->fwdPort)	
							{
								uint16 newFwdPort = psa->fwdPort + (ntohs(*chkport) - psa->orgPort);
								
								if ((iph->ip_p != IPPROTO_UDP) || (*chksum != 0))	
								{
									_RTL8651_L4_ADJUST_CHECKSUM(0, 0, newFwdPort, ntohs(*chkport), *chksum);
								}
								*chkport = htons(newFwdPort);
							}
						}
						retval = psa->action;
						goto out;	
					}
					else		
						retval = PS_ACTION_DROP;
				}
			}
			else if(psa->protocol == IPPROTO_ICMP)
			{
				struct icmp *im;
				im = (struct icmp *) ((int8 *) iph + ((iph->ip_vhl &0xf) << 2));

				if (im->icmp_type == ICMP_ECHO)	
				{
					
					if ((sip >= psa->lowerIp) && (sip <= psa->upperIp))	
					{

						

						retval = psa->action;
						
						if ((psa->action != PS_ACTION_DROP) && rtl8651_DMZHostIcmpPassthroughEnable)
							retval = PS_ACTION_NONE;
						
						goto out;	
					}
					else		
						retval = PS_ACTION_DROP;
				}
				else		
				{
					retval = PS_ACTION_NONE;
					goto out;
				}
			}
			else
			{
								
				if ((sip >= psa->lowerIp) && (sip <= psa->upperIp))	
				{
					retval = psa->action;
					goto out;	
				}
				else		
					retval = PS_ACTION_DROP;
			}
		}
	}
out:

	
	pktHdr->ph_procFlag |= PH_PROCFLAG_PS_ACTION;

	if (IS_FRAGMENT_FIRST(iph->ip_off))
	{
		_rtl8651_updateFragCache(PROTOCOL_STACK_FRAG, sip, dip, ntohs(iph->ip_id), retval, 0, NULL, 0);
	}

	if (retval == PS_ACTION_DONT_TIMEOUT)
		retval = PS_ACTION_NONE;

	return retval;
}

static inline rtl8651_PS_Action_Entry_t *_rtl8651_checkProtoStackRegistedPort(uint16 port, uint8 l4proto)
{
	int i;
	rtl8651_PS_Action_Entry_t *psa;

	psa = rtl8651_ProtoStackActions;
	
	for ( i = 0 ; i < rtl8651_fwdEnginePara.protoStackMaxActions ; i++, psa++)
	{
		if (psa->action == PS_ACTION_NONE)
			continue;

		if (l4proto == psa->protocol)
		{
			if (((l4proto == IPPROTO_TCP) ||(l4proto == IPPROTO_UDP)) && ((port < psa->orgPort )||(port>psa->orgPortEnd)))
				continue;
			return psa;
		}
	}
	return NULL;
}

static void _rtl8651_aliasProtoStackSentIcmpErr(struct ip *ip)
{
	int i;
	uint16 *sport = NULL, *dport = NULL;
	ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr);
	ipaddr_t dip = PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr);
	rtl8651_PS_Action_Entry_t *psa = rtl8651_ProtoStackActions;

	if (IS_FRAGMENT_REMAIN(ip->ip_off))
		return;

	switch(ip->ip_p)
	{
		case IPPROTO_TCP:
		{
			struct tcphdr *tcp = (struct tcphdr *)L4HDR_ADDR(ip);
			sport = &tcp->th_sport;
			dport = &tcp->th_dport;
			break;
		}
		case IPPROTO_UDP:
		{
			struct udphdr *udp = (struct udphdr *)L4HDR_ADDR(ip);
			sport = &udp->uh_sport;
			dport = &udp->uh_dport;
			break;
		}
		default:
			return;
	}
	
	for (i = 0; i < rtl8651_fwdEnginePara.protoStackMaxActions; i++, psa++)
	{
		if (psa->action == PS_ACTION_NONE)
			continue;
		if ((psa->dstIp == 0 || dip == psa->dstIp) && ip->ip_p == psa->protocol)  
		{
			uint16 *chkport = NULL;

			if (psa->role == PS_ACTION_SERVER)
				chkport = dport;
			else if (psa->role == PS_ACTION_CLIENT)
				chkport = sport;

			if (ntohs(*chkport) >= psa->fwdPort && ntohs(*chkport) <= (psa->fwdPort + psa->orgPortEnd - psa->orgPort))	
			{
				if ((sip >= psa->lowerIp) && (sip <= psa->upperIp))	
				{
					if (psa->action == PS_ACTION_TO_PS && psa->orgPort != psa->fwdPort)
					{
						uint16 newFwdPort = ntohs(*chkport) - psa->fwdPort + psa->orgPort;
						
						*chkport = htons(newFwdPort);
					}
				}
			}
		}
	}

}
 
static void _rtl8651_aliasProtoStackSentPkt(uint32 outbound, uint32 dsid, struct ip *ip)
{
	if (rtl8651_getAsicOperationLayer() == 4) {

		struct ip *iph = ip;
		ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&iph->ip_src.s_addr);
		ipaddr_t dip = PKTGET_UINT32_UNALIGNED(&iph->ip_dst.s_addr);

		if (outbound)
		{
			
			int i=0,dont_timeout=FALSE;	
			uint16 *sport=NULL,*dport=NULL,*chkport=NULL,*chksum=NULL;
			rtl8651_PS_Action_Entry_t *psa = rtl8651_ProtoStackActions;

		

			if (IS_FRAGMENT_REMAIN(iph->ip_off))
				return;

			switch(iph->ip_p)
			{
				case IPPROTO_TCP:
				{
					struct tcphdr *tcp;
					tcp = (struct tcphdr *) ((int8 *) iph + ((iph->ip_vhl &0xf) << 2));	
					sport=&tcp->th_sport;
					dport=&tcp->th_dport;
					chksum=&tcp->th_sum;

					if ( rtl8651_drvProtocolStackErrMsgDontTimeout == TRUE )
					{
						if ( tcp->th_flags & TH_RST )
						{
							
							dont_timeout = TRUE;
						}
					}

					break;
				}
				
				case IPPROTO_UDP:
				{
					struct udphdr *udp;
					udp = (struct udphdr *) ((int8 *) iph + ((iph->ip_vhl &0xf) << 2));	
					sport=&udp->uh_sport;
					dport=&udp->uh_dport;
					chksum=&udp->uh_sum;
					break;
				}
				case IPPROTO_ICMP:
				{
					
					struct icmp *ic = (struct icmp *)((int8 *)iph + ((*(uint8 *)iph & 0xf) << 2));

					if (ic->icmp_type == ICMP_UNREACH || ic->icmp_type == ICMP_SOURCEQUENCH || ic->icmp_type == ICMP_TIMXCEED || ic->icmp_type == ICMP_PARAMPROB) 
					{

						if ( rtl8651_drvProtocolStackErrMsgDontTimeout == TRUE )
						{
							
							dont_timeout = TRUE;
						}

						_rtl8651_aliasProtoStackSentIcmpErr(&ic->icmp_ip);
					}
					break;
				}
			}		
			
			for(; i < rtl8651_fwdEnginePara.protoStackMaxActions; i++, psa++)
			{
				if(psa->action == PS_ACTION_NONE)
					continue;
				
				if((psa->dstIp == 0 || sip == psa->dstIp) && iph->ip_p == psa->protocol)		
				{			
					if(psa->protocol == IPPROTO_TCP || psa->protocol == IPPROTO_UDP)
					{
						if(psa->role == PS_ACTION_SERVER) 
							chkport = sport;
						else if(psa->role == PS_ACTION_CLIENT) 
							chkport = dport;

						if (ntohs(*chkport) >= psa->fwdPort && ntohs(*chkport) <= (psa->fwdPort + psa->orgPortEnd - psa->orgPort))	
						{
							if (dip >= psa->lowerIp && dip <= psa->upperIp)	
							{
								
								if((psa->action == PS_ACTION_TO_PS) && (psa->orgPort != psa->fwdPort))
								{
									uint16 newFwdPort = ntohs(*chkport) - psa->fwdPort + psa->orgPort;
									
									if ((iph->ip_p != IPPROTO_UDP) || (*chksum != 0))
										_RTL8651_L4_ADJUST_CHECKSUM(0, 0, newFwdPort, ntohs(*chkport), *chksum);
									*chkport = htons(newFwdPort);
								}
								
								if(psa->action == PS_ACTION_DONT_TIMEOUT)
									dont_timeout = TRUE;
								
								goto _check_idleTimer;	
							}
						}
					}			
				}			
			}
_check_idleTimer:
			if ((dont_timeout == FALSE) && (rtl8651_drvProtocolStackDontTimeout == FALSE))
			{
				_rtl8651_recordTraffic(dsid, TRUE );
			}
		}
		
		
		
		else if (rtl8651_drvEnPortBouncingPSaction && _rtl8651_extIpAddr(sip, NULL) == TRUE ) {
			int i = 0 ;
			uint16 *sport = NULL, *dport = NULL, *chkport = NULL, *chksum = NULL;
			rtl8651_PS_Action_Entry_t *psa = rtl8651_ProtoStackActions;

			if (IS_FRAGMENT_REMAIN(iph->ip_off))
				return;

			switch(iph->ip_p) {
				case IPPROTO_TCP:
				{
					struct tcphdr *tcp;
					tcp = (struct tcphdr *) ((int8 *) iph + ((iph->ip_vhl &0xf) << 2));
					sport = &tcp->th_sport;
					dport = &tcp->th_dport;
					chksum = &tcp->th_sum;
					break;
				}

				case IPPROTO_UDP:
				{
					struct udphdr *udp;
					udp = (struct udphdr *) ((int8 *) iph + ((iph->ip_vhl &0xf) << 2));	
					sport=&udp->uh_sport;
					dport=&udp->uh_dport;
					chksum=&udp->uh_sum;
					break;
				}

				case IPPROTO_ICMP:
				{
					
					struct icmp *ic = (struct icmp *)((int8 *)iph + ((*(uint8 *)iph & 0xf) << 2));

					if (ic->icmp_type == ICMP_UNREACH || ic->icmp_type == ICMP_SOURCEQUENCH || ic->icmp_type == ICMP_TIMXCEED || ic->icmp_type == ICMP_PARAMPROB) 
					{
						_rtl8651_aliasProtoStackSentIcmpErr(&ic->icmp_ip);
					}
					break;
				}

				default:
					return;
			}

			for(; i < rtl8651_fwdEnginePara.protoStackMaxActions; i++, psa++) {
				if (psa->action == PS_ACTION_NONE)	
					continue;
#if 0
					if (psa->ip == 0 && psa->mask == 0)	
						continue;

				      printk("i: %d, psa->ip: %u.%u.%u.%u, psa->mask: %u.%u.%u.%u, srcip: %u.%u.%u.%u, psa->orgPort: %d, psa->fwdPort: %d\n",
					  	i, NIPQUAD(psa->ip), NIPQUAD(psa->mask), NIPQUAD(ntohl(iph->ip_src.s_addr)), psa->orgPort, psa->fwdPort);
				      printk("psa->protocol: %d, psa->action: %d, psa->role: %d, sport: %d\n", psa->protocol, psa->action, psa->role, *sport);
#endif

				if ((psa->dstIp == 0  || sip == psa->dstIp) && iph->ip_p == psa->protocol)	
				{			
					if (psa->protocol == IPPROTO_TCP || psa->protocol == IPPROTO_UDP)
					{
						if (psa->role == PS_ACTION_SERVER)
							chkport = sport;
						else if (psa->role == PS_ACTION_CLIENT) 
							chkport = dport;

						if (ntohs(*chkport) >= psa->fwdPort && ntohs(*chkport) <= (psa->fwdPort + psa->orgPortEnd - psa->orgPort)) 	
						{
							
							if (dip >= psa->lowerIp && dip <= psa->upperIp)
							{
								
								if((psa->action == PS_ACTION_TO_PS) && (psa->orgPort != psa->fwdPort))
								{
									uint16 newFwdPort = ntohs(*chkport) - psa->fwdPort + psa->orgPort;
									
									if ((iph->ip_p != IPPROTO_UDP) || (*chksum != 0))
										_RTL8651_L4_ADJUST_CHECKSUM(0, 0, newFwdPort, ntohs(*chkport), *chksum);
									*chkport = htons(newFwdPort);
								}
								return;	
							}
						}
					}
				}			
			}
		} 
	} 
}

static int32 _rtl8651_aliasProtoStackRecvPkt(struct rtl_pktHdr *pktHdr, uint32 fromOutbound, struct ip *ip)
{
	uint16 *sportp = NULL, *dportp = NULL, *ckportp = NULL, *cksump = NULL;
	rtl8651_PS_Action_Entry_t * psa;
	ipaddr_t ip_s, ip_d;
	uint32 idx;
	int32 retval = PS_ACTION_NONE;
	ip_d = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
	ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);

	
	if (pktHdr->ph_procFlag & PH_PROCFLAG_PS_ACTION)
	{
		return retval;
	}

	if (  (IS_FRAGMENT_REMAIN(ip->ip_off)) )
		goto out;

	switch (ip->ip_p)
	{
		case IPPROTO_TCP:
		{
			struct tcphdr * tc = (struct tcphdr *)L4HDR_ADDR(ip);
			sportp = &(tc->th_sport);
			dportp = &(tc->th_dport);
			cksump = &(tc->th_sum);

			break;
		}
		case IPPROTO_UDP:
		{
			struct udphdr * ud = (struct udphdr *)L4HDR_ADDR(ip);
			sportp = &(ud->uh_sport);
			dportp = &(ud->uh_dport);
			cksump = &(ud->uh_sum);

			break;
		}
		default:	
			goto out;
	}

	psa = rtl8651_ProtoStackActions;
	for ( idx = 0 ; idx < rtl8651_fwdEnginePara.protoStackMaxActions ; idx++, psa++ )
	{
		if (psa->action == PS_ACTION_NONE)
			continue;

		
		if ((psa->dstIp == 0 || psa->dstIp == ip_s) && ip->ip_p == psa->protocol)	
		{
			if(psa->role == PS_ACTION_SERVER)
				ckportp = sportp;
			else if (psa->role == PS_ACTION_CLIENT)
				ckportp = dportp;

			if (ntohs(*ckportp) >= psa->orgPort && ntohs(*ckportp) <= psa->orgPortEnd) 	
			{
				if (ip_d >= psa->lowerIp && ip_d <= psa->upperIp)		
				{
					
					if ((psa->action == PS_ACTION_TO_PS) && (psa->orgPort != psa->fwdPort))
					{
						
						*ckportp = htons(ntohs(*ckportp) - psa->orgPort + psa->fwdPort);
					}
 					retval = psa->action;
					goto out;
				} else
				{	
					retval = PS_ACTION_DROP;
				}
			}
		}
	}

out:

	
	pktHdr->ph_procFlag |= PH_PROCFLAG_PS_ACTION;

	return retval;
}

static inline int32 _rtl8651_protoStackAction_filter(struct rtl_pktHdr* pktHdr, rtl8651_tblDrv_vlanTable_t *svlan, struct ip *pip)
{
	int32 retval = PS_ACTION_NONE;

	
	if (pktHdr->ph_procFlag & PH_PROCFLAG_PS_ACTION)
	{
		goto out;
	}

	if (_rtl8651_extIpAddr(pktHdr->ph_dip, NULL) == TRUE)
	{
		if (	(pip->ip_p == IPPROTO_ICMP) &&
			(!IS_FRAGMENT_REMAIN(pip->ip_off)))
		{
			struct icmp *ic = (struct icmp *)L4HDR_ADDR(pip);

			switch (ic->icmp_type)
			{
				case ICMP_UNREACH:
				case ICMP_SOURCEQUENCH:
				case ICMP_TIMXCEED:
				case ICMP_PARAMPROB:
				{
					
					struct ip *cip = NULL;
					struct tcphdr *tc = NULL;
					struct udphdr *ud = NULL;
					uint16 orgSPort, orgDPort;
					uint16 *pnewSPort;
					uint16 *pnewDPort;

					cip = (struct ip*)&(ic->icmp_ip);

					if (!IS_FRAGMENT_REMAIN(cip->ip_off))
					{
						switch ( cip->ip_p )
						{
							case IPPROTO_TCP:
							{
								tc = (struct tcphdr *)L4HDR_ADDR(cip);

								orgSPort = ntohs(tc->th_sport);
								orgDPort = ntohs(tc->th_dport);
								pnewSPort = &(tc->th_sport);
								pnewDPort = &(tc->th_dport);
								break;
							}
							case IPPROTO_UDP:
							{
								ud = (struct udphdr *)L4HDR_ADDR(cip);

								orgSPort = ntohs(ud->uh_sport);
								orgDPort = ntohs(ud->uh_dport);
								pnewSPort = &(ud->uh_sport);
								pnewDPort = &(ud->uh_dport);
								break;
							}
							default:
							
								goto out;
						}

						if ( (retval = _rtl8651_aliasProtoStackRecvPkt(	pktHdr,
																	(svlan->internal)?FALSE:TRUE,
																	cip)) == PS_ACTION_TO_PS )
						{
							
							_RTL8651_L4_ADJUST_CHECKSUM(0, 0, ntohs(*pnewSPort), orgSPort, ic->icmp_cksum);
							_RTL8651_L4_ADJUST_CHECKSUM(0, 0, ntohs(*pnewDPort), orgDPort, ic->icmp_cksum);
						}
					}

					
					goto out;
				}
				default:
					
					break;
			}
		}

		
		retval = _rtl8651_doProtoStackAction(pktHdr, pip);

	}
out:

	
	pktHdr->ph_procFlag |= PH_PROCFLAG_PS_ACTION;

	switch ( retval )
	{
		case PS_ACTION_TO_PS:
			retval = FWDENG_TO_GW;
			break;
		case PS_ACTION_DROP:
			retval = FWDENG_USER_DROP;
			break;
		default:
			retval = SUCCESS;
			break;
	}

	return retval;
}
#endif 


#ifdef _RTL_PORT_BOUNCING
#define RTL8651_PORT_BOUNCING_FUNCTIONS

void _rtl8651_flushPortBouncingEntry(void)
{
	memset(portBouncingTable,0,PORT_BOUNCING_ITEM * sizeof (struct _RTL8651_PORT_BOUNCING_ENTRY));
}


#define _RTL8651_PB_CANDIDATE_CLOSETCP	0
#define _RTL8651_PB_CANDIDATE_ICMP		1
#define _RTL8651_PB_CANDIDATE_UDP		2
#define _RTL8651_PB_CANDIDATE_OTHERTCP	3
#define _RTL8651_PB_CANDIDATE_CNT			4

static struct _RTL8651_PORT_BOUNCING_ENTRY * _rtl8651_addPortBouncingEntry(uint8 flowType,ipaddr_t cip,uint16 cport,ipaddr_t gip,uint16 gport,ipaddr_t sip,uint16 sport, uint16 id, uint32 tcpFlag, uint16 age)
{
	int i;
	struct _RTL8651_PORT_BOUNCING_ENTRY *ptr;
	struct _RTL8651_PORT_BOUNCING_ENTRY *candidate[_RTL8651_PB_CANDIDATE_CNT] = {NULL};

	ptr = portBouncingTable;

	for(i=0;i<PORT_BOUNCING_ITEM;i++, ptr++)
	{
		if(ptr->age == 0)
		{
setNewEntry:
			ptr->clientIpAddr		= cip;
			ptr->clientPort		= cport;
			ptr->serverIpAddr		= sip;
			ptr->serverPort		= sport;
			ptr->gatewayIpAddr	= gip;
			ptr->gatewayPort		= gport;
			ptr->id				= id;
			ptr->age				= age;
			ptr->flowType			= flowType;
			if (tcpFlag)
			{
				ptr->tcpFlag		= (tcpFlag - 1);
			}else
			{
				ptr->tcpFlag		= 0;
			}
			return ptr;
		}else
		{	
			if (ptr->flowType == PKTHDR_TCP)
			{
				if (ptr->tcpFlag == (TCP_CLOSED_FLOW - 1))
					candidate[_RTL8651_PB_CANDIDATE_CLOSETCP] = ptr;
				else if (	(candidate[_RTL8651_PB_CANDIDATE_OTHERTCP] == NULL) ||
						(candidate[_RTL8651_PB_CANDIDATE_OTHERTCP]->age > ptr->age)	)
					candidate[_RTL8651_PB_CANDIDATE_OTHERTCP] = ptr;
			} else if (ptr->flowType == PKTHDR_UDP)
			{
				if (		(candidate[_RTL8651_PB_CANDIDATE_UDP] == NULL) ||
						(candidate[_RTL8651_PB_CANDIDATE_UDP]->age > ptr->age)	)
					candidate[_RTL8651_PB_CANDIDATE_UDP] = ptr;
			} else if (ptr->flowType == PKTHDR_ICMP)
			{
				if (		(candidate[_RTL8651_PB_CANDIDATE_ICMP] == NULL) ||
						(candidate[_RTL8651_PB_CANDIDATE_ICMP]->age > ptr->age)	)
					candidate[_RTL8651_PB_CANDIDATE_ICMP] = ptr;
			}
		}
	}
	
	for (i = 0 ; i < _RTL8651_PB_CANDIDATE_CNT ; i ++)
	{
		if (candidate[i])
		{
			ptr = candidate[i];
			goto setNewEntry;
		}
	}

	
	return NULL;
}

void _rtl8651_portBouncingTimeUpdate(uint32 secPassed)
{
	struct _RTL8651_PORT_BOUNCING_ENTRY *pb_t;
	int i;

	for(i=0, pb_t=portBouncingTable;i<PORT_BOUNCING_ITEM; i++, pb_t++)
	{
		if (pb_t->age < secPassed)
		{
			pb_t->age = 0;
		} else pb_t->age -= secPassed;
	}
}

static int32 _rtl8651_l34PortBouncingIcmpErrMsg(struct rtl_pktHdr *pkthdr, struct ip *pip, struct icmp *ic)
{
	uint32 nCount;
	uint16 errFlowType;
	struct ip *eip;

	struct tcphdr *etc=NULL;
	struct udphdr *eud=NULL;
	uint16 esport=0, edport=0;
	struct icmp *eic;
	uint16 eid=0;

	
	switch (ic->icmp_type)
	{
		case ICMP_TIMXCEED:
		case ICMP_UNREACH:
		case ICMP_SOURCEQUENCH:
		case ICMP_PARAMPROB:
			break;
		default:
			goto to_gw;				
	}

	eip = &ic->icmp_ip;
	switch (eip->ip_p)
	{
		case IPPROTO_TCP:
			errFlowType = PKTHDR_TCP;
			etc = (struct tcphdr*) ((int8 *) eip + ((*(uint8*)eip&0xf) << 2));
			esport = ntohs(etc->th_sport);
			edport = ntohs(etc->th_dport);
			break;
		case IPPROTO_UDP:
			errFlowType = PKTHDR_UDP;
			eud = (struct udphdr*) ((int8 *) eip + ((*(uint8*)eip&0xf) << 2));
			esport = ntohs(eud->uh_sport);
			edport = ntohs(eud->uh_dport);
			break;
		case IPPROTO_ICMP:
			errFlowType = PKTHDR_ICMP;
			eic = (struct icmp*) ((int8 *) eip + ((*(uint8*)eip&0xf) << 2));
			eid = ntohs(eic->icmp_id);
			break;
		default:
			goto to_gw;
	}

	
	for ( nCount = 0 ; nCount < PORT_BOUNCING_ITEM ; nCount++ )
	{
		if (portBouncingTable[nCount].age == 0)
			continue;
		if (pkthdr->ph_dip != portBouncingTable[nCount].gatewayIpAddr)
			continue;
		if (errFlowType != portBouncingTable[nCount].flowType)
			continue;

		if (pkthdr->ph_sip == portBouncingTable[nCount].clientIpAddr)
		{	
			if (((eip->ip_p == IPPROTO_TCP) || (eip->ip_p == IPPROTO_UDP)) &&
				(esport == portBouncingTable[nCount].gatewayPort) &&
				(edport == portBouncingTable[nCount].clientPort))
			{	
				PKTSET_UINT32_UNALIGNED(portBouncingTable[nCount].serverIpAddr, &eip->ip_src);
				PKTSET_UINT32_UNALIGNED(portBouncingTable[nCount].gatewayIpAddr, &eip->ip_dst);
				_RTL8651_L3_ADJUST_CHECKSUM( portBouncingTable[nCount].serverIpAddr, portBouncingTable[nCount].clientIpAddr, eip->ip_sum);
				if (eip->ip_p == IPPROTO_TCP)
				{	
					etc->th_sport = htons(portBouncingTable[nCount].serverPort);
				}else
				{	
					eud->uh_sport = htons(portBouncingTable[nCount].serverPort);
				}
			}else if (eid == portBouncingTable[nCount].id)
			{	
				PKTSET_UINT32_UNALIGNED(portBouncingTable[nCount].serverIpAddr, &eip->ip_src);
				PKTSET_UINT32_UNALIGNED(portBouncingTable[nCount].gatewayIpAddr, &eip->ip_dst);
				_RTL8651_L3_ADJUST_CHECKSUM( portBouncingTable[nCount].serverIpAddr, portBouncingTable[nCount].clientIpAddr, eip->ip_sum);
			}else
			{
				goto checkS2C;
			}
			pkthdr->ph_sip = pkthdr->ph_dip;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
			pkthdr->ph_dip = portBouncingTable[nCount].serverIpAddr;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
			goto out;
		}
checkS2C:
		if (pkthdr->ph_sip == portBouncingTable[nCount].serverIpAddr)
		{	
			if (((eip->ip_p == IPPROTO_TCP) || (eip->ip_p == IPPROTO_UDP)) &&
				(esport == portBouncingTable[nCount].clientPort) &&
				(edport == portBouncingTable[nCount].serverPort))
			{	
				PKTSET_UINT32_UNALIGNED(portBouncingTable[nCount].clientIpAddr, &eip->ip_src);
				PKTSET_UINT32_UNALIGNED(portBouncingTable[nCount].gatewayIpAddr, &eip->ip_dst);
				_RTL8651_L3_ADJUST_CHECKSUM(portBouncingTable[nCount].clientIpAddr, portBouncingTable[nCount].serverIpAddr, eip->ip_sum);
				if (eip->ip_p == IPPROTO_TCP)
				{	
					etc->th_dport = htons(portBouncingTable[nCount].gatewayPort);
				}else
				{	
					eud->uh_dport = htons(portBouncingTable[nCount].gatewayPort);
				}
			}else if (eid == portBouncingTable[nCount].id)
			{	
				PKTSET_UINT32_UNALIGNED(portBouncingTable[nCount].clientIpAddr, &eip->ip_src);
				PKTSET_UINT32_UNALIGNED(portBouncingTable[nCount].gatewayIpAddr, &eip->ip_dst);
				_RTL8651_L3_ADJUST_CHECKSUM(portBouncingTable[nCount].clientIpAddr, portBouncingTable[nCount].serverIpAddr, eip->ip_sum);
			
			}else
			{
				continue;
			}
			pkthdr->ph_sip = pkthdr->ph_dip;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
			pkthdr->ph_dip = portBouncingTable[nCount].clientIpAddr;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
			goto out;
		}
	}

	return FAILED;	
to_gw:
	return FWDENG_TO_GW;	
out:
	return SUCCESS;	
}


static inline int32 _rtl8651_l4NaptPortBouncing(struct rtl_pktHdr *pkthdr, struct ip *pip)
{
	struct _RTL8651_PORT_BOUNCING_ENTRY *pb_entry = NULL;
	rtl8651_tblDrv_vlanTable_t * ingress_vlan;
	uint32 netIdx;
	struct tcphdr *tc=NULL;
	struct udphdr *ud=NULL;
	struct icmp *ic=NULL;
	ipaddr_t sip = pkthdr->ph_sip;
	ipaddr_t dip = pkthdr->ph_dip;
	uint16 sport=0;
	uint16 dport=0;
	uint16 id=0;
	int16 idx = -1;
	int16 nCount;

	
	if (_rtl8651_extIpAddr(dip, &netIdx) != TRUE)
	{
		goto to_gw;
	}

	ingress_vlan = &DrvTbl.vlan[pkthdr->ph_vlanIdx & (RTL8651_VLAN_NUMBER - 1)];
	if (!ingress_vlan->internal)
	{
		goto to_gw;
	}

#ifdef _RTL_NAPT_FRAG
	if (ntohs(pip->ip_off) & IP_OFFMASK)
	{
		ipaddr_t mod_ip;

		if (_rtl8651_getFragCache(BOUNCING_FRAG, sip, dip, ntohs(pip->ip_id), &mod_ip, NULL, NULL, &(pkthdr->ph_dsid)) != SUCCESS)
		{
			goto to_gw;
		}
		pkthdr->ph_sip = pkthdr->ph_dip;
		pkthdr->ph_dip = mod_ip;
		PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
		PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
		goto out;
	}
#else
	if (ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK))
	{
		goto to_gw;
	}
#endif 


	switch (pkthdr->ph_proto)
	{
		case PKTHDR_TCP:
			tc = (struct tcphdr*)L4HDR_ADDR(pip);
			sport = ntohs(tc->th_sport);
			dport = ntohs(tc->th_dport);
			break;
		case PKTHDR_UDP:
			ud = (struct udphdr*)L4HDR_ADDR(pip);
			sport = ntohs(ud->uh_sport);
			dport = ntohs(ud->uh_dport);
			break;
		case PKTHDR_ICMP:
			ic = (struct icmp*)L4HDR_ADDR(pip);
			id = ntohs(ic->icmp_id);
			break;
		default:
			goto to_gw;
	}

	
	for ( nCount = 0 ; nCount < PORT_BOUNCING_ITEM ; nCount++ )
	{
		if (portBouncingTable[nCount].age == 0)
			continue;

		if (pkthdr->ph_proto != portBouncingTable[nCount].flowType)
			continue;

		if (dip != portBouncingTable[nCount].gatewayIpAddr)
			continue;

		if (sip == portBouncingTable[nCount].clientIpAddr)
		{	
			if( (((pkthdr->ph_proto == PKTHDR_TCP) ||(pkthdr->ph_proto == PKTHDR_UDP))) &&
				(sport == portBouncingTable[nCount].clientPort) &&
				(dport == portBouncingTable[nCount].gatewayPort))
			{	
				if(pkthdr->ph_proto == PKTHDR_TCP)
				{	
					tc->th_dport = htons(portBouncingTable[nCount].serverPort);
					portBouncingTable[nCount].age =
						_rtl8651_portBouncingTcpMonitor(tc, &(portBouncingTable[nCount].tcpFlag), TRUE);
				}else
				{	
					int j;
					for(j=0;j < PORT_BOUNCING_ITEM ;j++ )
					{
						if (portBouncingTable[j].age == 0)
							continue;

						if (pkthdr->ph_proto != portBouncingTable[j].flowType)
							continue;

						if (sip != portBouncingTable[j].serverIpAddr)
							continue;					

						if (ud->uh_sport != portBouncingTable[j].serverPort)
							continue;					
						
						ud->uh_sport= portBouncingTable[j].gatewayPort;
						break;				
					}
					ud->uh_dport = htons(portBouncingTable[nCount].serverPort);
					portBouncingTable[nCount].age = rtl8651GlobalControl.udpTimeout;
				}
			}else if ((pkthdr->ph_proto == PKTHDR_ICMP) && (id == portBouncingTable[nCount].id))	
			{	
				switch (ic->icmp_type)
				{
					#if 0	
					case ICMP_ECHOREPLY:
					case ICMP_TSTAMPREPLY:
 						goto to_gw;	
					#endif
					case ICMP_ECHO:
					case ICMP_TSTAMP:
						if (!rtl8651_DMZHostIcmpPassthroughEnable)
							goto to_gw;	
						break;
					default:
						break;
				}
				
				portBouncingTable[nCount].age = rtl8651GlobalControl.icmpTimeout;

			}else
			{
				goto checkS2C;
			}
			
			pkthdr->ph_sip = pkthdr->ph_dip;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
			pkthdr->ph_dip = portBouncingTable[nCount].serverIpAddr;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
			idx = nCount;
			pb_entry = &(portBouncingTable[nCount]);
			goto out;	
		}
checkS2C:
		if (sip == portBouncingTable[nCount].serverIpAddr)
		{	
			if (((pkthdr->ph_proto == PKTHDR_TCP) || (pkthdr->ph_proto == PKTHDR_UDP)) &&
				(sport == portBouncingTable[nCount].serverPort) &&
				(dport == portBouncingTable[nCount].clientPort))
			{	
				if (pkthdr->ph_proto == PKTHDR_TCP)
				{	
					tc->th_sport = htons(portBouncingTable[nCount].gatewayPort);
					portBouncingTable[nCount].age =
						_rtl8651_portBouncingTcpMonitor(tc, &(portBouncingTable[nCount].tcpFlag), FALSE);
				}else
				{	
					int j;
					for(j=0;j < PORT_BOUNCING_ITEM ;j++ )
					{
						if (portBouncingTable[j].age == 0)
							continue;

						if (pkthdr->ph_proto != portBouncingTable[j].flowType)
							continue;

						if (sip != portBouncingTable[j].clientIpAddr)
							continue;					

						if (ud->uh_sport != portBouncingTable[j].clientPort)
							continue;					
						
						ud->uh_dport= portBouncingTable[j].serverPort;
						break;				
					}				
					ud->uh_sport = htons(portBouncingTable[nCount].gatewayPort);
					portBouncingTable[nCount].age = rtl8651GlobalControl.udpTimeout;
				}
			}else if ((pkthdr->ph_proto == PKTHDR_ICMP) && (id == portBouncingTable[nCount].id))	
			{	
				
				portBouncingTable[nCount].age = rtl8651GlobalControl.icmpTimeout;
			}else
			{
				continue;
			}
			
			pkthdr->ph_sip = pkthdr->ph_dip;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
			pkthdr->ph_dip = portBouncingTable[nCount].clientIpAddr;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
			idx = nCount;
			pb_entry = &(portBouncingTable[nCount]);
			goto out;	
		}
	}

	{
		
		int32 local_val;
		rtl8651_tblDrv_vlanTable_t *local_vlanp = &DrvTbl.vlan[pkthdr->ph_vlanIdx];
		local_val = _rtl8651_ingressAcl(pkthdr->ph_dsid, 0, local_vlanp, local_vlanp->vid, pkthdr->ph_mbuf->m_data, (uint8 *) pip, RTL8651_ACL_L4NEWFLOW, _RTL8651_OPERATION_OTHER);
		if (((local_val > 0) && (local_val & FWDENG_DROP)) ||(local_val == FWDENG_ACL_IN_USERTRAP))
			return local_val;
	}



		if(idx == -1)
		{
			rtl8651_tblDrv_naptServerPortEntry_t * sp = NULL;
			if(pkthdr->ph_proto == PKTHDR_TCP)
			{
				sp = _rtl8651_getOutsideNaptServerPortMapping(TRUE, dip, dport);
				if (sp)
				{
					if ((pb_entry = _rtl8651_addPortBouncingEntry(PKTHDR_TCP,
						sip, sport,
						dip, dport,
						sp->localIp, (dport + sp->localPort  - sp->globalPort),
						0,
						TCP_OUTBOUND_SYN_RCVD_FLOW,
						rtl8651GlobalControl.tcpFastTimeout)) == NULL)
					{
						goto drop;
					}
					tc->th_dport = htons((dport + sp->localPort - sp->globalPort));
				}
			}else if(pkthdr->ph_proto == PKTHDR_UDP)
			{
				sp = _rtl8651_getOutsideNaptServerPortMapping(FALSE, dip, dport);
				if (sp)
				{
					if ((pb_entry = _rtl8651_addPortBouncingEntry(PKTHDR_UDP,
						sip, sport,
						dip, dport,
						sp->localIp, (dport + sp->localPort - sp->globalPort),
						0,
						0,
						rtl8651GlobalControl.udpTimeout)) == NULL)
					{
						goto drop;
					}
					ud->uh_dport = htons((dport + sp->localPort - sp->globalPort));
				}
			}
			if (sp)
			{	
				pkthdr->ph_sip = pkthdr->ph_dip;
				PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
				pkthdr->ph_dip = sp->localIp;
				PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
				goto out;
			}
			assert(!sp);

			if (rtl8651_drvProcessUpnpPortBouncing == TRUE)	
			{
				if ((pkthdr->ph_proto == PKTHDR_TCP) || (pkthdr->ph_proto == PKTHDR_UDP))
				{
					ipaddr_t localIp = 0;
					uint16 localPort = 0;

					
					_rtl8651_findInboundUpnpMapping((pkthdr->ph_proto == PKTHDR_TCP)?TRUE:FALSE, sip, sport, dip, dport, &localIp, &localPort, NULL, NULL);
					if (localIp)
					{	
						if ((pb_entry = _rtl8651_addPortBouncingEntry(pkthdr->ph_proto,
							sip, sport,
							dip, dport,
							localIp, localPort,
							0,
							(pkthdr->ph_proto == PKTHDR_TCP)?TCP_OUTBOUND_SYN_RCVD_FLOW:0,
							(pkthdr->ph_proto == PKTHDR_TCP)?rtl8651GlobalControl.tcpFastTimeout:rtl8651GlobalControl.udpTimeout)) == NULL)
						{
							goto drop;
						}
						if (pkthdr->ph_proto == PKTHDR_TCP)
							tc->th_dport = htons(localPort);
						else
							ud->uh_dport = htons(localPort);

						
						pkthdr->ph_sip = pkthdr->ph_dip;
						PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
						pkthdr->ph_dip = localIp;
						PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
						goto out;
					}
				}
			}


#ifdef _RTL_PS_ACTION
			if (rtl8651_drvEnPortBouncingPSaction) {
				
				int32 val;
				rtl8651_tblDrv_vlanTable_t *local_vlanp = &DrvTbl.vlan[pkthdr->ph_vlanIdx];

				if ((val = _rtl8651_protoStackAction_filter(pkthdr, local_vlanp, pip)) != SUCCESS)
				{
					switch (val)
					{
						case FWDENG_TO_GW:
							goto to_gw;
						case FWDENG_USER_DROP:
							goto drop;
					}
				}
			}
#endif	




			{
				ipaddr_t dmzhost;
				if (_rtl8651_getDmzHost(pkthdr->ph_dsid, dip, &dmzhost) == SUCCESS)
				{	
					switch (pkthdr->ph_proto)
					{
						case PKTHDR_TCP:
							if ((pb_entry = _rtl8651_addPortBouncingEntry(PKTHDR_TCP,
								sip, sport,
								dip, dport,
								dmzhost, dport,
								0,
								TCP_OUTBOUND_SYN_RCVD_FLOW,
								rtl8651GlobalControl.tcpFastTimeout)) == NULL)
							{
								goto drop;
							}
							break;
						case PKTHDR_UDP:
							if ((pb_entry = _rtl8651_addPortBouncingEntry(PKTHDR_UDP,
								sip, sport,
								dip, dport,
								dmzhost, dport,
								0,
								0,
								rtl8651GlobalControl.udpTimeout)) == NULL)
							{
								goto drop;
							}
							break;
						case PKTHDR_ICMP:
							switch (ic->icmp_type)
							{
								#if 0	
								case ICMP_ECHOREPLY:
								case ICMP_TSTAMPREPLY:
									goto to_gw;	
								#endif
								case ICMP_ECHO:
								case ICMP_TSTAMP:
									if (!rtl8651_DMZHostIcmpPassthroughEnable)
										goto to_gw;
									break;
								case ICMP_TIMXCEED:
								case ICMP_UNREACH:
								case ICMP_SOURCEQUENCH:
								case ICMP_PARAMPROB:
									goto icmp_errMsg;
								default:
									break;
							}
							if ((pb_entry = _rtl8651_addPortBouncingEntry(PKTHDR_ICMP,
								sip, 0,
								dip, 0,
								dmzhost, 0,
								id,
								0,
								rtl8651GlobalControl.icmpTimeout)) == NULL)
							{
								goto drop;
							}
							break;
					}
					pkthdr->ph_sip = pkthdr->ph_dip;
					PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
					pkthdr->ph_dip = dmzhost;
					PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
					goto out;
				}
			}
		}
		goto icmp_errMsg;	
out:
	{
		
		rtl8651_tblDrv_networkIntfTable_t * netIface = &DrvTbl.netIface[netIdx];

		pkthdr->ph_vlanIdx = netIface->vid;
		pkthdr->ph_routeIdx = 0;
		pkthdr->ph_dsid = 0;
		pkthdr->ph_portlist = 0;
	}
#ifdef _RTL_NAPT_FRAG
	if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK)) == IP_MF))
	{
		if ((pip->ip_vhl & 0x0f) != 5)
		{
			_RTL8651_L3_ADJUST_CHECKSUM(pkthdr->ph_sip, sip, pip->ip_sum);
			_RTL8651_L3_ADJUST_CHECKSUM(pkthdr->ph_dip, dip, pip->ip_sum);
		}
		
		if ((ntohs(pip->ip_off) & IP_OFFMASK) == 0)
		{
			if (pkthdr->ph_proto == PKTHDR_TCP)
			{
				_RTL8651_L4_ADJUST_CHECKSUM(pkthdr->ph_sip, sip, tc->th_sport, htons(sport), tc->th_sum);
				_RTL8651_L4_ADJUST_CHECKSUM(pkthdr->ph_dip, dip, tc->th_dport, htons(dport), tc->th_sum);
			}else if ((pkthdr->ph_proto == PKTHDR_UDP) && (ud->uh_sum))
			{
				_RTL8651_L4_ADJUST_CHECKSUM(pkthdr->ph_sip, sip, ud->uh_sport, htons(sport), ud->uh_sum);
				_RTL8651_L4_ADJUST_CHECKSUM(pkthdr->ph_dip, dip, ud->uh_dport, htons(dport), ud->uh_sum);
			}
			

			if (IS_FRAGMENT(pip->ip_off))
			{
				_rtl8651_updateFragCache(BOUNCING_FRAG, sip, dip, ntohs(pip->ip_id), pkthdr->ph_dip, 0, NULL, pkthdr->ph_dsid);
			}
		}
	}
#endif 
	if (_rtl8651_l3ActRouting(pkthdr, pkthdr->ph_dip, pip) != SUCCESS)
	{
		goto drop;
	}
	return SUCCESS;

icmp_errMsg:
	if (pkthdr->ph_proto == PKTHDR_ICMP)
	{
		if (_rtl8651_l34PortBouncingIcmpErrMsg(pkthdr, pip, ic) == SUCCESS)
		{
			goto out;
		}
	}
	goto to_gw;

drop:
	if (pb_entry)
	{
		pb_entry->age = 0;
	}
	return FWDENG_DROP;
to_gw:
	
	return FAILED;
}

static inline int32 _rtl8651_l4NatPortBouncing(struct rtl_pktHdr *pkthdr, struct ip *pip)
{
	struct _RTL8651_PORT_BOUNCING_ENTRY *pb_entry = NULL;
	rtl8651_tblDrv_vlanTable_t * ingress_vlan;
	rtl8651_tblDrv_natEntry_t * nat;
	struct tcphdr *tc=0;
	struct udphdr *ud=0;
	ipaddr_t sip = pkthdr->ph_sip;
	ipaddr_t dip = pkthdr->ph_dip;
	uint16 sport=0, dport=0;
	struct icmp *ic=0;
	uint16 id=0;
	int16 idx = -1;
	int16 nCount;

	
	if ((nat = _rtl8651_getNatExternalMappingEntry(dip, pkthdr)) == NULL)
	{
		goto to_gw;
	}

	ingress_vlan = &DrvTbl.vlan[pkthdr->ph_vlanIdx & (RTL8651_VLAN_NUMBER - 1)];
	if (!ingress_vlan->internal)
	{
		goto to_gw;
	}

	
	if (nat->globalIp == nat->localIp)
	{
		goto out;
	}

#ifdef _RTL_NAPT_FRAG
	if (ntohs(pip->ip_off) & IP_OFFMASK)
	{
		ipaddr_t mod_ip;

		if (_rtl8651_getFragCache(BOUNCING_FRAG, sip, dip, ntohs(pip->ip_id), &mod_ip, NULL, NULL, &(pkthdr->ph_dsid)) != SUCCESS)
		{
			goto to_gw;
		}

		pkthdr->ph_sip = pkthdr->ph_dip;
		pkthdr->ph_dip = mod_ip;
		PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
		PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
		goto out;
	}
#else
	if (ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK))
	{
		goto to_gw;
	}
#endif 

	switch (pkthdr->ph_proto)
	{
		case PKTHDR_TCP:
			tc = (struct tcphdr*)L4HDR_ADDR(pip);
			sport = ntohs(tc->th_sport);
			dport = ntohs(tc->th_dport);
			break;
		case PKTHDR_UDP:
			ud = (struct udphdr*)L4HDR_ADDR(pip);
			sport = ntohs(ud->uh_sport);
			dport = ntohs(ud->uh_dport);
			break;
		case PKTHDR_ICMP:
			ic = (struct icmp*)L4HDR_ADDR(pip);
			id = ntohs(ic->icmp_id);
			break;
		default:
			goto to_gw;
	}

	
	for ( nCount = 0 ; nCount < PORT_BOUNCING_ITEM ; nCount++ )
	{
		if (portBouncingTable[nCount].age == 0)
			continue;

		if (pkthdr->ph_proto != portBouncingTable[nCount].flowType)
			continue;

		if (pkthdr->ph_dip != portBouncingTable[nCount].gatewayIpAddr)
			continue;

		if (pkthdr->ph_sip == portBouncingTable[nCount].clientIpAddr)
		{	
			if( (((pkthdr->ph_proto == PKTHDR_TCP) ||(pkthdr->ph_proto == PKTHDR_UDP))) &&
				(sport == portBouncingTable[nCount].clientPort) &&
				(dport == portBouncingTable[nCount].gatewayPort))
			{	
				if(pkthdr->ph_proto == PKTHDR_TCP)
				{	
					tc->th_dport = htons(portBouncingTable[nCount].serverPort);
					portBouncingTable[nCount].age =
						_rtl8651_portBouncingTcpMonitor(tc, &(portBouncingTable[nCount].tcpFlag), TRUE);
				}else
				{	
					ud->uh_dport = htons(portBouncingTable[nCount].serverPort);
					portBouncingTable[nCount].age = rtl8651GlobalControl.udpTimeout;
				}
			}else if ((pkthdr->ph_proto == PKTHDR_ICMP) && (id == portBouncingTable[nCount].id))	
			{	
				portBouncingTable[nCount].age = rtl8651GlobalControl.icmpTimeout;

			}else
			{
				goto checkS2C;
			}
			
			pkthdr->ph_sip = pkthdr->ph_dip;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
			pkthdr->ph_dip = portBouncingTable[nCount].serverIpAddr;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
			idx = nCount;
			pb_entry = &(portBouncingTable[nCount]);
			goto out;	
		}
checkS2C:
		if (pkthdr->ph_sip == portBouncingTable[nCount].serverIpAddr)
		{	
			if (((pkthdr->ph_proto == PKTHDR_TCP) || (pkthdr->ph_proto == PKTHDR_UDP)) &&
				(sport == portBouncingTable[nCount].serverPort) &&
				(dport == portBouncingTable[nCount].clientPort))
			{	
				if (pkthdr->ph_proto == PKTHDR_TCP)
				{	
					tc->th_sport = htons(portBouncingTable[nCount].gatewayPort);
					portBouncingTable[nCount].age =
						_rtl8651_portBouncingTcpMonitor(tc, &(portBouncingTable[nCount].tcpFlag), FALSE);
				}else
				{	
					ud->uh_sport = htons(portBouncingTable[nCount].gatewayPort);
					portBouncingTable[nCount].age = rtl8651GlobalControl.udpTimeout;
				}
			}else if ((pkthdr->ph_proto == PKTHDR_ICMP) && (id == portBouncingTable[nCount].id))	
			{	
				portBouncingTable[nCount].age = rtl8651GlobalControl.icmpTimeout;
			}else
			{
				continue;
			}
			
			pkthdr->ph_sip = pkthdr->ph_dip;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
			pkthdr->ph_dip = portBouncingTable[nCount].clientIpAddr;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
			idx = nCount;
			pb_entry = &(portBouncingTable[nCount]);
			goto out;	
		}
	}

	{
		
		int32 local_val;
		rtl8651_tblDrv_vlanTable_t *local_vlanp = &DrvTbl.vlan[pkthdr->ph_vlanIdx];
		local_val = _rtl8651_ingressAcl(pkthdr->ph_dsid, 0, local_vlanp, local_vlanp->vid, pkthdr->ph_mbuf->m_data, (uint8 *) pip, RTL8651_ACL_L4NEWFLOW, _RTL8651_OPERATION_OTHER);
		if (((local_val > 0) && (local_val & FWDENG_DROP)) ||(local_val == FWDENG_ACL_IN_USERTRAP))
			return local_val;
	}
	


	if (idx == -1)
	{
		if (sip != nat->localIp)	
		{
			switch (pkthdr->ph_proto)
			{
				case PKTHDR_TCP:
					if ((pb_entry = _rtl8651_addPortBouncingEntry(PKTHDR_TCP,
						sip, sport,
						dip, dport,
						nat->localIp, dport,
						0,
						TCP_OUTBOUND_SYN_RCVD_FLOW,
						rtl8651GlobalControl.tcpFastTimeout)) == NULL)
					{
						goto drop;
					}
					break;
				case PKTHDR_UDP:
					if ((pb_entry = _rtl8651_addPortBouncingEntry(PKTHDR_UDP,
						sip, sport,
						dip, dport,
						nat->localIp, dport,
						0,
						0,
						rtl8651GlobalControl.udpTimeout)) == NULL)
					{
						goto drop;
					}
					break;
				case PKTHDR_ICMP:
					switch(ic->icmp_type)
					{
						case ICMP_TIMXCEED:
						case ICMP_UNREACH:
						case ICMP_SOURCEQUENCH:
						case ICMP_PARAMPROB:
							goto icmp_errMsg;
					}
					if ((pb_entry = _rtl8651_addPortBouncingEntry(PKTHDR_ICMP,
						sip, 0,
						dip, 0,
						nat->localIp, 0,
						id,
						0,
						rtl8651GlobalControl.icmpTimeout)) == NULL)
					{
						goto drop;
					}
					break;
			}
			pkthdr->ph_sip = pkthdr->ph_dip;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_sip, &pip->ip_src);
			pkthdr->ph_dip = nat->localIp;
			PKTSET_UINT32_UNALIGNED(pkthdr->ph_dip, &pip->ip_dst);
			goto out;
		}
	}

	goto icmp_errMsg;	
out:
	{
		
		uint32 netIdx;
		int8 ret;
		rtl8651_tblDrv_networkIntfTable_t *netIface;
		
		ret = _rtl8651_extNetIpAddr(nat->globalIp, &netIdx);
		assert(ret == TRUE);
		netIface = &DrvTbl.netIface[netIdx];
		pkthdr->ph_vlanIdx = netIface->vid;
		pkthdr->ph_routeIdx = 0;
		pkthdr->ph_dsid = 0;
		pkthdr->ph_portlist = 0;
	}
#ifdef _RTL_NAPT_FRAG
	if (((pip->ip_vhl & 0x0f) != 5) || ((ntohs(pip->ip_off) & (IP_MF|IP_OFFMASK)) == IP_MF))
	{
		if ((pip->ip_vhl & 0x0f) != 5)
		{
			_RTL8651_L3_ADJUST_CHECKSUM(pkthdr->ph_sip, sip, pip->ip_sum);
			_RTL8651_L3_ADJUST_CHECKSUM(pkthdr->ph_dip, dip, pip->ip_sum);
		}
		
		if ((ntohs(pip->ip_off) & IP_OFFMASK) == 0)
		{
			if (pkthdr->ph_proto == PKTHDR_TCP)
			{
				_RTL8651_L4_ADJUST_CHECKSUM(pkthdr->ph_sip, sip, tc->th_sport, htons(sport), tc->th_sum);
				_RTL8651_L4_ADJUST_CHECKSUM(pkthdr->ph_dip, dip, tc->th_dport, htons(dport), tc->th_sum);
			}else if ((pkthdr->ph_proto == PKTHDR_UDP) && (ud->uh_sum))
			{
				_RTL8651_L4_ADJUST_CHECKSUM(pkthdr->ph_sip, sip, ud->uh_sport, htons(sport), ud->uh_sum);
				_RTL8651_L4_ADJUST_CHECKSUM(pkthdr->ph_dip, dip, ud->uh_dport, htons(dport), ud->uh_sum);
			}
			

			if (IS_FRAGMENT(pip->ip_off))
			{
				_rtl8651_updateFragCache(BOUNCING_FRAG, sip, dip, ntohs(pip->ip_id), pkthdr->ph_dip, 0, NULL, pkthdr->ph_dsid);
			}
		}
	}
#endif 
	if (_rtl8651_l3ActRouting(pkthdr, pkthdr->ph_dip, pip) != SUCCESS)
	{
		goto drop;
	}
	return SUCCESS;
icmp_errMsg:
	if (pkthdr->ph_proto == PKTHDR_ICMP)
	{
		if (_rtl8651_l34PortBouncingIcmpErrMsg(pkthdr, pip, ic) == SUCCESS)
		{
			goto out;
		}
	}
	goto to_gw;

drop:
	if (pb_entry)
	{
		pb_entry->age = 0;
	}
	return FWDENG_DROP;
to_gw:

	return FAILED;
}

static inline uint32 _rtl8651_portBouncingTcpMonitor(struct tcphdr *tc, uint32 *currentState, int8 IsClientToServer)
{
	uint32 pktFlags;
	uint32 retval = 0;
	int8	*StateTable = NULL;
	
	

	pktFlags = tc->th_flags &  (TH_RST|TH_SYN|TH_FIN);
	assert((*currentState) <= (TCP_CLOSED_FLOW-1));

	if (IsClientToServer == TRUE)
	{
		StateTable = (int8*)_outNextState;
	}
	else
	{
		StateTable = (int8*)_inNextState;
	}

	if(pktFlags & TH_RST){
		*currentState = (TCP_CLOSED_FLOW - 1);
		retval = (rtl8651GlobalControl.tcpFastTimeout);
	}else if(pktFlags == 0){ 
resetage:
		
		retval = (*_ageTimer[(*currentState)+1]);
	}else if(pktFlags == TH_SYN){
		
		int8 state = StateTable[(8*0) + (*currentState)];
		assert(state >=0);
		if(state > 0){
			*currentState = (state - 1);
			retval = *(_ageTimer[(int)state]);
		}else if(state == 0) 
			goto resetage;
	}else{
		
		int8 state = StateTable[(8*1) + (*currentState)];
		assert(state >=0);
		if(state > 0){
			*currentState = (state - 1);
			retval = *(_ageTimer[(int)state]);
		}else if(state == 0) 
			goto resetage;
	}
	return retval;
}
#endif  

#ifdef _RTL_TRIGGER_PORT
#define RTL8651_TRIGGER_PORT_FUNCTIONS



#define _TRIGGERPORT_ENTRY_CACHE_LINK(HdrEntry,LinkCache) \
		do { \
			(LinkCache)->entryHdr=(HdrEntry); \
			(LinkCache)->entryList_next=(HdrEntry)->normalCache; \
			(LinkCache)->entryList_prev=NULL; \
			if ((HdrEntry)->normalCache){(HdrEntry)->normalCache->entryList_prev=(LinkCache);}\
			(HdrEntry)->normalCache=(LinkCache);\
		} while (0);

#define _TRIGGERPORT_ENTRY_CACHE_UNLINK(UnlinkCache) \
		do { \
			if ((UnlinkCache)->entryList_prev){(UnlinkCache)->entryList_prev->entryList_next=(UnlinkCache)->entryList_next;} \
			if ((UnlinkCache)->entryList_next){(UnlinkCache)->entryList_next->entryList_prev=(UnlinkCache)->entryList_prev;} \
			if ((UnlinkCache)->entryHdr->normalCache==(UnlinkCache)){(UnlinkCache)->entryHdr->normalCache=(UnlinkCache)->entryList_next;} \
		} while (0);


static inline void _rtl8651_TriggerPort_FreeCache(uint8 isStatic, _rtl8651_triggerPort_cache_t *cache)
{
	
	_NORMAL_UNLINK(cache);
	HTLIST_REMOVE(cache, lru_next, lru_prev, triggerPort_cache_lruHdr, triggerPort_cache_lruTail);

	
	if (isStatic == FALSE)
	{
		_TRIGGERPORT_ENTRY_CACHE_UNLINK(cache);
	}

	
	memset(cache, 0, sizeof(_rtl8651_triggerPort_cache_t));

	
	_PUT_TO_FREELIST(cache, triggerPort_cache_freeList);
}


static inline _rtl8651_triggerPort_cache_t * _rtl8651_TriggerPort_getCache(void)
{
	_rtl8651_triggerPort_cache_t *cache = NULL;

	if (	(triggerPort_cache_freeList == NULL) &&
		(triggerPort_cache_lruHdr) )
	{
		_rtl8651_TriggerPort_FreeCache((cache->entryHdr)?FALSE:TRUE, cache);
		assert(triggerPort_cache_freeList);
	}

	
	_GET_FROM_FREELIST(cache, triggerPort_cache_freeList);

	return cache;
}


static inline void _rtl8651_TriggerPort_FreeEntry(_rtl8651_triggerPort_entry_t *entry)
{
	
	_NORMAL_UNLINK(entry);

	
	while (entry->normalCache)
	{
		_rtl8651_TriggerPort_FreeCache(FALSE, entry->normalCache);
	}

	
	_PUT_TO_FREELIST(entry, triggerPort_entry_freeList);
}

static int32 _rtl8651_TriggerPortInit(rtl8651_fwdEngineInitPara_t *para)
{
	#ifdef TRIGGER_PORT_DEBUG
	printk("Init trigger port system.\n");
	#endif

	
	triggerPort_entry_tbl = NULL;
	triggerPort_entry_freeList = NULL;
	BZERO_ARRAY(triggerPort_entry_Hdr);

	triggerPort_cache_tbl = NULL;
	triggerPort_cache_freeList = NULL;
	triggerPort_cache_staticEntry = NULL;
	triggerPort_cache_lruHdr = NULL;
	triggerPort_cache_lruTail = NULL;
	BZERO_ARRAY(triggerPort_cache_hashTbl);

	triggerPort_entry_cnt = para->triggerPortEntryCnt;
	triggerPort_cache_cnt = para->triggerPortCacheSize;

	if ( (triggerPort_entry_cnt == 0) || (triggerPort_cache_cnt == 0) ) 
	{
		#ifdef TRIGGER_PORT_DEBUG
		printk("Init trigger port system DONE ... Module disabled.\n");
		#endif

		return SUCCESS;
	}

	

	MEM_ALLOCATE_PTR(triggerPort_entry_tbl, triggerPort_entry_cnt * sizeof(_rtl8651_triggerPort_entry_t));

	if ( triggerPort_entry_tbl == NULL ) 
	{

		#ifdef TRIGGER_PORT_DEBUG
		printk("Init trigger port system FAILED.\n");
		#endif

		return FAILED;
	}

	

	MEM_ALLOCATE_PTR(triggerPort_cache_tbl, triggerPort_cache_cnt * sizeof(_rtl8651_triggerPort_cache_t));

	if ( triggerPort_cache_tbl == NULL ) 
	{

		#ifdef TRIGGER_PORT_DEBUG
		printk("Init trigger port system FAILED.\n");
		#endif

		return FAILED;
	}

	_rtl8651_TriggerPortReinit(); 

	#ifdef TRIGGER_PORT_DEBUG
	printk("Init trigger port system OK.\n");
	#endif

	return SUCCESS;
}


static void _rtl8651_TriggerPortReinit(void)
{
	_rtl8651_triggerPort_entry_t *entry;
	_rtl8651_triggerPort_cache_t *cache;
	uint32 idx;

	#ifdef TRIGGER_PORT_DEBUG
	printk("Re-init trigger port system.\n");
	#endif

	if ( (triggerPort_entry_tbl == NULL) || (triggerPort_cache_tbl == NULL) ) 
	{
		#ifdef TRIGGER_PORT_DEBUG
		printk("Re-init trigger port system DONE.\n");
		#endif

		return;
	}

	BZERO_ARRAY(triggerPort_entry_Hdr);			
	BZERO_ARRAY(triggerPort_cache_hashTbl);		
	triggerPort_cache_staticEntry = NULL;				
	triggerPort_cache_lruHdr = NULL;					
	triggerPort_cache_lruTail = NULL;					
	BZERO_PTR(triggerPort_entry_tbl, triggerPort_entry_cnt * sizeof(_rtl8651_triggerPort_entry_t));
	BZERO_PTR(triggerPort_cache_tbl, triggerPort_cache_cnt * sizeof(_rtl8651_triggerPort_cache_t));

	
	entry = triggerPort_entry_freeList = triggerPort_entry_tbl;
	for ( idx=0 ; idx<(triggerPort_entry_cnt-1) ; idx++,entry++ )
	{
		entry->next = entry + 1;
	}

	
	cache = triggerPort_cache_freeList = triggerPort_cache_tbl;
	for ( idx=0 ; idx<(triggerPort_cache_cnt-1) ; idx++, cache++ )
	{
		cache->next = cache + 1;
	}

	#ifdef TRIGGER_PORT_DEBUG
	printk("Re-init trigger port system DONE.\n");
	#endif

}



void rtl8651_flushTriggerPortRules(void)
{
	rtlglue_drvMutexLock();
	_rtl8651_flushNetTriggerPortRules(0);
	rtlglue_drvMutexUnlock();
}


void rtl8651a_flushNetTriggerPortRules(uint32 netIntfId)
{
	rtlglue_drvMutexLock();
	_rtl8651_flushNetTriggerPortRules(netIntfId);
	rtlglue_drvMutexUnlock();
}

static void _rtl8651_flushNetTriggerPortRules(uint32 netIntfId)
{
	uint32 index;
	_rtl8651_triggerPort_cache_t *cache, *next;

	#ifdef TRIGGER_PORT_DEBUG
	printk("Flush Trigger port rule for Network Interface (%d).\n", netIntfId);
	#endif

	
	for ( index=0 ; index<RTL8651_MAX_DIALSESSION ; index++ )
	{
		_rtl8651_triggerPort_entry_t *entry;
		_rtl8651_triggerPort_entry_t *next;

		entry = triggerPort_entry_Hdr[index];

		while ( entry )
		{
			next = entry->next;

			if ( entry->netIntfId == netIntfId )
			{
				_rtl8651_TriggerPort_FreeEntry(entry);
			}
			entry = next;
		}
	}

	
	cache = triggerPort_cache_staticEntry;
	while ( cache )
	{
		next = cache->next;

		if ( cache->netIntfId == netIntfId )
		{
			#ifdef TRIGGER_PORT_DEBUG
			printk("Remove Trigger Port flow STATIC cache:\n\tNetwork Interface %d\n\tType: %s\n\tPort: %d ~ %d\n\tLocal IP Addr: %u.%u.%u.%u",
						cache->netIntfId,
						(cache->inType==0)?"TCP":(cache->inType==1)?"UDP":(cache->inType==2)?"BOTH":"ERROR !",
						cache->inPortStart,
						cache->inPortEnd,
						NIPQUAD(cache->localIpAddr));
			#endif

			_rtl8651_TriggerPort_FreeCache(TRUE, cache);
		}
		cache = next;
	}

}


int32 rtl8651_addTriggerPortMappingRule (
	uint32 netIntfId,
	uint8 inType,
	uint16 inPortStart,
	uint16 inPortEnd,
	_rtl8651_triggerPort_param_t *mappingInfo)
{
	int32 retval;

	if (	(netIntfId >= RTL8651_MAX_DIALSESSION) ||
		(inPortStart > inPortEnd) ||
		(mappingInfo == NULL))
	{
		return FAILED;
	}
	rtlglue_drvMutexLock();
	retval = _rtl8651_addTriggerPortRule(	netIntfId,
										inType,
										inPortStart,
										inPortEnd,
										mappingInfo);
	rtlglue_drvMutexUnlock();
	return retval;
}


int32 rtl8651_addTriggerPortRule(
	uint8 inType, uint16 inPortStart, uint16 inPortEnd,
	uint8 outType,uint16 outPortStart,uint16 outPortEnd,
	ipaddr_t localIpAddr)
{
	return rtl8651a_addTriggerPortRule(	0,
										inType,
										inPortStart,
										inPortEnd,
										outType,
										outPortStart,
										outPortEnd,
										localIpAddr);
}

int32 rtl8651a_addTriggerPortRule(
	uint32 netIntfId,
	uint8 inType, uint16 inPortStart, uint16 inPortEnd,
	uint8 outType,uint16 outPortStart,uint16 outPortEnd,
	ipaddr_t localIpAddr)
{
	int32 retval;
	_rtl8651_triggerPort_param_t mapInfo;


	if (localIpAddr)
	{	
		mapInfo.isStaticMapping = TRUE;
		mapInfo.age = 0;					

		mapInfo.tp_isStatic = TRUE;
		mapInfo.tp_mappedInsideLocalIpAddr = localIpAddr;
	} else
	{	
		mapInfo.isStaticMapping = FALSE;
		mapInfo.age = RTL8651_TRIGGER_PORT_DEFAULT_TIMEOUT;	

		mapInfo.tp_outType = outType;
		mapInfo.tp_outPortStart = outPortStart;
		mapInfo.tp_outPortEnd = outPortEnd;
		mapInfo.tp_triggeringInsideLocalIpAddrStart = 0;
		mapInfo.tp_triggeringInsideLocalIpAddrEnd = 0;
	}

	rtlglue_drvMutexLock();
	retval = _rtl8651_addTriggerPortRule(	netIntfId,
										inType,
										inPortStart,
										inPortEnd,
										&mapInfo);
	rtlglue_drvMutexUnlock();
	return retval;
}


static int32 _rtl8651_addTriggerPortRule(
	uint32 netIntfId,
	uint8 inType, uint16 inPortStart, uint16 inPortEnd,
	_rtl8651_triggerPort_param_t *mappingInfo)

{
	assert(mappingInfo);
	assert(inPortStart <= inPortEnd);

	#ifdef TRIGGER_PORT_DEBUG
	if (mappingInfo->isStaticMapping == TRUE)
	{
		printk("Add STATIC Trigger port entry:\n\tNetIntfId[%d]\n\tinType[%d], inPort[%d - %d]\n\tAge: %d\n\tNO-LRU: %s\n",
			netIntfId,
			inType, inPortStart, inPortEnd,
			mappingInfo->age,
			(mappingInfo->tp_isStatic==TRUE)?"YES":"NO");
	} else
	{
		printk("Add DYNAMIC Trigger port entry:\n\tNetIntfId[%d]\n\tinType[%d], inPort[%d - %d]\n\toutType[%d], outPort[%d - %d]\n\tTriggering IP[%u.%u.%u.%u - %u.%u.%u.%u]\n\tAge: %d\n",
			netIntfId,
			inType, inPortStart, inPortEnd,
			mappingInfo->tp_outType, mappingInfo->tp_outPortStart, mappingInfo->tp_outPortEnd,
			NIPQUAD(mappingInfo->tp_triggeringInsideLocalIpAddrStart), NIPQUAD(mappingInfo->tp_triggeringInsideLocalIpAddrEnd),
			mappingInfo->age);
	}
	#endif

	if ( mappingInfo->isStaticMapping == TRUE )
	{	
		_rtl8651_triggerPort_cache_t *cache;

		
		cache = triggerPort_cache_staticEntry;

		while ( cache )
		{
			if ( (cache->netIntfId==netIntfId) &&
			      (cache->inPortStart==inPortStart) &&
			      (cache->inPortEnd==inPortEnd))
			{
				if ( cache->inType==inType )
				{ 
					goto updateCache;
				} else if ((cache->inType==2)||(inType==2))
				{ 
					goto errout;
				}
			}

			if ( (!(cache->inPortStart>inPortEnd||cache->inPortEnd<inPortStart)) &&
			      (cache->inType==inType||cache->inType==2||inType==2))
			{ 
				goto errout;
			}
			
			cache = cache->next;
		}

		
		if ( (cache = _rtl8651_TriggerPort_getCache()) == NULL )
		{
			goto errout;
		}

		_NORMAL_LINK(triggerPort_cache_staticEntry, cache);

		cache->ExternalIpAddr	= 0;
		cache->netIntfId		= netIntfId;
		cache->inPortStart		= inPortStart;
		cache->inPortEnd		= inPortEnd;
		cache->inType		= inType;
updateCache:
		cache->isStatic		= mappingInfo->tp_isStatic;
		cache->localIpAddr	= mappingInfo->tp_mappedInsideLocalIpAddr;
		cache->age			= mappingInfo->age;
		cache->maxAge		= mappingInfo->age;

		
		HTLIST_REMOVE(cache, lru_next, lru_prev, triggerPort_cache_lruHdr, triggerPort_cache_lruTail);
		if (mappingInfo->tp_isStatic == FALSE)
		{
			HTLIST_ADD2TAIL(cache, lru_next, lru_prev, triggerPort_cache_lruHdr, triggerPort_cache_lruTail);
		}
	} else
	{	
		_rtl8651_triggerPort_entry_t *entry;

		if (	(mappingInfo->tp_outPortStart > mappingInfo->tp_outPortEnd) ||
			(mappingInfo->tp_triggeringInsideLocalIpAddrStart > mappingInfo->tp_triggeringInsideLocalIpAddrEnd))
		{
			goto errout;
		}

		
		entry = triggerPort_entry_Hdr[netIntfId];

		while ( entry )
		{
			if (	(entry->netIntfId==netIntfId) &&
				(entry->outPortStart==mappingInfo->tp_outPortStart) &&
				(entry->outPortEnd==mappingInfo->tp_outPortEnd) &&
				(entry->outType==mappingInfo->tp_outType) &&
				(entry->triggeringInsideLocalIpAddrStart==mappingInfo->tp_triggeringInsideLocalIpAddrStart) &&
				(entry->triggeringInsideLocalIpAddrEnd==mappingInfo->tp_triggeringInsideLocalIpAddrEnd) &&
				(entry->inPortStart==inPortStart) &&
				(entry->inPortEnd==inPortEnd))
			{ 
				if (entry->inType != inType)
				{ 
					entry->inType = 2;
				}
				goto out;
			}
			entry = entry->next;
		}

		
		_GET_FROM_FREELIST(entry, triggerPort_entry_freeList);
		if ( entry==NULL )
		{
			goto errout;
		}

		entry->netIntfId						= netIntfId;
		entry->outType						= mappingInfo->tp_outType;
		entry->outPortStart					= mappingInfo->tp_outPortStart;
		entry->outPortEnd						= mappingInfo->tp_outPortEnd;
		entry->triggeringInsideLocalIpAddrStart	= mappingInfo->tp_triggeringInsideLocalIpAddrStart;
		entry->triggeringInsideLocalIpAddrEnd	= mappingInfo->tp_triggeringInsideLocalIpAddrEnd;
		entry->inType						= inType;
		entry->inPortStart						= inPortStart;
		entry->inPortEnd						= inPortEnd;
		entry->cacheAge						= mappingInfo->age;
		entry->normalCache					= NULL;

		_NORMAL_LINK(triggerPort_entry_Hdr[netIntfId], entry);
	}
out:
	#ifdef TRIGGER_PORT_DEBUG
	printk("\t===> OK\n");
	#endif

	return SUCCESS;
errout:

	#ifdef TRIGGER_PORT_DEBUG
	printk("\t===> FAILED\n");
	#endif

	return FAILED;
}

static inline int32 _rtl8651_checkUsableTriggeredPortEntry(uint32 isTcp, uint32 netIntfId, ipaddr_t intIp, uint32 extPort)
{
	_rtl8651_triggerPort_cache_t *cache, *candidate = NULL;
	uint32 hashTblIdx;

	#ifdef TRIGGER_PORT_DEBUG
	printk("Find Entry:\n\tisTcp: %s\n\tNetwork Interface: %d\n\tinternal IP: %u.%u.%u.%u\n\textPort: %d\n",
				isTcp?"TRUE":"FALSE",
				netIntfId,
				NIPQUAD(intIp),
				extPort);
	#endif

	for ( hashTblIdx = 0 ; hashTblIdx < RTL8651_TRIGGER_PORT_HASH_CACHE_TBLSIZE ; hashTblIdx ++ )
	{
		cache = triggerPort_cache_hashTbl[hashTblIdx];

		while ( cache )
		{
			if (	(cache->netIntfId == netIntfId) &&
				(cache->inPortStart<=extPort) &&
				(cache->inPortEnd>=extPort) &&
				(cache->inType==2 || (isTcp&&cache->inType==0) || ((!isTcp)&&cache->inType==1)))
			{
				if (cache->localIpAddr==intIp)
				{
					#ifdef TRIGGER_PORT_DEBUG
					printk("\t==> FOUND!\n");
					#endif
					return TRUE;
				}
				candidate = cache;
			}

			cache = cache->next;
		}
	}

	if (candidate)
	{
		#ifdef TRIGGER_PORT_DEBUG
		printk("\t==> Triggered by other host: %u.%u.%u.%u !\n", NIPQUAD(candidate->localIpAddr));
		#endif
		return FALSE;
	}

	#ifdef TRIGGER_PORT_DEBUG
	printk("\t==> NO TRIGGER PORT ENTRY ABOUT THIS EXT PORT !\n");
	#endif

	return TRUE;

}


static inline _rtl8651_triggerPort_cache_t *_rtl8651_getTriggerPortCache(uint8 refreshAge, uint8 isTcp, uint32 netIntfId, ipaddr_t extIp, uint16 extPort)
{
	_rtl8651_triggerPort_cache_t *cache;
	uint32 hash = TWO_ITEM_EASYHASH(netIntfId, extIp, RTL8651_TRIGGER_PORT_HASH_CACHE_TBLSIZE);

	#ifdef TRIGGER_PORT_DEBUG
	printk("Get Cache Entry:\n\tisTcp: %s\n\tNetwork Interface: %d\n\tExt IP: %u.%u.%u.%u\n\tExt Port: %d\n",
				isTcp?"TRUE":"FALSE",
				netIntfId,
				NIPQUAD(extIp),
				extPort);
	#endif

	
	cache = triggerPort_cache_hashTbl[hash];
	while ( cache )
	{
		if ( (cache->netIntfId==netIntfId) &&
		      (cache->ExternalIpAddr==extIp) &&
		      (cache->inPortStart<=extPort) &&
		      (cache->inPortEnd>=extPort) &&
		      (cache->inType==2||(isTcp&&cache->inType==0)||(!isTcp&&cache->inType==1)))
		{
			goto found;
		}
		cache = cache->next;
	}
	
	
	cache = triggerPort_cache_staticEntry;
	while ( cache )
	{
		if ( (cache->netIntfId==netIntfId) &&
		      (cache->inPortStart<=extPort) &&
		      (cache->inPortEnd>=extPort) &&
		      (cache->inType==2||(isTcp&&cache->inType==0)||(!isTcp&&cache->inType==1)))
		{
			goto found;
		}
		cache = cache->next;
	}

	#ifdef TRIGGER_PORT_DEBUG
	printk("\t==> NO CACHE FOUND !\n");
	#endif

	return NULL;

found:
	#ifdef TRIGGER_PORT_DEBUG
	printk("\t==> WE GOT IT !\n");
	#endif

	if (refreshAge == TRUE)
	{
		
		if (cache->isStatic == FALSE)
		{
			HTLIST_MOVE2TAIL(cache, lru_next, lru_prev, triggerPort_cache_lruHdr, triggerPort_cache_lruTail);
		}

		cache->age = cache->maxAge;
	}

	return cache;

}


static inline void _rtl8651_addTriggerPortCache(_rtl8651_triggerPort_entry_t *entry, ipaddr_t extIp, ipaddr_t localIpAddr)
{
	_rtl8651_triggerPort_cache_t *cache;
	uint32 hash = TWO_ITEM_EASYHASH((entry->netIntfId), extIp, RTL8651_TRIGGER_PORT_HASH_CACHE_TBLSIZE);

	#ifdef TRIGGER_PORT_DEBUG
	printk("Add Cache Entry:\n\tType: %s\n\tNetwork Interface: %d\n\tExt IP: %u.%u.%u.%u\n\tLocal IP Addr: %u.%u.%u.%u\n",
				(entry->inType==0)?"TCP":(entry->inType==1)?"UDP":(entry->inType==2)?"BOTH":"ERROR !",
				entry->netIntfId,
				NIPQUAD(extIp),
				NIPQUAD(localIpAddr));
	#endif

	
	cache = entry->normalCache;
	while ( cache )
	{
		if ( (cache->netIntfId==entry->netIntfId) &&
		      (cache->ExternalIpAddr==extIp) &&
		      (cache->inPortStart==entry->inPortStart) &&
		      (cache->inPortEnd>=entry->inPortEnd) &&
		      (cache->inType==entry->inType||cache->inType==2||entry->inType==2))
		{	

			#ifdef TRIGGER_PORT_DEBUG
			printk("\t==> UPDATE EXIST\n");
			#endif

			goto updateCache;
		}
		cache = cache->entryList_next;
	}

	
	if ( (cache = _rtl8651_TriggerPort_getCache()) == NULL )
	{	

		#ifdef TRIGGER_PORT_DEBUG
		printk("\t==> NO ENTRY\n");
		#endif

		return;
	}

	#ifdef TRIGGER_PORT_DEBUG
	printk("\t==> ADD NEW ENTRY\n");
	#endif

	_NORMAL_LINK(triggerPort_cache_hashTbl[hash], cache);
	_TRIGGERPORT_ENTRY_CACHE_LINK(entry, cache);

	cache->ExternalIpAddr = extIp;
	cache->netIntfId = entry->netIntfId;
	cache->inPortStart = entry->inPortStart;
	cache->inPortEnd = entry->inPortEnd;
	cache->inType = entry->inType;
	cache->isStatic = FALSE;					
updateCache:
	cache->localIpAddr = localIpAddr;
	cache->maxAge = cache->age = entry->cacheAge;

	
	HTLIST_MOVE2TAIL(cache, lru_next, lru_prev, triggerPort_cache_lruHdr, triggerPort_cache_lruTail);

	#ifdef TRIGGER_PORT_DEBUG
	printk("\t==> Local IP: %u.%u.%u.%u AGE: %d\n", NIPQUAD(localIpAddr), cache->age);
	#endif

}


static inline int32 _rtl8651_tryActiveTriggerPort(uint8 isTcp, uint32 netIntfId, uint16 outPort, ipaddr_t extIp, ipaddr_t localIpAddr)
{
	_rtl8651_triggerPort_entry_t *entry;

	#ifdef TRIGGER_PORT_DEBUG
	printk("Try to trigger:\n\tisTcp: %s\n\tNetwork Interface: %d\n\tOutPort: %d\n\tExternal IP: %u.%u.%u.%u\n\tLocal IP Addr: %u.%u.%u.%u\n",
			(isTcp)?"TRUE":"FALSE",
			netIntfId,
			outPort,
			NIPQUAD(extIp),
			NIPQUAD(localIpAddr));
	#endif

	entry = triggerPort_entry_Hdr[netIntfId];

	while ( entry )
	{
		#ifdef TRIGGER_PORT_DEBUG
		printk("\tEntry:\n");
		printk("\t\tNetwork Interface ID [%d] <--> %d\n", entry->netIntfId, netIntfId);
		printk("\t\tOutPort [%d - %d] <--> %d\n", entry->outPortStart, entry->outPortEnd, outPort);
		printk("\t\tSIP [%u.%u.%u.%u - %u.%u.%u.%u] <--> %u.%u.%u.%u\n", NIPQUAD(entry->triggeringInsideLocalIpAddrStart), NIPQUAD(entry->triggeringInsideLocalIpAddrEnd), NIPQUAD(localIpAddr));
		printk("\t\tType [%s] <--> %s\n",	(entry->outType==0)?"TCP":(entry->outType==1)?"UDP":(entry->outType==2)?"BOTH":"ERROR !",
										(isTcp==TRUE)?"TCP":"UDP");
		
		#endif


		if (	(entry->outPortStart<=outPort) &&
			(entry->outPortEnd>=outPort) &&
			(	(entry->triggeringInsideLocalIpAddrStart==0 && entry->triggeringInsideLocalIpAddrEnd==0)||
				(entry->triggeringInsideLocalIpAddrStart<=localIpAddr&&entry->triggeringInsideLocalIpAddrEnd>=localIpAddr)) &&
			((isTcp&&entry->outType==0)||((!isTcp)&&entry->outType==1)||(entry->outType==2)) &&
			(entry->netIntfId==netIntfId) )
		{

			#ifdef TRIGGER_PORT_DEBUG
			printk("\t==> Trigger Port Entry FOUND ! Trigger it!\n");
			#endif


			_rtl8651_addTriggerPortCache(entry, extIp, localIpAddr);
			return 1;
		}
		entry = entry->next;		
	}

	#ifdef TRIGGER_PORT_DEBUG
	printk("\t==> NO Trigger Port Entry for it!\n");
	#endif

	return 0;
}


static inline int32 _rtl8651_getTriggeredIpAddr(uint8 isTcp, uint32 netIntfId, ipaddr_t extIp, uint16 inPort, ipaddr_t *localIpAddrp)
{
	_rtl8651_triggerPort_cache_t *cache;

	#ifdef TRIGGER_PORT_DEBUG
	printk("Get to trigger cache:\n\tisTcp: %s\n\tNetwork Interface: %d\n\tExternal IP: %u.%u.%u.%u\n\tIncoming Port %d\n",
			isTcp?"TRUE":"FALSE",
			netIntfId,
			NIPQUAD(extIp),
			inPort);
	#endif

	cache = _rtl8651_getTriggerPortCache(TRUE, isTcp, netIntfId, extIp, inPort);
	if ( cache )
	{

		#ifdef TRIGGER_PORT_DEBUG
		printk("\t==> GET!! Local IP Addr: %u.%u.%u.%u\n", NIPQUAD(cache->localIpAddr));
		#endif

		*localIpAddrp = cache->localIpAddr;
		return SUCCESS;
	}
	return FAILED;
}


static void _rtl8651_TriggerPortTimeUpdate(uint32 secPassed)
{
	uint32 idx;
	_rtl8651_triggerPort_cache_t *cache;
	_rtl8651_triggerPort_cache_t *next;

	
	for ( idx=0;idx<RTL8651_TRIGGER_PORT_HASH_CACHE_TBLSIZE;idx++ )
	{
		cache = triggerPort_cache_hashTbl[idx];
		while( cache )
		{
			next = cache->next;

			if (cache->age == 0)
			{
				

			} else if (cache->age>secPassed )
			{
				cache->age -= secPassed;
			}else
			{
				#ifdef TRIGGER_PORT_DEBUG
				printk("Trigger Port flow DYNAMIC cache timeout:\n\tNetwork Interface %d\n\tType: %s\n\tPort: %d ~ %d\n\tLocal IP Addr: %u.%u.%u.%u\n",
							cache->netIntfId,
							(cache->inType==0)?"TCP":(cache->inType==1)?"UDP":(cache->inType==2)?"BOTH":"ERROR TYPE!",
							cache->inPortStart,
							cache->inPortEnd,
							NIPQUAD(cache->localIpAddr));
				#endif

				_rtl8651_TriggerPort_FreeCache(FALSE, cache);
			}
			cache = next;
		}
	}
	
	cache = triggerPort_cache_staticEntry;
	while ( cache )
	{
		next = cache->next;
		if (cache->age == 0)
		{
				

		} else if ( cache->age>secPassed )
		{
			cache->age -= secPassed;
		}else
		{
			#ifdef TRIGGER_PORT_DEBUG
			printk("Trigger Port flow STATIC cache timeout:\n\tNetwork Interface %d\n\tType: %s\n\tPort: %d ~ %d\n\tLocal IP Addr: %u.%u.%u.%u\n",
						cache->netIntfId,
						(cache->inType==0)?"TCP":(cache->inType==1)?"UDP":(cache->inType==2)?"BOTH":"ERROR !",
						cache->inPortStart,
						cache->inPortEnd,
						NIPQUAD(cache->localIpAddr));
			#endif

			_rtl8651_TriggerPort_FreeCache(TRUE, cache);
		}
		cache = next;
	}
}
#endif 

#ifdef _RTL_QUEUE_ARP_PACKET
#define RTL8651_ARP_QUEUE_FUNCTIONS

static int32 _rtl8651_queueInit(void){
	queue_packet_tb = (struct _RTL8651_QUEUE_PACKET_ENTRY *)rtlglue_malloc(QUEUE_PACKET_ITEM * sizeof (struct _RTL8651_QUEUE_PACKET_ENTRY));
	memset(queue_packet_tb,0,QUEUE_PACKET_ITEM * sizeof (struct _RTL8651_QUEUE_PACKET_ENTRY));	
	return SUCCESS;
}

static int32 _rtl8651_queueReinit(void){
	memset(queue_packet_tb,0,QUEUE_PACKET_ITEM * sizeof (struct _RTL8651_QUEUE_PACKET_ENTRY));	
	return SUCCESS;
}



static int32 _rtl8651_enQueuePacket(struct rtl_pktHdr * pkthdrPtr, struct ip* ip, ipaddr_t waitIp, uint8 type){
	int32 i;
	struct _RTL8651_QUEUE_PACKET_ENTRY *tb;	
	tb = queue_packet_tb;

#if 0
	
	for(i = 0 ; i < QUEUE_PACKET_ITEM ; i++){
		if(tb->q_time &&   
			tb->q_ip == ip ){
			return SUCCESS;
		}
		tb++;
	}
#endif
	
	tb = queue_packet_tb;	
	for(i = 0 ; i < QUEUE_PACKET_ITEM ; i++){
		if(tb->q_time== 0 && 
			tb->q_pkthdrPtr == NULL){
			   struct rtl_pktHdr *newPh=NULL;
			   struct rtl_mBuf  *newmb=NULL, *oldMbuf;
			   uint8 *newCluster, *newClusterData;
			   uint32 newClusterId;
			   int16 rxdesc;

			if (pkthdrPtr->ph_rxdesc<0)	
			{
				newPh = pkthdrPtr;
			}else
			{
				oldMbuf=pkthdrPtr->ph_mbuf;

				
				if((newmb = mBuf_get(MBUF_DONTWAIT,MBUFTYPE_DATA, 1)) == NULL){

					return FAILED;
				}
				if((mBuf_getPkthdr(newmb, MBUF_DONTWAIT) == (struct rtl_mBuf *) NULL)||
					(mBuf_reserve(newmb,rtl8651_fwdEnginePara.mbufHeadroom))){

					mBuf_freeMbufChain(newmb);
					return FAILED;
				}
				assert(newmb);
				newPh=newmb->m_pkthdr;
				newCluster=newmb->m_extbuf;
				newClusterData=newmb->m_data;
				newClusterId=newmb->m_extClusterId;
				assert(newPh);

				*newmb=*oldMbuf;
				newmb->m_next=NULL;
				newmb->m_pkthdr=newPh;

				rxdesc = newPh->ph_rxdesc;
				*newPh=*pkthdrPtr;
				newPh->ph_mbuf=newmb;
				newPh->ph_rxdesc=rxdesc;

				oldMbuf->m_extClusterId=newClusterId;
				oldMbuf->m_data=newClusterData;
				oldMbuf->m_extbuf=newCluster;
				oldMbuf->m_len=0;
				mBuf_freeMbufChain(oldMbuf);
			}

			tb->q_time=Q_TIME;
			tb->q_waitIp = waitIp;
			tb->q_type = type;
			tb->q_id = ntohs(ip->ip_id);
			tb->q_ip = ip;
			tb->q_pkthdrPtr = newPh;

			return SUCCESS;
		}
		tb++;
	}
	return FAILED;
}

static struct rtl_pktHdr * _rtl8651_queryQuenePacket(struct ip* ip, uint8 type, 
					uint32 *dst_ip,  struct ip **ipp){
	int32 i;
	struct rtl_pktHdr * pkt;
	struct _RTL8651_QUEUE_PACKET_ENTRY *tb;
	
	tb = queue_packet_tb;
	for(i = 0 ; i < QUEUE_PACKET_ITEM ; i++){
		if(tb->q_time && tb->q_type == type && tb->q_pkthdrPtr){					
			switch(type){
			case Q_ARP:
				if(memcmp(&tb->q_waitIp, &ip->ip_dst, 4) == 0 ){
					pkt = tb->q_pkthdrPtr;
					if(dst_ip)
					{
						*dst_ip = PKTGET_UINT32_UNALIGNED(&tb->q_ip->ip_dst);
					}
					if(ipp)
					{
						*ipp = tb->q_ip;
					}
					memset(tb,0,	sizeof(struct _RTL8651_QUEUE_PACKET_ENTRY));
					return pkt;
				}
				break;
			}			
		}
		tb++;
	}
	return NULL;	
}


static int32 _rtl8651_queuePacketSecondTimer(void){
	int32 i;
	struct rtl_pktHdr * pkt;
	struct _RTL8651_QUEUE_PACKET_ENTRY *tb;	
	tb = queue_packet_tb;	
	
	for(i = 0 ; i < QUEUE_PACKET_ITEM ; i++){
		if(tb->q_time)
			tb->q_time--;
		
		if(tb->q_time == 0 && tb->q_pkthdrPtr){		
			pkt = tb->q_pkthdrPtr;
			tb->q_pkthdrPtr = NULL;
			tb->q_type = 0;
			tb->q_id = 0;
			tb->q_ip = NULL;
			mBuf_freeMbufChain(pkt->ph_mbuf);	
		}		
		tb++;
	}
	
	return SUCCESS;	
}

#endif 

#define PPPOE_NOT_EXISTED_SESSION_TERMINATION

void _rtl8651_freeAllPppoeActiveSession(void) {
	_rtl8651_pppoeActiveSession_entry_t * tempPtr;
	while(pppoeActiveSessionHead) {
		tempPtr = pppoeActiveSessionHead;
		pppoeActiveSessionHead = pppoeActiveSessionHead->next;
		tempPtr->next = pppoeFreeActiveSession;
		pppoeFreeActiveSession = tempPtr;
	}
}

void _rtl8651_updatePppoeActiveSession(uint16 pppoeSessionId) {
	_rtl8651_pppoeActiveSession_entry_t * tempActivePppoeSessionPtr, * trackingActivePppoeSessionPtr, * removedActivePppoeSessionPtr=NULL;
	uint16 smallestKeepAlive;
	
	
	smallestKeepAlive = 0xFFFF;
	tempActivePppoeSessionPtr = pppoeActiveSessionHead;
	while (tempActivePppoeSessionPtr) {
		if(tempActivePppoeSessionPtr->keepAlive == 0) {
			if(tempActivePppoeSessionPtr == pppoeActiveSessionHead) {
				pppoeActiveSessionHead = pppoeActiveSessionHead->next;
				removedActivePppoeSessionPtr = tempActivePppoeSessionPtr;
				tempActivePppoeSessionPtr = tempActivePppoeSessionPtr->next;
			} else {
				trackingActivePppoeSessionPtr = pppoeActiveSessionHead;
				while(trackingActivePppoeSessionPtr->next) {
					if(trackingActivePppoeSessionPtr->next == tempActivePppoeSessionPtr) {
						trackingActivePppoeSessionPtr->next = trackingActivePppoeSessionPtr->next->next;
						removedActivePppoeSessionPtr = tempActivePppoeSessionPtr;
						tempActivePppoeSessionPtr = trackingActivePppoeSessionPtr->next;
						break;
					}
					trackingActivePppoeSessionPtr = trackingActivePppoeSessionPtr->next;
				}
				assert(removedActivePppoeSessionPtr);
			}						
			removedActivePppoeSessionPtr->next = pppoeFreeActiveSession;
			pppoeFreeActiveSession = removedActivePppoeSessionPtr;
		}
		else {
			tempActivePppoeSessionPtr->keepAlive--;
			if(smallestKeepAlive > tempActivePppoeSessionPtr->keepAlive)
				smallestKeepAlive = tempActivePppoeSessionPtr->keepAlive;
			tempActivePppoeSessionPtr = tempActivePppoeSessionPtr->next;
		}
	}
	
	tempActivePppoeSessionPtr = pppoeActiveSessionHead;
	while(tempActivePppoeSessionPtr) {
		if(tempActivePppoeSessionPtr->sessionId == pppoeSessionId)
			break;
		tempActivePppoeSessionPtr = tempActivePppoeSessionPtr->next;
	}
	if(tempActivePppoeSessionPtr == NULL) {
		if(pppoeFreeActiveSession) {
			tempActivePppoeSessionPtr = pppoeFreeActiveSession;
			pppoeFreeActiveSession = pppoeFreeActiveSession->next;
			tempActivePppoeSessionPtr->next = pppoeActiveSessionHead;
			pppoeActiveSessionHead = tempActivePppoeSessionPtr;
		}
		else {
			trackingActivePppoeSessionPtr = pppoeActiveSessionHead;
			while(trackingActivePppoeSessionPtr) {
				if(trackingActivePppoeSessionPtr->keepAlive == smallestKeepAlive) {
					tempActivePppoeSessionPtr = trackingActivePppoeSessionPtr;
					break;
				}
				trackingActivePppoeSessionPtr = trackingActivePppoeSessionPtr->next;
			}
		}
		tempActivePppoeSessionPtr->sessionId = pppoeSessionId;
	}
	tempActivePppoeSessionPtr->keepAlive = 0xFFFF;

}

void _rtl8651_terminatePppoeActiveSession(uint16 pppoeSessionId) {
	_rtl8651_pppoeActiveSession_entry_t * tempActivePppoeSessionPtr, * trackingActivePppoeSessionPtr;
	
	
	tempActivePppoeSessionPtr = pppoeActiveSessionHead;
	while(tempActivePppoeSessionPtr) {
		if(tempActivePppoeSessionPtr->sessionId == pppoeSessionId)
			break;
		tempActivePppoeSessionPtr = tempActivePppoeSessionPtr->next;
	}
	if(tempActivePppoeSessionPtr) {
		if(tempActivePppoeSessionPtr == pppoeActiveSessionHead) {
			pppoeActiveSessionHead = pppoeActiveSessionHead->next;
		} else {
			trackingActivePppoeSessionPtr = pppoeActiveSessionHead;
			while(trackingActivePppoeSessionPtr->next) {
				if(trackingActivePppoeSessionPtr->next == tempActivePppoeSessionPtr) {
					trackingActivePppoeSessionPtr->next = trackingActivePppoeSessionPtr->next->next;
					break;
				}
				trackingActivePppoeSessionPtr = trackingActivePppoeSessionPtr->next;
			}
		}						
		tempActivePppoeSessionPtr->next = pppoeFreeActiveSession;
		pppoeFreeActiveSession = tempActivePppoeSessionPtr;
	}
}


inline int32 _rtl8651_pppoeSessionActive(uint16 pppoeSessionId) {
	_rtl8651_pppoeActiveSession_entry_t * tempActivePppoeSessionPtr;
	
	tempActivePppoeSessionPtr = pppoeActiveSessionHead;
	while(tempActivePppoeSessionPtr) {
		if(tempActivePppoeSessionPtr->sessionId == pppoeSessionId)
			break;
		tempActivePppoeSessionPtr = tempActivePppoeSessionPtr->next;
	}
	if(tempActivePppoeSessionPtr)
		return TRUE;
	return FALSE;
}


uint16 * _rtl8651_getNextPppoeActiveSession(uint16 *curPppoeSessionId, uint16 * nextPppoeSessionId) {
	_rtl8651_pppoeActiveSession_entry_t * tempActivePppoeSessionPtr;
	
	if(nextPppoeSessionId == NULL)
		return NULL;
	if(curPppoeSessionId == NULL) {
		if(pppoeActiveSessionHead) {
			*nextPppoeSessionId = pppoeActiveSessionHead->sessionId;
			return nextPppoeSessionId;
		}
		return NULL;
	}

	tempActivePppoeSessionPtr = pppoeActiveSessionHead;
	while(tempActivePppoeSessionPtr) {
		if(tempActivePppoeSessionPtr->sessionId == *curPppoeSessionId) {
			if(tempActivePppoeSessionPtr->next) {
				*nextPppoeSessionId = tempActivePppoeSessionPtr->next->sessionId;
				return nextPppoeSessionId;
			}
			return NULL;
		}
		tempActivePppoeSessionPtr = tempActivePppoeSessionPtr->next;
	}
	return NULL; 
}

#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
#define RTL8651_FRAGMENT_SHORTESTPATH_FUNCTIONS

static inline void _rtl8651_fragmentShortestPathCacheSet_firstHalf(struct rtl_pktHdr *pkthdr, uint8*l4hdr, struct ip *pip, ipaddr_t sip, ipaddr_t dip, uint32 mode, ipaddr_t aliasIp)
{
	uint16 idx = ((sip+dip+htons(pip->ip_id))&(RTL8651_FRAGMENTSHORTESTPATH_TBLSIZE-1));

	
	pkthdr->ph_fragOffset = idx;

	
	
	#define DOS_L3_SHORSTESTPATHFORBID_LIST	RTL8651_DOS_IPSPOOF|RTL8651_DOS_TEARDROP
	
	#define DOS_TCP_SHORTESTPATHFORBID_SYN	RTL8651_DOS_SYNFLOOD|RTL8651_DOS_SRC_SYNFLOOD
	#define DOS_TCP_SHORTESTPATHFORBID_FIN	RTL8651_DOS_STEALTHFIN|RTL8651_DOS_SRC_STEALTHFIN
	
	#define DOS_UDP_SHORTESTPATHFORBID_LIST	RTL8651_DOS_UDPBOMB|RTL8651_DOS_UDPFLOOD|RTL8651_DOS_SRC_UDPFLOOD

	
	if ((_rtl8651_dos_enable == TRUE) && (_rtl8651_dosIgnoreTypeCheck(((mode==RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYSIP)?0:1)) == FALSE))
	{
		if (pip->ip_p == IPPROTO_UDP)
		{	
			if (_rtl8651_dos_sw[pkthdr->ph_dsid] & (DOS_L3_SHORSTESTPATHFORBID_LIST|DOS_UDP_SHORTESTPATHFORBID_LIST))
				return;
		}else
		{	
			struct tcphdr *tc;

			assert(pip->ip_p == IPPROTO_TCP);

			tc = (struct tcphdr *)l4hdr;
			if ((tc->th_flags & TH_SYN) && (_rtl8651_dos_sw[pkthdr->ph_dsid] & (DOS_L3_SHORSTESTPATHFORBID_LIST|DOS_TCP_SHORTESTPATHFORBID_SYN)))
			{
				return;
			}else if ((tc->th_flags & TH_FIN) && (_rtl8651_dos_sw[pkthdr->ph_dsid] & (DOS_L3_SHORSTESTPATHFORBID_LIST|DOS_TCP_SHORTESTPATHFORBID_FIN)))
			{
				return;
			}			
		}
	}
	
	if ((pip->ip_p == IPPROTO_UDP) && (_rtl8651_udpSizeThreshValue[pkthdr->ph_dsid] != 0xffff))
		return;

	
	if (IPHDRLEN_IS_TWENTY(pip))
	{
		_rtl8651_FragmentShortestPathFwdCache_t *cache;
		
		
		cache = &(fragmentShortestPathCache[idx]);

		cache->sip = sip;
		cache->dip = dip;
		cache->id = htons(pip->ip_id);
		cache->aliasIp = aliasIp;
		cache->mode = mode;
		cache->status = RTL8651_FRAGMENT_SHORTESTPATH_STATUS_HALFOK;
	}
}

inline void _rtl8651_fragmentShortestPathCacheSet_secondHalf(struct rtl_pktHdr *pkthdr, uint8 *m_data, struct ip*pip)
{
	if (IS_FRAGMENT(pip->ip_off) && (IPHDRLEN_IS_TWENTY(pip)))
	{
		_rtl8651_FragmentShortestPathFwdCache_t *cache;

		
		cache = &(fragmentShortestPathCache[(pkthdr->ph_fragOffset&(RTL8651_FRAGMENTSHORTESTPATH_TBLSIZE-1))]);

		if (cache->status == RTL8651_FRAGMENT_SHORTESTPATH_STATUS_HALFOK)
		{
			rtl8651_memcpy(&cache->dmac, (void*)m_data, 6);
			rtl8651_memcpy(&cache->smac, (void*)(m_data + 6), 6);
		
			cache->vlanIdx = pkthdr->ph_vlanIdx;
			cache->portList = pkthdr->ph_portlist;
			cache->pppoeIdx = pkthdr->ph_pppoeIdx;
			cache->extPortList = pkthdr->ph_extPortList;
			cache->srcExtPortNum = pkthdr->ph_srcExtPortNum;
			cache->flags = (pkthdr->ph_flags & 0x000f);
			cache->status = RTL8651_FRAGMENT_SHORTESTPATH_STATUS_SETOK;
			cache->age = RTL8651_FRAGMENT_SHORTESTPATH_TIMEOUT;		
		}
	}
}

inline void _rtl8651_fragmentShortestPathCache_clear(struct rtl_pktHdr *pkthdr, struct ip*pip)
{
	if (IS_FRAGMENT(pip->ip_off) && (IPHDRLEN_IS_TWENTY(pip)))
	{
		_rtl8651_FragmentShortestPathFwdCache_t *cache;

		
		cache = &(fragmentShortestPathCache[(pkthdr->ph_fragOffset&(RTL8651_FRAGMENTSHORTESTPATH_TBLSIZE-1))]);

		cache->status = 0;
	}
}

static void _rtl8651_fragmentShortestPathCache_timeUpdate(uint32 passed)
{
	_rtl8651_FragmentShortestPathFwdCache_t *ptr;
	uint32 idx;

	ptr = fragmentShortestPathCache;

	for (idx = 0 ; idx < RTL8651_FRAGMENTSHORTESTPATH_TBLSIZE; idx ++, ptr ++)
	{
		if (ptr->age == 0)
			continue;

		if (ptr->age > passed)
			ptr->age = (ptr->age - passed);
		else
		{
			ptr->age = 0;
			ptr->status = 0;
		}
	}
}

static inline int32 _rtl8651_fragmentShortestPathFwd(struct rtl_pktHdr*pkthdr, struct ip *pip)
{
	if (IS_FRAGMENT_REMAIN(pip->ip_off) && IPHDRLEN_IS_TWENTY(pip))
	{
		_rtl8651_FragmentShortestPathFwdCache_t *cache;
		ipaddr_t sip;
		ipaddr_t dip;
		uint16 id;

		sip = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
		dip = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);
		id = ntohs(pip->ip_id);

		
		cache = &(fragmentShortestPathCache[(sip+dip+id)&(RTL8651_FRAGMENTSHORTESTPATH_TBLSIZE-1)]);

		if ((cache->status != RTL8651_FRAGMENT_SHORTESTPATH_STATUS_SETOK) ||
			(sip != cache->sip) || (dip != cache->dip) || (id != cache->id))
			return FAILED;

		
		if (pkthdr->ph_pppeTagged)
		{
			mBuf_adjHead(pkthdr->ph_mbuf, 8);
			*((uint16 *)((uint32)pip - (uint32)2)) = htons(0x0800);
			pkthdr->ph_pppeTagged = 0;
		}
		
		if (cache->mode == RTL8651_FRAGMENT_SHORTESTPATH_MODE_MODIFYSIP)
		{
			PKTSET_UINT32_UNALIGNED(cache->aliasIp, &pip->ip_src);
		}else
		{
			PKTSET_UINT32_UNALIGNED(cache->aliasIp, &pip->ip_dst);
		}
		
		pip->ip_ttl --;
		
		rtl8651_memcpy((void *)((uint32)pip - (uint32)14), &cache->dmac, 6);
		rtl8651_memcpy((void *)((uint32)pip - (uint32)8), &cache->smac, 6);
		
		pkthdr->ph_proto = PKTHDR_IP;
		pkthdr->ph_portlist = cache->portList;
		pkthdr->ph_extPortList = cache->extPortList;
		pkthdr->ph_srcExtPortNum = cache->srcExtPortNum;
		pkthdr->ph_pppoeIdx = cache->pppoeIdx;
		pkthdr->ph_vlanIdx = cache->vlanIdx;
		pkthdr->ph_flags = ((pkthdr->ph_flags & 0xfff0) | cache->flags);

		rtlglue_drvSend((void*)pkthdr);
		return SUCCESS;
	}
	return FAILED;
}

#endif 




#if 0
void _modifyPPPoEPassthruVid( struct rtl_pktHdr * pkthdrPtr,
                              uint16 ethType, rtl8651_tblDrv_vlanTable_t *local_vlanp )
{
	if ( rtl8651_drvPppoePassthruEnable && 
	     ( ethType == 0x8863 || ethType == 0x8864 ) &&
	     local_vlanp->vid == rtl8651_gPPPoEPassthruVlanID )
	{
		ether_addr_t vlanGMAC;

		
		rtl8651_getVlanMacAddress( local_vlanp->vid, &vlanGMAC, NULL );

		
		if ( memcmp( pkthdrPtr->ph_mbuf->m_data, &vlanGMAC, sizeof(ether_addr_t) ) == 0 )
		{
			
			
			pkthdrPtr->ph_vlanIdx = rtl8651_gPPPoEExternalVlanIndex;
		}
	}
}
#endif 


#ifdef _RTL_NAPT_REDIRECT
#define RTL8651_NAPTREDIRECT_FUNCTIONS

#undef _RTL_NAPT_REDIRECT_DEBUG


static int32 _rtl8651_naptRedirectInit(rtl8651_fwdEngineInitPara_t *para)
{
	uint32 redirectTblSize;
	uint32 flowCacheSize;

	redirectTblSize = para->redirectTblSize;
	flowCacheSize = para->redirectFlowCacheSize;
	
	
	_rtl8651_naptRedirectEntry_inuse = NULL;
	_rtl8651_naptRedirectEntry_freelist = NULL;

	
	if (redirectTblSize)
	{
		uint32 idx;
		_rtl8651_naptRedirectEntry_t *ptr;
		
		_rtl8651_naptRedirectEntry_freelist = (_rtl8651_naptRedirectEntry_t *)rtlglue_malloc(redirectTblSize * sizeof(_rtl8651_naptRedirectEntry_t));

		if (!_rtl8651_naptRedirectEntry_freelist)
			return FAILED;

		
		memset(_rtl8651_naptRedirectEntry_freelist, 0, (redirectTblSize*sizeof(_rtl8651_naptRedirectEntry_t)));

		for (idx = 0, ptr = _rtl8651_naptRedirectEntry_freelist ; idx < redirectTblSize ; idx ++, ptr ++)
		{
			if (idx < (redirectTblSize - 1))
				ptr->next = ptr + 1;
		}
	}

	
	
	_rtl8651_naptRedirectFlowCache_lru_head = NULL;
	_rtl8651_naptRedirectFlowCache_lru_tail = NULL;
	_rtl8651_naptRedirectFlowCache_freelist = NULL;

	
	if (flowCacheSize)
	{
		uint32 idx;
		_rtl8651_naptRedirectFlow_t *ptr;

		_rtl8651_naptRedirectFlowCache_freelist = (_rtl8651_naptRedirectFlow_t *)rtlglue_malloc(flowCacheSize * sizeof(_rtl8651_naptRedirectFlow_t));

		if (!_rtl8651_naptRedirectFlowCache_freelist)
			return FAILED;

		
		memset(_rtl8651_naptRedirectFlowCache_freelist, 0, (flowCacheSize*sizeof(_rtl8651_naptRedirectFlow_t)));

		for (idx = 0 , ptr = _rtl8651_naptRedirectFlowCache_freelist ; idx < flowCacheSize ; idx ++, ptr ++)
		{
			if (idx < (flowCacheSize - 1))
				ptr->next = ptr + 1;
		}
	}

	return SUCCESS;
}

static void _rtl8651_naptRedirectReinit(void)
{
	
	{
		_rtl8651_naptRedirectEntry_t *ptr;

		while ((ptr = _rtl8651_naptRedirectEntry_inuse) != NULL)
		{
			
			_rtl8651_naptRedirectEntry_inuse = _rtl8651_naptRedirectEntry_inuse->next;
			
			ptr->next = _rtl8651_naptRedirectEntry_freelist;
			_rtl8651_naptRedirectEntry_freelist = ptr;
		}
	}

	
	{
		
		if (_rtl8651_naptRedirectFlowCache_lru_tail)
		{
			_rtl8651_naptRedirectFlowCache_lru_tail->next = _rtl8651_naptRedirectFlowCache_freelist;
		}

		if (_rtl8651_naptRedirectFlowCache_lru_head)
		{
			_rtl8651_naptRedirectFlowCache_freelist = _rtl8651_naptRedirectFlowCache_lru_head;
		}

		_rtl8651_naptRedirectFlowCache_lru_head = NULL;
		_rtl8651_naptRedirectFlowCache_lru_tail = NULL;
	}
}



static _rtl8651_naptRedirectEntry_t *_rtl8651_findExistNaptRedirectEntry(
	uint8	isExceptionList,
	uint8	isTcp,
	ipaddr_t	sip,
	uint16	sport,
	ipaddr_t	originalDip,
	uint16	originalDport)
{
	_rtl8651_naptRedirectEntry_t *ptr;

#ifdef _RTL_NAPT_REDIRECT_DEBUG
	rtlglue_printf("\n\tFind %s entry for %u.%u.%u.%u(%d) -> %u.%u.%u.%u(%d)\n", isExceptionList?"Exception":"Redirect", NIPQUAD(sip), sport, NIPQUAD(originalDip), originalDport);
#endif 


	ptr = _rtl8651_naptRedirectEntry_inuse;

	while (ptr)
	{
#ifdef _RTL_NAPT_REDIRECT_DEBUG
		rtlglue_printf("\n\tTry match %s rule:\t(%d) %u.%u.%u.%u:%d -> %u.%u.%u.%u:%d ** %u.%u.%u.%u:%d\n",
				(ptr->isExceptionList==TRUE)?"Exception":"Redirect",
				ptr->isTcp, NIPQUAD(ptr->sip), ptr->sport, NIPQUAD(ptr->dip), ptr->dport, NIPQUAD(ptr->newDip), ptr->newDport);
#endif 

		if (ptr->isExceptionList != isExceptionList)
			goto next;
		if (ptr->isTcp != isTcp)
			goto next;
		if (ptr->sip && sip && (ptr->sip != sip))
			goto next;
		if (ptr->sport && sport && (ptr->sport != sport))
			goto next;
		if (ptr->dip && originalDip && (ptr->dip != originalDip))
			goto next;
		if (ptr->dport && originalDport && (ptr->dport != originalDport))
			goto next;
		
		return ptr;
	next:
		ptr = ptr->next;
	}

	return NULL;
}

static inline int32 _rtl8651_findNaptRedirectEntry(
	uint8	isTcp,
	ipaddr_t	sip,
	uint16	sport,
	ipaddr_t	dip,
	uint16	dport,
	ipaddr_t	*pNewDip,
	uint16	*pNewDport,
	uint8	createCache,		
	uint16	vlanIdx			
)
{
	_rtl8651_naptRedirectEntry_t *ptr;

	assert(pNewDip);
	assert(pNewDport);

#ifdef _RTL_NAPT_REDIRECT_DEBUG
	rtlglue_printf("[%s]\tFlow -- (%d) %u.%u.%u.%u:%d -> %u.%u.%u.%u:%d\n",
			__FUNCTION__, isTcp, NIPQUAD(sip), sport, NIPQUAD(dip), dport);
#endif 

	if ((ptr = _rtl8651_findExistNaptRedirectEntry(TRUE, isTcp, sip, sport, dip, dport)) != NULL)
	{	
		return FAILED;
	} else if ((ptr = _rtl8651_findExistNaptRedirectEntry(FALSE, isTcp, sip, sport, dip, dport)) != NULL)
	{	
		ipaddr_t	newDip = 0;
		uint16 newDport = 0;

		if (ptr->newDport >= 0)
		{
			
			newDport = ptr->newDport;

			
			if (ptr->newDip == 0)
			{	
				rtl8651_tblDrv_vlanTable_t *inVlan;
				rtl8651_tblDrv_networkIntfTable_t *netif;

				inVlan = &DrvTbl.vlan[vlanIdx];
				if (!inVlan->valid)
					return FAILED;

				netif = _rtl8651_getNetworkIntfEntryByVid(inVlan->vid);

				switch (netif->linkLayerType)
				{
					case RTL8651_LL_VLAN:
					{
						rtl8651_tblDrv_ipIntfEntry_t * ipIntfPtr;
						rtl8651_tblDrv_ipIntfIpAddrEntry_t * ipAddrPtr;

						ipIntfPtr = SLIST_FIRST(&netif->IpHead);
						if (!ipIntfPtr)
							return FAILED;
						ipAddrPtr = SLIST_FIRST(&ipIntfPtr->ipAddr);
						if (!ipAddrPtr)
							return FAILED;
						newDip = ipAddrPtr->ipAddr;
					}
						break;
					case RTL8651_LL_PPPOE:
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
					case RTL8651_LL_PPTP:
					case RTL8651_LL_L2TP:
#endif 
					{
						rtl8651_tblDrvSession_t *sessionPtr;

						sessionPtr = CTAILQ_FIRST(&netif->sessionHead);
						if ((!sessionPtr) || (!sessionPtr->ip_t))
							return FAILED;
							newDip = sessionPtr->ip_t->ipAddr;
					}
						break;
					default:
						#ifdef RTL865X_DEBUG
						rtlglue_printf("%s[%d]ERROR: unknown l2 type: %d\n", __FUNCTION__, __LINE__, netif->linkLayerType);
						#endif
						break;
				}
			}else
			{	
				newDip = ptr->newDip;
			}
		}else
		{
			
			newDport = dport;
			
			newDip = dip;
		}
		
		if (createCache == TRUE)
		{
			if (_rtl8651_addNaptRedirectFlow(isTcp, sip, sport, dip, dport, newDip, newDport) != SUCCESS)
			{
				return FAILED;
			}
		}

		
		*pNewDip = newDip;
		*pNewDport = newDport;

		return SUCCESS;
	}

	
	return FAILED;
}


static inline _rtl8651_naptRedirectFlow_t *_rtl8651_findNaptRedirectFlow(
	uint8	isTcp,
	ipaddr_t	sip,
	uint16	sport,
	ipaddr_t	originalDip,
	uint16	originalDport,
	ipaddr_t	newDip,
	uint16	newDport,
	uint8	isExternalQuery,
	uint8	refresh
)
{
	_rtl8651_naptRedirectFlow_t *prev;
	_rtl8651_naptRedirectFlow_t *ptr;

	assert(sip);
	assert(newDip);

	prev = NULL;
	ptr = _rtl8651_naptRedirectFlowCache_lru_head;

	while (ptr)
	{
		if (	(isTcp == ptr->isTcp) &&
			(sip == ptr->sip) &&
			(sport == ptr->sport) &&
			(newDip == ptr->newDip) &&
			(newDport == ptr->newDport) &&
			(!originalDip || (originalDip == ptr->dip)) &&
			(!originalDip  || (originalDport == ptr->dport)))
		{
			goto found;
		}
		prev = ptr;
		ptr = ptr->next;
	}
	
	return NULL;
found:
	assert(ptr); 

	if (isExternalQuery)
	{	
		ptr->queryCnt ++;
	}

	if (refresh)
	{	
		ptr->queryCnt = 0;
		ptr->age = RTL8651_NAPTREDIRECT_CACHETIMEOUT;
		
		if (ptr != _rtl8651_naptRedirectFlowCache_lru_tail)
		{
			
			if (prev)
			{	
				prev->next = ptr->next;
			}else
			{	
				assert(ptr == _rtl8651_naptRedirectFlowCache_lru_head);
				_rtl8651_naptRedirectFlowCache_lru_head = _rtl8651_naptRedirectFlowCache_lru_head->next;
			}
			
			assert(_rtl8651_naptRedirectFlowCache_lru_tail);
			_rtl8651_naptRedirectFlowCache_lru_tail->next = ptr;
			ptr->next = NULL;
			_rtl8651_naptRedirectFlowCache_lru_tail = ptr;
		}
	}

	return ptr;
}


static inline int32 _rtl8651_addNaptRedirectFlow(
	uint8	isTcp,
	ipaddr_t	sip,
	uint16	sport,
	ipaddr_t	originalDip,
	uint16	originalDport,
	ipaddr_t	newDip,
	uint16	newDport
)
{
	_rtl8651_naptRedirectFlow_t *prev;
	_rtl8651_naptRedirectFlow_t *ptr;

	
	ptr = _rtl8651_findNaptRedirectFlow(isTcp, sip, sport, originalDip, originalDport, newDip, newDport, FALSE, TRUE);
	if (ptr)
	{
		return SUCCESS;
	}
	
	
		
	if (_rtl8651_naptRedirectFlowCache_freelist)
	{
		ptr = _rtl8651_naptRedirectFlowCache_freelist;
		_rtl8651_naptRedirectFlowCache_freelist = _rtl8651_naptRedirectFlowCache_freelist->next;
	}else
	{	

		
		prev = NULL;
		ptr = _rtl8651_naptRedirectFlowCache_lru_head;
		while (ptr)
		{
			if (ptr->queryCnt > 0)
			{	
				if (prev)
				{
					prev->next = ptr->next;
				}else
				{
					_rtl8651_naptRedirectFlowCache_lru_head = ptr->next;
				}

				if (ptr == _rtl8651_naptRedirectFlowCache_lru_tail)
				{
					_rtl8651_naptRedirectFlowCache_lru_tail = prev;
				}
				goto setNewCache;
			}
			prev = ptr;
			ptr = ptr->next;
		}

		
		if (!_rtl8651_naptRedirectFlowCache_lru_head)
			return FAILED;

		ptr = _rtl8651_naptRedirectFlowCache_lru_head;

		if (_rtl8651_naptRedirectFlowCache_lru_head == _rtl8651_naptRedirectFlowCache_lru_tail)
		{	
			_rtl8651_naptRedirectFlowCache_lru_head = NULL;
			_rtl8651_naptRedirectFlowCache_lru_tail = NULL;
		}else
		{
			_rtl8651_naptRedirectFlowCache_lru_head = _rtl8651_naptRedirectFlowCache_lru_head->next;
		}
	}


setNewCache:

	assert(ptr);

	ptr->isTcp		= isTcp;
	ptr->sip			= sip;
	ptr->sport		= sport;
	ptr->dip			= originalDip;
	ptr->dport		= originalDport;
	ptr->newDip		= newDip;
	ptr->newDport	= newDport;
	ptr->age			= RTL8651_NAPTREDIRECT_CACHETIMEOUT;
	ptr->queryCnt	= 0;
	ptr->next		= NULL;

	
	if (_rtl8651_naptRedirectFlowCache_lru_tail)
		_rtl8651_naptRedirectFlowCache_lru_tail->next = ptr;
	_rtl8651_naptRedirectFlowCache_lru_tail = ptr;
	if (_rtl8651_naptRedirectFlowCache_lru_head == NULL)
		_rtl8651_naptRedirectFlowCache_lru_head = ptr;

	return SUCCESS;
}

static void _rtl8651_naptRedirectFlowTimeUpdate(uint32 secPassed)
{
	_rtl8651_naptRedirectFlow_t *ptr;

	ptr = _rtl8651_naptRedirectFlowCache_lru_head;

	while (ptr)
	{
		if (ptr->age > secPassed)
		{
			ptr->age -= secPassed;
			ptr = ptr->next;
		}else
		{
			
			assert(_rtl8651_naptRedirectFlowCache_lru_head == ptr);

			
			_rtl8651_naptRedirectFlowCache_lru_head = _rtl8651_naptRedirectFlowCache_lru_head->next;
			if (_rtl8651_naptRedirectFlowCache_lru_tail == ptr)
				_rtl8651_naptRedirectFlowCache_lru_tail = NULL;
			
			ptr->next = _rtl8651_naptRedirectFlowCache_freelist;
			_rtl8651_naptRedirectFlowCache_freelist = ptr;

			
			ptr = _rtl8651_naptRedirectFlowCache_lru_head;
		}
	}
}


int32 rtl8651_registerRedirectOutboundNaptFlow(
		uint8	isTcp,			
		ipaddr_t	sip,				
		uint16	sport,			
		ipaddr_t	originalDip,		
		uint16	originalDport,	
		ipaddr_t	newDip,			
		int32	newDport		
)
{
	int32 retval = FAILED;

	rtlglue_drvMutexLock();

	
	if (_rtl8651_findExistNaptRedirectEntry(FALSE, isTcp, sip, sport, originalDip, originalDport))
		goto out;
	
	if (newDport == 0)
		goto out;
	
	{
		_rtl8651_naptRedirectEntry_t *ptr;

		if (_rtl8651_naptRedirectEntry_freelist == NULL)
			goto out;

		ptr = _rtl8651_naptRedirectEntry_freelist;
		_rtl8651_naptRedirectEntry_freelist = _rtl8651_naptRedirectEntry_freelist->next;

		ptr->isExceptionList	= FALSE;
		ptr->isTcp			= isTcp;
		ptr->sip				= sip;
		ptr->sport			= sport;
		ptr->dip				= originalDip;
		ptr->dport			= originalDport;
		ptr->newDip			= newDip;
		ptr->newDport		= newDport;

		ptr->next = _rtl8651_naptRedirectEntry_inuse;
		_rtl8651_naptRedirectEntry_inuse = ptr;
	}
	retval = SUCCESS;

out:
	rtlglue_drvMutexUnlock();
	return retval;
}

int32 rtl8651_unregisterRedirectOutboundNaptFlow(
		uint8	isTcp,			
		ipaddr_t	sip,				
		uint16	sport,			
		ipaddr_t	originalDip,		
		uint16	originalDport,	
		ipaddr_t	newDip,			
		int32	newDport		
)
{
	
	_rtl8651_naptRedirectEntry_t *prev;
	_rtl8651_naptRedirectEntry_t *ptr;
	uint32 removeCnt;

	rtlglue_drvMutexLock();

	prev = NULL;
	ptr = _rtl8651_naptRedirectEntry_inuse;
	removeCnt = 0;

	while (ptr)
	{
		if (	(ptr->isExceptionList == FALSE) &&
			(isTcp == ptr->isTcp) &&
			(!sip || (sip == ptr->sip)) &&
			(!sport || (sport == ptr->sport)) &&
			(!originalDip || (originalDip == ptr->dip)) &&
			(!originalDport || (originalDport == ptr->dport)) &&
			(!newDip || (newDip == ptr->newDip)) &&
			(!newDport || (newDport == ptr->newDport)))
		{
			
			if (prev)
			{	
				prev->next = ptr->next;
			}else
			{	
				_rtl8651_naptRedirectEntry_inuse = ptr->next;
			}
			ptr->next = _rtl8651_naptRedirectEntry_freelist;
			_rtl8651_naptRedirectEntry_freelist = ptr;

			removeCnt ++;	
			
			if (prev)
			{	
				ptr = prev->next;
			}else
			{
				ptr = _rtl8651_naptRedirectEntry_inuse;
			}
		}else
		{
			prev = ptr;
			ptr = ptr->next;
		}
	}

	
	rtlglue_drvMutexUnlock();
	return removeCnt;
}

int32 rtl8651_queryRedirectOutboundNaptFlow(
		uint8	isTcp,
		ipaddr_t	sip,
		uint16	sport,
		ipaddr_t	*pOriginalDip,
		uint16	*pOriginalDport,
		ipaddr_t	newDip,
		uint16	newDport
)
{
	int32 retval = FAILED;
	rtlglue_drvMutexLock();
	retval = _rtl8651_queryRedirectOutboundNaptFlow(	isTcp,
													sip, sport,
													pOriginalDip, pOriginalDport,
													newDip, newDport);
	rtlglue_drvMutexUnlock();
	return retval;
}

static inline int32 _rtl8651_queryRedirectOutboundNaptFlow(
		uint8	isTcp,
		ipaddr_t	sip,
		uint16	sport,
		ipaddr_t	*pOriginalDip,
		uint16	*pOriginalDport,
		ipaddr_t	newDip,
		uint16	newDport
)
{
	_rtl8651_naptRedirectFlow_t *ptr;

	
	assert(pOriginalDip);
	assert(pOriginalDport);

	ptr = _rtl8651_findNaptRedirectFlow(isTcp, sip, sport, 0, 0, newDip, newDport, TRUE, FALSE);

	if (ptr)
	{
		*pOriginalDip = ptr->dip;
		*pOriginalDport = ptr->dport;

		return SUCCESS;
	}
	return FAILED;
}


int32 _rtl8651_resolveProxyInboundFlow(rtl8651_tblDrv_vlanTable_t *dvlan, struct ip *pip)
{
	struct tcphdr *tc = NULL;
	struct udphdr *ud = NULL;
	uint8 isTcp = FALSE;
	ipaddr_t sip = 0;
	ipaddr_t dip = 0;
	uint16 sport = 0;
	uint16 dport = 0;
	
	ipaddr_t newSip = 0;
	uint16 newSport = 0;

	
	if (!(dvlan->internal))
		goto out;

	
	if (IS_FRAGMENT_REMAIN(pip->ip_off))
	{
		if ((pip->ip_p == IPPROTO_TCP) || (pip->ip_p == IPPROTO_UDP))
		{
			sip = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
			dip = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);

			if (_rtl8651_getFragCache(NAPT_REDIRECT_FRAG_INBOUND, sip, dip, ntohs(pip->ip_id), &newSip, NULL, NULL, NULL) == SUCCESS)
			{	
				
				PKTSET_UINT32_UNALIGNED(newSip, &pip->ip_src);
				
				_RTL8651_L3_ADJUST_CHECKSUM(newSip, sip, pip->ip_sum);
			}
		}
		goto out;
	}

	
	switch (pip->ip_p)
	{
		case IPPROTO_TCP:
			isTcp = TRUE;
			tc = (struct tcphdr *) L4HDR_ADDR(pip);
			sport = ntohs(tc->th_sport);
			dport = ntohs(tc->th_dport);
			break;
		case IPPROTO_UDP:
			isTcp = FALSE;
			ud = (struct udphdr *) L4HDR_ADDR(pip);
			sport = ntohs(ud->uh_sport);
			dport= ntohs(ud->uh_dport);
			break;
		default:
			goto out;
	}

	sip = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
	dip = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);

	
	if (_rtl8651_queryRedirectOutboundNaptFlow(isTcp, dip, dport, &newSip, &newSport, sip, sport) != SUCCESS)
		goto out;

	
	{
		uint16 *l4cksum;
	
		assert(newSip);

		
		PKTSET_UINT32_UNALIGNED(newSip, &pip->ip_src);
		if (isTcp == TRUE)
		{
			l4cksum = &(tc->th_sum);
			tc->th_sport = htons(newSport);
		}else
		{
			l4cksum = &(ud->uh_sum);
			ud->uh_sport = htons(newSport);
		}

		
		if ((isTcp != FALSE) || (*l4cksum))
			_RTL8651_L4_ADJUST_CHECKSUM(newSip, sip, newSport, sport, *l4cksum);
		_RTL8651_L3_ADJUST_CHECKSUM(newSip, sip, pip->ip_sum);

		
		_rtl8651_updateFragCache(NAPT_REDIRECT_FRAG_INBOUND, sip, dip, ntohs(pip->ip_id), newSip, 0, NULL, 0);
	}
out:	
	return SUCCESS;
}


int32 rtl8651_registerRedirectOutboundNaptExceptionList(
		uint8	isTcp,			
		ipaddr_t	sip,				
		uint16	sport,			
		ipaddr_t	dip,				
		uint16	dport			
)
{
	int32 retval = FAILED;

	rtlglue_drvMutexLock();
	
	if (_rtl8651_findExistNaptRedirectEntry(TRUE, isTcp, sip, sport, dip, dport))
		goto out;
	
	{
		_rtl8651_naptRedirectEntry_t *ptr;

		if (_rtl8651_naptRedirectEntry_freelist == NULL)
			goto out;

		ptr = _rtl8651_naptRedirectEntry_freelist;
		_rtl8651_naptRedirectEntry_freelist = _rtl8651_naptRedirectEntry_freelist->next;

		ptr->isExceptionList	= TRUE;
		ptr->isTcp			= isTcp;
		ptr->sip				= sip;
		ptr->sport			= sport;
		ptr->dip				= dip;
		ptr->dport			= dport;
		ptr->newDip			= 0;
		ptr->newDport		= 0;

		ptr->next = _rtl8651_naptRedirectEntry_inuse;
		_rtl8651_naptRedirectEntry_inuse = ptr;
	}
	retval = SUCCESS;

out:
	rtlglue_drvMutexUnlock();
	return retval;
}

int32 rtl8651_unregisterRedirectOutboundNaptExceptionList(
		uint8	isTcp,			
		ipaddr_t	sip,				
		uint16	sport,			
		ipaddr_t	dip,				
		uint16	dport			
)
{
	
	_rtl8651_naptRedirectEntry_t *prev;
	_rtl8651_naptRedirectEntry_t *ptr;
	uint32 removeCnt;

	rtlglue_drvMutexLock();

	prev = NULL;
	ptr = _rtl8651_naptRedirectEntry_inuse;
	removeCnt = 0;

	while (ptr)
	{
		if (	(ptr->isExceptionList == TRUE) &&
			(isTcp == ptr->isTcp) &&
			(!sip || (sip == ptr->sip)) &&
			(!sport || (sport == ptr->sport)) &&
			(!dip || (dip == ptr->dip)) &&
			(!dport || (dport == ptr->dport)))
		{
			
			if (prev)
			{	
				prev->next = ptr->next;
			}else
			{	
				_rtl8651_naptRedirectEntry_inuse = ptr->next;
			}
			ptr->next = _rtl8651_naptRedirectEntry_freelist;
			_rtl8651_naptRedirectEntry_freelist = ptr;

			removeCnt ++;	
			
			if (prev)
			{	
				ptr = prev->next;
			}else
			{
				ptr = _rtl8651_naptRedirectEntry_inuse;
			}
		}else
		{
			prev = ptr;
			ptr = ptr->next;
		}
	}

	

	rtlglue_drvMutexUnlock();

	return removeCnt;
}

#endif 

#ifdef _RTL_PPTPL2TP_HDR_REFILL
#define RTL8651_PPTPL2TP_HEADER_REFILL_FUNCTIONS
static int32 _rtl8651_pptpHdrCacheInit(rtl8651_fwdEngineInitPara_t *para)
{
	uint32 cnt;

	cnt = para->pptpHdrCacheSize;

	
	memset(_rtl8651_pptpHdrCache_hashTbl, 0, sizeof(_rtl8651_pptpHdrCache_hashTbl));
	_rtl8651_pptpHdrCache_lru_head = NULL;
	_rtl8651_pptpHdrCache_lru_tail = NULL;
	_rtl8651_pptpHdrCache_unused = NULL;

	
	if (cnt)
	{
		uint32 idx;
		_rtl8651_pptpHdrCacheEntry_t *ptr;

		_rtl8651_pptpHdrCache_unused = (_rtl8651_pptpHdrCacheEntry_t*)rtlglue_malloc(cnt * sizeof(_rtl8651_pptpHdrCacheEntry_t));

		if (_rtl8651_pptpHdrCache_unused == NULL)
			return FAILED;

		
		memset(_rtl8651_pptpHdrCache_unused, 0, (cnt * sizeof(_rtl8651_pptpHdrCacheEntry_t)));

		ptr = _rtl8651_pptpHdrCache_unused;
		for (idx = 0 ; idx < (cnt-1) ; idx ++, ptr ++)
		{
			ptr->next = ptr + 1;
		}
	}

	return SUCCESS;
}

static void _rtl8651_pptpHdrCacheReinit(void)
{
	
	while (_rtl8651_pptpHdrCache_lru_head)
	{	
		_rtl8651_pptpHdrCache_Del(_rtl8651_pptpHdrCache_lru_head);
	}
}


void _rtl8651_pptpHdrCache_Add(uint16 ip_id, uint16 ip_off, uint32 seq, uint32 ack, uint8 type)
{
	uint32 hashIdx = RTL8651_IP_ID_EASYHASH(0, (uint32)ip_off, ip_id, RTL8651_PPTPHDR_CACHE_HASH_TBLSIZE);
	_rtl8651_pptpHdrCacheEntry_t **pHashTbl;
	_rtl8651_pptpHdrCacheEntry_t *ptr;

	
	if (_rtl8651_pptpHdrCache_unused)
	{	
fromUnused:
		ptr = _rtl8651_pptpHdrCache_unused;
		_rtl8651_pptpHdrCache_unused = _rtl8651_pptpHdrCache_unused->next;
	}else if (_rtl8651_pptpHdrCache_lru_head)	
	{
		_rtl8651_pptpHdrCache_Del(_rtl8651_pptpHdrCache_lru_head);
		assert(_rtl8651_pptpHdrCache_unused);
		goto fromUnused;
	}else
		goto out;	
	
	ptr->hdr = NULL;
	ptr->next = NULL;
	ptr->prev = NULL;
	ptr->lru_next = NULL;
	ptr->lru_prev = NULL;


	
	ptr->id		= ip_id;
	ptr->offset	= ip_off;
	ptr->seq		= seq;
	ptr->ack		= ack;
	ptr->type	= type;
	
	pHashTbl		= &(_rtl8651_pptpHdrCache_hashTbl[hashIdx]);
	ptr->hdr		= pHashTbl;
	ptr->prev	= NULL;
	ptr->next	= *pHashTbl;
	if (*pHashTbl)
		(*pHashTbl)->prev = ptr;
	*pHashTbl = ptr;
	
	if (_rtl8651_pptpHdrCache_lru_tail)
	{	
		ptr->lru_next = NULL;
		ptr->lru_prev = _rtl8651_pptpHdrCache_lru_tail;
		_rtl8651_pptpHdrCache_lru_tail->lru_next = ptr;
		_rtl8651_pptpHdrCache_lru_tail = ptr;
	}else
	{	
		ptr->lru_next = NULL;
		ptr->lru_prev = NULL;
		_rtl8651_pptpHdrCache_lru_head = ptr;
		_rtl8651_pptpHdrCache_lru_tail = ptr;
	}
out:
	return;
}


static void _rtl8651_pptpHdrCache_Del(_rtl8651_pptpHdrCacheEntry_t *ptr)
{
	_rtl8651_pptpHdrCacheEntry_t **hashTbl;
	
	assert(ptr->hdr);
	hashTbl = ptr->hdr;
	if (*hashTbl == ptr)
	{	
		assert(ptr->prev == NULL);
		*hashTbl = ptr->next;
		if (ptr->next)
			ptr->next->prev = NULL;
	}else
	{	
		assert(ptr->prev);
		ptr->prev->next = ptr->next;
		if (ptr->next)
			ptr->next->prev = ptr->prev;
	}
	ptr->hdr = NULL;
	ptr->prev = NULL;
	ptr->next = NULL;

	
	if (ptr->lru_prev)
	{	
		ptr->lru_prev->lru_next = ptr->lru_next;
	}else
	{	
		_rtl8651_pptpHdrCache_lru_head = ptr->lru_next;
	}
	if (ptr->lru_next)
	{	
		ptr->lru_next->lru_prev = ptr->lru_prev;
	}else
	{	
		_rtl8651_pptpHdrCache_lru_tail = ptr->lru_prev;
	}
	ptr->lru_prev = NULL;
	ptr->lru_next = NULL;
	
	ptr->next = _rtl8651_pptpHdrCache_unused;
	_rtl8651_pptpHdrCache_unused = ptr;
}


static inline int32 _rtl8651_pptpHdrCache_Find(uint16 ip_id, uint16 ip_off, uint32 *pSeq, uint32 *pAck, uint8 *pType)
{
	uint32 hashIdx = RTL8651_IP_ID_EASYHASH(0, (uint32)ip_off, ip_id, RTL8651_PPTPHDR_CACHE_HASH_TBLSIZE);
	_rtl8651_pptpHdrCacheEntry_t *ptr;

	assert(pSeq && pAck && pType);

	ptr = _rtl8651_pptpHdrCache_hashTbl[hashIdx];
	while (ptr)
	{
		if ((ptr->id == ip_id) && (ptr->offset == ip_off))
		{	
			*pSeq = ptr->seq;
			*pAck = ptr->ack;
			*pType = ptr->type;
			_rtl8651_pptpHdrCache_Del(ptr);
			return SUCCESS;
		}
		ptr = ptr->next;
	}
	return FAILED;
}


static inline int32 _rtl8651_refillHeader(int32 result, struct rtl_pktHdr *pkt, struct ip*pktip, rtl8651_tblDrv_vlanTable_t *svlan, uint16 srcPortList)
{
	uint8 wanType;
	rtl8651_tblDrv_routeTable_t *rt_t;
	rtl8651_tblDrv_pppTable_t *pppEntry_t;
	struct rtl_mBuf *mbuf;
	uint8 *data;
	struct rtl_pktHdr * pkthdr;
	struct ip*pip;

	pkthdr = pkt;
	pip = pktip;

	
	if (tunnel.valid != TRUE)
		goto out;

	if ((svlan->vid != tunnel.loopBackVid) || (srcPortList != tunnel.loopbackPort))
		goto out;

	
	wanType = 0;
	rt_t = DrvTbl.route + (rtl8651_tblDrvPara.routingTableSize - 1);
	if ((rt_t->valid == FALSE) || (rt_t->ifrt_flag != FALSE))
		goto out;

	pppEntry_t = rt_t->rt_nhSession_t;
	
	if ((!pppEntry_t) || (!pppEntry_t->initiated))
		goto out;
	if (rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP)
	{
		wanType = RTL8651_LL_PPTP;
	} else if (rt_t->netif_t->linkLayerType == RTL8651_LL_L2TP)
	{
		wanType = RTL8651_LL_L2TP;
	}else
	{	
		goto out;
	}
	
	while (pkthdr)
	{
		mbuf = pkthdr->ph_mbuf;
		data = mbuf->m_data;

		assert(pppEntry_t->macInfo);

		if (memcmp(data+6, &(pppEntry_t->macInfo->macAddr.octet), 6))
			goto out;

		
		pkthdr->ph_vlanIdx = rtl8651_vlanTableIndex(tunnel.wanVid);
		pkthdr->ph_portlist = tunnel.wanPort;


		if (wanType == RTL8651_LL_PPTP)
		{	
			if ((pppEntry_t->greBuf2_ == NULL) || (pppEntry_t->greOffset2_ == 0))
				goto out;
			if (((uint32)data - (uint32)(mbuf->m_extbuf)) >= pppEntry_t->greOffset2_)
			{
				uint16 pipLen;
				struct ip *ipBuf;
#ifndef RTL8651_VPNCOMPRESS_UNALIGNHANDLE
				struct ip *ipHdr;
#endif 
				struct wan_gre_header *greBuf;
				struct wan_gre_header *greHdr;
				uint16 pipId;
				uint16 pipOff;
				uint32 gre_seq;
				uint32 gre_ack;
				uint8 gre_type;
				int16 offset;
				uint8 *remain;
				int16 remainLen;
				uint8 *hdrRemain;

				
				pipId = ntohs(pip->ip_id);
				pipOff = ntohs(pip->ip_off);
				if (_rtl8651_pptpHdrCache_Find(pipId, pipOff, &gre_seq, &gre_ack, &gre_type) != SUCCESS)
				{	
					assert(0);
					gre_seq = 0;
					gre_ack = 0;
					gre_type = 0;
				}
				
				

				assert(((uint32)pip - (uint32)data) == 14);

				
				pipLen = ntohs(pip->ip_len);
				ipBuf = (struct ip *)(pppEntry_t->greBuf2_);
				greBuf = (struct wan_gre_header *)L4HDR_ADDR(ipBuf);
				remain = (uint8 *)((uint32)greBuf + sizeof(struct wan_gre_header));

				
				ipBuf->ip_id = htons(ntohs(ipBuf->ip_id) + 1);
				ipBuf->ip_off = htons(ntohs(ipBuf->ip_off) & ~(IP_OFFMASK));

				
				if (!(greBuf->flags & 0x10))	
				{
					remain -= 4;
				}
				if (!(greBuf->ver& 0x80))	
				{
					remain -= 4;
				}

				remainLen = pppEntry_t->greOffset2_ - ((uint32)remain - (uint32)ipBuf);

				
				offset = IPHDR_LEN(ipBuf) + sizeof(struct wan_gre_header) + remainLen;
				if (!(gre_type & RTL8651_PPTPHDR_SEQ_SET))
				{
					offset -= 4;
				}
				if (!(gre_type & RTL8651_PPTPHDR_ACK_SET))
				{
					offset -= 4;
				}

				
				ipBuf->ip_len = htons(offset + pipLen);
				greBuf->payload_len = htons(remainLen + pipLen);

				
				pkthdr->ph_len += offset;
				mbuf->m_len += offset;
				mbuf->m_data -= offset;

				
				data = mbuf->m_data;	

#ifdef RTL8651_VPNCOMPRESS_UNALIGNHANDLE
				
				ipBuf->ip_sum = 0;
				ipBuf->ip_sum = htons(_rtl8651_ipChecksum(ipBuf));

				
				
				rtl8651_memcpy(data + 14, pppEntry_t->greBuf2_, (IPHDR_LEN(ipBuf) + (sizeof(struct wan_gre_header) - 8)));

				greHdr = (struct wan_gre_header *)(data+14+IPHDR_LEN(ipBuf));	
				hdrRemain = (uint8*)greHdr + (sizeof(struct wan_gre_header) - 8);

				if (gre_type & RTL8651_PPTPHDR_SEQ_SET)
				{
					greHdr->flags |= 0x10;
					PKTSET_UINT32_UNALIGNED(gre_seq, &greHdr->seq);	
					hdrRemain += 4;
				}else
				{
					greHdr->flags &= ~(0x10);
				}
				if (gre_type & RTL8651_PPTPHDR_ACK_SET)
				{
					greHdr->ver |= 0x80;
					if (gre_type & RTL8651_PPTPHDR_SEQ_SET)
					{	
						PKTSET_UINT32_UNALIGNED(htonl(gre_ack - pppEntry_t->delta_), &greHdr->ack);	
					}else
					{	
						PKTSET_UINT32_UNALIGNED(htonl(gre_ack - pppEntry_t->delta_), &greHdr->seq);	
					}
					hdrRemain += 4;
				}else
				{
					greHdr->ver &= ~(0x80);
				}
				
				rtl8651_memcpy(hdrRemain, remain, remainLen);

#else	

				
				
				rtl8651_memcpy(data + 14, pppEntry_t->greBuf2_, (IPHDR_LEN(ipBuf) + (sizeof(struct wan_gre_header) - 8)));

				ipHdr = (struct ip*)((uint32)data + 14);
				greHdr = (struct wan_gre_header *)L4HDR_ADDR(ipHdr);
				hdrRemain = (uint8*)greHdr + (sizeof(struct wan_gre_header) - 8);
				if (gre_type & RTL8651_PPTPHDR_SEQ_SET)
				{
					greHdr->flags |= 0x10;
					PKTSET_UINT32_UNALIGNED(gre_seq, &(greHdr->seq));
					hdrRemain += 4;
				}else
				{
					greHdr->flags &= ~(0x10);
				}
				if (gre_type & RTL8651_PPTPHDR_ACK_SET)
				{
					greHdr->ver |= 0x80;
					if (gre_type & RTL8651_PPTPHDR_SEQ_SET)
					{	
						PKTSET_UINT32_UNALIGNED(htonl(gre_ack - pppEntry_t->delta_), &(greHdr->ack));
					}else
					{	
						PKTSET_UINT32_UNALIGNED(htonl(gre_ack - pppEntry_t->delta_), &(greHdr->seq));
					}
					hdrRemain += 4;
				}else
				{
					greHdr->ver &= ~(0x80);
				}
				
				rtl8651_memcpy(hdrRemain, remain, remainLen);

#endif	


				
				rtl8651_memcpy(data, &(svlan->macAddr), 6);	
				rtl8651_memcpy(data + 6, &(pppEntry_t->macInfo->macAddr), 6);	
				*(uint16*)((uint32)data + 12) = htons(0x0800);
#ifndef RTL8651_VPNCOMPRESS_UNALIGNHANDLE
				
				ipHdr->ip_sum = 0;
				ipHdr->ip_sum = htons(_rtl8651_ipChecksum(ipHdr));
#endif	
			}
		}else
		{	
			if ((pppEntry_t->l2tpBuf2_ == NULL) || (pppEntry_t->l2tpOffset2_ == 0))
				goto out;
			if (((uint32)data - (uint32)(mbuf->m_extbuf)) >= pppEntry_t->l2tpOffset2_)
			{
				uint16 pipLen;
				struct ip *ipBuf;
				struct udphdr *udpBuf;

				
				

				
				pipLen = ntohs(pip->ip_len);
				ipBuf = (struct ip *)(pppEntry_t->l2tpBuf2_);
				udpBuf = (struct udphdr*)L4HDR_ADDR(ipBuf);

				ipBuf->ip_id = htons(ntohs(ipBuf->ip_id) + 1);
				ipBuf->ip_off = htons(ntohs(ipBuf->ip_off) & ~(IP_OFFMASK));

				ipBuf->ip_len = htons(pipLen + pppEntry_t->l2tpOffset2_);
				udpBuf->uh_ulen = htons(pipLen + pppEntry_t->l2tpOffset2_ - IPHDR_LEN(ipBuf));

				
				if (*(uint8 *)((uint32)udpBuf + sizeof(struct udphdr)) & 0x40)	
				{
					uint16 *pLen = (uint16 *)((uint32)udpBuf + sizeof(struct udphdr) + 2);
					if ((pppEntry_t->l2tpBuf2_[pppEntry_t->l2tpOffset2_ - 2] == 0) &&
						(pppEntry_t->l2tpBuf2_[pppEntry_t->l2tpOffset2_ - 3] == 3))
					{	
						*pLen = htons(pipLen + 12);	
					}else
					{	
						*pLen = htons(pipLen + 9);		
					}
				}

				assert(((uint32)pip - (uint32)data) == 14);

				
				pkthdr->ph_len += pppEntry_t->l2tpOffset2_;
				mbuf->m_len += pppEntry_t->l2tpOffset2_;
				mbuf->m_data -= pppEntry_t->l2tpOffset2_;

				
				data = mbuf->m_data;	
				
				rtl8651_memcpy(data + 14, pppEntry_t->l2tpBuf2_, pppEntry_t->l2tpOffset2_);
				
				rtl8651_memcpy(data, &(svlan->macAddr), 6);	
				rtl8651_memcpy(data + 6, &(pppEntry_t->macInfo->macAddr), 6);	
				*(uint16*)((uint32)data + 12) = htons(0x0800);
				
				ipBuf = (struct ip *)(data + 14);
				udpBuf = (struct udphdr *)L4HDR_ADDR(ipBuf);
				ipBuf->ip_sum = 0;
				udpBuf->uh_sum = 0;
				udpBuf->uh_sum = htons(_rtl8651_tcpChecksum(ipBuf));
				ipBuf->ip_sum = htons(_rtl8651_ipChecksum(ipBuf));
			}
		}

		
		if (result != FWDENG_QUEUED_TO_GW)
			goto out;
		
		pkthdr = pkthdr->ph_nextHdr;
		if (pkthdr)
		{
			assert(pkthdr->ph_mbuf && pkthdr->ph_mbuf->m_data && pkthdr->ph_iphdrOffset);
			pip = (struct ip *)((uint32)(pkthdr->ph_mbuf->m_data) + pkthdr->ph_iphdrOffset);
		}
	}
out:
	return SUCCESS;
}
#endif 

#define RTL8651_FWDENG_QOS_FUNCTIONS

int32 _rtl8651_markDiffserv( int32 ruleNo, struct rtl_pktHdr *pkthdr, struct ip *pip, void *userDefined )
{



	if (IPHDRLEN_IS_TWENTY(pip))
	{
		pip->ip_tos = *(uint8 *)userDefined;
	} else
	{
		uint8 oldTos, newTos;

		oldTos = pip->ip_tos;
		newTos = (*(uint8 *)userDefined);

		pip->ip_tos = newTos;

		_RTL8651_L3_ADJUST_CHECKSUM(newTos, oldTos, pip->ip_sum);
	}

	return FAILED;
}



#define RTL8651_FWDENG_RETURN_STATISTIC_FUNCTION
#ifdef _RTL8651_FWDENG_RETURN_STATISTIC

void _rtl8651_fwdEngineRetValueStatisticInit(void)
{
	memset(rtl8651_returnValue, 0, TOTAL_RETURNVALUE);
}
void _rtl8651_fwdEngineRetValueStatisticReset(void)
{
	_rtl8651_fwdEngineRetValueStatisticInit();
}
void _rtl8651_fwdEngineRetValueStatisticUpdate(int32 retval)
{
	if (retval == FAILED)
	{
		rtl8651_returnValue[FWDENG_TOTALERRS + 1] ++;	
		return;
	}
	if ((retval > 0) &&(retval & FWDENG_DROP))
	{
		rtl8651_returnValue[FWDENG_TOTALERRS] ++;	
		retval &= ~FWDENG_DROP;
	}
	if (retval > 0 && retval < FWDENG_TOTALERRS)
	{
		rtl8651_returnValue[retval] ++;
		return;
	}
	rtl8651_returnValue[FWDENG_TOTALERRS + 2] ++;	
	return;
}
int32 _rtl8651_fwdEngineRetValueStaticDump(void)
{
	int i;
	printk("fwdEngine non-success return value Statistic:\n");
	for ( i = 0 ; i < FWDENG_TOTALERRS ; i ++)
	{
		if (rtl8651_returnValue[i])
		{
			printk("Return [%d] -- count: %d\n", i, rtl8651_returnValue[i]);
		}
	}
	printk("---other ---\n");
	
	printk("FAILED: %d\n", rtl8651_returnValue[FWDENG_TOTALERRS + 1]);
	
	printk("FWD DROP: %d\n", rtl8651_returnValue[FWDENG_TOTALERRS]);
	
	if (rtl8651_returnValue[FWDENG_TOTALERRS + 2])
	{
		printk("other return values: %d\n", rtl8651_returnValue[FWDENG_TOTALERRS + 2]);
	}
	return SUCCESS;
}
#endif 


#ifdef _RTL_TRAPPING_DISPATCH
#define RTL8651_TRAPPING_DISPATCH_FUNCTIONS


static int32 _rtl8651_trappingDispatchInit(rtl8651_fwdEngineInitPara_t *para)
{
	uint32 trappingDispatchTblSize, i;
	_rtl8651_trapping_dispatch_entry_t *ptr;

	
	rtl8651_trappingDispatchSystem_inUsed = NULL;
	rtl8651_trappingDispatchSystem_freeHdr = NULL;
	bzero(&rtl8651_trappingDispatchSystem_cache, sizeof(rtl8651_trappingDispatchSystem_cache));

	trappingDispatchTblSize = para->trappingPktDispatchTblSize;

	
	if (trappingDispatchTblSize == 0)
	{
		return SUCCESS;
	}

	rtl8651_trappingDispatchSystem_freeHdr =
		(_rtl8651_trapping_dispatch_entry_t *)rtlglue_malloc(trappingDispatchTblSize * sizeof(_rtl8651_trapping_dispatch_entry_t));

	
	if (rtl8651_trappingDispatchSystem_freeHdr == NULL)
	{
		return FAILED;
	}

		
	bzero(rtl8651_trappingDispatchSystem_freeHdr, (trappingDispatchTblSize * sizeof(_rtl8651_trapping_dispatch_entry_t)));

	for (i = 0, ptr = rtl8651_trappingDispatchSystem_freeHdr;
		i < (trappingDispatchTblSize - 1) ;
		i ++, ptr ++)
	{
		ptr->next = ptr + 1;
	}

	return SUCCESS;
}


static void _rtl8651_trappingDispatchReinit(void)
{
	while (rtl8651_trappingDispatchSystem_inUsed)
	{
		#ifdef RTL8651_DEBUG
		uint32 delCnt;
		delCnt =
		#endif
			_rtl8651_removeTrappingDispatchEntry(rtl8651_trappingDispatchSystem_inUsed);

		#ifdef RTL8651_DEBUG
		assert(delCnt == 1);
		#endif
	}
}



static _rtl8651_trapping_dispatch_entry_t *_rtl8651_findTrappingDispatchEntry(
	uint8 l4Proto,
	ipaddr_t srcIp,
	ipaddr_t dstIp,
	int32 srcPort,
	int32 dstPort,
	uint8 isExactlyMatch
)
{
	_rtl8651_trapping_dispatch_entry_t *ptr;

	ptr = rtl8651_trappingDispatchSystem_inUsed;

	if (isExactlyMatch == TRUE)
	{	
		while (ptr)
		{
			if ((l4Proto == ptr->l4Proto) &&			
			     (srcIp == ptr->srcIp) &&			
			     (dstIp == ptr->dstIp) &&			
			     ((srcPort < 0 && ptr->srcPort < 0) || (srcPort == ptr->srcPort)) &&	
			     ((dstPort < 0 && ptr->dstPort < 0) || (dstPort == ptr->dstPort)))		
			{	
				return ptr;
			}
			ptr = ptr->next;
		}
	}else
	{	

		
		if (	(l4Proto == rtl8651_trappingDispatchSystem_cache.l4Proto) &&
			(srcIp == rtl8651_trappingDispatchSystem_cache.srcIp) &&
			(dstIp == rtl8651_trappingDispatchSystem_cache.dstIp) &&
			(srcPort == rtl8651_trappingDispatchSystem_cache.srcPort) &&
			(dstPort == rtl8651_trappingDispatchSystem_cache.dstPort) &&
			rtl8651_trappingDispatchSystem_cache.ptr)
		{
			return rtl8651_trappingDispatchSystem_cache.ptr;
		}

		
		while (ptr)
		{
			if ( (ptr->l4Proto == 0 || l4Proto == ptr->l4Proto) &&
			     (ptr->srcIp == 0 || srcIp == ptr->srcIp) &&
			     (ptr->dstIp == 0 || dstIp == ptr->dstIp) &&
			     (ptr->srcPort < 0 || srcPort == ptr->srcPort) &&
			     (ptr->dstPort < 0 || dstPort == ptr->dstPort))
			{	

				
				rtl8651_trappingDispatchSystem_cache.l4Proto = l4Proto;
				rtl8651_trappingDispatchSystem_cache.srcIp = srcIp;
				rtl8651_trappingDispatchSystem_cache.dstIp = dstIp;
				rtl8651_trappingDispatchSystem_cache.srcPort = srcPort;
				rtl8651_trappingDispatchSystem_cache.dstPort = dstPort;
				rtl8651_trappingDispatchSystem_cache.ptr = ptr;

				return ptr;
			}
			ptr = ptr->next;
		}
	}
	
	return NULL;
}


int32 rtl8651_registerTrappingDispatchEntry(
	uint8 l4Proto,
	ipaddr_t srcIp,
	ipaddr_t dstIp,
	int32 srcPort,
	int32 dstPort,
	uint16 category
)
{
	int32 retval;

	#ifdef RTL8651_DEBUG
	if (category == RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY)
	{	
		rtlglue_printf("[WARNING] %s(%d) The Category or this registration is [%d], same as the default one.",
			__FUNCTION__, __LINE__, category);
	}
	#endif

	if ( (l4Proto != IPPROTO_TCP) &&
	      (l4Proto != IPPROTO_UDP))
	{	
		srcPort = -1;
		dstPort = -1;
	}

	rtlglue_drvMutexLock(); 

	retval = _rtl8651_registerTrappingDispatchEntry(l4Proto,
											 srcIp,
											 dstIp,
											 srcPort,
											 dstPort,
											 category);

	rtlglue_drvMutexUnlock(); 

	return retval;
}


static int32 _rtl8651_registerTrappingDispatchEntry(
	uint8 l4Proto,
	ipaddr_t srcIp,
	ipaddr_t dstIp,
	int32 srcPort,
	int32 dstPort,
	uint16 category
)
{
	_rtl8651_trapping_dispatch_entry_t *newEntry;
	int32 retval = FAILED;

	
	if ((newEntry = _rtl8651_findTrappingDispatchEntry(
				l4Proto,
				srcIp,
				dstIp,
				srcPort,
				dstPort,
				TRUE )) != NULL)
	{ 
		newEntry->category = category;
		retval = SUCCESS;
		goto out;
	}

	
	if (rtl8651_trappingDispatchSystem_freeHdr == NULL)
	{
		retval = FAILED;
		goto out;
	}

	

	
	bzero(&rtl8651_trappingDispatchSystem_cache, sizeof(rtl8651_trappingDispatchSystem_cache));

	
	newEntry = rtl8651_trappingDispatchSystem_freeHdr;
	rtl8651_trappingDispatchSystem_freeHdr = rtl8651_trappingDispatchSystem_freeHdr->next;

	
	newEntry->next = rtl8651_trappingDispatchSystem_inUsed;
	newEntry->prev = NULL;

	if (rtl8651_trappingDispatchSystem_inUsed)
	{
		rtl8651_trappingDispatchSystem_inUsed->prev = newEntry;
	}
	rtl8651_trappingDispatchSystem_inUsed = newEntry;

	
	newEntry->l4Proto = l4Proto;
	newEntry->srcIp = srcIp;
	newEntry->dstIp = dstIp;
	newEntry->srcPort = srcPort;
	newEntry->dstPort = dstPort;
	newEntry->category = category;

	retval = SUCCESS;

out:
	return retval;
}


static void _rtl8651_removeTrappingDispatchEntry(_rtl8651_trapping_dispatch_entry_t *delEntry)
{
	
	if (rtl8651_trappingDispatchSystem_cache.ptr == delEntry)
	{
		bzero(&rtl8651_trappingDispatchSystem_cache, sizeof(rtl8651_trappingDispatchSystem_cache));
	}

	
	if (delEntry->prev)
	{
		delEntry->prev->next = delEntry->next;
	}
	if (delEntry->next)
	{
		delEntry->next->prev = delEntry->prev;
	}
	if (rtl8651_trappingDispatchSystem_inUsed == delEntry)
	{
		rtl8651_trappingDispatchSystem_inUsed = delEntry->next;
	}

	
	delEntry->next = rtl8651_trappingDispatchSystem_freeHdr;
	rtl8651_trappingDispatchSystem_freeHdr = delEntry;
}


int32 rtl8651_unregisterTrappingDispatchEntry(
	uint8 l4Proto,
	ipaddr_t srcIp,
	ipaddr_t dstIp,
	int32 srcPort,
	int32 dstPort
)
{
	int32 retval;

	if ( (l4Proto != IPPROTO_TCP) &&
	      (l4Proto != IPPROTO_UDP))
	{	
		srcPort = -1;
		dstPort = -1;
	}

	rtlglue_drvMutexLock(); 
	retval = _rtl8651_unregisterTrappingDispatchEntry(
				l4Proto,
				srcIp,
				dstIp,
				srcPort,
				dstPort);
	rtlglue_drvMutexUnlock(); 
	return retval;
}


static int32 _rtl8651_unregisterTrappingDispatchEntry(
	uint8 l4Proto,
	ipaddr_t srcIp,
	ipaddr_t dstIp,
	int32 srcPort,
	int32 dstPort
)
{
	_rtl8651_trapping_dispatch_entry_t *delEntry;

	delEntry = _rtl8651_findTrappingDispatchEntry(
				l4Proto,
				srcIp,
				dstIp,
				srcPort,
				dstPort,
				TRUE);

	if (delEntry)
	{
		_rtl8651_removeTrappingDispatchEntry(delEntry);

		
		return 1;
	}

	
	return 0;

}


static uint16 _rtl8651_getTrappingDispatchCategory(struct ip *pip)
{
	ipaddr_t srcIp, dstIp;
	int32 srcPort, dstPort;
	uint8 l4Proto;
	uint16 offset;
	uint16 category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;
	_rtl8651_trapping_dispatch_entry_t *ptr;

	
	srcIp = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
	dstIp = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);
	offset = pip->ip_off;	
	l4Proto = pip->ip_p;

	if (IS_FRAGMENT_REMAIN(offset))
	{
		
		uint16 ipId;

		ipId = ntohs(pip->ip_id);

		if (_rtl8651_getFragCache(TRAP_DISPATCH_FRAG,
				srcIp,
				dstIp,
				ipId,
				(ipaddr_t *)(&category), NULL, NULL, NULL) == SUCCESS)
		{
			goto out;
		}

		
		srcPort = -1;
		dstPort = -1;
		goto find;
	}

	
	switch (l4Proto)
	{
		case IPPROTO_TCP:
		{
			struct tcphdr *tcpHdr;

			tcpHdr = (struct tcphdr *)L4HDR_ADDR(pip);
			srcPort = ntohs(tcpHdr->th_sport);
			dstPort = ntohs(tcpHdr->th_dport);
			break;
		}

		case IPPROTO_UDP:
		{
			struct udphdr *udpHdr;

			udpHdr = (struct udphdr *)L4HDR_ADDR(pip);
			srcPort = ntohs(udpHdr->uh_sport);
			dstPort = ntohs(udpHdr->uh_dport);
			break;
		}

		default:
			
			srcPort = -1;
			dstPort = -1;
	}

find:
	
	if ((ptr = _rtl8651_findTrappingDispatchEntry(
				l4Proto,
				srcIp,
				dstIp,
				srcPort,
				dstPort,
				FALSE)) != NULL)
	{
		
		category = ptr->category;
	
		if (IS_FRAGMENT_FIRST(offset))
		{
			
			uint16 ipId;

			ipId = ntohs(pip->ip_id);

			_rtl8651_updateFragCache(TRAP_DISPATCH_FRAG,
				srcIp,
				dstIp,
				ipId,
				(ipaddr_t)category,
				0, NULL, 0);
		}
		goto out; 
	}

	category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

out:
	return category;
}
#endif 


#ifdef _RTL_TOS_REMARKING


static void _rtl8651_DSCPRemark(	struct rtl_pktHdr *pkthdrPtr,
									struct ip *ip,
									ipaddr_t sip,
									ipaddr_t dip,
									uint8 dsid,
									rtl8651_tblDrv_vlanTable_t *pVlan)
{
	if (!PH_PROCFLAG_TEST(pkthdrPtr,PH_PROCFLAG_DSCP_ACTION))
	{
		if (IS_FRAGMENT_REMAIN(ip->ip_off))
		{
#ifdef _RTL_NAPT_FRAG	
			ipaddr_t	tos_tmp;
			uint8	org_tos;

			if (SUCCESS == _rtl8651_getFragCache(	DSCP_FRAG,
													sip,
													dip,
													dsid,
													(ipaddr_t*)(&tos_tmp),
													NULL,
													NULL,
													NULL))
			{
				org_tos = ip->ip_tos;
				ip->ip_tos = (uint8)tos_tmp;
				_RTL8651_DATA_ADJUST_CHECKSUM(tos_tmp, org_tos, ip->ip_sum);
				PH_PROCFLAG_SET(pkthdrPtr,PH_PROCFLAG_DSCP_ACTION);
			}
 #endif
			goto DSCP_DONE;
		}

		
		
		{
			_rtl8651_tblDrvAclRule_t *rule_matched;

			rule_matched = (_rtl8651_tblDrvAclRule_t *) _rtl8651_matchDiffservACL(	pkthdrPtr->ph_dsid,
																			pkthdrPtr,
																			ip,
																			pVlan);
			if (rule_matched)
			{
				_rtl8651_markDiffservPkt(rule_matched, ip);
				PH_PROCFLAG_SET(pkthdrPtr,PH_PROCFLAG_DSCP_ACTION);
			}
		}
	
DSCP_DONE:
		if (!PH_PROCFLAG_TEST(pkthdrPtr,PH_PROCFLAG_DSCP_ACTION))
		{
			if (TRUE == rtl8651_drvDSCPDefaultRemark)
			{
				ip->ip_tos = rtl8651_drvDSCPDefaultRemarkValue ;
			}
			PH_PROCFLAG_SET(pkthdrPtr,PH_PROCFLAG_DSCP_ACTION);
		}
#ifdef _RTL_NAPT_FRAG
		if (IS_FRAGMENT_FIRST(ip->ip_off))
		{
			_rtl8651_updateFragCache(	DSCP_FRAG,
										sip,
										dip,
										dsid,
										(ipaddr_t)(ip->ip_tos),
										0,
										NULL,
										0);
		}
#endif
	}
}



int32 rtl8651_setDSCPDefaultAction(int8 enable, uint8 value)
{	
	rtlglue_drvMutexLock();
	_rtl8651_setDSCPDefaultAction(enable, value);
	rtlglue_drvMutexUnlock();
	return SUCCESS;
}

static void _rtl8651_setDSCPDefaultAction(int8 enable, uint8 value)
{
	rtl8651_drvDSCPDefaultRemark = enable;
	rtl8651_drvDSCPDefaultRemarkValue = value;
}

inline int32 _rtl8651_setDSCPEnable(int8 enable)
{
	rtl8651_diffServEnable = enable;
	return SUCCESS;
}

static int32 _rtl8651_DSCPRemark_init(rtl8651_fwdEngineInitPara_t *para)
{
	_rtl8651_setDSCPEnable(FALSE);
	_rtl8651_setDSCPDefaultAction(FALSE,0);
	return SUCCESS;
}
#endif
